unit UMain;
{Testovaci projekt pro jednotku UObjemULT}
{
  Ovladani:

  Po startu nejprve kliknout na  "Naten tabulek"

  Pak vybrat drevinu a vyplnit vek

  1. Jednotlive hodnoty:
     Zadat tloustku "d" a vysku "h".
     Kliknout na "Vpoet"

  2. Tabelovane hodnoty
     Zadat minimalni hodnoty d a h.
     Zadat maximalni hodnoty d a h.
     Zadat diference (krok tabulky) d a h.
     Pro vypocet zvolene veliciny kliknout na jedno z tlacitek
     "Objem",  "Vtvarnice" nebo "Vtvarnicov vka"
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UObjemULT, StdCtrls, Buttons, ExtCtrls;

type
  TMain = class(TForm)
    Label7: TLabel;
    Label8: TLabel;
    CBDrev: TComboBox;
    EditVek: TEdit;
    Button1: TButton;
    BitBtn1: TBitBtn;
    Panel1: TPanel;
    Editg: TEdit;
    Label6: TLabel;
    Label3: TLabel;
    Editv: TEdit;
    Label4: TLabel;
    Editt: TEdit;
    Label5: TLabel;
    Editht: TEdit;
    Editd: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edith: TEdit;
    Button4: TButton;
    Memo1: TMemo;
    Bobjem: TButton;
    Panel2: TPanel;
    EDMin: TEdit;
    EDMax: TEdit;
    EHMax: TEdit;
    EHMin: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    EDDif: TEdit;
    EHDif: TEdit;
    dif: TLabel;
    BVytvarnice: TButton;
    BVytvVyska: TButton;
    Label13: TLabel;
    Label14: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure BobjemClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Main: TMain;

implementation

{$R *.DFM}

procedure TMain.Button1Click(Sender: TObject);
var
  idr:integer;
begin
 {Nacteni Tabulek  }
  nactiTabulky;
  
 {Seznam drevin do ComboBoxu CBDrev }
  CBDrev.Items.Clear;
  for idr:=0 to DrevLHPNaULT.Count-1 do CBDrev.Items.Add(DrevLHPNaULT.Names[idr]);
  CBDrev.ItemIndex:=0;
end;



procedure TMain.Button4Click(Sender: TObject);
{Vypocet jednotlivych hodnot}
var
  d,h:real;
  vek:integer;
  status:integer;
  g,v,t,ht:real;
begin
  Editg.Text:='';
  Editv.Text:='';
  Editht.Text:='';
  Editt.Text:='';
  vek:=StrToIntDef(EditVek.Text,100);
  EditVek.Text:=IntToStr(vek);
  try
    d:=StrToFloat(Editd.Text);
  except
    on EConvertError do d:=0;
  end;
  try
    h:=StrToFloat(Edith.Text);
  except
    on EConvertError do h:=0;
  end;
  if (h>0) and (d>0) then
  begin
    g:=pi*d*d/200/200;
    v:=Vratobjem(CBDrev.Text,d,h,vek,status);
    ht:=v/g;
    t:=ht/h;
    Editg.Text:=format('%8.5f',[g]);
    Editv.Text:=format('%8.5f',[v]);
    Editht.Text:=format('%8.5f',[ht]);
    Editt.Text:=format('%8.5f',[t]);
  end
  else ShowMessage('Chyba vstupu');
end;

procedure TMain.BobjemClick(Sender: TObject);
{Vypocet hodnot do tabulky}
var
  dmin,dmax,ddif,di:real;
  hmin,hmax,hdif,hi:real;
  poms:string;
  udaj:real;
  vek:integer;
  status:integer;
begin
  Memo1.Clear;
  vek:=StrToIntDef(EditVek.Text,100);
  {implicitni meze}
  dmin:=10;   dmax:=90;  ddif:=2;
  hmin:=8;    hmax:=40;  hdif:=1;
  try  dmin:=strtofloat(EDMin.Text); except end;
  try  dmax:=strtofloat(EDMax.Text); except end;
  try  ddif:=strtofloat(EDDif.Text); except end;
  try  hmin:=strtofloat(EHMin.Text); except end;
  try  hmax:=strtofloat(EHMax.Text); except end;
  try  hdif:=strtofloat(EHDif.Text); except end;
  {hlavicka }
  poms:='d';
  hi:=hmin;
  repeat
    poms:=poms+chr(9)+trim(format('%10.1f',[hi]));   {vysky v hlavicce}
    hi:=hi+hdif;
  until hi>hmax;
  Memo1.Lines.Add(poms);
  {tabulka hodnot}
  di:=dmin;
  repeat
    poms:=trim(format('%10.1f',[di]));
    hi:=hmin;
    repeat
      {objem}
      udaj:=VratObjem(CBDrev.Text,di,hi,vek,status);
      {vytvarnice}
      if (Sender as TComponent).Name='BVytvarnice' then udaj:=udaj/hi/di/di*40000/pi;
      {vytvarnicova vyska}
      if (Sender as TComponent).Name='BVytvVyska' then udaj:=udaj/di/di*40000/pi;
      poms:=poms+chr(9)+trim(format('%10.3f',[udaj]));
      hi:=hi+hdif;
    until hi>hmax;
    Memo1.Lines.Add(poms);
    di:=di+ddif;
  until di>dmax;

end;

end.
