unit PtCanvRTF;
interface
uses
  SysUtils, WinTypes, WinProcs, Messages,
  Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls,printers_F,ComCtrls,
  hkCanvas,U_zobraz,ELesObec,
  E_LesOdd,E_LesLHC,LesCisel,dtbles98,DBTables,mat1;

type
  TFPTCanvas = class(TForm)
    Image1: TImage;
    PrinterSetupDialog1: TPrinterSetupDialog;
  private
    { Private declarations }
  public
    { Public declarations }
  end;
                                      
var
FPTCanvas: TFPTCanvas;
RadRich:widestring;
procedure tiskPloTabOddeleni(VODD:TOddeleni;VAR Strana:integer;strana_pozadovana_k_tiskuI:integer;
            CanvasV:TCanvas;RichEd:TRichEdit;TbXLS:TTable;merX,MerY:longint;
            NaTiskarnu2,tiskSouctu:Boolean;oddMN:TOddeleniMN;
            tiskPorost:boolean;TisknoutMajitele:boolean;HavlBrod:Boolean;VColor:TColor;VFont:string;
            tiskMajitVRad,jenMaj_KOD:boolean;levaPrava:byte;pomerX,pomerY:double;jazyk:TJazyk;
            query1:TQuery);

procedure TiskKatastru(oddMn:TOddeleniMN;CanvasV:TCanvas;RichEd:TRichEdit;TBXls:TTAble;
                       merX,MerY:longint;NaTiskarnu1:Boolean;VColor:TColor;VFont:string;jazyk:tjazyk;
                       Query1:TQuery);
procedure TiskPot_Vlast(oddMn:TOddeleniMN;CanvasV:TCanvas;merX,MerY:longint;NaTiskarnu1:Boolean;VColor:TColor;VFont:string;Query1:TQuery);
implementation

{$R *.DFM}
uses {UVybHkPt!} tisky;
procedure tiskPloTabOddeleni(VODD:TOddeleni;VAR Strana:integer; strana_pozadovana_k_tiskuI:integer;
            CanvasV:TCanvas;RichEd:TRichEdit;TbXLS:TTable; merX,MerY:longint;
                 NaTiskarnu2,tiskSouctu:Boolean;oddMN:TOddeleniMN;
                 tiskPorost:boolean;TisknoutMajitele:boolean;HavlBrod:Boolean;VColor:TColor;VFont:string;
                 tiskMajitVrad,jenMaj_kod:boolean;levaPrava:byte;
                 pomerX,pomerY:double;jazyk:TJazyk;
                 query1:TQuery);
var XA1,XA2,XA3,XA3a,XA4,XA5,XA6,XA7,XA8,XA9,XA10,XA11,XA12,Xam:longint;
    XA4D,XA5D,XAR1D,XAR2D,XAR6D,XAR9D,XAR11D,XAR12D,XAR8D:longint;
    XAR,XAR1,XAR2,XAR3,XAR4,XAR5,XAR6,XAR7,XAR9,XAR10,XAR11,XAR12,XAR13:longint;
    XAR7a,XAR7b,XAR7c:longint;
    xpp:longint;
    RADx:longint;
    YR1,YR1T,YR1TT,YR2,YR3,YR4,RH,RADy,YR2T,YR4T,YR4TT,
    YRR,YP,merYMax:longint;
    FS,FSD,FSDK,FSDM:longint;
    netisknout,jePrava:boolean;


procedure tiskDleStrany(strana,strana_pozadovana_k_tisku:integer);

 begin
{  levaprava  - 0  oboustranne
                1 jen leve
                2 jen prave
                4 oboustrann}

  case levaPrava of
   0:begin   {oboustranna}
      netisknout:=false;
      jePrava:=false;
     end;
   1:begin   {jen leve }
      if strana mod 2=0 then
       begin
        netisknout:=true;
       end
      else
       begin
        netisknout:=false;
       end;
      jePrava:=False;
     end;
   2:begin   {jen prave}
      if strana=2 then
        begin
         netisknout:=false;
        end;
      if strana mod 2=0 then
       begin
        netisknout:=false;
       end
      else
       begin
        netisknout:=true;
       end;
      jeprava:=true;
     end;
   3:begin  {oboustranne}
      if strana=0 then
        begin
         netisknout:=false;
        end;
      if strana mod 2=0 then
       begin
        jeprava:=false;
       end
      else
       begin
        jeprava:=true;
       end;
      netisknout:=false;
     end;
   4:begin   {oboustranna}
      netisknout:=false;
      jePrava:=true;
     end;
   end;{case}
  if (strana_pozadovana_k_tisku>0) then
   begin
     if strana_pozadovana_k_tisku=strana then netisknout:=false
                                         else netisknout:=true;
   end;
 end;


function mx(x:real):longint;
//var PP:Double;
 begin
  // mx:=mx1(x+PP,MerX);
  mx:=mx1(x,MerX);
 end;
function my(y:real):longint;
 begin
  my:=my1(y,mery);
 end;
function YPT:longint;
 begin
  result:=YP+my(0.1);
 end;
procedure nastavBody;
var PP:Double;
 begin
   PP:=((1-PomerX)/2)*28.6;
   FS:=7;
   FSD:=9;
   FSDK:=12;
   FSDM:=3;
   radx:=   mx(0.40);
   XAR:=    mx(0.807);  //  mx(0.98);
   if jePrava then
    begin
     Xa1:= mx(PP+2.00);
    end
   else
    begin
     Xa1:= mx(PP+0.9);
    end;
   Xa2:=Xa1+mx(0.75);
   Xa3:=Xa2+mx(0.45);
   if tiskPorost then
    begin
     Xa3a:=Xa3  + mx(0.45);
     Xa4 :=Xa3a + mx(0.82);
     Xa5 :=Xa4  + mx(0.83);
    end
   else
    begin
     Xa3a:=Xa3;
     Xa4:=Xa3+mx(1.00);
     Xa5:=Xa4+mx(1.10);
    end;
   if tiskMajitVRad then
    begin
     XA5:=Xa5+mx(1.55);
    end;
   Xa6:=Xa5+mx(2.50);
   Xa7:=Xa6+mx(1.50);
   XaR1:=Xa7+XAR;
   XaR2:=XaR1+XAR;
   XaR3:=XaR2+XAR;
   XaR4:=XaR3+XAR;
   XaR5:=XaR4+XAR;
   XaR6:=XaR5+XAR;
   XaR7a:=XaR6+XAR;
   XaR7b:=XaR7a+XAR;
   XaR7c:=XaR7b+XAR;
   XaR7 :=XaR7c+XAR;

   Xa8:=XaR7+XAR;
   XaR9:=Xa8+XAR;
   XaR10:=XaR9+XAR;
   XaR11:=XaR10+XAR;
   XaR12:=XaR11+XAR;
   XaR13:=XaR12+XAR;
   Xa9:=XaR13+XAR;
   Xa10:=Xa9+mx(1.40);
   Xa11:=Xa10+mx(1.85);
   if tiskMajitVRad then
    begin
     Xa12:=Xa11;
    end
   else
    begin
     Xa12:=Xa11+mx(1.55);
    end;
   xpp:=mx(0.1);
   PP:=((1-PomerY)/2)*20.0;
   YR1:=my(1.8+PP)+YRR;
   YR1T:=YR1+my(1.40);
   YR1TT:=YR1+my(0.1);
   if HavlBrod then RH:=my(4.5)
   else RH:=my(3.5);
   RADy:=my(0.5);
   YR2:=YR1+RH;
   YR2T:=YR2-RADy-my(0.2);
   YR3:=YR1+RADy;
   YR4:=YR2-RADy;
   YR4T:=YR4-my(0.1);
   YR4TT:=YR4+my(0.1);
   YP:=YR2;
 end;
procedure HoleOdstrankovani;
begin
if NaTiskarnu2 then
 begin
  with printer do
   begin
    if not netisknout then
     begin
      newpage;
      MerYMax:=round(mery*0.95);
     end;
   end;
 end
else
 begin
   YRR:=YRR+round(screen.height*1.1);
   merYMax:=YRR+round(screen.height);
 end;
end;

procedure tiskniSvisleCarkyRadkuProSoucet;
 begin
  with canvasV do
   begin
     pen.width:=5;
     PolyLine([Point(XA1,YP),
               Point(XA1,YP+RADy)]);
     PolyLine([Point(XA6,YP),
               Point(XA6,YP+RADy)]);
     PolyLine([Point(XA7,YP),
               Point(XA7,YP+RADy)]);
     PolyLine([Point(XA8,YP),
               Point(XA8,YP+RADy)]);
     PolyLine([Point(XA9,YP),
               Point(XA9,YP+RADy)]);
     PolyLine([Point(XA10,YP),
               Point(XA10,YP+RADy)]);
     PolyLine([Point(XA12,YP),
               Point(XA12,YP+RADy)]);
     PolyLine([Point(XA11,YP),
               Point(XA11,YP+RADy)]);
     pen.width:=1;

     PolyLine([Point(XA2,YP),
               Point(XA2,YP+RADy)]);
     PolyLine([Point(XA3,YP),
               Point(XA3,YP+RADy)]);
     if tiskPorost then
      begin
       PolyLine([Point(XA3a,YP),
                 Point(XA3a,YP+RADy)]);
      end;
     {
     PolyLine([Point(XA4,YP),
               Point(XA4,YP+RADy)]);
     PolyLine([Point(XA5,YP),
               Point(XA5,YP+RADy)]);
     }
     PolyLine([Point(XAR1,YP),
               Point(XAR1,YP+RADy)]);
     PolyLine([Point(XAR2,YP),
               Point(XAR2,YP+RADy)]);
     PolyLine([Point(XAR3,YP),
               Point(XAR3,YP+RADy)]);
     PolyLine([Point(XAR4,YP),
               Point(XAR4,YP+RADy)]);
     PolyLine([Point(XAR5,YP),
               Point(XAR5,YP+RADy)]);
     PolyLine([Point(XAR6,YP),
               Point(XAR6,YP+RADy)]);
     PolyLine([Point(XAR7,YP),
               Point(XAR7,YP+RADy)]);
     PolyLine([Point(XAR7a,YP),
               Point(XAR7a,YP+RADy)]);
     PolyLine([Point(XAR7b,YP),
               Point(XAR7b,YP+RADy)]);
     PolyLine([Point(XAR7c,YP),
               Point(XAR7c,YP+RADy)]);
     PolyLine([Point(XAR9,YP),
               Point(XAR9,YP+RADy)]);
     PolyLine([Point(XAR10,YP),
               Point(XAR10,YP+RADy)]);
     PolyLine([Point(XAR11,YP),
               Point(XAR11,YP+RADy)]);
     PolyLine([Point(XAR12,YP),
               Point(XAR12,YP+RADy)]);
     PolyLine([Point(XAR13,YP),
               Point(XAR13,YP+RADy)]);

   end;
 end;
procedure tiskniSvisleCarkyRadku;
 begin
  tiskniSvisleCarkyRadkuProSoucet;
  with canvasV do
   begin
     pen.width:=1;
     PolyLine([Point(XA4,YP),
               Point(XA4,YP+RADy)]);
     PolyLine([Point(XA5,YP),
               Point(XA5,YP+RADy)]);
   end;
 end;
procedure VybarvyRadek;
 begin
  With canvasV do
   begin
    Brush.Color:=VColor;//clYellow;
    fillRect(rect(XA1,YP+my(0.03),XA12,YP+RADy));
    Brush.color:=ClWhite;
   end;
 end;
procedure TiskniRadekProZapsani;
 begin
  tiskniSvisleCarkyRadku;
  with canvasV do
   begin
    pen.width:=1; Pen.Style := psDot;
    PolyLine([Point(XA1,YP+RADy),
              Point(XA12,YP+RADy)]);
    pen.width:=1; Pen.Style := psSolid;
   end;
 end;
procedure TiskniRadekProSoucet;
 begin
  VybarvyRadek;
  tiskniSvisleCarkyRadkuProSoucet;
  with canvasV do
   begin
    pen.width:=5;
    PolyLine([Point(XA1,YP+RADy),
              Point(XA12,YP+RADy)]);
   end;
 end;
procedure tiskniHlavicku(MajitelLHC:string);
 var
   K:integer;
 begin
  inc(Strana);
  tiskDleStrany(strana,strana_pozadovana_k_tiskuI);
  nastavBody;
  with canvasV do
   begin
        // FONT.NAME:='Arial CE';
        FONT.NAME:=VFont;
        Font.Size:=FSDK;
        Font.Style:=[fsBold];
        font.Charset:=238;
        if not(tiskSouctu)
         then
          begin
           if jazyk=cesky then
            begin
             TextOut(XA1,YR1-2*RADy,
              'A. Pehledn sestaven ploch a vmr dle zkladnch jednotek rozdlen lesa');
            end;
           if jazyk=Anglicky1 then
            begin
             TextOut(XA1,YR1-2*RADy,'A. Register of stand area');
            end;
          end
         else
          begin
           if jazyk=cesky then
            begin
             TextOut(XA1,YR1-2*RADy,' Sum ');
            end;
           if jazyk=Anglicky1 then
            begin
             TextOut(XA1,YR1-2*RADy,' Summary ');
            end;
          end;
        if TisknoutMajitele then
         begin
          IF VODD<>NIL then
           begin
            //FONT.NAME:='Arial CE';
            FONT.NAME:=VFont;
            Font.Size:=FS;
            Font.Style:=[fsBold];
            font.Charset:=238;
            if not VOdd.dilecMN.AktualniPrvekJeVMnozine then
             begin
              VOdd.NastavNeboVytvorPrvniPorost;
             end;
            if not VOdd.dilec.porostMN.AktualniPrvekJeVMnozine then
             begin
              VOdd.NastavNeboVytvorPrvniPorost;
             end;
           if jazyk=Anglicky1 then
            begin
             TextOut(XA1,YR1-RADy,'Property:  '+vodpalZavinac(VOdd.Dilec.Porost.MAJ_NAZ));
             TextOutPK(canvasV,XA12,YR1-RADy,'No:  '+VOdd.Dilec.Porost.MAJ_KOD);
            end;
           if jazyk=cesky then
            begin
             TextOut(XA1,YR1-RADy,'Majitel:  '+vodpalZavinac(VOdd.Dilec.Porost.MAJ_NAZ));
             TextOutPK(canvasV,XA12,YR1-RADy,'slo:  '+VOdd.Dilec.Porost.MAJ_KOD);
            end;
           end
          else
           begin
            FONT.NAME:=VFont;
            Font.Size:=FS;
            Font.Style:=[fsBold];
            font.Charset:=238;
            if jazyk=cesky then
             begin
              TextOut(XA1,YR1-RADy,'Majitel:  '+majitelLHC);
             end;
            if jazyk=Anglicky1 then
             begin
              TextOut(XA1,YR1-RADy,'Property:  '+majitelLHC);
             end;
           end;
         end;
        // FONT.NAME:='Arial CE';
        FONT.NAME:=VFont;
        Font.Size:=FSD;
        Font.Style:=[];
        font.Charset:=238;
        SetTextOrientation(CanvasV,90);
        if jazyk=cesky then
         begin
          TextOutSsv(canvasV,XA1,XA2,YR2T,'Oddlen');
          TextOutSsv(canvasV,XA2,XA3,YR2T,'Dlec');
          if tiskPorost then TextOutSsv(canvasV,XA3,XA3a,YR2T,'Porost');
         end;
        if jazyk=Anglicky1 then
         begin
          TextOutSsv(canvasV,XA1,XA2,YR2T,'Compartment');
          TextOutSsv(canvasV,XA2,XA3,YR2T,'Subcompartment');
          if tiskPorost then TextOutSsv(canvasV,XA3,XA3a,YR2T,'Stand');
         end;
        Xam:=mx(0.11);
        XA4D:=((XA4-Xam)-(XA3a+Xam)) div 2;
        if jazyk=cesky then
         begin
          TextOutSsv(canvasV,XA3a,XA4-XA4d,YR2T,'Bezles a');
          TextOutSsv(canvasV,XA3a+XA4D,XA4,YR2T,'jin pozemky');
         end;
        if jazyk=Anglicky1 then
         begin
          TextOutSsv(canvasV,XA3a,XA4-XA4d,YR2T,'Forest-free');
          TextOutSsv(canvasV,XA3a+XA4D,XA4,YR2T,'and other areas');
         end;
        XA5D:=((XA5-Xam)-(XA4+Xam)) div 2;
        if not tiskMajitVRad then
        {
         begin
          TextOutSsv(canvasV,XA4,XA5-XA5d,YR2T,'Majitel ');
          TextOutSsv(canvasV,XA4+XA5D,XA5,YR2T,'cau ');
         end
        else }
         begin
          if jazyk=cesky then
          begin
           TextOutSsv(canvasV,XA4,XA5-XA5d,YR2T,'Pozemky ');
           TextOutSsv(canvasV,XA4+XA5D,XA5,YR2T,'mimo PUPFL ');
          end;
         if jazyk=Anglicky1 then
          begin
           TextOutSsv(canvasV,XA4,(2*xa4+XA5)div 3,YR2T,'Land out of PDFF ');
           TextOutSsv(canvasV,(2*xa4+XA5)div 3,(2*xa5+XA4)div 3,YR2T,'(plots determined ');
           TextOutSsv(canvasV,(2*xa5+XA4)div 3,XA5,YR2T,'for forest function)');
           // TextOutSsv(canvasV,XA4,XA5-XA5d,YR2T,'Land out of PDFF ');
           // TextOutSsv(canvasV,XA4+XA5D,XA5,YR2T,'(plots determined for forest function)');
          end;
         end;

        if not HavlBrod then
         begin
          pen.Width:=1;
          // FONT.NAME:='Arial CE';
          FONT.NAME:=VFont;
          Font.Size:=FS;
          Font.Style:=[];
          font.Charset:=238;
          SetTextOrientation(CanvasV,90);
         end;
        if jazyk=cesky then
         begin
          XAR1D:=((XAR1-mx(0.15))-(XA7+mx(0.15))) div 2;
          TextOutSsv(canvasV,XA7,XAR1-XAR1D,YR4T,'Rozleovac prseky');
          TextOutSsv(canvasV,XA7+XAR1D,XAR1,YR4T,'ir ne 4 m');
          XAR2D:=((XAR2-mx(0.15))-(XAR1+mx(0.15))) div 2;
          TextOutSsv(canvasV,XAR1,XAR2-XAR2D,YR4T,'Nezpevnn lesn');
          TextOutSsv(canvasV,XAR1+XAR2D,XAR2,YR4T,'cesty ir ne 4M');
          TextOutSsv(canvasV,XAR2,XAR3,YR4T,'Lesn skldky');
          TextOutSsv(canvasV,XAR3,XAR4,YR4T,'Lesn kolky');
          TextOutSsv(canvasV,XAR4,XAR5,YR4T,'Semeni');
          XAR6D:=((XAR6-mx(0.15))-(XAR5+mx(0.15))) div 2;
          TextOutSsv(canvasV,XAR5,XAR6-XAR6D,YR4T,'Produktovody a');
          TextOutSsv(canvasV,XAR5+XAR6D,XAR6,YR4T,'elektrovody');
          TextOutSsv(canvasV,XAR6,XAR7a,YR4T,'Okusov plochy');
          TextOutSsv(canvasV,XAR7a,XAR7b,YR4T,'Semenn sady');
          TextOutSsv(canvasV,XAR7b,XAR7c,YR4T,'Matenice');
          TextOutSsv(canvasV,XAR7c,XAR7,YR4T ,'Klonov archvy');
          TextOutSsv(canvasV,XAR7,XA8,YR4T,'Dal bezles');
          TextOutSsv(canvasV,XA8,XAR9,YR4T,'Zpevnn lesn cesty');
          TextOutSsv(canvasV,XAR9,XAR10,YR4T,'Drobn vodn plochy');
          XAR11D:=((XAR11-mx(0.15))-(XAR10+mx(0.15))) div 2;
          TextOutSsv(canvasV,XAR10,XAR11-XAR11D,YR4T,'Pozemky nad horn');
          TextOutSsv(canvasV,XAR10+XAR11D,XAR11,YR4T,'hranic lesa');
          XAR12D:=((XAR13-mx(0.15))-(XAR12+mx(0.15))) div 2;
          TextOutSsv(canvasV,XAR11,XAR12-XAR12D,YR4T,'Lesn pastviny a');
          TextOutSsv(canvasV,XAR11+XAR12D,XAR12,YR4T,'polka pro zv');
          TextOutSsv(canvasV,XAR12,XAR13,YR4T,'Neplodn pdy');
          TextOutSsv(canvasV,XAR13,XA9,YR4T,'Dal jin pozemky');
        FONT.NAME:=VFont;
        Font.Size:=FSD;
        Font.Style:=[];
        font.Charset:=238;

        if tiskMajitVRad then
         begin
          TextOutS(canvasV,XA4,XA5,YR1T,'Majitel');
          TextOutS(canvasV,XA4,XA5,YR1T+RADy,' ');
         end;

        TextOutS(canvasV,XA5,XA6,YR1T,'Katastrln');
        TextOutS(canvasV,XA5,XA6,YR1T+RADy,'zem');

        TextOutS(canvasV,XA6,XA7,YR1T,'Porostn');
        TextOutS(canvasV,XA6,XA7,YR1T+RADy,'pda');
        TextOutS(canvasV,XA6,XA7,YR1T+2*RADy,'( ha )');

        TextOutS(canvasV,XA7,XA8,YR1tt,'Bezles ( ha )');
        TextOutS(canvasV,XA8,XA9,YR1tt,'Jin pozemky ( ha )');
        TextOutS(canvasV,XA9,XA10,YR1T,'PUPFL');
        TextOutS(canvasV,XA9,XA10,YR1T+RADy,'celkem');
        TextOutS(canvasV,XA9,XA10,YR1T+2*RADy,'( ha )');
        TextOutS(canvasV,XA10,XA11,YR1T,'Kategorie');
        TextOutS(canvasV,XA10,XA11,YR1T+RADy,'s pekryvem');

        if not tiskMajitVRad then
         begin
          TextOutS(canvasV,XA11,XA12,YR1T-RADy,'Pozemky');
          TextOutS(canvasV,XA11,XA12,YR1T,'mimo');
          TextOutS(canvasV,XA11,XA12,YR1T+RADy,'PUPFL');
          TextOutS(canvasV,XA11,XA12,YR1T+2*RADy,'( ha )');
         end;

        TextOutS(canvasV,XA7,XAR1,   YR4TT,'RP');
        TextOutS(canvasV,XAR1,XAR2,  YR4TT,'NC');
        TextOutS(canvasV,XAR2,XAR3,  YR4TT,'SK');
        TextOutS(canvasV,XAR3,XAR4,  YR4TT,'LS');
        TextOutS(canvasV,XAR4,XAR5,  YR4TT,'SP');
        TextOutS(canvasV,XAR5,XAR6,  YR4TT,'PE');
        TextOutS(canvasV,XAR6,XAR7a, YR4TT,'OP');
        TextOutS(canvasV,XAR7a,XAR7b,YR4TT,'SS');
        TextOutS(canvasV,XAR7b,XAR7c,YR4TT,'MA');
        TextOutS(canvasV,XAR7c,XAR7, YR4TT,'KA');
        TextOutS(canvasV,XAR7,XA8,   YR4TT,'DB');
        TextOutS(canvasV,XA8,XAR9,   YR4TT,'ZC');
        TextOutS(canvasV,XAR9,XAR10, YR4TT,'VP');
        TextOutS(canvasV,XAR10,XAR11,YR4TT,'HP');
        TextOutS(canvasV,XAR11,XAR12,YR4TT,'ZP');
        TextOutS(canvasV,XAR12,XAR13,YR4TT,'NP');
        TextOutS(canvasV,XAR13,XA9,  YR4TT,'DJ');

         end;
        if jazyk=Anglicky1 then
         begin
          XAR1D:=((XAR1-mx(0.15))-(XA7+mx(0.15))) div 2;
          TextOutSsv(canvasV,XA7,XAR1-XAR1D,YR4T,'Rides over 4m ');
          TextOutSsv(canvasV,XA7+XAR1D,XAR1,YR4T,'in width');
          XAR2D:=((XAR2-mx(0.15))-(XAR1+mx(0.15))) div 2;
          TextOutSsv(canvasV,XAR1,XAR2-XAR2D,YR4T,'Unsurfaced forest');
          TextOutSsv(canvasV,XAR1+XAR2D,XAR2,YR4T,' roads over 4m width');
          TextOutSsv(canvasV,XAR2,XAR3,YR4T,'Forest depots');
          TextOutSsv(canvasV,XAR3,XAR4,YR4T,'Nurseries');
          TextOutSsv(canvasV,XAR4,XAR5,YR4T,'Seedling nurseries');
          XAR6D:=((XAR6-mx(0.15))-(XAR5+mx(0.15))) div 2;
          TextOutSsv(canvasV,XAR5,XAR6-XAR6D,YR4T,'Power transmission');
          TextOutSsv(canvasV,XAR5+XAR6D,XAR6,YR4T,'lines');
          TextOutSsv(canvasV,XAR6,XAR7a,YR4T,'Browsing areas');
          TextOutSsv(canvasV,XAR7a,XAR7b,YR4T,'Seed orchards');
          TextOutSsv(canvasV,XAR7b,XAR7c,YR4T,'Ortets area');
          TextOutSsv(canvasV,XAR7c,XAR7,YR4T ,'Clone archive');


          XAR8D:=((XA8-mx(0.15))-(XAR7+mx(0.15))) div 2;
          TextOutSsv(canvasV,XAR7,XA8-XAR8D,YR4T,'Other forest-free');
          TextOutSsv(canvasV,XAR7+XAR8D,XA8,YR4T,'areas');
          // TextOutSsv(canvasV,XAR7,XA8,YR4T,'Other forest-free areas');

          XAR9D:=((XAR9-mx(0.15))-(XA8+mx(0.15))) div 2;
          TextOutSsv(canvasV,XA8,XAR9-XAR9D,YR4T,'Surfaced forest');
          TextOutSsv(canvasV,XA8+XAR9D,XAR9,YR4T,'roads');
          // TextOutSsv(canvasV,XA8,XAR9,YR4T,'Surfaced forest roads');

          TextOutSsv(canvasV,XAR9,XAR10,YR4T,'Small water areas');
          XAR11D:=((XAR11-mx(0.15))-(XAR10+mx(0.15))) div 2;
          TextOutSsv(canvasV,XAR10,XAR11-XAR11D,YR4T,'Lands above');
          TextOutSsv(canvasV,XAR10+XAR11D,XAR11,YR4T,'the timber line');
          XAR12D:=((XAR13-mx(0.15))-(XAR12+mx(0.15))) div 2;
          TextOutSsv(canvasV,XAR11,XAR12-XAR12D,YR4T,'Pasture lands');
          TextOutSsv(canvasV,XAR11+XAR12D,XAR12,YR4T,'');
          TextOutSsv(canvasV,XAR12,XAR13,YR4T,'Barren lands');
          TextOutSsv(canvasV,XAR13,XA9,YR4T,'Other lands');

          FONT.NAME:=VFont;
          Font.Size:=FSD;
          Font.Style:=[];
          font.Charset:=238;

          if tiskMajitVRad then
           begin
            TextOutS(canvasV,XA4,XA5,YR1T,'Property');
            TextOutS(canvasV,XA4,XA5,YR1T+RADy,' ');
           end;

          TextOutS(canvasV,XA5,XA6,YR1T,'Cadastral');
          TextOutS(canvasV,XA5,XA6,YR1T+RADy,'area');

          TextOutS(canvasV,XA6,XA7,YR1T,'Wooded');
          TextOutS(canvasV,XA6,XA7,YR1T+RADy,'land');
          TextOutS(canvasV,XA6,XA7,YR1T+2*RADy,'( ha )');

          TextOutS(canvasV,XA7,XA8,YR1tt,'Wooded land (ha)');
          TextOutS(canvasV,XA8,XA9,YR1tt,'Other land (ha)');
          TextOutS(canvasV,XA9,XA10,YR1T,'PDFF');
          TextOutS(canvasV,XA9,XA10,YR1T+RADy,'Total');
          TextOutS(canvasV,XA9,XA10,YR1T+2*RADy,'( ha )');
          TextOutS(canvasV,XA10,XA11,YR1T,'Category');
          TextOutS(canvasV,XA10,XA11,YR1T+RADy,'with overlay');

          if not tiskMajitVRad then
           begin
            TextOutS(canvasV,XA11,XA12,YR1T-RADy,'Lands');
            TextOutS(canvasV,XA11,XA12,YR1T,'out of');
            TextOutS(canvasV,XA11,XA12,YR1T+RADy,'PDFF');
            TextOutS(canvasV,XA11,XA12,YR1T+2*RADy,'( ha )');
           end;
        end;
   if richEd<>nil then
    begin
      richEd.refresh;
      Application.ProcessMessages;
     with RichEd.Paragraph do
      begin
       // showmessage('cau '+inttostr(tabcount));
       LeftIndent:=0;
       tabcount:= 27;
       tab[0] :=  15;
       tab[1] :=  30;
       tab[2] :=  45;
       tab[3] :=  65;
       tab[4] :=  80;
       tab[5] := 120;
       tab[6] := 140;
       K:=15;
       tab[7] := tab[6]+K;
       tab[8] := tab[7]+K;
       tab[9] := tab[8]+K;
       tab[10] := tab[9]+K;
       tab[11] := tab[10]+K;
       tab[12] := tab[11]+K;
       tab[13] := tab[12]+K;
       tab[14] := tab[13]+K;
       tab[15] := tab[14]+K;
       tab[16] := tab[15]+K;
       tab[17] := tab[16]+K;
       tab[18] := tab[17]+K;
       tab[19] := tab[18]+K;
       tab[20] := tab[19]+K;
       tab[21] := tab[20]+K;
       tab[22] := tab[21]+K;
       tab[23] := tab[22]+K;

       tab[24] := tab[23]+20;
       tab[25] := tab[24]+40;
       tab[26] := tab[25]+K;

      end;

     with RichEd.SelAttributes do
      begin
       Size:=4;
       style:=[fsBold];
       name:='Arial';
       Charset:=238;
      end;
     RadRich:='Odd'+chr(9)+'Dil'+chr(9)+'Por'+chr(9)+'Bzl,JP'+chr(9)+'Ost'+chr(9)+'K.U.'+chr(9)+'Por.P.'+chr(9)+'RP'+chr(9)+'NC'+chr(9)+'SK'+chr(9)+'LS'+chr(9)+'SP'+chr(9)+'PE'+chr(9)+'OP'+chr(9)+'SS'+chr(9)+'MA'+chr(9)+'KA'+chr(9)+'DB'+chr(9)+'ZC'+chr(9)+'VP'+chr(9)+'HP'+chr(9)+'ZP'+chr(9)+'NP'+chr(9)+'DJ'+chr(9)+'PUPFL'+chr(9)+'KTG'+chr(9)+'Ost';
     richEd.lines.add('   ');richEd.lines.add('   ');
     richEd.lines.add(RadRich);
    end;
     pen.width:=5;
     PolyLine([Point(XA1,YR1),
               Point(XA12,YR1)]);
     PolyLine([Point(XA1,YR1),
               Point(XA1,YR2)]);
     PolyLine([Point(XA6,YR1),
               Point(XA6,YR2)]);
     PolyLine([Point(XA7,YR1),
               Point(XA7,YR2)]);
     PolyLine([Point(XA8,YR1),
               Point(XA8,YR2)]);
     PolyLine([Point(XA9,YR1),
               Point(XA9,YR2)]);
     PolyLine([Point(XA10,YR1),
               Point(XA10,YR2)]);
     PolyLine([Point(XA11,YR1),
               Point(XA11,YR2)]);
     PolyLine([Point(XA12,YR1),
               Point(XA12,YR2)]);

     pen.width:=1;
     PolyLine([Point(XA2,YR1),
               Point(XA2,YR2)]);
     PolyLine([Point(XA3,YR1),
               Point(XA3,YR2)]);
     if tiskPorost then
      begin
       PolyLine([Point(XA3a,YR1),
                 Point(XA3a,YR2)]);
      end;
     PolyLine([Point(XA4,YR1),
               Point(XA4,YR2)]);
     PolyLine([Point(XA5,YR1),
               Point(XA5,YR2)]);

     PolyLine([Point(XAR1,YR2),
               Point(XAR1,YR3)]);
     PolyLine([Point(XAR2,YR2),
               Point(XAR2,YR3)]);
     PolyLine([Point(XAR3,YR2),
               Point(XAR3,YR3)]);
     PolyLine([Point(XAR4,YR2),
               Point(XAR4,YR3)]);
     PolyLine([Point(XAR5,YR2),
               Point(XAR5,YR3)]);
     PolyLine([Point(XAR6,YR2),
               Point(XAR6,YR3)]);
     PolyLine([Point(XAR7,YR2),
               Point(XAR7,YR3)]);
     PolyLine([Point(XAR7a,YR2),
               Point(XAR7a,YR3)]);
     PolyLine([Point(XAR7b,YR2),
               Point(XAR7b,YR3)]);
     PolyLine([Point(XAR7c,YR2),
               Point(XAR7c,YR3)]);
     PolyLine([Point(XAR9,YR2),
               Point(XAR9,YR3)]);
     PolyLine([Point(XAR10,YR2),
               Point(XAR10,YR3)]);
     PolyLine([Point(XAR10,YR2),
               Point(XAR10,YR3)]);
     PolyLine([Point(XAR11,YR2),
               Point(XAR11,YR3)]);
     PolyLine([Point(XAR12,YR2),
               Point(XAR12,YR3)]);
     PolyLine([Point(XAR13,YR2),
               Point(XAR13,YR3)]);
     PolyLine([Point(XA7,YR4),
               Point(XA9,YR4)]);
     pen.width:=3;
     PolyLine([Point(XA11,YR1),
               Point(XA11,YR2)]);
     PolyLine([Point(XA7,YR3),
               Point(XA9,YR3)]);
     PolyLine([Point(XA12,YR2),
               Point(XA1,YR2)]);
   end;
 end;
procedure SouctovyRadekZaPorost;
var ichr:integer;
 begin
  with VOdd do
  with CanvasV do
   begin
    TiskniRadekProSoucet;
    with VOdd.dilec.porost do
     begin
      if tbxls<>nil then
       begin
        tbxls.append;
        tbxls.fieldByName('ODD').asinteger:=ODD;
        // tbxls.fieldByName('DIL').asstring:=VODD.dilec.DIL;
        tbxls.fieldByName('por').asstring:=VODD.dilec.DIL+' '+VODD.dilec.porost.por;
        tbxls.fieldByName('por_pud').asfloat:=PorostniPuda;
        {
          'RP'+chr(9)+'NC'+chr(9)+'SK'+chr(9)+'LS'+chr(9)+'SP'+chr(9)
  +'PE'+chr(9)+'OP'+chr(9)+'SS'+chr(9)+'MA'+chr(9)+'KA'+chr(9)+'DB'+chr(9)+'ZC'+chr(9)+
  'VP'+chr(9)+'HP'+chr(9)+'ZP'+chr(9)+'NP'+chr(9)+'DJ'+chr(9)+'PUPFL'+chr(9)+'KTG'+chr(9)+'Ost';
        }
        PoradiAktualnihoVyuziti:= 1;tbxls.fieldByName('RP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 2;tbxls.fieldByName('NC').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 3;tbxls.fieldByName('SK').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 4;tbxls.fieldByName('LS').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 5;tbxls.fieldByName('SP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 6;tbxls.fieldByName('PE').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 7;tbxls.fieldByName('OP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 8;tbxls.fieldByName('SS').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 9;tbxls.fieldByName('MA').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=10;tbxls.fieldByName('KA').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=11;tbxls.fieldByName('DB').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=12;tbxls.fieldByName('ZC').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=13;tbxls.fieldByName('VP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=14;tbxls.fieldByName('HP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=15;tbxls.fieldByName('ZP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=16;tbxls.fieldByName('NP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=17;tbxls.fieldByName('DJ').asfloat:=PlochaVyuziti;

        tbxls.fieldByName('PUPFL').asfloat:=PlochaPUPFL;
        tbxls.fieldByName('KTG').asstring:=Kategorie1MN.KategorieVcetnePrekryvu;
        if tiskMajitVrad then
          begin
           tbxls.fieldByName('MAJIT').asString:=MAJ_KOD;
          end
        else
          begin
           tbxls.fieldByName('OST_PUD').asfloat:=PlochaOSTATNI;
          end;
        tbxls.post;
       end;
      if riched<>nil then
       begin
        with RichEd.SelAttributes do
         begin
          Size:=4;
          style:=[fsBold];
          name:='Arial';
          Charset:=238;
         end;

        // RadRich:=        'Odd'+chr(9)+'Dil'+chr(9)+'Por'+chr(9)+'Bzl,JP'+chr(9)+'Ost'+chr(9)+'K.U.'+chr(9)+'Por.P.'+chr(9)+'RP'+chr(9)+'NC'+chr(9)+'SK'+chr(9)+'LS'+chr(9)+'SP'+chr(9)+'PE'+chr(9)+'OP'+chr(9)+'DB'+chr(9)+'ZC'+chr(9)+'VP'+chr(9)+'HP'+chr(9)+'ZP'+chr(9)+'NP'+chr(9)+'DJ'+chr(9)+'PUPFL'+chr(9)+'KTG';
        RadRich:=intTostr(ODD)+chr(9)+VODD.dilec.DIL+chr(9)+VODD.dilec.porost.POR+chr(9)+''+chr(9)+''
        +chr(9)+''+chr(9)+floatTOStrf(PorostniPuda,ffFixed,8,2);


        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=1;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=2;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=3;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=4;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=5;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=6;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=7;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=8;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=9;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=10;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=11;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=12;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=13;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=14;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=15;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=16;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=17;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);


        RadRich:=radRich+chr(9);
        RadRich:=radRich+floatTOStrf(PlochaPUPFL,ffFixed,8,2);
        RadRich:=radRich+chr(9);
        RadRich:=radRich+Kategorie1MN.KategorieVcetnePrekryvu;
        RadRich:=radRich+chr(9);
        if (PlochaOSTATNI>0.001) then RadRich:=radRich+floatTOStrf(PlochaOSTATNI,ffFixed,6,2);

        with RichEd.SelAttributes do
         begin
          Size:=4;
          style:=[fsBold];
          name:='Arial';
          Charset:=238;
         end;
        richEd.lines.add(RadRich);
        radrich:='-------';
          for ichr:=1 to 98 do
           begin
            radrich:=radrich+'-------';
           end;
          with RichEd.SelAttributes do
           begin
            Size:=2;
            style:=[];
            name:='Arial';
            Charset:=238;
           end;
          richEd.lines.add(RadRich);

       end;

      TextOutPK(CanvasV,XA2,YPT,intTostr(ODD));
      TextOutS(CanvasV,XA2,XA3,YPT,VODD.dilec.DIL);
      if tiskPorost then TextOutS(CanvasV,XA3,XA3a,YPT,VODD.dilec.porost.POR);
      TextOutPK(CanvasV,XA7,YPT,floatTOStrf(PorostniPuda,ffFixed,8,2));
      TextOutPK(CanvasV,XA10,YPT,floatTOStrf(PlochaPUPFL,ffFixed,8,2));
      {TextOutS(CanvasV,XA10,XA11,YPT,Kategorie1MN.KategorieVcetnePrekryvu);}
      TextOUTPrelom(CanvasV,XA10,XA11,YPT,YPT+rady,true,uprostred,Kategorie1MN.KategorieVcetnePrekryvu);


      if (PlochaOSTATNI>0.001)and (not tiskMajitVRad) then
        TextOutPK(CanvasV,XA12,YPT,floatTOStrf(PlochaOSTATNI,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=1;
      // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR1,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XA7+XPP,XAR1,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=2;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR2,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR1+XPP,XAR2,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=3;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR3,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR2+XPP,XAR3,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=4;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR4,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR3+XPP,XAR4,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=5;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR5,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR4+XPP,XAR5,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=6;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR6,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR5+XPP,XAR6,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=7;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR7a,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR6+XPP,XAR7a,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=8;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR7b,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7a+XPP,XAR7b,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=9;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR7c,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7b+XPP,XAR7c,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=10;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR7,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7c+XPP,XAR7,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=11;

       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XA8,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7+XPP,XA8,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=12;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR9,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XA8+XPP,XAR9,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=13;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR10,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR9+XPP,XAR10,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=14;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR11,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR10+XPP,XAR11,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=15;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR12,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR11+XPP,XAR12,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=16;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR13,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR12+XPP,XAR13,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=17;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XA9,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR13+XPP,XA9,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
     end;
    yp:=yp+RADy;
   end;
 end;

procedure SouctovyRadekZaOddeleni;
 begin
  with VOdd do
   begin
  with canvasV do
   begin
    pen.width:=5;
    PolyLine([Point(XA1,YP+RADy),
              Point(XA12,YP+RADy)]);
   end;
    TiskniRadekProSoucet;
    with VOdd do
     begin
      if tbxls<>nil then
       begin
        tbxls.Append;
        tbxls.fieldByName('ODD').asinteger:=ODD;
        tbxls.fieldByName('por').asstring:='celkem';
        tbxls.fieldByName('por_pud').asfloat:=PorostniPuda;
        {
          'RP'+chr(9)+'NC'+chr(9)+'SK'+chr(9)+'LS'+chr(9)+'SP'+chr(9)
  +'PE'+chr(9)+'OP'+chr(9)+'SS'+chr(9)+'MA'+chr(9)+'KA'+chr(9)+'DB'+chr(9)+'ZC'+chr(9)+
  'VP'+chr(9)+'HP'+chr(9)+'ZP'+chr(9)+'NP'+chr(9)+'DJ'+chr(9)+'PUPFL'+chr(9)+'KTG'+chr(9)+'Ost';
        }
        PoradiAktualnihoVyuziti:= 1;tbxls.fieldByName('RP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 2;tbxls.fieldByName('NC').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 3;tbxls.fieldByName('SK').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 4;tbxls.fieldByName('LS').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 5;tbxls.fieldByName('SP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 6;tbxls.fieldByName('PE').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 7;tbxls.fieldByName('OP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 8;tbxls.fieldByName('SS').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 9;tbxls.fieldByName('MA').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=10;tbxls.fieldByName('KA').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=11;tbxls.fieldByName('DB').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=12;tbxls.fieldByName('ZC').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=13;tbxls.fieldByName('VP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=14;tbxls.fieldByName('HP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=15;tbxls.fieldByName('ZP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=16;tbxls.fieldByName('NP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=17;tbxls.fieldByName('DJ').asfloat:=PlochaVyuziti;

        tbxls.fieldByName('PUPFL').asfloat:=PlochaPUPFL;
        tbxls.fieldByName('KTG').asstring:='';
        if not tiskMajitVrad then
          begin
           tbxls.fieldByName('OST_PUD').asfloat:=PlochaOSTATNI;
          end;

        // tbxls.fieldByName('OST_PUD').asfloat:=PlochaOSTATNI;
        tbxls.post;
       end;

      if riched<>nil then
       begin
        with RichEd.SelAttributes do
         begin
          Size:=4;
          style:=[fsBold];
          name:='Arial';
          Charset:=238;
         end;

        RadRich:=intTostr(ODD)+chr(9)+chr(9)+chr(9)+'Celkem za oddlen : '
        +chr(9)+floatTOStrf(PorostniPuda,ffFixed,8,2);


        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=1;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=2;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=3;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);
        RadRich:=radRich+'3';

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=4;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=5;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=6;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=7;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=8;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=9;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=10;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=11;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=12;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=13;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=14;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=15;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=16;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=17;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        RadRich:=radRich+floatTOStrf(PlochaPUPFL,ffFixed,8,2);
        RadRich:=radRich+chr(9);

        RadRich:=radRich+chr(9);
        if (PlochaOSTATNI>0.001) then RadRich:=radRich+floatTOStrf(PlochaOSTATNI,ffFixed,6,2);

        with RichEd.SelAttributes do
         begin
          Size:=4;
          style:=[fsBold];
          name:='Arial';
          Charset:=238;
         end;
        richEd.lines.add(RadRich);
       end;


      if jazyk=cesky then
       begin
        TextOutS (CanvasV,XA2,XA6,YPT,'Celkem za oddlen : ');
       end;
      if jazyk=Anglicky1 then
       begin
        TextOutS (CanvasV,XA2,XA6,YPT,'Compartment total:');
       end;
      TextOutPK(CanvasV,XA2,YPT,intTostr(ODD));
      TextOutPK(CanvasV,XA7,YPT,floatTOStrf(PorostniPuda,ffFixed,8,2));
      TextOutPK(CanvasV,XA10,YPT,floatTOStrf(PlochaPUPFL,ffFixed,8,2));
      if (PlochaOSTATNI>0.001)and (not tiskMajitVRad) then
           TextOutPK(CanvasV,XA12,YPT,floatTOStrf(PlochaOSTATNI,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=1;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XA7+XPP,XAR1,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=2;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR1+XPP,XAR2,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=3;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR2+XPP,XAR3,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=4;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR3+XPP,XAR4,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=5;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR4+XPP,XAR5,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=6;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR5+XPP,XAR6,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=7;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR6+XPP,XAR7a,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=8;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7a+XPP,XAR7b,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=9;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7b+XPP,XAR7c,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=10;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7c+XPP,XAR7,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=11;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7+XPP,XA8,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=12;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XA8+XPP,XAR9,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=13;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR9+XPP,XAR10,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=14;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR10+XPP,XAR11,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=15;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR11+XPP,XAR12,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=16;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR12+XPP,XAR13,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=17;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR13+XPP,XA9,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      {
      PoradiAktualnihoVyuziti:=1;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR1,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=2;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR2,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=3;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR3,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=4;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR4,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=5;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR5,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=6;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR6,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=7;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR7a,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=8;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR7b,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=9;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR7c,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=10;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR7,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=11;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XA8,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=12;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR9,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=13;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR10,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=14;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR11,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=15;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR12,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=16;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR13,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=17;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XA9,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      }
     end;
    yp:=yp+RADy;
   end;
 { printer.newPage; }
 end;
procedure TiskniPorost;
Function PorostSeVejde:boolean;
var zbyvaY:longint;
    ibz,iKtst:integer;
    VyjdeTisk,vyjdetoNaSirku:boolean;
 begin
 with CanvasV do
   begin
    with VOdd.dilec.porost do
     begin
      zbyvaY:=MerYMax-YP;
      for iKtst:=1 to PocetKatastruZeSkupin do
       begin
        PoradiAktualnihoKatastruZeSkupin:=iKtst;
        VyjdeTisk:=tiskniNeboVyzKousej(CanvasV,XA5,XA6,10,10+rady,uprostred,
                       NazevAktualnihoKatastruZeSkupin,false,
                       vyjdetoNaSirku);
        if VyjdeTisk and not(vyjdetoNaSirku) then vyjdeTisk:=false;
        if VyjdeTisk then
         begin
          zbyvaY:=zbyvaY-radY;
         end
        else
         begin
          zbyvaY:=zbyvaY-2*radY;
         end;
       end;
      with BezlesiMN do
       begin
        for ibz:=0 to count-1 do
         begin
          VyjdeTisk:=true;
          VyjdeTisk:=tiskniNeboVyzKousej(CanvasV,XA5,XA6,10,10+rady,uprostred,
                      TBezlesi(Elements[ibz]).NazevKatastru_BZL,false,vyjdetoNaSirku);
          if VyjdeTisk and not(vyjdetoNaSirku) then vyjdeTisk:=false;
          if VyjdeTisk then
           begin
            zbyvaY:=zbyvaY-radY;
           end
          else
           begin
            zbyvaY:=zbyvaY-2*radY;
           end;
         end;
       end;
      with JinyPozemekMN do
       begin
        for ibz:=0 to count-1 do
         begin
          VyjdeTisk:=tiskniNeboVyzKousej(CanvasV,XA5,XA6,10,10+rady,uprostred,
                        TJinyPozemek(Elements[ibz]).NazevKatastru_JP,false,vyjdetoNaSirku);
          if VyjdeTisk and not(vyjdetoNaSirku) then vyjdeTisk:=false;
          if VyjdeTisk then
           begin
            zbyvaY:=zbyvaY-radY;
           end
          else
           begin
            zbyvaY:=zbyvaY-2*radY;
           end;
         end;
       end;
      with OstatniMN do
       begin
        for ibz:=0 to count-1 do
         begin
          zbyvaY:=zbyvaY-radY;
         end;
       end;
     end;
   end;
  zbyvaY:=zbyvaY-radY; {soucet}
  result:=(ZbyvaY>0);
 end;
var ibz,iKtst,iJine,iOst,ichr:integer;
    zalFontSize:integer;
    XBZL,xbzl1,Xjp,xjp1:longint;
    vyjdetoNaSirku,VyjdeTisk,VyjdeTisk1:Boolean;
 begin
  with VOdd do
  with CanvasV do
   begin
    if    (Vodd.dilecMN.indexOf(VOdd.dilec)<>0)
        or (Vodd.dilec.porostMN.indexOf(VOdd.dilec.porost)<>0) then
      begin
       if not porostSeVejde then
        begin
         holeodstrankovani;
         tiskniHlavicku('');
        end;
      end;

    with VOdd.dilec.porost do
     begin
      for iKtst:=1 to PocetKatastruZeSkupin do
       begin
        PoradiAktualnihoKatastruZeSkupin:=iKtst;
        if PoradiAktualnihoKatastruZeSkupin=1 then
         begin
          if TbXLS<>nil then
           begin
            tbxls.append;
            tbxls.fieldByName('ODD').asinteger:=ODD;
            // tbxls.fieldByName('DIL').asstring:=VODD.dilec.DIL;
            tbxls.fieldByName('por').asstring:=VODD.dilec.DIL+' '+VODD.dilec.porost.POR;
            tbxls.fieldByName('por_pud').asfloat:=PorostniPuda;
           end;
          if richEd<>nil then
           begin
            with RichEd.SelAttributes do
             begin
              Size:=4;
              style:=[fsBold];
              name:='Arial';
              Charset:=238;
             end;
            RadRich:=intTostr(ODD)+chr(9)+VODD.dilec.DIL+chr(9)+VODD.dilec.porost.POR+chr(9)+''+chr(9)+'';
           end;
          TextOutPK(CanvasV,XA2,YPT,intTostr(ODD));
          TextOutS(CanvasV,XA2,XA3,YPT,VODD.dilec.DIL);
          if TiskPorost then TextOutS(CanvasV,XA3,XA3a,YPT,VODD.dilec.porost.POR);
          if tiskMajitVRad then
           begin

            zalFontSize:=Canvasv.Font.size;
            CanvasV.Font.size:=7;
            if jenMaj_KOD then
             begin
              VyjdeTisk1:=tiskniNeboVyzKousej(CanvasV,XA4,XA5,YPT,YPT+rady,uprostred,
                       VODD.dilec.porost.MAJ_KOD,false,
                       vyjdetoNaSirku);
             end
            else
             begin
              VyjdeTisk1:=tiskniNeboVyzKousej(CanvasV,XA4,XA5,YPT,YPT+rady,uprostred,
                       VODD.dilec.porost.MAJ_NAZ,false,
                       vyjdetoNaSirku);
             end;
            CanvasV.Font.size:=zalFontSize;
            if VyjdeTisk1 and not(vyjdetoNaSirku) then vyjdeTisk1:=false;
            if VyjdeTisk1 then
             begin
              // TextOUTPrelom(CanvasV,XA5,XA6,YPT,YPT+rady,true,uprostred,NazevAktualnihoKatastruZeSkupin);
             if jenMaj_KOD then
              begin
               TextOUTPrelom(CanvasV,XA4,XA5,YPT,YPT+rady,true,uprostred,VODD.dilec.porost.MAJ_KOD);
              end
             else
              begin
               TextOUTPrelom(CanvasV,XA4,XA5,YPT,YPT+rady,true,uprostred,VODD.dilec.porost.MAJ_NAZ);
              end;
             end
            else
             begin
             if jenMaj_KOD then
              begin
               TextOUTPrelom(CanvasV,XA4,XA5,YPT,YPT+2*rady,true,uprostred,VODD.dilec.porost.MAJ_KOD);
              end
             else
              begin
               TextOUTPrelom(CanvasV,XA4,XA5,YPT,YPT+2*rady,true,uprostred,VODD.dilec.porost.MAJ_NAZ);
              end;
             end;
           end
          else
           begin
            VyjdeTisk1:=true;
           end;
         end
        else
         begin
          if richEd<>nil then
           begin
            RadRich:=chr(9)+chr(9)+chr(9)+chr(9);
           end;
          if TbXLS<>nil then
           begin
            tbxls.append;
           end;
         end;
        zalFontSize:=Canvasv.Font.size;
        CanvasV.Font.size:=7;
        VyjdeTisk:=tiskniNeboVyzKousej(CanvasV,XA5,XA6,YPT,YPT+rady,uprostred,
                       NazevAktualnihoKatastruZeSkupin,false,
                       vyjdetoNaSirku);

        CanvasV.Font.size:=zalFontSize;
        if VyjdeTisk and not(vyjdetoNaSirku) then vyjdeTisk:=false;
        if VyjdeTisk then
         begin
          TextOUTPrelom(CanvasV,XA5,XA6,YPT,YPT+rady,true,uprostred,NazevAktualnihoKatastruZeSkupin);
         end
        else
         begin
          TextOUTPrelom(CanvasV,XA5,XA6,YPT,YPT+2*rady,true,uprostred,NazevAktualnihoKatastruZeSkupin);
         end;

        TextOutPK(CanvasV,XA7,YPT,floatTOStrf(PlochaAktualnihoKatastruZeSkupin,ffFixed,6,2));
        TextOutPK(CanvasV,XA10,YPT,floatTOStrf(PlochaAktualnihoKatastruZeSkupin,ffFixed,6,2));
        TextOUTPrelom(CanvasV,XA10,XA11,YPT,YPT+rady,true,uprostred,Kategorie1MN.KategorieVcetnePrekryvu);
        // TextOutS(CanvasV,XA10,XA11,YPT,Kategorie1MN.KategorieVcetnePrekryvu);
        if VyjdeTisk and VyjdeTisk1 then
         begin
          tiskniRadekProZapsani;
          yp:=yp+RADy;
         end
        else
         begin
          tiskniSvisleCarkyRadku;
          yp:=yp+RADy;
          tiskniRadekProZapsani;
          yp:=yp+RADy;
         end;

        if TbXLS<>nil then
         begin
          tbxls.fieldByName('KU').asstring:=NazevAktualnihoKatastruZeSkupin;
          tbxls.fieldByName('por_pud').asfloat:=PlochaAktualnihoKatastruZeSkupin;
          tbxls.fieldByName('PUPFL').asfloat:=PlochaAktualnihoKatastruZeSkupin;
          if tiskMajitVrad then
           begin
            tbxls.fieldByName('MAJIT').asString:=MAJ_KOD;
           end;

          // VODD.dilec.porost.MAJ_NAZ
          tbxls.fieldByName('KTG').asstring:=Kategorie1MN.KategorieVcetnePrekryvu;
          tbxls.post;
         end;

        if richEd<>nil then
         begin
          radRich:=radRich+chr(9)+CisloAktualnihoKatastruZeSkupin;
          radRich:=radRich+chr(9)+floatTOStrf(PlochaAktualnihoKatastruZeSkupin,ffFixed,6,2);
          for ichr:=1 to 17 do
           begin
            radRich:=radRich+chr(9);
           end;
          radRich:=radRich+chr(9)+floatTOStrf(PlochaAktualnihoKatastruZeSkupin,ffFixed,6,2);
          radRich:=radRich+chr(9)+Kategorie1MN.KategorieVcetnePrekryvu;
          with RichEd.SelAttributes do
           begin
            Size:=4;
            style:=[];
            name:='Arial';
            Charset:=238;
           end;
          richEd.lines.add(RadRich);
         end;
       end;
      with BezlesiMN do
       begin
        for ibz:=0 to count-1 do
         begin
          IF MerYMax<YP then
           begin
            holeodstrankovani;
            tiskniHlavicku('');
           end;
          if Elements[ibz] is TBezlesi then
           begin
            { TextOutS(CanvasV,XA10,XA11,YPT,Kategorie1MN.KategorieVcetnePrekryvu); }
            TextOUTPrelom(CanvasV,XA10,XA11,YPT,YPT+rady,true,uprostred,Kategorie1MN.KategorieVcetnePrekryvu);
            with TBezlesi(Elements[ibz]) do
             begin
              TextOutS(CanvasV,XA3a,XA4,YPT,intToStr(BZL));
              if tiskMajitVRad then
               begin

                zalFontSize:=Canvasv.Font.size;
                CanvasV.Font.size:=7;
                if jenMaj_KOD then
                 begin
                  VyjdeTisk1:=tiskniNeboVyzKousej(CanvasV,XA4,XA5,YPT,YPT+rady,uprostred,
                       VODD.dilec.porost.MAJ_KOD,false,
                       vyjdetoNaSirku);
                 end
                else
                 begin
                  VyjdeTisk1:=tiskniNeboVyzKousej(CanvasV,XA4,XA5,YPT,YPT+rady,uprostred,
                       VODD.dilec.porost.MAJ_NAZ,false,
                       vyjdetoNaSirku);
                 end;
                CanvasV.Font.size:=zalFontSize;
                if VyjdeTisk1 and not(vyjdetoNaSirku) then vyjdeTisk1:=false;
                if VyjdeTisk1 then
                 begin
                  if jenMaj_KOD then
                   begin
                    TextOUTPrelom(CanvasV,XA4,XA5,YPT,YPT+rady,true,uprostred,VODD.dilec.porost.MAJ_KOD);
                   end
                  else
                   begin
                    TextOUTPrelom(CanvasV,XA4,XA5,YPT,YPT+rady,true,uprostred,VODD.dilec.porost.MAJ_NAZ);
                   end
                 end
                else
                 begin
                  if jenMaj_KOD then
                   begin
                    TextOUTPrelom(CanvasV,XA4,XA5,YPT,YPT+2*rady,true,uprostred,VODD.dilec.porost.MAJ_KOD);
                   end
                  else
                   begin
                    TextOUTPrelom(CanvasV,XA4,XA5,YPT,YPT+2*rady,true,uprostred,VODD.dilec.porost.MAJ_NAZ);
                   end;
                 end;
               end
              else
               begin
                VyjdeTisk1:=true;
               end;
              zalFontSize:=CanvasV.Font.size;
              CanvasV.Font.size:=7;

              VyjdeTisk:=tiskniNeboVyzKousej(CanvasV,XA5,XA6,YPT,YPT+rady,uprostred,
                       NazevKatastru,false,
                       vyjdetoNaSirku);
              CanvasV.Font.size:=zalFontSize;

              if VyjdeTisk and not(vyjdetoNaSirku) then vyjdeTisk:=false;
              if VyjdeTisk then
               begin
                TextOUTPrelom(CanvasV,XA5,XA6,YPT,YPT+rady,true,uprostred,NazevKatastru);
               end
              else
               begin
                TextOUTPrelom(CanvasV,XA5,XA6,YPT,YPT+2*rady,true,uprostred,NazevKatastru);
               end;

              // TextOutS(CanvasV,XA5,XA6,YPT,NazevKatastru);

              XBzl:=XA8;
              if uppercase(VYUZITI)='RP' then begin xbzl1:=XA7  ;XBzl:=XAR1; end;
              if uppercase(VYUZITI)='NC' then begin xbzl1:=XAR1 ;XBzl:=XAR2; end;
              if uppercase(VYUZITI)='SK' then begin xbzl1:=XAR2 ;XBzl:=XAR3; end;
              if uppercase(VYUZITI)='LS' then begin xbzl1:=XAR3 ;XBzl:=XAR4; end;
              if uppercase(VYUZITI)='SP' then begin xbzl1:=XAR4 ;XBzl:=XAR5; end;
              if uppercase(VYUZITI)='PE' then begin xbzl1:=XAR5 ;XBzl:=XAR6; end;
              if uppercase(VYUZITI)='OP' then begin xbzl1:=XAR6 ;XBzl:=XAR7a; end;
              if uppercase(VYUZITI)='SS' then begin xbzl1:=XAR7a;XBzl:=XAR7b;  end;
              if uppercase(VYUZITI)='MA' then begin xbzl1:=XAR7b;XBzl:=XAR7c;  end;
              if uppercase(VYUZITI)='KA' then begin xbzl1:=XAR7c;XBzl:=XAR7;  end;
               if uppercase(VYUZITI)='DB'then begin xbzl1:=XAR7 ;XBzl:=XA8;  end;
             // TextOutPK(CanvasV,XBzl,YPT,floatTOStrf(BZL_P,ffFixed,6,2));
              TextOUTPrelom(CanvasV,xbzl1+XPP,xbzl,YPT,YPT+radY,true,naPravo,floatTOStrf(BZL_P,ffFixed,6,2));
              TextOutPK(CanvasV,XA10,YPT,floatTOStrf(BZL_P,ffFixed,6,2));

              if TbXLS<>nil then
               begin
                tbxls.append;
                tbxls.FieldByName('bzl,jp').asstring:=intToStr(BZL);
                tbxls.FieldByName('KU').asstring:=KU_NAZ_BZL;
                if tbxls.findField(uppercase(VYUZITI))<>nil then
                 begin
                  tbxls.FieldByName(uppercase(VYUZITI)).asfloat:=BZL_P;
                 end;
                tbxls.FieldByName('PUPFL').asfloat:=BZL_P;
                tbxls.FieldByName('KTG').asstring:=Kategorie1MN.KategorieVcetnePrekryvu;
                if tiskMajitVrad then
                 begin
                  tbxls.fieldByName('MAJIT').asString:=MAJ_KOD;
                 end;
                tbxls.post;
               end;
              if richEd<>nil then
               begin
                radRich:='';
                radRich:=radRich+chr(9)+chr(9)+chr(9)+intToStr(BZL);
                radRich:=radRich+chr(9)+chr(9)+KU_KOD_xml;

                if uppercase(VYUZITI)='RP' then
                 begin
                  radRich:=radRich+chr(9)+chr(9)+floatTOStrf(BZL_P,ffFixed,6,2)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9);
                 end;
                if uppercase(VYUZITI)='NC' then
                 begin
                  radRich:=radRich+chr(9)+chr(9)+chr(9)+floatTOStrf(BZL_P,ffFixed,6,2)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9);
                 end;
                if uppercase(VYUZITI)='SK' then
                 begin
                  radRich:=radRich+chr(9)+chr(9)+chr(9)+chr(9)+floatTOStrf(BZL_P,ffFixed,6,2)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9);
                 end;
                if uppercase(VYUZITI)='LS' then
                 begin
                  radRich:=radRich+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+floatTOStrf(BZL_P,ffFixed,6,2)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9);
                 end;
                if uppercase(VYUZITI)='SP' then
                 begin
                  radRich:=radRich+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+floatTOStrf(BZL_P,ffFixed,6,2)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9);
                 end;
                if uppercase(VYUZITI)='PE' then
                 begin
                  radRich:=radRich+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+floatTOStrf(BZL_P,ffFixed,6,2)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9);
                 end;
                if uppercase(VYUZITI)='OP' then
                 begin
                  radRich:=radRich+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+floatTOStrf(BZL_P,ffFixed,6,2)+chr(9)+chr(9)+chr(9)+chr(9);
                 end;
                if uppercase(VYUZITI)='SS' then
                 begin
                  radRich:=radRich+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+floatTOStrf(BZL_P,ffFixed,6,2)+chr(9)+chr(9)+chr(9);
                 end;
                if uppercase(VYUZITI)='MA' then
                 begin
                  radRich:=radRich+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+floatTOStrf(BZL_P,ffFixed,6,2)+chr(9)+chr(9);
                 end;
                if uppercase(VYUZITI)='KA' then
                 begin
                  radRich:=radRich+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+floatTOStrf(BZL_P,ffFixed,6,2)+chr(9);
                 end;
                if uppercase(VYUZITI)='DB' then
                 begin
                  radRich:=radRich+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+floatTOStrf(BZL_P,ffFixed,6,2);
                 end;
                radRich:=radRich+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9);
                radRich:=radRich+chr(9)+floatTOStrf(BZL_P,ffFixed,6,2);
                radRich:=radRich+chr(9)+Kategorie1MN.KategorieVcetnePrekryvu+chr(9);
                with RichEd.SelAttributes do
                 begin
                  Size:=4;
                  style:=[];
                  name:='Arial';
                  Charset:=238;
                 end;
                richEd.lines.add(RadRich);
               end;
             end;
            if VyjdeTisk and VyjdeTisk1 then
             begin
              tiskniRadekProZapsani;
              yp:=yp+RADy;
             end
            else
             begin
              tiskniSvisleCarkyRadku;
              yp:=yp+RADy;
              tiskniRadekProZapsani;
              yp:=yp+RADy;
             end;

           end;
         end;
       end;
      with JinyPozemekMN do
       begin
        for ijine:=0 to count-1 do
         begin
          if not (Elements[iJine] is TJinyPozemek) then continue;
          IF MerYMax<YP then
           begin
            holeodstrankovani;
            tiskniHlavicku('');
           end;
          with TJinyPozemek(Elements[iJine]) do
           begin
            TextOUTPrelom(CanvasV,XA10,XA11,YPT,YPT+rady,true,uprostred,Kategorie1MN.KategorieVcetnePrekryvu);
            { TextOutS(CanvasV,XA10 ,XA11,YPT,OwnerPorost.Kategorie1MN.KategorieVcetnePrekryvu);}
            TextOutS(CanvasV,XA3a ,XA4 ,YPT,intToStr(JP));
            // TextOutS(CanvasV,XA5  ,XA6 ,YPT,NazevKatastru);
            if tiskMajitVRad then
             begin
              zalFontSize:=Canvasv.Font.size;
              CanvasV.Font.size:=7;
              if jenMaj_KOD then
               begin
                VyjdeTisk1:=tiskniNeboVyzKousej(CanvasV,XA4,XA5,YPT,YPT+rady,uprostred,
                       VODD.dilec.porost.MAJ_NAZ,false,
                       vyjdetoNaSirku);
               end
              else
               begin
               end;
              CanvasV.Font.size:=zalFontSize;
              if VyjdeTisk1 and not(vyjdetoNaSirku) then vyjdeTisk1:=false;
              if VyjdeTisk1 then
               begin
                if jenMaj_KOD then
                 begin
                  TextOUTPrelom(CanvasV,XA4,XA5,YPT,YPT+rady,true,uprostred,VODD.dilec.porost.MAJ_KOD);
                 end
                else
                 begin
                  TextOUTPrelom(CanvasV,XA4,XA5,YPT,YPT+rady,true,uprostred,VODD.dilec.porost.MAJ_NAZ);
                 end;
               end
              else
               begin
                if jenMaj_KOD then
                 begin
                  TextOUTPrelom(CanvasV,XA4,XA5,YPT,YPT+2*rady,true,uprostred,VODD.dilec.porost.MAJ_KOD);
                 end
                else
                 begin
                  TextOUTPrelom(CanvasV,XA4,XA5,YPT,YPT+2*rady,true,uprostred,VODD.dilec.porost.MAJ_NAZ);
                 end;
               end;
             end
            else
             begin
              VyjdeTisk1:=true;
             end;
            zalFontSize:=CanvasV.Font.size;
            CanvasV.Font.size:=7;
            VyjdeTisk:=tiskniNeboVyzKousej(CanvasV,XA5,XA6,YPT,YPT+rady,uprostred,
                            NazevKatastru,false,vyjdetoNaSirku);
            CanvasV.Font.size:=zalFontSize;
            if VyjdeTisk and not(vyjdetoNaSirku) then vyjdeTisk:=false;
            if VyjdeTisk then
             begin
              TextOUTPrelom(CanvasV,XA5,XA6,YPT,YPT+rady,true,uprostred,NazevKatastru);
             end
            else
             begin
              TextOUTPrelom(CanvasV,XA5,XA6,YPT,YPT+2*rady,true,uprostred,NazevKatastru);
             end;
            Xjp:=XA9;
            if uppercase(VYUZITI)='ZC' then begin xjp1:=XA8;Xjp:=XAR9; end;
            if uppercase(VYUZITI)='VP' then begin xjp1:=XAR9;Xjp:=XAR10; end;
            if uppercase(VYUZITI)='HP' then begin xjp1:=XAR10;Xjp:=XAR11; end;
            if uppercase(VYUZITI)='ZP' then begin xjp1:=XAR11;Xjp:=XAR12; end;
            if uppercase(VYUZITI)='NP' then begin xjp1:=XAR12;Xjp:=XAR13; end;
            if uppercase(VYUZITI)='DJ' then begin xjp1:=XAR13;Xjp:=XA9; end;
            TextOUTPrelom(CanvasV,xjp1+XPP,xjp,YPT,YPT+radY,true,naPravo,floatTOStrf(JP_P,ffFixed,6,2));
            TextOutPK(CanvasV,XA10,YPT,floatTOStrf(JP_P,ffFixed,6,2));
              if TbXLS<>nil then
               begin
                tbxls.append;
                tbxls.FieldByName('bzl,jp').asstring:=intToStr(JP);
                tbxls.FieldByName('KU').asstring:=KU_NAZ_JP;
                if tbxls.findField(uppercase(VYUZITI))<>nil then
                 begin
                  tbxls.FieldByName(uppercase(VYUZITI)).asfloat:=JP_P;
                 end;
                tbxls.FieldByName('PUPFL').asfloat:=JP_P;
                tbxls.FieldByName('KTG').asstring:=Kategorie1MN.KategorieVcetnePrekryvu;
                if tiskMajitVrad then
                 begin
                  tbxls.fieldByName('MAJIT').asString:=MAJ_KOD;
                 end;
                tbxls.post;
               end;

              if richEd<>nil then
               begin
                radRich:='';
                radRich:=radRich+chr(9)+chr(9)+chr(9)+intToStr(JP);
                radRich:=radRich+chr(9)+chr(9)+KU_KOD_xml+chr(9);
                for  Ichr:=1 to 11 do
                 begin
                  radRich:=radRich+chr(9);
                 end;
                if uppercase(VYUZITI)='ZC' then
                 begin
                  radRich:=radRich+chr(9)+floatTOStrf(JP_P,ffFixed,6,2)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9);
                 end;
                if uppercase(VYUZITI)='VP' then
                 begin
                  radRich:=radRich+chr(9)+chr(9)+floatTOStrf(JP_P,ffFixed,6,2)+chr(9)+chr(9)+chr(9)+chr(9);
                 end;
                if uppercase(VYUZITI)='HP' then
                 begin
                  radRich:=radRich+chr(9)+chr(9)+chr(9)+floatTOStrf(JP_P,ffFixed,6,2)+chr(9)+chr(9)+chr(9);
                 end;
                if uppercase(VYUZITI)='ZP' then
                 begin
                  radRich:=radRich+chr(9)+chr(9)+chr(9)+chr(9)+floatTOStrf(JP_P,ffFixed,6,2)+chr(9)+chr(9);
                 end;
                if uppercase(VYUZITI)='NP' then
                 begin
                  radRich:=radRich+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+floatTOStrf(JP_P,ffFixed,6,2)+chr(9);
                 end;
                if uppercase(VYUZITI)='DJ' then
                 begin
                  radRich:=radRich+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+chr(9)+floatTOStrf(JP_P,ffFixed,6,2);
                 end;
                radRich:=radRich+chr(9)+floatTOStrf(JP_P,ffFixed,6,2);
                radRich:=radRich+chr(9)+Kategorie1MN.KategorieVcetnePrekryvu+chr(9);
                with RichEd.SelAttributes do
                 begin
                  Size:=4;
                  style:=[];
                  name:='Arial';
                  Charset:=238;
                 end;
                richEd.lines.add(RadRich);
               end;
             end;
            if VyjdeTisk and VyjdeTisk1 then
             begin
              tiskniRadekProZapsani;
              yp:=yp+RADy;
             end
            else
             begin
              tiskniSvisleCarkyRadku;
              yp:=yp+RADy;
              tiskniRadekProZapsani;
              yp:=yp+RADy;
             end;
           end;
         end;
        with OstatniMN do
         begin
          if (not tiskMajitVRad) then
           begin
            for iOST:=0 to count-1 do
             begin
              if not (Elements[iOST] is TOstatni) then continue;
              IF MerYMax<YP then
               begin
                holeodstrankovani;
                tiskniHlavicku('');
               end;
              with TOstatni(Elements[iOST]) do
               begin
                TextOutS(CanvasV,XA4,XA5,YPT,intToStr(OST));
                TextOutPK(CanvasV,XA12,YPT,floatTOStrf(OST_P,ffFixed,6,2));
                zalFontSize:=CanvasV.Font.size;
                CanvasV.Font.size:=7;
                VyjdeTisk:=tiskniNeboVyzKousej(CanvasV,XA5,XA6,YPT,YPT+rady,uprostred,
                         NazevKatastru,false,vyjdetoNaSirku);
                CanvasV.Font.size:=zalFontSize;
                if VyjdeTisk and not(vyjdetoNaSirku) then vyjdeTisk:=false;
                if VyjdeTisk then
                 begin
                  TextOUTPrelom(CanvasV,XA5,XA6,YPT,YPT+rady,true,uprostred,NazevKatastru);
                 end
                else
                 begin
                  TextOUTPrelom(CanvasV,XA5,XA6,YPT,YPT+2*rady,true,uprostred,NazevKatastru);
                 end;
              if TbXLS<>nil then
               begin
                tbxls.append;
                tbxls.FieldByName('OST').asstring:=intToStr(ost);
                tbxls.FieldByName('KU').asstring:=KU_NAZ;
                if tiskMajitVrad then
                 begin
                  tbxls.fieldByName('MAJIT').asString:=MAJ_KOD;
                 end
                else
                 begin
                  tbxls.FieldByName('OST_PUD').asfloat:=OST_P;
                 end;
                tbxls.FieldByName('KTG').asstring:=Kategorie1MN.KategorieVcetnePrekryvu;
                tbxls.post;
               end;

                if richEd<>nil then
                 begin
                  radRich:='';
                  radRich:=radRich+chr(9)+chr(9)+chr(9)+chr(9)+intToStr(OST);
                  radRich:=radRich+chr(9)+KU_KOD_xml+chr(9);
                  for  Ichr:=1 to 19 do
                   begin
                    radRich:=radRich+chr(9);
                   end;
                  radRich:=radRich+chr(9)+floatTOStrf(OST_P,ffFixed,6,2);
                  with RichEd.SelAttributes do
                   begin
                    Size:=4;
                    style:=[];
                    name:='Arial';
                    Charset:=238;
                   end;
                  richEd.lines.add(RadRich);
                 end;
               end;
              tiskniRadekProZapsani;
              yp:=yp+RADy;
             end;
           end;
         end;
     end;
    SouctovyRadekZaPorost;
   end;
 end;
procedure TiskniOddeleni;
var idil,iPor,iJine,iOst:integer;
    Xjp,xjp1:longint;
begin
netisknout:=false;
 with Vodd do
  begin
  YRR:=0;

  if NaTiskarnu2 then MerYMax:=round(mery*0.95)
     else merYMax:=round(screen.height);
  tiskniHlavicku('');
   with DilecMN do
    begin
     for iDil:=0 to count-1 do
      begin
       if not (Elements[iDil] is TDilec) then continue;
       JmenoAktualnihoPrvku:=TDilec(Elements[iDil]).DIL;
       with Dilec do
        begin
         with PorostMN do
          begin
           for iPor:=0 to count-1 do
            begin
             if not (Elements[iPor] is TPorost) then continue;
             JmenoAktualnihoPrvku:=TPorost(Elements[iPor]).POR;
             TiskniPorost;
            end;
          end;
        end;
      end;
    end;
   SouctovyRadekZaOddeleni;
 end;
 // holeOdstrankovani; {za oddeleni}
end;
procedure TiskniSoucet(oddMN:TOddeleniMN;Query1:TQuery);
var PSumarLHC:TSumarLHC;
 begin
  netisknout:=False;
  YRR:=0;
  if NaTiskarnu2 then MerYMax:=round(mery*0.95)
     else merYMax:=round(screen.height);
  if OddMN=nil then SpoctiSumarLHC_DB98(PSumarLHC,Query1)
  else SpoctiSumarOddeleniMN98(PSumarLHC,OddMN);
  With PSumarLHC do
   begin
    tiskniHlavicku(MajitelLHC);
    TiskniRadekProSoucet;
    if jazyk=cesky then
     begin
      TextOutS (CanvasV,XA2,XA6,YPT,'Celkem za celek : ');
     end;
    if jazyk=Anglicky1 then
     begin
      TextOutS (CanvasV,XA2,XA6,YPT,'Total per forest management plan area:');
     end;
      TextOutPK(CanvasV,XA7,YPT,floatTOStrf(PorostniPuda,ffFixed,8,2));
      TextOutPK(CanvasV,XA10,YPT,floatTOStrf(PlochaPUPFL,ffFixed,8,2));
      if (PlochaOSTATNI>0.001) and (not tiskMajitVRad)then
           TextOutPK(CanvasV,XA12,YPT,floatTOStrf(PlochaOSTATNI,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=1;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XA7+XPP,XAR1,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=2;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR1+XPP,XAR2,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=3;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR2+XPP,XAR3,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=4;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR3+XPP,XAR4,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=5;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR4+XPP,XAR5,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=6;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR5+XPP,XAR6,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=7;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR6+XPP,XAR7a,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=8;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7a+XPP,XAR7b,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=9;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7b+XPP,XAR7c,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=10;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7c+XPP,XAR7,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=11;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7+XPP,XA8,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=12;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XA8+XPP,XAR9,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=13;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR9+XPP,XAR10,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=14;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR10+XPP,XAR11,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=15;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR11+XPP,XAR12,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=16;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR12+XPP,XAR13,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=17;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR13+XPP,XA9,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));

      if tbxls<>nil then
       begin
        tbxls.append;
        tbxls.fieldByName('por').asstring:='LHC:';
        tbxls.fieldByName('por_pud').asfloat:=PorostniPuda;
        PoradiAktualnihoVyuziti:= 1;tbxls.fieldByName('RP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 2;tbxls.fieldByName('NC').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 3;tbxls.fieldByName('SK').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 4;tbxls.fieldByName('LS').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 5;tbxls.fieldByName('SP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 6;tbxls.fieldByName('PE').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 7;tbxls.fieldByName('OP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 8;tbxls.fieldByName('SS').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:= 9;tbxls.fieldByName('MA').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=10;tbxls.fieldByName('KA').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=11;tbxls.fieldByName('DB').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=12;tbxls.fieldByName('ZC').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=13;tbxls.fieldByName('VP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=14;tbxls.fieldByName('HP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=15;tbxls.fieldByName('ZP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=16;tbxls.fieldByName('NP').asfloat:=PlochaVyuziti;
        PoradiAktualnihoVyuziti:=17;tbxls.fieldByName('DJ').asfloat:=PlochaVyuziti;
        tbxls.fieldByName('PUPFL').asfloat:=PlochaPUPFL;
        // tbxls.fieldByName('OST_PUD').asfloat:=PlochaOSTATNI;
        if not tiskMajitVrad then
          begin
           tbxls.fieldByName('OST_PUD').asfloat:=PlochaOSTATNI;
          end;
        tbxls.post;
       end;


      if riched<>nil then
       begin
        RadRich:=chr(9)+chr(9)+chr(9)+'Celkem za cel LHC: '
        +chr(9)+floatTOStrf(PorostniPuda,ffFixed,8,2);
        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=1;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=2;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=3;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);
        RadRich:=radRich+'3';

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=4;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=5;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=6;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=7;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=8;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=9;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=10;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=11;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=12;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=13;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=14;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=15;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=16;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        PoradiAktualnihoVyuziti:=17;
        if PlochaVyuziti>0.0001 then RadRich:=radRich+floatTOStrf(PlochaVyuziti,ffFixed,6,2);

        RadRich:=radRich+chr(9);
        RadRich:=radRich+floatTOStrf(PlochaPUPFL,ffFixed,8,2);
        RadRich:=radRich+chr(9);

        RadRich:=radRich+chr(9);
        if (PlochaOSTATNI>0.001) then RadRich:=radRich+floatTOStrf(PlochaOSTATNI,ffFixed,6,2);

        with RichEd.SelAttributes do
         begin
          Size:=4;
          style:=[];
          name:='Arial';
          Charset:=238;
         end;
        richEd.lines.add(RadRich);
       end;

     end;
    yp:=yp+RADy;
   holeodstrankovani; {soucet}
   PSumarLHC.free;
  end;
 begin
 if tiskSouctu then
  tiskniSoucet(oddMN,query1)

 else
  TiskniOddeleni;
 end;

procedure TiskKatastru(oddMn:TOddeleniMN;CanvasV:TCanvas;RichEd:TRichEdit;TBXls:TTAble;
                       merX,MerY:longint;NaTiskarnu1:Boolean;VColor:TColor;VFont:string;jazyk:tjazyk;
                       Query1:TQuery);
 var PSumarLHC:TSumarLHC;
     FS,FSD,FSDK,FSDM:longint;
     radx,XAR,Xa1,Xa2,Xa3,Xa4,Xa5,Xa6,Xa7,Xa8,Xa9:longint;
     YRR,YP,merYMax,RH,RADy,YR1,YR2,YR3,YR4,YR1T,YR3T:longint;
function mx(x:real):longint;
 begin
  mx:=mx1(x,MerX);
 end;
function my(y:real):longint;
 begin
  my:=my1(y,mery);
 end;
function YPT:longint;
 begin
  result:=YP+my(0.1);
 end;
procedure HoleOdstrankovani1;
begin
if NaTiskarnu1 then
 begin
  with printer do
   begin
      newpage;
      MerYMax:=round(mery*0.95);
   end;
 end
else
 begin
   YRR:=YRR+round(screen.height*1.1);
   merYMax:=YRR+round(screen.height);
 end;
end;
procedure nastavBody;
 begin
   FS:=7;
   FSD:=9;
   FSDK:=12;
   FSDM:=3;
   radx:=   mx(0.40);
   XAR:=    mx(0.98);
   Xa1:=    mx(2.00);
   Xa2:=Xa1+mx(4.00);
   Xa3:=Xa2+mx(4.00);
   Xa4:=Xa3+mx(2.00);
   Xa5:=Xa4+mx(2.00);
   Xa6:=Xa5+mx(2.00);
   Xa7:=Xa6+mx(2.00);
   Xa8:=Xa7+mx(2.00);
   Xa9:=Xa8+mx(2.00);
   YR1:=my(1.8)+YRR;
   RH :=my(1.00);
   RADy:=my(0.5);
   YR2:=YR1+RH;
   YR1T:=YR1+my(0.1);
   YR3:=YR2;
   YP:=YR2;
 end;
procedure tiskniHlavicku;
 var
   K:integer;
 begin
  nastavBody;
  with canvasV do
   begin
    // FONT.NAME:='Arial CE';
    FONT.NAME:=VFont;
    Font.Size:=FSDK;
    Font.Style:=[fsBold];
    Font.Charset:=238;
    if jazyk=cesky then
     begin
      TextOut(XA1,YR1-2*RADy,'Plochy dle obc s rozenou ps., katastr a druh pozemk');
     end;
    if jazyk=Anglicky1 then
     begin
      TextOut(XA1,YR1-2*RADy,'Lands according to  forest offices, cadastral areas and kinds of lands');
     end;
    // FONT.NAME:='Arial CE';
    if jazyk=cesky then
     begin
       FONT.NAME:=VFont;
       Font.Size:=FSD;
       Font.Style:=[];
       Font.Charset:=238;
        TextOutS(canvasV,XA1,XA2,YR1T,'ORP');

        TextOutS(canvasV,XA2,XA3,YR1T,'Katastr');

        TextOutS(canvasV,XA3,XA4,YR1T,'Porostn');
        TextOutS(canvasV,XA3,XA4,YR1T+Rady,'pda');

        TextOutS(canvasV,XA4,XA5,YR1T,'Bezles');

        TextOutS(canvasV,XA5,XA6,YR1T,'Lesn');
        TextOutS(canvasV,XA5,XA6,YR1T+Rady,'pozemky');

        TextOutS(canvasV,XA6,XA7,YR1T,'Jin');
        TextOutS(canvasV,XA6,XA7,YR1T+Rady,'pozemky');

        TextOutS(canvasV,XA7,XA8,YR1T,'Celkem');
        TextOutS(canvasV,XA7,XA8,YR1T+Rady,'PUPFL');

        TextOutS(canvasV,XA8,XA9,YR1T,'Ostatn');
        TextOutS(canvasV,XA8,XA9,YR1T+Rady,'pozemky');
       end;
    if jazyk=Anglicky1 then
     begin
        FONT.NAME:=VFont;
        Font.Size:=FS;
        Font.Style:=[];
        Font.Charset:=238;
        TextOutS(canvasV,XA1,XA2,YR1T,'Competent state forest authority');

        TextOutS(canvasV,XA2,XA3,YR1T,'Cadastral area');

        TextOutS(canvasV,XA3,XA4,YR1T,'Wooded');
        TextOutS(canvasV,XA3,XA4,YR1T+Rady,'land');

        TextOutS(canvasV,XA4,XA5,YR1T,'Forest-free lands');

        TextOutS(canvasV,XA5,XA6,YR1T,'Forest lands');
        TextOutS(canvasV,XA5,XA6,YR1T+((Rady div 5)*3),'(wooded +');
        TextOutS(canvasV,XA5,XA6,YR1T+((Rady div 5)*6),'forest-free ones)');

        // TextOutS(canvasV,XA5,XA6,YR1T,'Forest lands (wooded');
        // TextOutS(canvasV,XA5,XA6,YR1T+Rady,' + forest-free ones)');

        TextOutS(canvasV,XA6,XA7,YR1T,'Other lands');
        TextOutS(canvasV,XA6,XA7,YR1T+Rady,'(out of PDFF)');

        TextOutS(canvasV,XA7,XA8,YR1T,'Total');
        TextOutS(canvasV,XA7,XA8,YR1T+Rady,'PDFF');

        TextOutS(canvasV,XA8,XA9,YR1T,'Others ');
        TextOutS(canvasV,XA8,XA9,YR1T+Rady,'(except of PDFF)');
        FONT.NAME:=VFont;
        Font.Size:=FSD;
        Font.Style:=[];
        Font.Charset:=238;
       end;
     pen.width:=5;
     PolyLine([Point(XA1,YR1),
               Point(XA9,YR1),
               Point(XA9,YR2),
               Point(XA1,YR2),
               Point(XA1,YR1)]);
     PolyLine([Point(XA1,YR1),
               Point(XA1,YR2)]);
     PolyLine([Point(XA2,YR1),
               Point(XA2,YR2)]);
     PolyLine([Point(XA3,YR1),
               Point(XA3,YR2)]);
     PolyLine([Point(XA4,YR1),
               Point(XA4,YR2)]);
     PolyLine([Point(XA5,YR1),
               Point(XA5,YR2)]);
     PolyLine([Point(XA6,YR1),
               Point(XA6,YR2)]);
     PolyLine([Point(XA7,YR1),
               Point(XA7,YR2)]);
     PolyLine([Point(XA8,YR1),
               Point(XA8,YR2)]);
     PolyLine([Point(XA9,YR1),
               Point(XA9,YR2)]);
   end;

   if richEd<>nil then
    begin
      richEd.refresh;
      Application.ProcessMessages;
     with RichEd.Paragraph do
      begin
       // showmessage('cau '+inttostr(tabcount));
       LeftIndent:=0;
       tabcount:= 9;
       K:=40;
       tab[0]  := 2*K;
       tab[1]  := tab[0] +2*K;
       tab[2]  := tab[1] +2*K;
       tab[3]  := tab[2] +K;
       tab[4]  := tab[3] +K;
       tab[5]  := tab[4] +K;
       tab[6]  := tab[5] +K;
       tab[7]  := tab[6] +K;
       tab[8]  := tab[7] +K;
      end;

     with RichEd.SelAttributes do
      begin
       Size:=4;
       style:=[fsBold];
       name:='Arial';
       Charset:=238;
      end;
     RadRich:=' ORP    '+chr(9)+'Katastr'+chr(9)+'Porostn'+chr(9)+'Bezles'+chr(9)+'Lesn'  +chr(9)+'Jin'   +chr(9)+'Celkem'+chr(9)+'Ostatn';
     richEd.lines.add(RadRich);
     RadRich:=''        +chr(9)+''       +chr(9)+'pda'    +chr(9)+''       +chr(9)+'pozemky'+chr(9)+'pozemky'+chr(9)+'PUPFL' +chr(9)+'pozemky';
     richEd.lines.add(RadRich);
     richEd.lines.add('   ');
    end;


 end;
 procedure tiskniSvisleCarkyZaCelek;
  begin
   with CanvasV do
    begin
     pen.width:=5;
     PolyLine([Point(XA1,YR3),
               Point(XA1,YR3+RADy)]);
    { PolyLine([Point(XA2,YR3),
               Point(XA2,YR3+RADy)]); }
     PolyLine([Point(XA3,YR3),
               Point(XA3,YR3+RADy)]);
     PolyLine([Point(XA4,YR3),
               Point(XA4,YR3+RADy)]);
     PolyLine([Point(XA5,YR3),
               Point(XA5,YR3+RADy)]);
     PolyLine([Point(XA6,YR3),
               Point(XA6,YR3+RADy)]);
     PolyLine([Point(XA7,YR3),
               Point(XA7,YR3+RADy)]);
     PolyLine([Point(XA8,YR3),
               Point(XA8,YR3+RADy)]);
     PolyLine([Point(XA9,YR3),
               Point(XA9,YR3+RADy)]);
    end;
  end;
 procedure tiskniSvisleCarky;
  begin
   tiskniSvisleCarkyZaCelek;
   with CanvasV do
    begin
     pen.width:=5;
     PolyLine([Point(XA2,YR3),
               Point(XA2,YR3+RADy)]);
    end;
  end;

 procedure tiskniRadekKatastru;
  begin
   with canvasV do
    begin
     pen.width:=1; Pen.Style := psDot;
     PolyLine([Point(XA1,YR3+RADy),
               Point(XA9,YR3+RADy)]);
     pen.width:=1; Pen.Style := psSolid;
    end;
   YR3T:=YR3+my(0.1);
   tiskniSvisleCarky;
   With PSumarLHC.katastr do
    begin
     TextOutS (CanvasV,XA1,XA2,YR3T,NazevOkresu);
     TextOutS (CanvasV,XA2,XA3,YR3T,NazevKatastru);
     TextOutPK(CanvasV,XA4,YR3T,floatTOStrf(PorostniPuda,ffFixed,8,2));
     TextOutPK(CanvasV,XA5,YR3T,floatTOStrf(Bezlesi,ffFixed,6,2));
     TextOutPK(CanvasV,XA6,YR3T,floatTOStrf(Bezlesi+PorostniPuda,ffFixed,8,2));
     TextOutPK(CanvasV,XA7,YR3T,floatTOStrf(JinePozemky,ffFixed,6,2));
     TextOutPK(CanvasV,XA8,YR3T,floatTOStrf(Bezlesi+PorostniPuda+JinePozemky,ffFixed,8,2));
     TextOutPK(CanvasV,XA9,YR3T,floatTOStrf(OstatniPozemky,ffFixed,6,2));
     if TBXls<>nil then
      begin
        tbxls.append;
        tbxls.fieldByName('Les_URAD').asstring:=NazevOkresu;
        tbxls.fieldByName('KATASTR').asstring:=NazevKatastru;
        tbxls.fieldByName('POR_PUD').asfloat:=PorostniPuda;
        tbxls.fieldByName('Bezlesi').asfloat:=Bezlesi;
        tbxls.fieldByName('les_Poz').asfloat:=Bezlesi+PorostniPuda;
        tbxls.fieldByName('Jin_Poz').asfloat:=JinePozemky;
        tbxls.fieldByName('PUPFL').asfloat:=Bezlesi+PorostniPuda+JinePozemky;
        tbxls.fieldByName('Ostat').asfloat:=OstatniPozemky;
        tbxls.post;
      end;
     if richEd<>nil then
      begin
       richEd.refresh;
       Application.ProcessMessages;
       with RichEd.SelAttributes do
        begin
         Size:=4;
         style:=[];
         name:='Arial';
         Charset:=238;
        end;
       RadRich:=NazevOkresu+chr(9)+NazevKatastru+chr(9)+floatTOStrf(PorostniPuda,ffFixed,8,2)
               +chr(9)+floatTOStrf(Bezlesi,ffFixed,6,2)+chr(9)+floatTOStrf(Bezlesi+PorostniPuda,ffFixed,8,2)
               +chr(9)+floatTOStrf(JinePozemky,ffFixed,6,2)+chr(9)+floatTOStrf(Bezlesi+PorostniPuda+JinePozemky,ffFixed,8,2)+chr(9)+floatTOStrf(OstatniPozemky,ffFixed,6,2);
       richEd.lines.add(RadRich);
      end;
    end;
   YR3:=YR3+RADy;
  end;
procedure VybarvyRadek;
 begin
  With canvasV do
   begin
    Brush.Color:=VColor; // clYellow;
    fillRect(rect(XA1,YR3+my(0.03),XA9,YR3+RADy));
    Brush.color:=ClWhite;
   end;
 end;
 procedure tiskniSoucetZaOkres(PozOkres:integer);
  begin
   VybarvyRadek;
   with CanvasV do
    begin
     pen.width:=5;
     PolyLine([Point(XA1,YR3),
               Point(XA9,YR3)]);
   YR3T:=YR3+my(0.1);
   tiskniSvisleCarkyZaCelek;
   PSumarLHC.AktualniOkres:=PozOkres;
   With PSumarLHC.katastrZaOkres do
    begin
    if jazyk=cesky then
     begin
      if pozOkres=-1 then TextOutS (CanvasV,XA1,XA3,YR3T,'Celkem:')
      else TextOutS (CanvasV,XA1,XA3,YR3T,' Celkem  za  ORP:');
     end;
    if jazyk=Anglicky1 then
     begin
      if pozOkres=-1 then TextOutS (CanvasV,XA1,XA3,YR3T,'Totally:')
      else TextOutS (CanvasV,XA1,XA3,YR3T,'Totally in one state forest authority:');
     end;
     TextOutPK(CanvasV,XA4,YR3T,floatTOStrf(PorostniPuda,ffFixed,8,2));
     TextOutPK(CanvasV,XA5,YR3T,floatTOStrf(Bezlesi,ffFixed,6,2));
     TextOutPK(CanvasV,XA6,YR3T,floatTOStrf(Bezlesi+PorostniPuda,ffFixed,8,2));
     TextOutPK(CanvasV,XA7,YR3T,floatTOStrf(JinePozemky,ffFixed,6,2));
     TextOutPK(CanvasV,XA8,YR3T,floatTOStrf(Bezlesi+PorostniPuda+JinePozemky,ffFixed,8,2));
     TextOutPK(CanvasV,XA9,YR3T,floatTOStrf(OstatniPozemky,ffFixed,6,2));
     if TBXls<>nil then
      begin
        tbxls.append;
        if pozOkres=-1 then
         begin
          tbxls.fieldByName('Les_URAD').asstring:='Celkem :';
         end
        else
         begin
          tbxls.fieldByName('Les_URAD').asstring:='Celkem ';
          tbxls.fieldByName('KATASTR').asstring:='za les.rad';
         end;
        tbxls.fieldByName('POR_PUD').asfloat:=PorostniPuda;
        tbxls.fieldByName('Bezlesi').asfloat:=Bezlesi;
        tbxls.fieldByName('les_Poz').asfloat:=Bezlesi+PorostniPuda;
        tbxls.fieldByName('Jin_Poz').asfloat:=JinePozemky;
        tbxls.fieldByName('PUPFL').asfloat:=Bezlesi+PorostniPuda+JinePozemky;
        tbxls.fieldByName('Ostat').asfloat:=OstatniPozemky;
        tbxls.post;
      end;
    end;

     YR3:=YR3+RADy;
     PolyLine([Point(XA1,YR3),
               Point(XA9,YR3)]);
    end;
  end;
 procedure SetridRadky;
 var i,maxI:integer;
     nasel:Boolean;
     MaxKat:Int64;
  PSumarLHC1:TsumarLHC;
  begin
   PSumarLHC1:=TSumarLHC.create;
   With PSumarLHC do
    begin
     repeat
      maxKat:=999999999999999;
      nasel:=false;
      for i:=0 to count-1 do
       begin
        if Elements[i] is TKatastr then
         begin
          if TKatastr(Elements[i]).OznKatastr+TKatastr(Elements[i]).okres*1000000000<maxkat then
           begin
             maxKat:=TKatastr(Elements[i]).OznKatastr+TKatastr(Elements[i]).okres*1000000000;
             maxI:=i;
             nasel:=True;
           end;
         end;
       end;
     if nasel then
      begin
       PSumarLHC1.addElement(Elements[maxI]);
       RemoveElement(Elements[maxI]);
      end;
     until not nasel;
     for i:=0 to PSumarLHC1.count-1 do
      begin
       if PSumarLHC1.Elements[i] is TKatastr then
        begin
         addElement(PSumarLHC1.Elements[I]);
        end;
      end;
     PSumarLHC1.free;
    end;
  end;
 procedure TiskniRadky;
  var i:integer;
    puvOkres:integer;
  begin
   With PSumarLHC do
    begin
     puvOkres:=-1;
     for i:=0 to count-1 do
      begin
       if Elements[i] is TKatastr then
        begin
         AktualniKatastr:=TKatastr(Elements[i]).OznKatastr;
         if (puvOkres<>katastr.okres)and(puvOkres<>-1)then
            tiskniSoucetZaOkres(puvOkres);
         puvOkres:=katastr.okres;
         if MerYMax<YR3+3*RadY then
          begin
           with CanvasV do
            begin
             pen.width:=5;
             PolyLine([Point(XA1,YR3),
                     Point(XA9,YR3)]);
            end;
           holeOdstrankovani1;
           tiskniHlavicku;
          end;
         tiskniRadekKatastru;
        end;
      end;
    end;
   tiskniSoucetZaOkres(puvOkres);
   tiskniSoucetZaOkres(-1);
  end;
  begin
   YRR:=0;
   if NaTiskarnu1 then
    MerYMax:=round(mery*0.95)
     else merYMax:=round(screen.height);
   if OddMN=nil then
    begin
     SpoctiSumarLHC_DB98(PSumarLHC,query1);
    end
   else
    begin
     SpoctiSumarOddeleniMN98(PSumarLHC,OddMN);
    end;
   tiskniHlavicku;
   setridRadky;
   tiskniRadky;
   holeodstrankovani1;  {za katastry}
  end;
procedure TiskPot_Vlast(oddMn:TOddeleniMN;CanvasV:TCanvas;merX,MerY:longint;NaTiskarnu1:Boolean;VColor:TColor;VFont:string;Query1:TQuery);
 var PSumarLHC:TSumarLHC;
     FS,FSD,FSDK,FSDM:longint;
     radx,XAR,Xa1,Xa2,Xa3,Xa4,Xa5,Xa6,Xa7,Xa9:longint;
     YRR,YP,merYMax,RH,RADy,YR1,YR2,YR3,YR4,YR1T,YR3T:longint;
function mx(x:real):longint;
 begin
  mx:=mx1(x,MerX);
 end;
function my(y:real):longint;
 begin
  my:=my1(y,mery);
 end;
function YPT:longint;
 begin
  result:=YP+my(0.1);
 end;
procedure HoleOdstrankovani;
begin
if NaTiskarnu1 then
 begin
  with printer do
   begin
    newpage;
    MerYMax:=round(mery*0.95)
   end;
 end
else
 begin
   YRR:=YRR+round(screen.height*1.1);
   merYMax:=YRR+round(screen.height);
 end;
end;
procedure nastavBody;
 begin
   FS:=7;
   FSD:=9;
   FSDK:=12;
   FSDM:=3;
   radx:=   mx(0.40);
   XAR:=    mx(0.98);
   Xa1:=    mx(2.00);
   Xa2:=Xa1+mx(4.00);
   Xa3:=Xa2+mx(4.00);
   Xa4:=Xa3+mx(2.60);
   Xa5:=Xa4+mx(2.60);
   Xa6:=Xa5+mx(2.60);
   Xa7:=Xa6+mx(2.60);
   Xa9:=Xa7+mx(2.60);
   YR1:=my(1.8)+YRR;
   RH :=my(1.00);
   RADy:=my(0.5);
   YR2:=YR1+RH;
   YR1T:=YR1+my(0.1);
   YR3:=YR2;
   YP:=YR2;
 end;
procedure tiskniHlavicku;
 begin
  nastavBody;
  with canvasV do
   begin
    // FONT.NAME:='Arial CE';
    FONT.NAME:=VFont;
    Font.Size:=FSDK;
    Font.Style:=[fsBold];
    Font.Charset:=238;
    TextOut(XA1,YR1-2*RADy,'  Plochy dle povench obc, katastr a kategori parcel');
    // FONT.NAME:='Arial CE';
    FONT.NAME:=VFont;
    Font.Size:=FSD;
    Font.Style:=[];
    Font.Charset:=238;
        TextOutS(canvasV,XA1,XA2,YR1T,' ORP ');

        TextOutS(canvasV,XA2,XA3,YR1T,'Katastr');

        TextOutS(canvasV,XA3,XA4,YR1T,     'Nepochybn');
        TextOutS(canvasV,XA3,XA4,YR1T+Rady,'vlastnk');

        TextOutS(canvasV,XA4,XA5,YR1T,     'Potenciln');
        TextOutS(canvasV,XA4,XA5,YR1T+Rady,'majetek crkve');

        TextOutS(canvasV,XA5,XA6,YR1T,'Ideln');
        TextOutS(canvasV,XA5,XA6,YR1T+Rady,'spoluvlastnictv');

        TextOutS(canvasV,XA6,XA7,YR1T,     'Nedokonen');
        TextOutS(canvasV,XA6,XA7,YR1T+Rady,'restitun zen');

        TextOutS(canvasV,XA7,XA9,YR1T,'Celkem');
        TextOutS(canvasV,XA7,XA9,YR1T+Rady,'PUPFL');

     pen.width:=5;
     PolyLine([Point(XA1,YR1),
               Point(XA9,YR1),
               Point(XA9,YR2),
               Point(XA1,YR2),
               Point(XA1,YR1)]);
     PolyLine([Point(XA1,YR1),
               Point(XA1,YR2)]);
     PolyLine([Point(XA2,YR1),
               Point(XA2,YR2)]);
     PolyLine([Point(XA3,YR1),
               Point(XA3,YR2)]);
     PolyLine([Point(XA4,YR1),
               Point(XA4,YR2)]);
     PolyLine([Point(XA5,YR1),
               Point(XA5,YR2)]);
     PolyLine([Point(XA6,YR1),
               Point(XA6,YR2)]);
     PolyLine([Point(XA7,YR1),
               Point(XA7,YR2)]);
     PolyLine([Point(XA9,YR1),
               Point(XA9,YR2)]);
   end;
 end;

 procedure tiskniSvisleCarkyZaCelek;
  begin
   with CanvasV do
    begin
     pen.width:=5;
     PolyLine([Point(XA1,YR3),
               Point(XA1,YR3+RADy)]);
     { PolyLine([Point(XA2,YR3),
                 Point(XA2,YR3+RADy)]); }
     PolyLine([Point(XA3,YR3),
               Point(XA3,YR3+RADy)]);
     PolyLine([Point(XA4,YR3),
               Point(XA4,YR3+RADy)]);
     PolyLine([Point(XA5,YR3),
               Point(XA5,YR3+RADy)]);
     PolyLine([Point(XA6,YR3),
               Point(XA6,YR3+RADy)]);
     PolyLine([Point(XA7,YR3),
               Point(XA7,YR3+RADy)]);
     PolyLine([Point(XA9,YR3),
               Point(XA9,YR3+RADy)]);
    end;
  end;

 procedure tiskniSvisleCarky;
  begin
   tiskniSvisleCarkyZaCelek;
   with CanvasV do
    begin
     pen.width:=5;
     PolyLine([Point(XA2,YR3),
               Point(XA2,YR3+RADy)]);
    end;
  end;

 procedure tiskniRadekKatastru;
 var pl:double;
  begin
   with canvasV do
    begin
     pen.width:=1; Pen.Style := psDot;
     PolyLine([Point(XA1,YR3+RADy),
               Point(XA9,YR3+RADy)]);
     pen.width:=1; Pen.Style := psSolid;
    end;
   YR3T:=YR3+my(0.1);
   tiskniSvisleCarky;
   With PSumarLHC.katastr do
    begin
     TextOutS (CanvasV,XA1,XA2,YR3T,NazevOkresu);
     TextOutS (CanvasV,XA2,XA3,YR3T,NazevKatastru);
     pl:=0;
     AktualniPot_Vlast:=11;
     TextOutPK(CanvasV,XA4,YR3T,floatTOStrf(PlochaPot_Vlast,ffFixed,6,2));
     pl:=Pl+PlochaPot_Vlast;

     AktualniPot_Vlast:=12;
     TextOutPK(CanvasV,XA5,YR3T,floatTOStrf(PlochaPot_Vlast,ffFixed,6,2));
     pl:=Pl+PlochaPot_Vlast;

     AktualniPot_Vlast:=13;
     TextOutPK(CanvasV,XA6,YR3T,floatTOStrf(PlochaPot_Vlast,ffFixed,6,2));
     pl:=Pl+PlochaPot_Vlast;

     AktualniPot_Vlast:=14;
     TextOutPK(CanvasV,XA7,YR3T,floatTOStrf(PlochaPot_Vlast,ffFixed,6,2));
     pl:=Pl+PlochaPot_Vlast;

     TextOutPK(CanvasV,XA9,YR3T,floatTOStrf(Pl,ffFixed,6,2));

    end;
   YR3:=YR3+RADy;
  end;
procedure VybarvyRadek;
 begin
  With canvasV do
   begin
    Brush.Color:=VColor; // clYellow;
    fillRect(rect(XA1,YR3+my(0.03),XA9,YR3+RADy));
    Brush.color:=ClWhite;
   end;
 end;
 procedure tiskniSoucetZaOkres(PozOkres:integer);
 var pl:double;
  begin
   VybarvyRadek;
   with CanvasV do
    begin
     pen.width:=5;
     PolyLine([Point(XA1,YR3),
               Point(XA9,YR3)]);
   YR3T:=YR3+my(0.1);
   tiskniSvisleCarkyZaCelek;
   PSumarLHC.AktualniOkres:=PozOkres;
   With PSumarLHC.katastrZaOkres do
    begin
     if pozOkres=-1 then TextOutS (CanvasV,XA1,XA3,YR3T,'Celkem :')
     else TextOutS (CanvasV,XA1,XA3,YR3T,'Celkem za o.r.p. :');
     pl:=0;
     AktualniPot_Vlast:=11;
     TextOutPK(CanvasV,XA4,YR3T,floatTOStrf(PlochaPot_Vlast,ffFixed,8,2));//cau 6,2));
     pl:=Pl+PlochaPot_Vlast;

     AktualniPot_Vlast:=12;
     TextOutPK(CanvasV,XA5,YR3T,floatTOStrf(PlochaPot_Vlast,ffFixed,8,2));//cau 6,2));
     pl:=Pl+PlochaPot_Vlast;

     AktualniPot_Vlast:=13;
     TextOutPK(CanvasV,XA6,YR3T,floatTOStrf(PlochaPot_Vlast,ffFixed,8,2));//cau 6,2));
     pl:=Pl+PlochaPot_Vlast;

     AktualniPot_Vlast:=14;
     TextOutPK(CanvasV,XA7,YR3T,floatTOStrf(PlochaPot_Vlast,ffFixed,8,2));//cau 6,2));
     pl:=Pl+PlochaPot_Vlast;

     TextOutPK(CanvasV,XA9,YR3T,floatTOStrf(Pl,ffFixed,8,2));//cau 6,2));

    end;
     YR3:=YR3+RADy;
     PolyLine([Point(XA1,YR3),
               Point(XA9,YR3)]);
    end;
  end;
{
 procedure SetridRadky;
 var i,maxI:integer;
     nasel:Boolean;
     MaxKat:LongInt;
  PSumarLHC1:TsumarLHC;
  begin
   PSumarLHC1:=TSumarLHC.create;
   With PSumarLHC do
    begin
     repeat
      maxKat:=999999999;
      nasel:=false;
      for i:=0 to count-1 do
       begin
        if Elements[i] is TKatastr then
         begin
          if TKatastr(Elements[i]).OznKatastr<maxkat then
           begin
             maxKat:=TKatastr(Elements[i]).OznKatastr;
             maxI:=i;
             nasel:=True;
           end;
         end;
       end;
     if nasel then
      begin
       PSumarLHC1.addElement(Elements[maxI]);
       RemoveElement(Elements[maxI]);
      end;
     until not nasel;
     for i:=0 to PSumarLHC1.count-1 do
      begin
       if PSumarLHC1.Elements[i] is TKatastr then
        begin
         addElement(PSumarLHC1.Elements[I]);
        end;
      end;
     PSumarLHC1.free;
    end;
  end;
}

procedure SetridRadky;
 var i,maxI:integer;
     nasel:Boolean;
     MaxKat:Int64;
  PSumarLHC1:TsumarLHC;
  begin
   PSumarLHC1:=TSumarLHC.create;
   With PSumarLHC do
    begin
     repeat
      maxKat:=999999999999999;
      nasel:=false;
      for i:=0 to count-1 do
       begin
        if Elements[i] is TKatastr then
         begin
          if TKatastr(Elements[i]).OznKatastr+TKatastr(Elements[i]).okres*1000000000<maxkat then
           begin
             maxKat:=TKatastr(Elements[i]).OznKatastr+TKatastr(Elements[i]).okres*1000000000;
             maxI:=i;
             nasel:=True;
           end;
         end;
       end;
     if nasel then
      begin
       PSumarLHC1.addElement(Elements[maxI]);
       RemoveElement(Elements[maxI]);
      end;
     until not nasel;
     for i:=0 to PSumarLHC1.count-1 do
      begin
       if PSumarLHC1.Elements[i] is TKatastr then
        begin
         addElement(PSumarLHC1.Elements[I]);
        end;
      end;
     PSumarLHC1.free;
    end;
  end;











 procedure TiskniRadky;
  var i:integer;
    puvOkres:integer;
  begin
   With PSumarLHC do
    begin
     puvOkres:=-1;
     for i:=0 to count-1 do
      begin
       if Elements[i] is TKatastr then
        begin
         AktualniKatastr:=TKatastr(Elements[i]).OznKatastr;
         if (puvOkres<>katastr.okres)and(puvOkres<>-1)then
            tiskniSoucetZaOkres(puvOkres);
         puvOkres:=katastr.okres;
         if MerYMax<YR3+3*RadY then
          begin
           with CanvasV do
            begin
             pen.width:=5;
             PolyLine([Point(XA1,YR3),
                      Point(XA9,YR3)]);
            end;
           holeOdstrankovani;
           tiskniHlavicku;
          end;
         tiskniRadekKatastru;
        end;
      end;
    end;
   tiskniSoucetZaOkres(puvOkres);
   tiskniSoucetZaOkres(-1);
  end;
  begin
   YRR:=0;
   if NaTiskarnu1 then MerYMax:=round(mery*0.95)
     else merYMax:=round(screen.height);
   if OddMN=nil then SpoctiSumarLHC_DB98(PSumarLHC,Query1)
   else SpoctiSumarOddeleniMN98(PSumarLHC,OddMN);
   tiskniHlavicku;
   setridRadky;
   tiskniRadky;
   holeodstrankovani; {za pot Vlast}
  end;
end.
