procedure TForm1.ZkontrolujIndex(pomTable: TTable; IdxName, IdxFields: String;
           Options:TIndexOptions);
var
   i, j, idxNum: integer;
   idxExists : Boolean;
   oldLabel , pp: String;
begin

{
    TIndexOptions = set of (ixPrimary, ixUnique, ixDescending, ixExpression,
     ixCaseInsensitive, ixNonMaintained);
}
    IdxFields := UpperCase(IdxFields);
    IdxName := UpperCase(IdxName);
    oldLabel :=  Panel2.caption;

   { kontrola existence indexu }
   idxExists := false;

   {Nati existujc indexy}
   pomTable.IndexDefs.update;

   {Porovnej indexy}
   for i := 0 to pomTable.IndexDefs.Count - 1 do
   begin
      if pomTable.IndexDefs.Items[i].Name = IdxName then
      begin
        idxExists := True;
        IdxNum := i;
        break;
     end;
   end;

   { eventuln reindexace, pop. vytvoenn novho indexu }
   if idxExists then
   begin
{
      try
         caption := ' Obnovuji index: ' + idxName;
         fDbiRegenIndex(PomTable, idxName, IdxFields, IdxNum);

      except
         on E: EDBEngineError do
         begin
            MessageDlg('Nemohu obnovit index ' + idxName + ' pro tabulku ' +
            pomTable.TableName + #13#10#13#10 + 'Chybov hlen: ' + #13#10 +
            E.Message, mtError, [mbOK], 0);
            Application.terminate;
         end;
      end;
 }
   end
   else
   begin
      try
         NastavPanel('Vytvm index: ' + idxName + ' pro tabulku ' +
         pomTable.TableName + ' ...');
         pomTable.AddIndex(idxName, idxFields, Options);
      except
         on E: EDatabaseError do
         begin
            screen.cursor := crDefault;
            MessageDlg('Nemohu vytvoit index ' + idxName + ' pro tabulku ' +
            pomTable.TableName + #13#10#13#10 + 'Chybov hlen: ' + #13#10 +
            E.Message, mtError, [mbOK], 0);
            Application.terminate;
         end;
      end;
   end;
   NastavPanel(oldLabel);

end;
