unit Sptop_bz;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DBTables, DB, Grids, DBGrids, StdCtrls,
  sp_zapis,spx_bzos;

type
  TS_top_bz1 = class(TForm)
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    DataSource3: TDataSource;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    DBGrid3: TDBGrid;
    Query1: TQuery;
    Query1SKUPINA: TStringField;
    Query1BEZLESI: TStringField;
    Query1PLOCHA: TFloatField;
    Query1VYMERA: TFloatField;
    Query1VLASTNIK: TFloatField;
    Query1SK_PARC: TStringField;
    Button3: TButton;
    Button2: TButton;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Query1KATASTR: TStringField;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    bzl_exist:boolean;
    procedure nactiPlochyOstJine;
    procedure nactiPlochuJine;
    procedure nactiPlochuOstatni;
    procedure setrid;
  end;

var
  S_top_bz1: TS_top_bz1;

implementation
uses spx_hf;
{$R *.DFM}

procedure TS_top_bz1.FormShow(Sender: TObject);
begin
 DataSource1.dataset:=s_bzl_os1.tb_ost;
 DataSource2.dataset:=s_bzl_os1.tb_jine;
 s_bzl_os1.tb_ost.open;
 s_bzl_os1.tb_jine.open;
 query1.open;
end;

procedure TS_top_bz1.FormHide(Sender: TObject);
begin
 {s_bzl_os1.tb_ost.close;
  s_bzl_os1.tb_jine.close; }
 query1.close;
end;

procedure TS_top_bz1.Button3Click(Sender: TObject);
begin
 query1.close;
 query1.SQL.strings[3]:='';
 query1.open;
end;

procedure TS_top_bz1.Button2Click(Sender: TObject);
begin
 setrid;
end;
procedure TS_top_bz1.setrid;
begin
 query1.close;
 query1.SQL.strings[3]:='order by SKUPINA';
 query1.open;
end;
procedure TS_top_bz1.nactiPlochuOstatni;
var sk_ozn:String[13];
    pl,vym:real;
begin
  sk_Ozn:=Query1Skupina.asstring;
  pl  :=Query1PLOCHA.asfloat;
  vym :=Query1VYMERA.asfloat;
  Query1.next;
  while (sk_Ozn=Query1Skupina.asstring)and(not Query1.eof) do
   begin
    pl  :=pl+Query1PLOCHA.asfloat;
    vym :=vym+Query1VYMERA.asfloat;
    Query1.next;
   end;
  if not(s_bzl_os1.tb_ost.state in [dsinsert,dsedit]) then
   begin
    s_bzl_os1.tb_ost.edit;
   end;
  s_bzl_os1.tb_ostOST_P0.asfloat :=pl;
  s_bzl_os1.tb_ostOST_V.asfloat :=vym;
  s_bzl_os1.tb_ostKU_KOD.asstring       :=Query1.fieldbyname('KATASTR').asstring;
  try
   strtoint(Query1.fieldbyname('KATASTR').asstring);
   s_bzl_os1.tb_ostKU_KOD.asstring   := Query1.fieldbyname('KATASTR').asstring;
  except
   on eConvertError do showmessage('Katastr "'+Query1.fieldbyname('KATASTR').asstring+'" nen cel slo.');
  end;
  s_bzl_os1.tb_ostSKUPPARC.asstring     :=Query1SK_PARC.asstring;
  if Query1.findfield('KV_PL') <>nil then
     s_bzl_os1.tb_ostKVAL_P.asstring    := Query1.findfield('KV_PL').asstring;
  { spx.tb_ostKVAL_P.asstring     :=Query1KV_PL.asstring; }
  if Query1.findfield('DR_MAJ') <>nil then
    s_bzl_os1.tb_ostMAJ_DRUH.asstring  :=Query1.findfield('DR_MAJ').asstring;
  { spx.tb_ostMAJ_DRUH.asstring     :=Query1DR_MAJ.asstring; }
  s_bzl_os1.tb_ostMAJ_KOD.asstring      :=Query1VLASTNIK.asstring;
  s_bzl_os1.tb_ostOST_P.asstring:=s_bzl_os1.tb_ostOST_P0.asstring;
end;
procedure TS_top_bz1.nactiPlochuJine;
var sk_ozn:String[13];
    pl,vym:real;
begin
  sk_Ozn:=Query1Skupina.asstring;
  pl  :=Query1PLOCHA.asfloat;
  vym :=Query1VYMERA.asfloat;
  Query1.next;
  while (sk_Ozn=Query1Skupina.asstring)and(not Query1.eof) do
   begin
    pl  :=pl+Query1PLOCHA.asfloat;
    vym :=vym+Query1VYMERA.asfloat;
    Query1.next;
   end;
  if not(s_bzl_os1.tb_jine.state in [dsinsert,dsedit]) then
   begin
    s_bzl_os1.tb_jine.edit;
   end;
  s_bzl_os1.tb_jineJP_P0.asfloat :=pl;
  s_bzl_os1.tb_jineJP_V.asfloat :=vym;
  s_bzl_os1.tb_jineKU_KOD.asstring       :=Query1.fieldbyname('KATASTR').asstring;
  try
   strtoint(Query1.fieldbyname('KATASTR').asstring);
   s_bzl_os1.tb_jineKU_KOD.asstring   := Query1.fieldbyname('KATASTR').asstring;
  except
   on eConvertError do showmessage('Katastr "'+Query1.fieldbyname('KATASTR').asstring+'" nen cel slo.');
  end;
  s_bzl_os1.tb_jineSKUPPARC.asstring     :=Query1SK_PARC.asstring;
  if Query1.findfield('KV_PL') <>nil then
     s_bzl_os1.tb_jineKVAL_P.asstring    :=Query1.findfield('KV_PL').asstring;
  if Query1.findfield('DR_MAJ') <>nil then
     s_bzl_os1.tb_jineMAJ_DRUH.asstring  :=Query1.findfield('DR_MAJ').asstring;
 {  spx.tb_jineMAJ_DRUH.asstring  :=Query1DR_MAJ.asstring; }
  s_bzl_os1.tb_jineMAJ_KOD.asstring :=Query1VLASTNIK.asstring;
  s_bzl_os1.tb_jineJP_P.asstring:=s_bzl_os1.tb_jineJP_P0.asstring;
end;

procedure TS_top_bz1.Button1Click(Sender: TObject);
begin
 nactiPlochyOstJine;
 close;
end;
procedure TS_top_bz1.nactiPlochyOstJine;
var s:string;
begin
 setrid;
 s_bzl_os1.tb_ost.first;
 s_bzl_os1.tb_jine.first;
 query1.first;
  while not (s_bzl_os1.tb_ost.eof and query1.eof and s_bzl_os1.tb_jine.eof) do
   begin
    s:='';
    if s_bzl_os1.tb_ost.eof then  s:=s+' ost.e ';
    if s_bzl_os1.tb_jine.eof then  s:=s+' jine.e ';
    if query1.eof then  s:=s+' query.e ';
    showmessage('ost*'+s_bzl_os1.tb_ostOST.asstring+'*tp*'+Query1Skupina.asstring+' *jine*'+s_bzl_os1.tb_jineJP.asstring+S);
    if (s_bzl_os1.tb_jineJP.asstring= Query1Skupina.asstring)
        and (not query1.eof) and (not s_bzl_os1.tb_jine.eof) then
     begin
      { nactiPlochuSkupiny; }
      nactiPlochuJine;
      { query1.next; }
      s_bzl_os1.tb_jine.next;
     end
    else
     begin
      if ((Query1Skupina.asstring<s_bzl_os1.tb_jineJP.asstring)
           and (not query1.eof)) or ( s_bzl_os1.tb_jine.eof ) then
       begin
        if (Query1Skupina.asstring=s_bzl_os1.tb_ostOST.asstring)
            and ( not query1.eof) and ( not s_bzl_os1.tb_ost.eof) then
         begin
          {nactiPlochuBezlesi;}
          nactiPlochuOstatni;
          { query1.next; }
          s_bzl_os1.tb_ost.next;
         end
        else
         begin
          if ((Query1Skupina.asstring>s_bzl_os1.tb_ostOST.asstring)
              or (query1.eof)) and ( not s_bzl_os1.tb_ost.eof) then
           begin
            showmessage('Ostatn plocha '+s_bzl_os1.tb_ostOst.asstring
            +' je v zpisnku, ale nen zplochovna.');
            s_bzl_os1.tb_ost.next;
           end
          else
           begin
           { showmessage('Plocha '+ Query1Skupina.asstring
                 +' je zplochovna, ale nen v zpisnku'); }
            s_zapis1.label1.caption:= 'Plocha '+ Query1Skupina.asstring
                 +' je zplochovna, ale nen v zpisnku.';
            s_zapis1.showmodal;
            if s_zapis1.zapsat_jine then
             begin
              s_bzl_os1.tb_jine.insert;
              s_bzl_os1.tb_jineJP.asstring:=Query1Skupina.asstring;
              nactiPlochuJine;
              s_bzl_os1.tb_jine.next;
             end;
            if s_zapis1.zapsat_ostatni then
             begin
              s_bzl_os1.tb_ost.insert;
              s_bzl_os1.tb_ostOST.asstring:=Query1Skupina.asstring;
              nactiPlochuOstatni;
              s_bzl_os1.tb_ost.next;
             end;
            if (not s_zapis1.zapsat_jine)and(not s_zapis1.zapsat_ostatni) then
             begin
              query1.next;
             end;
           end;
         end;
       end
      else
       begin
        showmessage('Jina plocha '+s_bzl_os1.tb_jineJP.asstring
              +' je v zpisnku, ale nen zplochovna.');
        s_bzl_os1.tb_jine.next;
       end
     end;
   end;
end;
procedure TS_top_bz1.FormCreate(Sender: TObject);
begin
if S_bzl_Os1=nil then
 begin
 Application.CreateForm(TS_bzl_Os2, S_Bzl_Os1);
 bzl_exist:=false;
 end
 else bzl_exist:=true;
Application.CreateForm(Ts_zapis1, S_zapis1);
end;

procedure TS_top_bz1.FormDestroy(Sender: TObject);
begin
 if bzl_exist then
  begin
   S_Bzl_Os1.destroy;
   s_Bzl_os1:=nil;
  end;
 S_zapis1.destroy;
end;

end.
