unit Spx_bzos;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, StdCtrls, Mask,
  DBCtrls,DBIPROCS,
  sp_ovr;

type
  TS_BZL_OS2 = class(TForm)
    Tb_BZL: TTable;
    DS_BZL: TDataSource;
    DB_bzl: TDBGrid;
    Tb_BZLVAZBA: TFloatField;
    Tb_BZLID: TFloatField;
    Tb_BZLBZL: TFloatField;
    Tb_BZLMAJ_KOD: TFloatField;
    Tb_BZLMAJ_DRUH: TSmallintField;
    Tb_BZLKU_KOD: TFloatField;
    Tb_BZLLES_URAD: TFloatField;
    Tb_BZLBZL_P0: TFloatField;
    Tb_BZLBZL_P: TFloatField;
    Tb_BZLBZL_V: TFloatField;
    Tb_BZLKVAL_P: TFloatField;
    Tb_BZLBZL_VYUZ: TStringField;
    LabOdd: TLabel;
    LabDil: TLabel;
    LabPor: TLabel;
    DB_Ost: TDBGrid;
    DB_Jine: TDBGrid;
    Tb_jine: TTable;
    Tb_ost: TTable;
    DS_ost: TDataSource;
    DS_Jine: TDataSource;
    Tb_ostVAZBA: TFloatField;
    Tb_ostOST: TFloatField;
    Tb_ostID: TFloatField;
    Tb_ostMAJ_KOD: TFloatField;
    Tb_ostMAJ_DRUH: TSmallintField;
    Tb_ostKU_KOD: TFloatField;
    Tb_ostLES_URAD: TFloatField;
    Tb_ostOST_P0: TFloatField;
    Tb_ostOST_P: TFloatField;
    Tb_ostOST_V: TFloatField;
    Tb_ostKVAL_P: TFloatField;
    Tb_ostDRUH_POZ: TFloatField;
    Tb_ostOST_VYUZ: TStringField;
    Tb_jineVAZBA: TFloatField;
    Tb_jineJP: TFloatField;
    Tb_jineID: TFloatField;
    Tb_jineJP_PUPFL: TStringField;
    Tb_jineMAJ_KOD: TFloatField;
    Tb_jineMAJ_DRUH: TSmallintField;
    Tb_jineKU_KOD: TFloatField;
    Tb_jineLES_URAD: TFloatField;
    Tb_jineJP_P0: TFloatField;
    Tb_jineJP_P: TFloatField;
    Tb_jineJP_V: TFloatField;
    Tb_jineKVAL_P: TFloatField;
    Tb_jineDRUH_POZ: TFloatField;
    Tb_jineJP_VYUZ: TStringField;
    Tb_BZLPOT_VLAST: TFloatField;
    Tb_BZLSKUPPARC: TStringField;
    Tb_ostPOT_VLAST: TFloatField;
    Tb_ostSKUPPARC: TStringField;
    Tb_jinePOT_VLAST: TFloatField;
    Tb_jineSKUPPARC: TStringField;
    bz_odd: TDBEdit;
    BZ_Dil: TDBEdit;
    BZ_Por: TDBEdit;
    procedure Tb_BZLAfterInsert(DataSet: TDataset);
    procedure Tb_jineAfterInsert(DataSet: TDataset);
    procedure Tb_ostAfterInsert(DataSet: TDataset);
    procedure FormActivate(Sender: TObject);
    procedure DB_bzlExit(Sender: TObject);
    procedure DB_OstColEnter(Sender: TObject);
    procedure DB_JineColEnter(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Tb_BZLBeforeDelete(DataSet: TDataset);
    procedure DB_bzlKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DB_JineKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DB_OstKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Tb_BZLBZLChange(Sender: TField);
    procedure Tb_BZLMAJ_KODChange(Sender: TField);
    procedure Tb_BZLKU_KODChange(Sender: TField);
    procedure Tb_BZLLES_URADChange(Sender: TField);
    procedure Tb_BZLKVAL_PChange(Sender: TField);
    procedure Tb_BZLPOT_VLASTChange(Sender: TField);
    procedure Tb_ostOSTChange(Sender: TField);
    procedure Tb_ostMAJ_KODChange(Sender: TField);
    procedure Tb_ostKU_KODChange(Sender: TField);
    procedure Tb_ostLES_URADChange(Sender: TField);
    procedure Tb_ostOST_PChange(Sender: TField);
    procedure Tb_ostOST_VChange(Sender: TField);
    procedure Tb_ostKVAL_PChange(Sender: TField);
    procedure Tb_ostDRUH_POZChange(Sender: TField);
    procedure Tb_ostPOT_VLASTChange(Sender: TField);
    procedure Tb_jineJPChange(Sender: TField);
    procedure Tb_jineMAJ_KODChange(Sender: TField);
    procedure Tb_jineKU_KODChange(Sender: TField);
    procedure Tb_jineLES_URADChange(Sender: TField);
    procedure Tb_jineJP_PChange(Sender: TField);
    procedure Tb_jineJP_VChange(Sender: TField);
    procedure Tb_jineKVAL_PChange(Sender: TField);
    procedure Tb_jineDRUH_POZChange(Sender: TField);
    procedure Tb_jinePOT_VLASTChange(Sender: TField);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  S_BZL_OS1: TS_BZL_OS2;

implementation
uses SPX_HF;
{$R *.DFM}

procedure TS_BZL_OS2.Tb_BZLAfterInsert(DataSet: TDataset);
var ID:longint;
    SS:string;
begin
 if ovr.tb_Id.active=false then ovr.tb_id.active:=true;
 with ovr.TB_Id do
  begin
   SetRangeStart; { Set the beginning key }
   FieldByName('TABULKA').AsString :='BEZLESI';
   SetRangeEnd;   { Set the ending key }
   FieldByName('TABULKA').AsString :='BEZLESI';
   ApplyRange; { Tell the dataset to establish the range }
  end;
 { ss:='tabulka='+chr(39)+'DREVINA'+chr(39);
   tb_Id.filter:= ss; }
 ID:=ovr.Tb_id.fieldByName('ID').asinteger;
 ID:=ID+1;
 ovr.TB_id.edit;
 ovr.Tb_id.fieldByName('ID').asinteger:=ID;
 ovr.tb_id.post;
 Tb_BZL.Edit;
 if (not(Tb_BZL.state=dsInsert)) then
  begin
   Tb_BZL.edit;
  end;
 Tb_BZL.fieldByName('ID').asinteger:=ID;
 Tb_BZL.fieldByName('VAZBA').asinteger
      :=ovr.Tb_Porost.fieldByName('ID').asinteger;
 Tb_BZL.fieldByName('MAJ_KOD').asinteger
      :=ovr.Tb_Porost.fieldByName('MAJ_KOD').asinteger;
 Tb_BZL.fieldByName('MAJ_DRUH').asinteger
      :=ovr.Tb_Porost.fieldByName('MAJ_DRUH').asinteger;
 Tb_BZL.fieldByName('KU_KOD').asinteger
      :=ovr.Tb_SK.fieldByName('KU_KOD').asinteger;
 Tb_BZL.fieldByName('LES_URAD').asinteger
      :=ovr.Tb_Sk.fieldByName('LES_URAD').asinteger;
 Tb_BZL.fieldByName('POT_VLAST').asinteger
      :=ovr.Tb_Sk.fieldByName('POT_VLAST').asinteger;

end;
procedure TS_BZL_OS2.Tb_jineAfterInsert(DataSet: TDataset);
var ID:longint;
    SS:string;
begin
if ovr.tb_Id.active=false then ovr.tb_id.active:=true;
 with ovr.TB_Id do
  begin
   SetRangeStart; { Set the beginning key }
   FieldByName('TABULKA').AsString :='JINE_POZ';
   SetRangeEnd;   { Set the ending key }
   FieldByName('TABULKA').AsString :='JINE_POZ';
   ApplyRange; { Tell the dataset to establish the range }
  end;
 { ss:='tabulka='+chr(39)+'DREVINA'+chr(39);
   tb_Id.filter:= ss; }
 ID:=ovr.Tb_id.fieldByName('ID').asinteger;
 ID:=ID+1;
 ovr.TB_id.edit;
 ovr.Tb_id.fieldByName('ID').asinteger:=ID;
 ovr.tb_id.post;
 Tb_Jine.Edit;
 if (not(Tb_Jine.state=dsInsert)) then
  begin
   Tb_Jine.edit;
  end;
 Tb_Jine.fieldByName('ID').asinteger:=ID;
 Tb_Jine.fieldByName('VAZBA').asinteger:=ovr.tb_odd.fieldByName('ID').asinteger;
 Tb_Jine.fieldByName('MAJ_KOD').asinteger
      :=ovr.Tb_Porost.fieldByName('MAJ_KOD').asinteger;
 Tb_Jine.fieldByName('MAJ_DRUH').asinteger
      :=ovr.Tb_Porost.fieldByName('MAJ_DRUH').asinteger;
 Tb_Jine.fieldByName('KU_KOD').asinteger
      :=ovr.Tb_SK.fieldByName('KU_KOD').asinteger;
 Tb_Jine.fieldByName('LES_URAD').asinteger
      :=ovr.Tb_Sk.fieldByName('LES_URAD').asinteger;
 Tb_Jine.fieldByName('POT_VLAST').asinteger
      :=ovr.Tb_Sk.fieldByName('POT_VLAST').asinteger;

     { :=Tb_ODD1.fieldByName('ID').asinteger; cislovano prubezne}
end;

procedure TS_BZL_OS2.Tb_ostAfterInsert(DataSet: TDataset);
var ID:longint;
    SS:string;
begin
 if ovr.tb_Id.active=false then ovr.tb_id.active:=true;
 with ovr.TB_Id do
  begin
   SetRangeStart; { Set the beginning key }
   FieldByName('TABULKA').AsString :='OST_POZ';
   SetRangeEnd;   { Set the ending key }
   FieldByName('TABULKA').AsString :='OST_POZ';
   ApplyRange; { Tell the dataset to establish the range }
  end;
 { ss:='tabulka='+chr(39)+'DREVINA'+chr(39);
   tb_Id.filter:= ss; }
 ID:=ovr.Tb_id.fieldByName('ID').asinteger;
 ID:=ID+1;
 ovr.TB_id.edit;
 ovr.Tb_id.fieldByName('ID').asinteger:=ID;
 ovr.tb_id.post;
 Tb_ost.Edit;
 if (not(Tb_ost.state=dsInsert)) then
  begin
   Tb_ost.edit;
  end;
 Tb_ost.fieldByName('ID').asinteger:=ID;
 Tb_ost.fieldByName('VAZBA').asinteger:=ovr.tb_odd.fieldByName('ID').asinteger;
 Tb_ost.fieldByName('MAJ_KOD').asinteger
      :=ovr.Tb_Porost.fieldByName('MAJ_KOD').asinteger;
 Tb_ost.fieldByName('MAJ_DRUH').asinteger
      :=ovr.Tb_Porost.fieldByName('MAJ_DRUH').asinteger;
 Tb_ost.fieldByName('KU_KOD').asinteger
      :=ovr.Tb_SK.fieldByName('KU_KOD').asinteger;
 Tb_ost.fieldByName('LES_URAD').asinteger
      :=ovr.Tb_Sk.fieldByName('LES_URAD').asinteger;
 Tb_ost.fieldByName('POT_VLAST').asinteger
      :=ovr.Tb_Sk.fieldByName('POT_VLAST').asinteger;

end;

procedure TS_BZL_OS2.FormActivate(Sender: TObject);
begin
{Tb_OST.MasterSource:=spx.dtz_odd;
 Tb_Jine.MasterSource:=spx.dtz_odd;
 Tb_BZL.active:=true;
 Tb_OST.active:=true;
 Tb_Jine.active:=true; }
end;

procedure TS_BZL_OS2.DB_bzlExit(Sender: TObject);
begin
 if tb_bzl.state in [dsedit,dsInsert] then tb_bzl.post;
end;

procedure TS_BZL_OS2.DB_OstColEnter(Sender: TObject);
begin
 if tb_ost.state in [dsedit,dsInsert] then tb_ost.post;
end;

procedure TS_BZL_OS2.DB_JineColEnter(Sender: TObject);
begin
 if tb_jine.state in [dsedit,dsInsert] then tb_jine.post;
end;

procedure TS_BZL_OS2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if tb_bzl.state in [dsedit,dsInsert] then tb_bzl.post;
 if tb_ost.state in [dsedit,dsInsert] then tb_ost.post;
 if tb_jine.state in [dsedit,dsInsert] then tb_jine.post;
 DbiSaveChanges(tb_bzl.handle);
 DbiSaveChanges(tb_ost.handle);
 DbiSaveChanges(tb_jine.handle);
end;

procedure TS_BZL_OS2.FormCreate(Sender: TObject);
begin
 Tb_bzl.MasterSource:=ovr.dtz_porost;
 Tb_OST.MasterSource:=ovr.dtz_odd;
 Tb_Jine.MasterSource:=ovr.dtz_odd;
 bz_odd.datasource:=ovr.dtz_odd;
 bz_dil.datasource:=ovr.dtz_dl;
 bz_por.datasource:=ovr.dtz_porost;
 Tb_BZL.active:=true;
 Tb_OST.active:=true;
 Tb_Jine.active:=true;
end;

procedure TS_BZL_OS2.Tb_BZLBeforeDelete(DataSet: TDataset);
begin
 Tb_BZL.cancel;
end;

procedure TS_BZL_OS2.DB_bzlKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 case key of
  13: begin
       DB_BZL.SelectedIndex:=DB_BZL.SelectedIndex+1;
      end;
 end;
end;

procedure TS_BZL_OS2.DB_JineKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 case key of
  13: begin
       DB_Jine.SelectedIndex:=DB_Jine.SelectedIndex+1;
      end;
 end;
end;

procedure TS_BZL_OS2.DB_OstKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 case key of
  13: begin
       DB_Ost.SelectedIndex:=DB_Ost.SelectedIndex+1;
      end;
 end;

end;
procedure omez_floatfield(var F:TFloatField;delka:integer);
var l:integer;
begin
 l:= length(f.asstring);
 if l>delka then f.asstring:=copy(f.asstring,l-(delka-1),delka);
end;

procedure TS_BZL_OS2.Tb_BZLBZLChange(Sender: TField);
 begin
  omez_floatfield(Tb_BZLBZL,4);
 end;

procedure TS_BZL_OS2.Tb_BZLMAJ_KODChange(Sender: TField);
begin
  omez_floatfield(Tb_BZLMAJ_KOD,6);
end;

procedure TS_BZL_OS2.Tb_BZLKU_KODChange(Sender: TField);
begin
  omez_floatfield(Tb_BZLKU_KOD,9);
end;

procedure TS_BZL_OS2.Tb_BZLLES_URADChange(Sender: TField);
begin
  omez_floatfield(Tb_BZLLES_URAD,4);
end;

procedure TS_BZL_OS2.Tb_BZLKVAL_PChange(Sender: TField);
begin
  omez_floatfield(Tb_BZLKVAL_P,1);
end;

procedure TS_BZL_OS2.Tb_BZLPOT_VLASTChange(Sender: TField);
begin
  omez_floatfield(Tb_BZLPOT_VLAST,2);
end;

procedure TS_BZL_OS2.Tb_ostOSTChange(Sender: TField);
begin
  omez_floatfield(Tb_ostOST,4);
end;

procedure TS_BZL_OS2.Tb_ostMAJ_KODChange(Sender: TField);
begin
  omez_floatfield(Tb_ostMAJ_KOD,6);
end;

procedure TS_BZL_OS2.Tb_ostKU_KODChange(Sender: TField);
begin
  omez_floatfield(Tb_ostKU_KOD,9);
end;

procedure TS_BZL_OS2.Tb_ostLES_URADChange(Sender: TField);
begin
  omez_floatfield(Tb_ostLES_URAD,4);
end;

procedure TS_BZL_OS2.Tb_ostOST_PChange(Sender: TField);
begin
   omez_floatfield(Tb_ostOST_P,5);
end;

procedure TS_BZL_OS2.Tb_ostOST_VChange(Sender: TField);
begin
  omez_floatfield(Tb_ostOST_V,5);
end;

procedure TS_BZL_OS2.Tb_ostKVAL_PChange(Sender: TField);
begin
  omez_floatfield(Tb_ostKVAL_P,1);
end;

procedure TS_BZL_OS2.Tb_ostDRUH_POZChange(Sender: TField);
begin
  omez_floatfield(Tb_ostDRUH_POZ,2);
end;

procedure TS_BZL_OS2.Tb_ostPOT_VLASTChange(Sender: TField);
begin
  omez_floatfield(Tb_ostPOT_VLAST,2);
end;

procedure TS_BZL_OS2.Tb_jineJPChange(Sender: TField);
begin
  omez_floatfield(Tb_jineJP,4);
end;

procedure TS_BZL_OS2.Tb_jineMAJ_KODChange(Sender: TField);
begin
  omez_floatfield(Tb_jineMAJ_KOD,6);
end;

procedure TS_BZL_OS2.Tb_jineKU_KODChange(Sender: TField);
begin
  omez_floatfield(Tb_jineKU_KOD,9);

end;

procedure TS_BZL_OS2.Tb_jineLES_URADChange(Sender: TField);
begin
  omez_floatfield(Tb_jineLES_URAD,4);
end;

procedure TS_BZL_OS2.Tb_jineJP_PChange(Sender: TField);
begin
  omez_floatfield(Tb_jineJP_P,5);
end;

procedure TS_BZL_OS2.Tb_jineJP_VChange(Sender: TField);
begin
  omez_floatfield(Tb_jineJP_V,5);
end;

procedure TS_BZL_OS2.Tb_jineKVAL_PChange(Sender: TField);
begin
  omez_floatfield(Tb_jineKVAL_P,1);
end;

procedure TS_BZL_OS2.Tb_jineDRUH_POZChange(Sender: TField);
begin
  omez_floatfield(Tb_jineDRUH_POZ,2);
end;

procedure TS_BZL_OS2.Tb_jinePOT_VLASTChange(Sender: TField);
begin
  omez_floatfield(Tb_jinePOT_VLAST,2);
end;

end.
