unit SP_MalyTax;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,
  sp_Ovr98,Sp_VyhSo, DtbLes98,
  U_ZobrComb, U_Zobraz,
  E_LesOdd, E_LesCel,ELesObec, ExtCtrls, StdCtrls;
type
  TFSp_MalyTax = class(TForm)
    Panel1: TPanel;
    LOdd: TLabel;
    LDilec: TLabel;
    LPorost: TLabel;
    LPSK: TLabel;
    LEtaz: TLabel;
    LDrevina: TLabel;
    LLT: TLabel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
   stGrmDrevina:TStringGridMuj;
   CobODD:TComboBoxMujOdd;
   CobMunDIL,CobMunPOR,CobMunPSK,CobMunEtaz:TComboBoxMujName;
   stGrm1ODD,stGrm1DIL,stGrm1POR,
   stGrm1PSK, stGrm1LT,
   stGrm1ETAZ:TStringGridMujJednoPole;
   LesniCelek:TLesniCelek;
   procedure UlozOddeleni(oznamUlozeno:Boolean);
   procedure prezobraz;
   procedure RePaint; override;
  end;

procedure vytvorSP_MalyTax;
procedure OtevriTax(LesniCelek:TLesniCelek);
procedure zobrazSp_MalyTax(HlOdd:integer;VLesniCelek:TLesniCelek;VFSp_MalyTax: TFSp_MalyTax);
var
  FSp_MalyTax: TFSp_MalyTax;

implementation

{$R *.dfm}

procedure TFSp_MalyTax.RePaint;
 begin
  inherited repaint;
  prezobraz;
 end;

procedure TFSp_MalyTax.prezobraz;
 begin
  with LesniCelek.lhc do
   begin
    with stGrm1ODD do
     begin
      ObLesPrvek:=oddelenikdyzJe;
      PouzeCteni:=false;
      refresh;
     end;
    with CobODD do
     begin
      if ObLesniCelek<>LesniCelek then
       begin
        ObLesniCelek := LesniCelek;
       end;
     end;
    with CobMunDIL do
     begin
      if OddeleniKdyzJe<>nil then
       begin
        ObLesMN:=OddeleniKdyzJe.dilecMN;
       end
      else
       begin
        ObLesMN:=nil;
       end;
     end;
    with stGrm1DIL do
     begin
      ObLesPrvek:=DilecKdyzJe;
      PouzeCteni:=false;
      refresh;
     end;
    with CobMunPOR do
     begin
      if DilecKdyzJe<>nil then
       begin
        ObLesMN:=DilecKdyzJe.PorostMN;
       end
      else
       begin
        ObLesMN:=nil;
       end;
     end;

   with stGrm1POR do
     begin
      ObLesPrvek:=porostkdyzJe;
      refresh;
      PouzeCteni:=false;
     end;
    with CobMunPSK do
     begin
      if porostKdyzJe<>nil then
       begin
        ObLesMN:=PorostVzdy.PorostniSkupinaMN;
       end
      else
       begin
        ObLesMN:=nil;
       end;
     end;

    with stGrm1PSK do
     begin
      ObLesPrvek:=porostniSkupinakdyzJe;
      refresh;PouzeCteni:=false;
     end;

     with stGrm1LT do
     begin
      ObLesPrvek:=porostniSkupinakdyzJe;
      refresh;PouzeCteni:=false;
     end;


    with CobMunETAZ do
     begin
      if porostniSkupinaKdyzJe<>nil then
       begin
        ObLesMN:=PorostniSkupinaKdyzJe.EtazMN;
       end
      else
       begin
        ObLesMN:=nil;
       end;
     end;


    with stGrm1ETAZ do
     begin
      ObLesPrvek:=EtazkdyzJe;
      refresh;PouzeCteni:=false;
     end;


    with stGrmDrevina do
     begin
      if EtazKdyzJe<>nil then
       begin
        ObLesMN:=EtazKdyzJe.DrevinaMN;
       end
      else
       begin
        ObLesMN:=nil;
       end;
      mnozinuDoGriduAVlastnosti;
      PouzeCteni:=false;
     end;



   end; // With lesniceleK.lhc
 end;
procedure zobrazSP_MalyTax(HlOdd:integer;VLesniCelek:TLesniCelek;VFSp_MalyTax: TFSp_MalyTax);
Var VOdd:TOddeleni;
begin
 VFSp_MalyTax.LesniCelek := VLesniCelek;

 vOdd:=VLesniCelek.OddeleniDleCislaBezTransformace(HlOdd);
 VLesniCelek.LHC.OddeleniMN.AddElement(VOdd);
 VFSp_MalyTax.Show;
end;
procedure vytvorSP_MalyTax;
 begin
  Application.CreateForm(TFSP_MalyTax, FSP_MalyTax);
 end;

procedure OtevriTax(LesniCelek:TLesniCelek);
var
LOvr98A:TOvr98;
 begin
  LesniCelek.VcetneBarev:= VcetneBarvy1;
  druhaDataBaze98:=true;
  nespoustetManager:=false;
  umoznitZalozeniNoveDatabaze:=false;
  Application.CreateForm(TOVR98,LOvr98A);
  LesniCelek.JakBylNacten :='Tax98-Paradox';
  LesniCelek.TypDatLHP    := tax98;
  LesniCelek.FFOvr98:=LOvr98A;
  NactiPolozkyLHC_DB98(LesniCelek.LHC,LesniCelek.LOvr98);
  PriradCiselnik_DB98(LesniCelek.ciselnik,LesniCelek.LOvr98);
  LesniCelek.CiselOrbis.nactiSeZOrbu(LesniCelek.PHSNazev,true);
  NactiCiselOrbis_DB98(LesniCelek.CiselOrbis,LesniCelek.LOvr98);
 end;


procedure TFSp_MalyTax.FormCreate(Sender: TObject);
var cc:string;
     i:integer;
begin

  try
  CobODD:=TComboBoxMujOdd.Create(Self);
  with CobODD do
   begin
    Parent         := panel1;
    top            := 11;
    left           := 6;
    height         := 21;
    width          := 51;
    ItemHeight     := 12;
    DropDownCount  := 25;
    name           := 'CobODD';
   end;
  SetTopPod(CobODD,LODD);
  CobOdd.top:=CobOdd.top-1;
  stGrm1ODD:=TStringGridMujJednoPole.Create(Self);
  with StGrm1ODD do
   begin
    name:='StGrm1ODD';
    Parent := panel1;
    top    := 12;
    left   := 6;
    mheight := 19;
    mwidth  := 35;
    JmenoProperty:='ODD';
    PocetZnaku:=4;
    TypPolozky:='I';
    onKeyDown:=nil;// stGrm1ODDKeyDown;
    onExit:=nil; //stGrm1ODDExit;
    onEnter:=nil; //stGrm1ODDEnter;
   end;
  SetTopPod(StGrm1ODD,LODD);
  SetStredX(LODD ,GetStredX(CobODD));
  //ButPrOdd.top:=CobOdd.top+CobOdd.Height+2;
  // ButPrOdd.left:=CobOdd.left;
  CobMunDIL:=TComboBoxMujName.Create(Self);
  with CobMunDIL do
   begin
    Parent := panel1;
    top    := 11;
    left   := 58;
    height := 21;
    width  := 35;
    ItemHeight:=12;
    DropDownCount:=25;
    name:='CobMunDIL';
   // onchange:=ComboBox3Change;
   end;
  stGrm1DIL:=TStringGridMujJednoPole.Create(Self);
  with StGrm1DIL do
   begin
    Parent  := panel1;
    name:='stGrm1DIL';
    top     := 12;
    left    := 58;
    mheight := 19;
    mwidth  := 20;
    JmenoProperty:='DIL';
    PocetZnaku:=1;
    typPolozky:='A';
    // onKeyDown:=stGrm1DILKeyDown;
   end;
  // LDilec.left:=stGrm1DIL.left+1;
  SetTopPod(StGrm1DIL,LDilec);
  SetStredX(LDilec ,GetStredX(CobMunDIL));
  SetTopPod(CobMunDIL,LDilec);
  CobMunDIL.top:=CobMunDIL.top-1;
  // ButPrDil.left:=CobMunDIL.left;
  // ButPrDil.top:=CobMunDil.top+CobMunDil.Height+2;
  CobMunPOR:=TComboBoxMujName.Create(Self);
  with CobMunPOR do
   begin
    Parent := panel1;
    top    := 11;
    left   := 94;
    height := 21;
    width  := 36;
    ItemHeight:=12;
    DropDownCount:=25;
    name:='CobMunPOR';
    // onchange:=ComboBox2Change;
   end;
  stGrm1POR:=TStringGridMujJednoPole.Create(Self);
  with StGrm1POR do
   begin
    name:='StGrm1POR';
    Parent := panel1;
    top    := 12;
    left   := 94;
    mheight := 19;
    mwidth  := 20;
    JmenoProperty:='POR';
    PocetZnaku:=1;
    typPolozky:='A';
    // onKeyDown:=stGrm1PorKeyDown;
   end;
  SetTopPod(StGrm1POR,LPorost);
  SetStredX(LPorost  ,GetStredX(CobMunPOR));
  SetTopPod(CobMunPOR,LPORost);
  CobMunPOR.top:=CobMunPOR.top-1;

  CobMunPSK:=TComboBoxMujName.Create(Self);
  with CobMunPSK do
   begin
    Parent := panel1;
    top    := 97;
    left   := 6;
    height := 21;
    width  := 120;
    ItemHeight:=12;
    DropDownCount:=12;
    name:='CobMunPSK';
    // onchange:=ComboBox1Change;
   end;

  stGrm1PSK:=TStringGridMujJednoPole.Create(Self);
  with StGrm1PSK do
   begin
    Parent  := panel1;
    name:='StGrm1PSK';
    top     := 98;
    left    := 6;
    mheight := 19;
    mwidth  := 104;
    JmenoProperty:='PSK';
    // onKeyDown:=stGrm1PSKKeyDown;
    PocetZnaku:=15;
   end;
  SetTopPod(StGrm1PSK,LPSK);
  LPSK.left:=CobMunPSK.left+6;
  SetStredX(LPSK,GetStredX(CobMunPSK));
  SetTopPod(CobMunPSK,LPSK);
  CobMunPSK.TOP:=CobMunPSK.Top-1;

  stGrm1LT:=TStringGridMujJednoPole.Create(Self);
  with StGrm1LT do
   begin
    Parent := panel1;
    name:='StGrm1LT';
    top    := 98;
    left   := 197;
    mheight := 19;
    mwidth  := 43;
    JmenoProperty:='LT';
    PocetZnaku:=4;
   end;
  SetTopPod(StGrm1LT,LLT);
  SetStredX(LLT,GetStredX(stGrm1LT));




  CobMunETAZ:=TComboBoxMujName.Create(Self);
  with CobMunEtaz do
   begin
    Parent    := panel1;
    top       := 183;
    left      := 6;
    height    := 21;
    width     := 52;
    ItemHeight:= 12;
    DropDownCount:=10;
    name:='CobMunETAZ';
   end;

  stGrm1ETAZ:=TStringGridMujJednoPole.Create(Self);
  with StGrm1ETAZ do
   begin
    Parent  := panel1;
    name:='StGrm1ETAZ';
    top     := 184;
    left    := 6;
    mheight := 19;
    mwidth  := 36;
    JmenoProperty:='ETAZ';
    // onKeyDown:=stGrm1ETAZKeyDown;
    PocetZnaku:=3;
   end;
  SetTopPod(StGrm1ETAZ,LETAZ);
  LEtaz.left:=stGrm1ETAZ.left+6;
  SetTopPod(CobMunEtaz,LEtaz);
  CobMunEtaz.TOP:=CobMunEtaz.Top-1;

  stGrmDrevina:=TStringGridMuj.Create(Self);
  with StGrmDrevina do
   begin
    name:='stGrmDrevina';
    NastavStringGridMujNaTax200(stGrmDrevina);
    Parent := panel1;
    ZobrazeniGridu:=vybranePole;
    top    := 235;
    left   := 0;
    height := 133;
    width  := Parent.Width-98;
    MenitRowHeights:=true;
    ObLesMN:=TDrevinaMN.create;
    NastavGrid;
    with VlastnostiSloupcuMN do
     begin
      for I:=0 to count-1 do
       begin
        with TVlastnostiSloupcu(elements[i]) do
         begin
          viditelny:=False;
         end;
       end;
     end;
    with VlastnostiSloupcuMN do
     begin
      JmenoAktualnihoPrvku:='DR_ZKR';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=30;
        Nadpis:='Dev.';
        poziceTisku:=uprostred;
        PocetZnaku:=3;
        TypPolozky:='A';
       end;
      JmenoAktualnihoPrvku:='ZAST';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=True;
        Sirka:=23;
        Nadpis:='Zast.';
        poziceTisku:=NaPravo;
        PocetZnaku:=3;
        TypPolozky:='I';
       end;
      JmenoAktualnihoPrvku:='TLOUSTKA';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=17;
        Nadpis:='D';
        poziceTisku:=uprostred;
        PocetZnaku:=2;
        TypPolozky:='I';
       end;
      JmenoAktualnihoPrvku:='VYSKA';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=17;
        Nadpis:='H';
        poziceTisku:=uprostred;
        PocetZnaku:=2;
        TypPolozky:='I';
       end;
      JmenoAktualnihoPrvku:='BON_A';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=20;
        Nadpis:='Bon';
        poziceTisku:=NaPravo;
        PocetZnaku:=2;
        TypPolozky:='I';
       end;
      JmenoAktualnihoPrvku:='ZAS_TAB_HA';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=28;
        Nadpis:='Vtab';
        poziceTisku:=NaPravo;
        PocetZnaku:=4;
        TypPolozky:='I';
       end;
      JmenoAktualnihoPrvku:='DR_ZAS_HA';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=28;
        Nadpis:='Vs/ha';
        poziceTisku:=NaPravo;
        PocetZnaku:=4;
        TypPolozky:='I';
       end;
      JmenoAktualnihoPrvku:='DR_ZAS_CEL';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=40;
        Nadpis:=' Vs ';
        poziceTisku:=NaPravo;
        PocetZnaku:=5;
        TypPolozky:='I';
       end;
    PripravZobrazeniGridu;
    // onEnter:=stGrmDrevinaEnter;
    // onKeyDown:=stGrmDrevinaKeyDown;
    // onExit:=stGrmDrevinaExit;
    // onSelectCell:=stGrmDrevinaSelectCell;
    // onDblClick:=stGrmDrevinaDblClick;
    end;
   end;
  SetTopPod(StGrmDrevina,LDrevina);



 except
  showmessage('Chyba '+cc);
 end;

end;

procedure TFSp_MalyTax.FormShow(Sender: TObject);
begin
 prezobraz;
end;

procedure TFSp_MalyTax.Button1Click(Sender: TObject);
 begin
  UlozOddeleni(true);
 end;

procedure TFSp_MalyTax.UlozOddeleni(oznamUlozeno:Boolean);
begin
  TOddeleni(LesniCelek.LHC.OddeleniMN.aktualniPrvek).DoplnZpZdPodleBarev;
  if LesniCelek.UlozZnovuOddeleni(TOddeleni(LesniCelek.LHC.OddeleniMN.aktualniPrvek)) then
   begin
    TOddeleni(LesniCelek.LHC.OddeleniMN.aktualniPrvek).NastavNebylEditovanVytvorRekurz;
    if oznamUlozeno then showmessage('Oddlen uloeno.');
   end
  else
   begin
    showmessage('Chyba v uloen.');
   end;
end;

procedure TFSp_MalyTax.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 UlozOddeleni(false);
end;

end.
