unit Sp_oznbz;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls,SysUtils,IniFiles,Dialogs,
  mat1;

type
  TS_OznBZ = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Bevel1: TBevel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormShow(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure CtiSpMezBezlOstJine;
procedure ZapisSpMezBezlOstJine;
function  JeBezlesi(SOzn:string):boolean;
function  JeJine(SOzn:string):boolean;
function  JeOstatni(SOzn:string):boolean;

var
  S_OznBZ: TS_OznBZ;
  SpMezBezl,SpMezJine,SpMezOst:integer;
implementation

{$R *.DFM}
function  JeBezlesi(SOzn:string):boolean;
var BZL:integer;
 begin
   if uc(SOzn)<>trim(SOzn) then
    begin
     result:=False;
     exit;
    end;
   try
   bzl:=StrToInt(SOzn);
   if (bzl>=SpMezBezl)and(bzl<SpMezJine)
      then jeBezlesi:=true
      else jeBezlesi:=false;
   except
   on EConvertError do
     begin
      jeBezlesi:=false;
      exit;
     end;
   end;
 end;

function  JeJine(SOzn:string):boolean;
var BZL:integer;
 begin
   if uc(SOzn)<>trim(SOzn) then
    begin
     result:=False;
     exit;
    end;
   try
   bzl:=StrToInt(SOzn);
   if (bzl>=SpMezJine)and(bzl<SpMezOst)
      then jeJine:=true
      else jejine:=false;
   except
   on EConvertError do
     begin
      jeJine:=false;
      exit;
     end;
   end;
 end;

function  JeOstatni(SOzn:string):boolean;
var BZL:integer;
 begin
   if uc(SOzn)<>trim(SOzn) then
    begin
     result:=False;
     exit;
    end;
   try
   bzl:=StrToInt(SOzn);
   if (bzl>=SpMezOst)
      then
       begin
        jeOstatni:=true;
       end
      else jeOstatni:=false;
   except
   on EConvertError do
     begin
      jeOstatni:=false;
      exit;
     end;
   end;
 end;

procedure TS_OznBZ.FormShow(Sender: TObject);
begin
 CtiSpMezBezlOstJine;
 Edit1.text:=IntToStr(SpMezBezl );
 Edit2.text:=intToStr(SpMezJine );
 Edit3.text:=intToStr(SpMezOst  );
end;

procedure TS_OznBZ.OKBtnClick(Sender: TObject);
begin
 SpMezBezl:=strToInt( Edit1.text);
 SpMezJine:=strToInt( Edit2.text);
 SpMezOst :=strToInt( Edit3.text);
 ZapisSpMezBezlOstJine;
end;



function WinDirStr: string;
type
  TDirStr          = array[0..100] of Char;
var
  PomDirStr: TDirStr;
begin
  getWindowsDirectory(PomDirStr, sizeOf(TDirStr));
  result:= StrPas(PomDirStr);
end;



procedure CtiSpMezBezlOstJine;
var
  IniFileName: string;
  IniFile: TIniFile;
begin
  IniFileName:= WinDirStr + '\' + 'TERTOPOL.INI';
  IniFile  := TIniFile.Create(IniFileName);
  SpMezBezl:= IniFile.ReadInteger('Global', 'SpodniMezBezlesi', 100);
  SpMezJine:= IniFile.ReadInteger('Global', 'SpodniMezJine'   , 500);
  SpMezOst := IniFile.ReadInteger('Global', 'SpodniMezOstatni', 900);
  Inifile.free;
end;

procedure ZapisSpMezBezlOstJine;
var
  IniFileName: string;
  IniFile: TIniFile;
 begin
  IniFileName:= WinDirStr + '\' + 'TERTOPOL.INI';
  IniFile   := TIniFile.Create(IniFileName);
  IniFile.WriteInteger('Global', 'SpodniMezBezlesi', SpMezBezl);
  IniFile.WriteInteger('Global', 'SpodniMezJine'   , SpMezJine);
  IniFile.WriteInteger('Global', 'SpodniMezOstatni', SpMezOst);
  IniFile.free;
 end;
end.
