unit Sp_topol;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, StdCtrls,
  ovr_SPX,spx_bzos;

type
  TS_Topol1 = class(TForm)
    Query1: TQuery;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DataSource2: TDataSource;
    DBGrid3: TDBGrid;
    Table1: TTable;
    Button1: TButton;
    Table1VAZBA: TFloatField;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    DataSource3: TDataSource;
    DataSource4: TDataSource;
    DBGrid4: TDBGrid;
    Button5: TButton;
    Table1PSK: TStringField;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Query1AfterOpen(DataSet: TDataset);
  private
    { Private declarations }
  public
    { Public declarations }
    nacitej:boolean;
    bzl_exist:boolean;
    nacitej_jine_a_ostatni:boolean;
    procedure setrid_data_topol;
  end;

procedure nactiPlochuSkupiny;
procedure nactiPlochuBezlesi;

var S_Topol1: TS_Topol1;

implementation
uses spx_hf,sp_ovr;
{$R *.DFM}

procedure TS_Topol1.Button1Click(Sender: TObject);
var ss:String[20];
begin
 query1.close;
 query1.SQL.strings[3]:='';
 query1.open;
 query1.first;
 while not query1.eof do
  begin
   ss:=Query1.fieldbyname('Skupina').asstring;
   opravSkupinu(ss);
   query1.edit;
   Query1.fieldbyName('Skupina').asstring:=ss;
   query1.post;
   query1.next;
  end;
end;

procedure TS_Topol1.Button2Click(Sender: TObject);
begin
 setrid_data_topol;
end;
procedure tS_Topol1.setrid_data_topol;
begin
 query1.close;
 query1.SQL.strings[3]:='order by SKUPINA';
 query1.open;
end;
procedure TS_Topol1.Button3Click(Sender: TObject);
begin
 query1.close;
 query1.SQL.strings[3]:='';
 query1.open;
end;

procedure TS_Topol1.FormShow(Sender: TObject);
begin
 nacitej:=false;
 nacitej_jine_a_ostatni:=false;
end;

procedure TS_Topol1.Button4Click(Sender: TObject);
begin
 setrid_data_topol;
 nacitej:=true;
 close;
end;

procedure TS_Topol1.FormActivate(Sender: TObject);
begin
 DataSource4.dataset:=s_bzl_os1.tb_bzl;
 s_bzl_os1.tb_bzl.open;
end;

procedure TS_Topol1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 s_bzl_os1.tb_bzl.close;
end;

procedure TS_Topol1.Button5Click(Sender: TObject);
begin
 nacitej_jine_a_ostatni:=true;
 close;
end;
procedure nactiPlochuSkupiny;
var sk_ozn:String[13];
    pl,vym:real;
begin
with SPX do
 begin
  sk_Ozn:=S_topol1.Query1.fieldByName('Skupina').asstring;
  pl  :=s_topol1.Query1.fieldByName('PLOCHA').asfloat;
  vym :=s_topol1.Query1.fieldByName('VYMERA').asfloat;
  s_topol1.Query1.next;
  while (sk_Ozn=S_topol1.Query1.fieldByName('Skupina').asstring)and(not s_topol1.Query1.eof) do
   begin
    pl  := pl  + s_topol1.Query1.fieldByName('PLOCHA').asfloat;
    vym := vym + s_topol1.Query1.fieldByName('VYMERA').asfloat;
    s_topol1.Query1.next;
   end;
  { if not (sk_Ozn=s_topol1.Query1Skupina.asstring) then s_topol1.Query1.prior; }
  if not(ovr.tb_sk.state in [dsinsert,dsedit]) then
   begin
    ovr.tb_sk.edit;
   end;
  ovr.tb_skPSK_P0.asfloat :=pl;
  ovr.tb_skPSK_V.asfloat :=vym;
  try
   strtoint(s_topol1.Query1.fieldByName('KATASTR').asstring);
   ovr.tb_skKU_KOD.asstring   :=   s_topol1.Query1.fieldByName('KATASTR').asstring;
   if length(ovr.tb_skKU_KOD.asstring)=9 then
     begin
       ovr.tb_sk.fieldByName('LES_URAD').asstring:=copy(ovr.tb_skKU_KOD.asstring,1,4);
     end;
  except
   on eConvertError  do showmessage('Katastr "'+s_topol1.Query1.fieldByName('KATASTR').asstring+'" nen cel slo.');
  end;
  ovr.tb_skSKUPPARC.asstring     :=   s_topol1.Query1.fieldByName('SK_PARC').asstring;
  if s_topol1.Query1.findfield('KV_PL') <>nil then
     begin
      ovr.tb_skKVAL_P.asstring := s_topol1.Query1.findfield('KV_PL').asstring;
      if ovr.tb_skKVAL_P.asstring='1' then
       begin
        ovr.tb_skPSK_P.asfloat:=vym;
       end
      else
       begin
        ovr.tb_skPSK_P.asfloat:=pl;
       end;
     end
  else
     begin
      ovr.tb_skPSK_P.asfloat:=vym;
     end;
if not(ovr.tb_porost.state in [dsinsert,dsedit]) then
   begin
    ovr.tb_porost.edit;
   end;
  if s_topol1.Query1.findfield('DR_MAJ') <>nil then
  ovr.tb_porostMAJ_DRUH.asstring  :=s_topol1.Query1.findfield('DR_MAJ').asstring;
  ovr.tb_porostMAJ_KOD.asstring :=s_topol1.Query1.fieldByName('VLASTNIK').asstring;
  if s_topol1.Query1.findfield('DR_MAJ') <>nil then
  ovr.tb_porostMAJ_DRUH.asstring  :=s_topol1.Query1.findfield('DR_MAJ').asstring;
  if s_topol1.Query1.findfield('POT_VLAST') <>nil then
    ovr.tb_sk.fieldByName('POT_VLAST').asstring  :=s_topol1.Query1.findfield('POT_VLAST').asstring;

 { if not(tb_sk.state in [dsinsert,dsedit]) then
   begin
    tb_sk.edit;
   end;    }
{  showmessage('*'+tb_skPSK_P0.asstring+'*');
   tb_skPSK_P.asstring:=tb_skPSK_P0.asstring; }
  end;
end;
procedure nactiPlochuBezlesi;
var sk_ozn:String[13];
    pl,vym:real;
begin
with spx do begin
  sk_Ozn:=S_topol1.Query1.fieldByName('Skupina').asstring;
  pl  :=s_topol1.Query1.fieldByName('PLOCHA').asfloat;
  vym :=s_topol1.Query1.fieldByName('VYMERA').asfloat;
  s_topol1.Query1.next;
  while (sk_Ozn=S_topol1.Query1.fieldByName('Skupina').asstring)and(not s_topol1.Query1.eof) do
   begin
    pl  := pl+s_topol1.Query1.fieldByName('PLOCHA').asfloat;
    vym := vym+s_topol1.Query1.fieldByName('VYMERA').asfloat;
    s_topol1.Query1.next;
   end;
  if not(s_bzl_os1.tb_bzl.state in [dsinsert,dsedit]) then
   begin
    s_bzl_os1.tb_bzl.edit;
   end;
  s_bzl_os1.tb_bzlBZL_P0.asfloat :=pl;
  s_bzl_os1.tb_bzlBZL_V.asfloat :=vym;
  try
   strtoint(s_topol1.Query1.fieldByName('KATASTR').asstring);
   s_bzl_os1.tb_bzlKU_KOD.asstring := s_topol1.Query1.fieldByName('KATASTR').asstring;
   if length(s_bzl_os1.tb_bzlKU_KOD.asstring)=9 then
     begin
       s_bzl_os1.tb_bzl.fieldByName('LES_URAD').asstring:=copy(s_bzl_os1.tb_bzlKU_KOD.asstring,1,4);
     end;
  except
   on eConvertError do showmessage('Katastr "'+s_topol1.Query1.fieldByName('KATASTR').asstring+'" nen cel slo.');
  end;
  s_bzl_os1.tb_bzlSKUPPARC.asstring     :=s_topol1.Query1.fieldByName('SK_PARC').asstring;
  if s_topol1.Query1.findfield('KV_PL')<>nil then
     s_bzl_os1.tb_bzlKVAL_P.asstring    :=s_topol1.Query1.findfield('KV_PL').asstring;
  if s_topol1.Query1.findfield('DR_MAJ')<>nil then
    s_bzl_os1.tb_bzlMAJ_DRUH.asstring  :=s_topol1.Query1.findfield('DR_MAJ').asstring;
  s_bzl_os1.tb_bzlMAJ_KOD.asstring :=s_topol1.Query1.fieldByName('VLASTNIK').asstring;
  s_bzl_os1.tb_bzlBZL_P.asstring:=s_bzl_os1.tb_bzlBZL_P0.asstring;
  end;
end;
procedure TS_Topol1.FormCreate(Sender: TObject);
begin
if S_bzl_Os1=nil then
 begin
 Application.CreateForm(TS_bzl_Os2, S_Bzl_Os1);
 bzl_exist:=false;
 end
 else bzl_exist:=true;
end;

procedure TS_Topol1.FormDestroy(Sender: TObject);
begin
if  bzl_exist then
  begin
   s_bzl_os1.destroy;
   s_bzl_os1:=nil;
  end;
end;
procedure TS_Topol1.Query1AfterOpen(DataSet: TDataset);
var I,index1:integer;
begin
 with Query1 do
 begin
  for I:=0 to fieldcount-1 do
   begin
    fields[I].visible:=false;
   end;
  index1:=0;
  if findField('SKUPINA')<>nil then
   begin
    with TStringField(fieldByName('SKUPINA')) do
     begin
      Visible:=true;
      DisplayLabel:='Skupina';
      DisplayWidth:=12;
      index:=index1;
      inc(index1);
     end
   end;
  if findField('PLOCHA')<>nil then
   begin
    with tFloatField(fieldByName('PLOCHA')) do
     begin
      Visible:=true;
      precision:=4;
      EditFormat:='0.00';
      DisplayFormat:='0.00';
      DisplayLabel:='Plocha';
      DisplayWidth:=6;
      index:=index1;
      inc(index1);
     end
   end;
  if findField('VYMERA')<>nil then
   begin
    with tFloatField(fieldByName('VYMERA')) do
     begin
      Visible:=true;
      precision:=4;
      EditFormat:='0.00';
      DisplayFormat:='0.00';
      DisplayLabel:='Vmra';
      DisplayWidth:=6;
      index:=index1;
      inc(index1);
     end
   end;
    if findField('KV_PL')<>nil then
   begin
    with fieldByName('KV_PL') do
     begin
      Visible:=true;
      DisplayLabel:='Kval.Pl.';
      DisplayWidth:=2;
      index:=index1;
      inc(index1);
     end
   end;

  if findField('SK_PARC')<>nil then
   begin
    with fieldByName('SK_PARC') do
     begin
      Visible:=true;
      DisplayLabel:='Skup.Parc.';
      DisplayWidth:=6;
      index:=index1;
      inc(index1);
     end
   end;
  if findField('KATASTR')<>nil then
   begin
    with fieldByName('KATASTR') do
     begin
      Visible:=true;
      DisplayLabel:='Katastr';
      index:=index1;
      inc(index1);
     end
   end;
  if findField('VLASTNIK')<>nil then
   begin
    with fieldByName('VLASTNIK') do
     begin
      Visible:=true;
      DisplayLabel:='Vlastnk';
      DisplayWidth:=6;
      index:=index1;
      inc(index1);
     end
   end;
  if findField('KULTURA_')<>nil then
   begin
    with fieldByName('KULTURA_') do
     begin
      Visible:=true;
      DisplayLabel:='Kult.';
      DisplayWidth:=2;
      index:=index1;
      inc(index1);
     end
   end;
 end;
end;
end.
