unit SecanvParcel;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls,E_lesOdd,U_Zobraz,ELesObec;

type
  TTypTiskuParcel=(dleDvoraka,dleVitkovice,dleGregora,dleMrazka);

  TFSeCanvParcel = class(TForm)
    Image1: TImage;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FSeCanvParcel: TFSeCanvParcel;
  procedure tiskSeparatuParcel(VMajitel:TMajitel;CanvasV:TCanvas;merX,MerY:longint;
                                  NaTiskarnu:boolean;
                                  VychDo40,RamcSmer,
                                  NavodNaAdresaNeniSoucastiJmena:TAnoNeRozhodniSeSam;
                                  VColor:TColor;dleKoho:TTypTiskuParcel);

implementation

{$R *.DFM}
uses  {hkCanvas,}
      E_type,lesCisel,lesRecur,tisky,mat1,SPWieSep;

procedure tiskSeparatuParcel(VMajitel:TMajitel;CanvasV:TCanvas;merX,MerY:longint;
                                  NaTiskarnu:boolean;
                                  VychDo40,RamcSmer,
                                  NavodNaAdresaNeniSoucastiJmena:TAnoNeRozhodniSeSam;
                                  VColor:TColor;dleKoho:TTypTiskuParcel);
var x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x14a,x14b,x14c,
    x15,x16,x17,x18,x19,
    x20,x21,x22,
    XtW1,XtW2,XtW3,
    xKon, x1Kr,xKonKr,xp,rrx:LongInt;
    y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11,y12,y13,y14,y15,Y15Kat,y16,y17,y17a,
    y18,y19,y20,y21,y22,y23,y24,y25,Y25a,y26,y27,y28,y29,y30,y31,
    Y4i,
    yKon,
    RadY,RadYK,RadYM,yp,radyKat,rry,
    x2k :LongInt;
    FS,FSD,FSDK,FSDM :integer;
    I:integer;
    SeznamCisKatastru,SeznamCisHS:TIntegerListElement;
    sHS:String;
    ss,SSp:Widestring;
    pradY:Integer;
 function adresaNeniSoucastiJmena:boolean;
  begin
   result:=false;
   case NavodNaAdresaNeniSoucastiJmena  of
     Ano           : result := true;
     Ne            : result := false;
     RozhodniSeSam : result := (VMajitel.majetky.JmePrijm_C='') and (VMajitel.majetky.MAJ_NAZ_C<>'');
   end;
  end;
 function mx(x:real):longint;
  begin
   mx:=mx1(x,MerX);
  end;
 function my(y:real):longint;
  begin
   my:=round(0.96*my1(y,mery));
  end;
 procedure NastavBody;
  begin
   FS:=8;
   FSD:=10;
   FSDK:=14;
   FSDM:=3;
   xp:=mx(0.1);
   x1kr:=mx(0.1);
   xKonkr:=mx(19.5);
   x1:=x1kr+mx(0.4);
   xKon:=xKonkr-mx(0.4);
   x2:=x1+mx(11.3);
   x3:=x2+mx(0.7);
   x4:=x1+mx(4.65);
   x5:=x4+mx(0.7);
   x6:=x5+mx(8.0);
   x7:=x6+mx(0.7);
   x8:=x1+mx(10.0);
   x9:=x8+mx(0.7);
   x10 :=x1+mx(5.3);
   x11 :=x10+mx(6.0);
   x12 :=x11+mx(5.3);
   x13 :=x1+mx(4.0);
   x14 :=x11;
   x14a:=x1+mx(3.0);
   x14b:=x14a+mx(2.5);
   x14c:=x14b+mx(1.0);
   x15:=x1+mx(7.4);
   x16:=x1+mx(10.0);
   x17:=x1+mx(8.0);
   x18:=x17+mx(0.7);
   x19:=x18+mx(4.6);
   x20:=x19+mx(0.7);
   x21:=x1+mx(8.7);
   x22:=x16;

   //y1:=my(0.1);
   y1:=my(0.8); // pro gregora
   // yKon:=my(29.4);
   yKon:=my(30.1); // pro gregora
   RadY:=my(0.78);
   RadYM:=round(radY*0.7);
   RadYK:=round(radY*0.25);
   yp:=my(0.1);
   y2:=y1+my(0.6);
   y3:=y2+radY;
   y4:=y3+RadYM;
   if adresaNeniSoucastiJmena
   then
    begin
     y5:=y4+4*radY;
    end
   else
    begin
     y5:=y4+6*radY;
    end;
   y6:=y5+RadYK;
   y7:=Y6+3*radY;
   y8:=y7+RadYM;
   if adresaNeniSoucastiJmena
   then  y9:=y8+radY*2
   else  y9:=y8;
   // else y9:=y8+radY*5;
   y10:=y9+radYM;
   y11:=y10+radY;
   y12:=y11+radYK;
   y13:=y12+RadY;
   y14:=y13+RadY;
   y15:=y14+RadYM;
   y16:=y15+RadY;
   y17:=y16+RadY;
   y17a:=y17+RadY;
   y18:=y17a+RadY;
   y19:=y18+RadYM;
   y20:=y19+RadY+(radY div 2);
   y21:=y20+RadYM;
   y22:=y21+RadYM;
   y23:=y22+RadYM;
   y24:=y23+RadYM;
   y25:=y24+RadYM;
   y25a:=y25+RadYK;
   y26:=y25+RadYK+radY*2+my(0.6);
   y27:=y26+RadY;
   y28:=y27+RadYK;
   y29:=y28+2*RadY;
   y30:=y29+RadYK;
   y31:=y30+2*RadY;
  end;
 var
  katastrGreg,LVGreg,parCisParPodGreg,PKCisPKPod:string;
 begin
  NastavBody;
  with CanvasV do
   begin
    Brush.Color:=VColor; //clYellow;
    fillrect(rect(x1kr,y1,XKonKr,YKon));
    pen.width:=3;

    FONT.NAME:='Arial CE';
    Font.Size:=FSDK;
    Font.Style:=[fsBold];
    font.Charset:=238;
    TextOutS(canvasV,X1,XKon,
               Y1,
              // (Y2+3*Y1) div 4,
              'Protokol o pedn a pevzet vlastnickho separtu lesn hospodsk osnovy');

    FONT.NAME:='Arial CE';
    Font.Size:=FSD;
    Font.Style:=[fsBold];
    font.Charset:=238;
    TextOut(X1+xp,(Y4+3*Y3)div 4,  'daje o vlastnkovi lesa');
    TextOut(X1+xp,(Y10+3*Y9)div 4, 'Jmno a adresa osoby zplnomocnn k pevzet vlastnickho separtu');
    XtW1:=textWidth(               'Jmno a adresa osoby zplnomocnn k pevzet vlastnickho separtu');
    TextOut(X1+xp,(Y15+3*Y14)div 4,'daje o lese');
    TextOut(X1+xp,(Y19+3*Y18)div 4,'Zvazn ustanoven lesn hospodsk osnovy');
    XtW2:=textWidth(               'Zvazn ustanoven lesn hospodsk osnovy');
    TextOut(X1+xp,(Y21+3*Y20)div 4,'Seznam pedanch a pevzatch st vlastnickho separtu');
    XtW3:=textWidth(               'Seznam pedanch a pevzatch st vlastnickho separtu');
    TextOutS(CanvasV,X16,xKon,(Y21+3*Y20) div 4,'Ostatn');
    FONT.NAME:='Arial CE';
    Font.Size:=FSD;
    Font.Style:=[];
    font.Charset:=238;
   if adresaNeniSoucastiJmena
   then TextOut(X1+xp,(Y8+3*Y7)div 4,'Adresa trvalho bydlit fyzick osoby nebo sdla prvnick osoby');
    FONT.NAME:='Arial CE';
    Font.Size:=FS;
    Font.Style:=[];
    font.Charset:=238;
    Y4i:=textheight('1)K tomuto protokolu je teba')div 2;
    TextOut(X1 +xp,((YKon+3*Y31)div 4)-Y4i,'1)K tomuto protokolu je teba piloit plnou moc');
    TextOut(X22+xp,((YKon+3*Y31)div 4)-Y4i,'2)Nehodc se krtnte nebo odstrate text');

    SeznamCisHS:=VMajitel.seznamHodnotTypu('HS');
    sHS:='';
    with SeznamCisHS do
     begin
      for I:=0 to count-1 do
       begin
        sHS:=sHS+elements[i].name+',';
       end;
     end;
     sHS:=KPoslednimuZnaku(sHS,',');

    TextOut(X1 +xp,((YKon+3*Y31)div 4)+Y4i,'3)Pro hospodsk soubory:'+sHS);
    TextOut(X1+xp+Xtw1,Y9+yp,'1),2)');
    TextOut(X1+xp+Xtw2,Y18+yp,'2)');
    TextOut(X1+xp+Xtw3,Y20+yp,'2)');
    Brush.color:=ClWhite;
    fillrect(rect(x1,y2,X2,Y3));
    FONT.NAME:='Arial CE';
    Font.Size:=FSD;
    Font.Style:=[];
    font.Charset:=238;
    TextOut(X1+xp,Y2+Yp,'Obec poven sprvou :'); // 15960 - Suice ');
    x2K:=X1+2*xp+textWidth('Obec poven sprvou :');
    TextOUTPrelom1(CanvasV,x2k,X2-2*xp,Y2+Yp,Y3,naPravo,VMajitel.Majetky.LES_URAD_nazev_C1);

    // TextOutP(CanvasV,X2-2*xp,Y2+Yp,VMajitel.Majetky.LES_URAD_nazev_C);
    // pro vtkovie TextOUTPrelom1(CanvasV,x2k,X2-2*xp,Y2+Yp,Y3,naPravo,VMajitel.Majetky.LES_URAD_nazev_C1);
                     //   left,Right,top,Bottom:integer;VPoziceTisku:TPoziceTisku;
                     //   TextStr:String);

      //  TLesniPlosnyPrvek(VMajitel.PrvniPrvekTypu(TLesniPlosnyPrvek)).LES_URAD_nazev);
    PolyLine([Point(X1   ,Y2),
              Point(X2   ,Y2),
              Point(X2   ,Y3),
              Point(X1   ,Y3),
              Point(X1   ,Y2)]);
    fillrect(rect(x3,y2,XKon,Y3));
    TextOut(X3+xp,Y2+Yp,'j. ORP');
    x2K:=X3+2*xp+textWidth('j. ORP');

    PolyLine([Point(X3   ,Y2),
              Point(XKon ,Y2),
              Point(XKon ,Y3),
              Point(X3   ,Y3),
              Point(X3   ,Y2)]);
    TextOUTPrelom1(CanvasV,x2k,XKon-xp,Y2+Yp,Y3,naPravo,VMajitel.Majetky.CjOU_C);

    PolyLine([Point(X1   ,Y4),
              Point(XKon ,Y4),
              Point(XKon ,Y7),
              Point(X1   ,Y7),
              Point(X1   ,Y4)]);

   if not(FWieSep.query1.eof) then
    begin
     case dleKoho of
      dleGregora:
       begin
        FWieSep.query1.first;
        SS:=' ';
        while not (FWieSep.query1.eof) do
         begin
          SSp:=FWieSep.query1.fieldbyname('KATUZE_KOD').asstring+' - '+ FWieSep.query1.fieldbyname('KATUZE_NAZ').asstring+' ';
          if pos(SSp,ss)=0 then ss:=SS+SSp;
          FWieSep.query1.next;
         end;
        katastrGreg:=SS;

        FWieSep.query1.first;
        SS:=' ';
        while not (FWieSep.query1.eof) do
         begin
          SSp:=' '+FWieSep.query1.fieldbyname('LV').asstring+' ';
          if pos(SSp,ss)=0 then ss:=SS+SSp;
          FWieSep.query1.next;
         end;
        LVGreg:=SS;
        TextOut(X1+xp,Y4+Yp,'Katastr :'+katastrGreg
                           +'   LV: '+LVGreg);

        FWieSep.query1.first;
        SS:=' ';
        while not (FWieSep.query1.eof) do
         begin
          SSp:=' '+FWieSep.query1.fieldbyname('PARCELA').asstring+' ';
          if ubm(FWieSep.query1.fieldbyname('PARCELA_PK').asstring)<>'' then
           begin
            SSp:=SSp+'(PK:'+FWieSep.query1.fieldbyname('PARCELA_PK').asstring+'/'+FWieSep.query1.fieldbyname('PODLOM_PK').asstring+') ';
           end;
          if pos(SSp,ss)=0 then ss:=SS+SSp;
          FWieSep.query1.next;
         end;
        parCisParPodGreg:=ss;

        {
        FWieSep.query1.first;
        SS:=' ';
        while not (FWieSep.query1.eof) do
         begin
          if ubm(FWieSep.query1.fieldbyname('PARCELA_PK').asstring)<>'' then
           begin
            SSp:=' '+FWieSep.query1.fieldbyname('PARCELA_PK').asstring+'/'+FWieSep.query1.fieldbyname('PODLOM_PK').asstring+' ';
            if pos(SSp,ss)=0 then ss:=SS+SSp;
           end;
          FWieSep.query1.next;
         end;
        PKCisPKPod:=ss;
        if ubm(PKCisPKPod)<>'' then  parCisParPodGreg:=parCisParPodGreg+'@$& PK: '+PKCisPKPod;
        }
        TextOUTPrelom1(CanvasV,x1+xp,xkon-xp,Y4+round(0.6*RADY),y4+3*RADY,nalevo,'Parcela: '+parCisParPodGreg);
        FWieSep.query1.first;
        SS:=' ';
        SS:=VMajitel.majetky.MAJ_NAZ_C + '@$&'; // vloeno pro skle 22.6. 2012
        while not (FWieSep.query1.eof) do
         begin
          // SSp:= FWieSep.query1.fieldbyname('SUBJEKT').asstring; // smazno pro skle 22.6. 2012
          SSp:='';    // vloeno pro skle 22.6. 2012
          if (ubm(FWieSep.query1.fieldbyname('PODIL_CITA').asstring)<>'')or (ubm(FWieSep.query1.fieldbyname('PODIL_JMEN').asstring)<>'') then
           begin
            SSp:= FWieSep.query1.fieldbyname('SUBJEKT').asstring; // vloeno pro skle 22.6. 2012
            SSp:= SSp + '    '+FWieSep.query1.fieldbyname('PODIL_CITA').asstring+'/'+FWieSep.query1.fieldbyname('PODIL_JMEN').asstring+'@$&';
           end
          else
           begin
            SSp:= SSp + '@$&';
           end;
          if pos(SSp,ss)=0 then ss:=SS+SSp;
          FWieSep.query1.next;
         end;
        TextOUTPrelom1(CanvasV,x1+xp,xkon-xp,Y4+3*RADY,y7,nalevo,ss);
       end;
      dleVitkovice:
       begin
        if (VMajitel.majetky.JmePrijm_C='') and (VMajitel.majetky.MAJ_NAZ_C<>'') then
         begin
          TextOut(X1+xp,Y4+Yp,VMajitel.majetky.MAJ_NAZ_C);
         end
        else
         begin
          TextOut(X1+xp,Y4+Yp,VMajitel.majetky.JmePrijm_C);
         end;
        pradY:=1;
        while not (FWieSep.query1.eof) do
         begin
          inc(PRadY);
          TextOut(X1+xp,Y4+Yp+round(PRadY*radY*0.6),'Katastr :'+FWieSep.query1.fieldbyname('CKAT_KN').asstring+' - '+FWieSep.query1.fieldbyname('KATASTR').asstring
                                   +'   LV: '+FWieSep.query1.fieldbyname('LV').asstring
                                   +'  Par.s.: '+FWieSep.query1.fieldbyname('PARCIS').asstring+'  '
                                   +'  Par.podl.: '+ FWieSep.query1.fieldbyname('PARPOD').asstring+' ');
          FWieSep.query1.next;
         end;
       end;
     dleDvoraka:
       begin
        TextOut(X1+xp,Y4+Yp,'Katastr :'+FWieSep.query1.fieldbyname('CKAT_KN').asstring+' - '+FWieSep.query1.fieldbyname('KATASTR').asstring
                                   +'   LV: '+FWieSep.query1.fieldbyname('LV').asstring);
        FWieSep.query1.first;
        SS:=' ';
        while not (FWieSep.query1.eof) do
         begin
          SSp:=FWieSep.query1.fieldbyname('PARCIS').asstring+'/'+ FWieSep.query1.fieldbyname('PARPOD').asstring+' ';
          if pos(SSp,ss)=0 then ss:=SS+SSp;
          FWieSep.query1.next;
         end;
        TextOUTPrelom1(CanvasV,x1+xp,xkon-xp,Y4+round(0.6*RADY),y4+3*RADY,nalevo,ss);
        FWieSep.query1.first;
        SS:=' ';
        while not (FWieSep.query1.eof) do
         begin
          SSp:= FWieSep.query1.fieldbyname('JMENO').asstring+'    '+FWieSep.query1.fieldbyname('PODIL_1').asstring+'/'+FWieSep.query1.fieldbyname('PODIL_2').asstring+'@$&';
          if pos(SSp,ss)=0 then ss:=SS+SSp;
          FWieSep.query1.next;
         end;
        TextOUTPrelom1(CanvasV,x1+xp,xkon-xp,Y4+3*RADY,y7,nalevo,ss);
       end;
     dleMrazka:
       begin
       {
        if (VMajitel.majetky.JmePrijm_C='') and (VMajitel.majetky.MAJ_NAZ_C<>'') then
         begin
          TextOut(X1+xp,Y4+Yp,VMajitel.majetky.MAJ_NAZ_C);
         end
        else
         begin
          TextOut(X1+xp,Y4+Yp,VMajitel.majetky.JmePrijm_C);
         end;
        pradY:=1;
        }
        if (VMajitel.majetky.JmePrijm_C='') and (VMajitel.majetky.MAJ_NAZ_C<>'') then
         begin
          SS:=VMajitel.majetky.MAJ_NAZ_C;
         end
        else
         begin
          SS:=VMajitel.majetky.JmePrijm_C;
         end;
        TextOUTPrelom1(CanvasV,x1+xp,xkon-xp,Y4+yp,Y4+round(1.2*RADY),nalevo,ss);

        TextOut(X1+xp,Y4+round(1.2*RADY),'Katastr :'+FWieSep.query1.fieldbyname('KATUZE_KOD').asstring //+' - '+FWieSep.query1.fieldbyname('KATASTR').asstring
                                   +'   LV: '+FWieSep.query1.fieldbyname('LV').asstring);
        FWieSep.query1.first;
        SS:='Par.s.: ';
        while not (FWieSep.query1.eof) do
         begin
          SSp:=FWieSep.query1.fieldbyname('PARCIS').asstring+'/'+ FWieSep.query1.fieldbyname('PARPOD').asstring+' ';
          if pos(SSp,ss)=0 then ss:=SS+SSp;
          FWieSep.query1.next;
         end;
        TextOUTPrelom1(CanvasV,x1+xp,xkon-xp,Y4+round(1.8*RADY),y4+5*RADY,nalevo,ss);
//        TextOUTPrelom1(CanvasV,x1+xp,xkon-xp,Y4+round(0.6*RADY),y4+3*RADY,nalevo,ss);
        {
        FWieSep.query1.first;
        SS:=' ';
        while not (FWieSep.query1.eof) do
         begin
          SSp:= FWieSep.query1.fieldbyname('JMENO').asstring+'    '+FWieSep.query1.fieldbyname('PODIL_1').asstring+'/'+FWieSep.query1.fieldbyname('PODIL_2').asstring+'@$&';
          if pos(SSp,ss)=0 then ss:=SS+SSp;
          FWieSep.query1.next;
         end;
        TextOUTPrelom1(CanvasV,x1+xp,xkon-xp,Y4+3*RADY,y7,nalevo,ss);  }
       end;
     end;
    end;
    {
    fillrect(rect(x1,y4,X4,Y5));
    TextOut(X1+xp,Y4+Yp,'Rodn slo fyzick osoby');
    Y4i:=Y4+2*YP+textheight('Rodn slo fyzick osoby');
    // TextOutS(CanvasV,X1,X4,Y4+RADY,VMajitel.Majetky.RodneCis_C);
    TextOUTPrelom1(CanvasV,x1+xp,x4-xp,Y4+RADY,y5,uprostred,VMajitel.majetky.RodneCis_C);
    PolyLine([Point(X1   ,Y4),
              Point(X4   ,Y4),
              Point(X4   ,Y5),
              Point(X1   ,Y5),
              Point(X1   ,Y4)]);
    }
    {
    fillrect(rect(x5,y4,X6,Y5));
    TextOut(X5+xp,Y4+Yp,'Pjmen, jmno, titul fyzick osoby');
    if (VMajitel.majetky.JmePrijm_C='') and (VMajitel.majetky.MAJ_NAZ_C<>'') then
     begin
      TextOUTPrelom1(CanvasV,x5+xp,x6-xp,Y4+RADY,y5,uprostred,VMajitel.majetky.MAJ_NAZ_C);
     end
    else
     begin
      TextOUTPrelom1(CanvasV,x5+xp,x6-xp,Y4+RADY,y5,uprostred,VMajitel.majetky.JmePrijm_C);
     end;
    PolyLine([Point(X5   ,Y4),
              Point(X6   ,Y4),
              Point(X6   ,Y5),
              Point(X5   ,Y5),
              Point(X5   ,Y4)]);
    }
    {
    fillrect(rect(x7,y4,XKon,Y5));
    TextOut(X7+xp,Y4+Yp,'IO prvnick osoby');
    // TextOutS(CanvasV,X7,XKon,Y4+RADY,VMajitel.majetky.ICO_C);
    TextOUTPrelom1(CanvasV,x7+xp,xKon-xp,Y4+RADY,y5,uprostred,VMajitel.majetky.ICO_C);
    PolyLine([Point(X7   ,Y4),
              Point(XKon ,Y4),
              Point(XKon ,Y5),
              Point(X7   ,Y5),
              Point(X7   ,Y4)]);

    }
    {
    fillrect(rect(x1,y6,x8,y7));
    TextOut(X1+xp,Y6+Yp,'Obchodn jmno prvnick osoby');
    Y4i:=Y6+2*YP+textheight('Obchodn jmno prvnick osoby');
    TextOUTPrelom1(CanvasV,x1+xp,x8-xp,Y6+RADY,y7,uprostred,VMajitel.majetky.ObchodJm_C);
    // TextOutS(CanvasV,X1,X8,Y6+RADY,VMajitel.majetky.ObchodJm_C);
    PolyLine([Point(X1   ,Y6),
              Point(X8   ,Y6),
              Point(X8   ,Y7),
              Point(X1   ,Y7),
              Point(X1   ,Y6)]);

    fillrect(rect(x9,y6,xKon,y7));
    TextOut(X9+xp,Y6+Yp,'Pjmen, jmno, titul zstupce prvnick osoby');
    TextOUTPrelom1(CanvasV,x9+xp,xKon-xp,Y6+RADY,y7,uprostred,VMajitel.majetky.Zastupce_C);
    // TextOutS(CanvasV,X9,XKon,Y6+RADY,VMajitel.majetky.Zastupce_C);
    PolyLine([Point(X9   ,Y6),
              Point(XKon ,Y6),
              Point(XKon ,Y7),
              Point(X9   ,Y7),
              Point(X9   ,Y6)]);
   }
   if adresaNeniSoucastiJmena
   then
    begin
     fillrect(rect(x1,y8,XKon,Y9));
     TextOut(X1+xp,Y8+Yp,'PS');
     TextOut(X10+xp,Y8+Yp,'Obec');
     TextOut(X11+xp,Y8+Yp,'Ulice');
     TextOut(X12+xp,Y8+Yp,'.domu');

     // TextOutS(CanvasV,X1,X10,Y8+RADY,s0(intToStr(VMajitel.majetky.PSC_C)));
     TextOUTPrelom1(CanvasV,x1+xp,x10-xp,Y8+RADY,y9-Yp,uprostred,VMajitel.majetky.PSC_txt_C);
     // TextOutS(CanvasV,X10,X11,Y8+RADY,VMajitel.majetky.AdrObec_C);
     TextOUTPrelom1(CanvasV,x10+xp,x11-xp,Y8+RADY,y9-Yp,uprostred,VMajitel.majetky.AdrObec_C);
     // TextOutS(CanvasV,X11,X12,Y8+RADY,VMajitel.majetky.AdrUlice_C);
     TextOUTPrelom1(CanvasV,x11+xp,x12-xp,Y8+RADY,y9-Yp,uprostred,VMajitel.majetky.AdrUlice_C);
     // TextOutS(CanvasV,X12,XKon,Y8+RADY,VMajitel.majetky.AdrCDomu_C);
     TextOUTPrelom1(CanvasV,x12+xp,xKon-xp,Y8+RADY,y9-Yp,uprostred,VMajitel.majetky.AdrCDomu_C);

     PolyLine([Point(X1   ,Y8),
               Point(XKon ,Y8),
               Point(XKon ,Y9),
               Point(X1   ,Y9),
               Point(X1   ,Y8)]);
     PolyLine([Point(X10   ,Y8),
               Point(X10   ,Y9)]);
     PolyLine([Point(X11   ,Y8),
               Point(X11   ,Y9)]);
     PolyLine([Point(X12   ,Y8),
               Point(X12   ,Y9)]);
    end;
    fillrect(rect(x1,y10,XKon,Y11));
    TextOut(X1+xp,Y10+Yp,'Pjmen, jmno, titul');
    x2K:=X1+2*xp+textWidth('Pjmen, jmno, titul');
    TextOUTPrelom1(CanvasV,x2K,xKon-xp,Y10+yP,y11-Yp,uprostred,VMajitel.majetky.JmePrijmZpln_C);
    PolyLine([Point(X1   ,Y10),
              Point(XKon ,Y10),
              Point(XKon ,Y11),
              Point(X1   ,Y11),
              Point(X1   ,Y10)]);

    fillrect(rect(x1,y12,XKon,Y14));

    TextOut(X1+xp,Y12+Yp ,'PS');
    x2K:=X1+2*xp+textWidth('PS');
    TextOUTPrelom1(CanvasV,x2K,x10-xp,Y12+yP,y13-Yp,naPravo,s0(VMajitel.majetky.PSCZpln_C));

    TextOut(X10+xp,Y12+Yp,'Obec');
    x2K:=X10+2*xp+textWidth('Obec');
    TextOUTPrelom1(CanvasV,x2K,x11-xp,Y12+yP,y13-Yp,naPravo,VMajitel.majetky.ObecZpln_C);

    TextOut(X11+xp,Y12+Yp,'Ulice');
    x2K:=X11+2*xp+textWidth('Ulice');
    TextOUTPrelom1(CanvasV,x2K,x12-xp,Y12+yP,y13-Yp,naPravo,VMajitel.majetky.UliceZpln_C);

    TextOut(X12+xp,Y12+Yp,'.domu');
    x2K:=X12+2*xp+textWidth('.domu');
    TextOUTPrelom1(CanvasV,x2K,xKon-xp,Y12+yP,y13-Yp,naPravo,VMajitel.majetky.CDomuZpln_C);

    TextOut(X1+xp,Y13+Yp ,'E_mail');
    x2K:=X1+2*xp+textWidth('E_mail');
    TextOUTPrelom1(CanvasV,x2K,x10-xp,Y13+yP,y14-Yp,naPravo,VMajitel.majetky.EMailZpln_C);

    TextOut(X10+xp,Y13+Yp,'Telefon');
    x2K:=X10+2*xp+textWidth('Telefon');
    TextOUTPrelom1(CanvasV,x2K,x11-xp,Y13+yP,y14-Yp,naPravo,VMajitel.majetky.TelefonZpln_C);

    TextOut(X11+xp,Y13+Yp,'Fax');
    x2K:=X11+2*xp+textWidth('Fax');
    TextOUTPrelom1(CanvasV,x2K,x12-xp,Y13+yP,y14-Yp,naPravo,VMajitel.majetky.FaxZpln_C);

    PolyLine([Point(X1   ,Y12),
              Point(XKon ,Y12),
              Point(XKon ,Y14),
              Point(X1   ,Y14),
              Point(X1   ,Y12)]);
    PolyLine([Point(X10   ,Y12),
              Point(X10   ,Y14)]);
    PolyLine([Point(X11   ,Y12),
              Point(X11   ,Y14)]);
    PolyLine([Point(X12   ,Y12),
              Point(X12   ,Y14)]);
    PolyLine([Point(X1    ,Y13),
              Point(X12   ,Y13)]);

    fillrect(rect(x1,y15,XKon,Y18));

    TextOut(X1+xp,Y15+Yp,'.LV');
    x2K:=X1+2*xp+textWidth('.LV');
    TextOUTPrelom1(CanvasV,x2K,x13-xp,Y15+yP,y16-Yp,naPravo,VMajitel.majetky.LV_C);
    // TextOutP(CanvasV,X13,Y15+Yp,VMajitel.majetky.LV_C);

    TextOut(X13+xp,Y15+Yp,'Obec');
    x2K:=X13+2*xp+textWidth('Obec');
    TextOUTPrelom1(CanvasV,x2K,x14-xp,Y15+yP,y16-Yp,naPravo,VMajitel.majetky.Obec_C);
    // TextOutP(CanvasV,X14,Y15+Yp,VMajitel.majetky.Obec_C);

    TextOut(X14+xp,Y15+Yp,'Katastrln zem');
    SeznamCisKatastru:=VMajitel.seznamHodnotTypu('KU_KOD');
    Y15Kat:=Y15;
    with SeznamCiskatastru do
     begin
      radyKat:=round((y18 - y15)/(count+1));
      for I:=0 to count-1 do
       begin
        Y15Kat:=Y15Kat+RADYKat;
        textOut(x11+xp,Y15Kat,elements[i].name);
      //  TextOutP(CanvasV,xKon-xp,Y15Kat,
      //     DleCiselniku(Vmajitel.Ciselnik.tb_Katastry,'Kod',
      //                        elements[i].name,'POPIS',false));
       end;
     end;
    TextOut(X1+xp,Y16+Yp,'Platnost od ');
    TextOut(X14a,Y16+Yp,VMajitel.OwnerLHC.LHP_OD);
    TextOut(X14b,Y16+Yp,'do');
    TextOut(X14c,Y16+Yp,VMajitel.OwnerLHC.LHP_DO);
    TextOut(X1+xp,Y17+Yp,'Vmra pozemk urench k plnn funkc lesa v ha ');
    TextOutP(CanvasV,X11-xp,Y17+Yp,floatTOStrf(Vmajitel.PlochaPUPFL,ffFixed,6,2));
    TextOut(X1+xp,Y17a+Yp,'  z toho lesn pozemky v ha ');
    TextOutP(CanvasV,X11-xp,Y17a+Yp,floatTOStrf(Vmajitel.PlochaLesnichPozemku,ffFixed,6,2));
    PolyLine([Point(X1   ,Y15),
              Point(XKon ,Y15),
              Point(XKon ,Y18),
              Point(X1   ,Y18),
              Point(X1   ,Y15)]);
    PolyLine([Point(X13   ,Y15),
              Point(X13   ,Y16)]);
    PolyLine([Point(X1    ,Y16),
              Point(X14  ,Y16)]);
    PolyLine([Point(X1    ,Y17),
              Point(X14  ,Y17)]);
    PolyLine([Point(X1    ,Y17a),
              Point(X14  ,Y17a)]);
    PolyLine([Point(X14  ,Y15),
              Point(X14  ,Y18)]);
    fillrect(rect(x1,y19,XKon,Y20));
    if (VMajitel.MAJ_DRUH=4) and (VychDo40=ano) then
     begin
      rry:=((y20-Y19) div 4);
      TextOut(X1+xp,Y19+  rry-(textHeight('Mini') div 2),'Celkov ve');
      TextOut(X1+xp,Y19+3*rry-(textHeight('Mini') div 2),'teb v m3 b.k.');
      if Vmajitel.majetky.TEZB_MAX_C>0.5 then
       begin
        X15:=X1+2*xp+textWidth('teb v m3 b.k. m'+'     '+inttoStr(Vmajitel.majetky.TEZB_MAX_C));
        TextOutP(CanvasV,X15-xp,Y19+2*Yp,inttoStr(Vmajitel.majetky.TEZB_MAX_C));
       end
      else
       begin
        X15:=X1+2*xp+textWidth('teb v m3 b.k. v'+'     '+inttoStr(Vmajitel.majetky.TEZB_VYP_C));
        TextOutP(CanvasV,X15-xp,Y19+2*Yp,inttoStr(Vmajitel.majetky.TEZB_VYP_C));
       end;
      TextOut(X15+xp,Y19+rry-(textHeight('Mini') div 2),'Minimln podl melioranch a ');
      TextOut(X15+xp,Y19+3*rry-(textHeight('Mini') div 2),'zpevujcch devin pi obnov porostu ');
      rrx:=X15+2*xp+textWidth('zpevujcch devin pi obnov porostu ');
      TextOut(rrX+xp,Y19+rry-(textHeight('Mini') div 2)  ,'Plocha vchovy');
      TextOut(rrX+xp,Y19+3*rry-(textHeight('Mini') div 2),'do 40 let v ha');
      TextOutP(CanvasV,XKon-xp,Y19+2*Yp,floatTOStrf(Vmajitel.VychovaDo40let,ffFixed,6,2));
      PolyLine([Point(x15,Y19),
                Point(x15,Y20)]);
      PolyLine([Point(rrx ,Y19),
                Point(rrx ,Y20)]);
     end
    else
     begin
      if Vmajitel.majetky.TEZB_MAX_C>0.5 then
       begin
        TextOut (X1+xp,Y19+Yp,'Celkov ve teb v m3 b.k. m');
        TextOutP(CanvasV,X15-xp,Y19+Yp,inttoStr(Vmajitel.majetky.TEZB_MAX_C));
       end
      else
       begin
        TextOut (X1+xp,Y19+Yp,'Celkov ve teb v m3 b.k. v');
        TextOutP(CanvasV,X15-xp,Y19+Yp,inttoStr(Vmajitel.majetky.TEZB_VYP_C));
       end;
      if Vmajitel.PlochaPUPFL>2.999 then
       begin
        TextOut(X15+xp,Y19+Yp,'Minimln podl melioranch a zpevujcch devin pi obnov porostu ');
       end;
      PolyLine([Point(X15  ,Y19),
                Point(X15  ,Y20)]);
     end;
    PolyLine([Point(X1   ,Y19),
              Point(XKon ,Y19),
              Point(XKon ,Y20),
              Point(X1   ,Y20),
              Point(X1   ,Y19)]);

    fillrect(rect(x1,y21,XKon,Y25));
    TextOut(X1+xp,Y21+Yp,'Vpis podrobnch daj pro porosty,porostn skupiny a ete');
    TextOut(X1+xp,Y22+Yp,'st plochov tabulky');
    TextOut(X1+xp,Y23+Yp,'st lesnick mapy');
    if (RamcSmer=ano) then
    begin
     TextOut(X1+xp,Y24+Yp,'st rmcovch smrnic hospodaen');
     TextOut(X1+xp+textWidth('st rmcovch smrnic hospodaen'),Y24+(Yp div 2),'3)');
    end;
    TextOut(X16+xp,Y21+Yp,'s.maj.: '+VMajitel.majetky.MAJ_KOD_C);
    NaskladejTextDoRamecku(CanvasV,X16+xp,Y22,Xkon-xp,Y24,VMajitel.majetky.ostatni_C);
    PolyLine([Point(X1   ,Y21),
              Point(XKon ,Y21),
              Point(XKon ,Y25),
              Point(X1   ,Y25),
              Point(X1   ,Y21)]);
    PolyLine([Point(X16  ,Y21),
              Point(X16  ,Y25)]);
    PolyLine([Point(X1   ,Y22),
              Point(X16  ,Y22)]);
    PolyLine([Point(X1   ,Y23),
              Point(X16  ,Y23)]);
    PolyLine([Point(X1   ,Y24),
              Point(X16  ,Y24)]);
    PolyLine([Point(X1   ,Y25),
              Point(X16  ,Y25)]);
    FONT.NAME:='Arial CE';
    Font.Size:=FSD-1;
    Font.Style:=[];
    font.Charset:=238;
    TextOUTPrelom(CanvasV,X1,xKon,Y25+Yp,y26+Yp,false,naLevo,
                  'Pouen:(25 odst.3 zk..289/1995 Sb.) Pro vlastnka lesa o vme vt ne 3 ha, kter m zjem vyut osnovu pro '+
                  'hospodaen v lese a protokolem o pevzet ji pevezme,stv se zvaznou celkov ve teb, kter je nepekroiteln a '+
                  'podl melioranch a zpevujcch devin pi obnov porost. Pro vlastnka lesa o vme do 3 ha, kter osnovu protokolem '+
                  'pevezme, se stv zvaznou celkov ve teb, kter je nepekroiteln.'+
                  'daje LHO byly poskytnuty za podmnky vylouen jejich komernho vyuit, a to bezplatn.');
    FONT.NAME:='Arial CE';
    Font.Size:=FSD;
    Font.Style:=[];
    font.Charset:=238;
    fillrect(rect(x1,y26,X17,Y27));
    TextOut (X1+xp,Y26+Yp,'V');
    x2K:=X1+2*xp+textWidth('V');
    TextOUTPrelom1(CanvasV,x2K,x17-xp,Y26+yP,y27-Yp,Uprostred,VMajitel.majetky.VPred_C);
    PolyLine([Point(X1   ,Y26),
              Point(X17 ,Y26),
              Point(X17 ,Y27),
              Point(X1   ,Y27),
              Point(X1   ,Y26)]);

    fillrect(rect(x18,y26,X19,Y27));
    TextOut (X18+xp,Y26+Yp,'Dne');
    x2K:=X18+2*xp+textWidth('Dne');
    TextOUTPrelom1(CanvasV,x2K,x19-xp,Y26+yP,y27-Yp,Uprostred,VMajitel.majetky.DnePred_C);
    PolyLine([Point(X18  ,Y26),
              Point(X19  ,Y26),
              Point(X19  ,Y27),
              Point(X18  ,Y27),
              Point(X18  ,Y26)]);

    fillrect(rect(x20,y26,XKon,Y27));
    TextOut (X20+xp,Y26+Yp,'Poet ploh');
    x2K:=X20+2*xp+textWidth('Poet ploh');
    TextOUTPrelom1(CanvasV,x2K,xKon-xp,Y26+yP,y27-Yp,Uprostred,VMajitel.majetky.PrilohyPred_C);
    PolyLine([Point(X20   ,Y26),
              Point(XKon  ,Y26),
              Point(XKon  ,Y27),
              Point(X20   ,Y27),
              Point(X20   ,Y26)]);

    fillrect(rect(x1,y28,X21,Y29));
    TextOut (X1+xp,Y28+Yp,'Podpis vlastnka lesa nebo zplnomocnn osoby');
    PolyLine([Point(X1   ,Y28),
              Point(X21  ,Y28),
              Point(X21  ,Y29),
              Point(X1   ,Y29),
              Point(X1   ,Y28)]);

    fillrect(rect(x22,y28,XKon,Y29));
    TextOut (X22+xp,Y28+Yp,'Pjmen,jmno,titul a podpis zstupce obce');
    TextOUTPrelom1(CanvasV,X22+xp,xKon-xp,Y28+RADY,y29-Yp,NaLevo,VMajitel.majetky.ZastOU_C);
    PolyLine([Point(X22   ,Y28),
              Point(XKon  ,Y28),
              Point(XKon  ,Y29),
              Point(X22   ,Y29),
              Point(X22   ,Y28)]);

    fillrect(rect(x1,y30,X21,Y31));
    TextOut (X1+xp,Y30+Yp,'Raztko vlastnka lesa(u prvnick osoby vdy)');
    PolyLine([Point(X1   ,Y30),
              Point(X21  ,Y30),
              Point(X21  ,Y31),
              Point(X1   ,Y31),
              Point(X1   ,Y30)]);
    fillrect(rect(x22,y30,XKon,Y31));
    TextOut (X22+xp,Y30+Yp,'Raztko obce poven sprvou');
    PolyLine([Point(X22  ,Y30),
              Point(XKon ,Y30),
              Point(XKon ,Y31),
              Point(X22  ,Y31),
              Point(X22  ,Y30)]);
   end;
 end;
end.
