unit UVySep98;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DBIPROCS,
  E_LesCel,mat1,
  DB, DBTables, Grids, DBGrids;

type
  TFVybSep97 = class(TForm)
    ButObnov: TButton;
    ButZobr: TButton;
    TbMajPor: TTable;
    DTZ_MajPor: TDataSource;
    DB_MajPor: TDBGrid;
    DB_Q_SepMajODD: TDBGrid;
    Q_SepMajOdd: TQuery;
    DTZ_QSepMajOdd: TDataSource;
    DTZ_SepMaj: TDataSource;
    DB_SEPMAj: TDBGrid;
    ButTiskni: TButton;
    chTiskPor: TCheckBox;
    TbSepMaj: TTable;
    ButTiskSep: TButton;
    ButZobrSep: TButton;
    ButTbCis: TButton;
    ButTiskSepPloch: TButton;
    ButTiskVsech: TButton;
    Button2: TButton;
    ButTiskSum: TButton;
    ButVypVse: TButton;
    ButNavrat: TButton;
    EditProcMax: TEdit;
    Label1: TLabel;
    ButVYpMax: TButton;
    procedure ButObnovClick(Sender: TObject);
    procedure ButTiskniClick(Sender: TObject);
    procedure ButZobrSepClick(Sender: TObject);
    procedure ButTiskSepClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure VytvorNeboObnov;
    procedure PlochovkaMajiteleNaTiskarnu;
    procedure ButTiskSepPlochClick(Sender: TObject);
    procedure ButTbCisClick(Sender: TObject);
    procedure ButTiskVsechClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ButTiskSumClick(Sender: TObject);
    procedure ButVypVseClick(Sender: TObject);
    procedure ButNavratClick(Sender: TObject);
    procedure ButVYpMaxClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    lesniCelek:TLesniCelek;
    procedure NactiMajitelePodleQ_SepMajOdd;
  end;

var
  FVybSep97: TFVybSep97;

implementation

{$R *.DFM}
uses
 printers,
 Sp_Ovr,Dotaz,
 Elements,
 E_LesOdd, DTB_Les,I_LhcStd, lesRecur,
 UVybPT,PtCanvas,SeCanvas,
 UVybHkPt{!};

procedure ZobrazSeparatDoImage(VMajitel:TMajitel);
var mxi,myi:integer;
begin
with FSeCanvas do
 begin
 mxi:=round(screen.width*1.5);
 myi:=round(screen.height*1.5);
 Image1.picture.bitmap.Width:=image1.width;
 Image1.picture.bitmap.height:=image1.height;
 {Image1.picture.bitmap.canvas.fillrect(
         rect(0,0,image1.width,image1.height)); }
 tiskSeparatu(VMajitel,Image1.picture.bitmap.canvas,MXi,MYi,false);
 image1.refresh;
 showmodal;
 end;
end;
procedure SeparatNaTiskarnu(VMajitel:TMajitel);
var PXI,PYI:integer;
begin
 with FSeCanvas do
  begin
   with printer do
    begin
     pxi:=round(printer.PageHeight);
     pyi:=round(printer.PageWidth);
     if not printing then
      begin
       { Orientation := poLandscape; }
       beginDoc;
      end;
     tiskSeparatu(VMajitel,canvas,pXi,pYi,True);
     enddoc;
    end;
  end;
end;
procedure TFVybSep97.VytvorNeboObnov;
 var VOdd: TOddeleni;
        i: Integer;
   vybMaj: TVyberMajitele;
begin
 Q_sepMajOdd.close;
 DB_MajPor.dataSource:=nil;
 DB_SepMaj.dataSource:=nil;
  with TbMajPor do
   begin
      close;
      TableName:='TBMajPor.DB';
      TableType:=ttParadox;
      Exclusive:=true;
      with FieldDefs do
       begin
        clear;
        Add('MAJ_DRUH', ftInteger, 0, false);
        Add('MAJ_KOD' , ftInteger, 0, false);
        Add('ODD'     , ftInteger, 0, false);
        Add('DIL'     , ftString,  1, false);
        Add('POR'     , ftString,  1, false);
        Add('JP'      , ftInteger, 0, false);
        Add('KU_KOD'  , ftInteger, 0, false);
       end;
      createTable;
      addindex('Ca','MAJ_DRUH;MAJ_KOD;ODD;DIL;POR;JP;KU_KOD',[ixprimary]);
      exclusive:=false;
      open;
     end; {Width TbMajPor}
  with TbSepMaj do
   begin
      close;
      TableName:='TBSepMaj.DB';
      TableType:=ttParadox;
      Exclusive:=true;
      try
      open;
      except
       with FieldDefs do
        begin
         clear;
         Add('MAJ_DRUH', ftInteger, 0, false);
         Add('MAJ_KOD' , ftInteger, 0, false);
         Add('LV'      , ftInteger, 0, false);
         Add('TEZB_VYP'     , ftInteger, 0, false);
         Add('TEZB_MAX'     , ftInteger, 0, false);
         Add('LesniPoz'     , ftFloat,   0, false);
         Add('JinePoz'      , ftFloat,   0, false);
         Add('RodneCis'     , ftString, 14, false);
         Add('JmePrijm'     , ftString, 30, false);
         Add('ICO'          , ftString, 14, false);
         Add('ObchodJm'     , ftString, 30, false);
         Add('Zastupce'     , ftString, 30, false);
         Add('PSC'          , ftInteger, 0, false);
         Add('AdrObec'      , ftString, 15, false);
         Add('AdrUlice'     , ftString, 15, false);
         Add('AdrCDomu'     , ftString, 10, false);
         Add('Obec'         , ftString, 15, false);
         Add('OSTATNI'      , ftString,100, false);
         Add('KOD'          , ftInteger, 0, false);
         Add('DOPLKOD'      , ftInteger, 0, false);
         Add('CISJEDN'      , ftString, 15, false);
         Add('DATVYDANI'    , ftDate,    0, false);
         Add('UZIVATEL'     , ftString, 30, false);
         Add('ZADATEL'      , ftString, 30, false);
         Add('CISORG'       , ftString, 12, false);
         Add('ODB_SPR'      , ftString, 12, false);
         Add('NAJDATE'      , ftDate,    0, false);
         Add('NAJPLAT'      , ftDate,    0, false);
         Add('CJ_ROZHOD'    , ftString, 15, false);
         Add('NAHRADA'     , ftString, 15, false);
         Add('POZN'        , ftString, 80, false);
         Add('UZIV'        , ftString, 15, false);
         Add('DOHODA'      , ftString, 50, false);
        end;
       createTable;
       addindex('Ca','MAJ_DRUH;MAJ_KOD',[ixprimary]);
       exclusive:=false;
       open;
      end;{except}
    end;{Width TbSepMaj}
   vybMaj:=TVyberMAjitele.create;
   VybMaj.TB_MajetkyPorosty:=TbMajPor;
   VybMaj.TB_MajetkySeparaty:=TbSepMaj;
   With LesniCelek do
    begin
     LOvr.tb_odd.first;
     while not LOvr.tb_odd.eof do
      begin
       NactiOddeleni_db (VOdd,LOvr,nil);
       LHC.OddeleniMN.AddElement(VOdd);
       vybMaj.Input:= VOdd;
       vybMaj.DoIt;
       LOvr.tb_odd.next;
      end;
     LHC.OddeleniMN.AktualniPrvek.free;
    end;
   VybMaj.Free;
   TbSepMaj.close;
   TbMajPor.close;
   DbiSaveChanges(TbSepMaj.handle);
   DbiSaveChanges(TbMajPor.handle);

   DB_SepMaj.dataSource:=DTZ_SepMaj;
 TbSepMaj.open;
 DB_MajPor.dataSource:=DTZ_MajPor;
 TbMajPor.open;
 Q_SepMajOdd.open;
end;
procedure TFVybSep97.ButObnovClick(Sender: TObject);
 begin
  VytvorNeboObnov;
 end;
procedure TFVybSep97.NactiMajitelePodleQ_SepMajOdd;
begin
 Q_SepMajOdd.close;
 Q_SepMajOdd.SQL.Strings[2]:=
        'where ((MAJ_DRUH='+TBSepMaj.fieldByName('MAJ_DRUH').asstring
           +')and(MAJ_KOD='+TBSepMaj.fieldByName('MAJ_KOD').asstring+'))';
 Q_SepMajOdd.Open;
 LesniCelek.NactiMajitele(Q_SepMajOdd);
 NactiPolozkyMajitele(LesniCelek.LHC.Majitel,TBSepMaj);
 UlozPolozkyMajitele (LesniCelek.LHC.Majitel,TBSepMaj);
{with LesniCelek.LHC.Majitel do
  begin
   TBSepMaj.Edit;
   TBSepMaj.fieldByName('LESNIPOZ').asFloat   :=PlochaLesnichPozemku;
   TBSepMaj.fieldByName('JinePoz').asFloat    :=PlochaJinychPozemku;
   TBSepMaj.fieldByName('TEZB_VYP').asInteger :=TezbyCelkem;
   TBSepMaj.Post;
   MAJ_DRUH:=TBSepMaj.fieldByName('MAJ_DRUH').asinteger;
   MAJ_KOD:=TBSepMaj.fieldByName('MAJ_KOD').asInteger;
   LV:=TBSepMaj.fieldByName('LV').asstring;
   TEZB_MAX:=TBSepMaj.fieldByName('TEZB_MAX').asInteger;
   RodneCis:=TBSepMaj.fieldByName('RodneCis').asstring;
   JmePrijm:=TBSepMaj.fieldByName('JmePrijm').asstring;
   ICO:=TBSepMaj.fieldByName('ICO').asString;
   ObchodJm:=TBSepMaj.fieldByName('ObchodJm').asstring;
   Zastupce:=TBSepMaj.fieldByName('Zastupce').asstring;
   PSC:=TBSepMaj.fieldByName('PSC').asinteger;
   AdrObec:=TBSepMaj.fieldByName('AdrObec').asstring;
   AdrUlice:=TBSepMaj.fieldByName('AdrUlice').asstring;
   AdrCDomu:=TBSepMaj.fieldByName('AdrCDomu').asstring;
   Obec:=TBSepMaj.fieldByName('Obec').asstring;
   Ostatni:=TBSepMaj.fieldByName('OSTATNI').asstring;
  end;        }
end;

procedure TFVybSep97.ButTiskniClick(Sender: TObject);
begin
 NactiMajitelePodleQ_SepMajOdd;
 PlochovkaMajiteleNaTiskarnu;
end;
procedure TFVybSep97.PlochovkaMajiteleNaTiskarnu;
var i:Integer;
    strana:Integer;
begin
 with printer do
  begin
   if not printing then
    begin
     Orientation := poLandscape;
     beginDoc;
    end;
  end;
 with LesniCelek.LHC.Majitel.oddeleniMN do
  begin
   strana:=1;
   for i:=0 to count - 1 do
    begin
     OddeleniNaTiskarnu(TOddeleni(elements[i]),strana,0,chTiskPor.checked);
    end;
  end;
 with printer do
  begin
   enddoc;
   Orientation := poPortrait;
  end;
end;
procedure TFVybSep97.ButZobrSepClick(Sender: TObject);
 begin
  NactiMajitelePodleQ_SepMajOdd;
  ZobrazSeparatDoImage(LesniCelek.LHC.Majitel);
 end;

procedure TFVybSep97.ButTiskSepClick(Sender: TObject);
 begin
  NactiMajitelePodleQ_SepMajOdd;
  SeparatNaTiskarnu(LesniCelek.LHC.Majitel);
 end;
procedure TFVybSep97.FormShow(Sender: TObject);
procedure NastavZobrazovani;
 begin
   TbSepMaj.fieldByName('MAJ_DRUH').DisplayLabel:='Druh majetku';
   TbSepMaj.fieldByName('MAJ_DRUH').DisplayWidth:=1;
   TbSepMaj.fieldByName('MAJ_KOD').DisplayLabel:='s.majetku';
   TbSepMaj.fieldByName('MAJ_KOD').DisplayWidth:=6;
   TbSepMaj.fieldByName('LV').DisplayLabel:='.list.vl.';
   TbSepMaj.fieldByName('LV').DisplayWidth:=6;
   TbSepMaj.fieldByName('TEZB_VYP').DisplayLabel:='T.vypoten';
   TbSepMaj.fieldByName('TEZB_MAX').DisplayLabel:='T.maximln';

   TbSepMaj.fieldByName('LesniPoz').DisplayLabel:='Lesn pozemky';
   TFloatfield(TbSepMaj.fieldByName('LesniPoz')).DisplayFormat:='0.00';
   TFloatfield(TbSepMaj.fieldByName('LesniPoz')).EditFormat:='0.00';
   TbSepMaj.fieldByName('LesniPoz').DisplayWidth:=7;
   TFloatfield(TbSepMaj.fieldByName('JinePoz')).DisplayFormat:='0.00';
   TFloatfield(TbSepMaj.fieldByName('JinePoz')).EditFormat:='0.00';
   TbSepMaj.fieldByName('JinePoz').DisplayLabel:='Jin pozemky';
   TbSepMaj.fieldByName('JinePoz').DisplayWidth:=7;
   TbSepMaj.fieldByName('JmePrijm').DisplayLabel:='Jmno,pjmen';
   TbSepMaj.fieldByName('JmePrijm').index:=2;
   TbSepMaj.fieldByName('OSTATNI').DisplayLabel:='Ostatn';
 end;
var vPoradku:Boolean;
 begin
  LesniCelek:=TLesniCelek.create;
  LesniCelek.LOvr:=Ovr;
  LesniCelek.nactiSe_DB;
  try
   vPoradku:=false;
   DB_SepMaj.dataSource:=DTZ_SepMaj;
   TbSepMaj.open;
   nastavZobrazovani;
   {TbSepMaj.fieldByName('MAJ_DRUH').DisplayLabel:='Druh majetku';
   TbSepMaj.fieldByName('MAJ_DRUH').DisplayWidth:=1;
   TbSepMaj.fieldByName('MAJ_KOD').DisplayLabel:='s.majetku';
   TbSepMaj.fieldByName('MAJ_KOD').DisplayWidth:=6;
   TbSepMaj.fieldByName('LV').DisplayLabel:='.list.vl.';
   TbSepMaj.fieldByName('LV').DisplayWidth:=6;
   TbSepMaj.fieldByName('TEZB_VYP').DisplayLabel:='T.vypoten';
   TbSepMaj.fieldByName('TEZB_MAX').DisplayLabel:='T.maximln';

   TbSepMaj.fieldByName('LesniPoz').DisplayLabel:='Lesn pozemky';
   TFloatfield(TbSepMaj.fieldByName('LesniPoz')).DisplayFormat:='0.00';
   TFloatfield(TbSepMaj.fieldByName('LesniPoz')).EditFormat:='0.00';
   TbSepMaj.fieldByName('LesniPoz').DisplayWidth:=7;
   TFloatfield(TbSepMaj.fieldByName('JinePoz')).DisplayFormat:='0.00';
   TFloatfield(TbSepMaj.fieldByName('JinePoz')).EditFormat:='0.00';
   TbSepMaj.fieldByName('JinePoz').DisplayLabel:='Jin pozemky';
   TbSepMaj.fieldByName('JinePoz').DisplayWidth:=7;
   TbSepMaj.fieldByName('JmePrijm').DisplayLabel:='Jmno,pjmen';
   TbSepMaj.fieldByName('JmePrijm').index:=2;
   TbSepMaj.fieldByName('OSTATNI').DisplayLabel:='Ostatn';
   {     Add('RodneCis'     , ftString, 14, false);
         Add('JmePrijm'     , ftString, 30, false);
         Add('ICO'          , ftString, 14, false);
         Add('ObchodJm'     , ftString, 30, false);
         Add('Zastupce'     , ftString, 30, false);
         Add('PSC'          , ftInteger, 0, false);
         Add('AdrObec'      , ftString, 15, false);
         Add('AdrUlice'     , ftString, 15, false);
         Add('AdrCDomu'     , ftInteger, 0, false);
         Add('Obec'         , ftString, 15, false); }
   DB_MajPor.dataSource:=DTZ_MajPor;
   TbMajPor.open;
   Q_SepMajOdd.open;
   vPoradku:=true;
   except
     VytvorNeboObnov;
     nastavZobrazovani;
   end;
 end;

procedure TFVybSep97.ButTiskSepPlochClick(Sender: TObject);
 begin
  NactiMajitelePodleQ_SepMajOdd;
  SeparatNaTiskarnu(LesniCelek.LHC.Majitel);
  PlochovkaMajiteleNaTiskarnu;
 end;

procedure TFVybSep97.ButTbCisClick(Sender: TObject);
var zkontroluj  :boolean;
    DotazF1     :TDotazf1;
begin
 LesniCelek.VytvorPristupKMajiteli('c:\tax97\Poz97\DTA\navrat.dbf','UZIV');
 if lesniCelek.pripojeniMajitele=nil then exit;
 zkontroluj:=false;
 TBSepMaj.first;
  while not TBSepMaj.eof do
   begin
    NactiMajitelePodleQ_SepMajOdd;
    if not zkontroluj then
     begin
      if not ZkontrolujTabulkuAPrvekPodleScriptu
        (LesniCelek.ciselnik.tb_Majetky,LesniCelek.lhc.MajitelMN.MAjitel,
          LesniCelek.pripojeniMajitele.PredpisPripojeniKolonekCiselnikuMajitele.StringListElement)
{       (LesniCelek.pripojeniMajitele.Navraty,LesniCelek.lhc.MajitelMN.MAjitel,
          LesniCelek.pripojeniMajitele.PredpisPripojeniKolonekNavratu.StringListElement) }
      then
       begin
        zkontroluj:=true;
        Application.CreateForm(TDotazf1, DotazF1);
        dotazf1.activecontrol:=dotazf1.CancelBtn;
        dotazf1.label1.caption:='V PHS.INI nen pesn definovno pipojen selnku majitele.';
        dotazf1.label2.caption:='M se pesto natat ?';
        dotazf1.showmodal;
        if dotazf1.odpoved=false then
         begin
          dotazf1.destroy;
          LesniCelek.pripojeniMajitele.navraty.close;
          LesniCelek.pripojeniMajitele.navraty.free;
          LesniCelek.pripojeniMajitele.free;
          LesniCelek.pripojeniMajitele:=Nil;
          exit;
         end;
        dotazf1.destroy;
       end;
     end;
    NactiZTabulkyHodnotyDoPrvkuPodleScriptu
     (LesniCelek.ciselnik.tb_Majetky,LesniCelek.lhc.MajitelMN.MAjitel,
          LesniCelek.pripojeniMajitele.PredpisPripojeniKolonekCiselnikuMajitele.StringListElement);
    UlozPolozkyMajitele (LesniCelek.LHC.Majitel,TBSepMaj);
    TbSepMAj.next;
   end;
  LesniCelek.pripojeniMajitele.navraty.close;
  LesniCelek.pripojeniMajitele.navraty.free;
  LesniCelek.pripojeniMajitele.free;
  LesniCelek.pripojeniMajitele :=Nil;
end;

{ begin
   LesniCelek.VytvorPristupKMajiteli('c:\tax97\Poz97\DTA\navrat.dbf','UZIV');
   if lesniCelek.pripojeniMajitele=nil then showmessage('Nepodailo se.');
  end; }

procedure TFVybSep97.ButTiskVsechClick(Sender: TObject);
 begin
  TBSepMaj.first;
  while not TBSepMaj.eof do
   begin
    NactiMajitelePodleQ_SepMajOdd;
    SeparatNaTiskarnu(LesniCelek.LHC.Majitel);
    PlochovkaMajiteleNaTiskarnu;
    TbSepMAj.next;
   end;
 end;

procedure ZobrazSoucetSeparatuDoImage(VMajitel:TMajitel);
var mxi,myi,strana:integer;
 begin
  with FSeCanvas do
   begin
    strana:=0;
    mxi:=round(screen.width*1.5);
    myi:=round(screen.height*1.5);
    Image1.picture.bitmap.Width:=image1.width;
    Image1.picture.bitmap.height:=image1.height;
    tiskPloTabOddeleni(nil,Strana,0,
                        Image1.picture.bitmap.canvas,MXi,MYi,False,true,
                        VMajitel.oddeleniMN,False);
    image1.refresh;
    showmodal;
   end;
 end;
procedure SeparatKatastruASouctuNaTiskarnu(VMajitel:TMajitel);
var PXI,PYI,strana:integer;
begin
 with FPTCanvas do
  begin
   with printer do
    begin
     if not printing then
      begin
       Orientation := poLandscape;
       beginDoc;
      end;
     pxi:=round(printer.PageWidth);
     pyi:=printer.PageHeight;
     TiskKatastru(VMajitel.oddeleniMN,canvas,pXi,pYi,True);
     tiskPloTabOddeleni(NIL,Strana,0,
                          canvas,
                          pXi,pYi,true,True,VMajitel.oddeleniMN,false);
     enddoc;
     Orientation := poPortrait;
    end;
  end;
end;

procedure ZobrazSeparatKatastruDoImage(VMajitel:TMajitel);
var mxi,myi,strana:integer;
 begin
  with FSeCanvas do
   begin
    strana:=0;
    mxi:=round(screen.width*1.5);
    myi:=round(screen.height*1.5);
    Image1.picture.bitmap.Width:=image1.width;
    Image1.picture.bitmap.height:=image1.height;
    TiskKatastru(VMajitel.oddeleniMN,Image1.picture.bitmap.canvas,MXi,MYi,False);
    { tiskPloTabOddeleni(nil,Strana,0,
                        Image1.picture.bitmap.canvas,MXi,MYi,False,true,
                        VMajitel.oddeleniMN,False);         }
    image1.refresh;
    showmodal;
   end;
 end;
procedure TFVybSep97.Button2Click(Sender: TObject);
 begin
  NactiMajitelePodleQ_SepMajOdd;
  { ZobrazSoucetSeparatuDoImage(LesniCelek.LHC.Majitel); }
  ZobrazSeparatKatastruDoImage(LesniCelek.LHC.Majitel);

 end;

procedure TFVybSep97.ButTiskSumClick(Sender: TObject);
begin
  NactiMajitelePodleQ_SepMajOdd;
  SeparatKatastruASouctuNaTiskarnu(LesniCelek.LHC.Majitel);
end;

procedure TFVybSep97.ButVypVseClick(Sender: TObject);
begin
  TBSepMaj.first;
  while not TBSepMaj.eof do
   begin
    NactiMajitelePodleQ_SepMajOdd;
    TbSepMAj.next;
   end;
end;

procedure TFVybSep97.ButNavratClick(Sender: TObject);
var zkontroluj  :boolean;
    DotazF1     :TDotazf1;
begin
 LesniCelek.VytvorPristupKMajiteli('c:\tax97\Poz97\DTA\navrat.dbf','UZIV');
 if lesniCelek.pripojeniMajitele=nil then exit;
 zkontroluj:=false;
 TBSepMaj.first;
  while not TBSepMaj.eof do
   begin
    NactiMajitelePodleQ_SepMajOdd;
    if not zkontroluj then
     begin
      if not ZkontrolujTabulkuAPrvekPodleScriptu
       (LesniCelek.pripojeniMajitele.Navraty,LesniCelek.lhc.MajitelMN.MAjitel,
          LesniCelek.pripojeniMajitele.PredpisPripojeniKolonekNavratu.StringListElement)
      then
       begin
        zkontroluj:=true;
        Application.CreateForm(TDotazf1, DotazF1);
        dotazf1.activecontrol:=dotazf1.CancelBtn;
        dotazf1.label1.caption:='V PHS.INI nen pesn definovno pipojen Navratu.';
        dotazf1.label2.caption:='M se pesto natat ?';
        dotazf1.showmodal;
        if dotazf1.odpoved=false then
         begin
          dotazf1.destroy;
          LesniCelek.pripojeniMajitele.navraty.close;
          LesniCelek.pripojeniMajitele.navraty.free;
          LesniCelek.pripojeniMajitele.free;
          LesniCelek.pripojeniMajitele:=Nil;
          exit;
         end;
        dotazf1.destroy;
       end;
     end;
    NactiZTabulkyHodnotyDoPrvkuPodleScriptu
     (LesniCelek.pripojeniMajitele.Navraty,LesniCelek.lhc.MajitelMN.MAjitel,
          LesniCelek.pripojeniMajitele.PredpisPripojeniKolonekNavratu.StringListElement);
    UlozPolozkyMajitele (LesniCelek.LHC.Majitel,TBSepMaj);
    TbSepMAj.next;
   end;
  LesniCelek.pripojeniMajitele.navraty.close;
  LesniCelek.pripojeniMajitele.navraty.free;
  LesniCelek.pripojeniMajitele.free;
  LesniCelek.pripojeniMajitele :=Nil;
end;
procedure TFVybSep97.ButVYpMaxClick(Sender: TObject);
var procMax:integer;
 begin
  try
   ProcMax:=strtoint(editProcMax.text);
  except
   showmessage('V kolonce "% zven maximln tby" nen cel slo.');
   exit;
  end;
 TBSepMaj.first;
  while not TBSepMaj.eof do
   begin
    NactiMajitelePodleQ_SepMajOdd;
    LesniCelek.LHC.Majitel.TEZB_MAX:=(LesniCelek.LHC.Majitel.TezbyCelkem*(ProcMax+100))div 100;
    UlozPolozkyMajitele (LesniCelek.LHC.Majitel,TBSepMaj);
    TbSepMAj.next;
   end;
 end;

end.
