unit Uvybsep;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DBIPROCS,
  E_LesCel,ELesObec,mat1,
  DB, DBTables, Grids, DBGrids;

type
  TFVybSep = class(TForm)
    ButObnov: TButton;
    ButZobr: TButton;
    TbMajPor: TTable;
    DTZ_MajPor: TDataSource;
    DB_MajPor: TDBGrid;
    DB_Q_SepMajODD: TDBGrid;
    Q_SepMajOdd: TQuery;
    DTZ_QSepMajOdd: TDataSource;
    DTZ_SepMaj: TDataSource;
    DB_SEPMAj: TDBGrid;
    ButTiskni: TButton;
    chTiskPor: TCheckBox;
    TbSepMaj: TTable;
    ButTiskSep: TButton;
    ButZobrSep: TButton;
    ButTbCis: TButton;
    ButTiskSepPloch: TButton;
    ButTiskVsech: TButton;
    Button2: TButton;
    ButTiskSum: TButton;
    ButVypVse: TButton;
    ButNavrat: TButton;
    EditProcMax: TEdit;
    Label1: TLabel;
    ButVYpMax: TButton;
    ChZavazVychov: TCheckBox;
    ChRamcSmer: TCheckBox;
    procedure ButObnovClick(Sender: TObject);
    procedure ButZobrClick(Sender: TObject);
    procedure ButTiskniClick(Sender: TObject);
    procedure ButZobrSepClick(Sender: TObject);
    procedure ButTiskSepClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure VytvorNeboObnov;
    procedure PlochovkaMajiteleNaTiskarnu;
    procedure ButTiskSepPlochClick(Sender: TObject);
    procedure ButTbCisClick(Sender: TObject);
    procedure ButTiskVsechClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ButTiskSumClick(Sender: TObject);
    procedure ButVypVseClick(Sender: TObject);
    procedure ButNavratClick(Sender: TObject);
    procedure ButVYpMaxClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    lesniCelek:TLesniCelek;
    procedure NactiMajitelePodleQ_SepMajOdd;
  end;

var
  FVybSep: TFVybSep;

implementation

{$R *.DFM}
uses
 printers,
 Sp_Ovr98,Dotaz,
 Elements, E_LesOdd, DTBLes98,I_LhcStd, lesRecur,
 UVybPT,PtCanvRTF,SeCanvas,lesVypoc
 //,UVybHkPt!
 ;

procedure ZobrazSeparatDoImage(VMajitel:TMajitel;VychDo40,RamcSmer:TAnoNeRozhodniSeSam;VColor:TColor);
var mxi,myi:integer;
begin
with FSeCanvas do
 begin
 mxi:=round(screen.width*1.5);
 myi:=round(screen.height*1.5);
 Image1.picture.bitmap.Width:=image1.width;
 Image1.picture.bitmap.height:=image1.height;
 {Image1.picture.bitmap.canvas.fillrect(
         rect(0,0,image1.width,image1.height)); }
 tiskSeparatu(VMajitel,Image1.picture.bitmap.canvas,MXi,MYi,false,VychDo40,RamcSmer,RozhodniSeSam,clyellow,'ARIAL');
 {
procedure tiskSeparatu(VMajitel:TMajitel;CanvasV:TCanvas;merX,MerY:longint;
                                  NaTiskarnu:boolean;
                                  VychDo40,RamcSmer,
                                  NavodNaAdresaNeniSoucastiJmena:TAnoNeRozhodniSeSam;
                                  VColor:TColor);
 }
 image1.refresh;
 showmodal;
 end;
end;
procedure SeparatNaTiskarnu(VMajitel:TMajitel;VychDo40,RamcSmer:TAnoNeRozhodniSeSam;VColor:TColor);
var PXI,PYI:integer;
begin
 with FSeCanvas do
  begin
   with printer do
    begin
     pxi:=round(printer.PageHeight);
     pyi:=round(printer.PageWidth);
     if not printing then
      begin
       { Orientation := poLandscape; }
       beginDoc;
      end;
     tiskSeparatu(VMajitel,canvas,pXi,pYi,True,VychDo40,RamcSmer,RozhodniSeSam,vColor,'ARIAL');
{
procedure tiskSeparatu(VMajitel:TMajitel;CanvasV:TCanvas;merX,MerY:longint;
                                  NaTiskarnu:boolean;
                                  VychDo40,RamcSmer,
                                  NavodNaAdresaNeniSoucastiJmena:TAnoNeRozhodniSeSam;
                                  VColor:TColor);
}
     enddoc;
    end;
  end;
end;
procedure TFVybSep.VytvorNeboObnov;
 var VOdd: TOddeleni;
        i: Integer;
   vybMaj: TVyberMajitele;
   PresunMajiteleZBezlesiDoPorostu: TPresunMajiteleZBezlesiDoPorostu;
begin
 Q_sepMajOdd.close;
 DB_MajPor.dataSource:=nil;
 DB_SepMaj.dataSource:=nil;
  with TbMajPor do
   begin
      close;
      TableName:='TBMajPor.DB';
      TableType:=ttParadox;
      Exclusive:=true;
      with FieldDefs do
       begin
        clear;
        Add('MAJ_DRUH', ftInteger, 0, false);
        Add('MAJ_KOD' , ftInteger, 0, false);
        Add('ODD'     , ftInteger, 0, false);
        Add('DIL'     , ftString,  1, false);
        Add('POR'     , ftString,  1, false);
        Add('JP'      , ftInteger, 0, false);
        Add('KU_KOD'  , ftInteger, 0, false);
       end;
      createTable;
      addindex('AAA','MAJ_DRUH;MAJ_KOD;ODD;DIL;POR;JP;KU_KOD',[ixprimary]);
      exclusive:=false;
      open;
     end; {Width TbMajPor}
  with TbSepMaj do
   begin
      close;
      TableName:='TBSepMaj.DB';
      TableType:=ttParadox;
      Exclusive:=true;
      try
      open;
      except
       with FieldDefs do
        begin
         clear;
         Add('MAJ_DRUH' , ftInteger, 0, false);
         Add('MAJ_KOD'  , ftInteger, 0, false);
         Add('LV'       , ftInteger, 0, false);
         Add('TEZB_VYP' , ftInteger, 0, false);
         Add('TEZB_MAX' , ftInteger, 0, false);
         Add('LesniPoz' , ftFloat,   0, false);
         Add('JinePoz'  , ftFloat,   0, false);
         Add('RodneCis' , ftString, 14, false);
         Add('JmePrijm' , ftString, 30, false);
         Add('ICO'      , ftString, 14, false);
         Add('ObchodJm' , ftString, 30, false);
         Add('Zastupce' , ftString, 30, false);
         Add('PSC'      , ftInteger, 0, false);
         Add('AdrObec'  , ftString, 15, false);
         Add('AdrUlice' , ftString, 15, false);
         Add('AdrCDomu' , ftString, 10, false);
         Add('Obec'     , ftString, 15, false);
         Add('OSTATNI'  , ftString,100, false);
         Add('KOD'      , ftInteger, 0, false);
         Add('DOPLKOD'  , ftInteger, 0, false);
         Add('CISJEDN'  , ftString, 15, false);
         Add('DATVYDANI', ftDate,    0, false);
         Add('UZIVATEL' , ftString, 30, false);
         Add('ZADATEL'  , ftString, 30, false);
         Add('CISORG'   , ftString, 12, false);
         Add('ODB_SPR'  , ftString, 12, false);
         Add('NAJDATE'  , ftDate,    0, false);
         Add('NAJPLAT'  , ftDate,    0, false);
         Add('CJ_ROZHOD', ftString, 15, false);
         Add('NAHRADA'  , ftString, 15, false);
         Add('POZN'     , ftString, 80, false);
         Add('UZIV'     , ftString, 15, false);
         Add('DOHODA'   , ftString, 50, false);
        end;
       createTable;
       addindex('AAA','MAJ_DRUH;MAJ_KOD',[ixprimary]);
       exclusive:=false;
       open;
      end;{except}
    end;{Width TbSepMaj}
   vybMaj:=TVyberMAjitele.create;
   PresunMajiteleZBezlesiDoPorostu:=TPresunMajiteleZBezlesiDoPorostu.create;
   VybMaj.TB_MajetkyPorosty:=TbMajPor;
   VybMaj.TB_MajetkySeparaty:=TbSepMaj;
   With LesniCelek do
    begin
     LOvr98.tb_odd.first;
     while not LOvr98.tb_odd.eof do
      begin
       { showmessage('V tabulce '+LOvr98.tb_odd.fieldByName('Odd').asstring); }
       NactiOddelenidb98 (VOdd,LOvr98,BezBarvy1);
       { showmessage('Po nacteni'+inttostr(VOdd.odd)); }
       LHC.OddeleniMN.AddElement(VOdd);
       { showmessage('Po Add '+inttostr(VOdd.odd));    }
       PresunMajiteleZBezlesiDoPorostu.Input:= VOdd;
       PresunMajiteleZBezlesiDoPorostu.DoIt;
       vybMaj.Input:= VOdd;
       vybMaj.DoIt;
       LOvr98.tb_odd.next;
       { showmessage('Po DoIt '+inttostr(VOdd.odd)); }
      end;
     LHC.OddeleniMN.AktualniPrvek.free;
    end;
   VybMaj.Free;
   TbSepMaj.close;
   TbMajPor.close;
   DbiSaveChanges(TbSepMaj.handle);
   DbiSaveChanges(TbMajPor.handle);

   DB_SepMaj.dataSource:=DTZ_SepMaj;
 TbSepMaj.open;
 DB_MajPor.dataSource:=DTZ_MajPor;
 TbMajPor.open;
 Q_SepMajOdd.open;
end;
procedure TFVybSep.ButObnovClick(Sender: TObject);
 begin
{  Application.CreateForm(TDotazf1, DotazF1);
  dotazf1.activecontrol:=dotazf1.CancelBtn;
  dotazf1.label1.caption:='Mm vytvoit tabulky pln znovu ';
  dotazf1.label2.caption:='';
  dotazf1.showmodal;
  if dotazf1.odpoved=true then
   begin

    dotazf1.destroy;
   end
  else  dotazf1.destroy; }
  VytvorNeboObnov;
 end;
procedure TFVybSep.ButZobrClick(Sender: TObject);
 begin
 end;
{var
 WV: TWorldView;
 begin
  WV:= TWorldView.Create;
  WV.Input:=LesniCelek;
  WV.DoIt;
 end;
}

procedure TFVybSep.NactiMajitelePodleQ_SepMajOdd;
begin
 Q_SepMajOdd.close;
 Q_SepMajOdd.SQL.Strings[2]:=
        'where ((MAJ_DRUH='+TBSepMaj.fieldByName('MAJ_DRUH').asstring
           +')and(MAJ_KOD='+TBSepMaj.fieldByName('MAJ_KOD').asstring+'))';
 Q_SepMajOdd.Open;
 LesniCelek.NactiMajitele(Q_SepMajOdd);
 // NactiPolozkyMajitele(LesniCelek.LHC.Majitel,TBSepMaj);
 // UlozPolozkyMajitele (LesniCelek.LHC.Majitel,TBSepMaj);
{with LesniCelek.LHC.Majitel do
  begin
   TBSepMaj.Edit;
   TBSepMaj.fieldByName('LESNIPOZ').asFloat   :=PlochaLesnichPozemku;
   TBSepMaj.fieldByName('JinePoz').asFloat    :=PlochaJinychPozemku;
   TBSepMaj.fieldByName('TEZB_VYP').asInteger :=TezbyCelkem;
   TBSepMaj.Post;
   MAJ_DRUH:=TBSepMaj.fieldByName('MAJ_DRUH').asinteger;
   MAJ_KOD:=TBSepMaj.fieldByName('MAJ_KOD').asInteger;
   LV:=TBSepMaj.fieldByName('LV').asstring;
   TEZB_MAX:=TBSepMaj.fieldByName('TEZB_MAX').asInteger;
   RodneCis:=TBSepMaj.fieldByName('RodneCis').asstring;
   JmePrijm:=TBSepMaj.fieldByName('JmePrijm').asstring;
   ICO:=TBSepMaj.fieldByName('ICO').asString;
   ObchodJm:=TBSepMaj.fieldByName('ObchodJm').asstring;
   Zastupce:=TBSepMaj.fieldByName('Zastupce').asstring;
   PSC:=TBSepMaj.fieldByName('PSC').asinteger;
   AdrObec:=TBSepMaj.fieldByName('AdrObec').asstring;
   AdrUlice:=TBSepMaj.fieldByName('AdrUlice').asstring;
   AdrCDomu:=TBSepMaj.fieldByName('AdrCDomu').asstring;
   Obec:=TBSepMaj.fieldByName('Obec').asstring;
   Ostatni:=TBSepMaj.fieldByName('OSTATNI').asstring;
  end;        }
end;

procedure TFVybSep.ButTiskniClick(Sender: TObject);
begin
 NactiMajitelePodleQ_SepMajOdd;
 PlochovkaMajiteleNaTiskarnu;
end;
procedure TFVybSep.PlochovkaMajiteleNaTiskarnu;
var i:Integer;
    strana:Integer;
begin
 with printer do
  begin
   if not printing then
    begin
     Orientation := poLandscape;
     beginDoc;
    end;
  end;
 with LesniCelek.LHC.Majitel.oddeleniMN do
  begin
   strana:=1;
   for i:=0 to count - 1 do
    begin
     OddeleniNaTiskarnu(TOddeleni(elements[i]),strana,0,chTiskPor.checked,true,false,'Arial',false,false,levaPrava,1,1,cesky,nil);
    end;
  end;
 with printer do
  begin
   enddoc;
   Orientation := poPortrait;
  end;
end;
procedure TFVybSep.ButZobrSepClick(Sender: TObject);
 begin
  NactiMajitelePodleQ_SepMajOdd;
  ZobrazSeparatDoImage(LesniCelek.LHC.Majitel,
                    AnoNeRozhodniSeSamZBooleanu(ChZavazVychov.checked),
                    AnoNeRozhodniSeSamZBooleanu(CHRamcSmer.checked),
                    clyellow);
 end;

procedure TFVybSep.ButTiskSepClick(Sender: TObject);
 begin
  NactiMajitelePodleQ_SepMajOdd;
  SeparatNaTiskarnu(LesniCelek.LHC.Majitel,
                    AnoNeRozhodniSeSamZBooleanu(ChZavazVychov.checked),
                    AnoNeRozhodniSeSamZBooleanu(CHRamcSmer.checked),
                    clyellow);
 end;
procedure TFVybSep.FormShow(Sender: TObject);
procedure NastavZobrazovani;
 begin
   TbSepMaj.fieldByName('MAJ_DRUH').DisplayLabel:='Druh majetku';
   TbSepMaj.fieldByName('MAJ_DRUH').DisplayWidth:=1;
   TbSepMaj.fieldByName('MAJ_KOD').DisplayLabel:='s.majetku';
   TbSepMaj.fieldByName('MAJ_KOD').DisplayWidth:=6;
   TbSepMaj.fieldByName('LV').DisplayLabel:='.list.vl.';
   TbSepMaj.fieldByName('LV').DisplayWidth:=6;
   TbSepMaj.fieldByName('TEZB_VYP').DisplayLabel:='T.vypoten';
   TbSepMaj.fieldByName('TEZB_MAX').DisplayLabel:='T.maximln';

   TbSepMaj.fieldByName('LesniPoz').DisplayLabel:='Lesn pozemky';
   TFloatfield(TbSepMaj.fieldByName('LesniPoz')).DisplayFormat:='0.00';
   TFloatfield(TbSepMaj.fieldByName('LesniPoz')).EditFormat:='0.00';
   TbSepMaj.fieldByName('LesniPoz').DisplayWidth:=7;
   TFloatfield(TbSepMaj.fieldByName('JinePoz')).DisplayFormat:='0.00';
   TFloatfield(TbSepMaj.fieldByName('JinePoz')).EditFormat:='0.00';
   TbSepMaj.fieldByName('JinePoz').DisplayLabel:='Jin pozemky';
   TbSepMaj.fieldByName('JinePoz').DisplayWidth:=7;
   TbSepMaj.fieldByName('JmePrijm').DisplayLabel:='Jmno,pjmen';
   TbSepMaj.fieldByName('JmePrijm').index:=2;
   TbSepMaj.fieldByName('OSTATNI').DisplayLabel:='Ostatn';
 end;
var vPoradku:Boolean;
 begin
  LesniCelek:=TLesniCelek.create;
  LesniCelek.LOvr98:=Ovr98;
  LesniCelek.nactiSe_DB98;
  try
   vPoradku:=false;
   DB_SepMaj.dataSource:=DTZ_SepMaj;
   TbSepMaj.open;
   nastavZobrazovani;
   DB_MajPor.dataSource:=DTZ_MajPor;
   TbMajPor.open;
   Q_SepMajOdd.open;
   vPoradku:=true;
    except
     VytvorNeboObnov;
     nastavZobrazovani;
    end;
 end;
procedure TFVybSep.ButTiskSepPlochClick(Sender: TObject);
 begin
  NactiMajitelePodleQ_SepMajOdd;
  SeparatNaTiskarnu(LesniCelek.LHC.Majitel,
                    AnoNeRozhodniSeSamZBooleanu(ChZavazVychov.checked),
                    AnoNeRozhodniSeSamZBooleanu(CHRamcSmer.checked),
                    clyellow);
  PlochovkaMajiteleNaTiskarnu;
 end;

procedure TFVybSep.ButTbCisClick(Sender: TObject);
var zkontroluj  :boolean;
    DotazF1     :TDotazf1;
begin
 // LesniCelek.VytvorPristupKMajiteli('c:\tax97\Poz97\DTA\navrat.dbf','UZIV');
 // if lesniCelek.pripojeniMajitele=nil then exit;
 zkontroluj:=false;
 TBSepMaj.first;
  while not TBSepMaj.eof do
   begin
    NactiMajitelePodleQ_SepMajOdd;
    if not zkontroluj then
     begin
      if not ZkontrolujTabulkuAPrvekPodleScriptu
        (LesniCelek.ciselnik.tb_Majetky,LesniCelek.lhc.MajitelMN.MAjitel,
          LesniCelek.pripojeniMajitele.PredpisPripojeniKolonekCiselnikuMajitele.StringListElement)
{       (LesniCelek.pripojeniMajitele.Navraty,LesniCelek.lhc.MajitelMN.MAjitel,
          LesniCelek.pripojeniMajitele.PredpisPripojeniKolonekNavratu.StringListElement) }
      then
       begin
        zkontroluj:=true;
        Application.CreateForm(TDotazf1, DotazF1);
        dotazf1.activecontrol:=dotazf1.CancelBtn;
        dotazf1.label1.caption:='V PHS.INI nen pesn definovno pipojen selnku majitele.';
        dotazf1.label2.caption:='M se pesto natat ?';
        dotazf1.showmodal;
        if dotazf1.odpoved=false then
         begin
          dotazf1.destroy;
          LesniCelek.pripojeniMajitele.navraty.close;
          LesniCelek.pripojeniMajitele.navraty.free;
          LesniCelek.pripojeniMajitele.free;
          LesniCelek.pripojeniMajitele:=Nil;
          exit;
         end;
        dotazf1.destroy;
       end;
     end;
    NactiZTabulkyHodnotyDoPrvkuPodleScriptu
     (LesniCelek.ciselnik.tb_Majetky,LesniCelek.lhc.MajitelMN.MAjitel,
          LesniCelek.pripojeniMajitele.PredpisPripojeniKolonekCiselnikuMajitele.StringListElement);
    // UlozPolozkyMajitele (LesniCelek.LHC.Majitel,TBSepMaj);
    TbSepMAj.next;
   end;
  LesniCelek.pripojeniMajitele.navraty.close;
  LesniCelek.pripojeniMajitele.navraty.free;
  LesniCelek.pripojeniMajitele.free;
  LesniCelek.pripojeniMajitele :=Nil;
end;

{ begin
   LesniCelek.VytvorPristupKMajiteli('c:\tax97\Poz97\DTA\navrat.dbf','UZIV');
   if lesniCelek.pripojeniMajitele=nil then showmessage('Nepodailo se.');
  end; }

procedure TFVybSep.ButTiskVsechClick(Sender: TObject);
 begin
  TBSepMaj.first;
  while not TBSepMaj.eof do
   begin
    NactiMajitelePodleQ_SepMajOdd;
    SeparatNaTiskarnu(LesniCelek.LHC.Majitel,
                    AnoNeRozhodniSeSamZBooleanu(ChZavazVychov.checked),
                    AnoNeRozhodniSeSamZBooleanu(CHRamcSmer.checked),
                    clyellow);
    PlochovkaMajiteleNaTiskarnu;
    TbSepMAj.next;
   end;
 end;

procedure ZobrazSoucetSeparatuDoImage(VMajitel:TMajitel);
var mxi,myi,strana:integer;
 begin
  with FSeCanvas do
   begin
    strana:=0;
    mxi:=round(screen.width*1.5);
    myi:=round(screen.height*1.5);
    Image1.picture.bitmap.Width:=image1.width;
    Image1.picture.bitmap.height:=image1.height;
    tiskPloTabOddeleni(nil,Strana,0,
                        Image1.picture.bitmap.canvas,nil,nil,MXi,MYi,False,true,
                        VMajitel.oddeleniMN,False,true,false,clYellow,'Arial',false,false,levaprava,1,1,cesky,nil);
    image1.refresh;
    showmodal;
   end;
 end;
procedure SeparatKatastruASouctuNaTiskarnu(VMajitel:TMajitel);
var PXI,PYI,strana:integer;
begin
 with FPTCanvas do
  begin
   with printer do
    begin
     if not printing then
      begin
       Orientation := poLandscape;
       beginDoc;
      end;
     pxi:=round(printer.PageWidth);
     pyi:=printer.PageHeight;
     TiskKatastru(VMajitel.oddeleniMN,canvas,nil,nil,pXi,pYi,True,clYellow,'Arial',cesky,nil);
     tiskPloTabOddeleni(NIL,Strana,0,
                          canvas,nil,nil,
                          pXi,pYi,true,True,VMajitel.oddeleniMN,false,true,false,clYellow,'Arial',false,false,levaPrava,1,1,cesky,nil);
     enddoc;
     Orientation := poPortrait;
    end;
  end;
end;

procedure ZobrazSeparatKatastruDoImage(VMajitel:TMajitel);
var mxi,myi,strana:integer;
 begin
  with FSeCanvas do
   begin
    strana:=0;
    mxi:=round(screen.width*1.5);
    myi:=round(screen.height*1.5);
    Image1.picture.bitmap.Width:=image1.width;
    Image1.picture.bitmap.height:=image1.height;
    TiskKatastru(VMajitel.oddeleniMN,Image1.picture.bitmap.canvas,nil,nil,MXi,MYi,False,clYellow,'Arial',cesky,nil);
    { tiskPloTabOddeleni(nil,Strana,0,
                        Image1.picture.bitmap.canvas,MXi,MYi,False,true,
                        VMajitel.oddeleniMN,False);         }
    image1.refresh;
    showmodal;
   end;
 end;
procedure TFVybSep.Button2Click(Sender: TObject);
 begin
  NactiMajitelePodleQ_SepMajOdd;
  { ZobrazSoucetSeparatuDoImage(LesniCelek.LHC.Majitel); }
  ZobrazSeparatKatastruDoImage(LesniCelek.LHC.Majitel);

 end;

procedure TFVybSep.ButTiskSumClick(Sender: TObject);
begin
  NactiMajitelePodleQ_SepMajOdd;
  SeparatKatastruASouctuNaTiskarnu(LesniCelek.LHC.Majitel);
end;

procedure TFVybSep.ButVypVseClick(Sender: TObject);
begin
  TBSepMaj.first;
  while not TBSepMaj.eof do
   begin
    NactiMajitelePodleQ_SepMajOdd;
    TbSepMAj.next;
   end;

end;

procedure TFVybSep.ButNavratClick(Sender: TObject);
var zkontroluj  :boolean;
    DotazF1     :TDotazf1;
begin
 LesniCelek.VytvorPristupKMajiteli('c:\tax97\Poz97\DTA\navrat.dbf','UZIV');
 if lesniCelek.pripojeniMajitele=nil then exit;
 zkontroluj:=false;
 TBSepMaj.first;
  while not TBSepMaj.eof do
   begin
    NactiMajitelePodleQ_SepMajOdd;
    if not zkontroluj then
     begin
      if not ZkontrolujTabulkuAPrvekPodleScriptu
       (LesniCelek.pripojeniMajitele.Navraty,LesniCelek.lhc.MajitelMN.MAjitel,
          LesniCelek.pripojeniMajitele.PredpisPripojeniKolonekNavratu.StringListElement)
      then
       begin
        zkontroluj:=true;
        Application.CreateForm(TDotazf1, DotazF1);
        dotazf1.activecontrol:=dotazf1.CancelBtn;
        dotazf1.label1.caption:='V PHS.INI nen pesn definovno pipojen Navratu.';
        dotazf1.label2.caption:='M se pesto natat ?';
        dotazf1.showmodal;
        if dotazf1.odpoved=false then
         begin
          dotazf1.destroy;
          LesniCelek.pripojeniMajitele.navraty.close;
          LesniCelek.pripojeniMajitele.navraty.free;
          LesniCelek.pripojeniMajitele.free;
          LesniCelek.pripojeniMajitele:=Nil;
          exit;
         end;
        dotazf1.destroy;
       end;
     end;
    NactiZTabulkyHodnotyDoPrvkuPodleScriptu
     (LesniCelek.pripojeniMajitele.Navraty,LesniCelek.lhc.MajitelMN.MAjitel,
          LesniCelek.pripojeniMajitele.PredpisPripojeniKolonekNavratu.StringListElement);
    // UlozPolozkyMajitele (LesniCelek.LHC.Majitel,TBSepMaj);
    TbSepMAj.next;
   end;
  LesniCelek.pripojeniMajitele.navraty.close;
  LesniCelek.pripojeniMajitele.navraty.free;
  LesniCelek.pripojeniMajitele.free;
  LesniCelek.pripojeniMajitele :=Nil;
end;
procedure TFVybSep.ButVYpMaxClick(Sender: TObject);
var procMax:integer;
 begin
  try
   ProcMax:=strtoint(editProcMax.text);
  except
   showmessage('V kolonce "% zven maximln tby" nen cel slo.');
   exit;
  end;
 TBSepMaj.first;
  while not TBSepMaj.eof do
   begin
    NactiMajitelePodleQ_SepMajOdd;
    LesniCelek.LHC.Majitel.bTEZB_MAX:=(LesniCelek.LHC.Majitel.TezbyCelkem*(ProcMax+100))div 100;
    // UlozPolozkyMajitele (LesniCelek.LHC.Majitel,TBSepMaj);
    TbSepMAj.next;
   end;
 end;


end.
