unit U_vybopr;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,
  sp_ovr, mat1, u_OprBzl, StdCtrls;

type
  TS_VybOpr = class(TForm)
    ButNulProb: TButton;
    Edit1: TEdit;
    ButSmazXXX: TButton;
    ButSmazMZD: TButton;
    ButParcPl: TButton;
    ButVyuz: TButton;
    Button1: TButton;
    ButGenKlas: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure ButNulProbClick(Sender: TObject);
    procedure ButSmazXXXClick(Sender: TObject);
    procedure ButSmazMZDClick(Sender: TObject);
    procedure ButParcPlClick(Sender: TObject);
    procedure ButVyuzClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ButGenKlasClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  S_VybOpr: TS_VybOpr;

implementation

{$R *.DFM}

procedure TS_VybOpr.ButNulProbClick(Sender: TObject);
var SKateg:String;
    Mazat:Boolean;
begin
 with ovr do
  begin
   tb_odd.first;
   while not Tb_odd.eof do
    begin
     tb_dl.first;
     while not Tb_dl.eof do
      begin
       tb_porost.first;
       while not Tb_porost.eof do
        begin
         tb_sk.first;
         while not Tb_sk.eof do
          begin
           tb_etaz.first;
           while not Tb_etaz.eof do
            begin
             Edit1.text:=tb_odd.fieldByName('ODD').asstring
                        +Tb_dl.fieldByName('DIL').asstring
                        +Tb_porost.fieldByName('POR').asstring;
             Edit1.refresh;
             nastavsetrange1(ovr);
             SKateg:=lowerCase(uBM(tb_PrekryvKtg_Str.asstring));
             mazat:=True;
             if (SKateg='21a')or(SKateg='21b')or(SKateg='21c')
              then Mazat:=False;
             if Tb_porost.fieldByName('ZVL_STATUS').asinteger in [2,6,10,11]
              then Mazat:=false;
             if mazat then
              begin
               tb_navrh.first;
               while not Tb_navrh.eof do
                begin
                 tb_navrh.edit;
                 Tb_navrh.fieldByName('N_Procento').asinteger:=0;
                 Tb_navrh.fieldByName('N_ObjemHa').asinteger:=0;
                 Tb_navrh.fieldByName('N_Objem').asinteger:=0;
                 Tb_navrh.post;
                 tb_navrh.next;
                end;
              end;
             tb_etaz.next;
            end;
           tb_sk.next;
          end;
         tb_porost.next;
        end;
       tb_dl.next;
      end;
     tb_odd.next;
    end;
   Edit1.text:='';Edit1.refresh;
  end;
end;

procedure TS_VybOpr.ButSmazXXXClick(Sender: TObject);
begin
 with ovr do
  begin
   tb_odd.first;
   while not Tb_odd.eof do
    begin
     tb_dl.first;
     while not Tb_dl.eof do
      begin
       tb_porost.first;
       while not Tb_porost.eof do
        begin
         Edit1.text:=tb_odd.fieldByName('ODD').asstring
                    +Tb_dl.fieldByName('DIL').asstring
                    +Tb_porost.fieldByName('POR').asstring;
         Edit1.refresh;
         tb_sk.first;
         while not Tb_sk.eof do
          begin
           if (tb_sk.fieldByName('PSK').asstring='XXX')
              or (uBM(tb_sk.fieldByName('PSK').asstring)='vv')then
            tb_sk.Delete
           else
             tb_sk.next;
          end;
         tb_porost.next;
        end;
       tb_dl.next;
      end;
     tb_odd.next;
    end;
   Edit1.text:='';Edit1.refresh;
  end;
end;

procedure TS_VybOpr.ButSmazMZDClick(Sender: TObject);
var
    jeMZD:Boolean;
begin
 with ovr do
  begin
   tb_odd.first;
   while not Tb_odd.eof do
    begin
     tb_dl.first;
     while not Tb_dl.eof do
      begin
       tb_porost.first;
       while not Tb_porost.eof do
        begin
         tb_sk.first;
         while not Tb_sk.eof do
          begin
           tb_etaz.first;
            while not Tb_etaz.eof do
             begin
              Edit1.text:=tb_odd.fieldByName('ODD').asstring
                          +Tb_dl.fieldByName('DIL').asstring
                          +Tb_porost.fieldByName('POR').asstring;
              Edit1.refresh;
              nastavsetrange1(ovr);
              jeMZD:=false;
              if (tb_zal.recordCount>0)
                 and (tb_zal.fieldByName('N_Druh_vykonu').asinteger in[1,3,4]) then
              begin
               jeMZD:=true;
              end; {tb_zal.recordCount>0}
             if tb_etaz.fieldByName('VEK').asinteger>80 then
              begin
               jeMZD:=true;
              end;
             if Hl11.findText(tb_etaz.fieldbyname('HS').asstring, True ) then
              begin
               if tb_etaz.fieldByName('VEK').asinteger
                    >=tb_hs.fieldByName('POC_OBNOVY').asinteger then
                begin
                 jeMzd:=true;
                end;
              end
             else
              begin
               showmessage('Hospodsk soubor '
                  +tb_etaz.fieldbyname('HS').asstring+' nen v selnku.');
              end;
             if  not jeMZD then
              begin
               tb_Etaz.edit;
               tb_etaz.fieldbyname('MZD').asinteger:=0;
               tb_etaz.post;
              end;
             tb_etaz.next;
            end;
           tb_sk.next;
          end;
         tb_porost.next;
        end;
       tb_dl.next;
      end;
     tb_odd.next;
    end;
   Edit1.text:='';Edit1.refresh;
  end;
end;

procedure TS_VybOpr.ButParcPlClick(Sender: TObject);
var parc_pl:double;
begin
 with ovr do
  begin
   tb_odd.first;
   while not Tb_odd.eof do
    begin
     tb_dl.first;
     while not Tb_dl.eof do
      begin
       tb_porost.first;
       while not Tb_porost.eof do
        begin
         tb_BZL.first;
         while not Tb_BZL.eof do
          begin
           tb_BZL.edit;
           Tb_BZL.fieldByName('BZL_P').AsFloat:=round(Tb_BZL.fieldByName('BZL_P').AsFloat*100)/100;
           Tb_BZL.post;
           tb_BZL.next;
          end;
         tb_sk.first;
         while not Tb_sk.eof do
          begin
           tb_SK.edit;
           Tb_sk.fieldByName('PSK_P').AsFloat:=round(Tb_sk.fieldByName('PSK_P').AsFloat*100)/100;
           Tb_SK.post;
           parc_pl:=0;
           tb_etaz.first;
           while not Tb_etaz.eof do
            begin
              Edit1.text:=tb_odd.fieldByName('ODD').asstring
                          +Tb_dl.fieldByName('DIL').asstring
                          +Tb_porost.fieldByName('POR').asstring;
              Edit1.refresh;
              parc_pl:=Parc_pl+Tb_etaz.fieldByName('ETAZ_PP').asfloat;
              tb_etaz.next;
            end;
           if not rovenFlo(Parc_pl,Tb_sk.fieldByName('PSK_P').asfloat,3) then
            begin
             tb_etaz.edit;
             Tb_etaz.fieldByName('ETAZ_PP').asfloat:=
               Tb_etaz.fieldByName('ETAZ_PP').asfloat
               +Tb_sk.fieldByName('PSK_P').asfloat
               -Parc_Pl;
             Tb_etaz.post;
            end;
           tb_sk.next;
          end;
         tb_porost.next;
        end;
       tb_dl.next;
      end;
     tb_odd.next;
    end;
   Edit1.text:='';Edit1.refresh;
  end;
end;

procedure TS_VybOpr.ButVyuzClick(Sender: TObject);
begin
 F_oprBzl.showmodal;
end;

procedure TS_VybOpr.Button1Click(Sender: TObject);
begin
 with ovr do
  begin
   tb_odd.first;
   while not Tb_odd.eof do
    begin
     tb_jine.first;
     while not Tb_jine.eof do
      begin
       Edit1.text:=tb_odd.fieldByName('ODD').asstring
                      +Tb_jine.fieldByName('JP').asstring;
       Edit1.refresh;
       tb_jine.edit;
       tb_JineKategorie.AsString:=LomeneKateg;
       tb_jine.post;
       TB_jine.next;
      end;
     tb_odd.next;
    end;
   Edit1.text:='';Edit1.refresh;
  end;
end;

procedure TS_VybOpr.ButGenKlasClick(Sender: TObject);
begin
 with ovr do
  begin
   tb_odd.first;
   while not Tb_odd.eof do
    begin
     tb_dl.first;
     while not Tb_dl.eof do
      begin
       tb_porost.first;
       while not Tb_porost.eof do
        begin
         tb_sk.first;
         while not Tb_sk.eof do
          begin
           tb_etaz.first;
           while not Tb_etaz.eof do
            begin
             Edit1.text:=tb_odd.fieldByName('ODD').asstring
                          +Tb_dl.fieldByName('DIL').asstring
                          +Tb_porost.fieldByName('POR').asstring;
             Edit1.refresh;
             tb_dr.first;
             while not Tb_dr.eof do
              begin
               tb_dr.edit;
               if Tb_dr.fieldByName('GEN_KLAS').asString='0' then
                begin
                 Tb_dr.fieldByName('GEN_KLAS').asString:='';
                end;
               Tb_dr.post;
               tb_dr.next;
              end;
             tb_etaz.next;
            end;
           tb_sk.next;
          end;
         tb_porost.next;
        end;
       tb_dl.next;
      end;
     tb_odd.next;
    end;
   Edit1.text:='';Edit1.refresh;
  end;
end;

procedure TS_VybOpr.Button2Click(Sender: TObject);
var sumProc,maxProc:integer;
    drevProc:string;
begin
 with ovr do
  begin
   tb_odd.first;
   while not Tb_odd.eof do
    begin
     tb_dl.first;
     while not Tb_dl.eof do
      begin
       tb_porost.first;
       while not Tb_porost.eof do
        begin
         tb_sk.first;
         while not Tb_sk.eof do
          begin
           tb_etaz.first;
           while not Tb_etaz.eof do
            begin
             nastavsetRange1(ovr);
             Edit1.text:=tb_odd.fieldByName('ODD').asstring
                          +Tb_dl.fieldByName('DIL').asstring
                          +Tb_porost.fieldByName('POR').asstring;
             Edit1.refresh;
             tb_zal.beforePost:=nil;
             floatField12.onCHange:=nil;
             tb_zal.first;
             SumProc:=0;
             maxProc:=0;

             while not Tb_zal.eof do
              begin
               tb_zal.edit;
               tb_zal.fieldByName('N_Procento').asinteger:=
                 round(tb_zal.fieldByName('N_Procento').asinteger/5)*5;
               Tb_zal.post;
               if maxProc<tb_zal.fieldByName('N_Procento').asinteger then
                  begin
                   drevProc:=tb_zal.fieldByName('N_Zkratka_dreviny').asString;
                   maxProc:=tb_zal.fieldByName('N_Procento').asinteger;
                  end;
               SumProc:=sumProc+tb_zal.fieldByName('N_Procento').asinteger;
               tb_zal.next;
              end;
             tb_zal.first;
              while not tb_zal.eof do
               begin
                if tb_zal.fieldByName('N_Zkratka_dreviny').asString=drevProc then
                  begin
                   tb_zal.edit;
                   tb_zal.fieldByName('N_Procento').asinteger:=
                   tb_zal.fieldByName('N_Procento').asinteger+100-SumProc;
                   tb_zal.post;
                  end;
                 tb_zal.next;
               end;
             tb_etaz.next;
            end;
           tb_sk.next;
          end;
         tb_porost.next;
        end;
       tb_dl.next;
      end;
     tb_odd.next;
    end;
   Edit1.text:='';Edit1.refresh;
  end;
end;

procedure TS_VybOpr.Button3Click(Sender: TObject);
begin
with OVR do
 begin
   tb_odd.first;
   while not Tb_odd.eof do
    begin
     tb_dl.first;
     while not Tb_dl.eof do
      begin
       tb_porost.first;
       while not Tb_porost.eof do
        begin
         tb_sk.first;
         while not Tb_sk.eof do
          begin
           Edit1.text:=tb_odd.fieldByName('ODD').asstring
                          +Tb_dl.fieldByName('DIL').asstring
                          +Tb_porost.fieldByName('POR').asstring;
           Edit1.refresh;
           tb_etaz.first;
           while not Tb_etaz.eof do
            begin
             tb_Navrh1.open;
             tb_navrh1.first;
             while not tb_navrh1.eof do
              begin
               tb_navrh1.edit;
               tb_navrh1.fieldByName('N_PLOCHA').asfloat:=
               round(tb_navrh1.fieldByName('N_PLOCHA').asfloat*100)/100;
               tb_navrh1.post;
               tb_navrh1.next;
              end;
             tb_etaz.next;
            end;
           tb_sk.next;
          end;
         tb_porost.next;
        end;
       tb_dl.next;
      end;
     tb_odd.next;
    end;
   Edit1.text:='';Edit1.refresh;
  end;
end;
procedure TS_VybOpr.Button4Click(Sender: TObject);
begin
with OVR do
 begin
   tb_odd.first;
   while not Tb_odd.eof do
    begin
     tb_dl.first;
     while not Tb_dl.eof do
      begin
       tb_porost.first;
       while not Tb_porost.eof do
        begin
         tb_bzl.first;
         while not Tb_bzl.eof do
          begin
           Edit1.text:=tb_odd.fieldByName('ODD').asstring
                          +Tb_dl.fieldByName('DIL').asstring
                          +Tb_porost.fieldByName('POR').asstring;
           Edit1.refresh;
           tb_bzl.edit;
           tb_bzl.fieldByName('BZL_P').asfloat:=round(tb_bzl.fieldByName('BZL_P').asfloat*100)/100;
           tb_bzl.post;
           tb_bzl.next;
          end;
         tb_porost.next;
        end;
       tb_dl.next;
      end;
         tb_jine.first;
         while not Tb_jine.eof do
          begin
           Edit1.text:=tb_odd.fieldByName('ODD').asstring;
           Edit1.refresh;
           tb_jine.edit;
           tb_jine.fieldByName('JP_P').asfloat:=round(tb_jine.fieldByName('JP_P').asfloat*100)/100;
           tb_jine.post;
           tb_jine.next;
          end;
         tb_ost.first;
         while not Tb_ost.eof do
          begin
           Edit1.text:=tb_odd.fieldByName('ODD').asstring;
           Edit1.refresh;
           tb_ost.edit;
           tb_ost.fieldByName('OST_P').asfloat:=round(tb_ost.fieldByName('OST_P').asfloat*100)/100;
           tb_ost.post;
           tb_ost.next;
          end;
     tb_odd.next;
    end;
   Edit1.text:='';Edit1.refresh;
  end;
end;

end.
