unit VenkZapCanv;
interface
uses SysUtils, WinTypes, WinProcs, Messages, Classes,
     Controls, Graphics,ELesObec,stdctrls,
     E_lesOdd,
     DB, DBTables;
procedure tiskPorostVenkZapi(var strana1:integer;
                         strana_pozadovana_k_tisku:integer;
                         CanvasV:TCanvas;merX,MerY:longint;
                         naTiskarnu:boolean;
                         PocetRadku:integer;prvniPorost:boolean;QP0444:TQuery;
                         var tiskSeUskutecnil:Boolean; infoEdit:TEdit);

var
  Yskup  :longint;
  predchODD:integer;
  VZapiOdd,VZapiOdd_Zal:TOddeleni;
implementation
uses hkCanvas,Dtbles98,Sp_Ovr98,mat1,
     dialogs,printers_F,tisky,U_Zobraz;

procedure tiskPorostVenkZapi(var strana1:integer;
                         strana_pozadovana_k_tisku:integer;
                         CanvasV:TCanvas;merX,MerY:longint;
                         naTiskarnu:boolean;
                         PocetRadku:integer;prvniPorost:boolean;QP0444:TQuery;
                         var tiskSeUskutecnil:Boolean; infoEdit:TEdit);
var
  iStrana:integer;
  y1, yp, yKon, RadY  :longint;
  x1, xmm, xp, XOdd, Xdil, xPor, XPsk, XStOzn, Xetaz,  XVek, XZakm, XLT, Xploch, Xdrev, Xzast, Xtlou, xVys, XGenKlas, Xkon  :longint;
  FS,FSD,FSDK,FSDM   :integer;

 function mx(x:real):longint;
  begin
   mx:=mx1(x,MerX);
  end;
 function my(y:real):longint;
  begin
   my:=round(0.96*my1(y,mery));
  end;
procedure HoleOdstrankovani;
begin
if NaTiskarnu then
 begin
  with printer do
   begin
{   if not netisknout then }
     begin
      newpage;
     end;
   end;
 end;
 inc(iStrana);
end;
procedure NastavBody;
 begin
   FS:=9;
   FSD:=8;
   FSDK:=11;
   FSDM:=3;
   if naTiskarnu then y1:=my(1.1)
   else y1:=my(0.1)+my(32.0)*IStrana;
   yKon:=y1+my(24.5);
   yp:=my(0.06);
   RadY:=my(0.30);
   xp:=mx(0.03);
   x1:=mx(0.1);
   xmm:=mx(0.1);
   XOdd:=x1;
   Xdil:=XOdd+mx(1.0);
   xPor:=XDil+mx(0.6);
   XPsk:=XPor+mx(1.2);
   XStOzn:=XPsk+mx(2.4);
   Xetaz:=XStOzn+mx(1.9);
   XVek:=XEtaz+mx(0.6);
   XZakm:=XVek+mx(0.8);
   XLT:=XZakm+mx(0.8);
   Xploch:=Xlt+mx(1.2);
   Xdrev:=Xploch+mx(1.2);
   Xzast:=Xdrev+mx(1.2);
   Xtlou   :=Xzast+mx(1.2);
   xVys    :=Xtlou+mx(1.2);
   XGenKlas:=XVys+mx(1.2);
   Xkon:=XGenKlas+mx(1.2);
 end;
procedure  TiskniHlavickuStranky(Ypor:longint);
 begin
  with CanvasV do
   begin
    FONT.NAME:='Arial CE';
    Font.Size:=FS;
    Font.Style:=[];
    textOutS(canvasV,xOdd,Xdil,Ypor+yp,'Odd.');
    textOutS(canvasV,xDil,XPor,Ypor+yp,'Dl.');
    textOutS(canvasV,xPor,XPsk,Ypor+yp,'Por.');

    textOutS(canvasV,xPSK,XStOzn,Ypor+yp,'Skup.');
    textOutS(canvasV,XStOzn,Xetaz,Ypor+yp,'Oz.star-nov');
    textOutS(canvasV,Xetaz,Xvek,Ypor+yp,'Et.');
    textOutS(canvasV,xvek,XZakm,Ypor+yp,'Vk');
    textOutS(canvasV,xZakm,XLT,Ypor+yp,'Zakm.');
    textOutS(canvasV,xLT,XPloch,Ypor+yp,'LT');
    textOutS(canvasV,xploch,Xdrev,Ypor+yp,'Pl.');
    textOutS(canvasV,xdrev,XZast,Ypor+yp,'Drev.');
    textOutS(canvasV,xzast,Xtlou,Ypor+yp,'Zast.');
    textOutS(canvasV,xtlou,Xvys,Ypor+yp,'tlou.');
    textOutS(canvasV,xVys,XGenKlas,Ypor+yp,'vyska');
    textOutS(canvasV,xGenKlas,XKon,Ypor+yp,'Gen.klas.');
   end;
 end;

function PocetPozadovanychRadku(PorSk:TPorostniSkupina):integer;
var i:integer;
 begin
  result:=0;
  with PorSk.etazMN do
   begin
    for i:=0 to count-1 do
     begin
      result:=result+max(TEtaz(Elements[i]).drevinaMN.count,1);
     end;
   end;
 end;

procedure tiskniPorSkup(PorSkup:TPorostniSkupina;YAkt:LongInt);
 var i,idr:integer;
     TextStr1:String;
begin
 with canvasV do
  begin
   YAkt:=YAkt+3*yp;
   PolyLine([Point(xODD ,YAkt+(yp div 2)),
             Point(Xkon   ,yAkt+(yp div 2))]);
   with porSkup.etazMN do
    begin
     for i:=0 to count-1 do
      begin
       with TEtaz(Elements[i]) do
        begin
         FONT.NAME:='Arial CE';
         Font.Size:=FSD;
         Font.Style:=[];
         //XOdd, Xdil, XPsk, Xetaz, XVek, XZakm, XLT, Xploch, Xdrev, Xzast, Xtlou, xVys, XGenKlas :longint;

         textOutS(canvasV,xOdd,Xdil,Yakt+yp,inttostr(porskup.ownerporost.ownerDilec.ownerOddeleni.ODD));
         textOutS(canvasV,xDil,XPor,Yakt+yp,porskup.ownerporost.ownerDilec.DIL);
         textOutS(canvasV,xPor,XPsk,Yakt+yp,porskup.ownerporost.POR);
         textOutS(canvasV,xPSK,XStOzn,YAkt+yp,porSkup.PSK);
         textOutS(canvasV,xStOzn,Xetaz,YAkt+yp,porSkup.StareOzn);

         if PorSkup.EtazMN.count>1 then
          begin
           textOutS(canvasV,xEtaz,XVek,YAkt+yp,ETAZ);
          end;
   // textOutS(canvasV,xvek,XZakm,Ypor+yp,'Vk');
           textOutS(canvasV,xvek,XZakm,Yakt+yp,inttostr(VEK));
   // textOutS(canvasV,xZakm,XLT,Yakt+yp,'Zakm.');
           textOutS(canvasV,xZakm,XLT,Yakt+yp,inttostr(ZAKM));
   // textOutS(canvasV,xLT,XPloch,Yakt+yp,'LT');
           textOutS(canvasV,xLT,XPloch,Yakt+yp,porskup.LT);
   // textOutS(canvasV,xploch,Xdrev,Yakt+yp,'Pl.');
      textOutS(canvasV,xploch,Xdrev,Yakt+yp,FloatToStrF(porSkup.PSK_P,ffFixed,5,2));
         for IDr:=0 to drevinaMN.count-1 do
          begin
           if Idr>0 then YAkt:=YAkt+radY;
           textOutS(canvasV,Xdrev,XZast,YAkt+yp,idrevina[iDr].DR_ZKR);
           textOutS(canvasV,XZast,Xtlou,YAkt+yp,inttostr(idrevina[iDr].ZAST));
//    textOutS(canvasV,xtlou,Xvys,Yakt+yp,'tlou.');
           textOutS(canvasV,xtlou,Xvys,Yakt+yp,inttostr(idrevina[iDr].TLOUSTKA));
//    textOutS(canvasV,xVys,XGenKlas,Yakt+yp,'vyska');
           textOutS(canvasV,Xvys,XGenKlas,Yakt+yp,inttostr(idrevina[iDr].VYSKA));
//    textOutS(canvasV,xGenKlas,XKon,Yakt+yp,'Gen.klas.');
           textOutS(canvasV,xGenKlas,XKon,Yakt+yp,idrevina[iDr].GEN_KLAS);
          end;
        end;
       YAkt:=YAkt+radY;
      end;
    end;
  end;
end;

procedure NactiPorost(var VOdd:TOddeleni);
var IODD:integer;
    IDil,iPor:string;
 begin
  with Ovr98 do
  begin
   IOdd                                    :=tb_ODD.fieldByName('ODD').asinteger;
   IDil                                    :=tb_Dl.fieldByName('DIL').asstring;
   IPor                                    :=tb_porost.fieldByName('POR').asstring;
   if VODD=Nil then
    begin
     NactiOddeleniDB98(vOdd,Ovr98,BezBarvy1);
    end
   else
    begin
     if Vodd.ODD<>IOdd then
      begin
       Vodd.free;
       NactiOddeleniDB98(vOdd,Ovr98,BezBarvy1);
      end;
    end;
   VOdd.DilecMN.JmenoAktualnihoPrvku       :=IDil;
   VOdd.Dilec.PorostMN.JmenoAktualnihoPrvku:=IPor;
  end;
 end;

 var  isk :integer;
     iPor,iDil: integer;
     KopiDilec:TDilec;
     KopiPorost:TPorost;
 begin
  NactiPorost(VZapiOdd);
  VZapiOdd_Zal:=nil;
  if  QP0444 <> nil then
   begin
    VZapiOdd_Zal:=VZapiOdd;
   //  showmessage(inttostr(VZapiOdd_Zal.dilec.porostMN.count)+' Kopiruju'+VZapiodd_Zal.Dilec.Porost.CeleOznaceni);
    VZapiOdd:=TOddeleni(VZapiOdd_Zal.KopieElementu);
    KopiDilec:=TDilec(VZapiOdd_Zal.dilec.KopieElementu);
    KopiPorost:=VZapiodd_Zal.Dilec.Porost.KopiePorostu;
    KopiDilec.PorostMN.AddElement(KopiPorost);
    VZapiOdd.DilecMN.AddElement(KopiDilec);
    VZapiOdd.DilecMN.AktualniPrvek:=KopiDilec;
    VZapiOdd.Dilec.porostMN.AktualniPrvek:=KopiPorost;
    // showmessage('Jsem za '+VZapiodd_Zal.Dilec.Porost.CeleOznaceni);

    iDil:=0;
    while iDil<VZapiOdd.DilecMN.count do
     begin
      if VZapiodd.IDilec[iDil]<>VZapiodd.Dilec then
       Begin
        VZapiodd.IDilec[iDil].Free;
       end
      else
       begin
        iPor:=0;
        while iPor<VZapiodd.Dilec.PorostMN.count do
         begin
          if VZapiodd.Dilec.IPorost[ipor]<>VZapiodd.Dilec.Porost then
           begin
            VZapiodd.Dilec.IPorost[ipor].free;
           end
          else
           begin
            inc(iPor);
           end;
         end;
        inc(iDil);
       end;
     end;
    VZapiOdd.smazCoNejsouVQuery(QP0444);
   end;
     if infoedit<>Nil then
       begin
        if  VZapiOdd.dilec.porost.PorostniSkupinaMN.count>0 then
         begin
          InfoEdit.Text:='tiskne se '+VZapiOdd.dilec.porost.celeOznaceni
              +' nov: '+VZapiOdd.dilec.porost.PorostniSkupina.StareOzn;
          InfoEdit.refresh;
         end
        else
         begin
          InfoEdit.Text:='tiskne se '+VZapiOdd.dilec.porost.celeOznaceni;
          InfoEdit.refresh;
         end;
       end;

  if VZapiOdd.dilec.Porost.PorostniSkupinaMN.Count = 0 then
   begin
    tiskSeUskutecnil:=false;
    if VZapiOdd_Zal<>nil then
     begin
      VZapiOdd.free;
      VZapiOdd:=VZapiOdd_Zal;
     end;
    exit;
   end
  else
   begin
    tiskSeUskutecnil:=true;
   end;
  Istrana:=0;
  with CanvasV do
   begin
    with VZapiOdd.Dilec.Porost do
     begin
      nastavBody;

      if not prvniPorost then
       begin
        if  QP0444=nil then
         begin
          if vZapiOdd.ODD<>predchODD then
           begin
            // HoleOdstrankovani;
            printer.EndDoc;
            printer.BeginDoc;
         // printer.NewPage;
            YSkup:=Y1+RadY;
           end;
         end;
       end;

      predchODD:=VZapiOdd.ODD;
      TiskniHlavickuStranky(y1);
      isk:=0;
      if prvniPorost then YSkup:=Y1+RadY;
      while iSk<porostniSkupinaMN.count do
       begin


        // IskTisk:=Isk;
        // if YKon>(YSkup+radY*PocetPozadovanychRadku(TPorostniSkupina(elements[IskTisk]))) do

        if YKon<(YSkup+radY*PocetPozadovanychRadku(IPorostniSkupina[Isk])) then
         begin
          holeOdstrankovani;
          if NaTiskarnu then
           begin
            YSkup:=Y1+RadY;
           end;
         // showmessage('cau strankuju pred '+IPorostniSkupina[Isk].CeleOznaceni);
          TiskniHlavickuStranky(Yskup-Rady);
         end;
      //  while true do
      //    begin
            tiskniPorSkup(IPorostniSkupina[Isk],YSkup);
            YSkup:=YSkup+PocetPozadovanychRadku(IPorostniSkupina[Isk])*RadY;
            inc(Isk);
      //     if Isk>porostniSkupinaMN.count-1 then break;
      //    end;
//           holeOdstrankovani;
       {
       if levaprava<>0 then
        begin
         TiskniEvidHlavickuPorostu;
         IskTisk:=Isk;
         while YKon>(YSkup+radY*PocetPozadovanychRadku(TPorostniSkupina(elements[IskTisk]))) do
          begin
           tiskniEvidPorSkup(TPorostniSkupina(elements[IskTisk]));
           inc(IskTisk);
           if IskTisk>count-1 then break;
          end;
         holeOdstrankovani;
        end;
       }
       // Isk:=IskTisk;
      end;
    end;
  end;
 strana1:=Strana1+IStrana;
        if  VZapiOdd.dilec.porost.PorostniSkupinaMN.count>0 then
         begin
          InfoEdit.Text:='Vytitno '+VZapiOdd.dilec.porost.celeOznaceni
              +' nov: '+VZapiOdd.dilec.porost.PorostniSkupina.StareOzn;
          InfoEdit.refresh;
         end
        else
         begin
          InfoEdit.Text:='Vytitno '+VZapiOdd.dilec.porost.celeOznaceni;
          InfoEdit.refresh;
         end;
 if VZapiOdd_Zal<>nil then
  begin
   VZapiOdd.free;
   VZapiOdd:=VZapiOdd_Zal;
  end;
end;
end.
