unit Dotaz;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls;

type
  TdotazF1 = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ButAnoVsem: TButton;
    ButNeVsem: TButton;
    procedure OKBtnClick      (Sender: TObject);
    procedure CancelBtnClick  (Sender: TObject);
    procedure FormShow        (Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButAnoVsemClick(Sender: TObject);
    procedure ButNeVsemClick(Sender: TObject);
  private
    { Private declarations }
  public
    odpoved:boolean;
    vsem:boolean;
    { Public declarations }
  end;

var
  dotazF2: TdotazF1;

implementation

{$R *.DFM}

procedure TdotazF1.OKBtnClick(Sender: TObject);
 begin
  vsem:=false;
  odpoved:=true;
  close;
 end;

procedure TdotazF1.CancelBtnClick(Sender: TObject);
begin
 odpoved:=false;
 vsem:=false;
 close;
end;

procedure TdotazF1.FormShow(Sender: TObject);
begin
 odpoved:=false;
 vsem:=false;
end;

procedure TdotazF1.FormClose(Sender: TObject; var Action: TCloseAction);
 begin
  Application.ProcessMessages;
 end;

procedure TdotazF1.ButAnoVsemClick(Sender: TObject);
begin
  vsem:=true;
  odpoved:=true;
  close;
end;

procedure TdotazF1.ButNeVsemClick(Sender: TObject);
begin
  vsem:=true;
  odpoved:=false;
  close;
end;

end.
