unit Sp_vyhso;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, FileCtrl, Buttons,
  ELesObec,E_Class,  Dotaz,
  dotazZad, mat1, ExtCtrls, Grids, u_Zobraz, Db, DBTables;

type
TUkazstGrmZdr=(ukazZdroje,neukazZdroje);

TZdroje   = class(TObecnyLesniPrvek)
private
 FLHC_KOD   :integer;
 FLHC_NAZ   :string;
 FZDROJ_ADR :string;
 FMDateTime :TDateTime;
 function getSDateTime:String;
 function getDateTimeJakoFloat:double;
public
published
 property  LHC_KOD   :integer         read FLHC_KOD   write FLHC_KOD;
 property  LHC_NAZ   :string          read FLHC_NAZ   write FLHC_NAZ;
 property  ZDROJ_ADR :string          read FZDROJ_ADR write FZDROJ_ADR;
 property  MDateTime :TDateTime       read FMDateTime write FMDateTime;
 property  SDateTime :String               read getSDateTime  stored false;
 property  DateTimeJakoMinusFloat :double  read getDateTimeJakoFloat  stored false;

end;

TZdrojeMN  = class(TLesniMnozina)
private
public
  constructor Create; override;
end;

  TS_VyhlSoub1 = class(TForm)
    Panel1: TPanel;
    DriveComboBox1: TDriveComboBox;
    ButNovAdr: TButton;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    ButAlias: TButton;
    Panel2: TPanel;
    Edit1: TEdit;
    Panel3: TPanel;
    FileListBox1: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    PanelStrGrm: TPanel;
    Table1: TTable;
    ButUbRad: TButton;
    procedure OKBtnClick(Sender: TObject);
    procedure OKBtnClickBezKopirovani(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure DriveComboBox1Change(Sender: TObject);
    procedure ButAliasClick(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure ButNovAdrClick(Sender: TObject);
    procedure ButCopFileClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButUbRadClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
     vybrano:Boolean;
     vybranAlias:Boolean;
     zmacknutNovAdr:Boolean;
     stGrmZdroje:TStringGridMuj;
     ZdrojeMN   :TZdrojeMN;
     procedure RePaint; override;
     procedure Prezobraz;
     procedure stGrmZdrojeClick(Sender: TObject);
     procedure viditelnostStrGrmZdroje(visibGrmZdr:TUkazstGrmZdr);
  published
  end;

var
  S_VyhlSoub1: TS_VyhlSoub1;
  NacitatZdrojeAdr: boolean;
Function Najdi_DB(vyrobitNovy:boolean;AdrDat,nazevOkna:String;visibGrmZdr:TUkazstGrmZdr):String;
Function Najdi_DBObecne(vyrobitNovy:boolean;AdrDat,nazevOkna,maska:String;muzeBytAlias:Boolean;visibGrmZdr:TUkazstGrmZdr):String;
Function Najdi_DBObecneBezKopirovaniSouboru(vyrobitNovy:boolean; AdrDat,nazevOkna,maska:String;muzeBytAlias:Boolean;visibGrmZdr:TUkazstGrmZdr):String;
Function Najdi_Soubor(AdrDat,nazevOkna,maska:String;visibGrmZdr:TUkazstGrmZdr):String;
Function Najdi_Adresar(AdrDat,nazevOkna,maska:String;visibGrmZdr:TUkazstGrmZdr):String;
Function Najdi_Adresar_IEdit(AdrDat,nazevOkna,maska:String;visibGrmZdr:TUkazstGrmZdr):String;
Function Najdi_DBObecneEdit(AdrDat,nazevOkna,maska:String;muzeBytAlias:Boolean;visibGrmZdr:TUkazstGrmZdr):String;
Function Najdi_AdresarNeboSoubor(AdrDat,nazevOkna,maska:String;visibGrmZdr:TUkazstGrmZdr):String;
function najdiVolnyNazevAdresare(Nazev:string):string;
procedure kopirujDoZdrojeSoubory(dokterehoAdresare:string);
procedure kopirujSouboryZAdresareDoAdresare(zekterehoAdresare,dokterehoAdresare:string);
procedure SmazVsechnySouboryVAdresari(zekterehoAdresare:string);
function  TabulkuDoExeAVratCestuNaTabulku(nazevTabACesta:String):String;
procedure vratTabulkuzExeDoAdr(nazevTabACesta:String);

implementation

{$R *.DFM}
procedure TS_VyhlSoub1.viditelnostStrGrmZdroje(visibGrmZdr:TUkazstGrmZdr);
 begin
  if visibGrmZdr=neukazZdroje then
   begin
    PanelStrGrm.visible:=false;
    ButUbRad.visible:=false;
    Width:=360;
   end
  else
   begin
    PanelStrGrm.visible:=true;
    ButUbRad.visible:=true;
    Width:=665;
   end;
 end;
Function Najdi_DB(vyrobitNovy:boolean;AdrDat,nazevOkna:String;visibGrmZdr:TUkazstGrmZdr):String;
 begin
  result:=Najdi_DBObecne(vyrobitNovy,AdrDat,nazevOkna,'*.DB',false,visibGrmZdr);
 end;

Function Najdi_DBObecneEdit(AdrDat,nazevOkna,maska:String;muzeBytAlias:Boolean;visibGrmZdr:TUkazstGrmZdr):String;
 begin
  Application.CreateForm(TS_VyhlSoub1, S_VyhlSoub1);
  S_VyhlSoub1.viditelnostStrGrmZdroje(visibGrmZdr);
  S_VyhlSoub1.caption:=nazevOkna;
  S_VyhlSoub1.fileListBox1.mask := maska;
  S_VyhlSoub1.butAlias.visible:=muzeBytAlias;
  S_VyhlSoub1.ButNovAdr.visible:=false;
  if DirectoryExists(AdrDat) then
     S_VyhlSoub1.DirectoryListBox1.Directory:=AdrDat
  else S_VyhlSoub1.DirectoryListBox1.Directory:='C:\';
  S_VyhlSoub1.showmodal;
  if S_VyhlSoub1.Vybrano then
   begin
    if S_VyhlSoub1.VybranAlias then result:='ALIAS'
    else
     begin
      result:=S_VyhlSoub1.Edit1.Text;
               //S_VyhlSoub1.DirectoryListBox1.Directory;
     end;
   end
  else
   begin
    result:='NicSeNevybralo';
   end;
  S_VYHLSOUB1.Free;
 end;


Function Najdi_DBObecne(vyrobitNovy:boolean; AdrDat,nazevOkna,maska:String;muzeBytAlias:Boolean;visibGrmZdr:TUkazstGrmZdr):String;
var
 zdS_VyhlSoub1:TS_VyhlSoub1;
 begin
  Application.CreateForm(TS_VyhlSoub1, zdS_VyhlSoub1);
  zdS_VyhlSoub1.viditelnostStrGrmZdroje(visibGrmZdr);
  zdS_VyhlSoub1.caption:=nazevOkna;
  zdS_VyhlSoub1.fileListBox1.mask := maska;
  zdS_VyhlSoub1.butAlias.visible:=muzeBytAlias;
  if DirectoryExists(AdrDat) then
     zdS_VyhlSoub1.DirectoryListBox1.Directory:=AdrDat
  else zdS_VyhlSoub1.DirectoryListBox1.Directory:='C:\';
  zdS_VyhlSoub1.ButNovAdr.Visible:=vyrobitNovy;
  zdS_VyhlSoub1.showmodal;
  if zdS_VyhlSoub1.Vybrano then
   begin
    if zdS_VyhlSoub1.VybranAlias then result:='ALIAS'
    else
     begin
      result:= zdS_VyhlSoub1.DirectoryListBox1.Directory;
     end;
   end
  else
   begin
    result:='NicSeNevybralo';
   end;
  zdS_VyhlSoub1.Free;
 end;
Function Najdi_DBObecneBezKopirovaniSouboru(vyrobitNovy:boolean; AdrDat,nazevOkna,maska:String;muzeBytAlias:Boolean;visibGrmZdr:TUkazstGrmZdr):String;
var
 zdS_VyhlSoub1:TS_VyhlSoub1;
 begin
  Application.CreateForm(TS_VyhlSoub1, zdS_VyhlSoub1);
  zdS_VyhlSoub1.viditelnostStrGrmZdroje(visibGrmZdr);
  zdS_VyhlSoub1.caption:=nazevOkna;
  zdS_VyhlSoub1.fileListBox1.mask := maska;
  zdS_VyhlSoub1.butAlias.visible:=muzeBytAlias;
  if DirectoryExists(AdrDat) then
     zdS_VyhlSoub1.DirectoryListBox1.Directory:=AdrDat
  else zdS_VyhlSoub1.DirectoryListBox1.Directory:='C:\';
  zdS_VyhlSoub1.ButNovAdr.Visible:=vyrobitNovy;
  zdS_VyhlSoub1.OKBtn.OnClick:=zdS_VyhlSoub1.OKBtnClickBezKopirovani;
  zdS_VyhlSoub1.showmodal;
  if zdS_VyhlSoub1.Vybrano then
   begin
    if zdS_VyhlSoub1.VybranAlias then result:='ALIAS'
    else
     begin
      result:= zdS_VyhlSoub1.DirectoryListBox1.Directory;
     end;
   end
  else
   begin
    result:='NicSeNevybralo';
   end;
  zdS_VyhlSoub1.Free;
 end;

Function Najdi_AdresarNeboSoubor(AdrDat,nazevOkna,maska:String;visibGrmZdr:TUkazstGrmZdr):String;
 begin
  Application.CreateForm(TS_VyhlSoub1, S_VyhlSoub1);
  S_VyhlSoub1.viditelnostStrGrmZdroje(visibGrmZdr);
  S_VyhlSoub1.caption:=nazevOkna;
  S_VyhlSoub1.fileListBox1.mask := maska;
  S_VyhlSoub1.butAlias.visible:=false;
  S_VyhlSoub1.ButNovAdr.visible:=false;
  if fileExists(AdrDat) then
   begin
    S_VyhlSoub1.FileListBox1.FileName:=AdrDat;
    S_VyhlSoub1.DirectoryListBox1.Directory:=KPoslednimuZnaku(AdrDat,'\');
    S_VyhlSoub1.edit1.Text:=AdrDat;
   end
  else
   begin
    if DirectoryExists(AdrDat) then
      S_VyhlSoub1.DirectoryListBox1.Directory:=AdrDat
    else S_VyhlSoub1.DirectoryListBox1.Directory:='C:\';
   end;
  S_VyhlSoub1.showmodal;
  if S_VyhlSoub1.Vybrano then
   begin
    // result:=S_VyhlSoub1.DirectoryListBox1.Directory;
    // result:=S_VyhlSoub1.FileListBox1.FileName;
    result:=S_VyhlSoub1.Edit1.Text;
   end
  else
   begin
    result:='NicSeNevybralo';
   end;
  S_VYHLSOUB1.Free;
 end;


Function Najdi_Soubor(AdrDat,nazevOkna,maska:String;visibGrmZdr:TUkazstGrmZdr):String;
 begin
  if visibGrmZdr=ukazZdroje then NacitatZdrojeAdr:=true;
   if visibGrmZdr=neukazZdroje then NacitatZdrojeAdr:=false;
  Application.CreateForm(TS_VyhlSoub1, S_VyhlSoub1);
  NacitatZdrojeAdr:=true;
  S_VyhlSoub1.caption:=nazevOkna;
  S_VyhlSoub1.fileListBox1.mask := maska;
  S_VyhlSoub1.viditelnostStrGrmZdroje(visibGrmZdr);
  S_VyhlSoub1.butAlias.visible:=false;
  S_VyhlSoub1.ButNovAdr.visible:=false;
  if DirectoryExists(AdrDat) then
     S_VyhlSoub1.DirectoryListBox1.Directory:=AdrDat
  else S_VyhlSoub1.DirectoryListBox1.Directory:='C:\';
  S_VyhlSoub1.showmodal;
  if S_VyhlSoub1.Vybrano then
   begin
    result:=S_VyhlSoub1.DirectoryListBox1.Directory;
    result:=S_VyhlSoub1.FileListBox1.FileName;
   end
  else
   begin
    result:='NicSeNevybralo';
   end;
  S_VYHLSOUB1.Free;
 end;

Function Najdi_Adresar(AdrDat,nazevOkna,maska:String;visibGrmZdr:TUkazstGrmZdr):String;
 begin
  Application.CreateForm(TS_VyhlSoub1, S_VyhlSoub1);
  S_VyhlSoub1.caption:=nazevOkna;
  S_VyhlSoub1.fileListBox1.mask := maska;
  S_VyhlSoub1.viditelnostStrGrmZdroje(visibGrmZdr);
  S_VyhlSoub1.butAlias.visible:=false;
  S_VyhlSoub1.ButNovAdr.visible:=false;
  if DirectoryExists(AdrDat) then
     S_VyhlSoub1.DirectoryListBox1.Directory:=AdrDat
  else S_VyhlSoub1.DirectoryListBox1.Directory:='C:\';
  S_VyhlSoub1.ButNovAdr.Visible:=false;
  S_VyhlSoub1.showmodal;
  if S_VyhlSoub1.Vybrano then
   begin
    result:=S_VyhlSoub1.DirectoryListBox1.Directory;
   end
  else
   begin
    result:='NicSeNevybralo';
   end;
  S_VYHLSOUB1.Free;
 end;

Function Najdi_Adresar_IEdit(AdrDat,nazevOkna,maska:String;visibGrmZdr:TUkazstGrmZdr):String;
 begin
  Application.CreateForm(TS_VyhlSoub1, S_VyhlSoub1);
  S_VyhlSoub1.caption:=nazevOkna;
  S_VyhlSoub1.viditelnostStrGrmZdroje(visibGrmZdr);
  S_VyhlSoub1.fileListBox1.mask := maska;
  S_VyhlSoub1.butAlias.visible:=false;
  S_VyhlSoub1.ButNovAdr.visible:=false;
  if DirectoryExists(AdrDat) then
     S_VyhlSoub1.DirectoryListBox1.Directory:=AdrDat
  else S_VyhlSoub1.DirectoryListBox1.Directory:='C:\';
  S_VyhlSoub1.showmodal;
  if S_VyhlSoub1.Vybrano then
   begin
    result:= S_VyhlSoub1.Edit1.text;
    // S_VyhlSoub1.DirectoryListBox1.Directory;
   end
  else
   begin
    result:='NicSeNevybralo';
   end;
  S_VYHLSOUB1.Free;
 end;

procedure kopirujDoZdrojeSoubory(dokterehoAdresare:string);
var
 Adr,Adr_PHS,HlAdr_PHS:string;
 dotazF4:TdotazF1;
 odp_maz:boolean;
begin
  if FileExists(dokterehoAdresare+'\oddeleni.db') then
   begin
     Application.CreateForm(TdotazF1,dotazF4);
     dotazF4.caption:='Dotaz na pepsn zdroje';
     dotazF4.label2.caption:='Adres '+dokterehoAdresare+' u obsahuje .DB soubory.';
     dotazF4.label3.caption:='Mm je pepsat ?';
     dotazF4.showmodal;
     odp_maz:=dotazF4.odpoved;
     dotazF4.Free;
     if odp_maz then exit;
   end;
  Adr:=KPoslednimuZnaku(Application.ExeName,'\')+'\PRAZDDATA\ZDROJ';
  Adr_PHS:=KPoslednimuZnaku(dokterehoAdresare,'\')+'\PHS';
  if not DirectoryExists(Adr_PHS) then
   begin
    hlAdr_PHS:=Najdi_Adresar(KPoslednimuZnaku(Application.ExeName,'\')+'\PRAZDDATA\PHS',
                          'U nov zaloenho zdroje chyb adres PHS. Vyhledej PHS','*.*',neukazZdroje);
    ForceDirectories(Adr_PHS);
    kopirujSouboryZAdresareDoAdresare(hlAdr_PHS,Adr_PHS);
   end;
  kopirujSouboryZAdresareDoAdresare(adr,dokterehoAdresare);
end;

procedure kopirujSouboryZAdresareDoAdresare(zekterehoAdresare,dokterehoAdresare:string);
var
 vysl:integer;
 SearchRec1: TSearchRec;
 Adr,adrName,kamAdrName:string;
 odkud, kam :Pchar;
begin
   Adr:=zekterehoAdresare;
   // KPoslednimuZnaku(Application.ExeName,'\')+'\CVICDATA\ZDROJ2006';
   vysl:=FindFirst(Adr+'\*.*', faAnyFile, SearchRec1);
   while vysl=0 do
    begin
     vysl:=findnext(SearchRec1);
     // showmessage(SearchRec1.Name);
     adrName:=adr+'\'+SearchRec1.Name;
     kamAdrName:=dokterehoAdresare+'\'+SearchRec1.Name;
     odkud:=PChar(adrName);
     kam:=PChar(kamAdrName);
  // odkud:='C:\DATAMoje\Babka\Babka.zip';
  // kam:='C:\DATAMoje\kukuc.zip';
     copyfile(odkud, kam,false);
    end;
  sysUtils.FindClose(SearchRec1);
end;
procedure SmazVsechnySouboryVAdresari(zekterehoAdresare:string);
var
 vysl:integer;
 SearchRec1: TSearchRec;
 Adr:string;
 adrName:pchar;
begin
   Adr:=zekterehoAdresare;
   vysl:=FindFirst(Adr+'\*.*', faAnyFile, SearchRec1);
   while vysl=0 do
    begin
     vysl:=findnext(SearchRec1);
     adrName:=pchar(adr+'\'+SearchRec1.Name);
     deletefile(adrname);
    end;
  sysUtils.FindClose(SearchRec1);
end;

procedure vratTabulkuzExeDoAdr(nazevTabACesta:String);
var
 jmenoTab,tabVExe:string;
 begin
  jmenotab:=OdPoslednihoZnaku(nazevTabACesta,'\');
  jmenotab:=KPoslednimuZnaku(jmenotab,'.');
  tabVExe:=KPoslednimuZnaku(Application.ExeName,'\')+'\'+jmenotab+'.db';
  CopyFile(Pchar(tabVExe),Pchar(nazevTabACesta),false);
  deletefile(Pchar(tabVExe));

  if FileExists(copy(tabVExe,1,length(tabVExe)-2)+'px') then
   begin
    CopyFile(Pchar(copy(tabVExe,1,length(tabVExe)-2)+'px'),
             Pchar(copy(nazevTabACesta,1,length(nazevTabACesta)-2)+'px'),false);
    deletefile(Pchar(copy(tabVExe,1,length(tabVExe)-2)+'px'));
   end;
 end;

function TabulkuDoExeAVratCestuNaTabulku(nazevTabACesta:String):String;
var
 jmenoTab:string;
 begin
  jmenotab:=OdPoslednihoZnaku(nazevTabACesta,'\');
  jmenotab:=KPoslednimuZnaku(jmenotab,'.');
  result:=KPoslednimuZnaku(Application.ExeName,'\')+'\'+jmenotab+'.db';
  CopyFile(Pchar(nazevTabACesta),Pchar(result),false);
  if FileExists( copy(nazevTabACesta,1,length(nazevTabACesta)-2)+'px') then
   begin
    CopyFile(Pchar(copy(nazevTabACesta,1,length(nazevTabACesta)-2)+'px'),Pchar(copy(result,1,length(result)-2)+'px'),false);
   end;
  end;
//        adrTbDb:=KPoslednimuZnaku(Application.ExeName,'\')+'/etaz.db';
//        CopyFile(Pchar(AdresarTabulek+'/etaz.db'),Pchar(adrTbDb),false);
//        CopyFile(Pchar(AdresarTabulek+'/etaz.px'),Pchar(copy(adrTbDb,1,length(adrTbDb)-2)+'px'),false);


procedure TS_VyhlSoub1.OKBtnClick(Sender: TObject);
var VZdroje :TZdroje;
begin
 if zmacknutNovAdr then
  begin
   kopirujDoZdrojeSoubory(edit1.Text);
   {
   Adr:=KPoslednimuZnaku(Application.ExeName,'\')+'\CVICDATA\ZDROJ2006';
   vysl:=FindFirst(Adr+'\*.*', faAnyFile, SearchRec1);
   while vysl=0 do
    begin
     vysl:=findnext(SearchRec1);
     // showmessage(SearchRec1.Name);
     adrName:=adr+'\'+SearchRec1.Name;
     kamAdrName:=edit1.Text+'\'+SearchRec1.Name;
     odkud:=PChar(adrName);
     kam:=PChar(kamAdrName);
  // odkud:='C:\DATAMoje\Babka\Babka.zip';
  // kam:='C:\DATAMoje\kukuc.zip';
     copyfile(odkud, kam,false);
    end;
   if not DirectoryExists(KPoslednimuZnaku(edit1.Text,'\')+'\PHS') then
    begin
    end;
    }
  end;
 vybrano:=true;
 if not ZdrojeMN.HodnotaPropertyExistuje('ZDROJ_ADR',edit1.Text) then
  begin
   if ZdrojeMN.count>8 then
    begin
     VZdroje:=tZdroje(ZdrojeMN.Maxprvek('DateTimeJakoMinusFloat'));
    end
   else
    begin
     VZdroje :=TZdroje.create;
     ZdrojeMN.AddElement(VZdroje);
    end;
   VZdroje.ZDROJ_ADR:=edit1.Text;
  end
 else
  begin
   VZdroje :=TZdroje(ZdrojeMN.PrvekPodleHodnotyProperty('ZDROJ_ADR',edit1.Text));
  end;
 if FileExists(edit1.Text+'\LHC.DB') then
  begin
   table1.TableName:=edit1.Text+'\LHC.DB';
   table1.open;
   VZdroje.LHC_KOD:=table1.fieldByName('LHC_KOD').asinteger;
   VZdroje.LHC_NAZ:=table1.fieldByName('LHC_NAZ').asstring;
   VZdroje.MDateTime:=now;
   table1.close;
   UlozDoOrbu(ZdrojeMN,KPoslednimuZnaku(Application.ExeName,'\')+'\ZdrojeAdr.Orb',0);
   close;
  end;
end;
procedure TS_VyhlSoub1.OKBtnClickBezKopirovani(Sender: TObject);
var VZdroje :TZdroje;
begin
 {
 if zmacknutNovAdr then
  begin
   kopirujDoZdrojeSoubory(edit1.Text);
  end;
 }
 vybrano:=true;
 if not ZdrojeMN.HodnotaPropertyExistuje('ZDROJ_ADR',edit1.Text) then
  begin
   if ZdrojeMN.count>8 then
    begin
     VZdroje:=tZdroje(ZdrojeMN.Maxprvek('DateTimeJakoMinusFloat'));
    end
   else
    begin
     VZdroje :=TZdroje.create;
     ZdrojeMN.AddElement(VZdroje);
    end;
   VZdroje.ZDROJ_ADR:=edit1.Text;
  end
 else
  begin
   VZdroje :=TZdroje(ZdrojeMN.PrvekPodleHodnotyProperty('ZDROJ_ADR',edit1.Text));
  end;
 {
 if FileExists(edit1.Text+'\LHC.DB') then
  begin
   table1.TableName:=edit1.Text+'\LHC.DB';
   table1.open;
   VZdroje.LHC_KOD:=table1.fieldByName('LHC_KOD').asinteger;
   VZdroje.LHC_NAZ:=table1.fieldByName('LHC_NAZ').asstring;
   VZdroje.MDateTime:=now;
   table1.close;
   UlozDoOrbu(ZdrojeMN,KPoslednimuZnaku(Application.ExeName,'\')+'\ZdrojeAdr.Orb',0);
   close;
  end;
 }
  close;
end;


function TZdroje.getDateTimeJakoFloat:double;
 begin
  result:=-Mdatetime;
 end;

function TZdroje.getSDateTime:String;
 begin
  result:={TimeToStr(FMDateTime)+'  '+}  DateTimeToStr(FMDateTime);
 end;

procedure TS_VyhlSoub1.CancelBtnClick(Sender: TObject);
begin
 vybrano:=false;
 close;
end;

procedure TS_VyhlSoub1.DirectoryListBox1Change(Sender: TObject);
 begin
  DriveComboBox1.OnChange:=nil;
  DriveComboBox1.Drive:=DirectoryListBox1.Drive;
  DriveComboBox1.OnChange:=DriveComboBox1Change;
  filelistBox1.Directory:=DirectoryListBox1.Directory;
  edit1.text:=filelistBox1.Directory;
  edit1.refresh;
 end;

procedure TS_VyhlSoub1.FormActivate(Sender: TObject);
 begin
  vybrano:=false;
  vybranAlias:=false;
  zmacknutNovAdr:=false;
  Prezobraz;
 end;

procedure TS_VyhlSoub1.DriveComboBox1Change(Sender: TObject);
 begin
  DirectoryListBox1.Drive:=DriveComboBox1.Drive;
 end;

procedure TS_VyhlSoub1.ButAliasClick(Sender: TObject);
 begin
  Vybrano := true;
  vybranAlias := true;
  close;
 end;

procedure TS_VyhlSoub1.FileListBox1Change(Sender: TObject);
begin
  edit1.text:=filelistBox1.FileName;
  edit1.refresh;
end;

procedure TS_VyhlSoub1.ButNovAdrClick(Sender: TObject);
var
 Adr_xml,Adr_PHS:string;
begin
 Application.CreateForm(TFdotazZad,FdotazZad);
 FdotazZad.caption:='Vyhledn etzce';
 FdotazZad.label1.caption:='Zadej nzev novho adrese:';
 FdotazZad.label2.caption:='';
 FdotazZad.Label3.caption:='';
 FdotazZad.Label4.caption:='';
 FdotazZad.edit2.Visible:=false;
 FdotazZad.CheckBox1.Visible:=false;
 FdotazZad.Edit1.Text:='zdroj';
 FdotazZad.ActiveControl:=FdotazZad.Edit1;
 FdotazZad.showModal;
 if FdotazZad.odpoved=false then
  begin
   FdotazZad.free;
   exit;
  end;
 Adr_xml:=trim(FdotazZad.Edit1.Text);
 FdotazZad.free;

  Adr_xml:=DirectoryListBox1.Directory+'/'+Adr_xml;
  ForceDirectories(Adr_xml);
  if DirectoryExists(Adr_xml) then
   begin
    if not SetCurrentDir(Adr_xml) then
     begin
      exit;
     end
    else
     begin
      zmacknutNovAdr:=true;
      DirectoryListBox1.Directory:=Adr_xml;
      refresh;
     end;
   end;
{ Adr_PHS:=KPoslednimuZnaku(Adr_xml,'\')+'\PHS');
 if not DirectoryExists(Adr_PHS) then
  begin
   Adr_PHS:=Najdi_Adresar(KPoslednimuZnaku(Application.ExeName,'\')+'\vtx.ini',
                          'U nov zaloenho zdroje chyb adres PHS. Vyhledej PHS','*.*');

  end;     }
end;

procedure TS_VyhlSoub1.ButCopFileClick(Sender: TObject);
var
  odkud, kam :Pchar;
begin
  odkud:='C:\DATAMoje\Babka\Babka.zip';
  kam:='C:\DATAMoje\kukuc.zip';
  copyfile(odkud, kam,false);
end;
function najdiVolnyNazevAdresare(Nazev:string):string;
var i:integer;
 begin
  i:=1;
  while DirectoryExists(nazev+'('+inttostr(i)+')') do
   begin
    inc(i);
   end;
  result:=nazev+'('+inttostr(i)+')';
 end;
procedure TS_VyhlSoub1.FormCreate(Sender: TObject);
var
   i:integer;
 begin
  stGrmZdroje:=TStringGridMuj.Create(Self);
  with stGrmZdroje do
   begin
    name:='StGrmZdroje';
    NastavStringGridMujNaTax200(stGrmZdroje);
    // NastavStringGridMujNaTaxPHS(stGrmDrKtgPhs);
    Parent := PanelStrGrm;
    align  := alClient;
    menitRowHeights:=true;
    fixedCols:=0;
    //top    := 23;
    //left   := 2;
    //height := GroupJP.height-25;
    //width  := GroupJP.width-5;
    //ctl3d  := False;
    ZobrazeniGridu:=vybranePole;
   if NacitatZdrojeAdr then
    begin
     if fileExists(KPoslednimuZnaku(Application.ExeName,'\')+'\ZdrojeAdr.Orb') then
      begin
       ZdrojeMN:=TZdrojeMN(NactiZOrbu(KPoslednimuZnaku(Application.ExeName,'\')+'\ZdrojeAdr.Orb',true));
      end
     else
      begin
       ZdrojeMN:=TZdrojeMN.create;
      end;
    end
   else
    begin
      ZdrojeMN:=TZdrojeMN.create;
    end;
    ObLesMN:=ZdrojeMN;

    NastavGrid;
    with VlastnostiSloupcuMN do
     begin
      for I:=0 to count-1 do
       begin
        with TVlastnostiSloupcu(elements[i]) do
         begin
          viditelny:=False;
         end;
       end;

      JmenoAktualnihoPrvku:='LHC_KOD';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=5*kr;
        Nadpis:='LHC_KOD';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='LHC_NAZ';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=20*kr;
        Nadpis:='LHC_NAZ';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='ZDROJ_ADR';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=73*kr;
        Nadpis:='Adres zdroje dat LHC';
        poziceTisku:=nalevo;
       end;

      JmenoAktualnihoPrvku:='SDateTime';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=20*kr;
        Nadpis:='Posledn pihlen';
        poziceTisku:=uprostred;
       end;
     end;
    PripravZobrazeniGridu;
    options:=[goFixedVertLine,goFixedHorzLine,goVertLine,goHorzLine,goRangeSelect,goEditing];
   end;
 end;


constructor TZdrojeMN.Create;
 begin
  inherited create;
  FClass:=TZdroje;
  FPredponaName:='Zdroje';
 end;

procedure TS_VyhlSoub1.RePaint;
 begin
  prezobraz;
  inherited repaint;
 end;

procedure TS_VyhlSoub1.PreZobraz;
 begin
    with stGrmZdroje do
     begin
      ObLesMN:=ZdrojeMN;
      mnozinuDoGridu;
     end;
 end;
procedure TS_VyhlSoub1.stGrmZdrojeClick(Sender: TObject);
begin
 if ActiveControl=stGrmZdroje then
  begin
   Edit1.Text:=TZdroje(ZdrojeMN.elements[stGrmZdroje.row-1]).ZDROJ_ADR;
   Edit1.refresh;
   DirectoryListBox1.Directory:=Edit1.Text;
   DirectoryListBox1.Refresh;
  end;
end;

procedure TS_VyhlSoub1.FormShow(Sender: TObject);
begin
  stGrmZdroje.onClick:=stGrmZdrojeClick;
end;

procedure TS_VyhlSoub1.ButUbRadClick(Sender: TObject);
begin
 stGrmZdroje.SmazRadek;
 stGrmZdroje.refresh;
end;

initialization

 registerOrbisClass(TZdroje);
 registerOrbisClass(TZdrojeMN);
 NacitatZdrojeAdr:=true;
end.
