unit EKursor;

interface
uses
  dialogs,
  Elements,E_Type,Classes,E_Class,Forms,sysUtils,
  controls,stdctrls,
  EKolDot,U_Podmin,T_oper,creacond,
  E_LesCel,mat1,UCasomir;
type
TPredPo=(napred,potom);
TOkynkoTlacitko = class (TOwnerEntity)
 private
 published
 end;


TPodminkaSkoku  = class (TOwnerEntity)
 private
  FPodminka:string;
 published
  property Podminka:string read FPodminka write FPodminka;
 end;

TAkcePoExitu = class (TPodminkaSkoku)
 private
 published
 end;

TAkcePoEntru = class (TPodminkaSkoku)
 private
 published
 end;

TAkcePoEntruIhned = class (TPodminkaSkoku)
 private
 published
 end;

TPohybKurzoru   = class (TOwnerEntity)
 private
 published
 end;

// function NactiPohybKurzoru(jmenoACestaNaOil:string):TPohybKurzoru;
procedure NactiPohybKurzoruZOilu(jmenoACestaNaOil:string);
function  ActiveControlPodleKurzoru(PuvActiveControl:String;PredPo:TPredPo):String;
procedure provedAkcePoEntru(PuvActiveControl:String;var alesponJednaAkceProvedena:Boolean);
procedure provedAkcePoExitu(PuvActiveControl:String;var alesponJednaAkceProvedena:Boolean);
procedure provedAkcePoEntruIhned(PuvActiveControl:String;var alesponJednaAkceProvedena,obnovobrazovkuIhned:Boolean);
procedure NastavAktivniPrvek(VForm:TForm;AktivniPrvek:String;DejDropDown:boolean);
function  LHCVyhovujePodmince(SPodminka:String):boolean;
procedure provedAkci(SAkce:String);
implementation

uses
   t_CmdLn,m_Orbis,Worlds,u_props,U_Zobraz;

procedure provedAkci(SAkce:String);
var
  LHCPrezCele:TLHCPrezCele;
  VLesniCelek:TlesniCelek;
 begin
  LHCPrezCele:=TLHCPrezCele.create;
  VLesniCelek:=TlesniCelek(World.objectmodel.FindElementName('TLesniCelek'));
  LHCPrezCele.LHCpc:=VlesniCelek.LHC;
  SAkce:=SmazPosledniZnaky(SAkce,'%');
  LHCPrezCele.SetPropertyBooleanByName(SAkce,true);
 end;
function  LHCVyhovujePodmince(SPodminka:String):boolean;
var
  Cond: TCondition;
  LHCPrezCele:TLHCPrezCele;
  VLesniCelek:TlesniCelek;
 begin
  if upperCase(ubm(SPodminka))='VZDY' then
   begin
    result:=true;
    exit;
   end;
  Cond:=CreateCondition(SPodminka);
  LHCPrezCele:=TLHCPrezCele.create;
  VLesniCelek:=TlesniCelek(World.objectmodel.FindElementName('TLesniCelek'));
  LHCPrezCele.LHCpc:=VlesniCelek.LHC;
  if ElementvyhovujePodmince(LHCPrezCele,cond) then
   begin
    result:=true;
   end
  else
   begin
    result:=false;
   end;
  LHCPrezCele.free;
  Cond.Free;
 end;

function  ActiveControlPodleKurzoru(PuvActiveControl:String;PredPo:TPredPo):String;
var PohKurz:TPohybKurzoru;
    puvOkynTlac:TOkynkoTlacitko;
    i:integer;
    SPodminka,SPredPO:string;
 begin
  PohKurz:=TPohybKurzoru(World.objectmodel.FindElementName('PohybKurzoru'));
  if PohKurz=nil then
   begin
    result:='PohybKurzoru=nil';
    exit;
   end;
  puvOkynTlac:=TOkynkoTlacitko(PohKurz.FindElementName(PuvActiveControl));
  if puvOkynTlac=nil then
   begin
    result:='PohybKurzoru=nil';
   end
  else
   begin
    for i:=0 to puvOkynTlac.count-1 do
     begin
      if      (puvOkynTlac.Elements[i] is TPodminkaSkoku)
          and (not(puvOkynTlac.Elements[i] is TAkcePoEntru))
          and (not(puvOkynTlac.Elements[i] is TAkcePoExitu))
          and (not(puvOkynTlac.Elements[i] is TAkcePoEntruIhned))
           then
       begin
        RozdelDlePrvnihoStringu(TPodminkaSkoku(puvOkynTlac.Elements[i]).Podminka,'::',SPodminka,SPredPo);
        SPredPo:=ubm(uppercase(SPredPo));
        // SPredPo:=ubm(uppercase(OdPoslednihoZnaku(TPodminkaSkoku(puvOkynTlac.Elements[i]).Podminka,':')));
        if PredPo=napred then
         begin
          if SPredPO<>'NAPRED' then
           begin
            result:='';
            exit;
           end;
         end;
        if PredPo=Potom then
         begin
          if SPredPO='NAPRED' then
           begin
            result:='';
            exit;
           end;
         end;
        // SPodminka:=KPoslednimuZnaku(TPodminkaSkoku(puvOkynTlac.Elements[i]).Podminka,':');
        try
        if LHCVyhovujePodmince(SPodminka) then
         begin
          result:=TPodminkaSkoku(PuvOkynTlac.Elements[i]).FindElementClass(TOkynkoTlacitko).name;
          exit;
         end;
        except
         showmessage('Nedoku vyhodnotit podminku "'+SPodminka+'".');
         exit;
        end;
       end;
     end;
   end;
 end;


procedure provedAkcePoEntru(PuvActiveControl:String;var alesponJednaAkceProvedena:Boolean);
var PohKurz:TPohybKurzoru;
    puvOkynTlac:TOkynkoTlacitko;
    i:integer;
 begin
  PohKurz:=TPohybKurzoru(World.objectmodel.FindElementName('PohybKurzoru'));
  alesponJednaAkceProvedena:=false;
  if PohKurz=nil then exit;
  puvOkynTlac:=TOkynkoTlacitko(PohKurz.FindElementName(PuvActiveControl));
  if puvOkynTlac=nil then
   begin
   end
  else
   begin
    for i:=0 to puvOkynTlac.count-1 do
     begin
      if puvOkynTlac.Elements[i] is TAkcePoEntru then
       begin
        if LHCVyhovujePodmince(TAkcePoEntru(puvOkynTlac.Elements[i]).Podminka) then
         begin
           provedAkci(TAkcePoEntru(PuvOkynTlac.Elements[i]).name);
           alesponJednaAkceProvedena:=true;
         end;
       end;
     end;
   end;
 end;

procedure provedAkcePoEntruIhned(PuvActiveControl:String;var alesponJednaAkceProvedena,obnovobrazovkuIhned:Boolean);
var PohKurz:TPohybKurzoru;
    puvOkynTlac:TOkynkoTlacitko;
    i:integer;
 begin
  PohKurz:=TPohybKurzoru(World.objectmodel.FindElementName('PohybKurzoru'));
  alesponJednaAkceProvedena:=false;
  obnovobrazovkuIhned:=false;
  if PohKurz=nil then exit;
  puvOkynTlac:=TOkynkoTlacitko(PohKurz.FindElementName(PuvActiveControl));
  if puvOkynTlac=nil then
   begin
   end
  else
   begin
    for i:=0 to puvOkynTlac.count-1 do
     begin
      if puvOkynTlac.Elements[i] is TAkcePoEntruIhned then
       begin
        if LHCVyhovujePodmince(TAkcePoEntruIhned(puvOkynTlac.Elements[i]).Podminka) then
         begin
           provedAkci(TAkcePoEntruIhned(PuvOkynTlac.Elements[i]).name);
           alesponJednaAkceProvedena:=true;
           if ubm(lowercase(SmazPosledniZnaky(TAkcePoEntruIhned(PuvOkynTlac.Elements[i]).name,'%')))='obnovobrazovku' then
            begin
             obnovobrazovkuIhned:=true;
            end;
         end;
       end;
     end;
   end;
 end;

procedure provedAkcePoExitu (PuvActiveControl:String;var alesponJednaAkceProvedena:Boolean);
var PohKurz:TPohybKurzoru;
    puvOkynTlac:TOkynkoTlacitko;
    i:integer;
 begin
  // Application.ProcessMessages;  showmessage('cau provadimAkcePoExitu');
  PohKurz:=TPohybKurzoru(World.objectmodel.FindElementName('PohybKurzoru'));
  alesponJednaAkceProvedena:=false;
  if PohKurz=nil then exit;
  puvOkynTlac:=TOkynkoTlacitko(PohKurz.FindElementName(PuvActiveControl));
  if puvOkynTlac=nil then
   begin
   end
  else
   begin
    for i:=0 to puvOkynTlac.count-1 do
     begin
      if puvOkynTlac.Elements[i] is TAkcePoExitu then
       begin
        if LHCVyhovujePodmince(TAkcePoExitu(puvOkynTlac.Elements[i]).Podminka) then
         begin
           provedAkci(TAkcePoExitu(PuvOkynTlac.Elements[i]).name);
           alesponJednaAkceProvedena:=true;
         end;
       end;
     end;
   end;
  // Application.ProcessMessages; showmessage('cau koncimAkcePoExitu');
 end;

procedure NastavAktivniPrvek(VForm:TForm;AktivniPrvek:String;DejDropDown:boolean);
var
  i: Integer;
  Temp: TWinControl;
  AktivniProperta,AktivniPrvek1:String;
 begin
  RozdelDlePrvnihoStringu(AktivniPrvek,'#',AktivniPrvek1,AktivniProperta);
  AktivniPrvek1:=uppercase(AktivniPrvek1);
  // showmessage('cau='+AktivniPrvek1+'=='+AktivniProperta);
  Temp:=nil;
  for i:=0 to VForm.ComponentCount - 1  do
   begin
    // showmessage('cau='+VForm.Components[I].name);
    if uppercase(VForm.Components[I].name)=AktivniPrvek1 then
     begin
      if VForm.Components[I] is  TWinControl then
       begin
        Temp := TWinControl(VForm.Components[I]);
        break;
       end
      else
       begin
        if AktivniPrvek1<>'' then
         begin
          showmessage('Nastavovan kontrola "'+AktivniPrvek1+'" neni typu TWinControl');
         end;
       end;
     end;
   end;
  if temp<>nil then
   begin
    if temp.visible=false then temp.Visible:=true;
    VForm.ActiveControl:=temp;
    if temp is TStringGridMuj then
     begin
      TStringGridMuj(temp).LRow:=TStringGridMuj(temp).RowAktualnihoPrvku;
      //  TStringGridMuj(temp).Row:=AktivniRow;
      TStringGridMuj(temp).col:=TStringGridMuj(temp).ColDleProperty(AktivniProperta);
      if temp.visible=false then temp.Visible:=true;
      VForm.ActiveControl:=temp;
     end;
    if temp is TComboBox then
     begin
      if DejDropDown then TComboBox(temp).DroppedDown:=true;
     end;
   end;
  vypnicas;
 end;

procedure NactiPohybKurzoruZOilu(jmenoACestaNaOil:string);
var
   CM: TCommandLine;
begin
   CM := TCommandLine.Create;
   CM.FileName:= JmenoACestaNaOIL;
   CM.DoIt;
   CM.Free;
end;
{
function NactiPohybKurzoru(jmenoACestaNaOil:string):TPohybKurzoru;
var okTlac:TOkynkoTlacitko;
    podm:TPodminkaSkoku;
    PohKur:TPohybKurzoru;
 begin
  showmessage(jmenoACestaNaOil);
  PohKur:=TPohybKurzoru.create;
  okTlac:=TOkynkoTlacitko.create;
  okTlac.Name:='PrvniOkynko';
  PohKur.AddElement(OkTlac);
  okTlac:=TOkynkoTlacitko.create;
  okTlac.Name:='DruhyOkynko';
  PohKur.AddElement(OkTlac);
  okTlac:=TOkynkoTlacitko.create;
  okTlac.Name:='TretiOkynko';
  PohKur.AddElement(OkTlac);
  okTlac:=TOkynkoTlacitko.create;
  okTlac.Name:='StvrtyOkynko';
  PohKur.AddElement(OkTlac);

  podm:=TPodminkaSkoku.create;
  podm.Name:='PrvniPodminka';
  podm.Podminka:='rozhodni dle prvni podmiky';
  TOkynkoTlacitko(PohKur.GetElement('DruhyOkynko')).AddElement(Podm);
  Podm.AddElement(PohKur.GetElement('TretiOkynko'));

  podm:=TPodminkaSkoku.create;
  podm.Name:='DruhaPodminka';
  podm.Podminka:='rozhodni dle druhy podmiky';
  TOkynkoTlacitko(PohKur.GetElement('DruhyOkynko')).AddElement(Podm);
  Podm.AddElement(PohKur.GetElement('StvrtyOkynko'));

  podm:=TPodminkaSkoku.create;
  podm.Name:='TretiPodminka';
  podm.Podminka:='rozhodni dle treti podmiky';
  TOkynkoTlacitko(PohKur.GetElement('DruhyOkynko')).AddElement(Podm);
  Podm.AddElement(PohKur.GetElement('DruhyOkynko'));

  result:=PohKur;
 end;
}
initialization
 registerOrbisClass(TOkynkoTlacitko);
 registerOrbisClass(TPodminkaSkoku);
 registerOrbisClass(TPohybKurzoru);
 registerOrbisClass(TAkcePoExitu);
 registerOrbisClass(TAkcePoEntru);
 registerOrbisClass(TAkcePoEntruIhned);
end.
