unit HkKrkonose;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls,printers,IniFiles,
  mat1,E_LesOdd,E_LesCel,U_Zobraz,ELesObec,//HKSumav2,
  excelImpl,
  U_string,elements;


procedure DoExceluPorostKrkonose(  VPorost:TPorost;
                         var strana:integer;
                         strana_pozadovana_k_tiskuI,od_StranyI,do_StranyI:integer;
                         levaprava:byte;
                         VyskaStrankyVmm:double;
                         infoEdit :TEdit; sevidenci:Boolean);

procedure SmazPrvniRadkyKrkonose;

var
 PosledniRadekSumav:integer;
 jePrava:boolean;
 KopirovatRadky:Boolean;

implementation
procedure DoExceluPorostKrkonose(  VPorost:TPorost;
                         var strana:integer;
                         strana_pozadovana_k_tiskuI,od_StranyI,do_StranyI:integer;
                         levaprava:byte;
                         VyskaStrankyVmm:double;
                         infoEdit :TEdit; sevidenci:Boolean);


Procedure VyplnHlaZalesneni(VZalesneni:TZalesneni;strana:integer;PrvniRadekHl:integer;
                          tiskniNaOstro:boolean;var predpoklVyska:double);
var p:integer;
    ss:string;

 begin
    p:=PrvniRadekHl;
   if tiskniNaOstro then
    begin
      if infoedit<>Nil then
       begin
        InfoEdit.Text:=VZalesneni.CeleOznaceni;
        InfoEdit.refresh;
       end;

     ZapisDoBunkyZemFormula(p,14,VZalesneni.ZAL_DR);
     ZapisDoBunkyZemFormuladouble(p,15,VZalesneni.ZAL_DR_P);
     ZapisDoBunkyZemFormuladouble(p,16,VZalesneni.ZAL_P);


   end;
 end;

Procedure VyplnHlaDrev(VDrevina:TDrevina;strana:integer;PrvniRadekHl:integer;
                          tiskniNaOstro:boolean;var predpoklVyska:double);
var p:integer;
    ss:string;

 begin
    p:=PrvniRadekHl;
   if tiskniNaOstro then
    begin
      if infoedit<>Nil then
       begin
        InfoEdit.Text:=VDrevina.CeleOznaceni;
        InfoEdit.refresh;
       end;

     ZapisDoBunkyZemFormula(p,3,VDrevina.DR_ZKR);
     ZapisDoBunkyZemFormuladouble(p,4,VDrevina.ZAST);
     ZapisDoBunkyZemFormula(p,7,VDrevina.GEN_KLAS);
     if VDrevina.PoskozeniMN.Count>0 then
      begin
       ZapisDoBunkyZemFormuladouble(p,8,VDrevina.iPoskozeni[0].POSKOZ_D);
       ZapisDoBunkyZemFormuladouble(p,9,VDrevina.iPoskozeni[0].POSKOZ_R);
      end;
     ZapisDoBunkyZemFormula(p,10,VDrevina.IMISE);
   end;
 end;

Procedure VyplnHlaEtaze(VEtaz:TEtaz;strana:integer;PrvniRadekHl:integer;
                          tiskniNaOstro:boolean;var predpoklVyska:double);
var p, iEt:integer;
    ss:string;

 begin
    p:=PrvniRadekHl;
   if tiskniNaOstro then
    begin
      if infoedit<>Nil then
       begin
        InfoEdit.Text:=VEtaz.CeleOznaceni;
        InfoEdit.refresh;
       end;

     ZapisDoBunkyZemFormula(p,1,VEtaz.ETAZ);
     ZapisDoBunkyZemFormuladouble(p,2,VEtaz.ETAZ_PS);
     ZapisDoBunkyZemFormuladouble(p,5,VEtaz.Etaz_ZAS_HA);
     ZapisDoBunkyZemFormuladouble(p,6,VEtaz.OwnerPorostniSkupina.PRIB_VZD);
    // ZapisDoBunkyZemFormuladouble(p,6,VEtaz.Etaz_ZAS_CELK);
     if  ubm(VEtaz.PRO_NAL)<>'' then ZapisDoBunkyZemFormula(p,11,VEtaz.PRO_NAL);
     if  ubm(VEtaz.TV_NAL)<>''  then ZapisDoBunkyZemFormula(p,11,VEtaz.TV_NAL);
     if  ubm(VEtaz.TO_NAL)<>''  then ZapisDoBunkyZemFormula(p,11,VEtaz.TO_NAL);
     if  VEtaz.PRO_P>0.001 then ZapisDoBunkyZemFormulaDouble(p,13,VEtaz.PRO_P);
     if  VEtaz.TV_P>0.001  then ZapisDoBunkyZemFormulaDouble(p,13,VEtaz.TV_P);
     if  VEtaz.TO_P>0.001  then ZapisDoBunkyZemFormulaDouble(p,13,VEtaz.TO_P);

   end;
 end;

 Procedure VyplnHlaPorostniSkupiny(VPorostniSkupina:TPorostniSkupina;strana:integer;PrvniRadekHl:integer;
                          tiskniNaOstro:boolean;var predpoklVyska:double);
var p, iEt:integer;
    ss:string;

 begin
    p:=PrvniRadekHl;
   if tiskniNaOstro then
    begin
      if infoedit<>Nil then
       begin
        InfoEdit.Text:=VPorostniSkupina.CeleOznaceni;
        InfoEdit.refresh;
       end;
     if JePrava then
      begin
       ZapisDoBunkyZemFormula(p+1,16,VPorostniSkupina.PSK);
       ZapisDoBunkyZemFormuladouble(p+1,14,VPorostniSkupina.PSK_P);

       ZapisDoBunkyZemFormula(p+1, 1,VPorostniSkupina.LT);
       ZapisDoBunkyZemFormula(p+1, 2,inttostr(VPorostniSkupina.Ietaz[0].HS)); //VTVL
       ZapisDoBunkyZemFormula(p+1, 3,inttostr(VPorostniSkupina.LVS));
       ZapisDoBunkyZemFormula(p+1, 4,VPorostniSkupina.TypManag );
       ZapisDoBunkyZemFormula(p+1, 5,VPorostniSkupina.TER_TYP );
       ZapisDoBunkyZemFormula(p+1, 6,VPorostniSkupina.Terenni_skupina);
       ZapisDoBunkyZemFormula(p+1, 7,VPorostniSkupina.KU_NAZ);
       ZapisDoBunkyZemFormula(p+1,11,VPorostniSkupina.LES_URAD_Nazev);
      end
     else
      begin
       ZapisDoBunkyZemFormula(p+1, 1,VPorostniSkupina.PSK);
       ZapisDoBunkyZemFormuladouble(p+1,3,VPorostniSkupina.PSK_P);
       ZapisDoBunkyZemFormula(p+1, 5,VPorostniSkupina.LT);
       ZapisDoBunkyZemFormula(p+1, 6,inttostr(VPorostniSkupina.Ietaz[0].HS)); //VTVL
       ZapisDoBunkyZemFormula(p+1, 7,inttostr(VPorostniSkupina.LVS));
       ZapisDoBunkyZemFormula(p+1, 8,VPorostniSkupina.TypManag );
       ZapisDoBunkyZemFormula(p+1, 9,VPorostniSkupina.TER_TYP );
       ZapisDoBunkyZemFormula(p+1,10,VPorostniSkupina.Terenni_skupina);
       ZapisDoBunkyZemFormula(p+1,11,VPorostniSkupina.KU_NAZ);
       ZapisDoBunkyZemFormula(p+1,15,VPorostniSkupina.LES_URAD_Nazev);
      end;

     ZapisDoBunkyZemFormula(p+3,1,VPorostniSkupina.PSK_TEXT
        +' '+vodpZavin(VPorostniSkupina.OchrCHKO_NP_Nazvy)
        +' '+vodpZavin(VPorostniSkupina.OchrMChU_Nazvy)
        +' '+vodpZavin(VPorostniSkupina.OchrNatura_Nazvy));

     ZapisDoBunkyZemFormula(p+5,1,VPorostniSkupina.BotanLok);
     ZapisDoBunkyZemFormula(p+5,3,VPorostniSkupina.ZoolLok);
     ZapisDoBunkyZemFormula(p+5,5,VPorostniSkupina.Face);
     ZapisDoBunkyZemFormula(p+5,6,VPorostniSkupina.OwnerPorost.MAJ_Kod);
     ZapisDoBunkyZemFormula(p+5,9,VPorostniSkupina.StupPrir);
     for iEt:=0 to VPorostniSkupina.EtazMN.Count-1 do
      begin
       if pos('1',VPorostniSkupina.IEtaz[iEt].ETAZ)>0  then ZapisDoBunkyZemFormula(p+5,12,'1 x');
       if pos('2',VPorostniSkupina.IEtaz[iEt].ETAZ)>0  then ZapisDoBunkyZemFormula(p+5,13,'2 x');
       if pos('3',VPorostniSkupina.IEtaz[iEt].ETAZ)>0  then ZapisDoBunkyZemFormula(p+5,14,'3 x');
       if VPorostniSkupina.IEtaz[iEt].MZD>0 then ZapisDoBunkyZemFormulaDouble(p+5,15,VPorostniSkupina.IEtaz[iEt].MZD);

      end;
   end;
 end;

Procedure VyplnHlaPorostu(VPorost:TPorost;strana:integer;PrvniRadekHl:integer;
                          tiskniNaOstro:boolean;var predpoklVyska:double);
var p,iZvl:integer;
    HZvl,Hktg:double;
    ss:string;
 begin
   p:=PrvniRadekHl;
   if tiskniNaOstro then
    begin
      if infoedit<>Nil then
       begin
        InfoEdit.Text:=VPorost.CeleOznaceni;
        InfoEdit.refresh;
       end;
     if JePrava then
      begin
       ZapisDoBunkyZemFormula(p+1,16,inttostr(VPorost.ownerDilec.ownerOddeleni.ODD));
       ZapisDoBunkyZemFormula(p+3,16,VPorost.ownerDilec.DIL);
       ZapisDoBunkyZemFormula(p+5,16,VPorost.POR);

       ZapisDoBunkyZemFormuladouble(p+1,14,VPorost.ownerDilec.ownerOddeleni.PorostniPuda);
       ZapisDoBunkyZemFormuladouble(p+3,14,VPorost.ownerDilec.PorostniPuda);
       ZapisDoBunkyZemFormuladouble(p+5,14,VPorost.PorostniPuda);

       ZapisDoBunkyZemFormula(p+1,1,VPorost.MAJ_KOD);
       ZapisDoBunkyZemFormula(p+1,2,VPorost.LES_OBL_nazev);
       ZapisDoBunkyZemFormula(p+1,7,inttostr(VPorost.ownerDilec.ownerOddeleni.OwnerLHC.LHC_KOD));

       ZapisDoBunkyZemFormula(p+1,9,VPorost.ownerDilec.ownerOddeleni.OwnerLHC.LHP_OD+'-'
                                +VPorost.ownerDilec.ownerOddeleni.OwnerLHC.LHP_DO);
       ZapisDoBunkyZemFormula(p+1,12,inttostr(strana));

       ZapisDoBunkyZemFormula(p,3,VPorost.LES_OBL);
       ZapisDoBunkyZemFormula(p,5,VPorost.LES_PODOBL);

       ZapisDoBunkyZemFormula(p+3,1,VPorost.Kategorie1Mn.KategorieVcetnePrekryvuSMezerama);
       ZapisDoBunkyZemFormula(p+3,2,VPorost.ZVL_STATUT_nazev);
       ZapisDoBunkyZemFormula(p+3,7,VPorost.PAS_OHR );

       ZapisDoBunkyZemFormula(p+2,10,VPorost.ORG_UROVEN1 );
       ZapisDoBunkyZemFormula(p+2,13,VPorost.ORG_UROVEN2 );

       ZapisDoBunkyZemFormula(p+3, 9,VPorost.ORG_UROVEN1_nazev );
       ZapisDoBunkyZemFormula(p+3,12,VPorost.ORG_UROVEN2_nazev );
       if VPorost.PorostniSkupinaMN.Count>0 then
        begin
         ZapisDoBunkyZemFormula(p+5,1,inttostr(VPorost.iPorostniSkupina[0].CIL_HS)); //TVL
        end;

       ZapisDoBunkyZemFormula(p+5,2,VPorost.POR_TEXT_Vse_BezZavin
                 +' ' + vodpZavin(VPorost.OchrCHKO_NP_Nazvy)
                 +' ' + vodpZavin(VPorost.OchrMChU_Nazvy)
                 +' ' + vodpZavin(VPorost.OchrNatura_Nazvy));


      end
     else
      begin
       ZapisDoBunkyZemFormula(p+1,1,inttostr(VPorost.ownerDilec.ownerOddeleni.ODD));
       ZapisDoBunkyZemFormula(p+3,1,VPorost.ownerDilec.DIL);
       ZapisDoBunkyZemFormula(p+5,1,VPorost.POR);

       ZapisDoBunkyZemFormuladouble(p+1,3,VPorost.ownerDilec.ownerOddeleni.PorostniPuda);
       ZapisDoBunkyZemFormuladouble(p+3,3,VPorost.ownerDilec.PorostniPuda);
       ZapisDoBunkyZemFormuladouble(p+5,3,VPorost.PorostniPuda);


       ZapisDoBunkyZemFormula(p+1,5,VPorost.MAJ_KOD);

       ZapisDoBunkyZemFormula(p,7,VPorost.LES_OBL);
       ZapisDoBunkyZemFormula(p,9,VPorost.LES_PODOBL);
       ZapisDoBunkyZemFormula(p+1,6,VPorost.LES_OBL_nazev);

       ZapisDoBunkyZemFormula(p+1,11,inttostr(VPorost.ownerDilec.ownerOddeleni.OwnerLHC.LHC_KOD));

       ZapisDoBunkyZemFormula(p+1,13,VPorost.ownerDilec.ownerOddeleni.OwnerLHC.LHP_OD+'-'
                                +VPorost.ownerDilec.ownerOddeleni.OwnerLHC.LHP_DO);
       ZapisDoBunkyZemFormula(p+1,16,inttostr(strana));


       ZapisDoBunkyZemFormula(p+3,5,VPorost.Kategorie1Mn.KategorieVcetnePrekryvuSMezerama);
       ZapisDoBunkyZemFormula(p+3,6,VPorost.ZVL_STATUT_nazev);
       ZapisDoBunkyZemFormula(p+3,11,VPorost.PAS_OHR );

       ZapisDoBunkyZemFormula(p+2,14,VPorost.ORG_UROVEN1 );
       ZapisDoBunkyZemFormula(p+2,17,VPorost.ORG_UROVEN2 );

       ZapisDoBunkyZemFormula(p+3,13,VPorost.ORG_UROVEN1_nazev );
       ZapisDoBunkyZemFormula(p+3,16,VPorost.ORG_UROVEN2_nazev );

       if VPorost.PorostniSkupinaMN.Count>0 then
        begin
         ZapisDoBunkyZemFormula(p+5,5,inttostr(VPorost.iPorostniSkupina[0].CIL_HS));  // TVL
        end;

       ZapisDoBunkyZemFormula(p+5,6,VPorost.POR_TEXT_Vse_BezZavin );

     end;
     {
     ZapisDoBunkyZemFormula(p+5,1,inttostr(VPorost.ownerDilec.ownerOddeleni.OwnerLHC.LHC_KOD));
     ZapisDoBunkyZemFormula(p,jePrava+5,VPorost.ownerDilec.ownerOddeleni.OwnerLHC.LHP_OD+'-'
                                +VPorost.ownerDilec.ownerOddeleni.OwnerLHC.LHP_DO);
     ZapisDoBunkyZemFormula(p,jePrava+10,VPorost.ORG_UROVEN2);  // neznm up
     ZapisDoBunkyZemFormula(p,jePrava+12,VPorost.ORG_UROVEN3);  // neznm OLE
     ZapisDoBunkyZemFormula(p,jePrava+13,VPorost.ORG_UROVEN3_nazev); // neznm rejtjn
     ZapisDoBunkyZemFormula(p+1,jePrava+3,inttostr(VPorost.ownerDilec.ownerOddeleni.ODD));
     ZapisDoBunkyZemFormuladouble(p+1,jePrava+5,VPorost.ownerDilec.ownerOddeleni.PorostniPuda);
     ZapisDoBunkyZemFormula(p+1,jePrava+8,'PLO: '+VPorost.LES_OBL_nazev);
     if VPorost.PorostniSkupinaMN.Count>0 then
      begin
       ZapisDoBunkyZemFormula(p+1,jePrava+12,VPorost.IPorostniSkupina[0].OCHR_PRIR_sumava);
      end;
     ZapisDoBunkyZemFormula(p+2,jePrava+3,DoplnZePreduZnakem1(
                         inttostr(VPorost.ownerDilec.ownerOddeleni.ODD),3,' ')
                         +VPorost.ownerDilec.DIL);
     ZapisDoBunkyFontFormula(p+2,jePrava+3,4,1,'Arial',14,'Tun');
     ZapisDoBunkyZemFormuladouble(p+2,jePrava+5,VPorost.ownerDilec.PorostniPuda);
     ZapisDoBunkyZemFormula (p+2,jePrava+8,VPorost.Kategorie1Mn.KategorieVcetnePrekryvuSMezerama);
     ZapisDoBunkyZemFormula (p+2,jePrava+10,VPorost.ZvlStMn.ZvlStVcetnePrekryvu);
     ZapisDoBunkyZemFormula (p+2,jePrava+12,inttostr(VPorost.CISLO_ZONY));
     ZapisDoBunkyZemFormula (p+2,jePrava+14,VPorost.PAS_OHR);
     ZapisDoBunkyZemFormula (p+3,jePrava+3,VPorost.maj_KOD);
     if VPorost.PorostniSkupinaMN.Count>0 then
      begin
       ZapisDoBunkyZemFormula(p+3,jePrava+6,VPorost.IPorostniSkupina[0].KU_NAZ);
      end;
     ZapisDoBunkyZemFormula (p+3,jePrava+14,VPorost.ZONACE);
  }
 end;
end;
procedure kopirujHlavickuSkupiny(naRadek:Integer; tiskniNaOstro:boolean;var predpoklVyska:double);
var
 row1,row2,rowKam:integer;
begin
 if jeprava then
  begin
   row1:=7;
   row2:=14;
  end
 else
  begin
   row1:=34;
   row2:=41;
  end;
 rowKam:=naRadek;
 KopirujOblastPoRadkach( row1,row2,rowKam,tiskniNaOstro,predpoklVyska);
// KopirujOblast( row1,1,row2,80, rowKam,1,tiskniNaOstro,predpoklVyska);
end;
procedure kopirujHlavickuEtaze(naRadek:Integer; tiskniNaOstro:boolean;var predpoklVyska:double);
var
 row1,row2,rowKam:integer;
begin
 row1:=15;
 row2:=15;

 rowKam:=naRadek;
 KopirujOblastPoRadkach( row1,row2,rowKam,tiskniNaOstro,predpoklVyska);
end;

procedure kopirujHlavickuPorostu(naRadek:Integer; tiskniNaOstro:boolean;var predpoklVyska:double);
var
 row1,row2,rowKam:integer;
begin
 if jeprava then
  begin
   row1:=1;
   row2:=6;
  end
 else
  begin
   row1:=28;
   row2:=33;
  end;
 rowKam:=naRadek;
 KopirujOblastPoRadkach( row1,row2,rowKam,tiskniNaOstro,predpoklVyska);
// KopirujOblast( row1,1,row2,80, rowKam,1,tiskniNaOstro,predpoklVyska);
end;
procedure kopirujHlavPorNaKonec (tiskniNaOstro:boolean;var predpoklVyska:double);
 begin
  {
  if PosledniRadekSumav>45 then
   begin
    // vlozKonecStranky(PosledniRadekSumav,1);
   end;         }
  kopirujHlavickuPorostu(PosledniRadekSumav,tiskniNaOstro,predpoklVyska);
 end;

procedure kopirujHlavSkupinyNaKonec (tiskniNaOstro:boolean;var predpoklVyska:double);
 begin
  {
  if PosledniRadekSumav>45 then
   begin
    // vlozKonecStranky(PosledniRadekSumav,1);
   end;         }
  kopirujHlavickuSkupiny(PosledniRadekSumav,tiskniNaOstro,predpoklVyska);
 end;

procedure kopirujHlavEtazeNaKonec (tiskniNaOstro:boolean;var predpoklVyska:double);
 begin
  kopirujHlavickuEtaze(PosledniRadekSumav,tiskniNaOstro,predpoklVyska);
 end;


procedure kopirujAVyPlnHlavPor(VPorost:TPorost;strana:integer;PrvniRadekHl:integer;
                                tiskniNaOstro:boolean;var predpoklVyska:double);
 begin
  predpoklVyska:=0;
  if KopirovatRadky then kopirujHlavPorNaKonec(tiskniNaOstro,predpoklVyska);
  posledniRadekSumav:=posledniRadekSumav+6;
  VyplnHlaPorostu(VPorost,strana,PrvniRadekHl,tiskniNaOstro,predpoklVyska);
 end;

procedure kopirujAVyPlnHlavSkupiny(VSkupina:TPorostniSkupina;strana:integer;PrvniRadekHl:integer;
                                tiskniNaOstro:boolean;var predpoklVyska:double);
 begin
  predpoklVyska:=0;
  if KopirovatRadky then kopirujHlavSkupinyNaKonec(tiskniNaOstro,predpoklVyska);
  posledniRadekSumav:=posledniRadekSumav+8;
  VyplnHlaPorostniSkupiny(VSkupina,strana,PrvniRadekHl,tiskniNaOstro,predpoklVyska);
 end;

procedure kopirujAVyPlnEtaz(VEtaz:TEtaz;strana:integer;PrvniRadekHl:integer;
                                tiskniNaOstro:boolean;var predpoklVyska:double);
 begin
  predpoklVyska:=0;
  if KopirovatRadky then kopirujHlavEtazeNaKonec(tiskniNaOstro,predpoklVyska);
  posledniRadekSumav:=posledniRadekSumav+1;
  VyplnHlaEtaze(VEtaz,strana,PrvniRadekHl,tiskniNaOstro,predpoklVyska);
 end;

procedure kopirujAVyPlnDrevinu(VDrevina:TDrevina;Poradidreviny,strana:integer;PrvniRadekHl:integer;
                                tiskniNaOstro:boolean;var predpoklVyska:double);
 begin
  predpoklVyska:=0;
  if Poradidreviny>0 then
   begin
    if KopirovatRadky then kopirujHlavEtazeNaKonec(tiskniNaOstro,predpoklVyska);
    posledniRadekSumav:=posledniRadekSumav+1;
   end
  else
   begin
    PrvniRadekHl:=PrvniRadekHl-1;
   end;
  VyplnHlaDrev(VDrevina,strana,PrvniRadekHl,tiskniNaOstro,predpoklVyska);
 end;


procedure kopirujAVyPlnZalesneni(VZalesneni:Tzalesneni;PoradiZalesneni,strana:integer;PrvniRadekHl:integer;
                                tiskniNaOstro:boolean;var predpoklVyska:double);
 begin
  predpoklVyska:=0;
  if PoradiZalesneni>VZalesneni.OwnerEtaz.DrevinaMN.Count-1 then
   begin
    if KopirovatRadky then kopirujHlavEtazeNaKonec(tiskniNaOstro,predpoklVyska);
    posledniRadekSumav:=posledniRadekSumav+1;
   end
  else
   begin
    PrvniRadekHl:=PrvniRadekHl-1;
   end;
  VyplnHlaZalesneni(VZalesneni,strana,PrvniRadekHl,tiskniNaOstro,predpoklVyska);
 end;



var
   iPsk, iEt, iDr, iZal, iEtPrv, iEtPosl, pocdrev,
   PrvRadHl,radekPor:integer;
   predpoklVyskaNanic:double;
   prvniRadekZal:integer;
   konec:Boolean;
 begin
   PrvRadHl:=PosledniRadekSumav;
   for iPsk:=0 to  VPorost.PorostniSkupinaMN.count-1 do
    begin
     iEtPosl:=0;
     repeat
     iEtPrv:=iEtPosl;
     pocdrev:=0;
      repeat
       konec:=false;
       PocDrev:=PocDrev+VPorost.IPorostniSkupina[iPSK].IEtaz[iEtPosl].drevinaMN.count;
       inc(ietPosl);
       if (ietPosl>Vporost.IPorostniSkupina[iPsk].EtazMN.count-1) then
        begin
         konec:=true;
        end
       else
        begin
         if (PocDrev+VPorost.IPorostniSkupina[iPSK].IEtaz[iEtPosl].drevinaMN.count)>9 then Konec:=true;
        end;
      until konec;
     radekPor:=PosledniRadekSumav;
     kopirujAVyPlnHlavPor(VPorost,strana,radekPor,true,predpoklVyskaNaNic);
     PrvRadHl:=PosledniRadekSumav;
    // tiskniskupinu(VPorost.IPorostniSkupina[iPsk],PrvRadHl,true,predpoklVyskaNaNic);
    // doradkujOdstrankuj;
     radekPor:=PosledniRadekSumav;
     kopirujAVyPlnHlavSkupiny(VPorost.IPorostniSkupina[iPSK],strana,radekPor,true,predpoklVyskaNaNic);
   //  for iEt:=0 to Vporost.IPorostniSkupina[iPsk].EtazMN.count-1 do
     for iEt:=iEtPrv to ietPosl-1 do
      begin
       radekPor:=PosledniRadekSumav;
       kopirujAVyPlnEtaz(VPorost.IPorostniSkupina[iPSK].IEtaz[iEt],strana,radekPor,true,predpoklVyskaNaNic);
       prvniRadekZal:=PosledniRadekSumav-1;
       for iDr:=0 to Vporost.IPorostniSkupina[iPsk].IEtaz[iEt].drevinaMN.count-1 do
        begin
         radekPor:=PosledniRadekSumav;
         kopirujAVyPlnDrevinu( Vporost.IPorostniSkupina[iPsk].IEtaz[iEt].Idrevina[iDr],
                              iDr,strana,radekPor,true,predpoklVyskaNaNic);
        end;
       for iZal:=0 to Vporost.IPorostniSkupina[iPsk].IEtaz[iEt].ZalesneniMN.count-1 do
        begin
          // kopirujAVyPlnZalesneni(Vporost.IPorostniSkupina[iPsk].IEtaz[iEt].IZalesneni[iZal],
          //                  iZal,strana,radekPor,true,predpoklVyskaNaNic);

         if izal>Vporost.IPorostniSkupina[iPsk].IEtaz[iEt].DrevinaMN.Count-1 then
          begin
           if KopirovatRadky then kopirujHlavEtazeNaKonec(true,predpoklVyskanaNic);
           PrvniRadekZal:=posledniRadekSumav;
           posledniRadekSumav:=posledniRadekSumav+1;
          end;
         VyplnHlaZalesneni(Vporost.IPorostniSkupina[iPsk].IEtaz[iEt].IZalesneni[iZal],
                           strana,PrvniRadekZal,true,predpoklVyskaNaNic);
         prvniRadekZal:=prvniRadekZal+1;
        end;
       UdelejPlnouCaruZem(posledniRadekSumav-1,1,1,17);
      end;
     vlozKonecStranky(posledniRadekSumav,1);
     inc(strana);

     case levaprava of
         3: jePrava:=not(jePrava);
       0,1: jePrava:=false;
       2,4: jePrava:=true;
     end; //case
{  levaprava  -
                0,1  leve
                2,4  prave
                3  Oboustrann }
    until iEtPosl= Vporost.IPorostniSkupina[iPsk].EtazMN.count;
   end;
 end;
procedure SmazPrvniRadkyKrkonose;
 begin
 //    SmazRadkyVExceluZem(1,54,posledniRadekSumav);
 //  vlozKonecStranky(1,1);
   vlozKonecStranky(55,1);
   SmazRadkyVExceluZem(1,53,posledniRadekSumav);
 end;


end.
