unit SPPolNactLED;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs,
  U_Zobraz, StdCtrls, EHledAChyb, Buttons;

type
  TFSPPolNactLED = class(TForm)
    LabPorost: TLabel;
    LabPorSkup: TLabel;
    LabBezlesi: TLabel;
    LabJinyPozemek: TLabel;
    LabOstatni: TLabel;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    LabOchrPrir: TLabel;
    Memo1: TMemo;
    ButZapVse: TButton;
    ButVypVse: TButton;
    CmbOrgUr: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButZapVseClick(Sender: TObject);
    procedure ButVypVseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    odpoved:boolean;
    CHBxmPLOCHAdoPlocha0PSK,CHBxmVYMERAdoVymeraPSK,CHBxmPLOCHAdoPlocha0BZL,CHBxmVYMERAdoVymeraBZL,
    CHBxmPLOCHAdoPlocha0JP ,CHBxmVYMERAdoVymeraJP ,CHBxmPLOCHAdoPlocha0OST,CHBxmVYMERAdoVymeraOST,
    CHBxmMAJ_KODdoMAJ_KOD, CHBxmMAJ_DRUHdoMAJ_DRUH,  CHBxmLS_KODDoOrgUr,
    CHBxmPAS_OHRdoPAS_OHR,
    CHBxmZVL_STATUTdoZvlStVcetnePrekryvu,CHBxmKATSdoKategorieVcetnePrekryvu,
    CHBxmKATSdoTB_PorKtg, CHBxmZVL_STATUTdoTB_PorZvl,
    CHBxmKVAL_PdoPSK_KVAL_Vypocet1,CHBxmKVAL_PdoBZL_KVAL_Vypocet,CHBxmKVAL_PdoJP_KVAL_Vypocet,CHBxmKVAL_PdoOST_KVAL_Vypocet,
    CHBxmKVAL_PdoPSK_KVAL_BezVypoctu,
    CHBxmKU_KODdoKU_KODPSK,CHBxmKU_KODdoORPzKU6PSK,CHBxmSK_PARCdoSKUPPARCPSK,CHBxmKATPAR_KODdoPOT_VLASTPSK
    ,CHBxmKU_KODdoKU_KODBZL,CHBxmKU_KODdoORPzKU6BZL,CHBxmSK_PARCdoSKUPPARCBZL,CHBxmKATPAR_KODdoPOT_VLASTBZL
    ,CHBxmKU_KODdoKU_KODJP,CHBxmKU_KODdoORPzKU6JP,CHBxmSK_PARCdoSKUPPARCJP,CHBxmKATPAR_KODdoPOT_VLASTJP
    ,CHBxmKU_KODdoKU_KODOST,CHBxmKU_KODdoORPzKU6OST,CHBxmSK_PARCdoSKUPPARCOST,CHBxmKATPAR_KODdoPOT_VLASTOST
    ,CHBxmLTdoLTPSK,CHBxmSLTDoSLTPSK,CHBxmLTdoLTBzlJPOst,CHBxmSLTDoSLTBzlJPOst
    ,CHBxmLES_OBLDoLES_OBL,CHBxmLO_CASTDoLES_PODOBL,CHBxmDalsiLTdoPSK_TEXT
    ,CHBxmPocetCastiDoPocetCasti, CHBxmPocetCastiDoPSK_TEXT

    ,CHBxmLVSdoLVSPSK ,CHBxmLVSdoLVSBzlJPOst
    ,CHBxmLVdoCislo_Tel
    ,CHBxmDoplnBezlJinOSTKdyzNeni,CHBxmSmazADoplnBezlJinOST
    ,CHBxmBLABLABLAdoBZL_DRUH,CHBxmKULTURAdoDRUH_POZJP,CHBxmKULTURAdoDRUH_POZOST
    ,CHBxmPoznamkaDoBZL_VYUZ, CHBxmPoznamkaDoJP_VYUZ, CHBxmPoznamkaDoOST_VYUZ
         :TCheckBoxNactLED;
     Ed1BLABLABLAdoBZL_DRUH, Ed1PoznamkaDoBZL_VYUZ: TEdit;

   procedure PozadovaneNacteniZLeduDoChecku;
   procedure ZCheckuDoPozadovaneNacteniZLedu;
   procedure MemoDoChecku;
  end;

var
  FSPPolNactLED: TFSPPolNactLED;

implementation

{$R *.dfm}

procedure TFSPPolNactLED.FormCreate(Sender: TObject);
begin
  CHBxmPLOCHAdoPlocha0PSK:=TCheckBoxNactLED.Create(Self);
  with CHBxmPLOCHAdoPlocha0PSK do
   begin
    Parent := self;//panel1;
    name:='CHBxmPLOCHAdoPlocha0PSK';
    top    :=  LabPorSkup.top+height+10;
    left   :=  LabPorSkup.left;
    Width  :=  200;
    caption:='PLOCHA-->Plocha0PSK';
    PozadovaneNacteniZLedu:=PLOCHAdoPlocha0PSK;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast PLOCHU z DETu do PLOCHY0 v porostn skupin v taxu. Nic se nepepotv, pouze se nate plocha0, plocha LHP se nemn.';
   end;

  CHBxmVYMERAdoVymeraPSK:=TCheckBoxNactLED.Create(Self);
  with CHBxmVYMERAdoVymeraPSK do
   begin
    Parent := self;//panel1;
    name:='CHBxmVYMERAdoVymeraPSK';
    left   :=  LabPorSkup.left;
    top    :=  CHBxmPLOCHAdoPlocha0PSK.top+height+10;
    Width  :=  200;
    caption:='VYMERA-->VymeraPSK';
    PozadovaneNacteniZLedu:=VYMERAdoVymeraPSK;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast VYMERU z DETu do VYMERY v porostn skupin v taxu. Nic se nepepotv, pouze se nate vmra.';
   end;


  CHBxmPLOCHAdoPlocha0BZL:=TCheckBoxNactLED.Create(Self);
  with CHBxmPLOCHAdoPlocha0BZL do
   begin
    Parent := self;//panel1;
    name:='CHBxmPLOCHAdoPlocha0BZL';
    top    :=  LabBezlesi.top+height+10;
    left   :=  LabBezlesi.left;
    Width  :=  200;
    caption:='PLOCHA-->Plocha0JP';
    PozadovaneNacteniZLedu:=PLOCHAdoPlocha0BZL;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast PLOCHU z DETu do PLOCHY0 v bezles v taxu. Nic se nepepotv, pouze se nate plocha0, plocha LHP se nemn.';
   end;

  CHBxmVYMERAdoVymeraBZL:=TCheckBoxNactLED.Create(Self);
  with CHBxmVYMERAdoVymeraBZL do
   begin
    Parent := self;//panel1;
    name:='CHBxmVYMERAdoVymeraBZL';
    left   :=  LabBezlesi.left;
    top    :=  CHBxmPLOCHAdoPlocha0BZL.top+height+10;
    Width  :=  200;
    caption:='VYMERA-->VymeraBZL';
    PozadovaneNacteniZLedu:=VYMERAdoVymeraBZL;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast VYMERU z DETu do VYMERY v bezles v taxu. Nic se nepepotv, pouze se nate vmra.';
   end;

  CHBxmPLOCHAdoPlocha0JP:=TCheckBoxNactLED.Create(Self);
  with CHBxmPLOCHAdoPlocha0JP do
   begin
    Parent := self;//panel1;
    name:='CHBxmPLOCHAdoPlocha0JP';
    top    :=  LabJinyPozemek.top+height+10;
    left   :=  LabJinyPozemek.left;
    Width  :=  200;
    caption:='PLOCHA-->Plocha0JP';
    PozadovaneNacteniZLedu:=PLOCHAdoPlocha0JP;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast PLOCHU z DETu do PLOCHY0 v jinch pozemcch v taxu. Nic se nepepotv, pouze se nate plocha0, plocha LHP se nemn.';
   end;

  CHBxmVYMERAdoVymeraJP:=TCheckBoxNactLED.Create(Self);
  with CHBxmVYMERAdoVymeraJP do
   begin
    Parent := self;//panel1;
    name:='CHBxmVYMERAdoVymeraJP';
    left   :=  LabJinyPozemek.left;
    top    :=  CHBxmPLOCHAdoPlocha0JP.top+height+10;
    Width  :=  200;
    caption:='VYMERA-->VymeraJP';
    PozadovaneNacteniZLedu:=VYMERAdoVymeraJP;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast VYMERU z DETu do VYMERY v jinch pozemcch v taxu. Nic se nepepotv, pouze se nate vmra.';
   end;

  CHBxmPLOCHAdoPlocha0OST:=TCheckBoxNactLED.Create(Self);
  with CHBxmPLOCHAdoPlocha0OST do
   begin
    Parent := self;//panel1;
    name:='CHBxmPLOCHAdoPlocha0OST';
    top    :=  LabOstatni.top+height+10;
    left   :=  LabOstatni.left;
    Width  :=  200;
    caption:='PLOCHA-->Plocha0OST';
    PozadovaneNacteniZLedu:=PLOCHAdoPlocha0OST;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast PLOCHU z DETu do PLOCHY0 v ostatnch v taxu. Nic se nepepotv, pouze se nate plocha0, plocha LHP se nemn.';
   end;

  CHBxmVYMERAdoVymeraOST:=TCheckBoxNactLED.Create(Self);
  with CHBxmVYMERAdoVymeraOST do
   begin
    Parent := self;//panel1;
    name:='CHBxmVYMERAdoVymeraOST';
    left   :=  LabOstatni.left;
    top    :=  CHBxmPLOCHAdoPlocha0OST.top+height+10;
    Width  :=  200;
    caption:='VYMERA-->VymeraOST';
    PozadovaneNacteniZLedu:=VYMERAdoVymeraOST;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast VYMERU z DETu do VYMERY v ostatnch v taxu. Nic se nepepotv, pouze se nate vmra.';
   end;

  CHBxmMAJ_KODdoMAJ_KOD:=TCheckBoxNactLED.Create(Self);
  with CHBxmMAJ_KODdoMAJ_KOD do
   begin
    Parent := self;//panel1;
    name:='CHBxmMAJ_KODdoMAJ_KOD';
    top    :=  LabPorost.top+height+10;
    left   :=  LabPorost.left;
    Width  :=  200;
    caption:='MAJ_KOD-->MAJ_KOD';
    PozadovaneNacteniZLedu:=MAJ_KODdoMAJ_KOD;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast MAJ_KOD z DETu do MAJ_KOD v porostu v taxu.';
   end;

  CHBxmMAJ_DRUHdoMAJ_DRUH:=TCheckBoxNactLED.Create(Self);
  with CHBxmMAJ_DRUHdoMAJ_DRUH do
   begin
    Parent := self;//panel1;
    name:='CHBxmMAJ_DRUHdoMAJ_DRUH';
    left   :=  LabPorost.left;
    top    :=  CHBxmMAJ_KODdoMAJ_KOD.top+height+10;
    Width  :=  200;
    caption:='MAJ_DRUH-->MAJ_DRUH';
    PozadovaneNacteniZLedu:=MAJ_DRUHdoMAJ_DRUH;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast MAJ_DRUH z DETu do MAJ_DRUH v porostu v taxu.';
   end;



  CHBxmZVL_STATUTdoZvlStVcetnePrekryvu:=TCheckBoxNactLED.Create(Self);
  with CHBxmZVL_STATUTdoZvlStVcetnePrekryvu do
   begin
    Parent := self;//panel1;
    name:='CHBxmZVL_STATUTdoZvlStVcetnePrekryvu';
    left   :=  LabPorost.left;
    top    :=  CHBxmMAJ_DRUHdoMAJ_DRUH.top+height+10;
    Width  :=  200;
    caption:='ZVL_STATUT-->ZvlStVcetnePrekryvu';
    PozadovaneNacteniZLedu:=ZVL_STATUTdoZvlStVcetnePrekryvu;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast ZVL_STATUT z DETu do ZvlStVcetnePrekryvu v porostu v taxu. Nsobn zvl.statuty ve ZVL_STATUT mus bt oddleny rkou.';
   end;

  CHBxmKATSdoKategorieVcetnePrekryvu:=TCheckBoxNactLED.Create(Self);
  with CHBxmKATSdoKategorieVcetnePrekryvu do
   begin
    Parent := self;//panel1;
    name:='CHBxmKATSdoKategorieVcetnePrekryvu';
    left   :=  LabPorost.left;
    top    :=  CHBxmZVL_STATUTdoZvlStVcetnePrekryvu.top+height+10;
    Width  :=  200;
    caption:='KATS-->KategorieVcetnePrekryvu';
    PozadovaneNacteniZLedu:=KATSdoKategorieVcetnePrekryvu;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast KATS z DETu do KategorieVcetnePrekryvu v porostu v taxu. Kategorie v pekryvu v KATS mus bt oddleny rkou.';
   end;

  CHBxmKVAL_PdoPSK_KVAL_Vypocet1:=TCheckBoxNactLED.Create(Self);
  with CHBxmKVAL_PdoPSK_KVAL_Vypocet1 do
   begin
    Parent := self;//panel1;
    name:='CHBxmKVAL_PdoPSK_KVAL_Vypocet';
    left   :=  LabPorSkup.left;
    top    :=  CHBxmVYMERAdoVymeraPSK.top+height+10;
    Width  :=  200;
    caption:='KVAL_P-->PSK_KVAL_Vypocet';
    PozadovaneNacteniZLedu:=KVAL_PdoPSK_KVAL_Vypocet1;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast KVAL_P z DETu do KVAL_P v porostn skupin v taxu. Dle kvality dosadit do plochy LHP buto plochu0 nebo vmru a pepotat zsoby, tby a plochy dle plochy LHP';
   end;

  CHBxmKVAL_PdoPSK_KVAL_BezVypoctu:=TCheckBoxNactLED.Create(Self);
  with CHBxmKVAL_PdoPSK_KVAL_BezVypoctu do
   begin
    Parent := self;//panel1;
    name:='CHBxmKVAL_PdoPSK_KVAL_BezVypoctu';
    left   :=  LabPorSkup.left;
    top    :=  CHBxmKVAL_PdoPSK_KVAL_Vypocet1.top+height+10;
    Width  :=  200;
    caption:='KVAL_P-->PSK_KVAL_BezVypoctu';
    PozadovaneNacteniZLedu:=KVAL_PdoPSK_KVAL_BezVypoctu;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast KVAL_P z DETu do KVAL_P v porostn skupin v taxu. Dle kvality dosadit do plochy LHP buto plochu0 nebo vmru ale nepepotv zsoby';
   end;


  CHBxmKVAL_PdoBZL_KVAL_Vypocet:=TCheckBoxNactLED.Create(Self);
  with CHBxmKVAL_PdoBZL_KVAL_Vypocet do
   begin
    Parent := self;//panel1;
    name:='CHBxmKVAL_PdoBZL_KVAL_Vypocet';
    left   :=  LabBezlesi.left;
    top    :=  CHBxmVYMERAdoVymeraBZL.top+height+10;
    Width  :=  200;
    caption:='KVAL_P-->BZL_KVAL_Vypocet';
    PozadovaneNacteniZLedu:=KVAL_PdoBZL_KVAL_Vypocet;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast KVAL_P z DETu do KVAL_P v bezles v taxu. Dle kvality dosadit do plochy LHP buto plochu0 nebo vmru.';
   end;
 //   KVAL_PdoBZL_KVAL_Vypocet,

  CHBxmKVAL_PdoJP_KVAL_Vypocet:=TCheckBoxNactLED.Create(Self);
  with CHBxmKVAL_PdoJP_KVAL_Vypocet do
   begin
    Parent := self;//panel1;
    name:='CHBxmKVAL_PdoJP_KVAL_Vypocet';
    left   :=  LabJinyPozemek.left;
    top    :=  CHBxmVYMERAdoVymeraJP.top+height+10;
    Width  :=  200;
    caption:='KVAL_P-->JP_KVAL_Vypocet';
    PozadovaneNacteniZLedu:=KVAL_PdoJP_KVAL_Vypocet;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast KVAL_P z DETu do KVAL_P v jinm pozemku v taxu. Dle kvality dosadit do plochy LHP buto plochu0 nebo vmru.';
   end;

// KVAL_PdoJP_KVAL_Vypocet,

  CHBxmKVAL_PdoOST_KVAL_Vypocet:=TCheckBoxNactLED.Create(Self);
  with CHBxmKVAL_PdoOST_KVAL_Vypocet do
   begin
    Parent := self;//panel1;
    name:='CHBxmKVAL_PdoOST_KVAL_Vypocet';
    left   :=  LabOstatni.left;
    top    :=  CHBxmVYMERAdoVymeraOST.top+height+10;
    Width  :=  200;
    caption:='KVAL_P-->OST_KVAL_Vypocet';
    PozadovaneNacteniZLedu:=KVAL_PdoOST_KVAL_Vypocet;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast KVAL_P z DETu do KVAL_P v ostatn v taxu. Dle kvality dosadit do plochy LHP buto plochu0 nebo vmru.';

   end;

//KVAL_PdoOST_KVAL_Vypocet


  CHBxmKU_KODdoKU_KODPSK:=TCheckBoxNactLED.Create(Self);
  with CHBxmKU_KODdoKU_KODPSK do
   begin
    Parent := self;//panel1;
    name:='CHBxmKU_KODdoKU_KODPSK';
    left   :=  LabPorSkup.left;
    top    :=  CHBxmKVAL_PdoPSK_KVAL_BezVypoctu.top+height+10;
    Width  :=  200;
    caption:='KU_KOD-->KU_KODPSK';
    PozadovaneNacteniZLedu:=KU_KODdoKU_KODPSK;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast KU_KOD z DETu do KU_KOD v porostn skupin v taxu.';
   end;

   // KU_KODdoKU_KODPSK,

  CHBxmKU_KODdoORPzKU6PSK:=TCheckBoxNactLED.Create(Self);
  with CHBxmKU_KODdoORPzKU6PSK do
   begin
    Parent := self;//panel1;
    name:='CHBxmKU_KODdoORPzKU6PSK';
    left   :=  LabPorSkup.left;
    top    :=  CHBxmKU_KODdoKU_KODPSK.top+height+10;
    Width  :=  200;
    caption:='KU_KOD-->ORPzKU6PSK';
    PozadovaneNacteniZLedu:=KU_KODdoORPzKU6PSK;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast KU_KOD z DETu do ORPzKU6 v porostn skupin v taxu. Procedura ORPzKU6 najde podle seznamu pslun ORP a dopln jej do porostn skupiny.';
   end;

   // KU_KODdoORPzKU6PSK,

  CHBxmSK_PARCdoSKUPPARCPSK:=TCheckBoxNactLED.Create(Self);
  with CHBxmSK_PARCdoSKUPPARCPSK do
   begin
    Parent := self;//panel1;
    name:='CHBxmSK_PARCdoSKUPPARCPSK';
    left   :=  LabPorSkup.left;
    top    :=  CHBxmKU_KODdoORPzKU6PSK.top+height+10;
    Width  :=  200;
    caption:='SK_PARC-->SKUPPARCPSK';
    PozadovaneNacteniZLedu:=SK_PARCdoSKUPPARCPSK;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:=' Nast SK_PARC z DETu do SKUPPARC v porostn skupin v taxu.';
   end;

 //   SK_PARCdoSKUPPARCPSK,

  CHBxmKATPAR_KODdoPOT_VLASTPSK:=TCheckBoxNactLED.Create(Self);
  with CHBxmKATPAR_KODdoPOT_VLASTPSK do
   begin
    Parent := self;//panel1;
    name:='CHBxmKATPAR_KODdoPOT_VLASTPSK';
    left   :=  LabPorSkup.left;
    top    :=  CHBxmSK_PARCdoSKUPPARCPSK.top+height+10;
    Width  :=  200;
    caption:='KATPAR_KOD-->POT_VLASTPSK';
    PozadovaneNacteniZLedu:=KATPAR_KODdoPOT_VLASTPSK;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:=' Nast KATPAR_KOD z DETu do POT_VLAST v porostn skupin v taxu. Projev se v taxu i u vlatnosti KAT_PAR_KOD.';
   end;
 //  KATPAR_KODdoPOT_VLASTPSK,


  CHBxmKU_KODdoKU_KODBZL:=TCheckBoxNactLED.Create(Self);
  with CHBxmKU_KODdoKU_KODBZL do
   begin
    Parent := self;//panel1;
    name:='CHBxmKU_KODdoKU_KODBZL';
    left   :=  LabBezlesi.left;
    top    :=  CHBxmKVAL_PdoBZL_KVAL_Vypocet.top+height+10;
    Width  :=  200;
    caption:='KU_KOD-->KU_KODBZL';
    PozadovaneNacteniZLedu:=KU_KODdoKU_KODBZL;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast KU_KOD z DETu do KU_KOD v bezles v taxu.';
   end;

   // KU_KODdoKU_KODBZL,

  CHBxmKU_KODdoORPzKU6BZL:=TCheckBoxNactLED.Create(Self);
  with CHBxmKU_KODdoORPzKU6BZL do
   begin
    Parent := self;//panel1;
    name:='CHBxmKU_KODdoORPzKU6BZL';
    left   :=  LabBezlesi.left;
    top    :=  CHBxmKU_KODdoKU_KODBZL.top+height+10;
    Width  :=  200;
    caption:='KU_KOD-->ORPzKU6BZL';
    PozadovaneNacteniZLedu:=KU_KODdoORPzKU6BZL;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast KU_KOD z DETu do ORPzKU6 v bezles v taxu. Procedura ORPzKU6 najde podle seznamu pslun ORP a dopln jej do bezles.';
   end;

   // KU_KODdoORPzKU6BZL,

  CHBxmSK_PARCdoSKUPPARCBZL:=TCheckBoxNactLED.Create(Self);
  with CHBxmSK_PARCdoSKUPPARCBZL do
   begin
    Parent := self;//panel1;
    name:='CHBxmSK_PARCdoSKUPPARCBZL';
    left   :=  LabBezlesi.left;
    top    :=  CHBxmKU_KODdoORPzKU6BZL.top+height+10;
    Width  :=  200;
    caption:='SK_PARC-->SKUPPARCBZL';
    PozadovaneNacteniZLedu:=SK_PARCdoSKUPPARCBZL;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:=' Nast SK_PARC z DETu do SKUPPARC v bezles v taxu.';
   end;

 //   SK_PARCdoSKUPPARCBZL,

  CHBxmKATPAR_KODdoPOT_VLASTBZL:=TCheckBoxNactLED.Create(Self);
  with CHBxmKATPAR_KODdoPOT_VLASTBZL do
   begin
    Parent := self;//panel1;
    name:='CHBxmKATPAR_KODdoPOT_VLASTBZL';
    left   :=  LabBezlesi.left;
    top    :=  CHBxmSK_PARCdoSKUPPARCBZL.top+height+10;
    Width  :=  200;
    caption:='KATPAR_KOD-->POT_VLASTBZL';
    PozadovaneNacteniZLedu:=KATPAR_KODdoPOT_VLASTBZL;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:=' Nast KATPAR_KOD z DETu do POT_VLAST v bezles v taxu. Projev se v taxu i u vlatnosti KAT_PAR_KOD.';
   end;
 //  KATPAR_KODdoPOT_VLASTBZL,


  CHBxmKU_KODdoKU_KODJP:=TCheckBoxNactLED.Create(Self);
  with CHBxmKU_KODdoKU_KODJP do
   begin
    Parent := self;//panel1;
    name:='CHBxmKU_KODdoKU_KODJP';
    left   :=  LabJinyPozemek.left;
    top    :=  CHBxmKVAL_PdoJP_KVAL_Vypocet.top+height+10;
    Width  :=  200;
    caption:='KU_KOD-->KU_KODJP';
    PozadovaneNacteniZLedu:=KU_KODdoKU_KODJP;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast KU_KOD z DETu do KU_KOD v jin pozemek v taxu.';
   end;

   // KU_KODdoKU_KODJP,

  CHBxmKU_KODdoORPzKU6JP:=TCheckBoxNactLED.Create(Self);
  with CHBxmKU_KODdoORPzKU6JP do
   begin
    Parent := self;//panel1;
    name:='CHBxmKU_KODdoORPzKU6JP';
    left   :=  LabJinyPozemek.left;
    top    :=  CHBxmKU_KODdoKU_KODJP.top+height+10;
    Width  :=  200;
    caption:='KU_KOD-->ORPzKU6JP';
    PozadovaneNacteniZLedu:=KU_KODdoORPzKU6JP;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast KU_KOD z DETu do ORPzKU6 v jin pozemek v taxu. Procedura ORPzKU6 najde podle seznamu pslun ORP a dopln jej do jin pozemek.';
   end;

   // KU_KODdoORPzKU6JP,

  CHBxmSK_PARCdoSKUPPARCJP:=TCheckBoxNactLED.Create(Self);
  with CHBxmSK_PARCdoSKUPPARCJP do
   begin
    Parent := self;//panel1;
    name:='CHBxmSK_PARCdoSKUPPARCJP';
    left   :=  LabJinyPozemek.left;
    top    :=  CHBxmKU_KODdoORPzKU6JP.top+height+10;
    Width  :=  200;
    caption:='SK_PARC-->SKUPPARCJP';
    PozadovaneNacteniZLedu:=SK_PARCdoSKUPPARCJP;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:=' Nast SK_PARC z DETu do SKUPPARC v jin pozemek v taxu.';
   end;

 //   SK_PARCdoSKUPPARCJP,

  CHBxmKATPAR_KODdoPOT_VLASTJP:=TCheckBoxNactLED.Create(Self);
  with CHBxmKATPAR_KODdoPOT_VLASTJP do
   begin
    Parent := self;//panel1;
    name:='CHBxmKATPAR_KODdoPOT_VLASTJP';
    left   :=  LabJinyPozemek.left;
    top    :=  CHBxmSK_PARCdoSKUPPARCJP.top+height+10;
    Width  :=  200;
    caption:='KATPAR_KOD-->POT_VLASTJP';
    PozadovaneNacteniZLedu:=KATPAR_KODdoPOT_VLASTJP;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:=' Nast KATPAR_KOD z DETu do POT_VLAST v jin pozemek v taxu. Projev se v taxu i u vlatnosti KAT_PAR_KOD.';
   end;
 //  KATPAR_KODdoPOT_VLASTJP,

  CHBxmKU_KODdoKU_KODOST:=TCheckBoxNactLED.Create(Self);
  with CHBxmKU_KODdoKU_KODOST do
   begin
    Parent := self;//panel1;
    name:='CHBxmKU_KODdoKU_KODOST';
    left   :=  LabOstatni.left;
    top    :=  CHBxmKVAL_PdoOST_KVAL_Vypocet.top+height+10;
    Width  :=  200;
    caption:='KU_KOD-->KU_KODOST';
    PozadovaneNacteniZLedu:=KU_KODdoKU_KODOST;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast KU_KOD z DETu do KU_KOD v ostatn v taxu.';
   end;

   // KU_KODdoKU_KODOST,

  CHBxmKU_KODdoORPzKU6OST:=TCheckBoxNactLED.Create(Self);
  with CHBxmKU_KODdoORPzKU6OST do
   begin
    Parent := self;//panel1;
    name:='CHBxmKU_KODdoORPzKU6OST';
    left   :=  LabOstatni.left;
    top    :=  CHBxmKU_KODdoKU_KODOST.top+height+10;
    Width  :=  200;
    caption:='KU_KOD-->ORPzKU6OST';
    PozadovaneNacteniZLedu:=KU_KODdoORPzKU6OST;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast KU_KOD z DETu do ORPzKU6 v ostatn v taxu. Procedura ORPzKU6 najde podle seznamu pslun ORP a dopln jej do ostatn';
   end;

   // KU_KODdoORPzKU6OST,

  CHBxmSK_PARCdoSKUPPARCOST:=TCheckBoxNactLED.Create(Self);
  with CHBxmSK_PARCdoSKUPPARCOST do
   begin
    Parent := self;//panel1;
    name:='CHBxmSK_PARCdoSKUPPARCOST';
    left   :=  LabOstatni.left;
    top    :=  CHBxmKU_KODdoORPzKU6OST.top+height+10;
    Width  :=  200;
    caption:='SK_PARC-->SKUPPARCOST';
    PozadovaneNacteniZLedu:=SK_PARCdoSKUPPARCOST;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:=' Nast SK_PARC z DETu do SKUPPARC v ostatn v taxu.';
   end;

 //   SK_PARCdoSKUPPARCOST,

  CHBxmKATPAR_KODdoPOT_VLASTOST:=TCheckBoxNactLED.Create(Self);
  with CHBxmKATPAR_KODdoPOT_VLASTOST do
   begin
    Parent := self;//panel1;
    name:='CHBxmKATPAR_KODdoPOT_VLASTOST';
    left   :=  LabOstatni.left;
    top    :=  CHBxmSK_PARCdoSKUPPARCOST.top+height+10;
    Width  :=  200;
    caption:='KATPAR_KOD-->POT_VLASTOST';
    PozadovaneNacteniZLedu:=KATPAR_KODdoPOT_VLASTOST;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:=' Nast KATPAR_KOD z DETu do POT_VLAST v ostatn v taxu. Projev se v taxu i u vlatnosti KAT_PAR_KOD.';
   end;
 //  KATPAR_KODdoPOT_VLASTOST,

  CHBxmKATSdoTB_PorKtg:=TCheckBoxNactLED.Create(Self);
  with CHBxmKATSdoTB_PorKtg do
   begin
    Parent := self;//panel1;
    name:='CHBxmKATSdoTB_PorKtg';
    left   :=  LabOchrPrir.left;
    top    :=  LabOchrPrir.top+height+10;
    Width  :=  200;
    caption:='KATS do tabulky TB_PorKtg';
    PozadovaneNacteniZLedu:=KATSdoTB_PorKtg;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast katagorii KAT z DETu do tabulky PHS/PorKtg.DB - Tabulka se zobrazuje v TAX/selnky PHS/Ochrana/Smluv.chr.zem/Kategorie';
   end;
 // KATSdoTB_PorKtg


  CHBxmZVL_STATUTdoTB_PorZvl:=TCheckBoxNactLED.Create(Self);
  with CHBxmZVL_STATUTdoTB_PorZvl do
   begin
    Parent := self;//panel1;
    name:='CHBxmZVL_STATUTdoTB_PorZvl';
    left   :=  LabOchrPrir.left;
    top    :=  CHBxmKATSdoTB_PorKtg.top+height+10;
    Width  :=  200;
    caption:='ZVL_STATUT do tabulky TB_PorZvl';
    PozadovaneNacteniZLedu:=ZVL_STATUTdoTB_PorZvl;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast ZVL_STATUT z DETu do tabulky PHS/PorZvl.DB - Tabulka se zobrazuje v TAX/selnky PHS/Ochrana/Smluv.chr.zem/Zvltn Statut';
   end;
 // ZVL_STATUTdoTB_PorZvl

  CHBxmLTdoLTPSK:=TCheckBoxNactLED.Create(Self);
  with CHBxmLTdoLTPSK do
   begin
    Parent := self;//panel1;
    name:='CHBxmLTdoLTPSK';
    left   :=  LabPorSkup.left;
    top    :=  CHBxmKATPAR_KODdoPOT_VLASTPSK.top+height+10;
    Width  :=  200;
    caption:='LT-->LT';
    PozadovaneNacteniZLedu:=LTdoLTPSK;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Z vrstvy typlogie DET_TYP dopln do porostn skupiny, bezles lesn typ.  V ledu mus bt ptomna vrstva typlogie DET_TYP.';
   end;


  CHBxmSLTdoSLTPSK:=TCheckBoxNactLED.Create(Self);
  with CHBxmSLTdoSLTPSK do
   begin
    Parent := self;//panel1;
    name:='CHBxmSLTdoSLTPSK';
    left   :=  LabPorSkup.left;
    top    :=  CHBxmLTdoLTPSK.top+height+10;
    Width  :=  200;
    caption:='SLT-->SLT';
    PozadovaneNacteniZLedu:=SLTdoSLTPSK;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Z vrstvy typlogie DET_TYP dopln do porostn skupiny soubor lesnch typ.  V ledu mus bt ptomna vrstva typlogie DET_TYP.';
   end;




  CHBxmLES_OBLDoLES_OBL:=TCheckBoxNactLED.Create(Self);
  with CHBxmLES_OBLDoLES_OBL do
   begin
    Parent := self;//panel1;
    name:='CHBxmLES_OBLDoLES_OBL';
    left   :=  LabPorost.left;
    top    :=  CHBxmKATSdoKategorieVcetnePrekryvu.top+height+10;
    Width  :=  200;
    caption:='LES_OBL-->LES_OBL';
    PozadovaneNacteniZLedu:=LES_OBLDoLES_OBL;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Z vrstvy typlogie DET_TYP dopln do porostu v taxu lesn oblast.  V ledu mus bt ptomna vrstva typlogie DET_TYP.';
   end;

  CHBxmLO_CASTDoLES_PODOBL:=TCheckBoxNactLED.Create(Self);
  with CHBxmLO_CASTDoLES_PODOBL do
   begin
    Parent := self;//panel1;
    name:='CHBxmLO_CASTDoLES_PODOBL';
    left   :=  LabPorost.left;
    top    :=  CHBxmLES_OBLDoLES_OBL.top+height+10;
    Width  :=  200;
    caption:='LO_CAST-->LES_PODOBL';
    PozadovaneNacteniZLedu:=LO_CASTDoLES_PODOBL;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Z vrstvy typlogie DET_TYP dopln lesn podoblast(LO_CAST) do porostu v taxu(LES_PODOBL) .  V ledu mus bt ptomna vrstva typlogie DET_TYP.';
   end;

  CHBxmLS_KODDoOrgUr:=TCheckBoxNactLED.Create(Self);
  with CHBxmLS_KODDoOrgUr do
   begin
    Parent := self;//panel1;
    name:='CHBxmLS_KODDoOrgUr';
    left   :=  LabPorost.left;
    top    :=  CHBxmLO_CASTDoLES_PODOBL.top+height+10;
    Width  :=  200;
    caption:='LS_KOD-->Org_Uroven';
    PozadovaneNacteniZLedu:=LS_KODDoOrgUr;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast LS_KOD z DETu do organizan rovn v porostu v taxu. slo organizan rovn uruje pipojen menu.';
   end;

   with CmbOrgUr do
    begin
     left   :=  CHBxmLS_KODDoOrgUr.left;
     top    :=  CHBxmLS_KODDoOrgUr.top+height;
     width  :=  110;
    end;

  CHBxmPAS_OHRdoPAS_OHR:=TCheckBoxNactLED.Create(Self);
  with CHBxmPAS_OHRdoPAS_OHR do
   begin
    Parent := self;//panel1;
    name:='CHBxmPAS_OHRdoPAS_OHR';
    left   :=  LabPorost.left;
    top    :=  CmbOrgUr.top+CmbOrgUr.height+10;
    Width  :=  200;
    caption:='PAS_OHR-->PAS_OHR';
    PozadovaneNacteniZLedu:=PAS_OHRdoPAS_OHR;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Nast PAS_OHR z DETu do PAS_OHR v porostu v taxu.';
   end;


  CHBxmDalsiLTdoPSK_TEXT:=TCheckBoxNactLED.Create(Self);
  with CHBxmDalsiLTdoPSK_TEXT do
   begin
    Parent := self;//panel1;
    name:='CHBxmDalsiLTdoPSK_TEXT';
    left   :=  LabPorSkup.left;
    top    :=  CHBxmSLTDoSLTPSK.top+height+10;
    Width  :=  200;
    caption:='DalsiLT-->PSK_TEXT';
    PozadovaneNacteniZLedu:=DalsiLTdoPSK_TEXT;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:=' Do poznmky u porostn skupiny vype dal lesn typy, kter se na ploe skupiny tak vyskytuj. Jsou seazen podle velikosti zaujat plochy. V ledu mus bt ptomna vrstva typlogie DET_TYP';
   end;

  CHBxmPocetCastiDoPocetCasti:=TCheckBoxNactLED.Create(Self);
  with CHBxmPocetCastiDoPocetCasti do
   begin
    Parent := self;//panel1;
    name:='CHBxmPocetCastiDoPocetCasti';
    left   :=  LabPorSkup.left;
    top    :=  CHBxmDalsiLTdoPSK_TEXT.top+height+10;
    Width  :=  200;
    caption:='PocetCasti-->PocetCasti';
    PozadovaneNacteniZLedu:=PocetCastiDoPocetCasti;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:=' V LEDu zjist poet st porostn skupiny a nate je do vlasnosti PocetCasti v porostn skupin v taxu. Pokud je PocetCasti vti ne 1,  v hosp.knize se tiskne do poznmky u skupiny. ';
   end;

  CHBxmPocetCastiDoPSK_TEXT:=TCheckBoxNactLED.Create(Self);
  with CHBxmPocetCastiDoPSK_TEXT do
   begin
    Parent := self;//panel1;
    name:='CHBxmPocetCastiDoPSK_TEXT';
    left   :=  LabPorSkup.left;
    top    :=  CHBxmPocetCastiDoPocetCasti.top+height+10;
    Width  :=  200;
    caption:='PocetCasti-->PSK_TEXT';
    PozadovaneNacteniZLedu:=PocetCastiDoPSK_TEXT;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:=' V LEDu zjist poet st porostn skupiny a nate je do textu v porostn skupin v taxu. Pokud je PocetCasti vti ne 1,  v hosp.knize se tiskne do poznmky u skupiny. ';
   end;


  CHBxmLVSdoLVSPSK:=TCheckBoxNactLED.Create(Self);
  with CHBxmLVSdoLVSPSK do
   begin
    Parent := self;//panel1;
    name:='CHBxmLVSdoLVS';
    left   :=  LabPorSkup.left;
    top    :=  CHBxmPocetCastiDoPSK_TEXT.top+height+10;
    Width  :=  200;
    caption:='LVS-->LVS';
    PozadovaneNacteniZLedu:=LVSdoLVSPSK;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Z LVS ve vrstv DET dopln LVS do porostn skupiny.';
   end;


 CHBxmLVdoCislo_Tel:=TCheckBoxNactLED.Create(Self);
  with CHBxmLVdoCislo_Tel do
   begin
    Parent := self;//panel1;
    name:='CHBxmLVdoCislo_Tel';
    left   :=  LabPorSkup.left;
    top    :=  CHBxmLVSDoLVSPSK.top+height+10;
    Width  :=  200;
    caption:='LV-->Cislo_Tel';
    PozadovaneNacteniZLedu:=LVdoCislo_Tel;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Z LV ve vrstv DET dopln cislo_TEL do porostn skupiny, bezles, jinho pozemku a ostatnch.';
   end;

 CHBxmDoplnBezlJinOSTKdyzNeni:=TCheckBoxNactLED.Create(Self);
  with CHBxmDoplnBezlJinOSTKdyzNeni do
   begin
    Parent := self;//panel1;
    name:='CHBxmDoplnBezlJinOSTKdyzNeni';
    left   :=  LabBezlesi.left;
    top    :=  CHBxmKATPAR_KODdoPOT_VLASTBZL.top+height+10;
    Width  :=  200;
    caption:='DoplnBezlJinOSTKdyzNeni';
    PozadovaneNacteniZLedu:=DoplnBezlJinOSTKdyzNeni;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Pokud  bezles, jin poz. nebo ostatn je v LEDu a nen v Taxu, tak se v Taxu vytvo';
   end;

 CHBxmSmazADoplnBezlJinOST:=TCheckBoxNactLED.Create(Self);
  with CHBxmSmazADoplnBezlJinOST do
   begin
    Parent := self;//panel1;
    name:='CHBxmSmazADoplnBezlJinOST';
    left   :=  LabBezlesi.left;
    top    :=  CHBxmDoplnBezlJinOSTKdyzNeni.top+height+10;
    Width  :=  200;
    caption:='SmazADoplnBezlJinOST';
    PozadovaneNacteniZLedu:=SmazADoplnBezlJinOST;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Z LV ve vrstv DET dopln cislo_TEL do porostn skupiny, bezles, jinho pozemku a ostatnch.';
   end;

  CHBxmLTdoLTBzlJPOst:=TCheckBoxNactLED.Create(Self);
  with CHBxmLTdoLTBzlJPOst do
   begin
    Parent := self;//panel1;
    name:='CHBxmLTdoLT';
    left   :=  LabBezlesi.left;
    top    :=  CHBxmSmazADoplnBezlJinOST.top+height+10;
    Width  :=  200;
    caption:='LT-->LT';
    PozadovaneNacteniZLedu:=LTdoLTBzlJPOst;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Z vrstvy typlogie DET_TYP dopln do bezles, jinho pozemku a ostatnch lesn typ.  V ledu mus bt ptomna vrstva typlogie DET_TYP.';
   end;


  CHBxmSLTdoSLTBzlJPOst:=TCheckBoxNactLED.Create(Self);
  with CHBxmSLTdoSLTBzlJPOst do
   begin
    Parent := self;//panel1;
    name:='CHBxmSLTdoSLTBzlJPOst';
    left   :=  LabBezlesi.left;
    top    :=  CHBxmLTdoLTBzlJPOst.top+height+10;
    Width  :=  200;
    caption:='SLT-->SLT';
    PozadovaneNacteniZLedu:=SLTdoSLTBzlJPOst;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Z vrstvy typlogie DET_TYP dopln do  bezles, jinho pozemku a ostatnch soubor lesnch typ.  V ledu mus bt ptomna vrstva typlogie DET_TYP.';
   end;

  CHBxmLVSdoLVSBzlJPOst:=TCheckBoxNactLED.Create(Self);
  with CHBxmLVSdoLVSBzlJPOst do
   begin
    Parent := self;//panel1;
    name:='CHBxmLVSdoLVSBzlJPOst';
    left   :=  LabBezlesi.left;
    top    :=  CHBxmSLTdoSLTBzlJPOst.top+height+10;
    Width  :=  200;
    caption:='LVS-->LVS';
    PozadovaneNacteniZLedu:=LVSdoLVSBzlJPOst;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Z LVS ve vrstv DET dopln LVS do bezles, jinho pozemku a ostatnch.';
   end;

  CHBxmBLABLABLAdoBZL_DRUH:=TCheckBoxNactLED.Create(Self);
  with CHBxmBLABLABLAdoBZL_DRUH  do
   begin
    Parent := self;//panel1;
    name:='CHBxmBLABLABLAdoBZL_DRUH';
    left   :=  LabBezlesi.left;
    top    :=  CHBxmLVSdoLVSBzlJPOst.top+height+10;
    Width  :=  200;
    caption:='(BLABLABLA)-->BZL_DRUH';
    PozadovaneNacteniZLedu:=BLABLABLAdoBZL_DRUH;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Dle retezce uvedenho v Pol.DETu 1 najde  ve vrstv DET vlastnost a jej hodnotu dopln do druhu v bezles a jinm pozemku v Taxu';
   end;

   Ed1BLABLABLAdoBZL_DRUH:=TEdit.Create(self);
   with Ed1BLABLABLAdoBZL_DRUH  do
   begin
    Parent := self;//panel1;
    name:='Ed1BLABLABLAdoBZL_DRUH';
    left   :=  CHBxmBLABLABLAdoBZL_DRUH.left;
    top    :=  CHBxmBLABLABLAdoBZL_DRUH.top+height;

    Width  :=  100;
    TEXT   :='BLABLABLA';
   end;


  CHBxmKULTURAdoDRUH_POZJP:=TCheckBoxNactLED.Create(Self);
  with CHBxmKULTURAdoDRUH_POZJP  do
   begin
    Parent := self;
    name:='CHBxmKULTURAdoDRUH_POZJP';
    left   :=  LabJinyPozemek.left;
    top    :=  CHBxmKATPAR_KODdoPOT_VLASTJP.top+height+10;
    Width  :=  200;
    caption:='KULTURA-->DRUH_POZ';
    PozadovaneNacteniZLedu:=KULTURAdoDRUH_POZJP;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Provede pekryv DETu s vrstvou parcel a nate z parcel Kulturu do DRUH_POZ v jinm pozemku v taxu. Pokud do jinho pozemku zasahuje vice parcel s odlinou kulturou,  dopln do DRUH_POZ nejvce plon zastoupenou kuturu';
   end;

  CHBxmKULTURAdoDRUH_POZOST:=TCheckBoxNactLED.Create(Self);
  with CHBxmKULTURAdoDRUH_POZOST  do
   begin
    Parent := self;
    name:='CHBxmKULTURAdoDRUH_POZOST';
    left   :=  LabOstatni.left;
    top    :=  CHBxmKATPAR_KODdoPOT_VLASTOst.top+height+10;
    Width  :=  200;
    caption:='KULTURA-->DRUH_POZ';
    PozadovaneNacteniZLedu:=KULTURAdoDRUH_POZOST;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Provede pekryv DETu s vrstvou parcel a nate z parcel Kulturu do DRUH_POZ v ostatnm pozemku v taxu. Pokud do ostatnho pozemku zasahuje vice parcel s odlinou kulturou,  dopln do DRUH_POZ nejvce plon zastoupenou kuturu';
   end;


  CHBxmPoznamkaDoBZL_VYUZ:=TCheckBoxNactLED.Create(Self);
  with CHBxmPoznamkaDoBZL_VYUZ  do
   begin
    Parent := self;
    name:='CHBxmPoznamkaDoBZL_VYUZ';
    left   :=  LabBezlesi.left;
    // top    :=  CHBxmBLABLABLAdoBZL_DRUH.top+height+10;
    top    :=  Ed1BLABLABLAdoBZL_DRUH.top+height+10;

    Width  :=  200;
    caption:='Poznamka-->BZL_VYUZ';
    PozadovaneNacteniZLedu:=PoznamkaDoBZL_VYUZ;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Z dynamick vlastnosti "POZNAMKA" do BZL_VYUZ';
   end;


   Ed1PoznamkaDoBZL_VYUZ:=TEdit.Create(self);
   with Ed1PoznamkaDoBZL_VYUZ  do
   begin
    Parent := self;//panel1;
    name:='PoznamkaDoBZL_VYUZ';
    left   :=  CHBxmPoznamkaDoBZL_VYUZ.left;
    top    :=  CHBxmPoznamkaDoBZL_VYUZ.top+height;

    Width  :=  100;
    TEXT   :='Poznamka';
   end;


  CHBxmPoznamkaDoJP_VYUZ:=TCheckBoxNactLED.Create(Self);
  with CHBxmPoznamkaDoJP_VYUZ  do
   begin
    Parent := self;
    name:='CHBxmPoznamkaDoJP_VYUZ';
    left   :=  LabJinyPozemek.left;
    top    :=  CHBxmKULTURAdoDRUH_POZJP.top+height+10;
    Width  :=  200;
    caption:='Poznamka-->JP_VYUZ';
    PozadovaneNacteniZLedu:=PoznamkaDoJP_VYUZ;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Z dynamick vlastnosti "POZNAMKA" do JP_VYUZ';
   end;

  CHBxmPoznamkaDoOST_VYUZ:=TCheckBoxNactLED.Create(Self);
  with CHBxmPoznamkaDoOST_VYUZ  do
   begin
    Parent := self;
    name:='CHBxmPoznamkaDoOST_VYUZ';
    left   :=  LabOstatni.left;
    top    :=  CHBxmKULTURAdoDRUH_POZOST.top+height+10;
    Width  :=  200;
    caption:='Poznamka-->OST_VYUZ';
    PozadovaneNacteniZLedu:=PoznamkaDoOST_VYUZ;
    caption:=inttostr(ord(PozadovaneNacteniZLedu))+'.'+caption;
    Vysvetleni:='Z dynamick vlastnosti "POZNAMKA" do OST_VYUZ';
   end;


  PozadovaneNacteniZLeduDoChecku;
  MemoDoChecku;

end;
procedure TFSPPolNactLED.ZCheckuDoPozadovaneNacteniZLedu;
var
 i:integer;
 begin
  with PozadovaneNacteniZLedu do
   begin
    NacteniZLedu:=[];
    for I := 0 to ComponentCount -1 do
     begin
      if Components[I] is TCheckBoxNactLED then
       begin
        if TCheckBoxNactLED(Components[I]).checked then
         begin
          NacteniZLedu:=NacteniZLedu+[TCheckBoxNactLED(Components[I]).PozadovaneNacteniZLedu];
         end;
       end;
     end;
    TxtPoznamkaDoBZL_VYUZ:=Ed1PoznamkaDoBZL_VYUZ.Text;
    TxtBLABLABLAdoBZL_DRUH:=Ed1BLABLABLAdoBZL_DRUH.text;
   end;
 end;
procedure TFSPPolNactLED.PozadovaneNacteniZLeduDoChecku;
var
 i:integer;
 begin
  with PozadovaneNacteniZLedu do
   begin
    for I := 0 to ComponentCount -1 do
     begin
      if Components[I] is TCheckBoxNactLED then
       begin
        if TCheckBoxNactLED(Components[I]).PozadovaneNacteniZLedu in NacteniZLedu then
         begin
          TCheckBoxNactLED(Components[I]).Checked:=true;
         end
        else
         begin
          TCheckBoxNactLED(Components[I]).Checked:=false;
         end;
       end;
     end;
    Ed1PoznamkaDoBZL_VYUZ.Text:=TxtPoznamkaDoBZL_VYUZ;
    Ed1BLABLABLAdoBZL_DRUH.text:=TxtBLABLABLAdoBZL_DRUH;
   end;

 end;

procedure TFSPPolNactLED.MemoDoChecku;
var
 i:integer;
 begin
  for I := 0 to ComponentCount -1 do
   begin
    if Components[I] is TCheckBoxNactLED then
     begin
      TCheckBoxNactLED(Components[I]).infoMemo:=Memo1;
     end;
   end;
 end;



procedure TFSPPolNactLED.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 ZCheckuDoPozadovaneNacteniZLedu;
end;



procedure TFSPPolNactLED.OKBtnClick(Sender: TObject);
begin
  odpoved:=true;
  close;
end;

procedure TFSPPolNactLED.CancelBtnClick(Sender: TObject);
begin
  odpoved:=false;
  close;
end;

procedure TFSPPolNactLED.FormShow(Sender: TObject);
begin
 ActiveControl:=OKBtn;
 odpoved:=false;
end;

procedure TFSPPolNactLED.ButZapVseClick(Sender: TObject);
var I:integer;
begin
  for I := 0 to ComponentCount -1 do
    begin
     if Components[I] is TCheckBoxNactLED then
      begin
       TCheckBoxNactLED(Components[I]).Checked := true;
      end;
    end;
end;

procedure TFSPPolNactLED.ButVypVseClick(Sender: TObject);
var I:integer;
begin
  for I := 0 to ComponentCount -1 do
    begin
     if Components[I] is TCheckBoxNactLED then
      begin
       TCheckBoxNactLED(Components[I]).Checked := false;
      end;
    end;
end;

end.
