unit SpHla200;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,inifiles,
  mat1,ELesObec,E_lesCel, E_lesOdd, uPrevod, U_Zobraz, dotaz, sp_vyhSo, StdCtrls, ExtCtrls;
type
  TFHla2000 = class(TForm)
    LLHC_NAZ: TLabel;
    LLHC_KOD: TLabel;
    LLHP_OD: TLabel;
    LLHP_DO: TLabel;
    Label5: TLabel;
    PanelNast: TPanel;
    RadioGrUklDat: TRadioGroup;
    RadButPSK: TRadioButton;
    RadButPor: TRadioButton;
    PanelLHC: TPanel;
    EdAdrTax: TEdit;
    RadioGrNacOdd: TRadioGroup;
    RadButOdd: TRadioButton;
    RadButTlac: TRadioButton;
    RadButDil: TRadioButton;
    Panel1: TPanel;
    RadButOddNaraz: TRadioButton;
    RadButPostup: TRadioButton;
    Ch_BezKury: TCheckBox;
    Ch_PtatNaUkla: TCheckBox;
    Label1: TLabel;
    EdAdrP0110: TEdit;
    Label6: TLabel;
    ButNajP0110: TButton;
    RadioGrNactPloch: TRadioGroup;
    Panel2: TPanel;
    RadButNactOdd: TRadioButton;
    RadButNactPor: TRadioButton;
    RadButNactPsk: TRadioButton;
    RadButNactDil: TRadioButton;
    Ch_MZD999: TCheckBox;
    Ch_ZablokovatZmenyVPHS: TCheckBox;
    RadioGrKU6_9: TRadioGroup;
    Panel3: TPanel;
    RadButKU6: TRadioButton;
    RadButKU9: TRadioButton;
    RadButKUDleDat: TRadioButton;
    Ch_nesklepStOzn: TCheckBox;
    Ch_doplnujTextyZKategPor: TCheckBox;
    Ch_PocitatHSdlePHSWinPostaru: TCheckBox;
    Ch_CiselnikZvlStBezOchrPrir: TCheckBox;
    Ch_nesklepOchrPrir: TCheckBox;
    Ch_DoplnovatKtgZvlOchrZeSamostTabulek: TCheckBox;
    ComboMZD: TComboBox;
    LabExpMZD: TLabel;
    RadioGroup1: TRadioGroup;
    Panel4: TPanel;
    RadButDelatScaleBy: TRadioButton;
    RadButNeDelatScaleby: TRadioButton;
    Ch_triditKategoriePredHSdlePHSWIN: TCheckBox;
    Ch_CelOddZahrn: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Ch_BezKuryClick(Sender: TObject);
    procedure Ch_PtatNaUklaClick(Sender: TObject);
    procedure ButNajP0110Click(Sender: TObject);
    procedure Ch_MZD999Click(Sender: TObject);
    procedure Ch_ZablokovatZmenyVPHSClick(Sender: TObject);
    procedure Ch_nesklepStOznClick(Sender: TObject);
    procedure Ch_doplnujTextyZKategPorClick(Sender: TObject);
    procedure Ch_PocitatHSdlePHSWinPostaruClick(Sender: TObject);
    procedure Ch_CiselnikZvlStBezOchrPrirClick(Sender: TObject);
    procedure Ch_nesklepOchrPrirClick(Sender: TObject);
    procedure Ch_DoplnovatKtgZvlOchrZeSamostTabulekClick(Sender: TObject);
    procedure RadButDelatScaleByClick(Sender: TObject);
    procedure Ch_triditKategoriePredHSdlePHSWINClick(Sender: TObject);
    procedure Ch_CelOddZahrnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
     LesniCelek:TLesniCelek;
     stGrm1LHP_OD,stGrm1LHP_DO,stGrm1LHC_NAZ,stGrm1LHC_KOD:TStringGridMujJednoPole;
     stGrmLhc:TStringGridMuj;
     ulozitVelikostHlavnihoOkna:Boolean;
     procedure PreZobraz;
     procedure RePaint; override;
     procedure stGrmLhcExit(Sender: TObject);
     procedure ZCombaZpusobVyplneniPovinnehoMZD;
  end;

var
  FHla2000: TFHla2000;
  ZablokovatZmenyVPHS, nesklepStOzn, nesklepOchrPrir :boolean;
implementation

{$R *.DFM}
uses Ekoldot;

procedure TFHla2000.PreZobraz;
var LhcMN:TLesniMnozina;
    initext:Tinifile;
 begin
  with LesniCelek do
   begin
    lhc.VlastnostiMNCreateKdyzNejsou;
    lhc.smazModrouBarvu;
    edAdrTAx.text:=adresarObecnychDatLHP;
    initext:=Tinifile.create(PHSNazev+'\PHS.ini');
    edAdrP0110.text:=iniText.ReadString('DATABASE','TOPOL','');
    initext.free;
    if  edAdrP0110.text='' then
     begin
      initext:=Tinifile.create(KPoslednimuZnaku(Application.ExeName,'\')+'\vtx.ini');
      edAdrP0110.text:=iniText.ReadString('DATABASE','TOPOL','C:\');
      initext.free;
     end;
    with stGrm1LHC_NAZ do
     begin
      ObLesPrvek:=lhc;
      refresh;
     end;
    with stGrm1LHC_KOD do
     begin
      ObLesPrvek:=lhc;
      refresh;
     end;
    with stGrm1LHP_OD do
     begin
      ObLesPrvek:=lhc;
      refresh;
     end;
    with stGrm1LHP_DO do
     begin
      ObLesPrvek:=lhc;
      refresh;
     end;
    with stGrmLhc do
     begin
      LhcMN:=TLesniMnozina.create;
      LhcMN.FClass:=TLHC;
      LhcMN.PredponaName:='LHC';
      LhcMN.addelement(Lhc);
      ObLesMN:=LhcMN;
      mnozinuDoGriduAVlastnosti;
      PouzeCteni:=false;
     end;

   end;
 end;
procedure TFHla2000.FormCreate(Sender: TObject);
var i:integer;
begin
  ulozitVelikostHlavnihoOkna:=false;
  stGrm1LHC_NAZ:=TStringGridMujJednoPole.Create(Self);
  with StGrm1LHC_NAZ do
   begin
    Parent := self;
    top    := 24;
    left   := 6;
    mheight := 30;
    mwidth  := 140;
    JmenoProperty:='LHC_NAZ';
   end;
  stGrm1LHC_NAZ.left:=LLHC_NAZ.left;
  stGrm1LHC_KOD:=TStringGridMujJednoPole.Create(Self);
  with StGrm1LHC_KOD do
   begin
    Parent  := self;
    top     := 24;
    left    := 10;
    mheight := 19;
    mwidth  := 60;
    JmenoProperty:='LHC_KOD';
   end;
  stGrm1LHC_KOD.left:=LLHC_KOD.left;

  stGrm1LHP_OD:=TStringGridMujJednoPole.Create(Self);
  with StGrm1LHP_OD do
   begin
    Parent := self;
    top    := 24;
    left   := 94;
    mheight := 19;
    mwidth  := 70;
    JmenoProperty:='LHP_OD';
   end;
  stGrm1LHP_OD.left:=LLHP_OD.left;

  stGrm1LHP_DO:=TStringGridMujJednoPole.Create(Self);
  with StGrm1LHP_DO do
   begin
    Parent := self;
    top    := 24;
    left   := 94;
    mheight := 19;
    mwidth  := 70;
    JmenoProperty:='LHP_DO';
   end;
  stGrm1LHP_DO.left:=LLHP_DO.left;


  stGrmLhc:=TStringGridMuj.Create(Self);
  with StGrmLhc do
   begin
    name:='stGrmLhc';
    NastavStringGridMujNaTax200(stGrmLhc);
    defaultRowHeight:=22;
    Parent := PanelLHC;
    ZobrazeniGridu:=vybranePole;
    top     := 70;
    left    := 10;
    height  := 105;
    width   := 540;
    align   := alClient;
    ObLesMN := TLesniMnozina.create;
    ObLesMN.FClass:=TLHC;
    ObLesMN.PredponaName:='LHC';
    NastavGrid;
    with VlastnostiSloupcuMN do
     begin
      for I:=0 to count-1 do
       begin
        with TVlastnostiSloupcu(elements[i]) do
         begin
          viditelny:=False;
         end;
       end;
     end;
    with VlastnostiSloupcuMN do
     begin
      JmenoAktualnihoPrvku:='LHC_KOD';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=45;
        Nadpis:='LHC_KOD';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='LHC_KOD_ID';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=60;
        Nadpis:='LHC_KOD_ID';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='LHC_NAZ';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=150;
        Nadpis:='LHC_NAZ';
        poziceTisku:=uprostred;
       end;


      JmenoAktualnihoPrvku:='LHP_OD';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=70;
        Nadpis:='LHP_OD';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='LHP_DO';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=70;
        Nadpis:='LHP_D0';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='ETAT_TO';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=60;
        Nadpis:='ETAT_TO';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='ETAT_TV';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=60;
        Nadpis:='ETAT_TV';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='ETAT';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=60;
        Nadpis:='ETAT';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='ETAT_TVYB';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=60;
        Nadpis:='ETAT_TVYB';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='LHP_Z_OD';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=60;
        Nadpis:='LHP_Z_OD';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='LHP_Z_DO';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=60;
        Nadpis:='LHP_Z_DO';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='LHP_Z_TAX';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=60;
        Nadpis:='LHP_Z_TAX';
        poziceTisku:=uprostred;
       end;


      JmenoAktualnihoPrvku:='LHP_TAX';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=90;
        Nadpis:='LHP_TAX';
        poziceTisku:=uprostred;
       end;


      JmenoAktualnihoPrvku:='LHP_Z_LIC';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=60;
        Nadpis:='LHP_Z_LIC';
        poziceTisku:=uprostred;
       end;


      JmenoAktualnihoPrvku:='LHP_LIC';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=90;
        Nadpis:='LHP_LIC';
        poziceTisku:=uprostred;
       end;


      JmenoAktualnihoPrvku:='LHP_Z_LIC';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=60;
        Nadpis:='LHP_Z_LIC';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='MVYCH_DO40';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=80;
        Nadpis:='MVYCH_DO40';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='TEZ_PROC';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=60;
        Nadpis:='TEZ_PROC';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='NOR_PAS';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=60;
        Nadpis:='NOR_PAS';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='LHC_PN_PRO';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=80;
        Nadpis:='LHC_PN_PRO';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='LHC_IND';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=60;
        Nadpis:='LHC_IND';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='LHC_MAX';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=60;
        Nadpis:='LHC_MAX';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='LHP_NEZDAR';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=80;
        Nadpis:='LHP_NEZDAR';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='KU_DATUM';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=60;
        Nadpis:='KU_DATUM';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='LHO';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=20;
        Nadpis:='LHO';
        poziceTisku:=uprostred;
       end;
     end;
    PripravZobrazeniGridu;
    onExit:=stGrmLhcExit;
    Align:=AlTop;
   end;
end;
procedure TFHla2000.RePaint;
 begin
  inherited repaint;
  prezobraz;
 end;

procedure TFHla2000.FormShow(Sender: TObject);
 begin
  PreZobraz;
 end;

procedure TFHla2000.stGrmLhcExit(Sender: TObject);
 begin
  stGrmLhc.onExit:=nil;
  stGrmLhc.DoExitPublic;
  stGrmLhc.onExit:=stGrmLhcExit;
 end;

procedure TFHla2000.FormClose(Sender: TObject; var Action: TCloseAction);
var
 puvAdrText,SS:string;
 initext:Tinifile;
 begin
  stGrmLhcExit(Nil);
   initext:=Tinifile.create(lesniCelek.PHSNazev+'\PHS.ini');
  if Ch_CelOddZahrn.Checked then SS:='ANO'
                                          else SS:='NE';
  initext.writeString('ObecneParametry','CelOddZahrn',SS);


  if CH_DoplnovatKtgZvlOchrZeSamostTabulek.Checked then SS:='ANO'
                                          else SS:='NE';
  initext.writeString('ObecneParametry','DoplnovatKtgZvlOchrZeSamostTabulek',SS);

  if CH_PocitatHSdlePHSWinPostaru.Checked then SS:='ANO'
                                          else SS:='NE';
  initext.writeString('ObecneParametry','PocitatHSdlePHSWinPostaru',SS);

  if CH_triditKategoriePredHSdlePHSWIN.Checked then SS:='ANO'
                                          else SS:='NE';
  initext.writeString('ObecneParametry','triditKategoriePredHSdlePHSWIN',SS);

  if CH_CiselnikZvlStBezOchrPrir.Checked then SS:='ANO'
                                          else SS:='NE';
  initext.writeString('ObecneParametry','CiselnikZvlStBezOchrPrir',SS);

  initext.writeString('ObecneParametry','ZpusobVyplneniPovinnehoMZD','dleSesulky2011');

  if ComboMZD.text='pvodn'      then initext.writeString('ObecneParametry','ZpusobVyplneniPovinnehoMZD','normalne');
  if ComboMZD.text='exportovat MZD pod 80, je-li tez.proc ped po. obnovy'  then
                                       initext.writeString('ObecneParametry','ZpusobVyplneniPovinnehoMZD','dleZezuly');
  if ComboMZD.text='dle LCR 2011' then initext.writeString('ObecneParametry','ZpusobVyplneniPovinnehoMZD','dleSesulky2011');



    puvAdrText:=iniText.ReadString('DATABASE','TOPOL','');
    if ubm(uppercase(edAdrP0110.text))<>ubm(uppercase(puvAdrText)) then
     begin
      iniText.WriteString('DATABASE','TOPOL',edAdrP0110.text);
      initext.free;
      initext:=Tinifile.create(KPoslednimuZnaku(Application.ExeName,'\')+'\vtx.ini');
      iniText.WriteString('DATABASE','TOPOL',edAdrP0110.text);
     end;
  initext.free;
 end;

procedure TFHla2000.Ch_BezKuryClick(Sender: TObject);
 begin
   odkornovat:=Ch_BezKury.Checked;
 end;

procedure TFHla2000.Ch_PtatNaUklaClick(Sender: TObject);
begin
  ptatSeNaUkladani1:=Ch_PtatNaUkla.Checked;
end;

procedure TFHla2000.ButNajP0110Click(Sender: TObject);
var
  S_VyhlSoub1: TS_VyhlSoub1;
  initext:Tinifile;
begin
  Application.CreateForm(TS_VyhlSoub1, S_VyhlSoub1);
  S_VyhlSoub1.caption:='Vyhledej P0110.DBF .';
  S_VyhlSoub1.fileListBox1.mask := 'P0110.DBF';
  try
    S_VyhlSoub1.DirectoryListBox1.Directory:=
         KPoslednimuZnaku(EdAdrP0110.text,'\');
  except
   S_VyhlSoub1.DirectoryListBox1.Directory:='C:\';
  end;
  S_VyhlSoub1.showmodal;
  if S_VyhlSoub1.Vybrano then
   begin
    EdAdrP0110.text:=S_VyhlSoub1.DirectoryListBox1.Directory+'\P0110.dbf';
   end;
end;

procedure TFHla2000.Ch_MZD999Click(Sender: TObject);
begin
 UkladatMZD999:=Ch_MZD999.Checked;
end;

procedure TFHla2000.Ch_ZablokovatZmenyVPHSClick(Sender: TObject);
 begin
  ZablokovatZmenyVPHS:=Ch_ZablokovatZmenyVPHS.Checked;
 end;

procedure TFHla2000.Ch_nesklepStOznClick(Sender:TObject);
 begin
   nesklepStOzn:=Ch_nesklepStOzn.Checked;
 end;

procedure TFHla2000.Ch_doplnujTextyZKategPorClick(Sender: TObject);
 begin
  doplnujTextyZKategPor:=Ch_doplnujTextyZKategPor.Checked;
 end;


procedure TFHla2000.Ch_PocitatHSdlePHSWinPostaruClick(Sender: TObject);
 begin
  PocitatHSdlePHSWinPostaru:=Ch_PocitatHSdlePHSWinPostaru.Checked;
 end;

procedure TFHla2000.Ch_CiselnikZvlStBezOchrPrirClick(Sender: TObject);
begin
 CiselnikZvlStBezOchrPrir:=Ch_CiselnikZvlStBezOchrPrir.Checked;
end;

procedure TFHla2000.Ch_nesklepOchrPrirClick(Sender: TObject);
begin
  nesklepOchrPrir:=Ch_NesklepOchrPrir.Checked;
end;

procedure TFHla2000.Ch_DoplnovatKtgZvlOchrZeSamostTabulekClick(
  Sender: TObject);
begin
 DoplnovatKtgZvlOchrZeSamostTabulek:=Ch_DoplnovatKtgZvlOchrZeSamostTabulek.Checked;
end;

procedure TFHla2000.ZCombaZpusobVyplneniPovinnehoMZD;
 begin
  if ComboMZD.Text='dle LCR 2011' then
   begin
    LesniCelek.LHC.ZpusobVyplneniPovinnehoMZD:=dleSesulky2011;
   end;
  if ComboMZD.Text='exportovat MZD pod 80, je-li tez.proc ped po. obnovy' then
   begin
    LesniCelek.LHC.ZpusobVyplneniPovinnehoMZD:=dleZezuly;
   end;
  if ComboMZD.Text='pvodn' then
   begin
    LesniCelek.LHC.ZpusobVyplneniPovinnehoMZD:=normalne;
   end;
 end;


procedure TFHla2000.RadButDelatScaleByClick(Sender: TObject);
begin
  if RadButDelatScaleby.Checked then
   begin
    Application.CreateForm(TdotazF1,dotazF2);
    dotazF2.caption:='Dotaz na uloen.';
    dotazF2.label1.caption:='M se uloit velikost hlavnho okna zpisnku?';
    dotazF2.label2.caption:='';
    dotazF2.label3.caption:='';
    dotazF2.ActiveControl:=dotazF2.OKBtn;
    dotazF2.showModal;
    if dotazF2.odpoved=true then
     begin
      ulozitVelikostHlavnihoOkna:=True;
     end
    else
     begin
      ulozitVelikostHlavnihoOkna:=False;
     end;
    dotazF2.free;
   end;

end;

procedure TFHla2000.Ch_triditKategoriePredHSdlePHSWINClick(
  Sender: TObject);
 begin
  triditKategoriePredHSdlePHSWIN:=Ch_triditKategoriePredHSdlePHSWIN.Checked;
 end;

procedure TFHla2000.Ch_CelOddZahrnClick(Sender: TObject);
begin
 celOddZahrn:=Ch_celOddZahrn.Checked;
end;

end.
