unit SpOraLCR;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables,
  UVybBase, mat1;

type
  TFOraLCR = class(TForm)
    LCR_Database: TDatabase;
    Qu_ODD: TQuery;
    Qu_DIL: TQuery;
    Qu_Cisel: TQuery;
    QuLHC: TQuery;
    QuPorost: TQuery;
    QuPrekryv: TQuery;
    QuPorost_Skup: TQuery;
    QuEtaz: TQuery;
    QuDrevina: TQuery;
    QuSkody: TQuery;
    QuDrev_Zales: TQuery;
    QuBezlesi: TQuery;
    QuJine_Poz: TQuery;
    QU_DREVINA: TQuery;
    Query1: TQuery;
    QuNact: TQuery;
    QuDotHS: TQuery;
    QuMojeMap: TQuery;
    QuKtgZvlSt: TQuery;
    QuZvl_ST: TQuery;
  private
    { Private declarations }
    FLHC_ID:string;
  public
    { Public declarations }
    function  ConnectDatabaseNaAno(VDATABASE: TDatabase;UserName,Alias:string):boolean;
    function  KU_nazev(sKU_KOD:string):string;
    function  ORG_UROVEN_nazev(PorOrgUr,sORG_ur:string):string;
    function  MAJ_NAZ(sMAJ_KOD,sMAJ_DRUH:string):string;
    function  OLH_NAZEV(sOLH:string):string;
  published
    property VLHC_ID:String read FLHC_ID write FLHC_ID;
  end;
procedure provedExecSQL(QU:TQuery);

{
var
  FOraLCR: TFOraLCR;
}

implementation

{$R *.DFM}

function  TFOraLCR.OLH_NAZEV(sOLH:string):string;
 begin
  with Qu_Cisel do
   begin
    DatabaseName:='LCR_ORAC';
    active:=false;
    SQL.clear;
    SQL.ADD('select * from C_054 ');
    SQL.ADD('where (LHC_ID='+vLHC_ID+')and(KOD='+sOLH+')');
    open;
    if eof then
     begin
      result:='-'+sOLH+'-';
     end
    else
     begin
      result:=fieldByName('JMENO').asstring;
     end;
    close;
   end;
 end;

function  TFOraLCR.MAJ_NAZ(sMAJ_KOD,sMAJ_DRUH:string):string;
 begin
  with Qu_Cisel do
   begin
    DatabaseName:='LCR_ORAC';
    active:=false;
    SQL.clear;
    SQL.ADD('select * from C_MAJ ');
    SQL.ADD('where (LHC_ID='+vLHC_ID+')and(MAJ_KOD='+sMAJ_KOD+')and(MAJ_DRUH='+sMAJ_DRUH+')');
    open;
    if eof then
     begin
      result:='-'+sMAJ_KOD+'-';
     end
    else
     begin
      result:=fieldByName('MAJ_NAZ').asstring;
     end;
    close;
   end;
 end;

function  TFOraLCR.ORG_UROVEN_nazev(PorOrgUr,sORG_ur:string):string;
 begin
  with Qu_Cisel do
   begin
    DatabaseName:='LCR_ORAC';
    active:=false;
    SQL.clear;
    SQL.ADD('select * from C_ORG_UR ');
    SQL.ADD('where (KOD='+sOrg_ur+')and(LHC_ID='+vLHC_ID+')and(PORADI='+PorOrgUr+')');
    open;
    if eof then
     begin
      result:='-'+sOrg_ur+'-';
     end
    else
     begin
      result:=fieldByName('POPIS'      ).asstring;
     end;
    close;
   end;
 end;

function  TFOraLCR.KU_nazev(sKU_KOD:string):string;
 begin
  with Qu_Cisel do
   begin
    DatabaseName:='LCR_ORAC';
    active:=false;
    SQL.clear;
    SQL.ADD('select * from C_KU ');
    SQL.ADD('where (KOD='+sKU_KOD+')');
    open;
    if eof then
     begin
      result:='-'+sKU_KOD+'-';
     end
    else
     begin
      result:=fieldByName('POPIS'      ).asstring;
     end;
    close;
   end;
 end;
procedure  provedExecSQL(QU:TQuery);
var     F: TextFile;
        i: integer;
    Cesta_ChB:string;
 begin
   try
    QU.ExecSQL;
   except
      Cesta_ChB:=KPoslednimuZnaku(Application.ExeName,'\')+'\ChybyORA.TXT';
    AssignFile(F,Cesta_ChB);
     try
      Append(F);
     except
      rewrite(f);
     end;
    Writeln(F,'');
    Writeln(F,'****');
    for i:=0 to QU.SQL.count-1 do
     begin
      Writeln(F, QU.SQL.strings[i]);
     end;
    CloseFile(F);
   end;
 end;

function TFOraLCR.ConnectDatabaseNaAno(VDATABASE: TDatabase;
                                          UserName,Alias:string):boolean;
var  VPoradku:boolean;
     Sender: TObject;
 begin
  if VDATABASE.connected then exit;
  Application.CreateForm(TFVybBase,FVybBase);
  FVybBase.EUserName.text:=UserName; //'LHP';
  FVybBase.EAlias.text:=Alias; //'LHP';
  repeat
   // misto showmodal zacatek
   {
   FVybBase.EUserName.text:='Koreny';
   FVybBase.EAlias.text:='LCR';
   FVybBase.EPassword.text:='KK';
   }

   FVybBase.EUserName.text:='LCR';
   FVybBase.EAlias.text:='LCR';
   FVybBase.EPassword.text:='KUK';

   FVybBase.Vybrano:=true;
   // misto showmodal konec
   // FVybBase.ShowModal;
   VPoradku:=true;
   if FVybBase.Vybrano then
    begin
     try
     VDataBase.AliasName:=FVybBase.EAlias.text;
     VDataBase.Params.clear;
     VDataBase.Params.add('SQLPASSTHRU MODE=SHARED NOAUTOCOMMIT');
     VDataBase.Params.add('USER NAME='+FVybBase.EUserName.text);
     VDataBase.Params.add('PASSWORD='+FVybBase.EPassword.text);
     // VDataBase.Params[0]:='SQLPASSTHRU MODE=SHARED NOAUTOCOMMIT';
     // VDataBase.Params[1]:='USER NAME='+FVybBase.EUserName.text;
     // VDataBase.Params[2]:='PASSWORD='+FVybBase.EPassword.text;
     VDataBase.connected:=true;
     except
     Application.HandleException(Sender);
     if not(VDataBase.connected) then
       begin
        showmessage('Databzi nelze pipojit. Zkuste to znovu.');
        VPoradku:=false;
       end;
     end;
    end;
  until VPoradku;
  result:=VDataBase.connected;
  FVybBase.free;
 end;


end.
