unit SpP0110;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FileCtrl,Db, DBTables, StdCtrls,IniFiles,
  Mat1,E_lesOdd,E_LesCel,Sp_vyhso, ExtCtrls, Grids, DBGrids;

type
  TFSpP0110 = class(TForm)
    TbPlochSkup: TTable;
    Tb_P0110: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    Button2: TButton;
    Button1: TButton;
    Edit1: TEdit;
    Button3: TButton;
    Button4: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   LesniCelek:TLesniCelek;
   procedure VytvorTabulkuPlochSkup;
   procedure Porovnej_P0110;
   procedure NastavPlochSkupNaMinimum;
   procedure NastavPlochSkupNaMinimumAPlochy;
   procedure NastavPlochSkupNaVse;
  end;

var
  FSpP0110: TFSpP0110;

implementation

{$R *.DFM}

procedure TFSpP0110.VytvorTabulkuPlochSkup;
 begin
  with tbPlochSkup do
   begin
    active:=false;
    FieldDefs.clear;
    fieldDefs.Add('ODD', ftInteger,0,true);
    fieldDefs.Add('DIL', ftString,2,true);
    fieldDefs.Add('POR', ftString,2,true);
    fieldDefs.Add('PSK', ftString,20,true);
    fieldDefs.Add('ODKUD', ftString,5,true);
    fieldDefs.Add('ID', ftInteger,0,true);
    fieldDefs.Add('ODD_TAX', ftInteger,0,false);
    fieldDefs.Add('DIL_TAX', ftString,2,false);
    fieldDefs.Add('POR_TAX', ftString,2,false);
    fieldDefs.Add('PSK_TAX', ftString,20,false);
    fieldDefs.Add('Ploch_TAX',ftFloat,0,false);
    fieldDefs.Add('ODD_P0110', ftInteger,0,false);
    fieldDefs.Add('DIL_P0110', ftString,2,false);
    fieldDefs.Add('POR_P0110', ftString,2,false);
    fieldDefs.Add('PSK_P0110', ftString,20,false);
    fieldDefs.Add('Ploch_P0110',ftFloat,0,false);
    createTable;
    addindex('ccc','ODD;DIL;POR;PSK;ODKUD;ID',[ixprimary]);
    open;
   end;
 end;
procedure TFSpP0110.FormShow(Sender: TObject);
begin
 tbPlochSkup.tableName:=LesniCelek.AdresarObecnychDatLHP+'\tabulky\PlochSkup.DB';
 if FileExists(LesniCelek.AdresarObecnychDatLHP+'\tabulky\PlochSkup.DB') then
  begin
   tbPlochSkup.open;
   NastavPlochSkupNaMinimum;
  end;
end;

procedure TFSpP0110.Button1Click(Sender: TObject);
begin
 NastavPlochSkupNaMinimum;
end;
procedure SkupinyDoTbPlochSkup(VOddeleni:TOddeleni;TbPlochSkup:TTable);
var
 IDil,IPor,IPsk,Ibzl,iJp,IOst,Idd:integer;
 begin
  TbPlochSkup.active:=true;
  idd:=10000;
  for IDil:=0 to VOddeleni.DilecMN.count-1 do
   begin
     for IPor:=0 to VOddeleni.IDilec[IDil].porostMN.count-1 do
      begin
       with VOddeleni.IDilec[IDil].Iporost[iPor] do
        begin
         for iPsk:=0 to PorostniSkupinaMN.count-1 do
          begin
           with TbPlochSkup do
            begin
             insert;
             fieldByName('ODD').asinteger :=VOddeleni.ODD;
             fieldByName('DIL').asstring  :=OwnerDilec.DIL;
             fieldByName('POR').asstring  :=POR;
             fieldByName('PSK').asstring  :=ubm(IPorostniSkupina[iPsk].PSK);
             fieldByName('ODKUD').asstring:='TAX';
             fieldByName('ID').asinteger  :=Idd;
             inc(Idd);
             fieldByName('ODD_TAX').asinteger:=VOddeleni.ODD;
             fieldByName('DIL_TAX').asstring :=OwnerDilec.DIL;
             fieldByName('POR_TAX').asstring :=POR;
             fieldByName('PSK_TAX').asstring :=IPorostniSkupina[iPsk].PSK;
             fieldByName('Ploch_TAX').asfloat:=IPorostniSkupina[iPsk].PSK_P0;
             post;
            end;
          end;
         for iBzl:=0 to BezlesiMN.count-1 do
          begin
           with TbPlochSkup do
            begin
             insert;
             fieldByName('ODD').asinteger :=VOddeleni.ODD;
             fieldByName('DIL').asstring  :=OwnerDilec.DIL;
             fieldByName('POR').asstring  :=POR;
             fieldByName('PSK').asstring  :=inttostr(IBezlesi[iBzl].BZL);
             fieldByName('ODKUD').asstring:='TAX';
             fieldByName('ID').asinteger  :=Idd;
             inc(Idd);
             fieldByName('ODD_TAX').asinteger:=VOddeleni.ODD;
             fieldByName('DIL_TAX').asstring :=OwnerDilec.DIL;
             fieldByName('POR_TAX').asstring :=POR;
             fieldByName('PSK_TAX').asstring :=inttostr(IBezlesi[iBzl].BZL);
             fieldByName('Ploch_TAX').asfloat:=IBezlesi[iBzl].BZL_P0;
             post;
            end;
          end;
         for iJp:=0 to JinyPozemekMN.count-1 do
          begin
           with TbPlochSkup do
            begin
             insert;
             fieldByName('ODD').asinteger :=VOddeleni.ODD;
             fieldByName('DIL').asstring  :=OwnerDilec.DIL;
             fieldByName('POR').asstring  :=POR;
             fieldByName('PSK').asstring  :=inttostr(IJinyPozemek[iJP].JP);
             fieldByName('ODKUD').asstring:='TAX';
             fieldByName('ID').asinteger  :=Idd;
             inc(Idd);
             fieldByName('ODD_TAX').asinteger:=VOddeleni.ODD;
             fieldByName('DIL_TAX').asstring :=OwnerDilec.DIL;
             fieldByName('POR_TAX').asstring :=POR;
             fieldByName('PSK_TAX').asstring :=inttostr(IJinyPozemek[iJP].JP);
             fieldByName('Ploch_TAX').asfloat:=IJinyPozemek[iJP].JP_P0;
             post;
            end;
          end;
         for iOst:=0 to OstatniMN.count-1 do
          begin
           with TbPlochSkup do
            begin
             insert;
             fieldByName('ODD').asinteger :=VOddeleni.ODD;
             fieldByName('DIL').asstring  :=OwnerDilec.DIL;
             fieldByName('POR').asstring  :=POR;
             fieldByName('PSK').asstring  :=inttostr(IOstatni[iOst].OST);
             fieldByName('ODKUD').asstring:='TAX';
             fieldByName('ID').asinteger  :=Idd;
             inc(Idd);
             fieldByName('ODD_TAX').asinteger:=VOddeleni.ODD;
             fieldByName('DIL_TAX').asstring :=OwnerDilec.DIL;
             fieldByName('POR_TAX').asstring :=POR;
             fieldByName('PSK_TAX').asstring :=inttostr(IOstatni[iOst].OST);
             fieldByName('Ploch_TAX').asfloat:=IOstatni[iOst].OST_P0;
             post;
            end;
          end;
        end;
      end;
   end;
 end;
procedure TFSpP0110.Button2Click(Sender: TObject);
begin
 dataSource1.dataset:=nil;
 VytvorTabulkuPlochSkup;
 Porovnej_P0110;
 LesniCelek.nactiPrvniOddeleni;
 edit1.text:='TAX '+inttostr(LesniCelek.LHC.Oddeleni.ODD);
 SkupinyDoTbPlochSkup(LesniCelek.LHC.Oddeleni,TbPlochSkup);
 while not LesniCelek.KonecOddeleni do
  begin
   LesniCelek.nactiOddeleni(false);
   SkupinyDoTbPlochSkup(LesniCelek.LHC.Oddeleni,TbPlochSkup);
   edit1.text:='TAX '+inttostr(LesniCelek.LHC.Oddeleni.ODD);
   edit1.refresh;
  end;
 dataSource1.dataset:=TbPlochSkup;
 tbPlochSkup.active:=true;
 NastavPlochSkupNaMinimum;
end;
procedure TFSpP0110.Porovnej_P0110;
var topAdr:string;
 initext:Tinifile;
 idd,iOdd:integer;
 begin
  Application.CreateForm(TS_VyhlSoub1, S_VyhlSoub1);
  S_VyhlSoub1.caption:='Vyhledej P0110.DBF.';
  S_VyhlSoub1.fileListBox1.mask := 'P0110.DBF';
  initext:=Tinifile.create(KPoslednimuZnaku(Application.ExeName,'\')+'\vtx.ini');
  TopAdr:=iniText.ReadString('DATABASE','TOPOL','C:\wtx');
  try
  S_VyhlSoub1.DirectoryListBox1.Directory:=
         KPoslednimuZnaku(topAdr,'\');
  except
   S_VyhlSoub1.DirectoryListBox1.Directory:='C:\';
  end;
  S_VyhlSoub1.showmodal;
  if S_VyhlSoub1.Vybrano then
   begin
    topAdr:=S_VyhlSoub1.DirectoryListBox1.Directory+'\P0110.dbf';
    S_VyhlSoub1.free;
   end
  else
   begin
    S_VyhlSoub1.free;
    exit;
   end;
  Tb_P0110.Active:=false;
  Tb_P0110.tableName:=topAdr;
  Tb_P0110.Open;
  IOdd:=0;
  idd:=1;
  TbPlochSkup.active:=true;
  while not Tb_P0110.eof do
   begin
    with TbPlochSkup do
     begin
      insert;
      fieldByName('ODD').asinteger :=Tb_P0110.fieldByName('ODDELENI').asinteger;
      fieldByName('DIL').asstring  :=Tb_P0110.fieldByName('DILEC').asstring;
      fieldByName('POR').asstring  :=Tb_P0110.fieldByName('POROST').asstring;
      fieldByName('PSK').asstring  :=Tb_P0110.fieldByName('SKUPINA').asstring;
      fieldByName('ODKUD').asstring:='P0110';
      fieldByName('ID').asinteger  :=Idd;
      inc(Idd);
      fieldByName('ODD_P0110').asinteger :=Tb_P0110.fieldByName('ODDELENI').asinteger;
      fieldByName('DIL_P0110').asstring  :=Tb_P0110.fieldByName('DILEC').asstring;
      fieldByName('POR_P0110').asstring  :=Tb_P0110.fieldByName('POROST').asstring;
      fieldByName('PSK_P0110').asstring  :=Tb_P0110.fieldByName('SKUPINA').asstring;
      fieldByName('Ploch_P0110').asfloat :=Tb_P0110.fieldByName('Plocha').asfloat;
      if IOdd<>Tb_P0110.fieldByName('ODDELENI').asinteger then
       begin
        IOdd:=Tb_P0110.fieldByName('ODDELENI').asinteger;
        edit1.text:='P0110 '+inttostr(IODD);
        edit1.refresh;
       end;
      post;
     end;
    Tb_P0110.next;
   end;
  TbPlochSkup.close;
  Tb_P0110.close;
 end;
procedure TFSpP0110.NastavPlochSkupNaMinimum;
var i:integer;
 begin
  if not TbPlochSkup.active then exit;
  for i:=0 to TbPlochSkup.fieldCount-1 do
   begin
    TbPlochSkup.Fields[i].visible:=false;
   end;
  TbPlochSkup.fieldByName('ODD').visible:=true;
  TbPlochSkup.fieldByName('DIL').visible:=true;
  TbPlochSkup.fieldByName('POR').visible:=true;
  TbPlochSkup.fieldByName('PSK_P0110').visible:=true;
  TbPlochSkup.fieldByName('PSK_TAX').visible:=true;
 end;
procedure TFSpP0110.NastavPlochSkupNaMinimumAPlochy;
var i:integer;
 begin
  if not TbPlochSkup.active then exit;
  for i:=0 to TbPlochSkup.fieldCount-1 do
   begin
    TbPlochSkup.Fields[i].visible:=false;
   end;
  TbPlochSkup.fieldByName('ODD').visible:=true;
  TbPlochSkup.fieldByName('DIL').visible:=true;
  TbPlochSkup.fieldByName('POR').visible:=true;
  TbPlochSkup.fieldByName('PSK_P0110').visible:=true;
  TbPlochSkup.fieldByName('PSK_TAX').visible:=true;
  TbPlochSkup.fieldByName('Ploch_P0110').visible:=true;
  TbPlochSkup.fieldByName('Ploch_TAX').visible:=true;
 end;
procedure TFSpP0110.NastavPlochSkupNaVse;
var i:integer;
 begin
  if not TbPlochSkup.active then exit;
  for i:=0 to TbPlochSkup.fieldCount-1 do
   begin
    TbPlochSkup.Fields[i].visible:=true;
   end;
 end;
procedure TFSpP0110.Button3Click(Sender: TObject);
begin
 NastavPlochSkupNaMinimumAPlochy;
end;

procedure TFSpP0110.Button4Click(Sender: TObject);
 begin
   NastavPlochSkupNaVse;
 end;

end.
