unit SpPorPsk;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  mat1, E_LesCel, E_LesOdd, U_ZobrComb;

type
  TFDilPorPsk = class(TForm)
    EdDil: TEdit;
    EdPor: TEdit;
    EdPSK: TEdit;
    ButOK: TButton;
    ButCancel: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    EdOdd: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    EdOddKam: TEdit;
    EdDilKam: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    EdPorKam: TEdit;
    Label8: TLabel;
    EdPSKKam: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    procedure ButOKClick(Sender: TObject);
    procedure ButCancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure EdPSKKamChange(Sender: TObject);
    procedure EdPorKamChange(Sender: TObject);
    procedure EdDilKamChange(Sender: TObject);
    procedure EdDilKamKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EdPorKamKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EdPSKKamKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
    odpoved:boolean;
    LesniCelek:TLesniCelek;
    procedure ZkopirujPorost(VPorost:TPorost);
  end;

var
  FDilPorPsk: TFDilPorPsk;

implementation

{$R *.DFM}
procedure TFDilPorPsk.ButOKClick(Sender: TObject);
var
 // VOdd:TOddeleni;
 VKopieDil{,VDil}:TDilec;
 VKopiePor{,VPor}:TPorost;
 VKopiePSK{,VPSK}:TPorostniSkupina;
 begin
  //VDil:=LesniCelek.lhc.DilecKdyzJe;
  //VPor:=LesniCelek.lhc.PorostKdyzJe;
  //VPSK:=LesniCelek.lhc.PorostniSkupinaKdyzJe;
  if (ubm(uppercase(FDilPorPsk.EdOddKam.text))=ubm(uppercase(FDilPorPsk.EdOdd.text)))
  and (ubm(uppercase(FDilPorPsk.EdDilKam.text))=ubm(uppercase(FDilPorPsk.EdDil.text)))
  and (ubm(uppercase(FDilPorPsk.EdPorKam.text))=ubm(uppercase(FDilPorPsk.EdPor.text)))
  and (ubm(uppercase(FDilPorPsk.EdPSKKam.text))=ubm(uppercase(FDilPorPsk.EdPSK.text)))
  and (EdPskKam.visible) then
   begin
    showmessage('Zdrojov porostn skupina(odkud) nesm bt toton s clovou(kam) porostn skupinou.');
    exit;
   end;

  if (ubm(uppercase(FDilPorPsk.EdOddKam.text))=ubm(uppercase(FDilPorPsk.EdOdd.text)))
  and (ubm(uppercase(FDilPorPsk.EdDilKam.text))=ubm(uppercase(FDilPorPsk.EdDil.text)))
  and (ubm(uppercase(FDilPorPsk.EdPorKam.text))=ubm(uppercase(FDilPorPsk.EdPor.text)))
  and (not EdPskKam.visible) then
   begin
    showmessage('Zdrojov porost(odkud) nesm bt toton s clovm(kam) porostem.');
    exit;
   end;

  VKopieDil:=TDilec(LesniCelek.lhc.DilecKdyzJe.KopieElementu);
  VKopieDil.DIL:=EdDilKam.text;
  VKopieDil.Rid:=-1;
  VKopieDil.puvodni_Oznaceni:='+-=+-=';
  VKopieDil.PorostMN:=nil;
  if EdPskKam.visible then
   begin
    VKopiePor:=LesniCelek.lhc.PorostKdyzJe.KopiePorostuBezPskJpBzl;
    VKopiePor.POR:=EdPorKam.text;
    VKopiePor.Rid:=-1;
    VKopiePor.puvodni_Oznaceni:='+-=+-=';

    VKopiePSK:=LesniCelek.lhc.porostniskupinaKdyzJe.KopiePorostniSkupiny;
    VKopiePSK.PSK:=FDilPorPsk.EdPSKKam.text;
    if VKopiePSK.etazMN.count=1 then
     begin
      VKopiePSK.IEtaz[0].ETAZ:=FDilPorPsk.EdPSKKam.text;
     end;
    VKopiePSK.Rid:=-1;
    VKopiePSK.puvodni_Oznaceni:='+-=+-=';
   end
  else
   begin
     VKopiePor:=LesniCelek.lhc.PorostKdyzJe.KopiePorostu;
     VKopiePor.POR:=FDilPorPsk.EdPORKam.text;
     VKopiePor.Rid:=-1;
     VKopiePor.puvodni_Oznaceni:='+-=+-=';
   end;
  if inttostr(LesniCelek.lhc.Oddeleni.ODD)<>ubm(FDilPorPsk.EdOddKam.text) then
   begin
    DotazUlozANactiOddeleni(self,LesniCelek,ubm(FDilPorPsk.EdOddKam.text),true);
   end;

  if LesniCelek.lhc.Oddeleni.dilecMN.PocetPrvkuPodleHodnotyProperty('DIL',EdDilKam.text)<1 then
   begin
    showmessage('Dlec '+EdOddKam.text+' '+EdDilKam.text+' neexistuje, vytvom nov.');
    VKopieDil.Vazba:=LesniCelek.lhc.OddeleniKdyzJe.Rid;
    LesniCelek.lhc.OddeleniKdyzJe.DilecMN.addelement(VKopieDil);
    LesniCelek.lhc.OddeleniKdyzJe.DilecMN.aktualniPrvek:=VKopieDil;
   end
  else
   begin
    LesniCelek.lhc.Oddeleni.dilecMN.JmenoAktualnihoPrvku:=FDilPorPsk.EdDilKam.text;
    VKopieDil.free;
   end;
  if EdPskKam.visible then
   begin
    if LesniCelek.lhc.Oddeleni.dilec.porostMN.PocetPrvkuPodleHodnotyProperty('POR',EdPorKam.text)<1 then
     begin
      showmessage('Porost '+EdOddKam.text+' '+EdDilKam.text+' '+EdPorKam.text+' neexistuje, vytvom nov.');
      VKopiePor.Vazba:=LesniCelek.lhc.DilecKdyzJe.Rid;
      LesniCelek.lhc.DilecKdyzJe.PorostMN.addelement(VKopiePor);
      LesniCelek.lhc.DilecKdyzJe.PorostMN.aktualniPrvek:=VKopiePor;
     end
    else
     begin
      LesniCelek.lhc.Oddeleni.dilec.PorostMN.JmenoAktualnihoPrvku:=FDilPorPsk.EdPorKam.text;
      VKopiePor.free;
     end;
    if LesniCelek.lhc.Oddeleni.dilecJmenem(EdDilKam.text).porostJmenem(EdPorKam.text).porostniSkupinaMN.PocetPrvkuPodleHodnotyProperty('PSK',opravenaSkupina(EdPSKKam.text))>0 then
     begin
      showmessage('Porostn skupina '+EdOddKam.text+' '+EdDilKam.text+' '+EdPorKam.text+' '+EdPSKKam.text+' ji existuje.');
      exit;
     end;
    VKopiePSK.Vazba:=LesniCelek.lhc.PorostKdyzJe.Rid;
    LesniCelek.lhc.PorostKdyzJe.PorostniSkupinaMN.addelement(VKopiePSK);
    LesniCelek.lhc.PorostKdyzJe.PorostniSkupinaMN.aktualniPrvek:=VKopiePSK;
   end
  else
   begin
    if LesniCelek.lhc.Oddeleni.dilec.porostMN.PocetPrvkuPodleHodnotyProperty('POR',ubm(EdPorKam.text))>0 then
     begin
      showmessage('Porost '+EdOddKam.text+' '+EdDilKam.text+' '+EdPorKam.text+' ji existuje.');
      exit;
     end;
    VKopiePor.Vazba:=LesniCelek.lhc.DilecKdyzJe.Rid;
    LesniCelek.lhc.DilecKdyzJe.PorostMN.addelement(VKopiePor);
    LesniCelek.lhc.DilecKdyzJe.PorostMN.aktualniPrvek:=VKopiePor;
   end;
  odpoved:=true;
  close;
 end;

{
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
if (ubm(uppercase(FDilPorPsk.EdOddKam.text))=ubm(uppercase(FDilPorPsk.EdOdd.text)))
  or (ubm(uppercase(FDilPorPsk.EdDilKam.text))=ubm(uppercase(FDilPorPsk.EdDil.text)))

  if VOdd.dilecMN.PocetPrvkuPodleHodnotyProperty('DIL',EdDilKam.text)<1 then
   begin
    showmessage('Dlec '+EdOddKam.text+' '+EdDilKam.text+' neexistuje, vytvom nov.');
    VKopieDil:=TDilec(VDil.KopieElementu);
    VKopieDil.DIL:=EdDilKam.text;
    VKopieDil.Rid:=-1;
    VKopieDil.puvodni_Oznaceni:='+-=+-=';
    VKopieDil.Vazba:=LesniCelek.lhc.OddeleniKdyzJe.Rid;
    LesniCelek.lhc.OddeleniKdyzJe.DilecMN.addelement(VKopieDil);
    LesniCelek.lhc.OddeleniKdyzJe.DilecMN.aktualniPrvek:=VKopieDil;
   end;
  // LesniCelek.lhc.Oddeleni.dilecMN.JmenoAktualnihoPrvku:=EdDilKam.text;
  if EdPskKam.visible then
   begin
    if VOdd.DilecJmenem(EdDilKam.text).porostMN.PocetPrvkuPodleHodnotyProperty('POR',EdPorKam.text)<1 then
     begin
      showmessage('Porost '+EdOddKam.text+' '+EdDilKam.text+' '+EdPorKam.text+' neexistuje, vytvom nov.');
      VKopiePor:=VPor.KopiePorostuBezPskJpBzl;
      // VKopiePor:=TPorost(VPor.KopieElementu);
      VKopiePor.POR:=EdPorKam.text;
      VKopiePor.Rid:=-1;
      VKopiePor.puvodni_Oznaceni:='+-=+-=';
      VKopiePor.Vazba:=LesniCelek.lhc.DilecKdyzJe.Rid;
      LesniCelek.lhc.DilecKdyzJe.PorostMN.addelement(VKopiePor);
      LesniCelek.lhc.DilecKdyzJe.PorostMN.aktualniPrvek:=VKopiePor;
     end;
    if VOdd.dilecJmenem(EdDilKam.text).porostJmenem(EdPorKam.text).porostniSkupinaMN.PocetPrvkuPodleHodnotyProperty('PSK',opravenaSkupina(EdPSKKam.text))>0 then
     begin
      showmessage('Porostn skupina '+EdOddKam.text+' '+EdDilKam.text+' '+EdPorKam.text+' '+EdPSKKam.text+' ji existuje.');
      exit;
     end;
    VKopiePSK:=VPSK.KopiePorostniSkupiny;
    VKopiePSK.PSK:=FDilPorPsk.EdPSKKam.text;
    if VKopiePSK.etazMN.count=1 then
     begin
      VKopiePSK.IEtaz[0].ETAZ:=FDilPorPsk.EdPSKKam.text;
     end;
    VKopiePSK.Rid:=-1;
    VKopiePSK.puvodni_Oznaceni:='+-=+-=';
    // FDilPorPsk zajistuje ze musi existovat Odd,Dil,Por
    LesniCelek.lhc.Oddeleni.dilecMN.JmenoAktualnihoPrvku:=FDilPorPsk.EdDilKam.text;
    LesniCelek.lhc.Oddeleni.dilec.PorostMN.JmenoAktualnihoPrvku:=FDilPorPsk.EdPorKam.text;
    VKopiePSK.Vazba:=LesniCelek.lhc.PorostKdyzJe.Rid;
    LesniCelek.lhc.PorostKdyzJe.PorostniSkupinaMN.addelement(VKopiePSK);
    LesniCelek.lhc.PorostKdyzJe.PorostniSkupinaMN.aktualniPrvek:=VKopiePSK;
   end
  else
   begin
    if VOdd.dilecJmenem(EdDilKam.text).porostMN.PocetPrvkuPodleHodnotyProperty('POR',ubm(EdPorKam.text))>0 then
     begin
      showmessage('Porost '+EdOddKam.text+' '+EdDilKam.text+' '+EdPorKam.text+' ji existuje.');
      exit;
     end;
    ZkopirujPorost(VPor);
   end;
}







{
procedure TFDilPorPsk.ButOKClick(Sender: TObject);
var
 VOdd:TOddeleni;
 VKopieDil,VDil:TDilec;
 VKopiePor,VPor:TPorost;
 VKopiePSK,VPSK:TPorostniSkupina;
 begin
  VOdd:=LesniCelek.lhc.Oddeleni;
  VDil:=LesniCelek.lhc.DilecKdyzJe;
  VPor:=LesniCelek.lhc.PorostKdyzJe;
  VPSK:=LesniCelek.lhc.PorostniSkupinaKdyzJe;
  if (ubm(uppercase(FDilPorPsk.EdOddKam.text))=ubm(uppercase(FDilPorPsk.EdOdd.text)))
  and (ubm(uppercase(FDilPorPsk.EdDilKam.text))=ubm(uppercase(FDilPorPsk.EdDil.text)))
  and (ubm(uppercase(FDilPorPsk.EdPorKam.text))=ubm(uppercase(FDilPorPsk.EdPor.text)))
  and (ubm(uppercase(FDilPorPsk.EdPSKKam.text))=ubm(uppercase(FDilPorPsk.EdPSK.text)))
  and (EdPskKam.visible) then
   begin
    showmessage('Zdrojov porostn skupina(odkud) nesm bt toton s clovou(kam) porostn skupinou.');
    exit;
   end;

  if (ubm(uppercase(FDilPorPsk.EdOddKam.text))=ubm(uppercase(FDilPorPsk.EdOdd.text)))
  and (ubm(uppercase(FDilPorPsk.EdDilKam.text))=ubm(uppercase(FDilPorPsk.EdDil.text)))
  and (ubm(uppercase(FDilPorPsk.EdPorKam.text))=ubm(uppercase(FDilPorPsk.EdPor.text)))
  and (not EdPskKam.visible) then
   begin
    showmessage('Zdrojov porost(odkud) nesm bt toton s clovm(kam) porostem.');
    exit;
   end;

if inttostr(LesniCelek.lhc.Oddeleni.ODD)=ubm(FDilPorPsk.EdOddKam.text) then
   begin
    VOdd:=LesniCelek.lhc.Oddeleni;
   end
  else
   begin
    vOdd:=LesniCelek.OddeleniDleCislaBezTransformace(strtoInt(FDilPorPsk.EdOddKam.text));
   end;

  if VOdd=nil then
   begin
    showmessage('Oddlen '+FDilPorPsk.EdOddKam.text+' neexistuje.');
    exit;
   end;


  if VOdd.dilecMN.PocetPrvkuPodleHodnotyProperty('DIL',EdDilKam.text)<1 then
   begin
    showmessage('Dlec '+EdOddKam.text+' '+EdDilKam.text+' neexistuje, vytvom nov.');
    VKopieDil:=TDilec(VDil.KopieElementu);
    VKopieDil.DIL:=EdDilKam.text;
    VKopieDil.Rid:=-1;
    VKopieDil.puvodni_Oznaceni:='+-=+-=';
    VKopieDil.Vazba:=LesniCelek.lhc.OddeleniKdyzJe.Rid;
    LesniCelek.lhc.OddeleniKdyzJe.DilecMN.addelement(VKopieDil);
    LesniCelek.lhc.OddeleniKdyzJe.DilecMN.aktualniPrvek:=VKopieDil;
   end;
  // LesniCelek.lhc.Oddeleni.dilecMN.JmenoAktualnihoPrvku:=EdDilKam.text;
  if EdPskKam.visible then
   begin
    if VOdd.DilecJmenem(EdDilKam.text).porostMN.PocetPrvkuPodleHodnotyProperty('POR',EdPorKam.text)<1 then
     begin
      showmessage('Porost '+EdOddKam.text+' '+EdDilKam.text+' '+EdPorKam.text+' neexistuje, vytvom nov.');
      VKopiePor:=VPor.KopiePorostuBezPskJpBzl;
      // VKopiePor:=TPorost(VPor.KopieElementu);
      VKopiePor.POR:=EdPorKam.text;
      VKopiePor.Rid:=-1;
      VKopiePor.puvodni_Oznaceni:='+-=+-=';
      VKopiePor.Vazba:=LesniCelek.lhc.DilecKdyzJe.Rid;
      LesniCelek.lhc.DilecKdyzJe.PorostMN.addelement(VKopiePor);
      LesniCelek.lhc.DilecKdyzJe.PorostMN.aktualniPrvek:=VKopiePor;
     end;
    if VOdd.dilecJmenem(EdDilKam.text).porostJmenem(EdPorKam.text).porostniSkupinaMN.PocetPrvkuPodleHodnotyProperty('PSK',opravenaSkupina(EdPSKKam.text))>0 then
     begin
      showmessage('Porostn skupina '+EdOddKam.text+' '+EdDilKam.text+' '+EdPorKam.text+' '+EdPSKKam.text+' ji existuje.');
      exit;
     end;
    VKopiePSK:=VPSK.KopiePorostniSkupiny;
    VKopiePSK.PSK:=FDilPorPsk.EdPSKKam.text;
    if VKopiePSK.etazMN.count=1 then
     begin
      VKopiePSK.IEtaz[0].ETAZ:=FDilPorPsk.EdPSKKam.text;
     end;
    VKopiePSK.Rid:=-1;
    VKopiePSK.puvodni_Oznaceni:='+-=+-=';
    // FDilPorPsk zajistuje ze musi existovat Odd,Dil,Por
    LesniCelek.lhc.Oddeleni.dilecMN.JmenoAktualnihoPrvku:=FDilPorPsk.EdDilKam.text;
    LesniCelek.lhc.Oddeleni.dilec.PorostMN.JmenoAktualnihoPrvku:=FDilPorPsk.EdPorKam.text;
    VKopiePSK.Vazba:=LesniCelek.lhc.PorostKdyzJe.Rid;
    LesniCelek.lhc.PorostKdyzJe.PorostniSkupinaMN.addelement(VKopiePSK);
    LesniCelek.lhc.PorostKdyzJe.PorostniSkupinaMN.aktualniPrvek:=VKopiePSK;
   end
  else
   begin
    if VOdd.dilecJmenem(EdDilKam.text).porostMN.PocetPrvkuPodleHodnotyProperty('POR',ubm(EdPorKam.text))>0 then
     begin
      showmessage('Porost '+EdOddKam.text+' '+EdDilKam.text+' '+EdPorKam.text+' ji existuje.');
      exit;
     end;
    ZkopirujPorost(VPor);
   end;
  odpoved:=true;

  close;
 end;
}

procedure TFDilPorPsk.ButCancelClick(Sender: TObject);
 begin
  odpoved:=false;
  close;
 end;

procedure TFDilPorPsk.FormShow(Sender: TObject);
 begin
  odpoved:=false;
 end;

procedure TFDilPorPsk.EdPSKKamChange(Sender: TObject);
begin
 EdPSKKam.text:=ubm(opravenaSkupina(EdPSKKam.text));
end;

procedure TFDilPorPsk.EdPorKamChange(Sender: TObject);
begin
 EdPorKam.text:=lowerCase(EdPorKam.text);
 if length(EdPorKam.text)>0 then
  begin
   if (EdPorKam.text[1]>'z')or(EdPorKam.text[1]<'a')then
    begin
     EdPorKam.text:='';
    end;
  end;
end;

procedure TFDilPorPsk.EdDilKamChange(Sender: TObject);
begin
 EdDilKam.text:=upperCase(EdDilKam.text);
 if length(EdDilKam.text)>0 then
  begin
   if (EdDilKam.text[1]>'Z')or(EdDilKam.text[1]<'A')then
    begin
     EdDilKam.text:='';
    end;
  end;

end;
procedure TFDilPorPsk.ZkopirujPorost(VPorost:TPorost);
var
 VKopiePor:TPorost;
 begin
     VKopiePor:=VPorost.KopiePorostu;
     VKopiePor.POR:=FDilPorPsk.EdPORKam.text;
     VKopiePor.Rid:=-1;
     VKopiePor.puvodni_Oznaceni:='+-=+-=';
     // FDilPorPsk zajistuje ze musi existovat Odd,Dil
     LesniCelek.lhc.Oddeleni.dilecMN.JmenoAktualnihoPrvku:=FDilPorPsk.EdDilKam.text;
     // LesniCelek.lhc.Oddeleni.dilec.PorostMN.JmenoAktualnihoPrvku:=FDilPorPsk.EdPorKam.text;
     VKopiePor.Vazba:=LesniCelek.lhc.DilecKdyzJe.Rid;
     LesniCelek.lhc.DilecKdyzJe.PorostMN.addelement(VKopiePor);
     LesniCelek.lhc.DilecKdyzJe.PorostMN.aktualniPrvek:=VKopiePor;
 end;
procedure TFDilPorPsk.EdDilKamKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key=13 then
  begin
   activeControl:=EdPorKam;
  end;
end;

procedure TFDilPorPsk.EdPorKamKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key=13 then
  begin
   if EdPskKam.Visible then
    begin
     activeControl:=EdPskKam;
    end
   else
    begin
     activeControl:=ButOK;
    end;
  end;
end;

procedure TFDilPorPsk.EdPSKKamKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key=13 then
  begin
   activeControl:=ButOK;
  end;
end;

end.
