unit UOraLCR;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBTables, Db, Grids, DBGrids, StdCtrls,
  dotaz,E_LesOdd,mat1,UDtbVyb,UVybLHCID,UVybBase,SpOraLCR,
  ComCtrls;
procedure UlozPolozkyLHC_LCR(UklLHC:TLHC;QU:TQuery);
procedure NactiPolozkyLHC_LCR(UklLHC:TLHC;QuNact:TQuery;VLHC_KOD,VLHC_KOD_ID:string);

procedure NactiOddeleni_LCR(var VOddeleni:TOddeleni;VFOraLCR:TFOraLCR;VLHC_KOD_ID:string);
procedure NactiOddeleni_LCR_DleCisla(VLHC_KOD,VLHC_KOD_ID,VOdd:string;
                  var VOddeleni:TOddeleni; VFOraLCR:TFOraLCR);
procedure UlozOddeleni_LCR(UklOddeleni:TOddeleni;VFOraLCR:TFOraLCR);

implementation

procedure UlozPolozkyPoskozeni_LCR(UklPoskozeni:TPoskozeni;QU:TQuery);
var s_poskoz_d:string;
 begin
  with UklPoskozeni do
   begin
    QU.SQL.Clear;
    QU.SQL.Add('INSERT INTO T_POSKOZ (LHC_ID,ODD,DIL,POR,MAJ_KOD,PSK,ETAZ,DR_ZKR,PROC_SOUS,POSKOZ_D,POSKOZ_R)');
    if POSKOZ_R>99 then POSKOZ_R:=99;
    QU.SQL.Add('VALUES      ('
    +IntToStr(OwnerDrevina.OwnerEtaz.OwnerPorostniSkupina.OwnerPorost.OwnerDilec.OwnerOddeleni.OwnerLHC.LHC_KOD_ID)
    +','+IntToStr(OwnerDrevina.OwnerEtaz.OwnerPorostniSkupina.OwnerPorost.OwnerDilec.OwnerOddeleni.ODD)
    +','''+OwnerDrevina.OwnerEtaz.OwnerPorostniSkupina.OwnerPorost.OwnerDilec.DIL+''''
    +','''+OwnerDrevina.OwnerEtaz.OwnerPorostniSkupina.OwnerPorost.POR+''''
    +','+OwnerDrevina.OwnerEtaz.OwnerPorostniSkupina.OwnerPorost.MAJ_KOD
    +','''+OwnerDrevina.OwnerEtaz.OwnerPorostniSkupina.PSK+''''
    +','''+OwnerDrevina.OwnerEtaz.ETAZ+''''
    +','''+OwnerDrevina.DR_ZKR+''''
    +','+IntToStr(OwnerDrevina.PROC_SOUS)
    +','+IntToStr(POSKOZ_D)
    +','+IntToStr(POSKOZ_R)
    +')');
    provedExecSQL(QU);
   end;
 end;
procedure UlozPolozkyDreviny_LCR(UklDrevina:TDrevina;QU:TQuery);
 begin
  with UklDrevina do
   begin
    Qu.SQL.clear;
    Qu.SQL.Add('INSERT INTO T_DREVIN (LHC_ID,ODD,DIL,POR,MAJ_KOD,PSK,ETAZ,DR_ZKR,PROC_SOUS,DR_PUVOD,ZDR_REP,ZAST,VYSKA,TLOUSTKA,BON_R,BON_A,GEN_KLAS,VYB_STR,DR_ZAS_HA,DR_ZAS_CEL,DR_CBP,DR_CPP,DR_PMP,HMOT,IMISE,DR_KVAL,DR_TV,DR_TO,DR_TVYB,DR_ZAS_TAB,HK)');
    QU.SQL.Add('VALUES      ('
    +IntToStr(OwnerEtaz.OwnerPorostniSkupina.OwnerPorost.OwnerDilec.OwnerOddeleni.OwnerLHC.LHC_KOD_ID)
    +','+IntToStr(OwnerEtaz.OwnerPorostniSkupina.OwnerPorost.OwnerDilec.OwnerOddeleni.ODD)
    +','''+OwnerEtaz.OwnerPorostniSkupina.OwnerPorost.OwnerDilec.DIL+''''
    +','''+OwnerEtaz.OwnerPorostniSkupina.OwnerPorost.POR+''''
    +','+OwnerEtaz.OwnerPorostniSkupina.OwnerPorost.MAJ_KOD
    +','''+OwnerEtaz.OwnerPorostniSkupina.PSK+''''
    +','''+OwnerEtaz.ETAZ+''''
    +','''+DR_ZKR+''''
    +','+IntToStr(PROC_SOUS)
    +','''+DR_PUVOD+''''
    +','''''
    +','+IntToStr(ZAST)
    +','+IntToStr(VYSKA)
    +','+IntToStr(TLOUSTKA)
    +','+IntToStr(BON_R)
    +','+IntToStr(BON_A)
    +','''+GEN_KLAS+''''
    +','+inttostr(VYB_STRint)
    +','+IntToStr(DR_ZAS_HA)
    +','+IntToStr(DR_ZAS_CEL)
    +',null'
    +',null'
    +',null'
    +','+floatTOStrf1(HMOT,ffFixed,6,3)
    +','''+IMISE+''''
    +','''+DR_KVAL+''''
    +','+IntToStr(DR_TV)
    +','+IntToStr(DR_TO)
    +','+IntToStr(DR_TVYB)
    +','+IntToStr(DR_ZAS_TAB)
    +','+IntToStr(0)
    +')');
    provedExecSQL(QU);
   end;
 end;

procedure UlozPolozkyZalesneni_LCR(UklZalesneni:TZalesneni;QU:TQuery);
 begin
  with UklZalesneni do
   begin
    Qu.SQL.clear;
    Qu.SQL.Add('INSERT INTO T_ZAL_DR (LHC_ID,ODD,DIL,POR,MAJ_KOD,PSK,ETAZ,ZAL_DR,ZAL_DR_P)');
    QU.SQL.Add('VALUES      ('
    +IntToStr(OwnerEtaz.OwnerPorostniSkupina.OwnerPorost.OwnerDilec.OwnerOddeleni.OwnerLHC.LHC_KOD_ID)
    +','+IntToStr(OwnerEtaz.OwnerPorostniSkupina.OwnerPorost.OwnerDilec.OwnerOddeleni.ODD)
    +','''+OwnerEtaz.OwnerPorostniSkupina.OwnerPorost.OwnerDilec.DIL+''''
    +','''+OwnerEtaz.OwnerPorostniSkupina.OwnerPorost.POR+''''
    +','+OwnerEtaz.OwnerPorostniSkupina.OwnerPorost.MAJ_KOD
    +','''+OwnerEtaz.OwnerPorostniSkupina.PSK+''''
    +','''+OwnerEtaz.ETAZ+''''
    +','''+ZAL_DR+''''
    +','+IntToStr(ZAL_DR_P)
    +')');
    provedExecSQL(QU);
   end;
 end;

procedure UlozPolozkyEtaze_LCR(UklEtaz:TEtaz;QU:TQuery);
 begin
  with UklEtaz do
   begin
    Qu.SQL.clear;
    Qu.SQL.Add('INSERT INTO T_ETAZ (LHC_ID,ODD,DIL,POR,MAJ_KOD,PSK,ETAZ,'
     +'ETAZ_PS,ETAZ_PP,HS,OBMYTI,OBN_DOBA,POC_OBNOVY,MZD,VEK,ZAKM,HOSP_TV,M_Z_ZASOBY,PRO_P,PRO_NAL,PRO_POC,TV_P,TV_NAL,TV_POC,TO_P,TO_NAL,TO_DUVOD,TO_ZPUSOB,TVYB_P,TVYB_NAL,ZAL_DRUH,ZAL_P,M_TEZ_PROC,ODVOZ_TEZ)');
    QU.SQL.Add('VALUES      ('
    +IntToStr(OwnerPorostniSkupina.OwnerPorost.OwnerDilec.OwnerOddeleni.OwnerLHC.LHC_KOD_ID)
    +','+IntToStr(OwnerPorostniSkupina.OwnerPorost.OwnerDilec.OwnerOddeleni.ODD)
    +','''+OwnerPorostniSkupina.OwnerPorost.OwnerDilec.DIL+''''
    +','''+OwnerPorostniSkupina.OwnerPorost.POR+''''
    +','+OwnerPorostniSkupina.OwnerPorost.MAJ_KOD
    +','''+OwnerPorostniSkupina.PSK+''''
    +','''+ETAZ+''''
    +','+floatTOStrf1(ETAZ_PS,ffFixed,6,2)
    +','+floatTOStrf1(ETAZ_PP,ffFixed,6,2)
    +','+IntToStr(HS)
    +','+IntToStr(OBMYTI)
    +','+IntToStr(OBN_DOBA)
    +','+IntToStr(POC_OBNOVY)
    +','+IntToStr(MZD)
    +','+IntToStr(VEK)
    +','+IntToStr(ZAKM)
    +','''+HOSP_TV+''''
    +','+IntToStr(M_Z_ZASOBY)
    +','+floatTOStrf1(PRO_P,ffFixed,6,2)
    +','+u0Oracle(PRO_NAL)
    +','+IntToStr(PRO_POC)
    +','+floatTOStrf1(TV_P,ffFixed,6,2)
    +','+u0Oracle(TV_NAL)
    +','+IntToStr(TV_POC)
    +','+floatTOStrf1(TO_P,ffFixed,6,2)
    +','+u0Oracle(TO_NAL)
    +','+u0Oracle(TO_DUVOD)
    +','+u0Oracle(TO_ZPUSOB)
    +','+floatTOStrf1(TVYB_P,ffFixed,6,2)
    +','+u0Oracle(TVYB_NAL)
    +','''+trim(ZAL_DRUH)+''''
    +','+floatTOStrf1(ZAL_P,ffFixed,6,2)
    +','+IntToStr(M_TEZ_PROC)
    +','''+trim(ODVOZ_TEZ)+''''
    +')');
    provedExecSQL(QU);
   end;
 end;

procedure UlozPolozkyPorostniSkupiny_LCR(UklPorostniSkupina:TPorostniSkupina;QU:TQuery);
var S_Ter_Typ,LES_URAD_st,KVAL_P_st:String;
 begin
  with UklPorostniSkupina do
   begin
    S_Ter_Typ:=u0(TER_TYP);
    if KVAL_P>0 then KVAL_P_st:=IntToStr(KVAL_P)
                  else KVAL_P_st:='null';
    if LES_URAD>0 then LES_URAD_st:=IntToStr(LES_URAD)
                  else LES_URAD_st:='null';
    Qu.SQL.clear;
    Qu.SQL.Add('INSERT INTO T_PSK (LHC_ID,ODD,DIL,POR,MAJ_KOD,PSK,PSK_P0,PSK_V,PSK_P,KVAL_P,LES_URAD,SLT,LT,TER_TYP,PRIB_VZD,HOSP_ZP,PSK_TEXT,KU_KOD)');
    QU.SQL.Add('VALUES      ('
    +IntToStr(OwnerPorost.OwnerDilec.OwnerOddeleni.OwnerLHC.LHC_KOD_ID)
    +','+IntToStr(OwnerPorost.OwnerDilec.OwnerOddeleni.ODD)
    +','''+OwnerPorost.OwnerDilec.DIL+''''
    +','''+OwnerPorost.POR+''''
    +','+OwnerPorost.MAJ_KOD
    +','''+PSK+''''
    +','+floatTOStrf1(PSK_P0,ffFixed,6,2)
    +','+floatTOStrf1(PSK_V,ffFixed,6,2)
    +','+floatTOStrf1(PSK_P,ffFixed,6,2)
    +','+KVAL_P_st
    +','+LES_URAD_st
    +','''+SLT+''''
    +','''+LT+''''
    +','  +S_TER_TYP
    +','+IntToStr(PRIB_VZD)
    +','+IntToStr(HOSP_ZP)
    +','''+DvojitzApostrof(PSK_TEXT)+''''
    +','+IntToStr(KU_KOD)
    +')');
    provedExecSQL(QU);
   end;
 end;


procedure UlozPolozkyBezlesi_LCR(UklBezlesi:TBezlesi;QU:TQuery);
 begin
  with UklBezlesi do
   begin
    Qu.SQL.clear;
    Qu.SQL.Add('INSERT INTO T_BZL (LHC_ID,ODD,DIL,POR,MAJ_KOD,BZL,KU_KOD,LES_URAD,BZL_P0,BZL_V,BZL_P,KVAL_P,BZL_VYUZ,BZL_DRUH)');
    QU.SQL.Add('VALUES      ('
    +IntToStr(OwnerPorost.OwnerDilec.OwnerOddeleni.OwnerLHC.LHC_KOD_ID)
    +','+IntToStr(OwnerPorost.OwnerDilec.OwnerOddeleni.ODD)
    +','''+OwnerPorost.OwnerDilec.DIL+''''
    +','''+OwnerPorost.POR+''''
    +','+OwnerPorost.MAJ_KOD
    +','+IntToStr(BZL)
    +','+IntToStr(KU_KOD)
    +','+IntToStr(LES_URAD)
    +','+floatTOStrf1(BZL_P0,ffFixed,6,2)
    +','+floatTOStrf1(BZL_V,ffFixed,6,2)
    +','+floatTOStrf1(BZL_P,ffFixed,6,2)
    +','+IntToStr(KVAL_P)
    +','''+DvojitzApostrof(BZL_VYUZ)+''''
    +','''+BZL_DRUH+''''
    +')');
    provedExecSQL(QU);
   end;
 end;

procedure UlozPolozkyJine_Poz_LCR(UklJinyPozemek:TJinyPozemek;QU:TQuery);
 begin
  with UklJinyPozemek do
   begin
    Qu.SQL.clear;
    Qu.SQL.Add('INSERT INTO T_JP (LHC_ID,ODD,DIL,POR,MAJ_KOD,JP,KU_KOD,LES_URAD,JP_P0,JP_V,JP_P,KVAL_P,JP_VYUZ,JP_DRUH)');
    QU.SQL.Add('VALUES      ('
    +IntToStr(OwnerPorost.OwnerDilec.OwnerOddeleni.OwnerLHC.LHC_KOD_ID)
    +','+IntToStr(OwnerPorost.OwnerDilec.OwnerOddeleni.ODD)
    +','''+OwnerPorost.OwnerDilec.DIL+''''
    +','''+OwnerPorost.POR+''''
    +','+OwnerPorost.MAJ_KOD
    +','+IntToStr(JP)
    +','+IntToStr(KU_KOD)
    +','+IntToStr(LES_URAD)
    +','+floatTOStrf1(JP_P0,ffFixed,6,2)
    +','+floatTOStrf1(JP_V,ffFixed,6,2)
    +','+floatTOStrf1(JP_P,ffFixed,6,2)
    +','+IntToStr(KVAL_P)
    +','''+DvojitzApostrof(JP_VYUZ)+''''
    +','''+JP_DRUH+''''
    +')');
    provedExecSQL(QU);
   end;
 end;


procedure UlozPolozkyPorostu_LCR(UklPorost:TPorost;QU:TQuery);
var OR_UR1_KODst,OR_UR2_KODst,OR_UR3_KODst:String;
    pridejMajetek:Boolean;
    IC:Integer;
 begin
  with UklPorost do
   begin

    if UBM(SDR_POR)='' then SDR_POR:='N';
    if Org_UrovenMn.count>0 then OR_UR1_KODst:=IntToStr(TOrg_Uroven(Org_UrovenMn.elements[0]).ORG_UROVEN) else OR_UR1_KODst:='null';
    if Org_UrovenMn.count>1 then OR_UR2_KODst:=IntToStr(TOrg_Uroven(Org_UrovenMn.elements[1]).ORG_UROVEN) else OR_UR2_KODst:='null';
    if Org_UrovenMn.count>2 then OR_UR3_KODst:=IntToStr(TOrg_Uroven(Org_UrovenMn.elements[2]).ORG_UROVEN) else OR_UR3_KODst:='null';
    Qu.SQL.clear;
    Qu.SQL.Add('INSERT INTO T_POR (LHC_ID,ODD,DIL,POR,MAJ_KOD,ORG_UR1,ORG_UR2,ORG_UR3,PAS_OHR,LES_OBL,SDR_POR,OLH,POR_TEXT )');
    QU.SQL.Add('VALUES      ('
    +inttostr(OwnerDilec.OwnerOddeleni.OwnerLHC.LHC_KOD_ID)
    +','  +IntToStr(OwnerDilec.OwnerOddeleni.ODD)
    +','''+OwnerDilec.DIL+''''
    +','''+POR+''''
    +','  +MAJ_KOD
    +','  +OR_UR1_KODst
    +','  +OR_UR2_KODst
    +','  +OR_UR3_KODst
    +','''+PAS_OHR+''''
    +','''+LES_OBL+''''
    +','''+ SDR_POR+''''
    +',1'
    //+','''+OLH_98+''''
    +','''+DvojitzApostrof(POR_TEXT_1RAdek)+''''
    +')');
    provedExecSQL(QU);
   end;
 end;



procedure UlozPolozkyOddeleni_LCR(UklOddeleni:TOddeleni;QU:TQuery);
 begin
    Qu.SQL.clear;
    Qu.SQL.Add('INSERT INTO T_ODD (LHC_ID,ODD)');
    QU.SQL.Add('VALUES      ('
    +inttostr(UklOddeleni.OwnerLHC.LHC_KOD_ID)
               +','  +IntToStr(UklOddeleni.ODD)
               +')');
    provedExecSQL(QU);
 end;

procedure UlozPolozkyDilec_LCR(UklDilec:TDilec;QU:TQuery);
 begin
    Qu.SQL.clear;
    Qu.SQL.Add('INSERT INTO T_DIL (LHC_ID,ODD,DIL)');
    QU.SQL.Add('VALUES      ('
    + inttostr(UklDilec.OwnerOddeleni.OwnerLHC.LHC_KOD_ID)
               +','  +IntToStr(UklDilec.OwnerOddeleni.ODD)
               +','''+UklDilec.DIL+''''
               +')');
    provedExecSQL(QU);
 end;

procedure UlozPolozkyZvl_Statut_LCR(UklPorost:TPorost;QU:TQuery);
 begin
  with UklPorost do
   begin
    Qu.SQL.clear;
    Qu.SQL.Add('INSERT INTO T_ZVS (LHC_ID, ODD, DIL, POR, MAJ_KOD, ZVL_STATUT)');
    QU.SQL.Add('VALUES      ('
    +IntToStr(OwnerDilec.OwnerOddeleni.OwnerLHC.LHC_KOD_ID)
    +','+IntToStr(OwnerDilec.OwnerOddeleni.ODD)
    +','''+OwnerDilec.DIL+''''
    +','''+POR+''''
    +','  +MAJ_KOD
    +','  +ZVL_STATUT
    +')');
    provedExecSQL(QU);
   end;
 end;

procedure UlozPolozkyKategorie_LCR(UklKategorie:TKategorie1;QU:TQuery);
 begin
  with UklKategorie do
   begin
    Qu.SQL.clear;
    Qu.SQL.Add('INSERT INTO T_KATEG (LHC_ID, ODD, DIL, POR, MAJ_KOD,PORADI,KATEGORIE,KAT_SPEC)');
    QU.SQL.Add('VALUES      ('
    +IntToStr(OwnerPorost.OwnerDilec.OwnerOddeleni.OwnerLHC.LHC_KOD_ID)
    +','+IntToStr(OwnerPorost.OwnerDilec.OwnerOddeleni.ODD)
    +','''+OwnerPorost.OwnerDilec.DIL+''''
    +','''+OwnerPorost.POR+''''
    +','  +OwnerPorost.MAJ_KOD
    +','+IntToStr(OwnerPorost.Kategorie1MN.indexOf(UklKategorie))
    +','''+KATEGORIE+''''
    +','+IntToStr(OwnerPorost.KAT_SPEC)
    +')');
    provedExecSQL(QU);
   end;
 end;

procedure UlozPolozkyLHC_LCR(UklLHC:TLHC;QU:TQuery);
 begin
  with UklLHC do
   begin
    Qu.SQL.clear;
    Qu.SQL.Add('INSERT INTO LCR.T_LHC (LHC_KOD,LHC_ID,LHP_OD,LHP_DO,LHC_NAZ)');
    // UHUL_KOD,ETAT_TO,ETAT_TC,NAHRANO,PUVOD_DAT)');
    QU.SQL.Add('VALUES      ('
    +IntToStr(LHC_KOD)
    +','+intToStr(LHC_KOD_ID)
    +','+DatumOracle(LHP_OD)
    +','+DatumOracle(LHP_DO)
    +','''+DvojitzApostrof(LHC_NAZ)+'''' +')');

{    +','''+UHUL_KOD+''''
    +','+IntToStr(ETAT_TO)
    +','+IntToStr(ETAT_TV+ETAT_TO)
     +','+DatumOracle(DateToStr(DATE))
     +','''+PUVOD_DAT+''''+')');  }
{    showmessage(Qu.SQL[0]);
     showmessage(Qu.SQL[1]);  }
    provedExecSQL(QU);
{    showmessage('Provedeno'); }
   end;

 end;


procedure NactiPolozkyPoskozeni_LCR(UklPoskozeni:TPoskozeni;QuSkody:TQuery);
 begin
  with UklPoskozeni do
  with QuSKODY do
   begin
    POSKOZ_D:=fieldByName ('POSKOZ_D').asinteger;
    POSKOZ_R:=fieldByName ('POSKOZ_R').asinteger;
   end;
 end;


procedure NactiPolozkyDreviny_LCR(UklDrevina:TDrevina;QuDREVINA:TQuery);
 begin
  with UklDrevina do
  with QuDrevina do
   begin
    DR_ZKR:=fieldByName('DR_ZKR').asstring;
    PROC_SOUS:=fieldByName('PROC_SOUS').asInteger;
    DR_PUVOD:=fieldByName('DR_PUVOD').asstring;
    ZAST:=fieldByName('ZAST').asInteger;
    VYSKA:=fieldByName('VYSKA').asInteger;
    TLOUSTKA:=fieldByName('TLOUSTKA').asInteger;
    BON_R:=StrToInt0(fieldByName('BON_R').asString);
    BON_A:=fieldByName('BON_A').asInteger;
    GEN_KLAS:=fieldByName('GEN_KLAS').asstring;
    VYB_STR:=fieldByName('VYB_STR').asstring;
    DR_ZAS_HA:=fieldByName('DR_ZAS_HA').asInteger;
    DR_ZAS_CEL:=fieldByName('DR_ZAS_CEL').asInteger;
    IMISE:=fieldByName('IMISE').asstring;
    DR_KVAL:=fieldByName('DR_KVAL').asstring;
    DR_TV:=fieldByName('DR_TV').asInteger;
    DR_TO:=fieldByName('DR_TO').asInteger;
    DR_TVYB:=fieldByName('DR_TVYB').asInteger;
    DR_ZAS_TAB:=fieldByName('DR_ZAS_TAB').asInteger;

   { fieldByName('DR_TC').asInteger:=DR_TC;}
    {fieldByName('OBJ_TEZ_N').asInteger:=0;}
   end;
 end;


procedure NactiPolozkyZalesneni_LCR(UklZalesneni:TZalesneni;QuDREV_ZALES:TQuery);
 begin
  with UklZalesneni do
  with QuDREV_ZALES do
   begin
    ZAL_DR:=fieldByName('ZAL_DR').asstring;
    ZAL_DR_P:=fieldByName('ZAL_DR_P').asinteger;
   end;
 end;

procedure NactiPolozkyEtaze_LCR(UklEtaz:TEtaz;QuETAZ:TQuery);
 begin
  with UklEtaz do
  with QuEtaz do
   begin
    ETAZ_nactene:=fieldByName('ETAZ').asstring;
    ETAZ:=OpravenaEtazLHP(ETAZ_nactene);
    ETAZ_PS:=fieldByName('ETAZ_PS').asfloat;
    ETAZ_PP:=fieldByName('ETAZ_PP').asfloat;
    HS:=fieldByName('HS').asinteger;
    OBMYTI:=fieldByName('OBMYTI').asinteger;
    OBN_DOBA:=fieldByName('OBN_DOBA').asinteger;
    MZDs:=fieldByName('OBN_DOBA').asstring;
    VEK:=fieldByName('VEK').asinteger;
    ZAKM:=fieldByName('ZAKM').asinteger;
    HOSP_TV:=fieldByName('HOSP_TV').asstring;
    M_Z_ZASOBY:=fieldByName('M_Z_ZASOBY').asinteger;
    PRO_P:=fieldByName('PRO_P').asfloat;
    PRO_NAL:=fieldByName('PRO_NAL').asstring;
    PRO_POC:=fieldByName('PRO_POC').asinteger;
    TV_P:=fieldByName('TV_P').asfloat;
    TV_NAL:=fieldByName('TV_NAL').asstring;
    TV_POC:=fieldByName('TV_POC').asinteger;
    TO_P:=fieldByName('TO_P').asfloat;
    TO_NAL:=fieldByName('TO_NAL').asstring;
    TO_DUVOD:=fieldByName('TO_DUVOD').asstring;
    TO_ZPUSOB:=fieldByName('TO_ZPUSOB').asstring;
    TVYB_P:=fieldByName('TVYB_P').asfloat;
    TVYB_NAL:=fieldByName('TVYB_NAL').asstring;
    M_TEZ_PROC:=fieldByName('M_TEZ_PROC').asinteger;
    ODVOZ_TEZ:=fieldByName('ODVOZ_TEZ').asstring;
   end;
 end;


procedure NactiPolozkyPorostniSkupiny_LCR(VPorostniSkupina:TPorostniSkupina;QuPOROST_SKUP:TQuery);
 begin
  with VPorostniSkupina do
  with QuPOROST_SKUP do
   begin
    PSK_nactene:=fieldByName('PSK').asstring;
    // PSK se upravi az po nacteni etazi
    PSK_P0:=fieldByName('PSK_P0').asfloat;
    PSK_V:=fieldByName('PSK_V').asfloat;
    PSK_P:=fieldByName('PSK_P').asfloat;
    KVAL_P:=strtoint0(fieldByName('KVAL_P').asstring);
    LES_URAD:=fieldByName('LES_URAD').asinteger;
    SLT:=fieldByName('SLT').asstring;
    LT:=fieldByName('LT').asstring;
    TER_TYP:=fieldByName('TER_TYP').asstring;
    PRIB_VZD:=fieldByName('PRIB_VZD').asinteger;
    KU_KOD:=fieldByName('KU_KOD').asinteger;
    PSK_TEXT:=fieldByName('PSK_TEXT').asstring;
    HOSP_ZP:=strtoint0(fieldByName('HOSP_ZP').asstring);
   end;
 end;

procedure NactiPolozkyBezlesi_LCR(UklBezlesi:TBezlesi;QuBEZLESI:TQuery);
 begin
  with UklBezlesi do
  with QuBEZLESI do
   begin
    BZL:=fieldByName('BZL').asinteger;
    KU_KOD:=fieldByNAme('KU_KOD').asinteger;
    LES_URAD:=strToInt0(fieldByNAme('LES_URAD').asstring);
    BZL_P0:=fieldByNAme('BZL_P0').asfloat;
    BZL_V:=fieldByNAme('BZL_V').asfloat;
    BZL_P:=fieldByNAme('BZL_P').asfloat;
    KVAL_P:=strToInt0(fieldByNAme('KVAL_P').asstring);
    BZL_VYUZ:=fieldByName('BZL_VYUZ').asstring;
    BZL_DRUH:=fieldByName('BZL_DRUH').asstring;
   end;
 end;


procedure NactiPolozkyJine_Poz_LCR(UklJinyPozemek:TJinyPozemek;QuJine_Poz:TQuery);
 begin
  with UklJinyPozemek do
  with QuJine_Poz do
   begin
    JP:=fieldByName('JP').asinteger;
    KU_KOD:=fieldByName('KU_KOD').asinteger;
    LES_URAD:=fieldByName('LES_URAD').asinteger;
    JP_P0:=fieldByName('JP_P0').asfloat;
    JP_V:=fieldByName('JP_V').asfloat;
    JP_P:=fieldByName('JP_P').asfloat;
    KVAL_P:=fieldByName('KVAL_P').asinteger;
    JP_DRUH:=fieldByName('JP_DRUH').asstring;
    JP_VYUZ:=fieldByName('JP_VYUZ').asstring;
   end;
 end;

procedure NactiPolozkyKategorie_LCR(UklKategorie:TKategorie1;QuPREKRYV:TQuery);
 begin
  with UklKategorie do
  with QuPREKRYV do
   begin
    rid:=fieldByName('PORADI').asinteger;
    KATEGORIE:=fieldByName('KATEGORIE').asstring;
    ownerPorost.KAT_SPEC:=strToInt0(fieldByName('KAT_SPEC').asstring);
   end;
 end;

procedure NactiPolozkyLHC_LCR(UklLHC:TLHC;QuNact:TQuery;VLHC_KOD,VLHC_KOD_ID:string);
 begin
  with UklLHC do
  with QuNact do
   begin
    DatabaseName:='LCR_ORAC';
    active:=false;
    SQL.clear;
    SQL.ADD('select * from T_LHC ');
    SQL.ADD('where (LHC_KOD='+VLHC_KOD+')and(LHC_ID='+VLHC_KOD_ID+')');
    open;
    LHC_KOD:=fieldByName('LHC_KOD'      ).asinteger;
    LHC_KOD_ID:=fieldByName('LHC_ID').asinteger;
    // LHP_OD:=fieldByName('LHP_OD'        ).asstring;
    // LHP_DO:=fieldByName('LHP_DO'        ).asstring;
    LHC_NAZ:=fieldByName('LHC_NAZ'      ).asstring;
  {  fieldByName('LHP_TAX'   ).asstring  LHP_TAX;
     fieldByName('LHP_Z_OD'  ).asstring  LHP_Z_OD;
     fieldByName('LHP_Z_DO'  ).asstring  LHP_Z_DO;
     fieldByName('LHP_Z_TAX' ).asstring  LHP_Z_TAX;
     fieldByName('LHP_NEZDAR').asinteger LHP_NEZDAR; }
   // ETAT_TO:=fieldByName('ETAT_TO').asinteger;
   // ETAT_TV:=fieldByName('ETAT_TC').asinteger-ETAT_TO;
   end;
 end;
procedure UlozDrevinu_LCR(UklDrevina:TDrevina;VFOraLCR:TFOraLCR);
var iPosk:integer;
 begin
  with VFOraLCR do
   begin
    UlozPolozkyDreviny_LCR(UklDrevina,Query1);

    UklDrevina.PoskozeniMN.ZrusDuplicitniPoskozeni;
    for iPosk:=0 to UklDrevina.PoskozeniMN.count-1 do
     begin
       UlozPolozkyPoskozeni_LCR(TPoskozeni(UklDrevina.PoskozeniMN.elements[iposk]),Query1);
     end;

   end;
 end;


procedure UlozEtaz_LCR(UklEtaz:TEtaz;VFOraLCR:TFOraLCR);
var idr,iZal:integer;
 begin
  with VFOraLCR do
   begin
    UlozPolozkyEtaze_LCR(UklEtaz,Query1);

    for iDr:=0 to UklEtaz.DrevinaMN.count-1 do
     begin
      UlozDrevinu_LCR(TDrevina(UklEtaz.DrevinaMN.elements[idr]),VFOraLCR);
     end;
    for iZal:=0 to UklEtaz.ZalesneniMN.count-1 do
     begin
      UlozPolozkyZalesneni_LCR(TZalesneni(UklEtaz.ZalesneniMN.elements[iZal]),Query1);
     end;
   end;
 end;

procedure UlozPorostniSkupinu_LCR(UklPorostniSkupina:TPorostniSkupina;VFOraLCR:TFOraLCR);
var iEt:integer;
 begin
  with VFOraLCR do
   begin
    UlozPolozkyPorostniSkupiny_LCR(UklPorostniSkupina,Query1);
    for iEt:=0 to UklPorostniSkupina.EtazMN.count-1 do
     begin
      UlozEtaz_LCR(TEtaz(UklPorostniSkupina.EtazMN.elements[iEt]),VFOraLCR);
     end;
   end;
 end;

procedure UlozPorost_LCR(UklPorost:TPorost;VFOraLCR:TFOraLCR);
var iPsk,iBzl,ijp,iOst,iktg:integer;
 begin
  with VFOraLCR do
   begin
    UlozPolozkyPorostu_LCR(UklPorost,Query1);
    for iKtg:=0 to UklPorost.Kategorie1MN.count-1 do
     begin
      UlozPolozkyKategorie_LCR(TKategorie1(UklPorost.Kategorie1MN.elements[Iktg]),Query1);
     end;
    if trim(UklPorost.ZVL_STATUT)<>'' then
     begin
      UlozPolozkyZvl_Statut_LCR(UklPorost,Query1);
     end;
    for iPSK:=0 to UklPorost.PorostniSkupinaMN.count-1 do
     begin
      UlozPorostniSkupinu_LCR(TPorostniSkupina(UklPorost.PorostniSkupinaMN.Elements[iPSK]),VFOraLCR);
     end;

    for iBZL:=0 to UklPorost.BezlesiMN.count-1 do
     begin
        UlozPolozkyBezlesi_LCR(TBezlesi(UklPorost.BezlesiMN.elements[iBzl]),Query1);
     end;
    for iJP:=0 to UklPorost.JinyPozemekMN.count-1 do
     begin
      UlozPolozkyJine_Poz_LCR(TJinyPozemek(UklPorost.JinyPozemekMN.Elements[iJP]),Query1);
     end;
    for iost:=0 to UklPorost.OstatniMN.count-1 do
     begin
      // UlozOstatni_DB(TOstatni(Elements[i]),OvrV);
     end;

   end;
 end;


procedure UlozOddeleni_LCR(UklOddeleni:TOddeleni;VFOraLCR:TFOraLCR);
var iDil,ip:integer;
 begin
  with VFOraLCR do
   begin
    if not LCR_DATABASE.InTransaction then
         LCR_DATABASE.StartTransaction;
    UlozPolozkyOddeleni_LCR(UklOddeleni,Query1);
    with UklOddeleni.dilecMN do
     begin
      for iDil:=0 to count-1 do
       begin
        if Elements[iDil] is TDilec then
         begin
         UlozPolozkyDilec_LCR(TDilec(Elements[iDil]),Query1);
          with TDilec(Elements[iDil]).porostMN do
           begin
            for ip:=0 to count-1 do
             begin
               {showmessage(TPorost(Elements[ip]).celeOznaceni);}
               UlozPorost_LCR(TPorost(Elements[ip]),VFOraLCR);
               {showmessage('Nacteno');}
             end
           end;
         end;
       end;
     end;
    if LCR_DATABASE.InTransaction then
     begin
      LCR_DATABASE.commit;
     end;
   end;
 end;


procedure NactiOddeleni_LCR
  (var VOddeleni:TOddeleni;VFOraLCR:TFOraLCR;VLHC_KOD_ID:string);
{ zacatek velke procedury}
procedure NactiPolozkyPorostu_LCR(VPorost:TPorost;QuPorost:TQuery);
 begin
  with VPorost do
  with QuPorost do
   begin
    POR:=fieldByName('POR').asstring;
    MAJ_KOD:=fieldByName('MAJ_KOD').asstring;
    if not(Org_UrovenMn.count>0) then
             Org_UrovenMN.novyPrvek:=fieldByName('ORG_UR1').asstring;
    TOrg_Uroven(Org_UrovenMn.elements[0]).ORG_UROVEN:=StrToInt0(fieldByName('ORG_UR1').asstring);
    if not(Org_UrovenMn.count>1) then
             Org_UrovenMN.novyPrvek:=fieldByName('ORG_UR2').asstring;
    TOrg_Uroven(Org_UrovenMn.elements[1]).ORG_UROVEN:=StrToInt0(fieldByName('ORG_UR2').asstring);
    if not(Org_UrovenMn.count>2) then
             Org_UrovenMN.novyPrvek:=fieldByName('ORG_UR3').asstring;
    TOrg_Uroven(Org_UrovenMn.elements[2]).ORG_UROVEN:=StrToInt0(fieldByName('ORG_UR3').asstring);

    PAS_OHR:=fieldByName('PAS_OHR').asstring;
    LES_OBL:=fieldByName('LES_OBL').asstring;
    SDR_POR:=fieldByName('SDR_POR').asstring;

    OLH_98:=fieldByName('OLH').asstring;

    HIST_ROZD:=fieldByName('HIST_ROZD').asstring;
    POR_TEXT.add(fieldByName('POR_TEXT').asstring);
    HIST_LHC:=StrToInt0(fieldByName('HIST_LHC').asstring);
    HIST_LHPOD:=fieldByName('HIST_LHPOD').asstring;
   end;
 end;
procedure NactiDrevinu_LCR(VDrevina:TDrevina;VFOraLCR:TFOraLCR);
 begin
  NactiPolozkyDreviny_LCR(VDrevina,VFOraLCR.QuDREVINA);
  with VFOraLCR.QuSKODY do
   begin
    with VDrevina do
     begin
      active:=false;
      DatabaseName:='LCR_ORAC';
      SQL.clear;
      SQL.ADD('select * from T_POSKOZ');
      SQL.ADD('where (LHC_ID='+VLHC_KOD_ID
      +')and(ODD='+inttostr(OwnerEtaz.OwnerPorostniSkupina.ownerporost.ownerDilec.ownerOddeleni.ODD)
      +')and(DIL='''+OwnerEtaz.OwnerPorostniSkupina.ownerporost.ownerDilec.DIL+''''
      +')and(POR='''+OwnerEtaz.OwnerPorostniSkupina.ownerporost.POR+''''
      +')and(MAJ_KOD='+OwnerEtaz.OwnerPorostniSkupina.ownerporost.MAJ_KOD
      +')and(PSK='''  +OwnerEtaz.OwnerPorostniSkupina.PSK_nactene+''''
      +')and(ETAZ=''' +OwnerEtaz.ETAZ_nactene+''''
      +')and(DR_ZKR=''' +DR_ZKR+''''
      +')and(PROC_SOUS='+IntToStr(PROC_SOUS)
      +')');
      open;
      while not(eof) do
       begin
        PoskozeniMN.NovyNeboAktualniPrvek:=fieldByName('POSKOZ_D').asstring;
        NactiPolozkyPoskozeni_LCR(Poskozeni,VFOraLCR.QuSKODY);
        next;
       end;
     end;
   end;
 end;
procedure NactiEtaz_LCR(VEtaz:TEtaz;VFOraLCR:TFOraLCR);
 begin
  NactiPolozkyEtaze_LCR(VEtaz,VFOraLCR.QuETAZ);
  with VEtaz do
   begin
    with VFOraLCR.QuDrevina do
     begin
      active:=false;
      DatabaseName:='LCR_ORAC';
      SQL.clear;
      SQL.ADD('select * from T_DREVIN ');
      SQL.ADD('where (LHC_ID='+VLHC_KOD_ID
      +')and(ODD='+IntToStr(OwnerPorostniSkupina.ownerporost.ownerDilec.ownerOddeleni.ODD)
      +')and(DIL='''+OwnerPorostniSkupina.ownerporost.ownerDilec.DIL+''''
      +')and(POR='''+OwnerPorostniSkupina.ownerporost.POR+''''
      +')and(MAJ_KOD='+OwnerPorostniSkupina.ownerporost.MAJ_KOD
      +')and(PSK='''+OwnerPorostniSkupina.PSK_nactene+''''
      +')and(ETAZ='''+ETAZ_nactene+''''
      +')');
      open;
      while not(eof) do
       begin
        DrevinaMN.NovyNeboAktualniPrvek:=fieldByName('DR_ZKR').asstring;
        NactiDrevinu_LCR(Drevina,VFOraLCR);
        next;
       end;
     end;
    with VFOraLCR.QuDrev_ZAles do
     begin
      active:=false;
      DatabaseName:='LCR_ORAC';
      SQL.clear;
      SQL.ADD('select * from T_ZAL_DR');
      SQL.ADD('where (LHC_ID='+VLHC_KOD_ID
      +')and(ODD='+IntToStr(OwnerPorostniSkupina.ownerporost.ownerDilec.ownerOddeleni.ODD)
      +')and(DIL='''+OwnerPorostniSkupina.ownerporost.ownerDilec.DIL+''''
      +')and(POR='''+OwnerPorostniSkupina.ownerporost.POR+''''
      +')and(MAJ_KOD='+OwnerPorostniSkupina.ownerporost.MAJ_KOD
      +')and(PSK='''+OwnerPorostniSkupina.PSK_nactene+''''
      +')and(ETAZ='''+ETAZ_nactene+''''
      +')');
      open;
      while not(eof) do
       begin
        ZalesneniMN.NovyNeboAktualniPrvek:=fieldByName('ZAL_DR').asstring;
        NactiPolozkyZalesneni_LCR(ZAlesneni,VFOraLCR.QuDrev_ZAles);
        next;
       end;
     end;
    with VFOraLCR.QuEtaz do
     begin
      ZAL_DRUH:=fieldByName('ZAL_DRUH').asstring;
      ZAL_P   :=fieldByName('ZAL_P').asfloat;
     end;
   end;
 end;
procedure NactiPorostniSkupinu_LCR(VporostniSkupina:TPorostniSkupina;VFOraLCR:TFOraLCR);
 begin
  NactiPolozkyPorostniSkupiny_LCR(VPorostniSkupina,VFOraLCR.QuPOROST_SKUP);
  with VFOraLCR.QuETAZ do
   begin
    with VPorostniSkupina do
     begin
      active:=false;
      DatabaseName:='LCR_ORAC';
      SQL.clear;
      SQL.ADD('select * from T_ETAZ ');
      SQL.ADD('where (LHC_ID='+VLHC_KOD_ID
      +')and(ODD='+IntToStr(ownerporost.ownerDilec.ownerOddeleni.ODD)
      +')and(DIL='''+ownerporost.ownerDilec.DIL+''''
      +')and(POR='''+ownerporost.POR+''''
      +')and(MAJ_KOD='+ownerporost.MAJ_KOD
      +')and(PSK='''+PSK_nactene+''''
      +')');
      open;
      while not(eof) do
       begin
        // DoEditu('pred natenm ete ',infoedit);
        EtazMN.NovyNeboAktualniPrvek:=fieldByName('ETAZ').asstring;
        NactiEtaz_LCR(etaz,VFOraLCR);
        // DoEditu('natena et '+VporostniSkupina.etaz.celeOznaceni,infoedit);
        next;
       end;
      PSK:=PSKzEtaziProKont1;
     end;
   end;
 end;

procedure NactiPorost_LCR(Vporost:TPorost;VFOraLCR:TFOraLCR);
 begin
  NactiPolozkyPorostu_LCR(VPorost,VFOraLCR.QuPorost);
  with VPorost do
   begin
    with VFOraLCR.QuPOROST_SKUP do
     begin
      active:=false;
      DatabaseName:='LCR_ORAC';
      SQL.clear;
      SQL.ADD('select * from T_PSK ');
      SQL.ADD('where (LHC_ID='+VLHC_KOD_ID
      +')and(ODD='+IntToStr(ownerDilec.ownerOddeleni.ODD)
      +')and(DIL='''+ownerDilec.DIL+''''
      +')and(POR='''+POR+''''
      +')and(MAJ_KOD='+MAJ_KOD
      +')');
      open;
      while not eof do
       begin
        PorostniSkupinaMN.NovyNeboAktualniPrvek:=fieldByName('PSK').asstring;
        NactiPorostniSkupinu_LCR(porostniSkupina,VFOraLCR);
        next;
       end;
     end;
    with VFOraLCR.QuZvl_ST do
     begin
      active:=false;
      DatabaseName:='LCR_ORAC';
      SQL.clear;
      SQL.ADD('select * from T_ZVS ');
      SQL.ADD('where (LHC_ID='+VLHC_KOD_ID
       +')and(ODD='+IntToStr(ownerDilec.ownerOddeleni.ODD)
       +')and(DIL='''+ownerDilec.DIL+''''
       +')and(POR='''+POR+''''
       +')and(MAJ_KOD='+MAJ_KOD
       +')');
      open;
      if not(eof) then
       begin
        ZVL_STATUT:=fieldByName('ZVL_STATUT').asstring;
       end;
     end;
    with VFOraLCR.QuPREKRYV do
     begin
      active:=false;
      DatabaseName:='LCR_ORAC';
      SQL.clear;
      SQL.ADD('select * from T_KATEG ');
      SQL.ADD('where (LHC_ID='+VLHC_KOD_ID
       +')and(ODD='+IntToStr(ownerDilec.ownerOddeleni.ODD)
       +')and(DIL='''+ownerDilec.DIL+''''
       +')and(POR='''+POR+''''
       +')and(MAJ_KOD='+MAJ_KOD
       +')');
      open;
      while not(eof) do
       begin
        Kategorie1MN.NovyNeboAktualniPrvek:=fieldByName('KATEGORIE').asstring;
        NactiPolozkyKategorie_LCR(kategorie1MN.Kategorie1,VFOraLCR.QuPREKRYV);
        next;
       end;
     end;
    with VFOraLCR.QuBEZLESI do
     begin
      active:=false;
      DatabaseName:='LCR_ORAC';
      SQL.clear;
      SQL.ADD('select * from T_BZL ');
      SQL.ADD('where (LHC_ID='+VLHC_KOD_ID
       +')and(ODD='+inttostr(ownerDilec.ownerOddeleni.ODD)
       +')and(DIL='''+ownerDilec.DIL+''''
       +')and(POR='''+POR+''''
       +')and(MAJ_KOD='+MAJ_KOD
       +')');
      open;
      while not(eof) do
       begin
        BezlesiMN.NovyNeboAktualniPrvek:=fieldByName('BZL').asstring;
        NactiPolozkyBezlesi_LCR(Bezlesi,VFOraLCR.QuBEZLESI);
        next;
       end;
     end;
    with VFOraLCR.QuJINE_POZ do
     begin
      active:=false;
      DatabaseName:='LCR_ORAC';
      SQL.clear;
      SQL.ADD('select * from T_JP');
      SQL.ADD('where (LHC_ID='+VLHC_KOD_ID
       +')and(ODD='+IntToStr(ownerDilec.ownerOddeleni.ODD)
       +')and(DIL='''+ownerDilec.DIL+''''
       +')and(POR='''+POR+''''
       +')and(MAJ_KOD='+MAJ_KOD
       +')');
      open;
      while not(eof) do
       begin
        JinyPozemekMN.NovyNeboAktualniPrvek:=fieldByName('JP').asstring;
        NactiPolozkyJine_Poz_LCR(JinyPozemek,VFOraLCR.QuJINE_POZ);
        next;
       end;
     end;
   end;
 end;

{procedure NactiOddeleni_LCR(var VOddeleni:TOddeleni;VFOraLCR:TFOraLCR;Infoedit:TEdit); }
var iOdd,ip:integer;
 begin
  VOddeleni:=TOddeleni.create;
  VOddeleni.ODD:=VFOraLCR.QU_ODD.fieldByName('ODD').asinteger;
  with VFOraLCR.Qu_DIL do
   begin
    Active:=false;
    DatabaseName:='LCR_ORAC';
    SQL.clear;
    SQL.ADD('select * from T_DIL ');
    SQL.ADD('where (LHC_ID='+VLHC_KOD_ID+')and(ODD='+IntToStr(VOddeleni.ODD)+')');
    open;
   end;

  while not VFOraLCR.Qu_DIL.eof do
   begin
    VOddeleni.dilecMN.NovyNeboAktualniPrvek:=VFOraLCR.Qu_DIL.fieldByName('DIL').asstring;
    VOddeleni.dilec.DIL:=VFOraLCR.Qu_DIL.fieldByName('DIL').asstring;
    with VFOraLCR.QuPorost do
     begin
      active:=false;
      DatabaseName:='LCR_ORAC';
      SQL.clear;
      SQL.ADD('select * from T_POR ');
      SQL.ADD('where (LHC_ID='+VLHC_KOD_ID
      +')and(ODD='+IntToStr(VOddeleni.ODD)
      +')and(DIL='''+VOddeleni.Dilec.DIL+''''
      +')');
      open;
      while not eof do
       begin
        VOddeleni.dilec.porostMN.NovyNeboAktualniPrvek:=fieldByName('POR').asstring;
        NactiPorost_LCR(VOddeleni.Dilec.Porost,VFOraLCR);
        next;
       end;
     end;
    VFOraLCR.Qu_DIL.next;
   end;
 end;


procedure NactiOddeleni_LCR_DleCisla(VLHC_KOD,VLHC_KOD_ID,VOdd:string;
                  var VOddeleni:TOddeleni; VFOraLCR:TFOraLCR);
 begin
  with VFOraLCR.Qu_ODD do
   begin
    active:=false;
    SQL.clear;
    SQL.ADD('select * from T_ODD ');
    SQL.ADD('where (LHC_ID='+VLHC_KOD_ID
              +')and(ODD='+VOdd+')');
    open;
   end;
  NactiOddeleni_LCR(VOddeleni,VFOraLCR,VLHC_KOD_ID);
 end;


end.
