unit hkExcelOr;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls,printers,IniFiles,
  mat1,E_LesOdd,E_LesCel,U_Zobraz,ELesObec,
  excelImpl,
  U_string,elements;

const
  StanVyskaRadku = 12.75;

procedure DoExceluPorostOR( EditInfo:Tedit;
                            VPorost:TPorost;
                         var strana:integer;
                         tisknoutMajitele:Boolean;
                         tisknoutNasobnost:Boolean;
                         mistoDilcePorost:Boolean;
                         dilecIPorost:Boolean;
                         naTiskarnu,tiskniEvidenciLCR,tiskniEvidenciObce:boolean;levaPrava:byte;
                         tisknoutDruh_maj,tisknoutOdb_hosp,
                         tisknoutPlDrZal,Zhustene,
                         mistoRelSchw,vymeru,nasobneZasahy,t0vimisich:Boolean;
                         PenWidth3:integer;
                         TistenaPorostniSkupina:string;
                         AniDilecAniPorost:boolean;
                         jazyk:TJazyk;
                         tisknoutObmytiObnovniDobu,TisknoutKvalDrMistoSousi,tisknoutUsek,tisknoutTerTyp:Boolean;
                         VColor:TColor;VFont:string;barvaPozDleKategorie:Boolean;
                         odsazeniRadkuOdHornihoOkraje:double;
                         evidOploc,mistoReviruPolesi,
                         mistozalesneniObnovaLesa,mistoSousiRedPlDreviny,netiskODDPl:boolean;
                         VyskaStrankyVmm:double);


procedure SmazPrvniRadky;

procedure RoztahniVyplnTEXT(mujTEXT:string;PrvniRadekHl,KamPsat,PocPisPredZalomenim:integer;tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);

var
  PosledniRadek:integer;
  jeLeva:boolean;

implementation

procedure RoztahniVyplnTEXT(mujTEXT:string;PrvniRadekHl,KamPsat,PocPisPredZalomenim:integer; tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
var p,h:integer;
 begin
   p:=PrvniRadekHl;
   h:=(length(mujTEXT) div PocPisPredZalomenim)+1;
   VyskaRady(p,StanVyskaRadku*h,tisknoutNaOstro,StanVyskaRadku,vyskaPopsaneStranky);
   if tisknoutNaOstro then
    begin
     ZapisDoBunkyZem(p,KamPsat,mujTEXT);
    end;
 end;

procedure DoExceluPorostOR(EditInfo:Tedit;
                          VPorost:TPorost;
                         var strana:integer;
                         tisknoutMajitele:Boolean;
                         tisknoutNasobnost:Boolean;
                         mistoDilcePorost:Boolean;
                         dilecIPorost:Boolean;
                         naTiskarnu,tiskniEvidenciLCR,tiskniEvidenciObce:boolean;levaPrava:byte;
                         tisknoutDruh_maj,tisknoutOdb_hosp,
                         tisknoutPlDrZal,Zhustene,
                         mistoRelSchw,vymeru,nasobneZasahy,t0vimisich:Boolean;
                         PenWidth3:integer;
                         TistenaPorostniSkupina:string;
                         AniDilecAniPorost:boolean;
                         jazyk:TJazyk;
                         tisknoutObmytiObnovniDobu,TisknoutKvalDrMistoSousi,tisknoutUsek,tisknoutTerTyp:Boolean;
                         VColor:TColor;VFont:string;barvaPozDleKategorie:Boolean;
                         odsazeniRadkuOdHornihoOkraje:double;
                         evidOploc,mistoReviruPolesi,
                         mistozalesneniObnovaLesa,mistoSousiRedPlDreviny,netiskODDPl:boolean;
                         VyskaStrankyVmm:double);

procedure pripravSablonuPodlePredvoleb;
 begin
  if not dilecIPorost then
   begin
    if mistoDilcePorost then
     begin
       ZapisDoBunkyZem(17,1,'');
       ZapisDoBunkyZem(4,68,'');
      // ZapisDoBunkyZem(p+2,6,VPorost.POR);
      //  ZapisDoBunkyZem(p+2,69,VPorost.ownerDilec.Dil);
      //  ZapisDoBunkyZem(p+2,72,VPorost.POR);
     end
    else
     begin
      // ZapisDoBunkyZem(p+2,3,VPorost.ownerDilec.Dil);
      ZapisDoBunkyZem(17,5,'');
      ZapisDoBunkyZem(4,70,'');
     end;
   end;
  if not tisknoutMajitele then
   begin
    ZapisDoBunkyZem(16,14,'');
    ZapisDoBunkyZem(3,7,'');
   end;
 if tisknoutOdb_hosp then
   begin
      ZapisDoBunkyZem(4,51,'OLH:');
      ZapisDoBunkyZem(17,58,'OLH:');
   end
  else
   begin
    if mistoReviruPolesi then
     begin
      ZapisDoBunkyZem(4,51,'Poles:');
      ZapisDoBunkyZem(17,58,'Poles:');
     end
    else
     begin
      ZapisDoBunkyZem(4,51,'Revr:');
      ZapisDoBunkyZem(17,58,'Revr:');
     end;
   end;

 end;
procedure kopirujHlavickuPravehoPorostu(naRadek:Integer;tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
var
 row1,row2,rowKam:integer;
begin
 row1:=2;
 row2:=6;
 rowKam:=naRadek;
 KopirujOblastPoRadkach( row1,row2,rowKam,true,vyskaPopsaneStranky);
end;
procedure kopirujHlavPravPorNaKonec(tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
 begin
  kopirujHlavickuPravehoPorostu(PosledniRadek,tisknoutNaOstro,vyskaPopsaneStranky);
  if tisknoutNaOstro then  posledniRadek:=posledniRadek+5;
 end;

procedure kopirujHlavickuLevehoPorostu(naRadek:Integer;tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
var
 row1,row2,rowKam:integer;
begin
 row1:=15;
 row2:=19;
 rowKam:=naRadek;
 KopirujOblastPoRadkach( row1,row2,rowKam,true,vyskaPopsaneStranky);
end;

procedure kopirujHlavLevPorNaKonec(tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
 begin
  kopirujHlavickuLevehoPorostu(PosledniRadek,tisknoutNaOstro,vyskaPopsaneStranky);
  if tisknoutNaOstro then posledniRadek:=posledniRadek+5;
 end;
procedure kopirujHlavickuPravePorSkupiny(naRadek:Integer;tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
var
 row1,row2,rowKam:integer;
begin
 row1:=7;
 row2:=8;
 rowKam:=naRadek;
 KopirujOblastPoRadkach( row1,row2,rowKam,tisknoutNaOstro,vyskaPopsaneStranky);
end;
procedure kopirujHlavickuPraveEtaze(naRadek:Integer;tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
var
 row1,row2,rowKam:integer;
begin
 row1:=9;
 row2:=12;
 rowKam:=naRadek;
 KopirujOblastPoRadkach( row1,row2,rowKam,tisknoutNaOstro,vyskaPopsaneStranky);
end;

procedure kopirujHlavPraveEtazeNaKonec(tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
 begin
    kopirujHlavickuPraveEtaze(PosledniRadek,tisknoutNaOstro,vyskaPopsaneStranky);
    if tisknoutNaOstro then posledniRadek:=posledniRadek+4;
 end;

procedure kopirujHlavPravePorSkupNaKonec(tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
 begin
    kopirujHlavickuPravePorSkupiny(PosledniRadek,tisknoutNaOstro,vyskaPopsaneStranky);
    if tisknoutNaOstro then posledniRadek:=posledniRadek+2;
 end;

procedure kopirujHlavickuLevePorSkupiny(naRadek:Integer;tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
var
 row1,row2,rowKam:integer;
begin
 row1:=20;
 row2:=21;
 rowKam:=naRadek;
 KopirujOblastPoRadkach( row1,row2,rowKam,tisknoutNaOstro,vyskaPopsaneStranky);
end;

procedure kopirujHlavickuLeveEtaze(naRadek:Integer;tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
var
 row1,row2,rowKam:integer;
begin
 row1:=22;
 row2:=25;
 rowKam:=naRadek;
 KopirujOblastPoRadkach( row1,row2,rowKam,tisknoutNaOstro,vyskaPopsaneStranky);
end;

procedure kopirujHlavLevePorSkupNaKonec(tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double );
 begin
    kopirujHlavickuLevePorSkupiny(PosledniRadek,tisknoutNaOstro,vyskaPopsaneStranky);
    if tisknoutNaOstro then posledniRadek:=posledniRadek+2;
 end;

procedure kopirujHlavLeveEtazeNaKonec(tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
 begin
    kopirujHlavickuLeveEtaze(PosledniRadek,tisknoutNaOstro,vyskaPopsaneStranky);
    if tisknoutNaOstro then posledniRadek:=posledniRadek+4;
 end;

procedure kopirujHlavickuLeveDreviny(naRadek:Integer;tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
var
 row1,row2,rowKam:integer;
begin
 row1:=26;
 row2:=26;
 rowKam:=naRadek;
 KopirujOblastPoRadkach( row1,row2,rowKam,tisknoutNaOstro,vyskaPopsaneStranky);
end;
procedure kopirujHlavickuLeveDrevNaKonec(tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
 begin
  kopirujHlavickuLeveDreviny(PosledniRadek,tisknoutNaOstro,vyskaPopsaneStranky);
  if tisknoutNaOstro then posledniRadek:=posledniRadek+1;
 end;

procedure kopirujHlavickuPraveDreviny(naRadek:Integer;tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
var
 row1,row2,rowKam:integer;
begin
 row1:=13;
 row2:=13;
 rowKam:=naRadek;
 KopirujOblastPoRadkach( row1,row2,rowKam,tisknoutNaOstro,vyskaPopsaneStranky);
end;
procedure kopirujHlavickuPraveDrevNaKonec(tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
 begin
  kopirujHlavickuPraveDreviny(PosledniRadek,tisknoutNaOstro,vyskaPopsaneStranky);
  if tisknoutNaOstro then posledniRadek:=posledniRadek+1;
 end;
Procedure VyplnHlaLeveDreviny(VDrev:TDrevina;PrvniRadekHl:integer;tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
var p:integer;
 begin
   p:=PrvniRadekHl;
   if tisknoutNaOstro then
    begin
     ZapisDoBunkyZem(p,10,VDrev.DR_ZKR);
     ZapisDoBunkyZem(p,12,inttostr(VDrev.ZAST));
     ZapisDoBunkyZem(p,14,inttoStr(VDrev.TLOUSTKA));
     ZapisDoBunkyZem(p,16,inttoStr(VDrev.VYSKA));
     ZapisDoBunkyZemdouble(p,18,VDrev.HMOT,true);
     ZapisDoBunkyZem(p,21,inttoStr(VDrev.BON_A));
     if mistoRelSchW then
      begin
       ZapisDoBunkyZem(p,23,inttostr(VDrev.BON_R));
      end
     else
      begin
       ZapisDoBunkyZem(p,23,inttostr(VDrev.BON_RVyhl));
      end;
     ZapisDoBunkyZem(p,27,VDrev.GEN_KLAS);
     if (t0vimisich)and(trim(s0(VDrev.imise))='')
          then ZapisDoBunkyZem(p,33,'0') //TextOutS(canvasV,C15,C16a,MDp,'0')
          else ZapisDoBunkyZem(p,33,s0(VDrev.imise));  //TextOutS(canvasV,C15,C16a,MDp,s0(Drevina.imise));
     ZapisDoBunkyZem(p,35,s0(inttostr(VDrev.DR_ZAS_HA)));
     if TisknoutKvalDrMistoSousi then
      begin
       ZapisDoBunkyZem(p,37,VDrev.DR_KVAL);
      end
     else
      begin
       if mistoSousiRedPlDreviny then
        begin
         ZapisDoBunkyZemdouble(p,37,VDrev.redukovanaPlocha,true);
        end
       else
        begin
         ZapisDoBunkyZem(p,37,s0(inttostr(VDrev.OBJ_SOUS)));
        end;
      end;
     ZapisDoBunkyZem(p,40,s0(inttostr(VDrev.DR_ZAS_CEL)));
     ZapisDoBunkyZem(p,48,s0(inttostr(VDrev.DR_TV)));
     ZapisDoBunkyZem(p,53,s0(inttostr(VDrev.DR_TO)));
   end;
 end;

Procedure VyplnHlaPraveDreviny(VDrev:TDrevina;PrvniRadekHl:integer;tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
var p:integer;
 begin
   p:=PrvniRadekHl;
   if tisknoutNaOstro then
    begin
     ZapisDoBunkyZem(p,15,VDrev.DR_ZKR);
     ZapisDoBunkyZem(p,17,inttostr(VDrev.ZAST));
     ZapisDoBunkyZem(p,19,inttoStr(VDrev.TLOUSTKA));
     ZapisDoBunkyZem(p,21,inttoStr(VDrev.VYSKA));
     ZapisDoBunkyZemdouble(p,23,VDrev.HMOT,true);
     ZapisDoBunkyZem(p,26,inttoStr(VDrev.BON_A));
     if mistoRelSchW then
      begin
       ZapisDoBunkyZem(p,28,inttostr(VDrev.BON_R));
      end
     else
      begin
       ZapisDoBunkyZem(p,28,inttostr(VDrev.BON_RVyhl));
      end;
     ZapisDoBunkyZem(p,32,VDrev.GEN_KLAS);
     if (t0vimisich)and(trim(s0(VDrev.imise))='')
        then ZapisDoBunkyZem(p,38,'0') //TextOutS(canvasV,C15,C16a,MDp,'0')
        else ZapisDoBunkyZem(p,38,s0(VDrev.imise));  //TextOutS(canvasV,C15,C16a,MDp,s0(Drevina.imise));
      ZapisDoBunkyZem(p,40,s0(inttostr(VDrev.DR_ZAS_HA)));
     if TisknoutKvalDrMistoSousi then
      begin
       ZapisDoBunkyZem(p,42,VDrev.DR_KVAL);
      end
     else
      begin
       if mistoSousiRedPlDreviny then
        begin
         ZapisDoBunkyZemdouble(p,42,VDrev.redukovanaPlocha,true);
        end
       else
        begin
         ZapisDoBunkyZem(p,42,s0(inttostr(VDrev.OBJ_SOUS)));
        end;
      end;
     ZapisDoBunkyZem(p,45,s0(inttostr(VDrev.DR_ZAS_CEL)));
     ZapisDoBunkyZem(p,53,s0(inttostr(VDrev.DR_TV)));
     ZapisDoBunkyZem(p,58,s0(inttostr(VDrev.DR_TO)));
    end;
  end;
Procedure VyplnHlaLevePosk(VPosk:Tposkozeni;PrvniRadekHl:integer;tisknoutnaOstro:boolean);
var p:integer;
 begin
   p:=PrvniRadekHl;
   if tisknoutNaOstro then
    begin
     ZapisDoBunkyZem(p,29,inttostr(VPosk.POSKOZ_D));
     ZapisDoBunkyZem(p,31,inttostr(VPosk.POSKOZ_R));
    end;
 end;

Procedure VyplnHlaPravePosk(VPosk:Tposkozeni;PrvniRadekHl:integer;tisknoutnaOstro:boolean);
var p:integer;
 begin
   p:=PrvniRadekHl;
   if tisknoutNaOstro then
    begin
     ZapisDoBunkyZem(p,34,inttostr(VPosk.POSKOZ_D));
     ZapisDoBunkyZem(p,36,inttostr(VPosk.POSKOZ_R));
    end;
 end;

Procedure VyplnHlaPraveZalesneni(VZal:TZalesneni;PrvniRadekHl:integer;tisknoutnaOstro:boolean);
var p:integer;
 begin
   p:=PrvniRadekHl;
   if tisknoutNaOstro then
    begin
     ZapisDoBunkyZem(p,67,VZal.ZAL_DR);
     ZapisDoBunkyZem(p,69,inttostr(VZal.ZAL_DR_P));
     ZapisDoBunkyZemdouble(p,71,VZal.ZAL_P,false);
    end;
 end;

Procedure VyplnHlaLeveZalesneni(VZal:TZalesneni;PrvniRadekHl:integer;tisknoutnaOstro:boolean);
var p:integer;
 begin
   p:=PrvniRadekHl;
   if tisknoutNaOstro then
    begin
     ZapisDoBunkyZem(p,62,VZal.ZAL_DR);
     ZapisDoBunkyZem(p,64,inttostr(VZal.ZAL_DR_P));
     ZapisDoBunkyZemdouble(p,66,VZal.ZAL_P,false);
    end;
 end;

Procedure VyplnPravySoucetZaEtaz(VEtaz:TEtaz;PrvniRadekHl:integer;tisknoutnaOstro:boolean);
 var          p:integer;
      jsouEtaze:boolean;
  begin
   if tisknoutNaOstro then
    begin
   if VEtaz.OwnerPorostniSkupina.EtazMN.count>1 then
     jsouEtaze:=true else jsouEtaze:=false;

   p:=PrvniRadekHl;
   if jsouEtaze then
    begin            //4
     ZapisDoBunkyZem(p,9,'Et celkem:');
    end
   else
    begin
     ZapisDoBunkyZem(p,9,'Por.sk.celkem:');
    end;
     ZapisDoBunkyZem(p,17,s0(intToStr(VEtaz.ZastoupeniDrevin)));
     ZapisDoBunkyZem(p,40,s0(intToStr(VEtaz.Etaz_ZAS_HA)));
     ZapisDoBunkyZem(p,42,s0(intToStr(VEtaz.Etaz_OBJ_SOUS)));
     ZapisDoBunkyZem(p,45,s0(intToStr(VEtaz.Etaz_ZAS_CELK)));

          if VEtaz.TV_P>0.001 then
           begin
            if tisknoutNasobnost then
             begin
              ZapisDoBunkyZem(p,48,VEtaz.TV_NAL+' '+IntToStr(VEtaz.TV_POC));
             end
            else
             begin
              ZapisDoBunkyZem(p,48,VEtaz.TV_NAL);
             end;
            if nasobneZasahy then
             begin
              ZapisDoBunkyZemdouble(p,50,VEtaz.TV_POC*VEtaz.TV_P,true);
             end
            else
             begin
              ZapisDoBunkyZemdouble(p,50,VEtaz.TV_P,true);
             end;
            ZapisDoBunkyZem(p,53,s0(intToStr(VEtaz.Etaz_TV)));
           end;


          if VEtaz.PRO_P>0.001 then
           begin
            if tisknoutNasobnost then
             begin
              ZapisDoBunkyZem(p,60,VEtaz.PRO_NAL+' '+IntToStr(VEtaz.PRO_POC));
             end
            else
             begin
              ZapisDoBunkyZem(p,60,VEtaz.PRO_NAL);
             end;
            if nasobneZasahy then
             begin
              ZapisDoBunkyZemdouble(p,62,VEtaz.PRO_POC*VEtaz.PRO_P,true);
             end
            else
             begin
              ZapisDoBunkyZemdouble(p,62,VEtaz.PRO_P,true);
             end;
           end;

          if VEtaz.TO_P>0.001 then
           begin
            ZapisDoBunkyZemdouble(p,55,VEtaz.TO_P,true);
           end;
          if VEtaz.Etaz_TO>0 then
           begin
            ZapisDoBunkyZem(p,58,s0(intToStr(VEtaz.Etaz_TO)));
           end;
         if VEtaz.ZalesneniMN.count>0 then
           begin
            ZapisDoBunkyZem(p,65,VEtaz.IZalesneni[0].ZAL_DRUH);
            ZapisDoBunkyZem(p,69,intToStr( VEtaz.ZalesneniMN.ProcentoZalesneni));
            ZapisDoBunkyZemdouble(p,71,VEtaz.ZalesneniMN.PlochaZalesneni,true);
           end;
   end;
 end;
Procedure VyplnPravySoucetZaSkupinu(VSkup:TPorostniSkupina;PrvniRadekHl:integer;tisknoutnaOstro:boolean);
 var p:integer;
  begin
   p:=PrvniRadekHl;
   if tisknoutNaOstro then
    begin
     ZapisDoBunkyZem(p,9,'Por.sk.celkem:');
     if TisknoutKvalDrMistoSousi then
      begin
      end
     else
      begin
       if mistoSousiRedPlDreviny then
        begin
        end
       else
        begin
         ZapisDoBunkyZem(p,42,s0(inttostr(VSkup.SouseCelkem)));
        end;
      end;

     ZapisDoBunkyZem(p,40,s0(intToStr(VSkup.hektarovaZasobaCelkem)));
     ZapisDoBunkyZem(p,45,s0(intToStr(VSkup.ZasobaCelkem)));
   end;
  end;
Procedure VyplnLevySoucetZaEtaz(VEtaz:TEtaz;PrvniRadekHl:integer;tisknoutnaOstro:boolean);
 var          p:integer;
      jsouEtaze:boolean;
  begin
   if VEtaz.OwnerPorostniSkupina.EtazMN.count>1 then
     jsouEtaze:=true else jsouEtaze:=false;

   p:=PrvniRadekHl;
   if tisknoutNaOstro then
    begin
     if jsouEtaze then
      begin
       ZapisDoBunkyZem(p,4,'Et celkem:');
      end
     else
      begin
       ZapisDoBunkyZem(p,4,'Por.sk.celkem:');
      end;
     ZapisDoBunkyZem(p,12,s0(intToStr(VEtaz.ZastoupeniDrevin)));
     ZapisDoBunkyZem(p,35,s0(intToStr(VEtaz.Etaz_ZAS_HA)));
     ZapisDoBunkyZem(p,37,s0(intToStr(VEtaz.Etaz_OBJ_SOUS)));
     ZapisDoBunkyZem(p,40,s0(intToStr(VEtaz.Etaz_ZAS_CELK)));

     if VEtaz.TV_P>0.001 then
      begin
       if tisknoutNasobnost then
        begin
         ZapisDoBunkyZem(p,43,VEtaz.TV_NAL+' '+IntToStr(VEtaz.TV_POC));
        end
       else
        begin
         ZapisDoBunkyZem(p,43,VEtaz.TV_NAL);
        end;
       if nasobneZasahy then
        begin
         ZapisDoBunkyZemdouble(p,45,VEtaz.TV_POC*VEtaz.TV_P,true);
        end
       else
        begin
         ZapisDoBunkyZemdouble(p,45,VEtaz.TV_P,true);
        end;
       ZapisDoBunkyZem(p,48,s0(intToStr(VEtaz.Etaz_TV)));
      end;

     if VEtaz.PRO_P>0.001 then
      begin
       if tisknoutNasobnost then
        begin
         ZapisDoBunkyZem(p,55,VEtaz.PRO_NAL+' '+IntToStr(VEtaz.PRO_POC));
        end
       else
        begin
         ZapisDoBunkyZem(p,55,VEtaz.PRO_NAL);
        end;
       if nasobneZasahy then
        begin
         ZapisDoBunkyZemdouble(p,57,VEtaz.PRO_POC*VEtaz.PRO_P,true);
        end
       else
        begin
         ZapisDoBunkyZemdouble(p,57,VEtaz.PRO_P,true);
        end;
      end;

     if VEtaz.TO_P>0.001 then
      begin
       ZapisDoBunkyZemdouble(p,50,VEtaz.TO_P,true);
      end;
     if VEtaz.Etaz_TO>0 then
      begin
       ZapisDoBunkyZem(p,53,s0(intToStr(VEtaz.Etaz_TO)));
      end;
     if VEtaz.ZalesneniMN.count>0 then
      begin
       ZapisDoBunkyZem(p,60,VEtaz.IZalesneni[0].ZAL_DRUH);
       ZapisDoBunkyZem(p,64,intToStr( VEtaz.ZalesneniMN.ProcentoZalesneni));
       ZapisDoBunkyZemdouble(p,66,VEtaz.ZalesneniMN.PlochaZalesneni,true);
      end;
    end;
  end;

Procedure VyplnLevySoucetZaSkupinu(VSkup:TPorostniSkupina;PrvniRadekHl:integer;tisknoutnaOstro:boolean);
 var p:integer;
  begin
   p:=PrvniRadekHl;

   if tisknoutNaOstro then
    begin
     ZapisDoBunkyZem(p,4,'Por.sk.celkem:');
     if TisknoutKvalDrMistoSousi then
      begin
      end
     else
      begin
       if mistoSousiRedPlDreviny then
        begin
        end
       else
        begin
         ZapisDoBunkyZem(p,37,s0(inttostr(VSkup.SouseCelkem)));
        end;
      end;
     ZapisDoBunkyZem(p,35,s0(intToStr(VSkup.hektarovaZasobaCelkem)));
     ZapisDoBunkyZem(p,40,s0(intToStr(VSkup.ZasobaCelkem)));
   end;
 end;


Procedure VyplnHlaLeveEtaze(VEtaz:TEtaz;PrvniRadekHl:integer;tisknoutnaOstro:boolean);
var p:integer;
 begin
   p:=PrvniRadekHl;
   if tisknoutNaOstro then
    begin
     if VEtaz.OwnerPorostniSkupina.etazMN.count>1 then
      begin
       ZapisDoBunkyZem(p,6,VEtaz.ETAZ);
       ZapisDoBunkyZemdouble(p,16,VEtaz.ETAZ_PP,faLse);
       ZapisDoBunkyZemdouble(p,26,VEtaz.ETAZ_PS,faLse);
      end
     else
      begin
       ZapisDoBunkyZem(p,4,'');
       ZapisDoBunkyZem(p,10,'');
       ZapisDoBunkyZem(p,21,'');
      end;
     ZapisDoBunkyZem(p,39,inttostr(vEtaz.OwnerPorostniSkupina.POT_VLAST));
     if (vEtaz.PROC_HS>0)and(vEtaz.ODVOZ_TEZ='D') then
      begin
       ZapisDoBunkyZem(p,47,inttostr(vEtaz.PROC_HS)+'%');
      end;
     ZapisDoBunkyZem(p,55,inttostr(vEtaz.OBMYTI)+'/'+inttostr(vEtaz.OBN_DOBA));
     if ubm(Vetaz.MZDs)<>'' then
      begin
       ZapisDoBunkyZem(p,66,Vetaz.MZDs+'%');
      end;
     ZapisDoBunkyZem(p+3,4,inttostr(vEtaz.HS));
     ZapisDoBunkyZem(p+3,6,inttostr(vEtaz.VEK));
    if VEtaz.DrevinaMN.count>0 then
     begin
      ZapisDoBunkyZem(p+3,8,inttostr(vEtaz.ZAKM));
     end;
   end;
 end;

Procedure VyplnHlaPraveEtaze(VEtaz:TEtaz;PrvniRadekHl:integer;tisknoutnaOstro:boolean);
var p:integer;
 begin
   p:=PrvniRadekHl;
   if tisknoutNaOstro then
    begin
     if VEtaz.OwnerPorostniSkupina.etazMN.count>1 then
      begin
       ZapisDoBunkyZem(p,11,VEtaz.ETAZ);
       ZapisDoBunkyZemdouble(p,21,VEtaz.ETAZ_PP,faLse);
       ZapisDoBunkyZemdouble(p,30,VEtaz.ETAZ_PS,faLse);
      end
     else
      begin
       ZapisDoBunkyZem(p,9,'');
       ZapisDoBunkyZem(p,15,'');
       ZapisDoBunkyZem(p,26,'');
      end;
     ZapisDoBunkyZem(p,44,inttostr(vEtaz.OwnerPorostniSkupina.POT_VLAST));
     if (vEtaz.PROC_HS>0)and(vEtaz.ODVOZ_TEZ='D') then
      begin
       ZapisDoBunkyZem(p,52,inttostr(vEtaz.PROC_HS)+'%');
      end;
     ZapisDoBunkyZem(p,60,inttostr(vEtaz.OBMYTI)+'/'+inttostr(vEtaz.OBN_DOBA));
     if ubm(Vetaz.MZDs)<>'' then
      begin
       ZapisDoBunkyZem(p,71,Vetaz.MZDs+'%');
      end;
     ZapisDoBunkyZem(p+3,9,inttostr(vEtaz.HS));
     ZapisDoBunkyZem(p+3,11,inttostr(vEtaz.VEK));
     if VEtaz.DrevinaMN.count>0 then
      begin
       ZapisDoBunkyZem(p+3,13,inttostr(vEtaz.ZAKM));
      end;
   end;
 end;

Procedure VyplnHlaLevePorSkup(VPorskup:TPorostniSkupina;PrvniRadekHl:integer;tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
var p:integer;
 begin
   p:=PrvniRadekHl;
   if tisknoutNaOstro then
    begin
     ZapisDoBunkyZem(p,6,VPorskup.PSK);
     ZapisDoBunkyZemdouble(p,17,VPorskup.PSK_P,faLse);
     ZapisDoBunkyZem(p,25,VPorskup.LT);
     ZapisDoBunkyZem(p,31,VPorskup.LES_URAD_Nazev);
     ZapisDoBunkyZem(p,43,inttostr(VPorskup.KU_KOD));
     ZapisDoBunkyZem(p,55,VPorskup.KU_NAZ);
    end;
   RoztahniVyplnTEXT(VPorskup.PSK_TEXT,p+1,7,100,tisknoutNaOstro,vyskaPopsaneStranky);
 end;

Procedure VyplnHlaPravePorSkup(VPorskup:TPorostniSkupina;PrvniRadekHl:integer;tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
var p:integer;
 begin
   p:=PrvniRadekHl;
   if tisknoutNaOstro then
    begin
     ZapisDoBunkyZem(p,11,VPorskup.PSK);
     ZapisDoBunkyZemdouble(p,24,VPorskup.PSK_P,faLse);

     ZapisDoBunkyZem(p,30,VPorskup.LT);
     ZapisDoBunkyZem(p,36,VPorskup.LES_URAD_Nazev);
     ZapisDoBunkyZem(p,48,inttostr(VPorskup.KU_KOD));
     ZapisDoBunkyZem(p,60,VPorskup.KU_NAZ);
    end;

   RoztahniVyplnTEXT(VPorskup.PSK_TEXT,p+1,14,100,tisknoutNaOstro,vyskaPopsaneStranky);
 end;

Procedure VyplnHlaLevehoPorostu(VPorost:TPorost;strana:integer;PrvniRadekHl:integer;tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
var p,iZvl:integer;
    sZvl:string;
 begin
   p:=PrvniRadekHl;
   if tisknoutNaOstro then
    begin
     ZapisDoBunkyZem(p+1,6,inttostr(VPorost.ownerDilec.ownerOddeleni.ODD));

     if dilecIPorost then
      begin
       ZapisDoBunkyZem(p+2,3,VPorost.ownerDilec.Dil);
       ZapisDoBunkyZem(p+2,6,VPorost.POR);
      end
     else
      begin
       if mistoDilcePorost then
        begin
         ZapisDoBunkyZem(p+2,6,VPorost.POR);
        end
       else
        begin
         ZapisDoBunkyZem(p+2,3,VPorost.ownerDilec.Dil);
        end;
      end;
     if tisknoutMajitele then
      begin
       if tisknoutDruh_maj then
        begin
         ZapisDoBunkyZem(p+1,17,inttostr(VPorost.MAJ_DRUH)+'/'+VPorost.MAJ_KOD);
        end
       else
        begin
         ZapisDoBunkyZem(p+1,17,VPorost.MAJ_KOD);
        end;
      end;
     ZapisDoBunkyZem(p+1,27,VPorost.LES_OBL);
     ZapisDoBunkyZem(p+1,29,VPorost.LES_OBL_nazev);
     ZapisDoBunkyZem(p+1,41,inttostr(VPorost.ownerDilec.ownerOddeleni.OwnerLHC.LHC_KOD));
     ZapisDoBunkyZem(p+1,49,VPorost.ownerDilec.ownerOddeleni.OwnerLHC.LHP_OD
                  +'-'+VPorost.ownerDilec.ownerOddeleni.OwnerLHC.LHP_DO);
     if tisknoutUsek then
      begin
       ZapisDoBunkyZem(p+1,60,VPorost.ORG_UROVEN3_nazev);
      end
     else
      begin
      end;
     ZapisDoBunkyZem(p+1,67,inttostr(strana));
    end;

//   RoztahniVyplnTEXT(VPorost.POR_TEXT_Vse,p+3,11,100);
   RoztahniVyplnTEXT(VPorost.POR_TEXT_Vse,p+3,6,100,true,vyskaPopsaneStranky);


   if tisknoutNaOstro then
    begin
     if vymeru then VPorost.PouzivatPlochuJakoVymeruUVsech:=false;
     ZapisDoBunkyZemDouble(p+1,11,VPorost.porostniPuda,false);
     VPorost.PouzivatPlochuJakoVymeruUVsech:=true;
     if vymeru then  ZapisDoBunkyZemdouble(p+2,11,VPorost.porostniPuda,false);
     VPorost.PouzivatPlochuJakoVymeruUVsech:=false;
     ZapisDoBunkyZem(p+2,18,VPorost.Kategorie1MN.KategorieVcetnePrekryvu);
     sZvl:='';
     for iZvl:=0 to VPorost.ZvlStMn.count-1 do
      begin
       sZvl:=sZvl+TZvlSt(VPorost.ZvlStMn.Elements[iZvl]).ZVL_STATUT_nazev;
       if iZvl<VPorost.ZvlStMn.count-1 then sZvl:=sZvl+', ';
      end;
      // ZapisDoBunkyZem(p+2,28,TZvlSt(VPorost.ZvlStMn.Elements[iZvl]).ZVL_STATUT_nazev+'  ');
      ZapisDoBunkyZem(p+2,28,sZvl);
     ZapisDoBunkyZem(p+2,44,VPorost.PAS_OHR);
     ZapisDoBunkyZem(p+2,49,VPorost.ORG_UROVEN1_nazev);
     if tisknoutOdb_hosp then
      begin
       ZapisDoBunkyZem(p+2,61,VPorost.OLH_nazev);
      end
     else
      begin
       ZapisDoBunkyZem(p+2,61,VPorost.ORG_UROVEN2_Nazev);
      end;
    end;
 end;


Procedure VyplnHlaPravehoPorostu(VPorost:TPorost;strana:integer;PrvniRadekHl:integer;tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
var p,iZvl:integer;
   sZvl:string;
 begin
   p:=PrvniRadekHl;
   if tisknoutNaOstro then
    begin
   ZapisDoBunkyZem(p+1,72,inttostr(VPorost.ownerDilec.ownerOddeleni.ODD));
      if dilecIPorost then
       begin
        ZapisDoBunkyZem(p+2,69,VPorost.ownerDilec.Dil);
        ZapisDoBunkyZem(p+2,72,VPorost.POR);
       end
      else
       begin
        if mistoDilcePorost then
         begin
          ZapisDoBunkyZem(p+2,72,VPorost.POR);
         end
        else
         begin
          ZapisDoBunkyZem(p+2,69,VPorost.ownerDilec.Dil);
         end;
       end;

      if tisknoutMajitele then
       begin
        if tisknoutDruh_maj then
         begin
          ZapisDoBunkyZem(p+1,10,inttostr(VPorost.MAJ_DRUH)+'/'+VPorost.MAJ_KOD);
         end
        else
         begin
          ZapisDoBunkyZem(p+1,10,VPorost.MAJ_KOD);
         end;
       end;


   ZapisDoBunkyZem(p+1,18,VPorost.LES_OBL);
   ZapisDoBunkyZem(p+1,20,VPorost.LES_OBL_nazev);
   ZapisDoBunkyZem(p+1,34,inttostr(VPorost.ownerDilec.ownerOddeleni.OwnerLHC.LHC_KOD));
   ZapisDoBunkyZem(p+1,42,VPorost.ownerDilec.ownerOddeleni.OwnerLHC.LHP_OD
                  +'-'+VPorost.ownerDilec.ownerOddeleni.OwnerLHC.LHP_DO);
   if tisknoutUsek then
    begin
     ZapisDoBunkyZem(p+1,53,VPorost.ORG_UROVEN3_nazev);
    end
   else
    begin
    end;
   ZapisDoBunkyZem(p+1,60,inttostr(strana));

   ZapisDoBunkyZem(p+2,72,VPorost.POR);
   end;
   RoztahniVyplnTEXT(VPorost.POR_TEXT_Vse,p+3,11,100, true, vyskaPopsaneStranky);
   if tisknoutNaOstro then
    begin
   if vymeru then VPorost.PouzivatPlochuJakoVymeruUVsech:=false;
   ZapisDoBunkyZemDouble(p+1,65,VPorost.porostniPuda,false);
   VPorost.PouzivatPlochuJakoVymeruUVsech:=true;
   if vymeru then  ZapisDoBunkyZemdouble(p+2,65,VPorost.porostniPuda,false);
   VPorost.PouzivatPlochuJakoVymeruUVsech:=false;


   ZapisDoBunkyZem(p+2,11,VPorost.Kategorie1MN.KategorieVcetnePrekryvu);
   {
   for iZvl:=0 to VPorost.ZvlStMn.count-1 do
    begin
      ZapisDoBunkyZem(p+2,19,TZvlSt(VPorost.ZvlStMn.Elements[iZvl]).ZVL_STATUT_nazev+'  ');
    end;     }

     sZvl:='';
     for iZvl:=0 to VPorost.ZvlStMn.count-1 do
      begin
       sZvl:=sZvl+TZvlSt(VPorost.ZvlStMn.Elements[iZvl]).ZVL_STATUT_nazev;
       if iZvl<VPorost.ZvlStMn.count-1 then sZvl:=sZvl+', ';
      end;
     ZapisDoBunkyZem(p+2,19,sZvl);
//     ZapisDoBunkyZem(p+2,19,TZvlSt(VPorost.ZvlStMn.Elements[iZvl]).ZVL_STATUT_nazev+'  ');


   ZapisDoBunkyZem(p+2,37,VPorost.PAS_OHR);
   ZapisDoBunkyZem(p+2,42,VPorost.ORG_UROVEN1_nazev);

       if tisknoutOdb_hosp then
        begin
         ZapisDoBunkyZem(p+2,54,VPorost.OLH_nazev);
        end
       else
        begin
         ZapisDoBunkyZem(p+2,54,VPorost.ORG_UROVEN2_Nazev);
        end;
   end;
 end;


procedure kopirujAVyPlnHlavPor(VPorost:TPorost;strana:integer;PrvniRadekHl:integer;tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
 begin
  if not(jeLeva) then
   begin
    kopirujHlavPravPorNaKonec(tisknoutNaOstro,vyskaPopsaneStranky);
    VyplnHlaPravehoPorostu(VPorost,strana,PrvniRadekHl,tisknoutNaOstro,vyskaPopsaneStranky);
   end
  else
   begin
    kopirujHlavLevPorNaKonec(tisknoutNaOstro,vyskaPopsaneStranky);
    VyplnHlaLevehoPorostu(VPorost,strana,PrvniRadekHl,tisknoutNaOstro,vyskaPopsaneStranky);
   end;
 end;

procedure kopirujAVyplnEtaz(VEtaz:TEtaz;PrvRadHl:integer;tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
var Idr,iZal,IPos:integer;
 begin
    PrvRadHl:=PosledniRadek;
    if jeLeva then
     begin
      kopirujHlavLeveEtazeNaKonec(tisknoutNaOstro,vyskaPopsaneStranky);
      VyplnHlaLeveEtaze(VEtaz,PrvRadHl,tisknoutNaOstro);
     end
    else
     begin
      kopirujHlavPraveEtazeNaKonec(tisknoutNaOstro,vyskaPopsaneStranky);
      VyplnHlaPraveEtaze(VEtaz,PrvRadHl,tisknoutNaOstro);
     end;


     PrvRadHl:=PosledniRadek-1;
     for Idr:=0 to  VEtaz.DrevinaMn.Count-1 do
      begin
       if idr>0 then
        begin
         PrvRadHl:=PosledniRadek;
         if jeLeva then
          begin
           kopirujHlavickuLeveDrevNaKonec(tisknoutNaOstro,vyskaPopsaneStranky);
          end
         else
          begin
           kopirujHlavickuPraveDrevNaKonec(tisknoutNaOstro,vyskaPopsaneStranky);
          end;

        end;
       if jeLeva then
        begin
         VyplnHlaLeveDreviny(VEtaz.IDrevina[idr],PrvRadHl,tisknoutNaOstro,vyskaPopsaneStranky);
        end
       else
        begin
         VyplnHlaPraveDreviny(VEtaz.IDrevina[idr],PrvRadHl,tisknoutNaOstro,vyskaPopsaneStranky);
        end;
       for IPos:=0 to VEtaz.iDrevina[idr].poskozeniMN.count-1 do
        begin
         if IPos>0 then
          begin
           PrvRadHl:=PosledniRadek;
           if jeLeva then
            begin
             kopirujHlavickuLeveDrevNaKonec(tisknoutNaOstro,vyskaPopsaneStranky);
            end
           else
            begin
             kopirujHlavickuPraveDrevNaKonec(tisknoutNaOstro,vyskaPopsaneStranky);
            end;
          end;
         if jeLeva then
          begin
           VyplnHlaLevePosk(VEtaz.IDrevina[idr].IPoskozeni[iPos],PrvRadHl,tisknoutNaOstro);
          end
         else
          begin
           VyplnHlaPravePosk(VEtaz.IDrevina[idr].IPoskozeni[iPos],PrvRadHl,tisknoutNaOstro);
          end;
        end;
      end;
    for iZal:=0 to VEtaz.ZalesneniMn.Count-1 do
     begin
      if (IZal>=VEtaz.PocetRadkuDrevVcetnePoskozeni)and(iZAL>0) then
       begin
        PrvRadHl:=PosledniRadek;
         if jeLeva then
          begin
           kopirujHlavickuLeveDrevNaKonec(tisknoutNaOstro,vyskaPopsaneStranky);
          end
         else
          begin
           kopirujHlavickuPraveDrevNaKonec(tisknoutNaOstro,vyskaPopsaneStranky);
          end;
       end
      else
       begin
        if VEtaz.DrevinaMN.Count=0 then
         begin
          prvRadHl:=PosledniRadek-(VEtaz.DrevinaMN.Count-IZal+1);
         end
        else
         begin
          prvRadHl:=PosledniRadek-(VEtaz.PocetRadkuDrevVcetnePoskozeni-IZal);
         end;
       end;
       if jeLeva then
        begin
         if iZal=0 then
          begin
           if tisknoutNaOstro then
            begin
             ZapisDoBunkyZem(PrvRadHl,60,VEtaz.iZalesneni[iZal].ZAL_DRUH);
            end;
          end;
         VyplnHlaLeveZalesneni(VEtaz.iZalesneni[iZal],PrvRadHl,tisknoutNaOstro);
        end
       else
        begin
         VyplnHlaPraveZalesneni(VEtaz.iZalesneni[iZal],PrvRadHl,tisknoutNaOstro);
         if iZal=0 then
          begin
           if tisknoutNaOstro then
            begin
             ZapisDoBunkyZem(PrvRadHl,65,VEtaz.iZalesneni[iZal].ZAL_DRUH);
            end;
          end;
        end;

     end;

    if jeLeva then
     begin
      kopirujHlavickuLeveDrevNaKonec(tisknoutNaOstro,vyskaPopsaneStranky);
     end
    else
     begin
      kopirujHlavickuPraveDrevNaKonec(tisknoutNaOstro,vyskaPopsaneStranky);
     end;
   //  if vEtaz.OwnerPorostniSkupina.EtazMN.count>1 then
   //   begin
      PrvRadHl:=PosledniRadek;
      if jeLeva then
       begin
        kopirujHlavickuLeveDrevNaKonec(tisknoutNaOstro,vyskaPopsaneStranky);
        VyplnLevySoucetZaEtaz(VEtaz,PrvRadHl,tisknoutNaOstro);
       end
      else
       begin
        kopirujHlavickuPraveDrevNaKonec(tisknoutNaOstro,vyskaPopsaneStranky);
        VyplnPravySoucetZaEtaz(VEtaz,PrvRadHl,tisknoutNaOstro);
       end;
  //   end;
 end;


procedure kopirujAVyplnSkupinu(VPorostniSkupina:TPorostniSkupina;PrvRadHl:integer; tisknoutNaOstro:boolean; var vyskaPopsaneStranky:double);
var
 iEt:integer;
begin
  if EditInfo<>nil then
   begin
    EditInfo.text:=VPorostniSkupina.CeleOznaceni;
    EditInfo.refresh;
   end;
  if JeLeva then
   begin
    kopirujHlavLevePorSkupNaKonec(tisknoutNaOstro,vyskaPopsaneStranky);
    VyplnHlaLevePorSkup(VPorostniskupina,PrvRadHl,tisknoutNaOstro,vyskaPopsaneStranky);
   end
  else
   begin
    kopirujHlavPravePorSkupNaKonec(tisknoutNaOstro,vyskaPopsaneStranky);
    VyplnHlaPravePorSkup(VPorostniskupina,PrvRadHl,tisknoutNaOstro,vyskaPopsaneStranky);
   end;
   for iEt:=0 to VPorostniSkupina.EtazMN.count-1 do
    begin
     PrvRadHl:=PosledniRadek;
     kopirujAVyplnEtaz(VPorostniSkupina.IEtaz[iEt],PrvRadHl,tisknoutNaOstro,vyskaPopsaneStranky);
     if (VPorostniSkupina.EtazMN.count-1=iEt)and(VPorostniSkupina.EtazMN.count>1) then
       begin
        PrvRadHl:=PosledniRadek;
        if JeLeva then
         begin
          kopirujHlavickuLeveDrevNaKonec(tisknoutNaOstro,vyskaPopsaneStranky);
          VyplnLevySoucetZaSkupinu(VPorostniSkupina,PrvRadHl,tisknoutNaOstro);
         end
        else
         begin
          kopirujHlavickuPraveDrevNaKonec(tisknoutNaOstro,vyskaPopsaneStranky);
          VyplnPravySoucetZaSkupinu(VPorostniSkupina,PrvRadHl,tisknoutNaOstro);
         end;
       end;
    end;
  end;



var
   iPsk,iEt,Idr:integer;
   PrvRadHl,ir,radekPS,radekPor,pocetzobrSkupin:integer;
   ss1,ss2,ps1,ps2:string;
   vyskaPopsaneStranky:double;
   pokusnavyskaPopsaneStranky:double;
 begin
 //  MujSHI:='List1';
 //  WorkSheet:=workbook.Worksheets.item[MujSHI];
 //  VyskaStr:=0;
 //  VyskaPS:=0;
   pripravSablonuPodlePredvoleb;
   PrvRadHl:=PosledniRadek;
   if (levaPrava=1)or(levaPrava=2)or(levaPrava=3) then
    begin
     if (strana mod 2)=1 then
      begin
       JeLeva:=false;
      end
     else
      begin
       JeLeva:=true;
      end;
    end;
   if levaPrava=0 then
    begin
     JeLeva:=true;
    end;
   if levaPrava=4 then
    begin
     JeLeva:=false;
    end;
   radekPor:=PrvRadHl;
   vyskaPopsaneStranky:=0;
   kopirujAVyPlnHlavPor(VPorost,strana,PrvRadHl,true,vyskaPopsaneStranky);
   pocetzobrSkupin:=0;
  // vyskaPopsaneStranky:=VyskaMeziRadky(radekPor,posledniRadek);
   for iPsk:=0 to  VPorost.PorostniSkupinaMN.count-1 do
    begin
     PrvRadHl:=PosledniRadek;
     radekPS:=PrvRadHl;
     pokusnavyskaPopsaneStranky:=vyskaPopsaneStranky;
     kopirujAVyplnSkupinu(VPorost.IPorostniSkupina[iPsk],PrvRadHl,false,pokusnavyskaPopsaneStranky);
     // showmessage('cau '+DoubleToStr(vyskaPopsaneStranky,10,2));
     inc(pocetzobrSkupin);

     if (pokusnavyskaPopsaneStranky>VyskaStrankyVmm)and(pocetzobrSkupin>1) then
      begin
       PrvRadHl:=PosledniRadek;
       if (levaPrava=1)or(levaPrava=2)or(levaPrava=3) then  JeLeva:=not jeleva;
       radekPor:=PrvRadHl;
       vlozKonecStranky(radekPor+1,6);
        inc(strana);
       vyskaPopsaneStranky:=0;
       kopirujAVyPlnHlavPor(VPorost,strana,PrvRadHl,true,vyskaPopsaneStranky);
       PrvRadHl:=PosledniRadek;
       radekPS:=PrvRadHl;
       kopirujAVyplnSkupinu(VPorost.IPorostniSkupina[iPsk],PrvRadHl,true,vyskaPopsaneStranky);
       pocetzobrSkupin:=1;
      end
     else
      begin
       kopirujAVyplnSkupinu(VPorost.IPorostniSkupina[iPsk],PrvRadHl,true,vyskaPopsaneStranky);
      end;
   { if (VyskaMeziRadky(radekPor,posledniRadek)>VyskaStrankyVmm)and(pocetzobrSkupin>1) then
      begin
       SmazRadkyVExceluZem(radekPS+1,posledniRadek,posledniRadek);
       if (levaPrava=1) and not(JeLeva) then
        begin
         SmazRadkyVExceluZem(radekPor+1,posledniRadek,posledniRadek);
        end;
       if (levaPrava=2) and JeLeva then
        begin
         SmazRadkyVExceluZem(radekPor+1,posledniRadek,posledniRadek);
        end;
       PrvRadHl:=PosledniRadek;
       if (levaPrava=1)or(levaPrava=2)or(levaPrava=3) then  JeLeva:=not jeleva;
       radekPor:=PrvRadHl;
       vlozKonecStranky(radekPor+1,6);
        inc(strana);
       kopirujAVyPlnHlavPor(VPorost,strana,PrvRadHl);
       PrvRadHl:=PosledniRadek;
       radekPS:=PrvRadHl;
       kopirujAVyplnSkupinu(VPorost.IPorostniSkupina[iPsk],PrvRadHl);
       pocetzobrSkupin:=1;
      end;   }
    end;
 vlozKonecStranky(PosledniRadek+1,6);
 inc(strana);
 // SmazRadkyVExceluZem(1,28,posledniRadek);

 end;
procedure SmazPrvniRadky;
 begin
  // RangeSmazRadky(WorkSheet:OleVariant;row1,row2:integer);
   SmazRadkyVExceluZem(1,28,posledniRadek);
 end;

{
        Jednostr_jako_lev   levaPrava:=0;
        Jen_leve_stranky    levaPrava:=1;
        Jen_prave_stranky  levaPrava:=2;
        Oboustranne levaPrava:=3;
        Jednostr_jako_prave levaPrava:=4;
}

end.
