unit Lescisel;
interface
uses Dialogs,DBTables,DB,Kfindtab,Forms,
     Elements,E_dClass,
     mat1;
type
TDatabaseMel_DrevClass=class(TDatabaseClass)
 private
  function GetDR_ZKR:string;
  function GetLT_SLT:string;
 published
  property DR_ZKR :string read GetDR_ZKR;
  property LT_SLT :string read GetLT_SLT;
end;
tciselnik = class(TOwnerEntity)
private
  FTB_PorPO    :TTable;
  FTB_PorPP    :TTable;
  FTB_PorPR    :TTable;
  FTB_PorNPP   :TTable;
  FTB_PorNPR   :TTable;
  FTB_PorSCHU  :TTable;
  FTB_PorEVL   :TTable;
  FTB_PorNP    :TTable;
  FTB_PorCHKO  :TTable;
  FTB_PorKtg   :TTable;
  FTB_PorZvl   :TTable;
  
  FTb_HS       :TTable;
  FTb_LT       :TTable;
  FTb_LTZkouselOtevrit:boolean;
  FTb_SLT      :TTable;
  FTb_SLTZkouselOtevrit:boolean;
  FTb_Ktg      :TTable;
  FTb_KtgZkouselOtevrit:boolean;
  FTb_PorKtg1   :TTable;
  FTb_PorZvlSt  :TTable;
  Ftb_PLT_LT     :TTable;
  Ftb_nal      :TTable;
  Ftb_nalZkouselOtevrit:boolean;
  Ftb_tvar     :TTable;
  Ftb_tvarZkouselOtevrit:boolean;
  Ftb_HZ       :TTable;
  Ftb_HZZkouselOtevrit:boolean;
  Ftb_ZJZ      :TTable;
  Ftb_ZJZZkouselOtevrit:boolean;
  Ftb_ZVL_Stat :TTable;
  Ftb_ZVL_StatZkouselOtevrit:boolean;
  Ftb_ZVL_StatZkr :TTable;
  Ftb_ZVL_StatZkrZkouselOtevrit:boolean;
  Ftb_Druh_vla :TTable;
  Ftb_Druh_vlaZkouselOtevrit:boolean;
  Ftb_PaOh     :TTable;
  Ftb_PaOhZkouselOtevrit:boolean;
  Ftb_LeOb98     :TTable;
  Ftb_LeOb98ZkouselOtevrit:boolean;
  Ftb_LeOb99     :TTable;
  Ftb_LeOb99ZkouselOtevrit:boolean;
  Ftb_Podob     :TTable;
  Ftb_PodobZkouselOtevrit:boolean;
  Ftb_sdr_por  :TTable;
  Ftb_sdr_porZkouselOtevrit:boolean;
  Ftb_Druh_poz :TTable;
  Ftb_Druh_pozZkouselOtevrit:boolean;
  Ftb_Biotop :TTable;
  Ftb_BiotopZkouselOtevrit:boolean;

  Ftb_Pot_vla  :TTable;
  Ftb_Pot_vlaZkouselOtevrit:boolean;
  Ftb_TeTy1    :TTable;
  Ftb_TeTy1ZkouselOtevrit:boolean;
  Ftb_PLT    :TTable;
  Ftb_PLTZkouselOtevrit:boolean;

  Ftb_EVL    :TTable;
  Ftb_EVLZkouselOtevrit:boolean;
  Ftb_PO     :TTable;
  Ftb_POZkouselOtevrit:boolean;
  Ftb_CHKO   :TTable;
  Ftb_CHKOZkouselOtevrit:boolean;
  Ftb_NP    :TTable;
  Ftb_NPZkouselOtevrit:boolean;
  Ftb_NPP    :TTable;
  Ftb_NPPZkouselOtevrit:boolean;
  Ftb_NPR    :TTable;
  Ftb_NPRZkouselOtevrit:boolean;
  Ftb_PP    :TTable;
  Ftb_PPZkouselOtevrit:boolean;
  Ftb_PR    :TTable;
  Ftb_PRZkouselOtevrit:boolean;
  Ftb_ZONA    :TTable;
  Ftb_ZONAZkouselOtevrit:boolean;

  Ftb_LVS    :TTable;
  Ftb_LVSZkouselOtevrit:boolean;
  Ftb_Gen_PUV    :TTable;
  Ftb_Gen_PUVZkouselOtevrit:boolean;

  Ftb_TypManag    :TTable;
  Ftb_TypManagZkouselOtevrit:boolean;
  Ftb_TechTyp    :TTable;
  Ftb_TechTypZkouselOtevrit:boolean;
  Ftb_LDU      :TTable;
  Ftb_LDUZkouselOtevrit:boolean;
  Ftb_ORP      :TTable;
  Ftb_ORPZkouselOtevrit:boolean;

  Ftb_KuOrpKraj     :TTable;
  Ftb_KuOrpKrajZkouselOtevrita:boolean;

  Ftb_KU6a     :TTable;
  Ftb_KU6ZkouselOtevrita:boolean;

  Ftb_KU6b     :TTable;
  Ftb_KU6ZkouselOtevritb:boolean;

  FTb9_6Win      :TTable;
  FTb9_6WinZkouselOtevrit:boolean;

  FtbObce6       :TTable;
  FtbObce6ZkouselOtevrit:boolean;

  Ftb_Kval_P   :TTable;
  Ftb_Kval_PZkouselOtevrit:boolean;
  Ftb_Duv_tezb :TTable;
  Ftb_Duv_tezbZkouselOtevrit:boolean;
  Ftb_Druh_Zal :TTable;
  Ftb_Druh_ZalZkouselOtevrit:boolean;
  Ftb_Dan      :TTable;
  Ftb_DanZkouselOtevrit:boolean;
  Ftb_Majetky  :TTable;
  Ftb_Katastry :TTable;
  Ftb_OLH      :TTable;
  Ftb_genKl    :TTable;
  Ftb_genKlZkouselOtevrit:boolean;
  Ftb_imise98    :TTable;
  Ftb_imise98ZkouselOtevrit:boolean;
  Ftb_imise99    :TTable;
  Ftb_imise99ZkouselOtevrit:boolean;
  FTb_puvod    :TTable;
  FTb_puvodZkouselOtevrit:boolean;
  Ftb_DrevCis  :TTable;
  Ftb_DrevCisZkouselOtevrit:boolean;
  Ftb_posk     :TTable;
  FTb_poskZkouselOtevrit:boolean;
  FTB_OrgUr1   :TTable;
  FTB_OrgUr2   :TTable;
  FTB_OrgUr3   :TTable;
  FTB_Mel_Drev:TTable;
  FTB_Cis_Bezl :TTable;
  FTB_Cis_BezlZkouselOtevrit:boolean;
  FTB_Cis_Jine :TTable;
  FTB_Cis_JineZkouselOtevrit:boolean;
  FTB_Cis_OstZkouselOtevrit:boolean;
  FTB_Cis_Ost :TTable;
  FTB_Zp_TEZBY :TTable;
  FTB_Zp_TEZBYZkouselOtevrit:boolean;
  FTB_ODVOZ_TEZ :TTable;
  FTB_ODVOZ_TEZZkouselOtevrit:boolean;
  FTb_RustTab :TTable;
  FTb_RustTabZkouselOtevrit:boolean;
  FTb_HSClass      :TDatabaseClass;
  FTb_LTClass      :TDatabaseClass;
  FTb_SLTClass      :TDatabaseClass;
  FTb_KtgClass     :TDatabaseClass;
  FTb_PorKtgClass  :TDatabaseClass;
  Ftb_nalClass     :TDatabaseClass;
  Ftb_tvarClass    :TDatabaseClass;
  Ftb_HZClass      :TDatabaseClass;
  Ftb_ZJZClass     :TDatabaseClass;
  Ftb_ZVL_StatClass:TDatabaseClass;
  Ftb_ZVL_StatZkrClass:TDatabaseClass;
  Ftb_Druh_vlaClass:TDatabaseClass;
  Ftb_PaOhClass    :TDatabaseClass;
  Ftb_LeOb98Class  :TDatabaseClass;
  Ftb_LeOb99Class  :TDatabaseClass;
  Ftb_PodobClass  :TDatabaseClass;
  Ftb_sdr_porClass :TDatabaseClass;
  Ftb_Druh_pozClass:TDatabaseClass;
  Ftb_BiotopClass:TDatabaseClass;
  Ftb_Pot_vlaClass :TDatabaseClass;
  Ftb_TeTyClass    :TDatabaseClass;
  Ftb_TypManagClass:TDatabaseClass;

  Ftb_LDUClass     :TDatabaseClass;
  Ftb_Kval_PClass  :TDatabaseClass;
  Ftb_Duv_tezbClass:TDatabaseClass;
  Ftb_Druh_ZalClass:TDatabaseClass;
  Ftb_DanClass     :TDatabaseClass;
  Ftb_MajetkyClass :TDatabaseClass;
  Ftb_KatastryClass:TDatabaseClass;
  Ftb_OLHClass     :TDatabaseClass;
  Ftb_genKlClass   :TDatabaseClass;
  Ftb_imise98Class   :TDatabaseClass;
  Ftb_imise99Class   :TDatabaseClass;
  FTb_puvodClass   :TDatabaseClass;
  Ftb_DrevCisClass :TDatabaseClass;
  Ftb_poskClass    :TDatabaseClass;
  FTB_OrgUr1Class  :TDatabaseClass;
  FTB_OrgUr2Class  :TDatabaseClass;
  FTB_OrgUr3Class  :TDatabaseClass;
  FTB_Mel_DrevClass:TDatabaseMel_DrevClass;
  FTB_Cis_BezlClass:TDatabaseClass;
  FTB_Cis_JineClass:TDatabaseClass;
  FTB_Cis_OstClass:TDatabaseClass;
  FTB_Zp_TEZBYClass:TDatabaseClass;
  FTB_ODVOZ_TEZClass:TDatabaseClass;
  FTb_RustTabClass:TDatabaseClass;
 function GetTb_LTClass:TDatabaseClass;
 function GetTb_SLTClass:TDatabaseClass;
 function GetTb_KTGClass:TDatabaseClass;
 function GetTb_NalClass:TDatabaseClass;
 function GetTb_TvarClass:TDatabaseClass;
 function GetTb_HZClass:TDatabaseClass;
 function GetTb_ZJZClass:TDatabaseClass;
 function GetTb_ZVL_StatClass:TDatabaseClass;
 function GetTb_ZVL_StatZkrClass:TDatabaseClass;
 function GetTb_Druh_vlaClass:TDatabaseClass;
 function GetTb_PaOhClass:TDatabaseClass;
 function GetTb_LeOb98Class:TDatabaseClass;
 function GetTb_LeOb99Class:TDatabaseClass;
 function GetTb_PodobClass:TDatabaseClass;
 function GetTb_Sdr_porClass:TDatabaseClass;
 function GetTb_Druh_pozClass:TDatabaseClass;
 function GetTb_BiotopClass:TDatabaseClass;
 function GetTb_Pot_vlaClass:TDatabaseClass;
 function GetTb_TetyClass:TDatabaseClass;
 function GetTB_TypManagClass:TDatabaseClass;
 function GetTb_LDUClass:TDatabaseClass;
 function GetTb_Kval_PClass:TDatabaseClass;
 function GetTb_Duv_tezbClass:TDatabaseClass;
 function GetTb_Druh_zalClass:TDatabaseClass;
 function GetTb_DanClass:TDatabaseClass;
 function GetTb_KatastryClass:TDatabaseClass;
 function GetTb_OLHClass:TDatabaseClass;
 function GetTb_GenKLClass:TDatabaseClass;
 function GetTb_Imise98Class:TDatabaseClass;
 function GetTb_Imise99Class:TDatabaseClass;
 function GetTb_PuvodClass:TDatabaseClass;
 function GetTb_PoskClass:TDatabaseClass;
 function GetTb_OrgUr1Class:TDatabaseClass;
 function GetTb_OrgUr2Class:TDatabaseClass;
 function GetTb_OrgUr3Class:TDatabaseClass;
 function GetTb_HSClass:TDatabaseClass;
 function GetTb_PorKtgClass:TDatabaseClass;
 function GetTb_MAjetkyClass:TDatabaseClass;
 function GetTb_DrevCisClass:TDatabaseClass;
 function GetTb_Mel_DrevClass:TDatabaseMel_DrevClass;
 function GetTB_Cis_BezlClass:TDatabaseClass;
 function GetTB_Cis_JineClass:TDatabaseClass;
 function GetTB_Cis_ostClass:TDatabaseClass;
 function GetTB_Zp_TEZBYClass:TDatabaseClass;
 function GetTB_ODVOZ_TEZClass:TDatabaseClass;
 function GetTb_RustTabClass:TDatabaseClass;

 function GetTb_LeOb98:TTable;
 function GetTb_LeOb99:TTable;
 function GetTb_Podob:TTable;
 function GetTb_LT :TTable;
 function GetTb_SLT      :TTable;
 function GetTb_Ktg      :TTable;
 function Gettb_nal      :TTable;
 function Gettb_tvar     :TTable;
 function Gettb_HZ       :TTable;
 function Gettb_ZJZ      :TTable;
 function Gettb_ZVL_Stat :TTable;
 function Gettb_ZVL_StatZkr :TTable;
 function Gettb_Druh_vla :TTable;
 function Gettb_PaOh     :TTable;
 function Gettb_sdr_por  :TTable;
 function Gettb_Druh_poz :TTable;
 function Gettb_Biotop   :TTable;
 function Gettb_Pot_vla  :TTable;
 function Gettb_TeTy1    :TTable;
 function Gettb_PLT    :TTable;
 function Gettb_EVL    :TTable;
 function Gettb_PO     :TTable;
 function Gettb_CHKO   :TTable;
 function Gettb_NP    :TTable;
 function Gettb_NPP    :TTable;
 function Gettb_NPR    :TTable;
 function Gettb_PP    :TTable;
 function Gettb_PR    :TTable;
 function Gettb_ZONA    :TTable;

 function Gettb_Gen_PUV :TTable;
 function Gettb_LVS     :TTable;

 function Gettb_TypManag :TTable;
 function Gettb_TechTyp  :TTable;
 function Gettb_LDU      :TTable;
 function Gettb_ORP      :TTable;
 function Gettb_KuOrpKraj :TTable;
 function Gettb_KU6a      :TTable;
 function Gettb_KU6b      :TTable;
 function GetTb9_6Win    :TTable;
 function GettbObce6     :TTable;
 function Gettb_Kval_P   :TTable;
 function Gettb_Duv_tezb :TTable;
 function GetTb_RustTab  :TTable;
 function Gettb_Druh_Zal :TTable;
 function Gettb_Dan      :TTable;
 function Gettb_genKl    :TTable;
 function Gettb_imise98  :TTable;
 function Gettb_imise99  :TTable;
 function GetTb_puvod    :TTable;
 function Gettb_posk     :TTable;
 function Gettb_DrevCis  :TTable;
 function GetTB_Zp_TEZBY :TTable;
 function GetTB_ODVOZ_TEZ:TTable;
 function GetTB_Cis_Bezl :TTable;
 function GetTB_Cis_Jine :TTable;
 function GetTB_Cis_Ost :TTable;
 public
 procedure VypORP(KU_KOD6:longint; var ORP:longint);
 published



  property Tb_PorPO :TTable read FTb_PorPO write FTb_PorPO;
  property Tb_PorPR :TTable read FTb_PorPR write FTb_PorPR;
  property Tb_PorPP :TTable read FTb_PorPP write FTb_PorPP;

  property Tb_PorNPP :TTable read FTb_PorNPP  write FTb_PorNPP;
  property Tb_PorNPR :TTable read FTb_PorNPR  write FTb_PorNPR;
  property Tb_PorEVL :TTable read FTb_PorEVL  write FTb_PorEVL;
  property Tb_PorSCHU:TTable read FTb_PorSCHU write FTb_PorSCHU;

  property Tb_PorNP   :TTable read FTb_PorNP   write FTb_PorNP;
  property Tb_PorCHKO :TTable read FTb_PorCHKO write FTb_PorCHKO;

  property Tb_PorZvl :TTable read FTb_PorZvl write FTb_PorZvl;
  property Tb_PorKtg :TTable read FTb_PorKtg write FTb_PorKtg;

  property Tb_LT :TTable read GetTb_LT write FTb_LT;
  property Tb_SLT :TTable read GetTb_SLT write FTb_SLT;
  property Tb_PorKtg1 :TTable read FTb_PorKtg1 write FTb_PorKtg1;
  property tb_PLT_LT:TTable read Ftb_PLT_LT write Ftb_PLT_LT;

  property Tb_PorZvlSt :TTable read FTb_PorZvlSt write FTb_PorZvlSt;
  property Tb_PaOh :TTable read GetTb_PaOh write FTb_PaOh;
  property tb_nal :TTable read Gettb_nal write Ftb_nal;
  property tb_tvar:TTable read Gettb_tvar write Ftb_tvar;
  property tb_HZ:TTable read Gettb_HZ write Ftb_HZ;
  property tb_ZJZ:TTable read Gettb_ZJZ write Ftb_ZJZ;
  property tb_ZVL_Stat:TTable read Gettb_ZVL_Stat write Ftb_ZVL_Stat;
  property tb_ZVL_StatZkr:TTable read Gettb_ZVL_StatZkr write Ftb_ZVL_StatZkr;
  property tb_Druh_vla:TTable read Gettb_Druh_vla write Ftb_Druh_vla;
  property tb_LeOb98:TTable read GetTb_LeOb98 write Ftb_LeOb98;
  property tb_LeOb99:TTable read GetTb_LeOb99 write Ftb_LeOb99;
  property tb_Podob:TTable read GetTb_Podob write Ftb_Podob;
  property tb_sdr_por:TTable read Gettb_sdr_por write Ftb_sdr_por;
  property tb_Druh_poz:TTable read Gettb_Druh_poz write Ftb_Druh_poz;
  property tb_Biotop:TTable read Gettb_Biotop write Ftb_Biotop;
  property tb_Pot_vla:TTable read Gettb_Pot_vla write Ftb_Pot_vla;
  property tb_TeTy1:TTable read Gettb_TeTy1 write Ftb_TeTy1;
  property tb_PLT:TTable read Gettb_PLT write Ftb_PLT;

  property tb_EVL    :TTable read Gettb_EVL   write Ftb_EVL;
  property tb_ZONA   :TTable read Gettb_ZONA  write Ftb_ZONA;

  property tb_PO     :TTable read Gettb_PO   write Ftb_PO;
  property tb_CHKO   :TTable read Gettb_CHKO write Ftb_CHKO;
  property tb_NP     :TTable read Gettb_NP   write Ftb_NP;
  property tb_NPP    :TTable read Gettb_NPP  write Ftb_NPP;
  property tb_NPR    :TTable read Gettb_NPR  write Ftb_NPR;
  property tb_PP     :TTable read Gettb_PP   write Ftb_PP;
  property tb_PR     :TTable read Gettb_PR   write Ftb_PR;

  property tb_LVS    :TTable read Gettb_LVS     write Ftb_LVS;
  property tb_Gen_PUV:TTable read Gettb_Gen_PUV write Ftb_Gen_PUV;

  property tb_TypManag:TTable read Gettb_TypManag write Ftb_TypManag;

  property tb_TechTyp:TTable read Gettb_TechTyp write Ftb_TechTyp;
  property tb_LDU:TTable read Gettb_LDU write Ftb_LDU;
  property tb_ORP:TTable read Gettb_ORP write Ftb_ORP;

  property tb_KuOrpKraj:TTable read Gettb_KuOrpKraj write Ftb_KuOrpKraj;
  property tb_KU6a:TTable read Gettb_KU6a write Ftb_KU6a;
  property tb_KU6b:TTable read Gettb_KU6b write Ftb_KU6b;

  property Tb9_6Win:TTable read GetTb9_6Win write FTb9_6Win;
  property tbObce6:TTable read GettbObce6 write FtbObce6;

  property tb_Kval_P:TTable read Gettb_Kval_P write Ftb_Kval_P;
  property tb_Duv_tezb:TTable read Gettb_Duv_tezb write Ftb_Duv_tezb;
  property Tb_RustTab:TTable read GetTb_RustTab write FTb_RustTab;
  property tb_Druh_Zal:TTable read Gettb_Druh_Zal write Ftb_Druh_Zal;
  property tb_Dan:TTable read Gettb_Dan write Ftb_Dan;
  property tb_Majetky:TTable read Ftb_Majetky write Ftb_Majetky;
  property tb_Katastry:TTable read Ftb_Katastry write Ftb_Katastry;
  property tb_OLH:TTable read Ftb_OLH write Ftb_OLH;
  property Tb_HS :TTable read FTb_HS write FTb_HS;


  property tb_genKl:TTable read Gettb_genKl write Ftb_genKl;
  property tb_imise98:TTable read Gettb_imise98 write Ftb_imise98;
  property tb_imise99:TTable read Gettb_imise99 write Ftb_imise99;
  property Tb_Ktg :TTable read GetTb_Ktg write FTb_Ktg;
  property Tb_puvod:TTable read GetTb_puvod write FTb_puvod;
  property tb_posk:TTable read Gettb_posk write Ftb_posk;

  property tb_DrevCis:TTable read Gettb_DrevCis write Ftb_DrevCis;
  property Tb_OrgUr1 :TTable read FTb_OrgUr1 write FTb_OrgUr1;
  property Tb_OrgUr2 :TTable read FTb_OrgUr2 write FTb_OrgUr2;
  property Tb_OrgUr3 :TTable read FTb_OrgUr3 write FTb_OrgUr3;
  property TB_Mel_Drev:TTable read FTB_Mel_Drev write FTB_Mel_Drev;
  property TB_Cis_Bezl :TTable read GetTB_Cis_Bezl write FTB_Cis_Bezl;
  property TB_Cis_Jine :TTable read GetTB_Cis_Jine write FTB_Cis_Jine;
  property TB_Cis_Ost :TTable read GetTB_Cis_Ost write FTB_Cis_Ost;
  property TB_Zp_TEZBY :TTable read GetTB_Zp_TEZBY write FTB_Zp_TEZBY;
  property TB_ODVOZ_TEZ :TTable read GetTB_ODVOZ_TEZ write FTB_ODVOZ_TEZ;

  property Tb_LTClass:TDatabaseClass        read GetTb_LTClass;
  property Tb_SLTClass:TDatabaseClass       read GetTb_SLTClass;
  property Tb_KTGClass:TDatabaseClass       read GetTb_KTGClass;
  property Tb_NalClass:TDatabaseClass       read GetTb_NalClass;
  property Tb_TvarClass:TDatabaseClass      read GetTb_TvarClass;
  property Tb_HZClass:TDatabaseClass        read GetTb_HZClass;
  property Tb_ZJZClass:TDatabaseClass       read GetTb_ZJZClass;
  property Tb_ZVL_StatClass:TDatabaseClass  read GetTb_ZVL_StatClass;
  property Tb_ZVL_StatZkrClass:TDatabaseClass  read GetTb_ZVL_StatZkrClass;
  property Tb_Druh_vlaClass:TDatabaseClass   read GetTb_Druh_vlaClass;
  property Tb_PaOhClass:TDatabaseClass       read GetTb_PaOhClass;
  property Tb_LeOb98Class:TDatabaseClass     read GetTb_LeOb98Class;
  property Tb_LeOb99Class:TDatabaseClass     read GetTb_LeOb99Class;
  property Tb_PodobClass:TDatabaseClass      read GetTb_PodobClass;
  property Tb_Sdr_porClass:TDatabaseClass    read GetTb_Sdr_porClass;
  property Tb_Druh_pozClass:TDatabaseClass   read GetTb_Druh_pozClass;
  property Tb_BiotopClass:TDatabaseClass     read GetTb_BiotopClass;
  property Tb_Pot_vlaClass:TDatabaseClass    read GetTb_Pot_VlaClass;
  property Tb_TetyClass:TDatabaseClass       read GetTb_TeTyClass;
  property Tb_TypManagClass:TDatabaseClass   read GetTb_TypManagClass;
  property Tb_LDUClass:TDatabaseClass        read GetTb_LDUClass;
  property Tb_Kval_PClass:TDatabaseClass     read GetTb_Kval_PClass;
  property Tb_Duv_tezbClass:TDatabaseClass   read GetTb_Duv_tezbClass;
  property Tb_RustTabClass:TDatabaseClass    read GetTb_RustTabClass;
  property Tb_Druh_zalClass:TDatabaseClass   read GetTb_Druh_ZalClass;
  property Tb_DanClass:TDatabaseClass        read GetTb_DanClass;
  property Tb_KatastryClass:TDatabaseClass   read GetTb_KatastryClass;
  property Tb_OLHClass:TDatabaseClass        read GetTb_OLHClass;
  property Tb_GenKLClass:TDatabaseClass      read GetTb_GenKlClass;
  property Tb_Imise98Class:TDatabaseClass    read GetTb_Imise98Class;
  property Tb_Imise99Class:TDatabaseClass    read GetTb_Imise99Class;
  property Tb_PuvodClass:TDatabaseClass      read GetTb_PuvodClass;
  property Tb_PoskClass:TDatabaseClass       read GetTb_PoskClass;
  // property Tb_PLT_LTClass:TDatabaseClass     read GetTb_PLT_LTClass;

  property Tb_OrgUr1Class:TDatabaseClass     read GetTb_OrgUr1Class;
  property Tb_OrgUr2Class:TDatabaseClass     read GetTb_OrgUr2Class;
  property Tb_OrgUr3Class:TDatabaseClass     read GetTb_OrgUr3Class;
  property Tb_HSClass:TDatabaseClass         read GetTb_HSClass;
  property Tb_PorKtgClass:TDatabaseClass     read GetTb_PorKtgClass;
  property Tb_MAjetkyClass:TDatabaseClass    read GetTb_MAjetkyClass;
  property Tb_DrevCisClass:TDatabaseClass    read GetTb_DrevCisClass;
  property Tb_Mel_DrevClass:TDatabaseMel_DrevClass  read GetTb_Mel_DrevClass;
  property TB_Cis_BezlClass:TDatabaseClass   read GetTB_Cis_BezlClass;
  property TB_Cis_JineClass:TDatabaseClass   read GetTB_Cis_JineClass;
  property TB_Cis_OstClass:TDatabaseClass   read GetTB_Cis_OstClass;
  property TB_Zp_TEZBYClass:TDatabaseClass   read GetTB_Zp_TEZBYClass;
  property TB_ODVOZ_TEZClass:TDatabaseClass   read GetTB_ODVOZ_TEZClass;
 end;
function Jehlicnan(drevSt:string):boolean;
function JeVCiselniku(dtSet:TDataSet;poleHl:string;hodnota:String;zpusobPorovnani:Boolean;
                      PripustitPrazdny:boolean):boolean;
function DleCiselniku(dtSet:TDataSet;
                      poleKtereZname:string;
                      hodnotaPoleKtereZname:String;
                      poleKtereHledameVCiselniku:string;
                      zpusobPorovnani:Boolean):String;
function ZAbsNaRelSchwVyhl295r95Nepouzivat(drevSt:string;vek,AVB:Integer):integer;
function ZAbsNaRelSchwVyhl2008(drevSt:string;vek,AVB:Integer):integer;
function zKategorieCislo(st:string):integer;
procedure vypoctiPrirustyTab(RustTab:TTable;DrevStr:string;Vek,AVB,Obmyti:Integer;
                              odkornovat:boolean; var BeznyPrirust,PMP,CPP:integer);
// Function vypoctiBeznyPrirTab(RustTab:TTable;DrevStr:string;Vek,AVB:Integer):integer;
function PLT_z_TabulkyPLT_LT(vLT,vLES_OBL,vLES_Podobl:string;TB_PLT_LT:TTable):string;
function CIL_HS_z_TabulkyPLT_LT(vLT,vLES_OBL,vLES_Podobl:string;TB_PLT_LT:TTable):integer;
function PLT_z_TabulkyPLT_LTAbyVyhovelKople(vLT,vLES_OBL,vLES_Podobl:string;TB_PLT_LT:TTable):string;


function Kategorie_st_z_TabulkyPorostu(sODD,sDIL,sPor:string;TB_porKTG:TTable):string;
function ZvlSt_st_z_TabulkyPorostu(sODD,sDIL,sPor:string;TB_porZvlSt:TTable):string;
function Texty_st_z_TabulkyPorostu(sODD,sDIL,sPor:string;TB_porKTG:TTable):string;
function bezKury(V:integer;drevSt:string):integer;
function bezKuryFloat(V:double;drevSt:string):double;
function SKurou(V:integer;drevSt:string):integer;

function ZkrOchrPrirDleZvlSt(iZvlSt:integer; Var vZona:integer):string;
function ZvlStDleZkrOchrPrir(ZkrOchrS:string):integer;
procedure VypORPPoStaru(KU6:longint; TbKU6,tbObce6:TTable; var ORP:longint);


var CiselnikP:TCiselnik;
implementation
uses bonita,SysUtils;
const
Pole_ABS_na_RELVyhl2008:Array[1..25,1..16] of byte =
// je to z Vyhlky Ministerstva financ R . 3/2008 Sb., kterou se provdj nkter ustanoven zkona . 151/1997 Sb., o oceovn majetku a o zmn nkterch zkon (zkon o oceovn majetku), ve znn vyhlky . 456/2008 Sb.)
 {SM}
((9,9,9,7,7,6,5,4,3,3,2,1,1,1,1,1),
 (9,9,9,8,7,6,5,5,4,3,2,1,1,1,1,1),
 (9,9,9,8,8,7,6,5,4,3,2,1,1,1,1,1),
 {BO}
 (9,9,8,7,6,5,4,3,2,1,1,1,1,1,1,1),
 (9,9,8,7,7,6,5,3,2,1,1,1,1,1,1,1),
 (9,9,8,8,7,6,5,4,3,1,1,1,1,1,1,1),
 {JD}
 (9,9,9,9,7,5,4,3,2,1,1,1,1,1,1,1),
 (9,9,9,9,8,6,5,4,3,2,1,1,1,1,1,1),
 {MD}
 (9,9,8,7,6,6,5,4,2,1,1,1,1,1,1,1),
 (9,9,8,7,6,5,4,3,2,1,1,1,1,1,1,1),
 {DG}
 (5,5,5,5,5,5,5,5,5,5,5,5,5,5,4,3),
 {BK}
 (9,9,9,8,7,6,5,4,3,2,1,1,1,1,1,1),
 (9,9,9,8,7,6,6,5,4,3,2,1,1,1,1,1),
 {DB}
 (9,8,7,7,6,5,4,3,2,1,1,1,1,1,1,1),
 (9,9,8,7,6,5,5,4,2,1,1,1,1,1,1,1),
 (9,9,8,7,7,6,5,4,2,1,1,1,1,1,1,1),
 {JS}
 (3,3,3,3,3,3,3,3,2,2,1,1,1,1,1,1),
 {OL}
 (5,5,5,5,5,5,4,3,2,2,1,1,1,1,1,1),
 {BR}
 (3,3,3,3,3,3,2,1,1,1,1,1,1,1,1,1),
 {OS}
 (3,3,3,3,3,3,2,1,1,1,1,1,1,1,1,1),
 {AK}
 (9,9,9,8,7,7,6,1,1,1,1,1,1,1,1,1),
 (9,8,8,7,6,6,5,4,1,1,1,1,1,1,1,1),
 {TO}
 (9,9,9,9,9,9,9,9,8,7,6,1,1,1,1,1),
 {HB}
 (9,9,8,7,6,4,2,1,1,1,1,1,1,1,1,1),
 (9,9,8,6,5,3,2,1,1,1,1,1,1,1,1,1));
                     // vek   AVB
Pole_ABS_na_REL:array [1..42,1..16] of byte =
 {SM}
((9,9,8,7,6,6,5,4,3,2,1,1,1,1,1,1), // (vek<=20)
 (9,9,8,7,6,6,5,4,3,2,1,1,1,1,1,1), // (vek>20) and(vek<=40)
 (9,9,9,7,7,6,5,4,3,3,2,1,1,1,1,1), // (vek>40) and(vek<=60)
 (9,9,9,8,7,6,5,5,4,3,2,1,1,1,1,1), // (vek>60) and(vek<=80)
 (9,9,9,9,8,7,6,5,4,3,2,1,1,1,1,1), // (vek>80) and(vek<=100)
 (9,9,9,9,9,8,7,6,5,4,3,2,1,1,1,1), // (vek>100)and(vek<=120)
 (9,9,9,9,9,9,8,7,5,4,3,2,1,1,1,1), // (vek>120)
 {BO}
 (9,9,8,7,6,5,4,3,2,1,1,1,1,1,1,1),
 (9,9,8,7,6,5,4,3,2,1,1,1,1,1,1,1),
 (9,9,8,7,6,5,4,3,2,1,1,1,1,1,1,1),
 (9,9,8,7,7,6,5,3,2,1,1,1,1,1,1,1),
 (9,9,9,8,7,6,5,4,3,1,1,1,1,1,1,1),
 (9,9,9,9,8,7,5,4,3,2,1,1,1,1,1,1),
 (9,9,9,9,8,7,6,5,4,2,1,1,1,1,1,1),
 {jd}
 (9,9,9,9,6,5,4,3,2,1,1,1,1,1,1,1),
 (9,9,9,9,8,6,5,4,3,2,1,1,1,1,1,1),
 {md}
 (9,9,8,7,6,6,5,4,2,1,1,1,1,1,1,1),
 (9,9,8,7,6,5,4,3,2,1,1,1,1,1,1,1),
 (9,9,9,8,7,6,5,4,3,2,1,1,1,1,1,1),
 {dg}
 (9,9,9,9,9,9,9,9,5,5,5,5,5,5,4,3),
 {bk}
 (9,9,9,8,7,6,5,4,3,1,1,1,1,1,1,1),
 (9,9,9,8,7,6,5,4,3,1,1,1,1,1,1,1),
 (9,9,9,8,7,6,5,4,3,2,1,1,1,1,1,1),
 (9,9,9,8,7,6,5,4,3,2,1,1,1,1,1,1),
 (9,9,9,8,7,6,6,5,4,3,2,1,1,1,1,1),
 (9,9,9,9,8,7,6,5,4,3,2,1,1,1,1,1),
 (9,9,9,9,9,7,6,6,5,3,2,1,1,1,1,1),
 {DB}
 (9,8,7,7,6,5,4,3,2,1,1,1,1,1,1,1),
 (9,8,7,7,6,5,4,3,2,1,1,1,1,1,1,1),
 (9,8,7,7,6,5,4,3,2,1,1,1,1,1,1,1),
 (9,9,8,7,6,5,5,4,2,1,1,1,1,1,1,1),
 (9,9,8,7,7,6,5,4,2,1,1,1,1,1,1,1),
 (9,9,9,8,7,6,5,4,3,1,1,1,1,1,1,1),
 (9,9,9,9,8,7,6,5,3,2,1,1,1,1,1,1),
 {JS}
 (3,3,3,3,3,3,3,3,2,2,1,1,1,1,1,1),
 {OL}
 (5,5,5,5,5,5,4,3,2,2,1,1,1,1,1,1),
 {br,os}
 (3,3,3,3,3,3,2,1,1,1,1,1,1,1,1,1),
 {ak}
 (9,9,9,8,7,7,6,5,1,1,1,1,1,1,1,1),
 (9,8,8,7,6,6,5,4,1,1,1,1,1,1,1,1),
 {to}
 (9,9,9,9,9,9,9,9,8,7,6,1,1,1,1,1),
 {hb}
 (9,9,8,7,6,4,2,1,1,1,1,1,1,1,1,1),
 (9,9,8,6,5,3,2,1,1,1,1,1,1,1,1,1));

function bezKury(V:integer;drevSt:string):integer;
 begin
  if jehlicnan(DrevSt) then
   begin
    result:= round(V*0.90909);
   end
  else
   begin
    result:= round(V*0.86956);
   end;
 end;

function bezKuryFloat(V:double;drevSt:string):double;
 begin
  if jehlicnan(DrevSt) then
   begin
    result:= V*0.90909;
   end
  else
   begin
    result:= V*0.86956;
   end;
 end;

function ZkrOchrPrirDleZvlSt(iZvlSt:integer; Var vZona:integer):string;
 begin
  result:='';
  vZona:=0;
  case izvlSt of
     1:Begin result:='NP'; vZona:=0; end;
     2:Begin result:='NP'; vZona:=1; end;
     3:Begin result:='NP'; vZona:=2; end;
     4:Begin result:='NP'; vZona:=3; end;

     5:Begin result:='CHKO';  vZona:=0 ; end;
     6:Begin result:='CHKO';  vZona:=1 ; end;
     7:Begin result:='CHKO';  vZona:=2 ; end;
     8:Begin result:='CHKO';  vZona:=3 ; end;

    10:result:='NPR';
    11:result:='PR';
    12:result:='NPP';
    13:result:='PP';
    55:result:='EVL';
    56:result:='PO';
    57:result:='SCHU';
   end; //case
 end;

function ZvlStDleZkrOchrPrir(ZkrOchrS:string):integer;
 begin
    ZkrOchrS:=ubm(uppercase(ZkrOchrS));
    if ZkrOchrS='' then result:=0
                   else result:=999;
     if ZkrOchrS='NP_Z' then result:=2;
     if ZkrOchrS='NP' then result:=1;
     if ZkrOchrS='CHKO_Z' then result:=6;
     if ZkrOchrS='CHKO' then result:=5;
     if ZkrOchrS='NPR' then result:=10;
    if ZkrOchrS='PR' then result:=11;
    if ZkrOchrS='NPP' then result:=12;
    if ZkrOchrS='PP' then result:=13;
    if ZkrOchrS='EVL' then result:=55;
    if ZkrOchrS='PO' then result:=56;
    if ZkrOchrS='SCHU' then result:=57;
 end;

function SKurou(V:integer;drevSt:string):integer;
 begin
  if jehlicnan(DrevSt) then
   begin
    result:= round(V/0.90909);
   end
  else
   begin
    result:= round(V/0.86956);
   end;
 end;

function Jehlicnan(drevSt:string):boolean;
var drev:Bonita.drevina;
 begin
  drev:=prev_dr(DrevSt);
  result:=false;
  case drev of
   sm,bo,md,jd,dg: result:=true;
  end;{case}
 end;

function ZAbsNaRelSchwVyhl295r95Nepouzivat(drevSt:string;vek,AVB:Integer):integer;
// definitvne zruseno v taxu 2012
// vyhl ocen 295/95Sb a stadard 2010

var drev:Bonita.drevina;
    Ivek,IAvb:Integer;
 begin
  drev:=prev_dr(DrevSt);
  if (drev=ker)or(drev=neni) then
   begin
    result:=0;
    exit;
   end;
  if trim(DrevSt)='OS' then
   begin
    drev:=br;
   end;
  Iavb:=(avb-8)div 2;
  IVek:=0;
  case drev of
   sm:begin
       if (vek<=20)              then IVek:=1;
       if (vek>20) and(vek<=40)  then IVek:=2;
       if (vek>40) and(vek<=60)  then IVek:=3;
       if (vek>60) and(vek<=80)  then IVek:=4;
       if (vek>80) and(vek<=100) then IVek:=5;
       if (vek>100)and(vek<=120) then IVek:=6;
       if (vek>120)              then IVek:=7;
      end;
   bo:begin
       if (vek<=20)              then IVek:=8;
       if (vek>20) and(vek<=40)  then IVek:=9;
       if (vek>40) and(vek<=60)  then IVek:=10;
       if (vek>60) and(vek<=80)  then IVek:=11;
       if (vek>80) and(vek<=100) then IVek:=12;
       if (vek>100)and(vek<=120) then IVek:=13;
       if (vek>120)              then IVek:=14;
      end;
   jd:begin
       if (vek<=50)              then IVek:=15;
       if (vek>50)               then IVek:=16;
      end;
   md:begin
       if (vek<=50)              then IVek:=17;
       if (vek>50) and(vek<=90)  then IVek:=18;
       if (vek> 90)              then IVek:=19;
      end;
   dg:begin
                                      IVek:=20;
      end;

   bk:begin
       // opraveno 9.8.2011  byla tam chyba
       if (vek<=20)               then IVek:=21;//22;
       if (vek>20) and (vek<=40)  then IVek:=22;//23;
       if (vek>40) and (vek<=60)  then IVek:=23;//24;
       if (vek>60) and (vek<=80)  then IVek:=24;//25;
       if (vek>80) and (vek<=100) then IVek:=25;//26;
       if (vek>100)and (vek<=120) then IVek:=26;//27;
       if (vek>120)               then IVek:=27;//28;
      end;
  dbz:begin
       // opraveno 9.8.2011 byla tam chyba
       if (vek<=20)              then IVek:=28;//29;
       if (vek>20) and(vek<=40)  then IVek:=29;//30;
       if (vek>40) and(vek<=60)  then IVek:=30;//31;
       if (vek>60) and(vek<=80)  then IVek:=31;//32;
       if (vek>80) and(vek<=100) then IVek:=32;//33;
       if (vek>100)and(vek<=120) then IVek:=33;//34;
       if (vek>120)              then IVek:=34;//35;
      end;
   js:begin
                                      IVek:=35;
      end;
   ol:begin
                                      IVek:=36;
      end;
   br:begin
                                      IVek:=37;
      end;
   ak:begin
       if (vek<=50)              then IVek:=38;
       if (vek>50)               then IVek:=39;
      end;
   tp:begin
                                      IVek:=40;
      end;
   hb:begin
       if (vek<=50)              then IVek:=41;
       if (vek>50)               then IVek:=42;
      end;
  end;
  if (IAvb>16)or(IAvb<1)or(IVek=0) then result:=0
  else result:=Pole_ABS_na_REL[IVek,IAvb];
 end;

function ZAbsNaRelSchwVyhl2008(drevSt:string;vek,AVB:Integer):integer;
// je to z Vyhlky Ministerstva financ R . 3/2008 Sb., kterou se provdj nkter ustanoven zkona . 151/1997 Sb., o oceovn majetku a o zmn nkterch zkon (zkon o oceovn majetku), ve znn vyhlky . 456/2008 Sb.)
var drev:Bonita.drevina;
    Ivek,IAvb:Integer;
 begin
  drev:=prev_dr(DrevSt);
{  if (drev=ker)or(drev=neni) then
   begin
    result:=0;
    exit;
   end;  Nahrazeno 2.2.2012 // pokud nechceme u keru bonitu, je nutno v TAXu zadavat AVB=0 }

  if (drev=ker)or(drev=neni) then
   begin
    drev:=sm;
   end;
  // konec nahrazen 2.2.2012
  if trim(DrevSt)='OS' then
   begin
    drev:=br;
   end;
  Iavb:=(avb-8)div 2;
  IVek:=0;
  case drev of
   sm:begin
       if (vek<=60)              then IVek:=1;
       if (vek>60)and(vek<=80)   then IVek:=2;
       if (vek>80)               then IVek:=3;
      end;
   bo:begin
       if (vek<=60)              then IVek:=4;
       if (vek>60)and(vek<=80)   then IVek:=5;
       if (vek>80)               then IVek:=6;
      end;
   jd:begin
       if (vek<=50)              then IVek:=7;
       if (vek>50)               then IVek:=8;
      end;
   md:begin
       if (vek<=50)              then IVek:=9;
       if (vek>50)               then IVek:=10;
      end;
   dg:begin
                                      IVek:=11;
      end;
   bk:begin
       if (vek<=80)              then IVek:=12;
       if (vek>80)               then IVek:=13;
      end;
   dbz:begin
       if (vek<=60)            then   IVek:=14;
       if (vek>60)and(vek<=80) then   IVek:=15;
       if (vek>80)             then   IVek:=16;
      end;
   js:begin
                                      IVek:=17;
      end;
   ol:begin
                                      IVek:=18;
      end;
   br:begin
                                      IVek:=19;
      end;
{ osika nen, potm ji jako bzu
   os:begin
                                      IVek:=20;
      end;  }
   ak:begin
       if (vek<=50)              then IVek:=21;
       if (vek>50)               then IVek:=22;
      end;
   tp:begin
                                      IVek:=23;
      end;
   hb:begin
       if (vek<=50)              then IVek:=24;
       if (vek>50)               then IVek:=25;
      end;
  end;
  if (IAvb>16)or(IAvb<1)or(IVek=0) then result:=0
  else result:=Pole_ABS_na_RELVyhl2008[IVek,IAvb];
 end;
function TCiselnik.GetTb_LTClass:TDatabaseClass;
 begin
  if FTb_LTClass=nil then
   begin
    FTb_LTClass:=TDatabaseClass.create;
    FTb_LTClass.DataSourceType:=dstTable;
    FTb_LTClass.DataSourcePath:=TTable(FTb_LT).DatabaseName;
    FTb_LTClass.DataSource:=TTable(FTb_LT).tableName;
    FTb_LTClass.AdressField:='KOD';
    FTb_LTClass.NameField:='KOD';
    FTb_LTClass.Name:='LT';
    AddElement(FTb_LTClass);
   end;
  result:=FTb_LTClass;
 end;

function TCiselnik.GetTb_SLTClass:TDatabaseClass;
 begin
  if FTb_SLTClass=nil then
   begin
    FTb_SLTClass:=TDatabaseClass.create;
    FTb_SLTClass.DataSourceType:=dstTable;
    FTb_SLTClass.DataSourcePath:=TTable(FTb_SLT).DatabaseName;
    FTb_SLTClass.DataSource:=TTable(FTb_SLT).tableName;
    FTb_SLTClass.AdressField:='KOD';
    FTb_SLTClass.NameField:='KOD';
    FTb_SLTClass.Name:='SLT';
    AddElement(FTb_SLTClass);
   end;
  result:=FTb_SLTClass;
 end;

function TCiselnik.GetTb_KTGClass:TDatabaseClass;
 begin
  if FTb_KTGClass=nil then
   begin
    FTb_KTGClass:=TDatabaseClass.create;
    FTb_KTGClass.DataSourceType:=dstTable;
    FTb_KTGClass.DataSourcePath:=TTable(FTb_KTG).DatabaseName;
    FTb_KTGClass.DataSource:=TTable(FTb_KTG).tableName;
    FTb_KTGClass.AdressField:='KOD';
    FTb_KTGClass.NameField:='KOD';
    FTb_KTGClass.Name:='KATEGORIE';
    AddElement(FTb_KTGClass);
   end;
  result:=FTb_KTGClass;
 end;

function TCiselnik.GetTb_NalClass:TDatabaseClass;
 begin
  if FTb_NalClass=nil then
   begin
    FTb_NalClass:=TDatabaseClass.create;
    FTb_NalClass.DataSourceType:=dstTable;
    FTb_NalClass.DataSourcePath:=TTable(FTb_Nal).DatabaseName;
    FTb_NalClass.DataSource:=TTable(FTb_Nal).tableName;
    FTb_NalClass.AdressField:='KOD';
    FTb_NalClass.NameField:='KOD';
    FTb_NalClass.Name:='NALEHAVOST';
    AddElement(FTb_NalClass);
   end;
  result:=FTb_NalClass;
 end;

function TCiselnik.GetTb_TvarClass:TDatabaseClass;
 begin
  if FTb_TvarClass=nil then
   begin
    FTb_TvarClass:=TDatabaseClass.create;
    FTb_TvarClass.DataSourceType:=dstTable;
    FTb_TvarClass.DataSourcePath:=TTable(FTb_Tvar).DatabaseName;
    FTb_TvarClass.DataSource:=TTable(FTb_Tvar).tableName;
    FTb_TvarClass.AdressField:='KOD';
    FTb_TvarClass.NameField:='KOD';
    FTb_TvarClass.Name:='HOSP_TV';
    AddElement(FTb_TvarClass);
   end;
  result:=FTb_TvarClass;
 end;

function TCiselnik.GetTb_HZClass:TDatabaseClass;
 begin
  if FTb_HZClass=nil then
   begin
    FTb_HZClass:=TDatabaseClass.create;
    FTb_HZClass.DataSourceType:=dstTable;
    FTb_HZClass.DataSourcePath:=TTable(FTb_HZ).DatabaseName;
    FTb_HZClass.DataSource:=TTable(FTb_HZ).tableName;
    FTb_HZClass.AdressField:='KOD';
    FTb_HZClass.NameField:='KOD';
    FTb_HZClass.Name:='HOSP_ZP';
    AddElement(FTb_HZClass);  
   end;
  result:=FTb_HZClass;
 end;
function TCiselnik.GetTb_ZJZClass:TDatabaseClass;
 begin
  if FTb_ZJZClass=nil then
   begin
    FTb_ZJZClass:=TDatabaseClass.create;
    FTb_ZJZClass.DataSourceType:=dstTable;
    FTb_ZJZClass.DataSourcePath:=TTable(FTb_ZJZ).DatabaseName;
    FTb_ZJZClass.DataSource:=TTable(FTb_ZJZ).tableName;
    FTb_ZJZClass.AdressField:='KOD';
    FTb_ZJZClass.NameField:='KOD';
    FTb_ZJZClass.Name:='ZJZ';
    AddElement(FTb_ZJZClass);
   end;
  result:=FTb_ZJZClass;
 end;

function TCiselnik.GetTb_ZVL_StatClass:TDatabaseClass;
 begin
  if FTb_ZVL_StatClass=nil then
   begin
    FTb_ZVL_StatClass:=TDatabaseClass.create;
    FTb_ZVL_StatClass.DataSourceType:=dstTable;
    FTb_ZVL_StatClass.DataSourcePath:=TTable(FTb_ZVL_Stat).DatabaseName;
    FTb_ZVL_StatClass.DataSource:=TTable(FTb_ZVL_Stat).tableName;
    FTb_ZVL_StatClass.AdressField:='KOD';
    FTb_ZVL_StatClass.NameField:='KOD';
    FTb_ZVL_StatClass.Name:='ZVL_STATUT';
    AddElement(FTb_ZVL_StatClass);
   end;
  result:=FTb_ZVL_StatClass;
 end;

function TCiselnik.GetTb_ZVL_StatZkrClass:TDatabaseClass;
 begin
  if FTb_ZVL_StatZkrClass=nil then
   begin
    FTb_ZVL_StatZkrClass:=TDatabaseClass.create;
    FTb_ZVL_StatZkrClass.DataSourceType:=dstTable;
    FTb_ZVL_StatZkrClass.DataSourcePath:=TTable(FTb_ZVL_StatZkr).DatabaseName;
    FTb_ZVL_StatZkrClass.DataSource:=TTable(FTb_ZVL_StatZkr).tableName;
    FTb_ZVL_StatZkrClass.AdressField:='KOD';
    FTb_ZVL_StatZkrClass.NameField:='KOD';
    FTb_ZVL_StatZkrClass.Name:='ZVL_STATUT';
    AddElement(FTb_ZVL_StatZkrClass);
   end;
  result:=FTb_ZVL_StatZkrClass;
 end;

function TCiselnik.GetTb_Druh_vlaClass:TDatabaseClass;
 begin
  if FTb_Druh_vlaClass=nil then
   begin
    FTb_Druh_vlaClass:=TDatabaseClass.create;
    FTb_Druh_vlaClass.DataSourceType:=dstTable;
    FTb_Druh_vlaClass.DataSourcePath:=TTable(FTb_Druh_vla).DatabaseName;
    FTb_Druh_vlaClass.DataSource:=TTable(FTb_Druh_vla).tableName;
    FTb_Druh_vlaClass.AdressField:='KOD';
    FTb_Druh_vlaClass.NameField:='KOD';
    FTb_Druh_vlaClass.Name:='DRUH_VLAST';
    AddElement(FTb_Druh_vlaClass);
   end;
  result:=FTb_Druh_vlaClass;
 end;

function TCiselnik.GetTb_RustTabClass:TDatabaseClass;
 begin
  if FTb_RustTabClass=nil then
   begin
    FTb_RustTabClass:=TDatabaseClass.create;
    FTb_RustTabClass.DataSourceType:=dstTable;
    FTb_RustTabClass.DataSourcePath:=TTable(FTb_RustTab).DatabaseName;
    FTb_RustTabClass.DataSource:=TTable(FTb_RustTab).tableName;
    //FTb_RustTabClass.AdressField:='KOD';
    //FTb_RustTabClass.NameField:='KOD';
    // FTb_RustTabClass.Name:='DRUH_VLAST';
    AddElement(FTb_RustTabClass);
   end;
  result:=FTb_RustTabClass;
 end;


function TCiselnik.GetTb_PaOhClass:TDatabaseClass;
 begin
  if FTb_PaOhClass=nil then
   begin
    FTb_PaOhClass:=TDatabaseClass.create;
    FTb_PaOhClass.DataSourceType:=dstTable;
    FTb_PaOhClass.DataSourcePath:=TTable(FTb_PaOh).DatabaseName;
    FTb_PaOhClass.DataSource:=TTable(FTb_PaOh).tableName;
    FTb_PaOhClass.AdressField:='KOD';
    FTb_PaOhClass.NameField:='KOD';
    FTb_PaOhClass.Name:='PASMA_OHR';
    AddElement(FTb_PaOhClass);
   end;
  result:=FTb_PaOhClass;
 end;

 function TCiselnik.GetTb_LeOb99Class:TDatabaseClass;
 begin
  if FTb_LeOb99Class=nil then
   begin
    FTb_LeOb99Class:=TDatabaseClass.create;
    FTb_LeOb99Class.DataSourceType:=dstTable;
    FTb_LeOb99Class.DataSourcePath:=TTable(FTb_LeOb99).DatabaseName;
    FTb_LeOb99Class.DataSource:=TTable(FTb_LeOb99).tableName;
    FTb_LeOb99Class.AdressField:='KOD';
    FTb_LeOb99Class.NameField:='KOD';
    FTb_LeOb99Class.Name:='LES_OBL';
    AddElement(FTb_LeOb99Class);
   end;
  result:=FTb_LeOb99Class;
 end;

 function TCiselnik.GetTb_LeOb98Class:TDatabaseClass;
 begin
  if FTb_LeOb98Class=nil then
   begin
    FTb_LeOb98Class:=TDatabaseClass.create;
    FTb_LeOb98Class.DataSourceType:=dstTable;
    FTb_LeOb98Class.DataSourcePath:=TTable(FTb_LeOb98).DatabaseName;
    FTb_LeOb98Class.DataSource:=TTable(FTb_LeOb98).tableName;
    FTb_LeOb98Class.AdressField:='KOD';
    FTb_LeOb98Class.NameField:='KOD';
    FTb_LeOb98Class.Name:='LES_OBL';
    AddElement(FTb_LeOb98Class);
   end;
  result:=FTb_LeOb98Class;
 end;

 function TCiselnik.GetTb_PodobClass:TDatabaseClass;
 begin
  if FTb_PodobClass=nil then
   begin
    FTb_PodobClass:=TDatabaseClass.create;
    FTb_PodobClass.DataSourceType:=dstTable;
    FTb_PodobClass.DataSourcePath:=TTable(FTb_Podob).DatabaseName;
    FTb_PodobClass.DataSource:=TTable(FTb_Podob).tableName;
    FTb_PodobClass.AdressField:='KOD';
    FTb_PodobClass.NameField:='KOD';
    FTb_PodobClass.Name:='LES_OBL';
    AddElement(FTb_PodobClass);
   end;
  result:=FTb_PodobClass;
 end;

 function TCiselnik.GetTb_Sdr_porClass:TDatabaseClass;
 begin
  if FTb_Sdr_porClass=nil then
   begin
    FTb_Sdr_porClass:=TDatabaseClass.create;
    FTb_Sdr_porClass.DataSourceType:=dstTable;
    FTb_Sdr_porClass.DataSourcePath:=TTable(FTb_Sdr_por).DatabaseName;
    FTb_Sdr_porClass.DataSource:=TTable(FTb_Sdr_por).tableName;
    FTb_Sdr_porClass.AdressField:='KOD';
    FTb_Sdr_porClass.NameField:='KOD';
    FTb_Sdr_porClass.Name:='Sdr_Por';
    AddElement(FTb_Sdr_porClass);
   end;
  result:=FTb_Sdr_porClass;
 end;

function TCiselnik.GetTb_Druh_pozClass:TDatabaseClass;
 begin
  if FTb_Druh_pozClass=nil then
   begin
    FTb_Druh_pozClass:=TDatabaseClass.create;
    FTb_Druh_pozClass.DataSourceType:=dstTable;
    FTb_Druh_pozClass.DataSourcePath:=TTable(FTb_Druh_poz).DatabaseName;
    FTb_Druh_pozClass.DataSource:=TTable(FTb_Druh_poz).tableName;
    FTb_Druh_pozClass.AdressField:='KOD';
    FTb_Druh_pozClass.NameField:='KOD';
    FTb_Druh_pozClass.Name:='DRUH_POZ';
    AddElement(FTb_Druh_pozClass);
   end;
  result:=FTb_Druh_pozClass;
 end;

function TCiselnik.GetTb_BiotopClass:TDatabaseClass;
 begin
  if FTb_BiotopClass=nil then
   begin
    FTb_BiotopClass:=TDatabaseClass.create;
    FTb_BiotopClass.DataSourceType:=dstTable;
    FTb_BiotopClass.DataSourcePath:=TTable(FTb_Biotop).DatabaseName;
    FTb_BiotopClass.DataSource:=TTable(FTb_Biotop).tableName;
    FTb_BiotopClass.AdressField:='KOD';
    FTb_BiotopClass.NameField:='KOD';
    FTb_BiotopClass.Name:='popis';
    AddElement(FTb_BiotopClass);
   end;
  result:=FTb_BiotopClass;
 end;

 function TCiselnik.GetTb_Pot_vlaClass:TDatabaseClass;
 begin
  if FTb_Pot_vlaClass=nil then
   begin
    FTb_Pot_vlaClass:=TDatabaseClass.create;
    FTb_Pot_vlaClass.DataSourceType:=dstTable;
    FTb_Pot_vlaClass.DataSourcePath:=TTable(FTb_Pot_vla).DatabaseName;
    FTb_Pot_vlaClass.DataSource:=TTable(FTb_Pot_vla).tableName;
    FTb_Pot_vlaClass.AdressField:='KOD';
    FTb_Pot_vlaClass.NameField:='KOD';
    FTb_Pot_VlaClass.Name:='Pot_Vla';
    AddElement(FTb_Pot_vlaClass);
   end;
  result:=FTb_Pot_vlaClass;
 end;

function TCiselnik.GetTb_TetyClass:TDatabaseClass;
 begin
  if FTb_TetyClass=nil then
   begin
    FTb_TetyClass:=TDatabaseClass.create;
    FTb_TetyClass.DataSourceType:=dstTable;
    FTb_TetyClass.DataSourcePath:=TTable(FTb_Tety1).DatabaseName;
    FTb_TetyClass.DataSource:=TTable(FTb_Tety1).tableName;
    FTb_TetyClass.AdressField:='KOD';
    FTb_TetyClass.NameField:='KOD';
    FTb_TeTyClass.Name:='TER_TYPY';
    AddElement(FTb_TetyClass);
   end;
  result:=FTb_TetyClass;
 end;

function TCiselnik.GetTb_TypManagClass:TDatabaseClass;
 begin
  if FTb_TypManagClass=nil then
   begin
    FTb_TypManagClass:=TDatabaseClass.create;
    FTb_TypManagClass.DataSourceType:=dstTable;
    FTb_TypManagClass.DataSourcePath:=TTable(FTb_Tety1).DatabaseName;
    FTb_TypManagClass.DataSource:=TTable(FTb_Tety1).tableName;
    FTb_TypManagClass.AdressField:='KOD';
    FTb_TypManagClass.NameField:='KOD';
    FTb_TypManagClass.Name:='TypManag';
    AddElement(FTb_TypManagClass);
   end;
  result:=FTb_TypManagClass;
 end;


 function TCiselnik.GetTb_LDUClass:TDatabaseClass;
 begin
  if FTb_LDUClass=nil then
   begin
    FTb_LDUClass:=TDatabaseClass.create;
    FTb_LDUClass.DataSourceType:=dstTable;
    FTb_LDUClass.DataSourcePath:=TTable(FTb_LDU).DatabaseName;
    FTb_LDUClass.DataSource:=TTable(FTb_LDU).tableName;
    FTb_LDUClass.AdressField:='KOD';
    FTb_LDUClass.NameField:='KOD';
    FTb_LDUClass.Name:='LES_URADY';
    AddElement(FTb_LDUClass);
   end;
  result:=FTb_LDUClass;
 end;

 function TCiselnik.GetTb_Kval_PClass:TDatabaseClass;
 begin
  if FTb_Kval_PClass=nil then
   begin
    FTb_Kval_PClass:=TDatabaseClass.create;
    FTb_Kval_PClass.DataSourceType:=dstTable;
    FTb_Kval_PClass.DataSourcePath:=TTable(FTb_Kval_P).DatabaseName;
    FTb_Kval_PClass.DataSource:=TTable(FTb_Kval_P).tableName;
    FTb_Kval_PClass.AdressField:='KOD';
    FTb_Kval_PClass.NameField:='KOD';
    FTb_Kval_PClass.Name:='KVAL_P';
    AddElement(FTb_Kval_PClass);
   end;
  result:=FTb_Kval_PClass;
 end;

 function TCiselnik.GetTb_Duv_tezbClass:TDatabaseClass;
 begin
  if FTb_Duv_tezbClass=nil then
   begin
    FTb_Duv_tezbClass:=TDatabaseClass.create;
    FTb_Duv_tezbClass.DataSourceType:=dstTable;
    FTb_Duv_tezbClass.DataSourcePath:=TTable(FTb_Duv_tezb).DatabaseName;
    FTb_Duv_tezbClass.DataSource:=TTable(FTb_Duv_tezb).tableName;
    FTb_Duv_tezbClass.AdressField:='KOD';
    FTb_Duv_tezbClass.NameField:='KOD';
    FTb_Duv_tezbClass.Name:='DUV_TEZBY';
    AddElement(FTb_Duv_tezbClass);
   end;
  result:=FTb_Duv_tezbClass;
 end;
 function TCiselnik.GetTb_Druh_zalClass:TDatabaseClass;
 begin
  if FTb_Druh_zalClass=nil then
   begin
    FTb_Druh_zalClass:=TDatabaseClass.create;
    FTb_Druh_zalClass.DataSourceType:=dstTable;
    FTb_Druh_zalClass.DataSourcePath:=TTable(FTb_Druh_zal).DatabaseName;
    FTb_Druh_zalClass.DataSource:=TTable(FTb_Druh_zal).tableName;
    FTb_Druh_zalClass.AdressField:='KOD';
    FTb_Druh_zalClass.NameField:='KOD';
    FTb_Druh_zalClass.Name:='DRUH_ZAL';
    AddElement(FTb_Druh_zalClass);
   end;
  result:=FTb_Druh_zalClass;
 end;
function TCiselnik.GetTb_DanClass:TDatabaseClass;
 begin
  if FTb_DanClass=nil then
   begin
    FTb_DanClass:=TDatabaseClass.create;
    FTb_DanClass.DataSourceType:=dstTable;
    FTb_DanClass.DataSourcePath:=TTable(FTb_Dan).DatabaseName;
    FTb_DanClass.DataSource:=TTable(FTb_Dan).tableName;
    FTb_DanClass.AdressField:='KOD';
    FTb_DanClass.NameField:='KOD';
    FTb_DanClass.Name:='Dan';
    AddElement(FTb_DanClass);
   end;
  result:=FTb_DanClass;
 end;
function TCiselnik.GetTb_KatastryClass:TDatabaseClass;
 begin
  if FTb_KatastryClass=nil then
   begin
    FTb_KatastryClass:=TDatabaseClass.create;
    FTb_KatastryClass.DataSourceType:=dstTable;
    FTb_KatastryClass.DataSourcePath:=TTable(FTb_Katastry).DatabaseName;
    FTb_KatastryClass.DataSource:=TTable(FTb_Katastry).tableName;
    FTb_KatastryClass.AdressField:='KOD';
    FTb_KatastryClass.NameField:='KOD';
    FTb_KatastryClass.Name:='Katastry';
    AddElement(FTb_KatastryClass);
   end;
  result:=FTb_KatastryClass;
 end;
function TCiselnik.GetTb_OLHClass:TDatabaseClass;
 begin
  if FTb_OLHClass=nil then
   begin
    FTb_OLHClass:=TDatabaseClass.create;
    FTb_OLHClass.DataSourceType:=dstTable;
    FTb_OLHClass.DataSourcePath:=TTable(FTb_OLH).DatabaseName;
    FTb_OLHClass.DataSource:=TTable(FTb_OLH).tableName;
    FTb_OLHClass.AdressField:='KOD';
    FTb_OLHClass.NameField:='KOD';
    FTb_OLHClass.Name:='OLH';
    AddElement(FTb_OLHClass);
   end;
  result:=FTb_OLHClass;
 end;
function TCiselnik.GetTb_GenKLClass:TDatabaseClass;
 begin
  if FTb_GenKLClass=nil then
   begin
    FTb_GenKLClass:=TDatabaseClass.create;
    FTb_GenKLClass.DataSourceType:=dstTable;
    FTb_GenKLClass.DataSourcePath:=TTable(FTb_GenKL).DatabaseName;
    FTb_GenKLClass.DataSource:=TTable(FTb_GenKL).tableName;
    FTb_GenKLClass.AdressField:='KOD';
    FTb_GenKLClass.NameField:='KOD';
    FTb_GenKLClass.Name:='GEN_KLAS';
    AddElement(FTb_GenKLClass);
   end;
  result:=FTb_GenKLClass;
 end;
function TCiselnik.GetTb_Imise98Class:TDatabaseClass;
 begin
  if FTb_Imise98Class=nil then
   begin
    FTb_Imise98Class:=TDatabaseClass.create;
    FTb_Imise98Class.DataSourceType:=dstTable;
    FTb_Imise98Class.DataSourcePath:=TTable(FTb_Imise98).DatabaseName;
    FTb_Imise98Class.DataSource:=TTable(FTb_Imise98).tableName;
    FTb_Imise98Class.AdressField:='KOD';
    FTb_Imise98Class.NameField:='KOD';
    FTb_Imise98Class.Name:='IMISE';
    AddElement(FTb_Imise98Class);
   end;
  result:=FTb_Imise98Class;
 end;
function TCiselnik.GetTb_Imise99Class:TDatabaseClass;
 begin
  if FTb_Imise99Class=nil then
   begin
    FTb_Imise99Class:=TDatabaseClass.create;
    FTb_Imise99Class.DataSourceType:=dstTable;
    FTb_Imise99Class.DataSourcePath:=TTable(FTb_Imise99).DatabaseName;
    FTb_Imise99Class.DataSource:=TTable(FTb_Imise99).tableName;
    FTb_Imise99Class.AdressField:='KOD';
    FTb_Imise99Class.NameField:='KOD';
    FTb_Imise99Class.Name:='IMISE';
    AddElement(FTb_Imise99Class);
   end;
  result:=FTb_Imise99Class;
 end;

 function TCiselnik.GetTb_PuvodClass:TDatabaseClass;
 begin
  if FTb_puvodClass=nil then
   begin
    FTb_puvodClass:=TDatabaseClass.create;
    FTb_puvodClass.DataSourceType:=dstTable;
    FTb_puvodClass.DataSourcePath:=TTable(FTb_puvod).DatabaseName;
    FTb_puvodClass.DataSource:=TTable(FTb_puvod).tableName;
    FTb_puvodClass.AdressField:='KOD';
    FTb_puvodClass.NameField:='KOD';
    FTb_puvodClass.Name:='PUVOD_DR';
    AddElement(FTb_puvodClass);
   end;
  result:=FTb_puvodClass;
 end;

 function TCiselnik.GetTb_PoskClass:TDatabaseClass;
 begin
  if FTb_PoskClass=nil then
   begin
    FTb_PoskClass:=TDatabaseClass.create;
    FTb_PoskClass.DataSourceType:=dstTable;
    FTb_PoskClass.DataSourcePath:=TTable(FTb_Posk).DatabaseName;
    FTb_PoskClass.DataSource:=TTable(FTb_Posk).tableName;
    FTb_PoskClass.AdressField:='KOD';
    FTb_PoskClass.NameField:='KOD';
    FTb_PoskClass.Name:='SKODY';
    AddElement(FTb_PoskClass);
   end;
  result:=FTb_PoskClass;
 end;


 function TCiselnik.GetTb_OrgUr1Class:TDatabaseClass;
 begin
  if FTb_OrgUr1Class=nil then
   begin
    FTb_OrgUr1Class:=TDatabaseClass.create;
    FTb_OrgUr1Class.DataSourceType:=dstTable;
    FTb_OrgUr1Class.DataSourcePath:=TTable(FTb_OrgUr1).DatabaseName;
    FTb_OrgUr1Class.DataSource:=TTable(FTb_OrgUr1).tableName;
    FTb_OrgUr1Class.AdressField:='KOD';
    FTb_OrgUr1Class.NameField:='KOD';
    FTb_OrgUr1Class.Name:='OrgUr1';
    AddElement(FTb_OrgUr1Class);
   end;
  result:=FTb_OrgUr1Class;
 end;

function TCiselnik.GetTb_Cis_JineClass:TDatabaseClass;
 begin
  if FTb_Cis_JineClass=nil then
   begin
    FTb_Cis_JineClass:=TDatabaseClass.create;
    FTb_Cis_JineClass.DataSourceType:=dstTable;
    FTb_Cis_JineClass.DataSourcePath:=TTable(FTb_Cis_Jine).DatabaseName;
    FTb_Cis_JineClass.DataSource:=TTable(FTb_Cis_Jine).tableName;
    FTb_Cis_JineClass.AdressField:='KOD';
    FTb_Cis_JineClass.NameField:='KOD';
    FTb_Cis_JineClass.Name:='Cis_Jine';
    AddElement(FTb_Cis_JineClass);
   end;
  result:=FTb_Cis_JineClass;
 end;

procedure vypORPPoStaru(KU6:longint; TbKU6,tbObce6:TTable; var ORP:longint);
begin
 // showmessage('cau '+TbKU6.TableName+'  '+tbObce6.TableName);

 with TbKU6 do
  begin
   EditKey;
   FieldByName('KODKU6').AsInteger :=KU6;
   GotoNearest;
   // showmessage(TbKU6.TableName+'cau NAZKU='+FieldByName('NAZKU').Asstring);
   // showmessage(TbKU6.TableName+'cau KODOB='+FieldByName('KODOB').Asstring);
  end;
 if tbObce6.FieldByName('KODOB').Asstring=tbKU6.FieldByName('KODOB').Asstring then
  begin
   ORP:=tbObce6.FieldByName('CISORP').asinteger+200000;
  end
 else
  begin
   with tbObce6 do
    begin
     EditKey;
     FieldByName('KODOB').Asstring:=tbKU6.FieldByName('KODOB').Asstring;
     GotoNearest;
    end;
 // showmessage(TbObce6.TableName+'cau KODOB='  +tbObce6.FieldByName('KODOB').Asstring);
 // showmessage(TbObce6.TableName+'cau CISORP=' +tbObce6.FieldByName('CISORP').Asstring);

  if tbObce6.FieldByName('KODOB').Asstring=tbKU6.FieldByName('KODOB').Asstring then
    begin
     // showmessage(TbObce6.TableName+'  cau KODOB='+tbKU6.FieldByName('KODOB').Asstring);
     ORP:=tbObce6.FieldByName('CISORP').asinteger+200000;
    end
   else
    begin
     ORP:=0;
    end;
  end;
 // showmessage(inttostr(ORP));
end;


procedure TCiselnik.VypORP(KU_KOD6:longint; var ORP:longint);

Var
  S_Orp,S_KU_KOD6:string;
begin
  if tb_KuOrpKraj<>nil then
   begin
    S_KU_KOD6:=inttostr(KU_KOD6);
    S_ORP:=DleCiselniku(tb_KuOrpKraj,'KU_KOD',S_KU_KOD6, 'ORP',false);
    ORP:=Strtoint0(S_ORP)+200000;
   end
  else
   begin
    vypORPpoStaru(KU_KOD6,Tb_KU6b,tbObce6,ORP);
   end
 end;

function TCiselnik.GetTb_Cis_OstClass:TDatabaseClass;
 begin
  if FTb_Cis_ostClass=nil then
   begin
    FTb_Cis_ostClass:=TDatabaseClass.create;
    FTb_Cis_ostClass.DataSourceType:=dstTable;
    FTb_Cis_ostClass.DataSourcePath:=TTable(FTb_Cis_ost).DatabaseName;
    FTb_Cis_ostClass.DataSource:=TTable(FTb_Cis_ost).tableName;
    FTb_Cis_ostClass.AdressField:='KOD';
    FTb_Cis_ostClass.NameField:='KOD';
    FTb_Cis_ostClass.Name:='Cis_ost';
    AddElement(FTb_Cis_ostClass);
   end;
  result:=FTb_Cis_ostClass;
 end;

function TCiselnik.GetTb_Cis_BezlClass:TDatabaseClass;
 begin
  if FTb_Cis_bezlClass=nil then
   begin
    FTb_Cis_bezlClass:=TDatabaseClass.create;
    FTb_Cis_bezlClass.DataSourceType:=dstTable;
    FTb_Cis_bezlClass.DataSourcePath:=TTable(FTb_Cis_Bezl).DatabaseName;
    FTb_Cis_bezlClass.DataSource:=TTable(FTb_Cis_Bezl).tableName;
    FTb_Cis_bezlClass.AdressField:='KOD';
    FTb_Cis_bezlClass.NameField:='KOD';
    FTb_Cis_bezlClass.Name:='Cis_bezl';
    AddElement(FTb_Cis_bezlClass);
   end;
  result:=FTb_Cis_bezlClass;
 end;
 function TCiselnik.GetTb_Zp_TEZBYClass:TDatabaseClass;
 begin
  if FTb_Zp_TEZBYClass=nil then
   begin
    FTb_Zp_TEZBYClass:=TDatabaseClass.create;
    FTb_Zp_TEZBYClass.DataSourceType:=dstTable;
    FTb_Zp_TEZBYClass.DataSourcePath:=TTable(FTb_Zp_TEZBY).DatabaseName;
    FTb_Zp_TEZBYClass.DataSource:=TTable(FTb_Zp_TEZBY).tableName;
    FTb_Zp_TEZBYClass.AdressField:='KOD';
    FTb_Zp_TEZBYClass.NameField:='KOD';
    FTb_Zp_TEZBYClass.Name:='Zp_TEZBY';
    AddElement(FTb_Zp_TEZBYClass);
   end;
  result:=FTb_Zp_TEZBYClass;
 end;

 function TCiselnik.GetTb_ODVOZ_TEZClass:TDatabaseClass;
 begin
  if FTb_ODVOZ_TEZClass=nil then
   begin
    FTb_ODVOZ_TEZClass:=TDatabaseClass.create;
    FTb_ODVOZ_TEZClass.DataSourceType:=dstTable;
    FTb_ODVOZ_TEZClass.DataSourcePath:=TTable(FTb_ODVOZ_TEZ).DatabaseName;
    FTb_ODVOZ_TEZClass.DataSource:=TTable(FTb_ODVOZ_TEZ).tableName;
    FTb_ODVOZ_TEZClass.AdressField:='KOD';
    FTb_ODVOZ_TEZClass.NameField:='KOD';
    FTb_ODVOZ_TEZClass.Name:='ODVOZ_TEZ';
    AddElement(FTb_ODVOZ_TEZClass);
   end;
  result:=FTb_ODVOZ_TEZClass;
 end;

 function TCiselnik.GetTb_OrgUr2Class:TDatabaseClass;
 begin
  if FTb_OrgUr2Class=nil then
   begin
    FTb_OrgUr2Class:=TDatabaseClass.create;
    FTb_OrgUr2Class.DataSourceType:=dstTable;
    FTb_OrgUr2Class.DataSourcePath:=TTable(FTb_OrgUr2).DatabaseName;
    FTb_OrgUr2Class.DataSource:=TTable(FTb_OrgUr2).tableName;
    FTb_OrgUr2Class.AdressField:='KOD';
    FTb_OrgUr2Class.NameField:='KOD';
    FTb_OrgUr2Class.Name:='OrgUr2';
    AddElement(FTb_OrgUr2Class);
   end;
  result:=FTb_OrgUr2Class;
 end;

 function TCiselnik.GetTb_OrgUr3Class:TDatabaseClass;
 begin
  if FTb_OrgUr3Class=nil then
   begin
    FTb_OrgUr3Class:=TDatabaseClass.create;
    FTb_OrgUr3Class.DataSourceType:=dstTable;
    FTb_OrgUr3Class.DataSourcePath:=TTable(FTb_OrgUr3).DatabaseName;
    FTb_OrgUr3Class.DataSource:=TTable(FTb_OrgUr3).tableName;
    FTb_OrgUr3Class.AdressField:='KOD';
    FTb_OrgUr3Class.NameField:='KOD';
    FTb_OrgUr3Class.Name:='OrgUr3';
    AddElement(FTb_OrgUr3Class);
   end;
  result:=FTb_OrgUr3Class;
 end;

 function TCiselnik.GetTb_HSClass:TDatabaseClass;
 begin
  if FTb_HSClass=nil then
   begin
    FTb_HSClass:=TDatabaseClass.create;
    FTb_HSClass.DataSourceType:=dstTable;
    FTb_HSClass.DataSourcePath:=TTable(FTb_HS).DatabaseName;
    FTb_HSClass.DataSource:=TTable(FTb_HS).tableName;
    FTb_HSClass.AdressField:='CISLO_HS';
    FTb_HSClass.NameField:='CISLO_HS';
    FTb_HSClass.Name:='HS';
    AddElement(FTb_HSClass);
   end;
  result:=FTb_HSClass;
 end;
 function TCiselnik.GetTb_PorKtgClass:TDatabaseClass;
 begin
  if FTb_PorKtgClass=nil then
   begin
    FTb_PorKtgClass:=TDatabaseClass.create;
    FTb_PorKtgClass.DataSourceType:=dstTable;
    FTb_PorKtgClass.DataSourcePath:=TTable(FTb_PorKtg1).DatabaseName;
    FTb_PorKtgClass.DataSource:=TTable(FTb_PorKtg1).tableName;
    FTb_PorKtgClass.AdressField:='ID';
    FTb_PorKtgClass.NameField:='ID';
    FTb_PorKtgClass.Name:='PorKtg';
    AddElement(FTb_PorKtgClass);
   end;
  result:=FTb_PorKtgClass;
 end;
 function TCiselnik.GetTb_MAjetkyClass:TDatabaseClass;
 begin
  if FTb_MAjetkyClass=nil then
   begin
    FTb_MAjetkyClass:=TDatabaseClass.create;
    FTb_MAjetkyClass.DataSourceType:=dstTable;
    FTb_MAjetkyClass.DataSourcePath:=TTable(FTb_MAjetky).DatabaseName;
    FTb_MAjetkyClass.DataSource:=TTable(FTb_MAjetky).tableName;
    FTb_MAjetkyClass.AdressField:='MAJ_KOD';
    FTb_MAjetkyClass.NameField:='MAJ_KOD';
    FTb_MajetkyClass.Name:='Majetky';
    AddElement(FTb_MAjetkyClass);
   end;
  result:=FTb_MAjetkyClass;
 end;
 function TCiselnik.GetTb_DrevCisClass:TDatabaseClass;
 begin
  if FTb_DrevCisClass=nil then
   begin
    FTb_DrevCisClass:=TDatabaseClass.create;
    FTb_DrevCisClass.DataSourceType:=dstTable;
    FTb_DrevCisClass.DataSourcePath:=TTable(FTb_DrevCis).DatabaseName;
    FTb_DrevCisClass.DataSource:=TTable(FTb_DrevCis).tableName;
    FTb_DrevCisClass.AdressField:='';
    FTb_DrevCisClass.NameField:='CKOD';
    FTb_DrevCisClass.Name:='DREVINY';
    AddElement(FTb_DrevCisClass);
   end;
  result:=FTb_DrevCisClass;
 end;
 function TCiselnik.GetTb_Mel_DrevClass:TDatabaseMel_DrevClass;
 begin
  if FTb_Mel_DrevClass=nil then
   begin
    FTb_Mel_DrevClass:=TDatabaseMel_DrevClass.create;
    FTb_Mel_DrevClass.DataSourceType:=dstTable;
    FTb_Mel_DrevClass.DataSourcePath:=TTable(FTb_Mel_Drev).DatabaseName;
    FTb_Mel_DrevClass.DataSource:=TTable(FTb_Mel_Drev).tableName;
    FTb_Mel_DrevClass.AdressField:='Cislo_HS';
    FTb_Mel_DrevClass.NameField:='Cislo_HS';
    FTb_Mel_DrevClass.Name:='Mel_Drev';
    AddElement(FTb_Mel_DrevClass);
   end;
  result:=FTb_Mel_DrevClass;
 end;


function JeVCiselniku(dtSet:TDataSet;poleHl:string;hodnota:String;zpusobPorovnani:Boolean;
                      PripustitPrazdny:boolean):boolean;
var hl_:TKSekvenFind;
    dtz_:TDatasource;
begin
 if (hodnota='') then
  begin
  if (PripustitPrazdny) then result:=true
    else result:=False ;
   exit;
  end;
 hl_:=TKSekvenFind.create(application.mainform);
 hl_.findStyle:=FromTop;
 DtSet.open;
 dtz_:=TDataSource.create(application.mainform);
 dtz_.dataset:=DtSet;
 hl_.datasource:=dtz_;
 hl_.dataField:=PoleHl;
 result:=hl_.findText(hodnota,zpusobPorovnani);
 hl_.free;
 dtz_.free;
end;

function DleCiselniku(dtSet:TDataSet;
                      poleKtereZname:string;
                      hodnotaPoleKtereZname:String;
                      poleKtereHledameVCiselniku:string;
                      zpusobPorovnani:Boolean):String;
var hl_:TKSekvenFind;
    dtz_:TDatasource;
    s:string;
begin
 // result:='';
 result:='**'+hodnotaPoleKtereZname;
 if dtSet=nil then
  begin
   result:='*zz1*'+hodnotaPoleKtereZname;
   exit;
  end;
 hl_:=TKSekvenFind.create(application.mainform);
 hl_.findStyle:=FromTop;
 DtSet.open;
 dtz_:=TDataSource.create(application.mainform);
 dtz_.dataset:=DtSet;
 hl_.datasource:=dtz_;
 hl_.dataField:=PoleKtereZname;
 try
 s:='i1';
 if (hl_.findText(hodnotaPoleKtereZname,zpusobPorovnani)) then
     begin
 s:='i2';
      Result:=DtSet.fieldByName(poleKtereHledameVCiselniku).asstring;
 s:='i3';
     end
   else
     begin
 s:='i4';
      result:='*zz2*'+hodnotaPoleKtereZname;
 s:='i5';
     end;
 except
  result:=s+'*zz3*'+hodnotaPoleKtereZname;
 end;
 hl_.free;
 dtz_.free;
end;
function zKategorieCislo(st:string):integer;
 begin
  st:=uppercase(st);
  result:=strToInt0(copy(st,1,2))*10;
  if length(st)=3 then
   begin
    result:=result+ord(st[3])-ord('A')+1;
   end;
 end;
function tciselnik.GetTb_LeOb99:TTable;
 begin
  if FTb_LeOb99=nil then
   begin
    if not FTb_LeOb99ZkouselOtevrit then
     begin
      FTb_LeOb99ZkouselOtevrit:=true;
      FTb_LeOb99:=TTable.Create(Application.mainform);
      FTb_LeOb99.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\CisLeOb99.db';
      try
       FTb_LeOb99.open;
      except
       FTb_LeOb99:=nil;
      end;
     end;
   end;
  result:=FTb_LeOb99;
 end;

function tciselnik.GetTb_LeOb98:TTable;
 begin
  if FTb_LeOb98=nil then
   begin
    if not FTb_LeOb98ZkouselOtevrit then
     begin
      FTb_LeOb98ZkouselOtevrit:=true;
      FTb_LeOb98:=TTable.Create(Application.mainform);
      FTb_LeOb98.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Cis_LeOb.db';
      try
       FTb_LeOb98.open;
      except
       FTb_LeOb98:=nil;
      end;
     end;
   end;
  result:=FTb_LeOb98;
 end;

function tciselnik.GetTb_Podob:TTable;
 begin
  if FTb_Podob=nil then
   begin
    if not FTb_PodobZkouselOtevrit then
     begin
      FTb_PodobZkouselOtevrit:=true;
      FTb_Podob:=TTable.Create(Application.mainform);
      FTb_Podob.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Cis_Podob.db';
      try
       FTb_Podob.open;
      except
       FTb_Podob:=nil;
      end;
     end;
   end;
  result:=FTb_Podob;
 end;

function tciselnik.GetTb_LT :TTable;
 begin
  if FTb_LT=nil then
   begin
    if not FTb_LTZkouselOtevrit then
     begin
      FTb_LTZkouselOtevrit:=true;
      FTb_LT:=TTable.Create(Application.mainform);
      FTb_LT.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Cis_LT.db';
      try
       FTb_LT.open;
      except
       FTb_LT:=nil;
      end;
     end;
   end;
  result:=FTb_LT;
 end;
function tciselnik.GetTb_SLT      :TTable;
 begin
  if FTb_SLT=nil then
   begin
    if not FTb_SLTZkouselOtevrit then
     begin
      FTb_SLTZkouselOtevrit:=true;
      FTb_SLT:=TTable.Create(Application.mainform);
      FTb_SLT.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Cis_SLT.db';
      try
       FTb_SLT.open;
      except
       FTb_SLT:=nil;
      end;
     end;
   end;
  result:=FTb_SLT;
 end;
function tciselnik.GetTb_Ktg      :TTable;
 begin
  if FTb_Ktg=nil then
   begin
    if not FTb_KtgZkouselOtevrit then
     begin
      FTb_KtgZkouselOtevrit:=true;
      FTb_Ktg:=TTable.Create(Application.mainform);
      FTb_Ktg.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Kategori.db';
      try
       FTb_Ktg.open;
      except
       FTb_Ktg:=nil;
      end;
     end;
   end;
  result:=FTb_Ktg;
 end;
function tciselnik.Gettb_nal      :TTable;
 begin
  if FTb_nal=nil then
   begin
    if not FTb_nalZkouselOtevrit then
     begin
      FTb_nalZkouselOtevrit:=true;
      FTb_nal:=TTable.Create(Application.mainform);
      FTb_nal.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Cis_nale.db';
      try
       FTb_nal.open;
      except
       FTb_nal:=nil;
      end;
     end;
   end;
  result:=FTb_nal;
 end;

function tciselnik.Gettb_tvar     :TTable;
 begin
  if FTb_tvar=nil then
   begin
    if not FTb_tvarZkouselOtevrit then
     begin
      FTb_tvarZkouselOtevrit:=true;
      FTb_tvar:=TTable.Create(Application.mainform);
      FTb_tvar.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\tvar.db';
      try
       FTb_tvar.open;
      except
       FTb_tvar:=nil;
      end;
     end;
   end;
  result:=FTb_tvar;
 end;
function tciselnik.Gettb_HZ       :TTable;
 begin
  if FTb_HZ=nil then
   begin
    if not FTb_HZZkouselOtevrit then
     begin
      FTb_HZZkouselOtevrit:=true;
      FTb_HZ:=TTable.Create(Application.mainform);
      FTb_HZ.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Zpusob.db';
      try
       FTb_HZ.open;
      except
       FTb_HZ:=nil;
      end;
     end;
   end;
  result:=FTb_HZ;
 end;
function tciselnik.Gettb_ZJZ      :TTable;
 begin
  if FTb_ZJZ=nil then
   begin
    if not FTb_ZJZZkouselOtevrit then
     begin
      FTb_ZJZZkouselOtevrit:=true;
      FTb_ZJZ:=TTable.Create(Application.mainform);
      FTb_ZJZ.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\CIS_ZJZ.DB';
      try
       FTb_ZJZ.open;
      except
       FTb_ZJZ:=nil;
      end;
     end;
   end;
  result:=FTb_ZJZ;
 end;
function tciselnik.Gettb_ZVL_Stat :TTable;
 begin
  if FTb_ZVL_Stat=nil then
   begin
    if not FTb_ZVL_StatZkouselOtevrit then
     begin
      FTb_ZVL_StatZkouselOtevrit:=true;
      FTb_ZVL_Stat:=TTable.Create(Application.mainform);
      FTb_ZVL_Stat.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\ZVL_STAT.DB';
      try
       FTb_ZVL_Stat.open;
      except
       FTb_ZVL_Stat:=nil;
      end;
     end;
   end;
  result:=FTb_ZVL_Stat;
 end;

function tciselnik.Gettb_ZVL_StatZkr :TTable;
 begin
  if FTb_ZVL_StatZkr=nil then
   begin
    if not FTb_ZVL_StatZkrZkouselOtevrit then
     begin
      FTb_ZVL_StatZkrZkouselOtevrit:=true;
      FTb_ZVL_StatZkr:=TTable.Create(Application.mainform);
      if FileExists(KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\ZVL_St_Zkr.DB') then
       begin
        FTb_ZVL_StatZkr.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\ZVL_St_Zkr.DB';
       end
      else
       begin
        FTb_ZVL_StatZkr.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\ZVL_STAT.DB';
       end;
      try
       FTb_ZVL_StatZkr.open;
      except
       FTb_ZVL_StatZkr:=nil;
      end;
     end;
   end;
  result:=FTb_ZVL_StatZkr;
 end;

function tciselnik.Gettb_Druh_vla :TTable;
 begin
  if FTb_Druh_vla=nil then
   begin
    if not FTb_Druh_vlaZkouselOtevrit then
     begin
      FTb_Druh_vlaZkouselOtevrit:=true;
      FTb_Druh_vla:=TTable.Create(Application.mainform);
      FTb_Druh_vla.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\DRUH_VLA.DB';
      try
       FTb_Druh_vla.open;
      except
       FTb_Druh_vla:=nil;
      end;
     end;
   end;
  result:=FTb_Druh_vla;
 end;

function tciselnik.GetTb_RustTab    :TTable;
 begin
  if FTb_RustTab=nil then
   begin
    if not FTb_RustTabZkouselOtevrit then
     begin
      FTb_RustTabZkouselOtevrit:=true;
      FTb_RustTab:=TTable.Create(Application.mainform);
      FTb_RustTab.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\RustTab.DB';
      try
       FTb_RustTab.open;
      except
       FTb_RustTab:=nil;
      end;
     end;
   end;
  result:=FTb_RustTab;
 end;

function tciselnik.Gettb_PaOh     :TTable;
 begin
  if FTb_PaOh=nil then
   begin
    if not FTb_PaOhZkouselOtevrit then
     begin
      FTb_PaOhZkouselOtevrit:=true;
      FTb_PaOh:=TTable.Create(Application.mainform);
      FTb_PaOh.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\CIS_PAOH.DB';
      try
       FTb_PaOh.open;
      except
       FTb_PaOh:=nil;
      end;
     end;
   end;
  result:=FTb_PaOh;
 end;
function tciselnik.Gettb_sdr_por  :TTable;
 begin
  if FTb_sdr_por=nil then
   begin
    if not FTb_sdr_porZkouselOtevrit then
     begin
      FTb_sdr_porZkouselOtevrit:=true;
      FTb_sdr_por:=TTable.Create(Application.mainform);
      FTb_sdr_por.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\SDR_POR.DB';
      try
       FTb_sdr_por.open;
      except
       FTb_sdr_por:=nil;
      end;
     end;
   end;
  result:=FTb_sdr_por;
 end;
function tciselnik.Gettb_Druh_poz :TTable;
 begin
  if FTb_Druh_poz=nil then
   begin
    if not FTb_Druh_pozZkouselOtevrit then
     begin
      FTb_Druh_pozZkouselOtevrit:=true;
      FTb_Druh_poz:=TTable.Create(Application.mainform);
      FTb_Druh_poz.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\DRUH_POZ.DB';
      try
       FTb_Druh_poz.open;
      except
       FTb_Druh_poz:=nil;
      end;
     end;
   end;
  result:=FTb_Druh_poz;
 end;
 
function tciselnik.Gettb_Biotop :TTable;
 begin
  if FTb_Biotop=nil then
   begin
    if not FTb_BiotopZkouselOtevrit then
     begin
      FTb_BiotopZkouselOtevrit:=true;
      FTb_Biotop:=TTable.Create(Application.mainform);
      FTb_Biotop.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Biotop.DB';
      try
       FTb_Biotop.open;
      except
       FTb_Biotop:=nil;
      end;
     end;
   end;
  result:=FTb_Biotop;
 end;



function tciselnik.Gettb_Pot_vla  :TTable;
 begin
  if FTb_Pot_vla=nil then
   begin
    if not FTb_Pot_vlaZkouselOtevrit then
     begin
      FTb_Pot_vlaZkouselOtevrit:=true;
      FTb_Pot_vla:=TTable.Create(Application.mainform);
      FTb_Pot_vla.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\POT_VLA.DB';
      try
       FTb_Pot_vla.open;
      except
       FTb_Pot_vla:=nil;
      end;
     end;
   end;
  result:=FTb_Pot_vla;
 end;
function tciselnik.Gettb_TeTy1 :TTable;
 begin
  if FTb_TeTy1=nil then
   begin
    if not FTb_TeTy1ZkouselOtevrit then
     begin
      FTb_TeTy1ZkouselOtevrit:=true;
      FTb_TeTy1:=TTable.Create(Application.mainform);
      FTb_TeTy1.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\CIS_TETY.DB';
      try
       FTb_TeTy1.open;
      except
       FTb_TeTy1:=nil;
      end;
     end;
   end;
  result:=FTb_TeTy1;
 end;

function tciselnik.Gettb_PLT :TTable;
 begin
  if FTb_PLT=nil then
   begin
    if not FTb_PLTZkouselOtevrit then
     begin
      FTb_PLTZkouselOtevrit:=true;
      FTb_PLT:=TTable.Create(Application.mainform);
      FTb_PLT.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\CIS_PLT.DB';
      try
       FTb_PLT.open;
      except                      
       FTb_PLT:=nil;
      end;
     end;
   end;
  result:=FTb_PLT;
 end;
 
function tciselnik.Gettb_EVL    :TTable;
 begin
  if FTb_EVL=nil then
   begin
    if not FTb_EVLZkouselOtevrit then
     begin
      FTb_EVLZkouselOtevrit:=true;
      FTb_EVL:=TTable.Create(Application.mainform);
      FTb_EVL.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\C_OCHR_EVL.DB';
      try
       FTb_EVL.open;
      except
       FTb_EVL:=nil;
      end;
     end;
   end;
  result:=FTb_EVL;
 end;

function tciselnik.Gettb_ZONA    :TTable;
 begin
  if FTb_ZONA=nil then
   begin
    if not FTb_ZONAZkouselOtevrit then
     begin
      FTb_ZONAZkouselOtevrit:=true;
      FTb_ZONA:=TTable.Create(Application.mainform);
      FTb_ZONA.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\C_OCHR_ZONY.DB';
      try
       FTb_ZONA.open;
      except
       FTb_ZONA:=nil;
      end;
     end;
   end;
  result:=FTb_ZONA;
 end;

function tciselnik.Gettb_PO     :TTable;
 begin
  if FTb_PO=nil then
   begin
    if not FTb_POZkouselOtevrit then
     begin
      FTb_POZkouselOtevrit:=true;
      FTb_PO:=TTable.Create(Application.mainform);
      FTb_PO.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\C_OCHR_PO.DB';
      try
       FTb_PO.open;
      except
       FTb_PO:=nil;
      end;
     end;
   end;
  result:=FTb_PO;
 end;

function tciselnik.Gettb_CHKO   :TTable;
 begin
  if FTb_CHKO=nil then
   begin
    if not FTb_CHKOZkouselOtevrit then
     begin
      FTb_CHKOZkouselOtevrit:=true;
      FTb_CHKO:=TTable.Create(Application.mainform);
      FTb_CHKO.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\C_OCHR_CHKO.DB';
      try
       FTb_CHKO.open;
      except
       FTb_CHKO:=nil;
      end;
     end;
   end;
  result:=FTb_CHKO;
 end;

function tciselnik.Gettb_NP    :TTable;
 begin
  if FTb_NP=nil then
   begin
    if not FTb_NPZkouselOtevrit then
     begin
      FTb_NPZkouselOtevrit:=true;
      FTb_NP:=TTable.Create(Application.mainform);
      FTb_NP.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\C_OCHR_NP.DB';
      try
       FTb_NP.open;
      except
       FTb_NP:=nil;
      end;
     end;
   end;
  result:=FTb_NP;
 end;

function tciselnik.Gettb_NPP    :TTable;
 begin
  if FTb_NPP=nil then
   begin
    if not FTb_NPPZkouselOtevrit then
     begin
      FTb_NPPZkouselOtevrit:=true;
      FTb_NPP:=TTable.Create(Application.mainform);
      FTb_NPP.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\C_OCHR_NPP.DB';
      try
       FTb_NPP.open;
      except
       FTb_NPP:=nil;
      end;
     end;
   end;
  result:=FTb_NPP;
 end;

function tciselnik.Gettb_NPR    :TTable;
 begin
  if FTb_NPR=nil then
   begin
    if not FTb_NPRZkouselOtevrit then
     begin
      FTb_NPRZkouselOtevrit:=true;
      FTb_NPR:=TTable.Create(Application.mainform);
      FTb_NPR.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\C_OCHR_NPR.DB';
      try
       FTb_NPR.open;
      except                      
       FTb_NPR:=nil;
      end;
     end;
   end;
  result:=FTb_NPR;
 end;

function tciselnik.Gettb_PP    :TTable;
 begin
  if FTb_PP=nil then
   begin
    if not FTb_PPZkouselOtevrit then
     begin
      FTb_PPZkouselOtevrit:=true;
      FTb_PP:=TTable.Create(Application.mainform);
      FTb_PP.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\C_OCHR_PP.DB';
      try
       FTb_PP.open;
      except
       FTb_PP:=nil;
      end;
     end;
   end;
  result:=FTb_PP;
 end;

function tciselnik.Gettb_Gen_PUV  :TTable;
 begin
  if FTb_Gen_PUV=nil then
   begin
    if not FTb_Gen_PUVZkouselOtevrit then
     begin
      FTb_Gen_PUVZkouselOtevrit:=true;
      FTb_Gen_PUV:=TTable.Create(Application.mainform);
      FTb_Gen_PUV.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\CIS_Gen_PUV.DB';
      try
       FTb_Gen_PUV.open;
      except
       FTb_Gen_PUV:=nil;
      end;
     end;
   end;
  result:=FTb_Gen_PUV;
 end;

function tciselnik.Gettb_LVS    :TTable;
 begin
  if FTb_LVS=nil then
   begin
    if not FTb_LVSZkouselOtevrit then
     begin
      FTb_LVSZkouselOtevrit:=true;
      FTb_LVS:=TTable.Create(Application.mainform);
      FTb_LVS.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\CIS_LVS.DB';
      try
       FTb_LVS.open;
      except
       FTb_LVS:=nil;
      end;
     end;
   end;
  result:=FTb_LVS;
 end;



function tciselnik.Gettb_PR    :TTable;
 begin
  if FTb_PR=nil then
   begin
    if not FTb_PRZkouselOtevrit then
     begin
      FTb_PRZkouselOtevrit:=true;
      FTb_PR:=TTable.Create(Application.mainform);
      FTb_PR.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\C_OCHR_PR.DB';
      try
       FTb_PR.open;
      except
       FTb_PR:=nil;
      end;
     end;
   end;
  result:=FTb_PR;
 end;

function tciselnik.Gettb_TypManag :TTable;
 begin
  if FTb_TypManag=nil then
   begin
    if not FTb_TypManagZkouselOtevrit then
     begin
      FTb_TypManagZkouselOtevrit:=true;
      FTb_TypManag:=TTable.Create(Application.mainform);
      FTb_TypManag.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\CISManag.DB';
      try
       FTb_TypManag.open;
      except
       FTb_TypManag:=nil;
      end;
     end;
   end;
  result:=FTb_TypManag;
 end;

function tciselnik.Gettb_TechTyp :TTable;
 begin
  if FTb_TechTyp=nil then
   begin
    if not FTb_TechTypZkouselOtevrit then
     begin
      FTb_TechTypZkouselOtevrit:=true;
      FTb_TechTyp:=TTable.Create(Application.mainform);
      FTb_TechTyp.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\technTyp.DB';
      try
       FTb_TechTyp.open;
      except
       FTb_TechTyp:=nil;
      end;
     end;
   end;
  result:=FTb_TechTyp;
 end;
function tciselnik.Gettb_LDU      :TTable;
 begin
  if FTb_LDU=nil then
   begin
    if not FTb_LDUZkouselOtevrit then
     begin
      FTb_LDUZkouselOtevrit:=true;
      FTb_LDU:=TTable.Create(Application.mainform);
      FTb_LDU.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\CIS_LDU.DB';
      try
       FTb_LDU.open;
      except
       FTb_LDU:=nil;
      end;
     end;
   end;
  result:=FTb_LDU;
 end;

function tciselnik.Gettb_ORP      :TTable;
 begin
  if FTb_ORP=nil then
   begin
    if not FTb_ORPZkouselOtevrit then
     begin
      FTb_ORPZkouselOtevrit:=true;
      FTb_ORP:=TTable.Create(Application.mainform);
      FTb_ORP.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\ORP.DB';
      try
       FTb_ORP.open;
      except
       FTb_ORP:=nil;
      end;
     end;
   end;
  result:=FTb_ORP;
 end;

function tciselnik.GettbObce6      :TTable;
 begin
  if FtbObce6=nil then
   begin
    if not FtbObce6ZkouselOtevrit then
     begin
      FtbObce6ZkouselOtevrit:=true;
      FtbObce6:=TTable.Create(Application.mainform);
      FtbObce6.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Obce.db';
      try
       FtbObce6.open;
      except
       FtbObce6:=nil;
      end;
     end;
   end;
  result:=FtbObce6;
 end;

function tciselnik.GetTb9_6Win      :TTable;
 begin
  if FTb9_6Win=nil then
   begin
    if not FTb9_6WinZkouselOtevrit then
     begin
      FTb9_6WinZkouselOtevrit:=true;
      FTb9_6Win:=TTable.Create(Application.mainform);
      FTb9_6Win.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\9_6_WIN.db';
      try
       FTb9_6Win.open;
      except
       FTb9_6Win:=nil;
      end;
     end;
   end;
  result:=FTb9_6Win;
 end;


function tciselnik.Gettb_KuOrpKraj      :TTable;
 begin
  if Ftb_KuOrpKraj=nil then
   begin
    if not Ftb_KuOrpKrajZkouselOtevrita then
     begin
      Ftb_KuOrpKrajZkouselOtevrita:=true;
      Ftb_KuOrpKraj:=TTable.Create(Application.mainform);
      Ftb_KuOrpKraj.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\KuOrpKraj.DB';
      try
       Ftb_KuOrpKraj.open;
      except
       Ftb_KuOrpKraj:=nil;
      end;
     end;
   end;
  result:=Ftb_KuOrpKraj;
 end;


function tciselnik.Gettb_KU6a      :TTable;
 begin
  if Ftb_KU6a=nil then
   begin
    if not Ftb_KU6ZkouselOtevrita then
     begin
      Ftb_KU6ZkouselOtevrita:=true;
      Ftb_KU6a:=TTable.Create(Application.mainform);
      Ftb_KU6a.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\KU6.DB';
      try
       Ftb_KU6a.open;
      except
       Ftb_KU6a:=nil;
      end;
     end;
   end;
  result:=Ftb_KU6a;
 end;

function tciselnik.Gettb_KU6b      :TTable;
 begin
  if Ftb_KU6a=nil then
   begin
    if not Ftb_KU6ZkouselOtevritb then
     begin
      Ftb_KU6ZkouselOtevritb:=true;
      Ftb_KU6b:=TTable.Create(Application.mainform);
      Ftb_KU6b.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\KU.DB';
      try
       Ftb_KU6b.open;
      except
       Ftb_KU6b:=nil;
      end;
     end;
   end;
  result:=Ftb_KU6b;
 end;

function tciselnik.Gettb_Kval_P   :TTable;
 begin
  if FTb_Kval_P=nil then
   begin
    if not FTb_Kval_PZkouselOtevrit then
     begin
      FTb_Kval_PZkouselOtevrit:=true;
      FTb_Kval_P:=TTable.Create(Application.mainform);
      FTb_Kval_P.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Kval_P.db';
      try
       FTb_Kval_P.open;
      except
       FTb_Kval_P:=nil;
      end;
     end;
   end;
  result:=FTb_Kval_P;
 end;
function tciselnik.Gettb_Duv_tezb :TTable;
 begin
  if FTb_Duv_tezb=nil then
   begin
    if not FTb_Duv_tezbZkouselOtevrit then
     begin
      FTb_Duv_tezbZkouselOtevrit:=true;
      FTb_Duv_tezb:=TTable.Create(Application.mainform);
      FTb_Duv_tezb.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Duv_Tezb.db';
      try
       FTb_Duv_tezb.open;
      except
       FTb_Duv_tezb:=nil;
      end;
     end;
   end;
  result:=FTb_Duv_tezb;
 end;
function tciselnik.Gettb_Druh_Zal :TTable;
 begin
  if FTb_Druh_Zal=nil then
   begin
    if not FTb_Druh_ZalZkouselOtevrit then
     begin
      FTb_Druh_ZalZkouselOtevrit:=true;
      FTb_Druh_Zal:=TTable.Create(Application.mainform);
      FTb_Druh_Zal.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Druh_Zal.db';
      try
       FTb_Druh_Zal.open;
      except
       FTb_Druh_Zal:=nil;
      end;
     end;
   end;
  result:=FTb_Druh_Zal;
 end;
function tciselnik.Gettb_Dan      :TTable;
 begin
  if FTb_dan=nil then
   begin
    if not FTb_DanZkouselOtevrit then
     begin
      FTb_DanZkouselOtevrit:=true;
      FTb_Dan:=TTable.Create(Application.mainform);
      FTb_Dan.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Cis_Dan.db';
      try
       FTb_Dan.open;
      except
       FTb_Dan:=nil;
      end;
     end;
   end;
  result:=FTb_DAN;
 end;
function tciselnik.Gettb_genKl    :TTable;
 begin
  if FTb_genKl=nil then
   begin
    if not FTb_genKlZkouselOtevrit then
     begin
      FTb_genKlZkouselOtevrit:=true;
      FTb_genKl:=TTable.Create(Application.mainform);
      FTb_genKl.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Gen_Klas.db';
      try
       FTb_genKl.open;
      except
       FTb_genKl:=nil;
      end;
     end;
   end;
  result:=FTb_genKl;
 end;
function tciselnik.Gettb_imise98    :TTable;
 begin
  if FTb_Imise98=nil then
   begin
    if not FTb_Imise98ZkouselOtevrit then
     begin
      FTb_Imise98ZkouselOtevrit:=true;
      FTb_Imise98:=TTable.Create(Application.mainform);
      FTb_Imise98.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Imise.db';
      try
       FTb_Imise98.open;
      except
       FTb_Imise98:=nil;
      end;
     end;
   end;
  result:=FTb_Imise98;
 end;


function tciselnik.Gettb_imise99    :TTable;
 begin
  if FTb_Imise99=nil then
   begin
    if not FTb_Imise99ZkouselOtevrit then
     begin
      FTb_Imise99ZkouselOtevrit:=true;
      FTb_Imise99:=TTable.Create(Application.mainform);
      FTb_Imise99.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Imise99.db';
      try
       FTb_Imise99.open;
      except
       FTb_Imise99:=nil;
      end;
     end;
   end;
  result:=FTb_Imise99;
 end;

function tciselnik.GetTB_Cis_ost    :TTable;
 begin
  if FTB_Cis_ost=nil then
   begin
    if not FTB_Cis_ostZkouselOtevrit then
     begin
      FTB_Cis_ostZkouselOtevrit:=true;
      FTB_Cis_ost:=TTable.Create(Application.mainform);
      FTB_Cis_ost.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Cis_ost.db';
      try
       FTB_Cis_ost.open;
      except
       FTB_Cis_ost:=nil;
      end;
     end;
   end;
  result:=FTB_Cis_ost;
 end;

function tciselnik.GetTB_Cis_Jine    :TTable;
 begin
  if FTB_Cis_Jine=nil then
   begin
    if not FTB_Cis_JineZkouselOtevrit then
     begin
      FTB_Cis_JineZkouselOtevrit:=true;
      FTB_Cis_Jine:=TTable.Create(Application.mainform);
      FTB_Cis_Jine.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Cis_Jine.db';
      try
       FTB_Cis_Jine.open;
      except
       FTB_Cis_Jine:=nil;
      end;
     end;
   end;
  result:=FTB_Cis_Jine;
 end;

function tciselnik.GetTB_Cis_Bezl    :TTable;
 begin
  if FTB_Cis_Bezl=nil then
   begin
    if not FTB_Cis_BezlZkouselOtevrit then
     begin
      FTB_Cis_BezlZkouselOtevrit:=true;
      FTB_Cis_Bezl:=TTable.Create(Application.mainform);
      FTB_Cis_Bezl.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Cis_Bezl.db';
      try
       FTB_Cis_Bezl.open;
      except
       FTB_Cis_Bezl:=nil;
      end;
     end;
   end;
  result:=FTB_Cis_Bezl;
 end;

function tciselnik.Gettb_posk     :TTable;
 begin
  if FTb_posk=nil then
   begin
    if not FTb_poskZkouselOtevrit then
     begin
      FTb_poskZkouselOtevrit:=true;
      FTb_posk:=TTable.Create(Application.mainform);
      FTb_posk.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Cis_Posk.DB';
      try
       FTb_posk.open;
      except
       FTb_posk:=nil;
      end;
     end;
   end;
  result:=FTb_posk;
 end;

function tciselnik.GetTb_puvod    :TTable;
 begin
  if FTb_puvod=nil then
   begin
    if not FTb_puvodZkouselOtevrit then
     begin
      FTb_puvodZkouselOtevrit:=true;
      FTb_puvod:=TTable.Create(Application.mainform);
      FTb_puvod.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\PUVOD_DR.DB';
      try
       FTb_puvod.open;
      except
       FTb_puvod:=nil;
      end;
     end;
   end;
  result:=FTb_puvod;
 end;
function tciselnik.Gettb_DrevCis  :TTable;
 begin
  if FTb_DrevCis=nil then
   begin
    if not FTb_DrevCisZkouselOtevrit then
     begin
      FTb_DrevCisZkouselOtevrit:=true;
      FTb_DrevCis:=TTable.Create(Application.mainform);
      FTb_DrevCis.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\CIS_DREV.DB';
      try
       FTb_DrevCis.open;
      except
       FTb_DrevCis:=nil;
      end;
     end;
   end;
  result:=FTb_DrevCis;
 end;
function tciselnik.GetTB_Zp_TEZBY :TTable;
 begin
  if FTb_Zp_TEZBY=nil then
   begin
    if not FTb_Zp_TEZBYZkouselOtevrit then
     begin
      FTb_Zp_TEZBYZkouselOtevrit:=true;
      FTb_Zp_TEZBY:=TTable.Create(Application.mainform);
      FTb_Zp_TEZBY.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\Zp_TEZBY.db';
      try
       FTb_Zp_TEZBY.open;
      except
       FTb_Zp_TEZBY:=nil;
      end;
     end;
   end;
  result:=FTb_Zp_TEZBY;
 end;

function tciselnik.GetTB_ODVOZ_TEZ :TTable;
 begin
  if FTb_ODVOZ_TEZ=nil then
   begin
    if not FTb_ODVOZ_TEZZkouselOtevrit then
     begin
      FTb_ODVOZ_TEZZkouselOtevrit:=true;
      FTb_ODVOZ_TEZ:=TTable.Create(Application.mainform);
      FTb_ODVOZ_TEZ.tableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\ODV_TEZ.db';
      try
       FTb_ODVOZ_TEZ.open;
      except
       FTb_ODVOZ_TEZ:=nil;
      end;
     end;
   end;
  result:=FTb_ODVOZ_TEZ;
 end;

function TDatabaseMel_DrevClass.GetDR_ZKR:string;
 begin
  result:=DSData.dataSet.fieldByName('Mel_DR1').asstring;
  if  trim(DSData.dataSet.fieldByName('Mel_DR2').asstring)<>'' then
          result:=result+'&'+DSData.dataSet.fieldByName('Mel_DR2').asstring;
  if  trim(DSData.dataSet.fieldByName('Mel_DR3').asstring)<>'' then
          result:=result+'&'+DSData.dataSet.fieldByName('Mel_DR3').asstring;
  if  trim(DSData.dataSet.fieldByName('Mel_DR4').asstring)<>'' then
          result:=result+'&'+DSData.dataSet.fieldByName('Mel_DR4').asstring;
  if  trim(DSData.dataSet.fieldByName('Mel_DR5').asstring)<>'' then
          result:=result+'&'+DSData.dataSet.fieldByName('Mel_DR5').asstring;
  if  trim(DSData.dataSet.fieldByName('Mel_DR6').asstring)<>'' then
          result:=result+'&'+DSData.dataSet.fieldByName('Mel_DR6').asstring;
  if  trim(DSData.dataSet.fieldByName('Mel_DR7').asstring)<>'' then
          result:=result+'&'+DSData.dataSet.fieldByName('Mel_DR7').asstring;
  if  trim(DSData.dataSet.fieldByName('Mel_DR8').asstring)<>'' then
          result:=result+'&'+DSData.dataSet.fieldByName('Mel_DR8').asstring;
  if  trim(DSData.dataSet.fieldByName('Mel_DR9').asstring)<>'' then
          result:=result+'&'+DSData.dataSet.fieldByName('Mel_DR9').asstring;
  if  trim(DSData.dataSet.fieldByName('Mel_DR10').asstring)<>'' then
          result:=result+'&'+DSData.dataSet.fieldByName('Mel_DR10').asstring;

 end;
function TDatabaseMel_DrevClass.GetLT_SLT:string;
var VLT_SLT:string;
    POS1,i:integer;
 begin
  VLT_SLT:=trim(DSData.dataSet.fieldByName('LT').asstring);
  VLT_SLT:=trim(copy(VLT_SLT,1,length(VLT_SLT)-1));
  POS1:=pos('  ',VLT_SLT);
  while POS1<>0 do
   begin
    VLT_SLT:=copy(VLT_SLT,1,POS1-1)+copy(VLT_SLT,POS1+1,length(VLT_SLT)-POS1);
    POS1:=pos('  ',VLT_SLT);
   end;
  result:='';
  for i:=1 to length(VLT_SLT) do
   begin
    if VLT_SLT[i]=' ' then
     begin
      result:=result+'&';
     end
    else
     begin
      result:=result+VLT_SLT[i];
     end;
   end;
 end;

procedure vypoctiPrirustyTab(RustTab:TTable;DrevStr:string;Vek,AVB,Obmyti:Integer;odkornovat:boolean;
                                var BeznyPrirust,PMP,CPP:integer);
var DrevStr1:string;
    Vek1:integer;
 begin
  if not RustTab.active then RustTab.open;
  // RustTab.FindNearest(['BO',32,30,35]);
  DrevStr1:=trim(prev_dr_na_st(drevina_stat_tab(prev_dr_na_Drevina_rm(DrevStr))));
  Vek1:=(Vek div 10)*10;
  if Vek1>120 then Vek1:=120;
  Obmyti:=(Obmyti div 5)*5;
  if Obmyti>130 then Obmyti:=130;
  RustTab.FindNearest([DrevStr1,AVB,Vek1,Vek1+5]);
  BeznyPrirust:=RustTab.FindField('BEZNPRIR').AsInteger;
  if Vek1<40 then Vek1:=40;
  RustTab.FindNearest([DrevStr1,AVB,Vek1,Obmyti]);
  if Obmyti>0 then
   begin
    PMP:= round(RustTab.FindField('Z_HR_H').AsInteger/Obmyti);
    CPP:= round(RustTab.FindField('CELKPROD').AsInteger/Obmyti);
   end
  else
   begin
    PMP:= 0;
    CPP:= 0;
   end;
  if odkornovat then
   begin
    BeznyPrirust:=bezkury(BeznyPrirust,DrevStr);
    PMP:=bezkury(PMP,DrevStr);
    CPP:=bezkury(CPP,DrevStr);
   end;
 end;

function PLT_z_TabulkyPLT_LT(vLT,vLES_OBL,vLES_Podobl:string;TB_PLT_LT:TTable):string;
var
 shoda:integer;
 begin
  vLT:=uppercase(ubm(vLT));
  vLES_OBL:=ubm(vLES_OBL);
  vLES_PodOBL:=Lowercase(ubm(vLES_PodOBL));
  result:='';
  if (vLT='')or(vLES_OBL='') then exit;
  try
   TB_PLT_LT.active:=true;
  except
   // showmessage('Chyb tabulka PLT dle LT');
   exit;
  end;
  with  TB_PLT_LT do
   begin
    SetRangeStart; { Set the beginning key }
    FieldByName('LT').AsString :=vLT;
    FieldByName('PLO').AsString :='';
    SetRangeEnd; { Set the ending key }
    FieldByName('LT').AsString :=vLT+'z';
    FieldByName('PLO').AsString :='999';
    ApplyRange; { Tell the dataset to establish the range }
    first;
    shoda:=0;
    while not eof do
     begin
      if (Ubm(FieldByName('LT').AsString)=vLT) and
         (Ubm(FieldByName('PLO').AsString)=vLES_PodOBL)  then
       begin
        shoda:=6;
        result:=FieldByName('PLT').AsString;
       end;
      if (Ubm(FieldByName('LT').AsString)=vLT)
         and (Ubm(FieldByName('PLO').AsString)=vLES_OBL)
         and (shoda<6) then
       begin
        shoda:=5;
        result:=FieldByName('PLT').AsString;
       end;
      if (pos(vlt,FieldByName('LT').AsString)>0)
         and (Ubm(FieldByName('PLO').AsString)=vLES_PodOBL)
         and (shoda<5) then
       begin
        shoda:=4;
        result:=FieldByName('PLT').AsString;
       end;
      if (pos(vlt,FieldByName('LT').AsString)>0)
         and (Ubm(FieldByName('PLO').AsString)=vLES_OBL)
         and (shoda<4) then
       begin
        shoda:=3;
        result:=FieldByName('PLT').AsString;
       end;
      if (Ubm(FieldByName('LT').AsString)=vLT)
         and (pos(vLES_OBL,Ubm(FieldByName('PLO').AsString))>0)
         and (shoda<3) then
       begin
        shoda:=2;
        result:=FieldByName('PLT').AsString;
       end;
      if (pos(vlt,FieldByName('LT').AsString)>0)
         and (pos(vLES_OBL,Ubm(FieldByName('PLO').AsString))>0)
         and (shoda<2) then
       begin
        shoda:=1;
        result:=FieldByName('PLT').AsString;
       end;
      next;
     end;
   end;
 end;

function PLTupravProKoplu(vPLT:String):String;
 begin
  if length(vPLT)>3 then vPLT:=copy(vPLT,1,3);
  if vPLT='0Kd' then vPLT:='0K-';
  if vPLT='0Kb' then vPLT:='0K-';
  if vPLT='0Ks' then vPLT:='0K-';
  if vPLT='0Mq' then vPLT:='0M-';
  if vPLT='0Mb' then vPLT:='0M-';
  if vPLT='0Pr' then vPLT:='0P-';
  if vPLT='0Rv' then vPLT:='0R-';
  if vPLT='0Ri' then vPLT:='0R-';
  if vPLT='0Yb' then vPLT:='0Y-';
  if vPLT='0Yv' then vPLT:='0Y-';
  if vPLT='0Yr' then vPLT:='0Y-';
  if vPLT='0Zv' then vPLT:='0Z-';
  if vPLT='0Zp' then vPLT:='0Z-';
  if vPLT='0Zs' then vPLT:='0Z-';
  if vPLT='1Gi' then vPLT:='1G-';
  if vPLT='1Lq' then vPLT:='1L-';
  if vPLT='1Ms' then vPLT:='1M-';
  if vPLT='1Mq' then vPLT:='1M-';
  if vPLT='1Op' then vPLT:='1O-';
  if vPLT='1Xh' then vPLT:='1X-';
  if vPLT='1Xi' then vPLT:='1X-';
  if vPLT='1Zi' then vPLT:='1Z-';
  if vPLT='1Zs' then vPLT:='1Z-';
  if vPLT='2Bl' then vPLT:='2B-';
  if vPLT='2DV' then vPLT:='2D-';


  if vPLT='2Dw' then vPLT:='2D-';
  if vPLT='2Hl' then vPLT:='2H-';
  if vPLT='2Kp' then vPLT:='2K-';
  if vPLT='2Kh' then vPLT:='2K-';
  if vPLT='2Lc' then vPLT:='2L-';
  if vPLT='2Lk' then vPLT:='2L-';
  if vPLT='2Sp' then vPLT:='2S-';
  if vPLT='2Sl' then vPLT:='2S-';
  if vPLT='2Zs' then vPLT:='2Z-';
  if vPLT='3Bh' then vPLT:='3B-';
  if vPLT='3Bj' then vPLT:='3B-';
  if vPLT='3Dw' then vPLT:='3D-';
  if vPLT='3Dj' then vPLT:='3D-';
  if vPLT='3Hj' then vPLT:='3H-';
  if vPLT='3Jh' then vPLT:='3J-';
  if vPLT='3Kp' then vPLT:='3K-';
  if vPLT='3Ks' then vPLT:='3K-';
  if vPLT='3Kh' then vPLT:='3K-';
  if vPLT='3Kj' then vPLT:='3K-';
  if vPLT='3Lp' then vPLT:='3L-';
  if vPLT='3Sp' then vPLT:='3S-';
  if vPLT='3Sj' then vPLT:='3S-';
  if vPLT='3Su' then vPLT:='3S-';
  if vPLT='3Yi' then vPLT:='3Y-';
  if vPLT='3Zs' then vPLT:='3Z-';
  if vPLT='4Kp' then vPLT:='4K-';
  if vPLT='4Ks' then vPLT:='4K-';
  if vPLT='4Kh' then vPLT:='4K-';
  if vPLT='4Sp' then vPLT:='4S-';
  if vPLT='4Sh' then vPLT:='4S-';
  if vPLT='5Fx' then vPLT:='5F-';
  if vPLT='5Ks' then vPLT:='5K-';
  if vPLT='5Kd' then vPLT:='5K-';
  if vPLT='5Pd' then vPLT:='5P-';
  if vPLT='5Qr' then vPLT:='5Q-';
  if vPLT='5Zs' then vPLT:='5Z-';
  if vPLT='6Kd' then vPLT:='6K-';
  if vPLT='6Lr' then vPLT:='6L-';
  if vPLT='6Md' then vPLT:='6M-';
  if vPLT='6Nj' then vPLT:='6N-';
  if vPLT='6Pd' then vPLT:='6P-';
  if vPLT='6Qd' then vPLT:='6Q-';
  if vPLT='6Td' then vPLT:='6T-';
  if vPLT='6Yj' then vPLT:='6Y-';
  if vPLT='6Zj' then vPLT:='6Z-';
  if vPLT='7Zs' then vPLT:='7Z-';
  if vPLT='8Qv' then vPLT:='8Q-';
  if vPLT='8Ri' then vPLT:='8R-';
  if vPLT='8Rv' then vPLT:='8R-';
  if vPLT='8Tv' then vPLT:='8T-';
  if vPLT='8Vg' then vPLT:='8V-';
  if vPLT='8Vv' then vPLT:='8V-';
  if vPLT='8Yv' then vPLT:='8Y-';
  if vPLT='8Zk' then vPLT:='8Z-';
  if vPLT='8Zt' then vPLT:='8Z-';
  if vPLT='9Ki' then vPLT:='9K-';
  if vPLT='9Rv' then vPLT:='9R-';
  if vPLT='9Ri' then vPLT:='9R-';
  if vPLT='9Yy' then vPLT:='9Y-';
  if vPLT='9Yb' then vPLT:='9Y-';
  if vPLT='9Yg' then vPLT:='9Y-';
  if vPLT='9Zk' then vPLT:='9Z-';
  if vPLT='9Zi' then vPLT:='9Z-';
  if vPLT='9Zg' then vPLT:='9Z-';
  result:=vPLT;
 end;

function PLT_z_TabulkyPLT_LTAbyVyhovelKople(vLT,vLES_OBL,vLES_Podobl:string;TB_PLT_LT:TTable):string;
var
 sPLT:string;
 begin
  sPLT:=PLT_z_TabulkyPLT_LT(vLT,vLES_OBL,vLES_Podobl,TB_PLT_LT);
  if SPlt='' then SPlt:=copy(vLT,1,2)+'-';
  sPLT:=PLTupravProKoplu(sPLT);
  result:=sPLT;
 end;


function CIL_HS_z_TabulkyPLT_LT(vLT,vLES_OBL,vLES_Podobl:string;TB_PLT_LT:TTable):integer;
var
 shoda:integer;
 ss:string;
 begin
  vLT:=uppercase(ubm(vLT));
  vLES_OBL:=ubm(vLES_OBL);
  vLES_PodOBL:=Lowercase(ubm(vLES_PodOBL));
  ss:='';
  if (vLT='')or(vLES_OBL='') then exit;
  try
   TB_PLT_LT.active:=true;
  except
   exit;
  end;
  with  TB_PLT_LT do
   begin
    SetRangeStart; { Set the beginning key }
    FieldByName('LT').AsString :=vLT;
    FieldByName('PLO').AsString :='';
    SetRangeEnd; { Set the ending key }
    FieldByName('LT').AsString :=vLT+'z';
    FieldByName('PLO').AsString :='999';
    ApplyRange; { Tell the dataset to establish the range }
    first;
    shoda:=0;
    while not eof do
     begin
      if (Ubm(FieldByName('LT').AsString)=vLT) and
         (Ubm(FieldByName('PLO').AsString)=vLES_PodOBL)  then
       begin
        shoda:=6;
        ss:=FieldByName('CIHO').AsString;
       end;
      if (Ubm(FieldByName('LT').AsString)=vLT)
         and (Ubm(FieldByName('PLO').AsString)=vLES_OBL)
         and (shoda<6) then
       begin
        shoda:=5;
        ss:=FieldByName('CIHO').AsString;
       end;
      if (pos(vlt,FieldByName('LT').AsString)>0)
         and (Ubm(FieldByName('PLO').AsString)=vLES_PodOBL)
         and (shoda<5) then
       begin
        shoda:=4;
        ss:=FieldByName('CIHO').AsString;
       end;
      if (pos(vlt,FieldByName('LT').AsString)>0)
         and (Ubm(FieldByName('PLO').AsString)=vLES_OBL)
         and (shoda<4) then
       begin
        shoda:=3;
        ss:=FieldByName('CIHO').AsString;
       end;
      if (Ubm(FieldByName('LT').AsString)=vLT)
         and (pos(vLES_OBL,Ubm(FieldByName('PLO').AsString))>0)
         and (shoda<3) then
       begin
        shoda:=2;
        ss:=FieldByName('CIHO').AsString;
       end;
      if (pos(vlt,FieldByName('LT').AsString)>0)
         and (pos(vLES_OBL,Ubm(FieldByName('PLO').AsString))>0)
         and (shoda<2) then
       begin
        shoda:=1;
        ss:=FieldByName('CIHO').AsString;
       end;

      next;
     end;
   end;
  result:= strtoint0(ss);
 end;



{function PLT_z_TabulkyPLT_LT(vLT:string;TB_PLT_LT:TTable):string;
var ncLT,vysl1,Vysl2,vSLT:String;
 begin
  vLT:=uppercase(ubm(vLT));
  try
   TB_PLT_LT.active:=true;
  except
   // showmessage('Chyb tabulka PLT dle LT');
   result:='';
   exit;
  end;
  TB_PLT_LT.first;
  if TB_PLT_LT.Eof then
   begin
    result:='';
    exit;
   end;

  if Length(Vlt)<3 then
   begin
    result:='***';
    exit;
   end;
  vysl1:='***';
  vysl2:='***';
  Vslt:=copy(Vlt,1,2);
  while not TB_PLT_LT.eof do
   begin
    ncLt:= ubm(TB_PLT_LT.fieldByname('LT').asstring);
    if nclt<>'' then
     begin
      if nclt[1]<>',' then nclt:=','+nclt;
      if nclt[Length(nclt)]<>',' then nclt:=nclt+',';
      if pos(','+vLT+',',nclt)>0 then
       begin
        vysl1:=ubm(TB_PLT_LT.fieldByname('PLT').asstring);
       end;
      if pos(','+vSLT+',',nclt)>0 then
       begin
        vysl2:=ubm(TB_PLT_LT.fieldByname('PLT').asstring);
       end;
     end;
    TB_PLT_LT.Next;
   end;
  if vysl1<>'***' then
   begin
    result:=vysl1;
   end
  else
   begin
    result:=vysl2;
   end;
 end;
}

function Kategorie_st_z_TabulkyPorostu(sODD,sDIL,sPor:string;TB_porKTG:TTable):string;
var iktg:integer;
    SKTG:string;
  procedure najdiSktgVTabulce;
   begin
    with TB_porKTG do
     begin
      sKTG:='';
      while not Eof do
       begin
        if sKTG<>''then SKtg:=sKTG+'/';
        if    (ubm(fieldByName('Kategorie').asstring)<>'')
           and(ubm(fieldByName('Kategorie').asstring)<>'0') then
         begin
          sKTG:=sktg+ubm(fieldByName('Kategorie').asstring);
         end;
        next;
       end;
     end;
   end;
 procedure najdiExplic;
  begin
   with TB_porKTG do
    begin
     SetRangeStart;
     FieldByName('ODD').AsString :='0';
     FieldByName('DIL').AsString :='';
     FieldByName('POR').AsString :='';
     FieldByName('ID').AsString  :='-1';
     SetRangeEnd;
     FieldByName('ODD').AsString :='0';
     FieldByName('DIL').AsString :='';
     FieldByName('POR').AsString :='';
     FieldByName('ID').AsString  :='99999';
     ApplyRange;
     first;
     if eof then
      begin
       SKtg:='10';
       exit;
      end
     else
      begin
       najdiSktgVTabulce;
      end;
    end;
  end;
begin
 with TB_porKTG do
  begin
   active:=true;
   SetRangeStart;
   FieldByName('ODD').AsString :=sOdd;
   FieldByName('DIL').AsString :='';
   FieldByName('POR').AsString :='';
   FieldByName('ID').AsString  :='-1';
   SetRangeEnd;
   FieldByName('ODD').AsString :=sODD;
   FieldByName('DIL').AsString :='Z';
   FieldByName('POR').AsString :='z';
   FieldByName('ID').AsString  :='99999';
   ApplyRange;
   first;
   if eof then
    begin
     najdiExplic;
    end //nenasel Oddeleni
   else // nael Oddeleni
    begin
     SetRangeStart;
     FieldByName('ODD').AsString :=sOdd;
     FieldByName('DIL').AsString :=sDIL;
     FieldByName('POR').AsString :=sPOR;
     FieldByName('ID').AsString  :='-1';
     SetRangeEnd;
     FieldByName('ODD').AsString :=sODD;
     FieldByName('DIL').AsString :=sDIL;
     FieldByName('POR').AsString :=sPOR;
     FieldByName('ID').AsString  :='99999';
     ApplyRange;
     first;
     if Eof then //nenasel Porost
      begin
       SetRangeStart;
       FieldByName('ODD').AsString :=sOdd;
       FieldByName('DIL').AsString :=sDIL;
       FieldByName('POR').AsString :='';
       FieldByName('ID').AsString  :='-1';
       SetRangeEnd;
       FieldByName('ODD').AsString :=sODD;
       FieldByName('DIL').AsString :=sDIL;
       FieldByName('POR').AsString :='';
       FieldByName('ID').AsString  :='99999';
       ApplyRange;
       first;
       if Eof then //nenasel dilec s prazdnym porostem
        begin
         SetRangeStart;
         FieldByName('ODD').AsString :=sOdd;
         FieldByName('DIL').AsString :='';
         FieldByName('POR').AsString :='';
         FieldByName('ID').AsString  :='-1';
         SetRangeEnd;
         FieldByName('ODD').AsString :=sODD;
         FieldByName('DIL').AsString :='';
         FieldByName('POR').AsString :='';
         FieldByName('ID').AsString  :='99999';
         ApplyRange;
         first;
         if Eof then //nenasel prazdne oddeleni
          begin
           najdiExplic;
          end
         else
          begin // nasel prazdne oddeleni
           najdiSktgVTabulce;
          end;
        end
       else
        begin //nasel dilec s prazdnym porostem
         najdiSktgVTabulce;
        end;
      end
     else
      begin //nasel Porost
       najdiSktgVTabulce;
      end;
    end; // nasel oddeleni
  end;
 SKTG:=VyhodStejneMeziZnaky('/',SKTG);
 if ubm(SKTG)='' then  SKTG:='10';
 result:=SKTG;
end;

function Texty_st_z_TabulkyPorostu(sODD,sDIL,sPor:string;TB_porKTG:TTable):string;
var iktg:integer;
    SPozn:string;
  procedure najdiTextVTabulce;
   begin
    with TB_porKTG do
     begin
      SPozn:='';
      if findfield('Poznamka')<>nil then
      begin
       while not Eof do
        begin
         SPozn:=sPozn+fieldByName('Poznamka').asstring;
         if SPozn<>'' then
          begin
           if sPozn[length(SPozn)]<>';' then SPozn:=sPozn+';';
          end;
         next;
        end;
      end;
       // if SPozn<>'' then  sPozn:=';'+sPozn;
     end;
   end;
 procedure najdiExplic;
  begin
   with TB_porKTG do
    begin
     SetRangeStart;
     FieldByName('ODD').AsString :='0';
     FieldByName('DIL').AsString :='';
     FieldByName('POR').AsString :='';
     FieldByName('ID').AsString  :='-1';
     SetRangeEnd;
     FieldByName('ODD').AsString :='0';
     FieldByName('DIL').AsString :='';
     FieldByName('POR').AsString :='';
     FieldByName('ID').AsString  :='99999';
     ApplyRange;
     first;
     if eof then
      begin
       exit;
      end
     else
      begin
       najdiTextVTabulce;
      end;
    end;
  end;
begin
 with TB_porKTG do
  begin
   active:=true;
   SetRangeStart;
   FieldByName('ODD').AsString :=sOdd;
   FieldByName('DIL').AsString :='';
   FieldByName('POR').AsString :='';
   FieldByName('ID').AsString  :='-1';
   SetRangeEnd;
   FieldByName('ODD').AsString :=sODD;
   FieldByName('DIL').AsString :='Z';
   FieldByName('POR').AsString :='z';
   FieldByName('ID').AsString  :='99999';
   ApplyRange;
   first;
   if eof then
    begin
     najdiExplic;
    end //nenasel Oddeleni
   else // nael Oddeleni
    begin
     SetRangeStart;
     FieldByName('ODD').AsString :=sOdd;
     FieldByName('DIL').AsString :=sDIL;
     FieldByName('POR').AsString :=sPOR;
     FieldByName('ID').AsString  :='-1';
     SetRangeEnd;
     FieldByName('ODD').AsString :=sODD;
     FieldByName('DIL').AsString :=sDIL;
     FieldByName('POR').AsString :=sPOR;
     FieldByName('ID').AsString  :='99999';
     ApplyRange;
     first;
     if Eof then //nenasel Porost
      begin
       SetRangeStart;
       FieldByName('ODD').AsString :=sOdd;
       FieldByName('DIL').AsString :=sDIL;
       FieldByName('POR').AsString :='';
       FieldByName('ID').AsString  :='-1';
       SetRangeEnd;
       FieldByName('ODD').AsString :=sODD;
       FieldByName('DIL').AsString :=sDIL;
       FieldByName('POR').AsString :='';
       FieldByName('ID').AsString  :='99999';
       ApplyRange;
       first;
       if Eof then //nenasel dilec s prazdnym porostem
        begin
         SetRangeStart;
         FieldByName('ODD').AsString :=sOdd;
         FieldByName('DIL').AsString :='';
         FieldByName('POR').AsString :='';
         FieldByName('ID').AsString  :='-1';
         SetRangeEnd;
         FieldByName('ODD').AsString :=sODD;
         FieldByName('DIL').AsString :='';
         FieldByName('POR').AsString :='';
         FieldByName('ID').AsString  :='99999';
         ApplyRange;
         first;
         if Eof then //nenasel prazdne oddeleni
          begin
           najdiExplic;
          end
         else
          begin // nasel prazdne oddeleni
           najdiTextVTabulce;
          end;
        end
       else
        begin //nasel dilec s prazdnym porostem
         najdiTextVTabulce;
        end;
      end
     else
      begin //nasel Porost
       najdiTextVTabulce;
      end;
    end; // nasel oddeleni
  end;
 // SKTG:=VyhodStejneMeziZnaky('/',SKTG);
 result:=SPozn;
end;


function ZvlSt_st_z_TabulkyPorostu(sODD,sDIL,sPor:string;TB_porZvlSt:TTable):string;
// pred opravou 17.5. 2007
var iZvlSt:integer;
    SZvlSt:string;
  procedure najdiSZvlStVTabulce;
   begin
    with TB_porZvlSt do
     begin
      SZvlSt:='';
      while not Eof do
       begin
        if     (ubm(fieldByName('Org_Uroven2').asstring) <> '')
           and (ubm(fieldByName('Org_Uroven2').asstring) <> '0') then
         begin
          if SZvlSt<>''then SZvlSt:=SZvlSt+'/';
          SZvlSt:=SZvlSt+fieldByName('Org_Uroven2').asstring;
         end;
        next;
       end;
     end;
   end;
 procedure najdiExplic;
  begin
   with TB_porZvlSt do
    begin
     SetRangeStart;
     FieldByName('ODD').AsString :='0';
     FieldByName('DIL').AsString :='';
     FieldByName('POR').AsString :='';
     FieldByName('ID').AsString  :='-1';
     SetRangeEnd;
     FieldByName('ODD').AsString :='0';
     FieldByName('DIL').AsString :='';
     FieldByName('POR').AsString :='';
     FieldByName('ID').AsString  :='99999';
     ApplyRange;
     first;
     if eof then
      begin
       SZvlSt:='';
       exit;
      end
     else
      begin
       najdiSZvlStVTabulce;
      end;
    end;
  end;
begin
 with TB_porZvlSt do
  begin
   active:=true;
   SetRangeStart;
   FieldByName('ODD').AsString :=sOdd;
   FieldByName('DIL').AsString :='';
   FieldByName('POR').AsString :='';
   FieldByName('ID').AsString  :='-1';
   SetRangeEnd;
   FieldByName('ODD').AsString :=sODD;
   FieldByName('DIL').AsString :='Z';
   FieldByName('POR').AsString :='z';
   FieldByName('ID').AsString  :='99999';
   ApplyRange;
   first;
   if eof then
    begin
     najdiExplic;
    end //nenasel Oddeleni
   else // nael Oddeleni
    begin
     SetRangeStart;
     FieldByName('ODD').AsString :=sOdd;
     FieldByName('DIL').AsString :=sDIL;
     FieldByName('POR').AsString :=sPOR;
     FieldByName('ID').AsString  :='-1';
     SetRangeEnd;
     FieldByName('ODD').AsString :=sODD;
     FieldByName('DIL').AsString :=sDIL;
     FieldByName('POR').AsString :=sPOR;
     FieldByName('ID').AsString  :='99999';
     ApplyRange;
     first;
     if Eof then //nenasel Porost
      begin
       SetRangeStart;
       FieldByName('ODD').AsString :=sOdd;
       FieldByName('DIL').AsString :=sDIL;
       FieldByName('POR').AsString :='';
       FieldByName('ID').AsString  :='-1';
       SetRangeEnd;
       FieldByName('ODD').AsString :=sODD;
       FieldByName('DIL').AsString :=sDIL;
       FieldByName('POR').AsString :='';
       FieldByName('ID').AsString  :='99999';
       ApplyRange;
       first;
       if Eof then //nenasel dilec s prazdnym porostem
        begin
         SetRangeStart;
         FieldByName('ODD').AsString :=sOdd;
         FieldByName('DIL').AsString :='';
         FieldByName('POR').AsString :='';
         FieldByName('ID').AsString  :='-1';
         SetRangeEnd;
         FieldByName('ODD').AsString :=sODD;
         FieldByName('DIL').AsString :='';
         FieldByName('POR').AsString :='';
         FieldByName('ID').AsString  :='99999';
         ApplyRange;
         first;
         if Eof then //nenasel prazdne oddeleni
          begin
           najdiExplic;
          end
         else
          begin // nasel prazdne oddeleni
           najdiSZvlStVTabulce;
          end;
        end
       else
        begin //nasel dilec s prazdnym porostem
         najdiSZvlStVTabulce;
        end;
      end
     else
      begin //nasel Porost
       najdiSZvlStVTabulce;
      end;
    end; // nasel oddeleni
  end;
 if ubm(SZvlSt)='0' then SZvlSt:='';
 SZvlSt:=VyhodStejneMeziZnaky('/',SZvlSt);
 result:=SZvlSt;

{
begin
 with TB_porZvlSt do
  begin
   active:=true;
   SetRangeStart;
   FieldByName('ODD').AsString :=sOdd;
   FieldByName('DIL').AsString :=sDIL;
   FieldByName('POR').AsString :=sPOR;
   FieldByName('ID').AsString  :='-1';
   SetRangeEnd;
   FieldByName('ODD').AsString :=sODD;
   FieldByName('DIL').AsString :=sDIL;
   FieldByName('POR').AsString :=sPOR;
   FieldByName('ID').AsString  :='99999';
   ApplyRange;
   first;
   sZvlSt:='';
   while not Eof do
    begin
     if sZvlSt<>''then SZvlSt:=sZvlSt+'/';
     sZvlSt:=sZvlSt+fieldByName('Org_Uroven2').asstring;
     next;
    end;
  end;
 if ubm(SZvlSt)='0' then SZvlSt:='';
 SZvlSt:=VyhodStejneMeziZnaky('/',SZvlSt);
 result:=SZvlSt;
}
end;


 end.
