Unit MAT;

Interface

{ uses CRT; }

Function  Expp(X:real):real;  {osetrena exponencialni funkce}
Function  RPower(X,Y:real):real;
Function  IntPower(X:real;N:integer):real;
Function  Min(X,Y:real):real;
Function  Max(X,Y:real):real;
Function  IntMin(X,Y:integer):integer;
Function  IntMax(X,Y:integer):integer;
Function  LongIntMin(X,Y:longint):longint;
Function  LongIntMax(X,Y:longint):longint;
Function  Log(X:real):real;
Function  Rad(X:real):integer;
Function  NCIS(X:real):integer;
Function  FNZ(X:real;K:integer):real;
Function  NumW(R:real):integer;{zjisteni celkoveho poctu mist cisla - pro popis}
Function  StDev(SumaX,SumaX2,N:real):real;
Function  Student(N :integer) :real; {hladina vyznamnosti = 0.05}
{ Procedure ESC;
  Procedure Stop; zastaveni programu s odmacknutim klavesy}
{ Procedure Open(var f:text); }
Function ByteStr(B :byte) :string; {identifikace 1 bytu podle bitu}
Function Byte_Word(Lo,Hi :byte) :word;   {vytvoreni promenne WORD ze 2 BYTE}
Function Byte_Int(Lo,Hi :byte) :integer; {vytvoreni promenne INTEGER ze 2 BYTE}
{ Procedure CRTread(Filename :string); {cteni obsahu CRT do souboru}
{CH-R H }             Function Eq1(A,c,b,t:real):real;
{CH-R b }             Function Eq2(A,c,H,t:real):real;
{CH-R A }             Function Eq3(b,c,H,t:real):real;
{CH-R c }             Function Eq4(A,b,H,t:real):real;
{CH-R prirust}        Function Eq5(A,c,b,t :real) :real;
{CH-R SI (Burk-Tenn}  Function Eq6(Beta,c,SIAGE,H,t :real) :real;
{CH-R SI (Southland}  Function Eq7(Accuracy,Alpha,Beta,c,SIAGE,H,t :real) :real;
{CH-R SI (b local}    Function Eq8(Accuracy,A0,A1,C0,C1,H,t :real) :real;
{CH-R SI (b const}    Function Eq8a(Accuracy,b,C0,C1,H,t :real) :real;
{Korf H }             Function Korf(A,k,n,t :real) :real;
{Korf k }             Function Korf_k(A,n,H,t :real) :real;
{Korf SI }            Function Eq9(Accuracy,A0,A1,n,H,t :real) :real;
{Korf prirust}        Function Eq10(A,k,n,t :real) :real;
{Mitserlich H}        Function Eq11(A,B,C,t :real) :real;
{Mitserlich prirust}  Function Eq12(A,B,C,t :real) :real;

Implementation

Function expp(X:real):real;
  {osetrena exponencialni funkce}
    begin
      if X<-88 then expp:=0 else expp:=exp(X);
    end;{expp}

Function RPower;{(X,Y:real):real;}
  begin if X=0 then Rpower:=0 else Rpower:=exp(Y*ln(X));end;

Function IntPower;{(X:real;N:integer):real;}
{vypocet mocniny - celociselne }
   var
      V:real;
   begin
      V:=1;
      while N>0 do
         begin
            while not odd(N) do
               begin N:=N div 2; X:=sqr(X); end;
            N:=N-1;V:=V*X;
         end;
     IntPower:=V;
   end;{IntPower}

Function Min; begin if X<Y then Min:=X else Min:=Y; end;
Function Max; begin if X>Y then Max:=X else Max:=Y; end;
Function IntMin; begin if X<Y then IntMin:=X else IntMin:=Y; end;
Function IntMax; begin if X>Y then IntMax:=X else IntMax:=Y; end;
Function LongIntMin; begin if X<Y then LongIntMin:=X else LongIntMin:=Y; end;
Function LongIntMax; begin if X>Y then LongIntMax:=X else LongIntMax:=Y; end;
Function Log; begin Log:=ln(abs(X))/ln(10);end;
Function Rad;
  begin
    if X=0 then Rad:=0
    else if (log(X)<0)and(frac(log(X))<>0) then Rad:=trunc(log(X))-1 else Rad:=trunc(log(X));
  end;{Rad}

Function NCIS;
  var A:string[19];I:integer;
  begin
    str(X:19,A);
    while A[1] in [' ','-'] do delete(A,1,1); {odmazani mezer a - zpredu}
    while A[length(A)]<>'E' do delete(A,length(A),1);
    delete(A,length(A),1); {odmazani exponentu}
    I:=12;while A[I]='0' do I:=I-1;
    NCIS:=I-1;
  end;{NCIS}

Function FNZ;
{Zaokrouhlovani X na K cislic}
  const N=17+0;
  var I,Code:integer;A:string[N];

  Procedure Up(I:integer);
    begin
      A[I]:=succ(A[I]);
      if A[I]=':' then
        if I=2 then
          begin
            A[I]:='1';
            if A[14]='+'then Up(16)
            else
                if A[16]<>'0' then A[16]:=pred(A[16])
                else begin A[16]:='9';A[15]:=pred(A[15]);end;
          end
        else begin A[I]:='0';Up(I-1);end;
    end;{Up}

  begin{FNZ}
    str(X:N,A);
    delete(A,3,1);
    if A[1]<>'-' then A[1]:='+';
    if A[K+2]>='5' then Up(K+1);
    for I:=K+2 to 12 do A[I]:='0';
    insert('.',A,3); Val(A,X,Code);
    FNZ:=X;
  end;{FNZ}

Function NumW;
{zjisteni celkoveho poctu mist cisla - pro popis}
  var I:integer;
  begin
    if rad(R)>=0 then
      begin
        if rad(R)+1=Ncis(R) then I:=Ncis(R)
        else if rad(R)+1>Ncis(R) then  I:=rad(R)+1
        else if rad(R)+1<Ncis(R) then I:=Ncis(R)+1;
      end
    else I:=Ncis(R)-rad(R)+1;
    if R<0 then inc(I); {znamenko -}
    NumW:=I;
  end;{NumW}

Function StDev;
  begin
    if N=1 then StDev:=0
    else StDev:=sqrt((SumaX2-N*sqr(SumaX/N))/(N-1));
  end;{StDev}

Function Student;
  begin
    Student:=1.955+2.713/(N-1)+8.037/IntPower(N-1,3);
  end;{Student}
(*
Procedure ESC;
  begin
    if keypressed then readln;
  end;

Procedure Stop;
  var CH :char;
  begin
    CH:=readkey;
    halt;
  end;

Procedure Open;
  begin
    {$I-}append(f);{$I+}
    if IORESULT<>0 then rewrite(f);
  end;{Open}
*)
{CH-R H }Function Eq1(A,c,b,t:real):real;  begin Eq1 :=A*RPower(1-exp(-b*t),1/c);end;
{CH-R b }Function Eq2(A,c,H,t:real):real;  begin Eq2 :=-ln(1-RPower(H/A,c))/t;end;
{CH-R A }Function Eq3(b,c,H,t:real):real;  begin Eq3 :=H/RPower(1-exp(-b*t),1/c);end;
{CH-R c }Function Eq4(A,b,H,t:real):real;  begin Eq4 :=ln(1-exp(-b*t))/ln(H/A);end;
Function Eq5;
 var H :real;
 begin
   H:=Eq1(A,c,b,t);
   Eq5:=b*H*(rpower(A/H,c)-1)/c;
 end;{Eq5}

Function Eq6;
  var H100 :real;

  Function Ht(t,H100 :real) :real;
  {vypocet vysky pro vek t pri zadane bonite H-SIAGE}
    var A,b :real;
    begin
      A:=H100/rpower(1.e0-EXP(-SIAGE*Beta*H100),1/c);
      b:=Beta*H100;
      Ht:=Eq1(A,c,b,t);
    end;{Ht}

  begin{Eq6}
   {1. odhad H100}
    H100:=H;
   {upresneni H100 (presnost hledane H na 0.01m) }
    while round(Ht(t,H100)*100)<>round(H*100) do
      H100:=H100 + H-Ht(t,H100);
   {---}
    Eq6:=H100;
  end;{Eq6}

Function Eq7; {vypocet bonity - Southland model}
  var H100 :real;

  Function Ht(t,H100 :real) :real;
  {vypocet vysky pro vek t pri zadane bonite H-SIAGE}
    var A,b :real;
    begin
      A:=Alpha+Beta*H100;
      b:=-1/SIAGE*ln(1.0-rpower(H100/A,c));
      Ht:=Eq1(A,c,b,t);
    end;{Ht}

  begin{Eq7}
   {1. odhad H100}
    H100:=H;
   {upresneni H100 (presnost hledane H na Accuracy) }
    Accuracy:=1/Accuracy;
    while round(Ht(t,H100)*Accuracy)<>round(H*Accuracy) do
      H100:=H100 + H-Ht(t,H100);
   {---}
    Eq7:=H100;
  end;{Eq7}

Function Eq8; {vypocet bonity - b=const A=a0+a1*SI c=c0+c1*SI}
  var H100 :real;

  Function Ht(t,H100 :real) :real;
  {vypocet vysky pro vek t pri zadane bonite H-SIAGE}
    var A,c,b :real;
    begin
      A:=A0+A1*H100;
      c:=C0+C1*H100;
      b:=Eq2(A,c,H100,100);
      Ht:=Eq1(A,c,b,t);
    end;{Ht}

  begin{Eq8}
   {1. odhad H100}
    H100:=H;
   {upresneni H100 (presnost hledane H na Accuracy) }
    Accuracy:=1/Accuracy;
    while round(Ht(t,H100)*Accuracy)<>round(H*Accuracy) do
      H100:=H100 + H-Ht(t,H100);
   {---}
    Eq8:=H100;
  end;{Eq8}

Function Eq8a; {vypocet bonity - b=const A=a0+a1*SI c=c0+c1*SI}
  var H100 :real;

  Function Ht(t,H100 :real) :real;
  {vypocet vysky pro vek t pri zadane bonite H-SIAGE}
    var A,c :real;
    begin
      c:=C0+C1*H100;
      A:=Eq3(b,c,H100,100);
      Ht:=Eq1(A,c,b,t);
    end;{Ht}

  begin{Eq8a}
   {1. odhad H100}
    H100:=H;
   {upresneni H100 (presnost hledane H na Accuracy) }
    Accuracy:=1/Accuracy;
    while round(Ht(t,H100)*Accuracy)<>round(H*Accuracy) do
      H100:=H100 + H-Ht(t,H100);
   {---}
    Eq8a:=H100;
  end;{Eq8a}

Function Eq9; {vypocet bonity - n=const A=a0+a1*SI Korf}
  var H100 :real;

  Function Ht(t,H100 :real) :real;
  {vypocet vysky pro vek t pri zadane bonite H-SIAGE}
    var A,k :real;
    begin
      A:=A0+A1*H100;
      k:=Korf_k(A,n,H100,100);
      Ht:=Korf(A,k,n,t);
    end;{Ht}

  begin{Eq9}
   {1. odhad H100}
    H100:=H;
   {upresneni H100 (presnost hledane H na Accuracy) }
    Accuracy:=1/Accuracy;
    while round(Ht(t,H100)*Accuracy)<>round(H*Accuracy) do
      H100:=H100 + H-Ht(t,H100);
   {---}
    Eq9:=H100;
  end;{Eq9}

{Korf H }Function Korf;  begin Korf:=A*exp(k/(1-n)*rpower(t,1-n));end;
{Korf k }Function Korf_k;
  begin Korf_k:=(1-n)*ln(H/A)/rpower(t,1-n);end;

Function Eq10; {bezny prirust podle Korfa}
  begin
    Eq10:=A*exp(k/(1-n)/rpower(t,n-1))*k/rpower(t,n);
  end;{Eq10}

Function Eq11;
  begin
    Eq11:=A*(1-B*exp(-C*t));
  end;

Function Eq12;
  begin
    Eq12:=A*B*C*exp(-C*t);
  end;

{$R-}
Function ByteStr(B :byte) :string; {identifikace 1 bytu podle bitu}
  const M :array[0..7] of byte =(1,2,4,8,16,32,64,128);
  var I :integer; S :string[8];
  begin
    S:='00000000';
    for I:=7 downto 0 do
      begin
        if B div M[I] = 1 then begin S[I+1]:='1';B:=B-M[I];end;
      end;
    ByteStr:=S;
  end;{ByteStr}
{$R+}
Function Byte_Word(Lo,Hi :byte) :word;
{vytvoreni promenne word ze 2 bytu}
  const D :array[1..16] of word=(1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768);
  var I,B :word; S :string[16];
  begin
    S:=ByteStr(Lo)+ByteStr(Hi);
    B:=0;
    for I:=1 to 16 do if S[I]='1' then B:=B+D[I];
    Byte_Word:=B;
  end;{Byte_Word}

Function Byte_Int(Lo,Hi :byte) :integer;
{vytvoreni promenne word ze 2 bytu}
  const D :array[1..16] of word=(1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768);
  var I,B :integer; S :string[16]; P :byte;
  begin
    if Hi>=128 then begin P:=0;Hi:=Hi-128;end else P:=1;
    S:=ByteStr(Lo)+ByteStr(Hi);
    B:=0;for I:=1 to 16 do if S[I]='1' then B:=B+D[I];
    if P=1 then Byte_Int:=B else Byte_Int:=B-D[16];
  end;{Byte_Int}
(*
Procedure CRTread(FileName :string); {cteni obsahu obrazovky do souboru}
  type Scr   = array[1..24,1..80,1..2] of char; {3840 byte}
  var  { ColoD :Scr ABSOLUTE $B800 : 0000; }
       f     :text;
       I,J   :integer;
  begin
    assign(f,FileName);open(f);
    for I:=1 to 24 do
      begin
        for J:=1 to 80 do write(f,ColoD[I,J,1]);
        writeln(f);
      end;
  end;{CRTread}
*)
end.
