unit Ptcanvas;
interface
uses
  SysUtils, WinTypes, WinProcs, Messages,
  Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls,printers_F,
  hkCanvas,U_zobraz,ELesObec,
  E_LesOdd,E_LesLHC,LesCisel,dtbles98,mat1;

type
  TFPTCanvas = class(TForm)
    Image1: TImage;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
FPTCanvas: TFPTCanvas;
procedure tiskPloTabOddeleni(VODD:TOddeleni;Strana,strana_pozadovana_k_tiskuI:integer;
            CanvasV:TCanvas;merX,MerY:longint;
            NaTiskarnu2,tiskSouctu:Boolean;oddMN:TOddeleniMN;
            tiskPorost:boolean;TisknoutMajitele:boolean;HavlBrod:Boolean;VColor:TColor);
procedure TiskKatastru(oddMn:TOddeleniMN;CanvasV:TCanvas;merX,MerY:longint;NaTiskarnu1:Boolean;VColor:TColor);
procedure TiskPot_Vlast(oddMn:TOddeleniMN;CanvasV:TCanvas;merX,MerY:longint;NaTiskarnu1:Boolean;VColor:TColor);
implementation

{$R *.DFM}
uses {UVybHkPt!} tisky;
procedure tiskPloTabOddeleni(VODD:TOddeleni;Strana,strana_pozadovana_k_tiskuI:integer;
            CanvasV:TCanvas;merX,MerY:longint;
                 NaTiskarnu2,tiskSouctu:Boolean;oddMN:TOddeleniMN;
                 tiskPorost:boolean;TisknoutMajitele:boolean;HavlBrod:Boolean;VColor:TColor);
var XA1,XA2,XA3,XA3a,XA4,XA5,XA6,XA7,XA8,XA9,XA10,XA11,XA12,Xam:longint;
    XA4D,XA5D,XAR1D,XAR2D,XAR6D,XAR11D,XAR12D:longint;
    XAR,XAR1,XAR2,XAR3,XAR4,XAR5,XAR6,XAR7,XAR9,XAR10,XAR11,XAR12,XAR13:longint;
    XAR7a,XAR7b,XAR7c:longint;
    xpp:longint;
    RADx:longint;
    YR1,YR1T,YR1TT,YR2,YR3,YR4,RH,RADy,YR2T,YR4T,YR4TT,
    YRR,YP,merYMax:longint;
    FS,FSD,FSDK,FSDM:longint;
    netisknout1:Boolean;
function mx(x:real):longint;
 begin
  mx:=mx1(x,MerX);
 end;
function my(y:real):longint;
 begin
  my:=my1(y,mery);
 end;
function YPT:longint;
 begin
  result:=YP+my(0.1);
 end;
procedure nastavBody;
 begin
   FS:=7;
   FSD:=9;
   FSDK:=12;
   FSDM:=3;
   radx:=   mx(0.40);
   XAR:=    mx(0.807);  //  mx(0.98);
   Xa1:=    mx(2.00);
   Xa2:=Xa1+mx(0.75);
   Xa3:=Xa2+mx(0.45);
   if tiskPorost then
    begin
     Xa3a:=Xa3  + mx(0.45);
     Xa4 :=Xa3a + mx(0.82);
     Xa5 :=Xa4  + mx(0.83);
    end
   else
    begin
     Xa3a:=Xa3;
     Xa4:=Xa3+mx(1.00);
     Xa5:=Xa4+mx(1.10);
    end;
   Xa6:=Xa5+mx(2.50);
   Xa7:=Xa6+mx(1.50);
   XaR1:=Xa7+XAR;
   XaR2:=XaR1+XAR;
   XaR3:=XaR2+XAR;
   XaR4:=XaR3+XAR;
   XaR5:=XaR4+XAR;
   XaR6:=XaR5+XAR;
   XaR7a:=XaR6+XAR;
   XaR7b:=XaR7a+XAR;
   XaR7c:=XaR7b+XAR;
   XaR7 :=XaR7c+XAR;

   Xa8:=XaR7+XAR;
   XaR9:=Xa8+XAR;
   XaR10:=XaR9+XAR;
   XaR11:=XaR10+XAR;
   XaR12:=XaR11+XAR;
   XaR13:=XaR12+XAR;
   Xa9:=XaR13+XAR;
   Xa10:=Xa9+mx(1.40);
   Xa11:=Xa10+mx(1.85);
   Xa12:=Xa11+mx(1.55);
   xpp:=mx(0.1);
   YR1:=my(1.8)+YRR;
   YR1T:=YR1+my(1.40);
   YR1TT:=YR1+my(0.1);
   if HavlBrod then RH:=my(4.5)
   else RH:=my(3.5);
   RADy:=my(0.5);
   YR2:=YR1+RH;
   YR2T:=YR2-RADy-my(0.2);
   YR3:=YR1+RADy;
   YR4:=YR2-RADy;
   YR4T:=YR4-my(0.1);
   YR4TT:=YR4+my(0.1);
   YP:=YR2;
 end;
procedure HoleOdstrankovani;
begin
if NaTiskarnu2 then
 begin
  with printer do
   begin
    if not netisknout1 then
     begin
      newpage;
      MerYMax:=round(mery*0.95);
     end;
   end;
 end
else
 begin
   YRR:=YRR+round(screen.height*1.1);
   merYMax:=YRR+round(screen.height);
 end;
end;

procedure tiskniSvisleCarkyRadkuProSoucet;
 begin
  with canvasV do
   begin
     pen.width:=5;
     PolyLine([Point(XA1,YP),
               Point(XA1,YP+RADy)]);
     PolyLine([Point(XA6,YP),
               Point(XA6,YP+RADy)]);
     PolyLine([Point(XA7,YP),
               Point(XA7,YP+RADy)]);
     PolyLine([Point(XA8,YP),
               Point(XA8,YP+RADy)]);
     PolyLine([Point(XA9,YP),
               Point(XA9,YP+RADy)]);
     PolyLine([Point(XA10,YP),
               Point(XA10,YP+RADy)]);
     PolyLine([Point(XA12,YP),
               Point(XA12,YP+RADy)]);
     PolyLine([Point(XA11,YP),
               Point(XA11,YP+RADy)]);
     pen.width:=1;

     PolyLine([Point(XA2,YP),
               Point(XA2,YP+RADy)]);
     PolyLine([Point(XA3,YP),
               Point(XA3,YP+RADy)]);
     if tiskPorost then
      begin
       PolyLine([Point(XA3a,YP),
                 Point(XA3a,YP+RADy)]);
      end;
     {
     PolyLine([Point(XA4,YP),
               Point(XA4,YP+RADy)]);
     PolyLine([Point(XA5,YP),
               Point(XA5,YP+RADy)]);
     }
     PolyLine([Point(XAR1,YP),
               Point(XAR1,YP+RADy)]);
     PolyLine([Point(XAR2,YP),
               Point(XAR2,YP+RADy)]);
     PolyLine([Point(XAR3,YP),
               Point(XAR3,YP+RADy)]);
     PolyLine([Point(XAR4,YP),
               Point(XAR4,YP+RADy)]);
     PolyLine([Point(XAR5,YP),
               Point(XAR5,YP+RADy)]);
     PolyLine([Point(XAR6,YP),
               Point(XAR6,YP+RADy)]);
     PolyLine([Point(XAR7,YP),
               Point(XAR7,YP+RADy)]);
     PolyLine([Point(XAR7a,YP),
               Point(XAR7a,YP+RADy)]);
     PolyLine([Point(XAR7b,YP),
               Point(XAR7b,YP+RADy)]);
     PolyLine([Point(XAR7c,YP),
               Point(XAR7c,YP+RADy)]);
     PolyLine([Point(XAR9,YP),
               Point(XAR9,YP+RADy)]);
     PolyLine([Point(XAR10,YP),
               Point(XAR10,YP+RADy)]);
     PolyLine([Point(XAR11,YP),
               Point(XAR11,YP+RADy)]);
     PolyLine([Point(XAR12,YP),
               Point(XAR12,YP+RADy)]);
     PolyLine([Point(XAR13,YP),
               Point(XAR13,YP+RADy)]);

   end;
 end;
procedure tiskniSvisleCarkyRadku;
 begin
  tiskniSvisleCarkyRadkuProSoucet;
  with canvasV do
   begin
     pen.width:=1;
     PolyLine([Point(XA4,YP),
               Point(XA4,YP+RADy)]);
     PolyLine([Point(XA5,YP),
               Point(XA5,YP+RADy)]);
   end;
 end;
procedure VybarvyRadek;
 begin
  With canvasV do
   begin
    Brush.Color:=VColor;//clYellow;
    fillRect(rect(XA1,YP+my(0.03),XA12,YP+RADy));
    Brush.color:=ClWhite;
   end;
 end;
procedure TiskniRadekProZapsani;
 begin
  tiskniSvisleCarkyRadku;
  with canvasV do
   begin
    pen.width:=1; Pen.Style := psDot;
    PolyLine([Point(XA1,YP+RADy),
              Point(XA12,YP+RADy)]);
    pen.width:=1; Pen.Style := psSolid;
   end;
 end;
procedure TiskniRadekProSoucet;
 begin
  VybarvyRadek;
  tiskniSvisleCarkyRadkuProSoucet;
  with canvasV do
   begin
    pen.width:=5;
    PolyLine([Point(XA1,YP+RADy),
              Point(XA12,YP+RADy)]);
   end;
 end;
procedure tiskniHlavicku;
 begin
  nastavBody;
  with canvasV do
   begin
        // FONT.NAME:='Arial CE';
        FONT.NAME:='Arial';
        Font.Size:=FSDK;
        Font.Style:=[fsBold];
        if not(tiskSouctu)
         then TextOut(XA1,YR1-2*RADy,
             'A. Pehledn sestaven ploch a vmr dle zkladnch jednotek rozdlen lesa')
         else TextOut(XA1,YR1-2*RADy,' Sum ');
        if TisknoutMajitele then
         begin
          IF VODD<>NIL then
           begin
            //FONT.NAME:='Arial CE';
            FONT.NAME:='Arial';
            Font.Size:=FS;
            Font.Style:=[fsBold];
            if not VOdd.dilecMN.AktualniPrvekJeVMnozine then
             begin
              VOdd.NastavNeboVytvorPrvniPorost;
             end;
            if not VOdd.dilec.porostMN.AktualniPrvekJeVMnozine then
             begin
              VOdd.NastavNeboVytvorPrvniPorost;
             end;
            TextOut(XA1,YR1-RADy,'Majitel:  '+vodpalZavinac(VOdd.Dilec.Porost.MAJ_NAZ));
            TextOutPK(canvasV,XA12,YR1-RADy,'slo:  '+intToStr(VOdd.Dilec.Porost.MAJ_KOD));
           end;
         end;
        // FONT.NAME:='Arial CE';
        FONT.NAME:='Arial';
        Font.Size:=FSD;
        Font.Style:=[];
        SetTextOrientation(CanvasV,90);
        TextOutSsv(canvasV,XA1,XA2,YR2T,'Oddlen');
        TextOutSsv(canvasV,XA2,XA3,YR2T,'Dlec');
        if tiskPorost then TextOutSsv(canvasV,XA3,XA3a,YR2T,'Porost');
        Xam:=mx(0.11);
        XA4D:=((XA4-Xam)-(XA3a+Xam)) div 2;
        TextOutSsv(canvasV,XA3a,XA4-XA4d,YR2T,'Bezles a');
        TextOutSsv(canvasV,XA3a+XA4D,XA4,YR2T,'jin pozemky');
        XA5D:=((XA5-Xam)-(XA4+Xam)) div 2;
        TextOutSsv(canvasV,XA4,XA5-XA5d,YR2T,'Pozemky ');
        TextOutSsv(canvasV,XA4+XA5D,XA5,YR2T,'mimo PUPFL ');
        if not HavlBrod then
         begin
          pen.Width:=1;
          // FONT.NAME:='Arial CE';
          FONT.NAME:='Arial';
          Font.Size:=FS;
          Font.Style:=[];
          SetTextOrientation(CanvasV,90);
         end;

        XAR1D:=((XAR1-mx(0.15))-(XA7+mx(0.15))) div 2;
        TextOutSsv(canvasV,XA7,XAR1-XAR1D,YR4T,'Rozleovac prseky');
        TextOutSsv(canvasV,XA7+XAR1D,XAR1,YR4T,'ir ne 4 m');
        XAR2D:=((XAR2-mx(0.15))-(XAR1+mx(0.15))) div 2;
        TextOutSsv(canvasV,XAR1,XAR2-XAR2D,YR4T,'Nezpevnn lesn');
        TextOutSsv(canvasV,XAR1+XAR2D,XAR2,YR4T,'cesty ir ne 4M');

        TextOutSsv(canvasV,XAR2,XAR3,YR4T,'Lesn skldky');
        TextOutSsv(canvasV,XAR3,XAR4,YR4T,'Lesn kolky');
        TextOutSsv(canvasV,XAR4,XAR5,YR4T,'Semeni');

        XAR6D:=((XAR6-mx(0.15))-(XAR5+mx(0.15))) div 2;
        TextOutSsv(canvasV,XAR5,XAR6-XAR6D,YR4T,'Produktovody a');
        TextOutSsv(canvasV,XAR5+XAR6D,XAR6,YR4T,'elektrovody');

        TextOutSsv(canvasV,XAR6,XAR7a,YR4T,'Okusov plochy');
        TextOutSsv(canvasV,XAR7a,XAR7b,YR4T,'Semenn sady');
        TextOutSsv(canvasV,XAR7b,XAR7c,YR4T,'Matenice');
        TextOutSsv(canvasV,XAR7c,XAR7,YR4T ,'Klonov archvy');

        TextOutSsv(canvasV,XAR7,XA8,YR4T,'Dal bezles');

        TextOutSsv(canvasV,XA8,XAR9,YR4T,'Zpevnn lesn cesty');
        TextOutSsv(canvasV,XAR9,XAR10,YR4T,'Drobn vodn plochy');

        XAR11D:=((XAR11-mx(0.15))-(XAR10+mx(0.15))) div 2;
        TextOutSsv(canvasV,XAR10,XAR11-XAR11D,YR4T,'Pozemky nad horn');
        TextOutSsv(canvasV,XAR10+XAR11D,XAR11,YR4T,'hranic lesa');

        XAR12D:=((XAR13-mx(0.15))-(XAR12+mx(0.15))) div 2;
        TextOutSsv(canvasV,XAR11,XAR12-XAR12D,YR4T,'Lesn pastviny a');
        TextOutSsv(canvasV,XAR11+XAR12D,XAR12,YR4T,'polka pro zv');

        TextOutSsv(canvasV,XAR12,XAR13,YR4T,'Neplodn pdy');
        TextOutSsv(canvasV,XAR13,XA9,YR4T,'Dal jin pozemky');

        // FONT.NAME:='Arial CE';
        FONT.NAME:='Arial';
        Font.Size:=FSD;
        Font.Style:=[];
        TextOutS(canvasV,XA5,XA6,YR1T,'Katastrln');
        TextOutS(canvasV,XA5,XA6,YR1T+RADy,'zem');

        TextOutS(canvasV,XA6,XA7,YR1T,'Porostn');
        TextOutS(canvasV,XA6,XA7,YR1T+RADy,'pda');
        TextOutS(canvasV,XA6,XA7,YR1T+2*RADy,'( ha )');

        TextOutS(canvasV,XA7,XA8,YR1tt,'Bezles ( ha )');
        TextOutS(canvasV,XA8,XA9,YR1tt,'Jin pozemky ( ha )');

        TextOutS(canvasV,XA9,XA10,YR1T,'PUPFL');
        TextOutS(canvasV,XA9,XA10,YR1T+RADy,'celkem');
        TextOutS(canvasV,XA9,XA10,YR1T+2*RADy,'( ha )');

        TextOutS(canvasV,XA10,XA11,YR1T,'Kategorie');
        TextOutS(canvasV,XA10,XA11,YR1T+RADy,'s pekryvem');

        TextOutS(canvasV,XA11,XA12,YR1T-RADy,'Pozemky');
        TextOutS(canvasV,XA11,XA12,YR1T,'mimo');
        TextOutS(canvasV,XA11,XA12,YR1T+RADy,'PUPFL');
        TextOutS(canvasV,XA11,XA12,YR1T+2*RADy,'( ha )');

        TextOutS(canvasV,XA7,XAR1,   YR4TT,'RP');
        TextOutS(canvasV,XAR1,XAR2,  YR4TT,'NC');
        TextOutS(canvasV,XAR2,XAR3,  YR4TT,'SK');
        TextOutS(canvasV,XAR3,XAR4,  YR4TT,'LS');
        TextOutS(canvasV,XAR4,XAR5,  YR4TT,'SP');
        TextOutS(canvasV,XAR5,XAR6,  YR4TT,'PE');
        TextOutS(canvasV,XAR6,XAR7a, YR4TT,'OP');
        TextOutS(canvasV,XAR7a,XAR7b,YR4TT,'SS');
        TextOutS(canvasV,XAR7b,XAR7c,YR4TT,'MA');
        TextOutS(canvasV,XAR7c,XAR7, YR4TT,'KA');
        TextOutS(canvasV,XAR7,XA8,   YR4TT,'DB');
        TextOutS(canvasV,XA8,XAR9,   YR4TT,'ZC');
        TextOutS(canvasV,XAR9,XAR10, YR4TT,'VP');
        TextOutS(canvasV,XAR10,XAR11,YR4TT,'HP');
        TextOutS(canvasV,XAR11,XAR12,YR4TT,'ZP');
        TextOutS(canvasV,XAR12,XAR13,YR4TT,'NP');
        TextOutS(canvasV,XAR13,XA9,  YR4TT,'DJ');

     pen.width:=5;
     PolyLine([Point(XA1,YR1),
               Point(XA12,YR1)]);
     PolyLine([Point(XA1,YR1),
               Point(XA1,YR2)]);
     PolyLine([Point(XA6,YR1),
               Point(XA6,YR2)]);
     PolyLine([Point(XA7,YR1),
               Point(XA7,YR2)]);
     PolyLine([Point(XA8,YR1),
               Point(XA8,YR2)]);
     PolyLine([Point(XA9,YR1),
               Point(XA9,YR2)]);
     PolyLine([Point(XA10,YR1),
               Point(XA10,YR2)]);
     PolyLine([Point(XA11,YR1),
               Point(XA11,YR2)]);
     PolyLine([Point(XA12,YR1),
               Point(XA12,YR2)]);

     pen.width:=1;
     PolyLine([Point(XA2,YR1),
               Point(XA2,YR2)]);
     PolyLine([Point(XA3,YR1),
               Point(XA3,YR2)]);
     if tiskPorost then
      begin
       PolyLine([Point(XA3a,YR1),
                 Point(XA3a,YR2)]);
      end;
     PolyLine([Point(XA4,YR1),
               Point(XA4,YR2)]);
     PolyLine([Point(XA5,YR1),
               Point(XA5,YR2)]);

     PolyLine([Point(XAR1,YR2),
               Point(XAR1,YR3)]);
     PolyLine([Point(XAR2,YR2),
               Point(XAR2,YR3)]);
     PolyLine([Point(XAR3,YR2),
               Point(XAR3,YR3)]);
     PolyLine([Point(XAR4,YR2),
               Point(XAR4,YR3)]);
     PolyLine([Point(XAR5,YR2),
               Point(XAR5,YR3)]);
     PolyLine([Point(XAR6,YR2),
               Point(XAR6,YR3)]);
     PolyLine([Point(XAR7,YR2),
               Point(XAR7,YR3)]);
     PolyLine([Point(XAR7a,YR2),
               Point(XAR7a,YR3)]);
     PolyLine([Point(XAR7b,YR2),
               Point(XAR7b,YR3)]);
     PolyLine([Point(XAR7c,YR2),
               Point(XAR7c,YR3)]);
     PolyLine([Point(XAR9,YR2),
               Point(XAR9,YR3)]);
     PolyLine([Point(XAR10,YR2),
               Point(XAR10,YR3)]);
     PolyLine([Point(XAR10,YR2),
               Point(XAR10,YR3)]);
     PolyLine([Point(XAR11,YR2),
               Point(XAR11,YR3)]);
     PolyLine([Point(XAR12,YR2),
               Point(XAR12,YR3)]);
     PolyLine([Point(XAR13,YR2),
               Point(XAR13,YR3)]);
     PolyLine([Point(XA7,YR4),
               Point(XA9,YR4)]);
     pen.width:=3;
     PolyLine([Point(XA11,YR1),
               Point(XA11,YR2)]);
     PolyLine([Point(XA7,YR3),
               Point(XA9,YR3)]);
     PolyLine([Point(XA12,YR2),
               Point(XA1,YR2)]);
   end;
 end;
procedure SouctovyRadekZaPorost;
 begin
  with VOdd do
  with CanvasV do
   begin
    TiskniRadekProSoucet;
    with VOdd.dilec.porost do
     begin
      TextOutPK(CanvasV,XA2,YPT,intTostr(ODD));
      TextOutS(CanvasV,XA2,XA3,YPT,VODD.dilec.DIL);
      if tiskPorost then TextOutS(CanvasV,XA3,XA3a,YPT,VODD.dilec.porost.POR);
      TextOutPK(CanvasV,XA7,YPT,floatTOStrf(PorostniPuda,ffFixed,8,2));
      TextOutPK(CanvasV,XA10,YPT,floatTOStrf(PlochaPUPFL,ffFixed,8,2));
      {TextOutS(CanvasV,XA10,XA11,YPT,Kategorie1MN.KategorieVcetnePrekryvu);}
      TextOUTPrelom(CanvasV,XA10,XA11,YPT,YPT+rady,true,uprostred,Kategorie1MN.KategorieVcetnePrekryvu);
      if PlochaOSTATNI>0.001 then
        TextOutPK(CanvasV,XA12,YPT,floatTOStrf(PlochaOSTATNI,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=1;
      // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR1,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XA7+XPP,XAR1,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=2;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR2,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR1+XPP,XAR2,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=3;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR3,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR2+XPP,XAR3,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=4;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR4,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR3+XPP,XAR4,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=5;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR5,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR4+XPP,XAR5,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=6;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR6,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR5+XPP,XAR6,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=7;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR7a,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR6+XPP,XAR7a,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=8;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR7b,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7a+XPP,XAR7b,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=9;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR7c,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7b+XPP,XAR7c,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=10;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR7,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7c+XPP,XAR7,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=11;

       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XA8,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7+XPP,XA8,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=12;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR9,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XA8+XPP,XAR9,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=13;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR10,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR9+XPP,XAR10,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=14;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR11,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR10+XPP,XAR11,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=15;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR12,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR11+XPP,XAR12,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=16;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR13,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR12+XPP,XAR13,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=17;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XA9,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR13+XPP,XA9,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
     end;
    yp:=yp+RADy;
   end;
 end;

procedure SouctovyRadekZaOddeleni;
 begin
  with VOdd do
   begin
  with canvasV do
   begin
    pen.width:=5;
    PolyLine([Point(XA1,YP+RADy),
              Point(XA12,YP+RADy)]);
   end;
    TiskniRadekProSoucet;
    with VOdd do
     begin
      TextOutS (CanvasV,XA2,XA6,YPT,'Celkem za oddlen : ');
      TextOutPK(CanvasV,XA2,YPT,intTostr(ODD));
      TextOutPK(CanvasV,XA7,YPT,floatTOStrf(PorostniPuda,ffFixed,8,2));
      TextOutPK(CanvasV,XA10,YPT,floatTOStrf(PlochaPUPFL,ffFixed,8,2));
      if PlochaOSTATNI>0.001 then
           TextOutPK(CanvasV,XA12,YPT,floatTOStrf(PlochaOSTATNI,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=1;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XA7+XPP,XAR1,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=2;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR1+XPP,XAR2,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=3;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR2+XPP,XAR3,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=4;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR3+XPP,XAR4,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=5;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR4+XPP,XAR5,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=6;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR5+XPP,XAR6,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=7;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR6+XPP,XAR7a,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=8;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7a+XPP,XAR7b,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=9;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7b+XPP,XAR7c,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=10;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7c+XPP,XAR7,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=11;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7+XPP,XA8,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=12;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XA8+XPP,XAR9,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=13;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR9+XPP,XAR10,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=14;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR10+XPP,XAR11,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=15;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR11+XPP,XAR12,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=16;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR12+XPP,XAR13,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=17;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR13+XPP,XA9,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      {
      PoradiAktualnihoVyuziti:=1;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR1,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=2;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR2,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=3;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR3,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=4;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR4,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=5;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR5,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=6;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR6,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=7;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR7a,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=8;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR7b,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=9;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR7c,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=10;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR7,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=11;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XA8,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=12;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR9,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=13;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR10,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=14;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR11,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=15;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR12,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=16;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR13,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=17;
       if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XA9,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      }
     end;
    yp:=yp+RADy;
   end;
 { printer.newPage; }
 end;
procedure TiskniPorost;
Function PorostSeVejde:boolean;
var zbyvaY:longint;
    ibz,iKtst:integer;
    VyjdeTisk,vyjdetoNaSirku:boolean;
 begin
 with CanvasV do
   begin
    with VOdd.dilec.porost do
     begin
      zbyvaY:=MerYMax-YP;
      for iKtst:=1 to PocetKatastruZeSkupin do
       begin
        PoradiAktualnihoKatastruZeSkupin:=iKtst;
        VyjdeTisk:=tiskniNeboVyzKousej(CanvasV,XA5,XA6,10,10+rady,uprostred,
                       NazevAktualnihoKatastruZeSkupin,false,
                       vyjdetoNaSirku);
        if VyjdeTisk and not(vyjdetoNaSirku) then vyjdeTisk:=false;
        if VyjdeTisk then
         begin
          zbyvaY:=zbyvaY-radY;
         end
        else
         begin
          zbyvaY:=zbyvaY-2*radY;
         end;
       end;
      with BezlesiMN do
       begin
        for ibz:=0 to count-1 do
         begin
          VyjdeTisk:=true;
          VyjdeTisk:=tiskniNeboVyzKousej(CanvasV,XA5,XA6,10,10+rady,uprostred,
                      TBezlesi(Elements[ibz]).NazevKatastru_BZL,false,vyjdetoNaSirku);
          if VyjdeTisk and not(vyjdetoNaSirku) then vyjdeTisk:=false;
          if VyjdeTisk then
           begin
            zbyvaY:=zbyvaY-radY;
           end
          else
           begin
            zbyvaY:=zbyvaY-2*radY;
           end;
         end;
       end;
      with JinyPozemekMN do
       begin
        for ibz:=0 to count-1 do
         begin
          VyjdeTisk:=tiskniNeboVyzKousej(CanvasV,XA5,XA6,10,10+rady,uprostred,
                        TJinyPozemek(Elements[ibz]).NazevKatastru_JP,false,vyjdetoNaSirku);
          if VyjdeTisk and not(vyjdetoNaSirku) then vyjdeTisk:=false;
          if VyjdeTisk then
           begin
            zbyvaY:=zbyvaY-radY;
           end
          else
           begin
            zbyvaY:=zbyvaY-2*radY;
           end;
         end;
       end;
      with OstatniMN do
       begin
        for ibz:=0 to count-1 do
         begin
          zbyvaY:=zbyvaY-radY;
         end;
       end;
     end;
   end;
  zbyvaY:=zbyvaY-radY; {soucet}
  result:=(ZbyvaY>0);
 end;
var ibz,iKtst,iJine,iOst:integer;
    zalFontSize:integer;
    XBZL,xbzl1,Xjp,xjp1:longint;
    vyjdetoNaSirku,VyjdeTisk:Boolean;
 begin
  with VOdd do
  with CanvasV do
   begin
    if    (Vodd.dilecMN.indexOf(VOdd.dilec)<>0)
        or (Vodd.dilec.porostMN.indexOf(VOdd.dilec.porost)<>0) then
      begin
       if not porostSeVejde then
        begin
         holeodstrankovani;
         tiskniHlavicku;
        end;
      end;
    with VOdd.dilec.porost do
     begin
      for iKtst:=1 to PocetKatastruZeSkupin do
       begin
        PoradiAktualnihoKatastruZeSkupin:=iKtst;
        if PoradiAktualnihoKatastruZeSkupin=1 then
         begin
          TextOutPK(CanvasV,XA2,YPT,intTostr(ODD));
          TextOutS(CanvasV,XA2,XA3,YPT,VODD.dilec.DIL);
          if TiskPorost then TextOutS(CanvasV,XA3,XA3a,YPT,VODD.dilec.porost.POR);
         end;
        // TextOutS(CanvasV,XA5,XA6,YPT,NazevAktualnihoKatastruZeSkupin);

        zalFontSize:=Canvasv.Font.size;
        CanvasV.Font.size:=7;
        VyjdeTisk:=tiskniNeboVyzKousej(CanvasV,XA5,XA6,YPT,YPT+rady,uprostred,
                       NazevAktualnihoKatastruZeSkupin,false,
                       vyjdetoNaSirku);

        CanvasV.Font.size:=zalFontSize;
        if VyjdeTisk and not(vyjdetoNaSirku) then vyjdeTisk:=false;
        if VyjdeTisk then
         begin
          TextOUTPrelom(CanvasV,XA5,XA6,YPT,YPT+rady,true,uprostred,NazevAktualnihoKatastruZeSkupin);
         end
        else
         begin
          TextOUTPrelom(CanvasV,XA5,XA6,YPT,YPT+2*rady,true,uprostred,NazevAktualnihoKatastruZeSkupin);
         end;
        TextOutPK(CanvasV,XA7,YPT,floatTOStrf(PlochaAktualnihoKatastruZeSkupin,ffFixed,6,2));
        TextOutPK(CanvasV,XA10,YPT,floatTOStrf(PlochaAktualnihoKatastruZeSkupin,ffFixed,6,2));
        TextOUTPrelom(CanvasV,XA10,XA11,YPT,YPT+rady,true,uprostred,Kategorie1MN.KategorieVcetnePrekryvu);
        // TextOutS(CanvasV,XA10,XA11,YPT,Kategorie1MN.KategorieVcetnePrekryvu);
        if VyjdeTisk then
         begin
          tiskniRadekProZapsani;
          yp:=yp+RADy;
         end
        else
         begin
          tiskniSvisleCarkyRadku;
          yp:=yp+RADy;
          tiskniRadekProZapsani;
          yp:=yp+RADy;
         end;
       end;
      with BezlesiMN do
       begin
        for ibz:=0 to count-1 do
         begin
          IF MerYMax<YP then
           begin
            holeodstrankovani;
            tiskniHlavicku;
           end;
          if Elements[ibz] is TBezlesi then
           begin
            { TextOutS(CanvasV,XA10,XA11,YPT,Kategorie1MN.KategorieVcetnePrekryvu); }
            TextOUTPrelom(CanvasV,XA10,XA11,YPT,YPT+rady,true,uprostred,Kategorie1MN.KategorieVcetnePrekryvu);
            with TBezlesi(Elements[ibz]) do
             begin
              TextOutS(CanvasV,XA3a,XA4,YPT,intToStr(BZL));

              zalFontSize:=CanvasV.Font.size;
              CanvasV.Font.size:=7;
              VyjdeTisk:=tiskniNeboVyzKousej(CanvasV,XA5,XA6,YPT,YPT+rady,uprostred,
                       NazevKatastru,false,
                       vyjdetoNaSirku);
              CanvasV.Font.size:=zalFontSize;

              if VyjdeTisk and not(vyjdetoNaSirku) then vyjdeTisk:=false;
              if VyjdeTisk then
               begin
                TextOUTPrelom(CanvasV,XA5,XA6,YPT,YPT+rady,true,uprostred,NazevKatastru);
               end
              else
               begin
                TextOUTPrelom(CanvasV,XA5,XA6,YPT,YPT+2*rady,true,uprostred,NazevKatastru);
               end;

              // TextOutS(CanvasV,XA5,XA6,YPT,NazevKatastru);

              XBzl:=XA8;
              if uppercase(VYUZITI)='RP' then begin xbzl1:=XA7  ;XBzl:=XAR1; end;
              if uppercase(VYUZITI)='NC' then begin xbzl1:=XAR1 ;XBzl:=XAR2; end;
              if uppercase(VYUZITI)='SK' then begin xbzl1:=XAR2 ;XBzl:=XAR3; end;
              if uppercase(VYUZITI)='LS' then begin xbzl1:=XAR3 ;XBzl:=XAR4; end;
              if uppercase(VYUZITI)='SP' then begin xbzl1:=XAR4 ;XBzl:=XAR5; end;
              if uppercase(VYUZITI)='PE' then begin xbzl1:=XAR5 ;XBzl:=XAR6; end;
              if uppercase(VYUZITI)='OP' then begin xbzl1:=XAR6 ;XBzl:=XAR7a; end;
              if uppercase(VYUZITI)='SS' then begin xbzl1:=XAR7a;XBzl:=XAR7b;  end;
              if uppercase(VYUZITI)='MA' then begin xbzl1:=XAR7b;XBzl:=XAR7c;  end;
              if uppercase(VYUZITI)='KA' then begin xbzl1:=XAR7c;XBzl:=XAR7;  end;
               if uppercase(VYUZITI)='DB'then begin xbzl1:=XAR7 ;XBzl:=XA8;  end;
             // TextOutPK(CanvasV,XBzl,YPT,floatTOStrf(BZL_P,ffFixed,6,2));
              TextOUTPrelom(CanvasV,xbzl1+XPP,xbzl,YPT,YPT+radY,true,naPravo,floatTOStrf(BZL_P,ffFixed,6,2));
              TextOutPK(CanvasV,XA10,YPT,floatTOStrf(BZL_P,ffFixed,6,2));
             end;
            if VyjdeTisk then
             begin
              tiskniRadekProZapsani;
              yp:=yp+RADy;
             end
            else
             begin
              tiskniSvisleCarkyRadku;
              yp:=yp+RADy;
              tiskniRadekProZapsani;
              yp:=yp+RADy;
             end;
           end;
         end;
       end;
               with JinyPozemekMN do
                begin
                 for ijine:=0 to count-1 do
                  begin
                   if not (Elements[iJine] is TJinyPozemek) then continue;
                  IF MerYMax<YP then
                    begin
                     holeodstrankovani;
                     tiskniHlavicku;
                    end;
                   with TJinyPozemek(Elements[iJine]) do
                    begin
                     TextOUTPrelom(CanvasV,XA10,XA11,YPT,YPT+rady,true,uprostred,Kategorie1MN.KategorieVcetnePrekryvu);
                     { TextOutS(CanvasV,XA10 ,XA11,YPT,OwnerPorost.Kategorie1MN.KategorieVcetnePrekryvu);}
                     TextOutS(CanvasV,XA3a ,XA4 ,YPT,intToStr(JP));
                     // TextOutS(CanvasV,XA5  ,XA6 ,YPT,NazevKatastru);

                     zalFontSize:=CanvasV.Font.size;
                     CanvasV.Font.size:=7;
                     VyjdeTisk:=tiskniNeboVyzKousej(CanvasV,XA5,XA6,YPT,YPT+rady,uprostred,
                            NazevKatastru,false,vyjdetoNaSirku);
                     CanvasV.Font.size:=zalFontSize;

                     if VyjdeTisk and not(vyjdetoNaSirku) then vyjdeTisk:=false;
                     if VyjdeTisk then
                      begin
                       TextOUTPrelom(CanvasV,XA5,XA6,YPT,YPT+rady,true,uprostred,NazevKatastru);
                      end
                     else
                      begin
                       TextOUTPrelom(CanvasV,XA5,XA6,YPT,YPT+2*rady,true,uprostred,NazevKatastru);
                      end;
                     Xjp:=XA9;
                     if uppercase(VYUZITI)='ZC' then begin xjp1:=XA8;Xjp:=XAR9; end;
                     if uppercase(VYUZITI)='VP' then begin xjp1:=XAR9;Xjp:=XAR10; end;
                     if uppercase(VYUZITI)='HP' then begin xjp1:=XAR10;Xjp:=XAR11; end;
                     if uppercase(VYUZITI)='ZP' then begin xjp1:=XAR11;Xjp:=XAR12; end;
                     if uppercase(VYUZITI)='NP' then begin xjp1:=XAR12;Xjp:=XAR13; end;
                     if uppercase(VYUZITI)='DJ' then begin xjp1:=XAR13;Xjp:=XA9; end;
                     TextOUTPrelom(CanvasV,xjp1+XPP,xjp,YPT,YPT+radY,true,naPravo,floatTOStrf(JP_P,ffFixed,6,2));
                     // TextOutPK(CanvasV,Xjp,YPT,floatTOStrf(JP_P,ffFixed,6,2));
                     TextOutPK(CanvasV,XA10,YPT,floatTOStrf(JP_P,ffFixed,6,2));
                    end;
                   if VyjdeTisk then
                    begin
                     tiskniRadekProZapsani;
                     yp:=yp+RADy;
                    end
                   else
                    begin
                     tiskniSvisleCarkyRadku;
                     yp:=yp+RADy;
                     tiskniRadekProZapsani;
                     yp:=yp+RADy;
                    end;
                  end;
                end;
               with OstatniMN do
                begin
                 for iOST:=0 to count-1 do
                  begin
                   if not (Elements[iOST] is TOstatni) then continue;
                   IF MerYMax<YP then
                    begin
                     holeodstrankovani;
                     tiskniHlavicku;
                    end;
                   with TOstatni(Elements[iOST]) do
                    begin
                     TextOutS(CanvasV,XA4,XA5,YPT,intToStr(OST));
                     TextOutPK(CanvasV,XA12,YPT,floatTOStrf(OST_P,ffFixed,6,2));

                     zalFontSize:=CanvasV.Font.size;
                     CanvasV.Font.size:=7;
                     VyjdeTisk:=tiskniNeboVyzKousej(CanvasV,XA5,XA6,YPT,YPT+rady,uprostred,
                            NazevKatastru,false,vyjdetoNaSirku);
                     CanvasV.Font.size:=zalFontSize;

                     if VyjdeTisk and not(vyjdetoNaSirku) then vyjdeTisk:=false;
                     if VyjdeTisk then
                      begin
                       TextOUTPrelom(CanvasV,XA5,XA6,YPT,YPT+rady,true,uprostred,NazevKatastru);
                      end
                     else
                      begin
                       TextOUTPrelom(CanvasV,XA5,XA6,YPT,YPT+2*rady,true,uprostred,NazevKatastru);
                      end;

{                    zalFontSize:=CanvasV.Font.size;
                     CanvasV.Font.size:=7;
                     VyjdeTisk:=tiskniNeboVyzKousej(CanvasV,XA5,XA6,YPT,YPT+rady,uprostred,
                            NazevKatastru,false,vyjdetoNaSirku);
                     CanvasV.Font.size:=zalFontSize;
}
                    end;
                   tiskniRadekProZapsani;
                   yp:=yp+RADy;
                  end;
                end;
     end;
    SouctovyRadekZaPorost;
   end;
 end;
procedure TiskniOddeleni;
{function OstatniSeVejdou:boolean;
var zbyvaY:longint;
    iOst,iDil,iPor:integer;
 begin
  with CanvasV do
   begin
    with VOdd do
     begin
      zbyvaY:=MerYMax-YP;
      with DilecMN do
       begin
        for iDil:=0 to count-1 do
         begin
          with TDilec(elements[iDil]) do
           begin
            with PorostMN do
             begin
              for iPor:=0 to count-1 do
               begin
                with TPorost(elements[iPor]) do
                 begin
                  with OstatniMN do
                   begin
                    for iOst:=0 to count-1 do
                     begin
                      if Elements[iOst] is TOstatni then
                       begin
                        zbyvaY:=zbyvaY-radY;
                       end;
                     end;
                   end;
                 end;
               end;
             end;
           end;
         end;
       end;
     end;
   end;
  result:=(ZbyvaY>0);
 end;
function JineSeVejdou:boolean;
var zbyvaY:longint;
    iJine,iDil,iPor:integer;
 begin
  with CanvasV do
   begin
    with VOdd do
     begin
      zbyvaY:=MerYMax-YP;
      with DilecMN do
       begin
        for iDil:=0 to count-1 do
         begin
          with TDilec(elements[iDil]) do
           begin
            with PorostMN do
             begin
              for iPor:=0 to count-1 do
               begin
                with TPorost(elements[iPor]) do
                 begin
                  with JinyPozemekMN do
                   begin
                    for ijine:=0 to count-1 do
                     begin
                      if Elements[iJine] is TJinyPozemek then
                       begin
                        zbyvaY:=zbyvaY-radY;
                       end;
                     end;
                   end;
                 end;
               end;
             end;
           end;
         end;
       end;
     end;
   end;
  result:=(ZbyvaY>0);
 end;
}
var idil,iPor,iJine,iOst:integer;
    Xjp,xjp1:longint;
begin
netisknout1:=false;
 with Vodd do
  begin
  YRR:=0;
  if NaTiskarnu2 then MerYMax:=round(mery*0.95)
     else merYMax:=round(screen.height);
  tiskniHlavicku;
   with DilecMN do
    begin
     for iDil:=0 to count-1 do
      begin
       if not (Elements[iDil] is TDilec) then continue;
       JmenoAktualnihoPrvku:=TDilec(Elements[iDil]).DIL;
       with Dilec do
        begin
         with PorostMN do
          begin
           for iPor:=0 to count-1 do
            begin
             if not (Elements[iPor] is TPorost) then continue;
             JmenoAktualnihoPrvku:=TPorost(Elements[iPor]).POR;
             TiskniPorost;
            end;
          end;
        end;
      end;
    end;
{  if not JineSeVejdou then
    begin
     holeodstrankovani;
     tiskniHlavicku;
    end;
   with DilecMN do
    begin
     for iDil:=0 to count-1 do
      begin
       with TDilec(elements[iDil]) do
        begin
         TextOutS(CanvasV,XA2,XA3,YPT,DIL);
         with PorostMN do
          begin
           for iPor:=0 to count-1 do
            begin
             with TPorost(elements[iPor]) do
              begin
               if TiskPorost then TextOutS(CanvasV,XA3,XA3a,YPT,POR);
               with JinyPozemekMN do
                begin
                 for ijine:=0 to count-1 do
                  begin
                   if not (Elements[iJine] is TJinyPozemek) then continue;
                   with TJinyPozemek(Elements[iJine]) do
                    begin
                     TextOutS(CanvasV,XA10,XA11,YPT,KategorieMN.KategorieVcetnePrekryvu);
                     TextOutS(CanvasV,XA3a,XA4,YPT,intToStr(JP));
                     TextOutS(CanvasV,XA5,XA6,YPT,NazevKatastru);
                     Xjp:=XA9;
                     if uppercase(VYUZITI)='ZC' then begin Xjp:=XAR9; end;
                     if uppercase(VYUZITI)='VP' then begin Xjp:=XAR10; end;
                     if uppercase(VYUZITI)='HP' then begin Xjp:=XAR11; end;
                     if uppercase(VYUZITI)='ZP' then begin Xjp:=XAR12; end;
                     if uppercase(VYUZITI)='NP' then begin Xjp:=XAR13; end;
                     if uppercase(VYUZITI)='DJ' then begin Xjp:=XA9; end;
                     TextOutPK(CanvasV,Xjp,YPT,floatTOStrf(JP_P,ffFixed,6,2));
                     TextOutPK(CanvasV,XA10,YPT,floatTOStrf(JP_P,ffFixed,6,2));
                    end;
                   tiskniRadekProZapsani;
                   yp:=yp+RADy;
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
   if not ostatniSeVejdou then
    begin
     with CanvasV do
      begin
       pen.width:=5;
       PolyLine([Point(XA1,YP),
                Point(XA12,YP)]);
      end;
     holeodstrankovani;
     tiskniHlavicku;
    end;
   with DilecMN do
    begin
     for iDil:=0 to count-1 do
      begin
       with TDilec(elements[iDil]) do
        begin
         with PorostMN do
          begin
           for iPor:=0 to count-1 do
            begin
             with TPorost(elements[iPor]) do
              begin
               with OstatniMN do
                begin
                 for iOST:=0 to count-1 do
                  begin
                   if not (Elements[iOST] is TOstatni) then continue;
                   with TOstatni(Elements[iOST]) do
                    begin
                     TextOutS(CanvasV,XA4,XA5,YPT,intToStr(OST));
                     TextOutPK(CanvasV,XA12,YPT,floatTOStrf(OST_P,ffFixed,6,2));
                    end;
                   tiskniRadekProZapsani;
                   yp:=yp+RADy;
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    end;  }
   SouctovyRadekZaOddeleni;
 end;
 // holeOdstrankovani; {za oddeleni}
end;
procedure TiskniSoucet(oddMN:TOddeleniMN);
var PSumarLHC:TSumarLHC;
 begin
  netisknout1:=False;
  YRR:=0;
  if NaTiskarnu2 then MerYMax:=round(mery*0.95)
     else merYMax:=round(screen.height);
  tiskniHlavicku;
  if OddMN=nil then SpoctiSumarLHC_DB98(PSumarLHC)
  else SpoctiSumarOddeleniMN98(PSumarLHC,OddMN);
  With PSumarLHC do
   begin
    TiskniRadekProSoucet;
      TextOutS (CanvasV,XA2,XA6,YPT,'Celkem za celek : ');
      TextOutPK(CanvasV,XA7,YPT,floatTOStrf(PorostniPuda,ffFixed,8,2));
      TextOutPK(CanvasV,XA10,YPT,floatTOStrf(PlochaPUPFL,ffFixed,8,2));
      if PlochaOSTATNI>0.001 then
           TextOutPK(CanvasV,XA12,YPT,floatTOStrf(PlochaOSTATNI,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=1;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XA7+XPP,XAR1,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=2;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR1+XPP,XAR2,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=3;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR2+XPP,XAR3,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=4;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR3+XPP,XAR4,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=5;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR4+XPP,XAR5,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=6;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR5+XPP,XAR6,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=7;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR6+XPP,XAR7a,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=8;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7a+XPP,XAR7b,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=9;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7b+XPP,XAR7c,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=10;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7c+XPP,XAR7,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=11;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7+XPP,XA8,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=12;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XA8+XPP,XAR9,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=13;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR9+XPP,XAR10,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=14;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR10+XPP,XAR11,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=15;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR11+XPP,XAR12,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=16;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR12+XPP,XAR13,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=17;
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR13+XPP,XA9,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));

{     PoradiAktualnihoVyuziti:=1;
      //if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR1,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XA7+XPP,XAR1,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=2;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR2,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR1+XPP,XAR2,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=3;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR3,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR2+XPP,XAR3,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=4;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR4,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR3+XPP,XAR4,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=5;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR5,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR4+XPP,XAR5,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=6;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR6,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR5+XPP,XAR6,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=7;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR7,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR6+XPP,XAR7,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=8;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XA8,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR7+XPP,XA8,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=9;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR9,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XA8+XPP,XAR9,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=10;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR10,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR9+XPP,XAR10,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=11;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR11,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR10+XPP,XAR11,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=12;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR12,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR11+XPP,XAR12,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=13;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XAR13,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR12+XPP,XAR13,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      PoradiAktualnihoVyuziti:=14;
       // if PlochaVyuziti>0.0001 then TextOutPK(CanvasV,XA9,YPT,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      if PlochaVyuziti>0.0001 then TextOUTPrelom(CanvasV,XAR13+XPP,XA9,YPT,YPT+radY,true,naPravo,floatTOStrf(PlochaVyuziti,ffFixed,6,2));
      }
     end;
    yp:=yp+RADy;
   holeodstrankovani; {soucet}
   PSumarLHC.free;
  end;
 begin
 if tiskSouctu then
  tiskniSoucet(oddMN)
 else
  TiskniOddeleni;
 end;
procedure TiskKatastru(oddMn:TOddeleniMN;CanvasV:TCanvas;merX,MerY:longint;NaTiskarnu1:Boolean;VColor:TColor);
 var PSumarLHC:TSumarLHC;
     FS,FSD,FSDK,FSDM:longint;
     radx,XAR,Xa1,Xa2,Xa3,Xa4,Xa5,Xa6,Xa7,Xa8,Xa9:longint;
     YRR,YP,merYMax,RH,RADy,YR1,YR2,YR3,YR4,YR1T,YR3T:longint;
function mx(x:real):longint;
 begin
  mx:=mx1(x,MerX);
 end;
function my(y:real):longint;
 begin
  my:=my1(y,mery);
 end;
function YPT:longint;
 begin
  result:=YP+my(0.1);
 end;
procedure HoleOdstrankovani1;
begin
if NaTiskarnu1 then
 begin
  with printer do
   begin
      newpage;
      MerYMax:=round(mery*0.95);
   end;
 end
else
 begin
   YRR:=YRR+round(screen.height*1.1);
   merYMax:=YRR+round(screen.height);
 end;
end;
procedure nastavBody;
 begin
   FS:=7;
   FSD:=9;
   FSDK:=12;
   FSDM:=3;
   radx:=   mx(0.40);
   XAR:=    mx(0.98);
   Xa1:=    mx(2.00);
   Xa2:=Xa1+mx(4.00);
   Xa3:=Xa2+mx(4.00);
   Xa4:=Xa3+mx(2.00);
   Xa5:=Xa4+mx(2.00);
   Xa6:=Xa5+mx(2.00);
   Xa7:=Xa6+mx(2.00);
   Xa8:=Xa7+mx(2.00);
   Xa9:=Xa8+mx(2.00);
   YR1:=my(1.8)+YRR;
   RH :=my(1.00);
   RADy:=my(0.5);
   YR2:=YR1+RH;
   YR1T:=YR1+my(0.1);
   YR3:=YR2;
   YP:=YR2;
 end;
procedure tiskniHlavicku;
 begin
  nastavBody;
  with canvasV do
   begin
    // FONT.NAME:='Arial CE';
    FONT.NAME:='Arial';
    Font.Size:=FSDK;
    Font.Style:=[fsBold];
    TextOut(XA1,YR1-2*RADy,'  Plochy dle okres, katastr a druh pozemk');
    // FONT.NAME:='Arial CE';
    FONT.NAME:='Arial';
    Font.Size:=FSD;
    Font.Style:=[];
        TextOutS(canvasV,XA1,XA2,YR1T,'Okres');

        TextOutS(canvasV,XA2,XA3,YR1T,'Katastr');

        TextOutS(canvasV,XA3,XA4,YR1T,'Porostn');
        TextOutS(canvasV,XA3,XA4,YR1T+Rady,'pda');

        TextOutS(canvasV,XA4,XA5,YR1T,'Bezles');

        TextOutS(canvasV,XA5,XA6,YR1T,'Lesn');
        TextOutS(canvasV,XA5,XA6,YR1T+Rady,'pozemky');

        TextOutS(canvasV,XA6,XA7,YR1T,'Jin');
        TextOutS(canvasV,XA6,XA7,YR1T+Rady,'pozemky');

        TextOutS(canvasV,XA7,XA8,YR1T,'Celkem');
        TextOutS(canvasV,XA7,XA8,YR1T+Rady,'PUPFL');

        TextOutS(canvasV,XA8,XA9,YR1T,'Ostatn');
        TextOutS(canvasV,XA8,XA9,YR1T+Rady,'pozemky');
     pen.width:=5;
     PolyLine([Point(XA1,YR1),
               Point(XA9,YR1),
               Point(XA9,YR2),
               Point(XA1,YR2),
               Point(XA1,YR1)]);
     PolyLine([Point(XA1,YR1),
               Point(XA1,YR2)]);
     PolyLine([Point(XA2,YR1),
               Point(XA2,YR2)]);
     PolyLine([Point(XA3,YR1),
               Point(XA3,YR2)]);
     PolyLine([Point(XA4,YR1),
               Point(XA4,YR2)]);
     PolyLine([Point(XA5,YR1),
               Point(XA5,YR2)]);
     PolyLine([Point(XA6,YR1),
               Point(XA6,YR2)]);
     PolyLine([Point(XA7,YR1),
               Point(XA7,YR2)]);
     PolyLine([Point(XA8,YR1),
               Point(XA8,YR2)]);
     PolyLine([Point(XA9,YR1),
               Point(XA9,YR2)]);
   end;
 end;
 procedure tiskniSvisleCarkyZaCelek;
  begin
   with CanvasV do
    begin
     pen.width:=5;
     PolyLine([Point(XA1,YR3),
               Point(XA1,YR3+RADy)]);
    { PolyLine([Point(XA2,YR3),
               Point(XA2,YR3+RADy)]); }
     PolyLine([Point(XA3,YR3),
               Point(XA3,YR3+RADy)]);
     PolyLine([Point(XA4,YR3),
               Point(XA4,YR3+RADy)]);
     PolyLine([Point(XA5,YR3),
               Point(XA5,YR3+RADy)]);
     PolyLine([Point(XA6,YR3),
               Point(XA6,YR3+RADy)]);
     PolyLine([Point(XA7,YR3),
               Point(XA7,YR3+RADy)]);
     PolyLine([Point(XA8,YR3),
               Point(XA8,YR3+RADy)]);
     PolyLine([Point(XA9,YR3),
               Point(XA9,YR3+RADy)]);
    end;
  end;
 procedure tiskniSvisleCarky;
  begin
   tiskniSvisleCarkyZaCelek;
   with CanvasV do
    begin
     pen.width:=5;
     PolyLine([Point(XA2,YR3),
               Point(XA2,YR3+RADy)]);
    end;
  end;

 procedure tiskniRadekKatastru;
  begin
   with canvasV do
    begin
     pen.width:=1; Pen.Style := psDot;
     PolyLine([Point(XA1,YR3+RADy),
               Point(XA9,YR3+RADy)]);
     pen.width:=1; Pen.Style := psSolid;
    end;
   YR3T:=YR3+my(0.1);
   tiskniSvisleCarky;
   With PSumarLHC.katastr do
    begin
     TextOutS (CanvasV,XA1,XA2,YR3T,NazevOkresu);
     TextOutS (CanvasV,XA2,XA3,YR3T,NazevKatastru);
     TextOutPK(CanvasV,XA4,YR3T,floatTOStrf(PorostniPuda,ffFixed,8,2));
     TextOutPK(CanvasV,XA5,YR3T,floatTOStrf(Bezlesi,ffFixed,6,2));
     TextOutPK(CanvasV,XA6,YR3T,floatTOStrf(Bezlesi+PorostniPuda,ffFixed,8,2));
     TextOutPK(CanvasV,XA7,YR3T,floatTOStrf(JinePozemky,ffFixed,6,2));
     TextOutPK(CanvasV,XA8,YR3T,floatTOStrf(Bezlesi+PorostniPuda+JinePozemky,ffFixed,8,2));
     TextOutPK(CanvasV,XA9,YR3T,floatTOStrf(OstatniPozemky,ffFixed,6,2));
    end;
   YR3:=YR3+RADy;
  end;
procedure VybarvyRadek;
 begin
  With canvasV do
   begin
    Brush.Color:=VColor; // clYellow;
    fillRect(rect(XA1,YR3+my(0.03),XA9,YR3+RADy));
    Brush.color:=ClWhite;
   end;
 end;
 procedure tiskniSoucetZaOkres(PozOkres:integer);
  begin
   VybarvyRadek;
   with CanvasV do
    begin
     pen.width:=5;
     PolyLine([Point(XA1,YR3),
               Point(XA9,YR3)]);
   YR3T:=YR3+my(0.1);
   tiskniSvisleCarkyZaCelek;
   PSumarLHC.AktualniOkres:=PozOkres;
   With PSumarLHC.katastrZaOkres do
    begin
     if pozOkres=-1 then TextOutS (CanvasV,XA1,XA3,YR3T,'Celkem :')
     else TextOutS (CanvasV,XA1,XA3,YR3T,'Celkem za okres :');
     TextOutPK(CanvasV,XA4,YR3T,floatTOStrf(PorostniPuda,ffFixed,8,2));
     TextOutPK(CanvasV,XA5,YR3T,floatTOStrf(Bezlesi,ffFixed,6,2));
     TextOutPK(CanvasV,XA6,YR3T,floatTOStrf(Bezlesi+PorostniPuda,ffFixed,8,2));
     TextOutPK(CanvasV,XA7,YR3T,floatTOStrf(JinePozemky,ffFixed,6,2));
     TextOutPK(CanvasV,XA8,YR3T,floatTOStrf(Bezlesi+PorostniPuda+JinePozemky,ffFixed,8,2));
     TextOutPK(CanvasV,XA9,YR3T,floatTOStrf(OstatniPozemky,ffFixed,6,2));
    end;
     YR3:=YR3+RADy;
     PolyLine([Point(XA1,YR3),
               Point(XA9,YR3)]);
    end;
  end;
 procedure SetridRadky;
 var i,maxI:integer;
     nasel:Boolean;
     MaxKat:LongInt;
  PSumarLHC1:TsumarLHC;
  begin
   PSumarLHC1:=TSumarLHC.create;
   With PSumarLHC do
    begin
     repeat
      maxKat:=999999999;
      nasel:=false;
      for i:=0 to count-1 do
       begin
        if Elements[i] is TKatastr then
         begin
          if TKatastr(Elements[i]).OznKatastr<maxkat then
           begin
             maxKat:=TKatastr(Elements[i]).OznKatastr;
             maxI:=i;
             nasel:=True;
           end;
         end;
       end;
     if nasel then
      begin
       PSumarLHC1.addElement(Elements[maxI]);
       RemoveElement(Elements[maxI]);
      end;
     until not nasel;
     for i:=0 to PSumarLHC1.count-1 do
      begin
       if PSumarLHC1.Elements[i] is TKatastr then
        begin
         addElement(PSumarLHC1.Elements[I]);
        end;
      end;
     PSumarLHC1.free;
    end;
  end;
 procedure TiskniRadky;
  var i:integer;
    puvOkres:integer;
  begin
   With PSumarLHC do
    begin
     puvOkres:=-1;
     for i:=0 to count-1 do
      begin
       if Elements[i] is TKatastr then
        begin
         AktualniKatastr:=TKatastr(Elements[i]).OznKatastr;
         if (puvOkres<>katastr.okres)and(puvOkres<>-1)then
            tiskniSoucetZaOkres(puvOkres);
         puvOkres:=katastr.okres;
         if MerYMax<YR3+3*RadY then
          begin
           with CanvasV do
            begin
             pen.width:=5;
             PolyLine([Point(XA1,YR3),
                     Point(XA9,YR3)]);
            end;
           holeOdstrankovani1;
           tiskniHlavicku;
          end;
         tiskniRadekKatastru;
        end;
      end;
    end;
   tiskniSoucetZaOkres(puvOkres);
   tiskniSoucetZaOkres(-1);
  end;
  begin
   YRR:=0;
   if NaTiskarnu1 then
    MerYMax:=round(mery*0.95)
     else merYMax:=round(screen.height);
   if OddMN=nil then SpoctiSumarLHC_DB98(PSumarLHC)
   else SpoctiSumarOddeleniMN98(PSumarLHC,OddMN);
   tiskniHlavicku;
   setridRadky;
   tiskniRadky;
   holeodstrankovani1;  {za katastry}
  end;
procedure TiskPot_Vlast(oddMn:TOddeleniMN;CanvasV:TCanvas;merX,MerY:longint;NaTiskarnu1:Boolean;VColor:TColor);
 var PSumarLHC:TSumarLHC;
     FS,FSD,FSDK,FSDM:longint;
     radx,XAR,Xa1,Xa2,Xa3,Xa4,Xa5,Xa6,Xa7,Xa9:longint;
     YRR,YP,merYMax,RH,RADy,YR1,YR2,YR3,YR4,YR1T,YR3T:longint;
function mx(x:real):longint;
 begin
  mx:=mx1(x,MerX);
 end;
function my(y:real):longint;
 begin
  my:=my1(y,mery);
 end;
function YPT:longint;
 begin
  result:=YP+my(0.1);
 end;
procedure HoleOdstrankovani;
begin
if NaTiskarnu1 then
 begin
  with printer do
   begin
    newpage;
    MerYMax:=round(mery*0.95)
   end;
 end
else
 begin
   YRR:=YRR+round(screen.height*1.1);
   merYMax:=YRR+round(screen.height);
 end;
end;
procedure nastavBody;
 begin
   FS:=7;
   FSD:=9;
   FSDK:=12;
   FSDM:=3;
   radx:=   mx(0.40);
   XAR:=    mx(0.98);
   Xa1:=    mx(2.00);
   Xa2:=Xa1+mx(4.00);
   Xa3:=Xa2+mx(4.00);
   Xa4:=Xa3+mx(2.60);
   Xa5:=Xa4+mx(2.60);
   Xa6:=Xa5+mx(2.60);
   Xa7:=Xa6+mx(2.60);
   Xa9:=Xa7+mx(2.60);
   YR1:=my(1.8)+YRR;
   RH :=my(1.00);
   RADy:=my(0.5);
   YR2:=YR1+RH;
   YR1T:=YR1+my(0.1);
   YR3:=YR2;
   YP:=YR2;
 end;
procedure tiskniHlavicku;
 begin
  nastavBody;
  with canvasV do
   begin
    // FONT.NAME:='Arial CE';
    FONT.NAME:='Arial';
    Font.Size:=FSDK;
    Font.Style:=[fsBold];
    TextOut(XA1,YR1-2*RADy,'  Plochy dle okres, katastr a kategori parcel');
    // FONT.NAME:='Arial CE';
    FONT.NAME:='Arial';
    Font.Size:=FSD;
    Font.Style:=[];
        TextOutS(canvasV,XA1,XA2,YR1T,'Okres');

        TextOutS(canvasV,XA2,XA3,YR1T,'Katastr');

        TextOutS(canvasV,XA3,XA4,YR1T,     'Nepochybn');
        TextOutS(canvasV,XA3,XA4,YR1T+Rady,'vlastnk');

        TextOutS(canvasV,XA4,XA5,YR1T,     'Potenciln');
        TextOutS(canvasV,XA4,XA5,YR1T+Rady,'majetek crkve');

        TextOutS(canvasV,XA5,XA6,YR1T,'Ideln');
        TextOutS(canvasV,XA5,XA6,YR1T+Rady,'spoluvlastnictv');

        TextOutS(canvasV,XA6,XA7,YR1T,     'Nedokonen');
        TextOutS(canvasV,XA6,XA7,YR1T+Rady,'restitun zen');

        TextOutS(canvasV,XA7,XA9,YR1T,'Celkem');
        TextOutS(canvasV,XA7,XA9,YR1T+Rady,'PUPFL');

     pen.width:=5;
     PolyLine([Point(XA1,YR1),
               Point(XA9,YR1),
               Point(XA9,YR2),
               Point(XA1,YR2),
               Point(XA1,YR1)]);
     PolyLine([Point(XA1,YR1),
               Point(XA1,YR2)]);
     PolyLine([Point(XA2,YR1),
               Point(XA2,YR2)]);
     PolyLine([Point(XA3,YR1),
               Point(XA3,YR2)]);
     PolyLine([Point(XA4,YR1),
               Point(XA4,YR2)]);
     PolyLine([Point(XA5,YR1),
               Point(XA5,YR2)]);
     PolyLine([Point(XA6,YR1),
               Point(XA6,YR2)]);
     PolyLine([Point(XA7,YR1),
               Point(XA7,YR2)]);
     PolyLine([Point(XA9,YR1),
               Point(XA9,YR2)]);
   end;
 end;

 procedure tiskniSvisleCarkyZaCelek;
  begin
   with CanvasV do
    begin
     pen.width:=5;
     PolyLine([Point(XA1,YR3),
               Point(XA1,YR3+RADy)]);
     { PolyLine([Point(XA2,YR3),
                 Point(XA2,YR3+RADy)]); }
     PolyLine([Point(XA3,YR3),
               Point(XA3,YR3+RADy)]);
     PolyLine([Point(XA4,YR3),
               Point(XA4,YR3+RADy)]);
     PolyLine([Point(XA5,YR3),
               Point(XA5,YR3+RADy)]);
     PolyLine([Point(XA6,YR3),
               Point(XA6,YR3+RADy)]);
     PolyLine([Point(XA7,YR3),
               Point(XA7,YR3+RADy)]);
     PolyLine([Point(XA9,YR3),
               Point(XA9,YR3+RADy)]);
    end;
  end;

 procedure tiskniSvisleCarky;
  begin
   tiskniSvisleCarkyZaCelek;
   with CanvasV do
    begin
     pen.width:=5;
     PolyLine([Point(XA2,YR3),
               Point(XA2,YR3+RADy)]);
    end;
  end;

 procedure tiskniRadekKatastru;
 var pl:double;
  begin
   with canvasV do
    begin
     pen.width:=1; Pen.Style := psDot;
     PolyLine([Point(XA1,YR3+RADy),
               Point(XA9,YR3+RADy)]);
     pen.width:=1; Pen.Style := psSolid;
    end;
   YR3T:=YR3+my(0.1);
   tiskniSvisleCarky;
   With PSumarLHC.katastr do
    begin
     TextOutS (CanvasV,XA1,XA2,YR3T,NazevOkresu);
     TextOutS (CanvasV,XA2,XA3,YR3T,NazevKatastru);
     pl:=0;
     AktualniPot_Vlast:=11;
     TextOutPK(CanvasV,XA4,YR3T,floatTOStrf(PlochaPot_Vlast,ffFixed,6,2));
     pl:=Pl+PlochaPot_Vlast;

     AktualniPot_Vlast:=12;
     TextOutPK(CanvasV,XA5,YR3T,floatTOStrf(PlochaPot_Vlast,ffFixed,6,2));
     pl:=Pl+PlochaPot_Vlast;

     AktualniPot_Vlast:=13;
     TextOutPK(CanvasV,XA6,YR3T,floatTOStrf(PlochaPot_Vlast,ffFixed,6,2));
     pl:=Pl+PlochaPot_Vlast;

     AktualniPot_Vlast:=14;
     TextOutPK(CanvasV,XA7,YR3T,floatTOStrf(PlochaPot_Vlast,ffFixed,6,2));
     pl:=Pl+PlochaPot_Vlast;

     TextOutPK(CanvasV,XA9,YR3T,floatTOStrf(Pl,ffFixed,6,2));

    end;
   YR3:=YR3+RADy;
  end;
procedure VybarvyRadek;
 begin
  With canvasV do
   begin
    Brush.Color:=VColor; // clYellow;
    fillRect(rect(XA1,YR3+my(0.03),XA9,YR3+RADy));
    Brush.color:=ClWhite;
   end;
 end;
 procedure tiskniSoucetZaOkres(PozOkres:integer);
 var pl:double;
  begin
   VybarvyRadek;
   with CanvasV do
    begin
     pen.width:=5;
     PolyLine([Point(XA1,YR3),
               Point(XA9,YR3)]);
   YR3T:=YR3+my(0.1);
   tiskniSvisleCarkyZaCelek;
   PSumarLHC.AktualniOkres:=PozOkres;
   With PSumarLHC.katastrZaOkres do
    begin
     if pozOkres=-1 then TextOutS (CanvasV,XA1,XA3,YR3T,'Celkem :')
     else TextOutS (CanvasV,XA1,XA3,YR3T,'Celkem za okres :');
     pl:=0;
     AktualniPot_Vlast:=11;
     TextOutPK(CanvasV,XA4,YR3T,floatTOStrf(PlochaPot_Vlast,ffFixed,6,2));
     pl:=Pl+PlochaPot_Vlast;

     AktualniPot_Vlast:=12;
     TextOutPK(CanvasV,XA5,YR3T,floatTOStrf(PlochaPot_Vlast,ffFixed,6,2));
     pl:=Pl+PlochaPot_Vlast;

     AktualniPot_Vlast:=13;
     TextOutPK(CanvasV,XA6,YR3T,floatTOStrf(PlochaPot_Vlast,ffFixed,6,2));
     pl:=Pl+PlochaPot_Vlast;

     AktualniPot_Vlast:=14;
     TextOutPK(CanvasV,XA7,YR3T,floatTOStrf(PlochaPot_Vlast,ffFixed,6,2));
     pl:=Pl+PlochaPot_Vlast;

     TextOutPK(CanvasV,XA9,YR3T,floatTOStrf(Pl,ffFixed,6,2));

    end;
     YR3:=YR3+RADy;
     PolyLine([Point(XA1,YR3),
               Point(XA9,YR3)]);
    end;
  end;
 procedure SetridRadky;
 var i,maxI:integer;
     nasel:Boolean;
     MaxKat:LongInt;
  PSumarLHC1:TsumarLHC;
  begin
   PSumarLHC1:=TSumarLHC.create;
   With PSumarLHC do
    begin
     repeat
      maxKat:=999999999;
      nasel:=false;
      for i:=0 to count-1 do
       begin
        if Elements[i] is TKatastr then
         begin
          if TKatastr(Elements[i]).OznKatastr<maxkat then
           begin
             maxKat:=TKatastr(Elements[i]).OznKatastr;
             maxI:=i;
             nasel:=True;
           end;
         end;
       end;
     if nasel then
      begin
       PSumarLHC1.addElement(Elements[maxI]);
       RemoveElement(Elements[maxI]);
      end;
     until not nasel;
     for i:=0 to PSumarLHC1.count-1 do
      begin
       if PSumarLHC1.Elements[i] is TKatastr then
        begin
         addElement(PSumarLHC1.Elements[I]);
        end;
      end;
     PSumarLHC1.free;
    end;
  end;
 procedure TiskniRadky;
  var i:integer;
    puvOkres:integer;
  begin
   With PSumarLHC do
    begin
     puvOkres:=-1;
     for i:=0 to count-1 do
      begin
       if Elements[i] is TKatastr then
        begin
         AktualniKatastr:=TKatastr(Elements[i]).OznKatastr;
         if (puvOkres<>katastr.okres)and(puvOkres<>-1)then
            tiskniSoucetZaOkres(puvOkres);
         puvOkres:=katastr.okres;
         if MerYMax<YR3+3*RadY then
          begin
           with CanvasV do
            begin
             pen.width:=5;
             PolyLine([Point(XA1,YR3),
                      Point(XA9,YR3)]);
            end;
           holeOdstrankovani;
           tiskniHlavicku;
          end;
         tiskniRadekKatastru;
        end;
      end;
    end;
   tiskniSoucetZaOkres(puvOkres);
   tiskniSoucetZaOkres(-1);
  end;
  begin
   YRR:=0;
   if NaTiskarnu1 then MerYMax:=round(mery*0.95)
     else merYMax:=round(screen.height);
   if OddMN=nil then SpoctiSumarLHC_DB98(PSumarLHC)
   else SpoctiSumarOddeleniMN98(PSumarLHC,OddMN);
   tiskniHlavicku;
   setridRadky;
   tiskniRadky;
   holeodstrankovani; {za pot Vlast}
  end;
end.
