unit SP_MalaEtaz;

interface

uses
  Windows, Messages, SysUtils, Variants,
  U_ZobrComb, U_Zobraz, E_LesOdd, E_LesCel, ELesObec,
  E_LesOddMaly, U_ZobrMaly,
  Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TFSP_MalaEtaz = class(TForm)
    Panel1: TPanel;
    LEtCislo: TLabel;
    LVek: TLabel;
    LZakm: TLabel;
    ButPridDrev: TButton;
    LEtIndex: TLabel;
    ButVypZas: TButton;
    LPodil_et: TLabel;
    LEtaz_PS: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButPridDrevClick(Sender: TObject);
    procedure ButVypZasClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
   ScrollSeznEtazi:TScrollBoxProMaly;
   stGrmDrevina:TStringGridMuj;
   stGrm1EtCislo,stGrm1EtIndex,StGrm1VEK,stGrm1ZAKM,stGrm1Podil_Et,stGrm1ETAZ_PS:TStringGridMujJednoPole;
   cobEtCislo,cobEtIndex,cobVEK,cobZAKM,CobPodil_ET:TComboBoxCiselnik;
   cobDR_ZKR,cobZAST,cobTLOUSTKA,cobVYSKA,cobBON_A:TComboBoxCiselnikProGrid;
   LesniCelek:TLesniCelek;
   etaz:TEtazMaly;
   procedure stGrm1EtCisloExit(Sender: TObject);

   procedure ZobrazCobDR_ZKR;
   procedure ZobrazcobZAST;
   procedure ZobrazcobTLOUSTKA;
   procedure ZobrazcobVYSKA;
   procedure ZobrazcobBON_A;
   procedure stGrmDrevinaDblClick(Sender: TObject);
   procedure prezobraz;
   procedure RePaint; override;
   procedure upravMaxLeft(CobXX:TComboBoxCiselnik;widthFormulare:LongInt);
  end;

procedure zobrazSP_MalaEtaz(VFSP_MalaEtaz:TFSP_MalaEtaz;VEtaz:TEtazMaly;modalne:boolean);

var
  FSP_MalaEtaz: TFSP_MalaEtaz;

implementation

uses Grids;

{$R *.dfm}

procedure zobrazSP_MalaEtaz(VFSP_MalaEtaz:TFSP_MalaEtaz;VEtaz:TEtazMaly;modalne:boolean);
 begin
  VFSP_MalaEtaz.etaz:=VEtaz;
  if modalne then
   begin
    VFSP_MalaEtaz.ShowModal;
   end
  else
   begin
    VFSP_MalaEtaz.Show;
   end;
 end;
procedure TFSp_MalaEtaz.RePaint;
 begin
  inherited repaint;
  prezobraz;
 end;

procedure TFSp_MalaEtaz.Prezobraz;
 begin
  with stGrm1EtCislo do
   begin
    ObLesPrvek:=Etaz;
    refresh;PouzeCteni:=false;
   end;
  with stGrm1EtIndex do
   begin
    ObLesPrvek:=Etaz;
    refresh;PouzeCteni:=false;
   end;
  with stGrm1VEK do
   begin
    ObLesPrvek:=Etaz;
    refresh;PouzeCteni:=false;
   end;
  with stGrm1ZAKM do
   begin
    ObLesPrvek:=Etaz;
    refresh;PouzeCteni:=false;
   end;
  with stGrm1Podil_Et do
   begin
    ObLesPrvek:=Etaz;
    refresh;PouzeCteni:=false;
   end;
  with stGrm1ETAZ_PS do
   begin
    ObLesPrvek:=Etaz;
    refresh;PouzeCteni:=false;
   end;


  with stGrmDrevina do
   begin
    if Etaz<>nil then
     begin
      ObLesMN:=Etaz.DrevinaMN;
     end
    else
     begin
      ObLesMN:=nil;
     end;
    mnozinuDoGriduAVlastnosti;
    PouzeCteni:=false;
   end;
  caption:=Etaz.ETAZzkrPopis;
 end;

procedure TFSP_MalaEtaz.FormShow(Sender: TObject);
 begin
  prezobraz;
 end;

procedure TFSP_MalaEtaz.FormCreate(Sender: TObject);
var
 i,icis:Integer;
 s1:String;
 Ch:Char;
begin
  ScrollSeznEtazi:=nil;
  CobEtCislo:=TComboBoxCiselnik.Create(Self);
  with CobEtCislo do
   begin
    Parent := panel1;
    MaxWidth:=100;
    ZpPrevodu:=doPomlcky;
    DropDownCount:=12;
    name:='CobEtCislo';
   end;

  stGrm1EtCislo:=TStringGridMujJednoPole.Create(Self);
  with StGrm1EtCislo do
   begin
    Parent  := panel1;
    name:='StGrm1EtCislo';
    top     := 12;
    left    := 6;
    mheight := 19;
    mwidth  := 26;
    JmenoProperty:='EtCislo';
    PocetZnaku:=3;
    OnExit:=stGrm1EtCisloExit;
   end;
  LEtCislo.Left:=StGrm1EtCislo.Left;

  SetTopPod(StGrm1EtCislo, LEtCislo);
  CobEtCislo.JednoPole:=StGrm1EtCislo;
  with cobEtCislo do
   begin
    items.clear;
    for icis:=0 to 17 do
     begin
      s1:=inttostr(icis);
      items.Add(s1);
     end;
    ItemIndex:=0;
   end;
  SetStredX(LEtCislo,GetStredX(CobEtCislo));
  upravMaxLeft(CobEtCislo,self.Width);

  CobEtIndex:=TComboBoxCiselnik.Create(Self);
  with CobEtIndex do
   begin
    Parent := panel1;
    MaxWidth:=100;
    ZpPrevodu:=doPomlcky;
    DropDownCount:=12;
    name:='CobEtIndex';
   end;
  stGrm1EtIndex:=TStringGridMujJednoPole.Create(Self);
  with stGrm1EtIndex do
   begin
    Parent  := panel1;
    name:='StGrm1EtIndex';
    top     := 12;
    left    := 56;
    mheight := 19;
    mwidth  := 16;
    JmenoProperty:='EtIndex';
    PocetZnaku:=3;
   end;
  LEtIndex.Left:=StGrm1EtIndex.Left;

  SetTopPod(StGrm1EtIndex, LEtCislo);
  CobEtIndex.JednoPole:=StGrm1EtIndex;
  with cobEtIndex do
   begin
    items.clear;
    for ch:='a' to 'z' do
     begin
      s1:=ch;
      items.Add(s1);
     end;
    ItemIndex:=0;
   end;
  SetStredX(LEtIndex,GetStredX(CobEtIndex));
  upravMaxLeft(CobEtIndex,self.Width);


  CobVEK:=TComboBoxCiselnik.Create(Self);
  with CobVEK do
   begin
    Parent := panel1;
    MaxWidth:=100;
    ZpPrevodu:=doPomlcky;
    DropDownCount:=12;
    name:='CobVEK';
   end;

  stGrm1VEK:=TStringGridMujJednoPole.Create(Self);
  with StGrm1VEK do
   begin
    Parent := panel1;
    name:='StGrm1VEK';
    top    := 12;
    left   := 85;
    mheight := 19;
    mwidth  := 26;
    JmenoProperty:='VEK';
    PocetZnaku:=3;
    TypPolozky:='I';
   end;
  LVek.Left :=StGrm1Vek.Left;

  SetTopPod(StGrm1VEK, LVEK);
  CobVEK.JednoPole:=StGrm1VEK;
  with cobVEK do
   begin
    items.clear;
    for icis:=0 to 180 do
     begin
      s1:=inttostr(icis);
      items.Add(s1);
     end;
    ItemIndex:=0;
   end;
  SetStredX(LVEK,GetStredX(CobVEK));
  upravMaxLeft(CobVEK,self.Width);


  CobZAKM:=TComboBoxCiselnik.Create(Self);
  with CobZAKM do
   begin
    Parent := panel1;
    MaxWidth:=100;
    ZpPrevodu:=doPomlcky;
    DropDownCount:=11;
    name:='CobZAKM';
   end;
  stGrm1ZAKM:=TStringGridMujJednoPole.Create(Self);
  with StGrm1ZAKM do
   begin
    Parent  := panel1;
    name:='StGrm1ZAKM';
    top     := 12;
    left    := 135;
    mheight := 19;
    mwidth  := 21;
    JmenoProperty:='ZAKM';
    PocetZnaku:=2;
    TypPolozky:='I';
   end;
  LZakm.Left :=StGrm1Zakm.Left;

  SetTopPod(StGrm1ZAKM, LZAKM);
  CobZAKM.JednoPole:=StGrm1ZAKM;
  with cobZAKM do
   begin
    items.clear;
    for icis:=13 downto 0 do
     begin
      s1:=inttostr(icis);
      items.Add(s1);
     end;
    ItemIndex:=0;
   end;
  SetStredX(LZAKM,GetStredX(CobZAKM));
  upravMaxLeft(CobZAKM,self.Width);


  CobPodil_ET:=TComboBoxCiselnik.Create(Self);
  with CobPodil_ET do
   begin
    Parent := panel1;
    MaxWidth:=100;
    ZpPrevodu:=doPomlcky;
    DropDownCount:=11;
    name:='CobPodil_ET';
   end;
  stGrm1Podil_ET:=TStringGridMujJednoPole.Create(Self);
  with StGrm1Podil_ET do
   begin
    Parent  := panel1;
    name:='StGrm1Podil_ET';
    top     := 12;
    left    := 175;
    mheight := 19;
    mwidth  := 31;
    JmenoProperty:='Podil_ET';
    PocetZnaku:=2;
    TypPolozky:='I';
   end;
  LPodil_ET.Left :=StGrm1Podil_ET.Left;

  SetTopPod(StGrm1Podil_ET, LPodil_ET);
  CobPodil_ET.JednoPole:=StGrm1Podil_ET;
  with cobPodil_ET do
   begin
    items.clear;
    for icis:=10 downto 1 do
     begin
      s1:=inttostr(icis*10);
      items.Add(s1);
     end;
    ItemIndex:=0;
   end;
  SetStredX(LPodil_ET,GetStredX(CobPodil_ET));
  upravMaxLeft(CobPodil_ET,self.Width);

  stGrm1ETAZ_PS:=TStringGridMujJednoPole.Create(Self);
  with stGrm1ETAZ_PS do
   begin
    Parent := panel1;
    name:='StGrm1ETAZ_PS';
    top    :=  12;
    left   :=  225;
    mheight := 19;
    mwidth  := 40; // 59;
    JmenoProperty:='ETAZ_PS';
    DoubleWidth:=6;
    DoublePrec:=2;
    PocetZnaku:=6;
    DesMista:=2;
    TypPolozky:='F';
   end;
  LETAZ_PS.Left :=StGrm1ETAZ_PS.Left;


  stGrmDrevina:=TStringGridMuj.Create(Self);
  with StGrmDrevina do
   begin
    name:='stGrmDrevina';
    NastavStringGridMujNaTax200(stGrmDrevina);
    Parent := panel1;
    ZobrazeniGridu:=vybranePole;
    top    := 36;
    left   := 0;
    height := 133;
    width  := Parent.Width-98;
    MenitRowHeights:=true;
    ObLesMN:=TDrevinaMN.create;
    NastavGrid;
    with VlastnostiSloupcuMN do
     begin
      for I:=0 to count-1 do
       begin
        with TVlastnostiSloupcu(elements[i]) do
         begin
          viditelny:=False;
         end;
       end;
     end;
    with VlastnostiSloupcuMN do
     begin
      JmenoAktualnihoPrvku:='DR_ZKR';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=30;
        Nadpis:='Dev.';
        poziceTisku:=uprostred;
        PocetZnaku:=3;
        TypPolozky:='A';
       end;
      JmenoAktualnihoPrvku:='ZAST';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=True;
        Sirka:=23;
        Nadpis:='Zast.';
        poziceTisku:=NaPravo;
        PocetZnaku:=3;
        TypPolozky:='I';
       end;
      JmenoAktualnihoPrvku:='TLOUSTKA';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=17;
        Nadpis:='D';
        poziceTisku:=uprostred;
        PocetZnaku:=2;
        TypPolozky:='I';
       end;
      JmenoAktualnihoPrvku:='VYSKA';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=17;
        Nadpis:='H';
        poziceTisku:=uprostred;
        PocetZnaku:=2;
        TypPolozky:='I';
       end;
      JmenoAktualnihoPrvku:='BON_A';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=20;
        Nadpis:='Bon';
        poziceTisku:=NaPravo;
        PocetZnaku:=2;
        TypPolozky:='I';
       end;
      JmenoAktualnihoPrvku:='ZAS_TAB_HA';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=28;
        Nadpis:='Vtab';
        poziceTisku:=NaPravo;
        PocetZnaku:=4;
        TypPolozky:='I';
       end;
      JmenoAktualnihoPrvku:='DR_ZAS_HA';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=28;
        Nadpis:='Vs/ha';
        poziceTisku:=NaPravo;
        PocetZnaku:=4;
        TypPolozky:='I';
       end;
      JmenoAktualnihoPrvku:='DR_ZAS_CEL';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=40;
        Nadpis:=' Vs ';
        poziceTisku:=NaPravo;
        PocetZnaku:=5;
        TypPolozky:='I';
       end;
    PripravZobrazeniGridu;
    // onEnter:=stGrmDrevinaEnter;
    // onKeyDown:=stGrmDrevinaKeyDown;
    // onExit:=stGrmDrevinaExit;
    // onSelectCell:=stGrmDrevinaSelectCell;
     onDblClick:=stGrmDrevinaDblClick;

    end;

  cobDR_ZKR:=TComboBoxCiselnikProGrid.Create(Self);
   with CobDR_ZKR do
    begin
     Parent := panel1;
     height := 19;
     ZpPrevodu:=doPomlcky;
     name   := 'CobDR_ZKR';
     visible:=false;
     JmenoHlProperty:='DR_ZKR';
     StrGrMuj:=StGrmDrevina;
     items.clear;
     items.Add('SM');
     items.Add('BO');
    end;

  cobZAST:=TComboBoxCiselnikProGrid.Create(Self);
   with CobZAST do
    begin
     Parent := panel1;
     height := 19;
     ZpPrevodu:=doPomlcky;
     name   := 'CobZAST';
     visible:=false;
     JmenoHlProperty:='ZAST';
     StrGrMuj:=StGrmDrevina;
     for icis:=20 downto 1 do
      begin
       s1:=inttostr(icis*5);
       items.Add(s1);
      end;
     ItemIndex:=0;

    end;

  cobTLOUSTKA:=TComboBoxCiselnikProGrid.Create(Self);
   with CobTLOUSTKA do
    begin
     Parent := panel1;
     height := 19;
     ZpPrevodu:=doPomlcky;
     name   := 'CobTLOUSTKA';
     visible:=false;
     JmenoHlProperty:='TLOUSTKA';
     StrGrMuj:=StGrmDrevina;
    for icis:=6 to 44 do
     begin
      s1:=inttostr(icis);
      items.Add(s1);
     end;
    ItemIndex:=0;
    end;

  cobVYSKA:=TComboBoxCiselnikProGrid.Create(Self);
   with CobVYSKA do
    begin
     Parent := panel1;
     height := 19;
     ZpPrevodu:=doPomlcky;
     name   := 'CobVYSKA';
     visible:=false;
     JmenoHlProperty:='VYSKA';
     StrGrMuj:=StGrmDrevina;
     for icis:=6 to 44 do
      begin
       s1:=inttostr(icis);
       items.Add(s1);
      end;
     ItemIndex:=0;
    end;

  cobBON_A:=TComboBoxCiselnikProGrid.Create(Self);
   with CobBON_A do
    begin
     Parent := panel1;
     height := 19;
     ZpPrevodu:=doPomlcky;
     name   := 'CobBON_A';
     visible:=false;
     JmenoHlProperty:='BON_A';
     StrGrMuj:=StGrmDrevina;
     for icis:=16 to 38 do
      begin
       s1:=inttostr(icis);
       items.Add(s1);
      end;
     ItemIndex:=0;
    end;
  end;
end;


procedure TFSP_MalaEtaz.ZobrazCobDR_ZKR;
var Acol,Arow:integer;
 begin
  with CobDR_ZKR do
   begin
    if not visible then
     begin
      acol:=stgrmDrevina.col;
      arow:=stgrmDrevina.row;
      left   :=stGrmDrevina.left+stGrmDrevina.colLeft[aCol+1]; // ColLeft[1]; //
      width  :=stGrmDrevina.Width div 3;
      Top    :=stGrmDrevina.Top+stGrmDrevina.RowHeights[0];
      DroppedDown:=true;
      visible:=true;
     end;
    activeControl:=CobDR_ZKR;
   end;
 end;

procedure TFSP_MalaEtaz.ZobrazCobZAST;
var Acol,Arow:integer;
 begin
  with CobZAST do
   begin
    if not visible then
     begin
      acol:=stgrmDrevina.col;
      arow:=stgrmDrevina.row;
      left   :=stGrmDrevina.left+stGrmDrevina.colLeft[aCol+1]; // ColLeft[1]; //
      width  :=stGrmDrevina.Width div 3;
      Top    :=stGrmDrevina.Top+stGrmDrevina.RowHeights[0];
      DroppedDown:=true;
      visible:=true;
     end;
    activeControl:=CobZAST;
   end;
 end;

procedure TFSP_MalaEtaz.ZobrazCobTLOUSTKA;
var Acol,Arow:integer;
 begin
  with CobTLOUSTKA do
   begin
    if not visible then
     begin
      acol:=stgrmDrevina.col;
      arow:=stgrmDrevina.row;
      left   :=stGrmDrevina.left+stGrmDrevina.colLeft[aCol+1]; // ColLeft[1]; //
      width  :=stGrmDrevina.Width div 3;
      Top    :=stGrmDrevina.Top+stGrmDrevina.RowHeights[0];
      DroppedDown:=true;
      visible:=true;
     end;
    activeControl:=CobTLOUSTKA;
   end;
 end;
procedure TFSP_MalaEtaz.ZobrazCobVYSKA;
var Acol,Arow:integer;
 begin
  with CobVYSKA do
   begin
    if not visible then
     begin
      acol:=stgrmDrevina.col;
      arow:=stgrmDrevina.row;
      left   :=stGrmDrevina.left+stGrmDrevina.colLeft[aCol+1]; // ColLeft[1]; //
      width  :=stGrmDrevina.Width div 3;
      Top    :=stGrmDrevina.Top+stGrmDrevina.RowHeights[0];
      DroppedDown:=true;
      visible:=true;
     end;
    activeControl:=CobVYSKA;
   end;
 end;

procedure TFSP_MalaEtaz.ZobrazCobBON_A;
var Acol,Arow:integer;
 begin
  with CobBON_A do
   begin
    if not visible then
     begin
      acol:=stgrmDrevina.col;
      arow:=stgrmDrevina.row;
      left   :=stGrmDrevina.left+stGrmDrevina.colLeft[aCol+1]; // ColLeft[1]; //
      width  :=stGrmDrevina.Width div 3;
      Top    :=stGrmDrevina.Top+stGrmDrevina.RowHeights[0];
      DroppedDown:=true;
      visible:=true;
     end;
    activeControl:=CobBON_A;
   end;
 end;


procedure TFSP_MalaEtaz.upravMaxLeft(CobXX:TComboBoxCiselnik;widthFormulare:LongInt);
 begin
  if CobXX.left+CobXX.MaxWidth>widthFormulare-10 then
   begin
    CobXX.MaxLeft:=widthFormulare-CobXX.MaxWidth-10;
   end
  else
   begin
    CobXX.maxLeft:=-1111;
   end;
 end;


procedure TFSP_MalaEtaz.ButPridDrevClick(Sender: TObject);
begin
 etaz.pridejDrevinuProKolDotAMaly;
 prezobraz;
end;

procedure TFSP_MalaEtaz.stGrm1EtCisloExit(Sender: TObject);
  begin
   if etaz.EtCislo=0 then
    begin
     CobVEK.ItemIndex:=0;
    end
   else
    begin
      if not barvaBraniMenit(Etaz.Barva['VEK']) then
       begin
        if etaz.EtCislo=0 then
         begin
          etaz.VEK := 0;
         end
        else
         begin
          etaz.VEK := (etaz.EtCislo-1)*10+1;
          stGrm1VEK.prekresli;
         end;
       end;
     // showmessage(inttostr(etaz.EtCislo));
    end;
  end;


procedure TFSP_MalaEtaz.stGrmDrevinaDblClick(Sender: TObject);
 begin
  if stGrmDrevina.col=stGrmDrevina.ColDleProperty('DR_ZKR')   then ZobrazCobDR_ZKR;
  if stGrmDrevina.col=stGrmDrevina.ColDleProperty('ZAST')     then ZobrazcobZAST;
  if stGrmDrevina.col=stGrmDrevina.ColDleProperty('TLOUSTKA') then ZobrazcobTLOUSTKA;
  if stGrmDrevina.col=stGrmDrevina.ColDleProperty('VYSKA')    then ZobrazcobVYSKA;
  if stGrmDrevina.col=stGrmDrevina.ColDleProperty('BON_A')    then ZobrazcobBON_A;
 end;
procedure TFSP_MalaEtaz.ButVypZasClick(Sender: TObject);
begin
 etaz.vypoctiZasoby;
 prezobraz;
end;

procedure TFSP_MalaEtaz.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 if ScrollSeznEtazi<>nil then
  begin
   ScrollSeznEtazi.MnozinaDoScrollBoxu;
   if scrollSeznEtazi.mnozinaMaly<>nil then
    begin
     if not(scrollSeznEtazi.mnozinaMaly.PrvekJeVMnozine(etaz)) then
      begin
       scrollSeznEtazi.mnozinaMaly.addelement(etaz);
      end;
    end;
  end;
end;

end.
