unit SpPskTxt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls,
  E_LesCel,U_Zobraz, Grids;

type
  TFSpPskTxt = class(TForm)
    LabPozn: TLabel;
    LabNMD:  TLabel;
    LabDTO:  TLabel;
    ButUloz: TButton;
    ButNeukl: TButton;
    CombPozn: TComboBox;
    ButVlozPozn: TButton;
    ButVymazPozn: TButton;
    CombNMD: TComboBox;
    ButVlozNMD: TButton;
    CombDTO: TComboBox;
    ButVlozDTO : TButton;
    ButVymazNMD: TButton;
    ButVymazDTO: TButton;
    procedure EdPoznKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ButUlozClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButNeuklClick(Sender: TObject);
    procedure CombPoznKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ButVlozPoznClick(Sender: TObject);
    procedure ButVymazPoznClick(Sender: TObject);
    procedure CombNMDKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ButVlozNMDClick(Sender: TObject);
    procedure CombDTOKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ButVlozDTOClick(Sender: TObject);
    procedure ButVymazDTOClick(Sender: TObject);
    procedure ButVymazNMDClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ukladat:Boolean;
    ObLesniCelek:TLesniCelek;
  end;

var
  FSpPskTxt: TFSpPskTxt;

implementation

{$R *.DFM}

procedure TFSpPskTxt.EdPoznKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key=13 then
  begin
   activeControl:=CombNMD;
  end;
end;

procedure TFSpPskTxt.ButUlozClick(Sender: TObject);
begin
 if (length(combpozn.Text)+length(combNMD.Text)+length(combDTO.Text))>1019 then
  begin
   showmessage('Souet dlek text nesm bt vy ne 1019');
  end
 else
  begin
   close;
   Ukladat:=true;
  end;
end;

procedure TFSpPskTxt.FormShow(Sender: TObject);
begin
 ukladat:=false;
end;

procedure TFSpPskTxt.ButNeuklClick(Sender: TObject);
begin
 close;
 Ukladat:=false;
end;

procedure TFSpPskTxt.CombPoznKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key=13 then
  begin
   activeControl:=CombNMD;
  end;
end;

procedure TFSpPskTxt.ButVlozPoznClick(Sender: TObject);
 begin
  CombPozn.items.add(CombPozn.TEXT);
  ZCombaDoMnoziny(CombPozn,oblesniCelek.PoznNmdDto.VybPozn_MN,'VybTxt');
  oblesniCelek.PoznNmdDto.ulozSeDoOrbu(obLesniCelek.PHSNazev);
 end;

procedure TFSpPskTxt.ButVymazPoznClick(Sender: TObject);
var ii:integer;
 begin
  ii:=CombPozn.items.IndexOf(CombPozn.TEXT);
  if ii<>-1 then
   begin
    CombPozn.items.Delete(ii);
   end;
  ZCombaDoMnoziny(CombPozn,oblesniCelek.PoznNmdDto.VybPozn_MN,'VybTxt');
  oblesniCelek.PoznNmdDto.ulozSeDoOrbu(obLesniCelek.PHSNazev);
 end;

procedure TFSpPskTxt.CombNMDKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key=13 then
  begin
   activeControl:=CombDTO;
  end;
end;

procedure TFSpPskTxt.ButVlozNMDClick(Sender: TObject);
 begin
  CombNMD.items.add(CombNMD.TEXT);
  ZCombaDoMnoziny(CombNMD,oblesniCelek.PoznNmdDto.VybNMD_MN,'VybTxt');
  oblesniCelek.PoznNmdDto.ulozSeDoOrbu(obLesniCelek.PHSNazev);
 end;

procedure TFSpPskTxt.CombDTOKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key=13 then
  begin
   activeControl:=ButUloz;
  end;
end;

procedure TFSpPskTxt.ButVlozDTOClick(Sender: TObject);
 begin
  CombDTO.items.add(CombDTO.TEXT);
  ZCombaDoMnoziny(CombDTO,oblesniCelek.PoznNmdDto.VybDTO_MN,'VybTxt');
  oblesniCelek.PoznNmdDto.ulozSeDoOrbu(obLesniCelek.PHSNazev);
 end;

procedure TFSpPskTxt.ButVymazDTOClick(Sender: TObject);
var ii:integer;
 begin
  ii:=CombDTO.items.IndexOf(CombDTO.TEXT);
  if ii<>-1 then
   begin
    CombDTO.items.Delete(ii);
   end;
  ZCombaDoMnoziny(CombDTO,oblesniCelek.PoznNmdDto.VybDTO_MN,'VybTxt');
  oblesniCelek.PoznNmdDto.ulozSeDoOrbu(obLesniCelek.PHSNazev);
 end;

procedure TFSpPskTxt.ButVymazNMDClick(Sender: TObject);
var ii:integer;
 begin
  ii:=CombNMD.items.IndexOf(CombNMD.TEXT);
  if ii<>-1 then
   begin
    CombNMD.items.Delete(ii);
   end;
  ZCombaDoMnoziny(CombNMD,oblesniCelek.PoznNmdDto.VybNMD_MN,'VybTxt');
  oblesniCelek.PoznNmdDto.ulozSeDoOrbu(obLesniCelek.PHSNazev);
 end;

end.
