unit SpZobrTable;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, Grids, DBGrids, ExtCtrls, DBTables, StdCtrls,
  mat1;

type
  TFZobrTable = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    LabelTab: TLabel;
    Label1: TLabel;
    Label2: TLabel;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Procedure ZobrazDataset(TAB1:TTable;cel1,cel2:String);
Procedure ZobrazQuery(Que1:TQuery);
Function JeVQuery(Que1:TQuery;SDil,SPor,SPsk:string; Var NOdd, NDil, NPor:string):Boolean;

var
  FZobrTable: TFZobrTable;

implementation

{$R *.DFM}
Function JeVQuery(Que1:TQuery;SDil,SPor,SPsk:string;Var NOdd, NDil, NPor :string):Boolean;
 begin
  NOdd:='';
  NDil:='';
  NPor:='';
  Que1.First;
  result:=false;
  while not Que1.eof do
   begin
    if    (ubm(Que1.FieldByName('DILEC').AsString)=ubm(SDil))
       and(ubm(Que1.FieldByName('POROST').AsString)=ubm(SPor))
       and(ubm(Que1.FieldByName('SKUPINA').AsString)=ubm(SPsk))
       then
      begin
       NOdd:=Que1.FieldByName('NODDELENI').AsString;
       NDil:=Que1.FieldByName('NDILEC').AsString;
       NPor:=Que1.FieldByName('NPOROST').AsString;
       result:=true;
      end;
    Que1.next;
   end;
 end;
Procedure ZobrazDataset(TAB1:TTable;cel1,cel2:String);
var Zavrit:boolean;
 Begin
   Application.CreateForm(TFZobrTable,FZobrTable);
   If not tab1.Active then
    begin
     tab1.open;
     zavrit:=true;
    end
   else
    begin
     zavrit:=false;
    end;
   FZobrTable.DataSource1.DataSet:=Tab1;
   FZobrTable.LabelTab.Caption:='Tabulka uloena v :"'+Tab1.tableName+'"';
   FZobrTable.Label1.Caption:='Zdroj1 :"'+cel1+'"';
   FZobrTable.Label2.Caption:='Zdroj2 :"'+cel2+'"';
   FZobrTable.showmodal;
   if zavrit then
    begin
     tab1.close;
    end;
   FZobrTable.free;
 end;
Procedure ZobrazQuery(Que1:TQuery);
var Zavrit:boolean;
 Begin
   Application.CreateForm(TFZobrTable,FZobrTable);
   If not Que1.Active then
    begin
     Que1.open;
     zavrit:=true;
    end
   else
    begin
     zavrit:=false;
    end;
   FZobrTable.DBGrid1.columns.Clear;
   FZobrTable.DataSource1.DataSet:=Que1;
   FZobrTable.DBGrid1.DataSource:=FZobrTable.DataSource1;
   FZobrTable.DBGrid1.refresh;
   FZobrTable.showmodal;
   FZobrTable.free;
 end;

end.
