
procedure SetTextOrientation(aOrientation: double);
var
  LogFont: TLogFont;

begin
  if Canvas = nil then exit;
{  if aOrientation = 0 then exit; }

  with LogFont do
  begin
    lfHeight := Font.Height;
{    lfHeight := Font.Size; }

    lfWidth := 0; { have font mapper choose }
    lfEscapement := round(aOrientation*10);
    lfOrientation := 0{round(aOrientation*10)};
    if fsBold in Font.Style then
      lfWeight := FW_BOLD
    else
      lfWeight := FW_NORMAL;
    lfItalic := Byte(fsItalic in Font.Style);
    lfUnderline := Byte(fsUnderline in Font.Style);
    lfStrikeOut := Byte(fsStrikeOut in Font.Style);
    lfCharSet := DEFAULT_CHARSET;
    StrPCopy(lfFaceName, Font.Name);
    lfQuality := DEFAULT_QUALITY;
    { Everything else as default }
    lfOutPrecision := OUT_DEFAULT_PRECIS;
    lfClipPrecision := CLIP_DEFAULT_PRECIS;
    lfPitchAndFamily := DEFAULT_PITCH;
  end;
{  DeleteObject(Canvas.Font.Handle); }
  Canvas.Font.Handle := CreateFontIndirect(LogFont);
  FOrientation:= aOrientation;
end;

