unit Tisky;

interface
uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, printers_F;

function mx1(x:real;merX:longint):longint;
function my1(y:real;MerY:longint):longint;
procedure TextOutP(canvasV:TCanvas;x,y:longint;s:string);
procedure TextOutPK(canvasV:TCanvas;x,y:longint;s:string);
procedure TextOutS(canvasV:TCanvas;x1,x2,y:longint;s:string);
procedure TextOutPsv(canvasV:TCanvas;x,y:longint;s:string);
procedure TextOutSsv(canvasV:TCanvas;x1,x2,y:longint;s:string);
// procedure {mj} SetTextOrientation(CV:TCanvas;aOrientation: double);
procedure {Petruv} SetTextOrientation(canvasV:TCanvas;aOrientation: double);
procedure tiskniMaleDoLine(canvasV:TCanvas;x,y:longint;s:string);
procedure BodAText(canvasV:TCanvas; X, Y: Integer; S: String);

implementation
function mx1(x:real;merX:longint):longint;
 begin
  result:=round((x/28.6)*merx);
 end;
function my1(y:real;MerY:longint):longint;
 begin
  result:=round((y/20.0)*mery);
 end;

procedure BodAText(canvasV:TCanvas; X, Y: Integer; S: String);
 begin
  canvasV.PolyLine([Point(x+5,y),Point(x,y),Point(x,y+5),Point(x+5,y+5),Point(x+5,y)]);
  tiskniMaleDoLine(canvasV,x+7,y,s);
 end;

procedure TextOutP(canvasV:TCanvas;x,y:longint;s:string);
begin
 with canvasV do
  begin
   x:=x-TextWidth(S);
   textOut(x,y,s);
  end;
end;

procedure tiskniMaleDoLine(canvasV:TCanvas;x,y:longint;s:string);
var ZalFont:TFont;
 begin
  ZalFont:= canvasV.Font;
  canvasV.Font.Style := [];
  canvasV.font.size:=4;
  canvasV.font.Charset:=238;
  canvasV.textOut(x,y,s);
  canvasV.font:=ZalFont;
 end;
procedure TextOutPK(canvasV:TCanvas;x,y:longint;s:string);
begin
 with canvasV do
  begin
   x:=x-TextWidth(S)-TextWidth('I');
   textOut(x,y,s);
  end;
end;

procedure TextOutS(canvasV:TCanvas;x1,x2,y:longint;s:string);
var x:longint;
 begin
 with canvasV do
  begin
   x:=(x1+x2-TextWidth(S)) div 2;
   textOut(x,y,s);
  end;
 end;

procedure TextOutPsv(canvasV:TCanvas;x,y:longint;s:string);
begin
 with canvasV do
  begin
   x:=x-TextHeight(S);
   textOut(x,y,s);
  end;
end;

procedure TextOutSsv(canvasV:TCanvas;x1,x2,y:longint;s:string);
var x:longint;
 begin
 with canvasV do
  begin
   x:=(x1+x2-TextHeight(S)) div 2;
   textOut(x,y,s);
  end;
 end;
(*
procedure {(mj)} SetTextOrientation(CV:TCanvas; aOrientation: double);
var
  LogFont: TLogFont;

begin
 if CV = nil then exit;
  with LogFont do
  begin
    lfHeight := cv.Font.Height;
{    lfHeight := Font.Size; }

    lfWidth := 0; { have font mapper choose }
    lfEscapement := round(aOrientation*10);
   // lfOrientation := round(aOrientation*10);
    lfOrientation := 0{round(aOrientation*10)};
    if fsBold in CV.Font.Style then
      lfWeight := FW_BOLD
    else
      lfWeight := FW_NORMAL;
    lfItalic := Byte(fsItalic in CV.Font.Style);
    lfUnderline := Byte(fsUnderline in CV.Font.Style);
    lfStrikeOut := Byte(fsStrikeOut in CV.Font.Style);
    lfCharSet := DEFAULT_CHARSET;
    StrPCopy(lfFaceName, CV.Font.Name);
    lfQuality := DEFAULT_QUALITY;
    { Everything else as default }
    lfOutPrecision := OUT_DEFAULT_PRECIS;
    lfClipPrecision := CLIP_DEFAULT_PRECIS;
    lfPitchAndFamily := DEFAULT_PITCH;
  end;
  CV.Font.Handle := CreateFontIndirect(LogFont);
end;
*)

procedure {Petruv} SetTextOrientation(canvasV:TCanvas;aOrientation: double);
var
  LogFont: TLogFont;

begin
  // font mus bt arial.nebo njak jin tru type, rastrov fonty to neot
  if CanvasV = nil then exit;
{  if aOrientation = 0 then exit; }
// CanvasV.TextOut(100,100,'XXXXXXXXXXXXXXX');
  with LogFont do
  begin
    lfHeight := CanvasV.Font.Height;
{    lfHeight := Font.Size; }

    lfWidth := 0; { have font mapper choose }
    lfEscapement := round(aOrientation*10);
    lfOrientation := 0{round(aOrientation*10)};
    if fsBold in CanvasV.Font.Style then
      lfWeight := FW_BOLD
    else
      lfWeight := FW_NORMAL;
    lfItalic := Byte(fsItalic in CanvasV.Font.Style);
    lfUnderline := Byte(fsUnderline in CanvasV.Font.Style);
    lfStrikeOut := Byte(fsStrikeOut in CanvasV.Font.Style);
    lfCharSet := CanvasV.Font.CharSet;
    StrPCopy(lfFaceName, CanvasV.Font.Name);
    lfQuality := DEFAULT_QUALITY;
    { Everything else as default }
    lfOutPrecision := OUT_DEFAULT_PRECIS;
    lfClipPrecision := CLIP_DEFAULT_PRECIS;
    lfPitchAndFamily := byte(CanvasV.Font.Pitch);
  end;
{  DeleteObject(Canvas.Font.Handle); }
  CanvasV.Font.Handle := CreateFontIndirect(LogFont);
 // FOrientation:= aOrientation;
 // CanvasV.TextOut(300,300,'XXXXXXXXXXXXXXX');
end;


end.
