unit UPrevOrb;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs,dbtables,inifiles, stdctrls,FileCtrl,
  U_String,E_dClass,T_Type,E_Type,Elements, T_oper,
  Worlds,
  e_OverlayGeometryElement, e_LHCElements, e_Geometry,
  i_LHCStd, Dtb_les, DtbLes98, UDtb_les,UOraLCR,SpOraLCR, Dotaz,
  sp_ovr,sp_Ovr98,Sp_VyhSo,SP_OznBz,EKolDot,u_Podmin,SP_KonNactiPl,U_Sehr,
  E_LesOdd, E_LesCel,ELesObec,LesTopol, mat1,UTab_Odd,NactMnoz,lescisOr,UVybLHCID,
  SpDotNaZal,SpPorovnOdd, UPrevodODD,
  e_LHCModel, e_KatastrModel,
  Uprevod, EHledAChyb,
  SP_MalyTax;

type
 TCoNacistzOchrPrir=(nacistEVL,nacistPO,NacistCHKO,NacistUSESNazev,NacistUsesKOD_UPK,
                     NacistUsesKOD_UPKdoZvlSt, NacistZCHU, nenacitatNic);
 TPoleOvrl = record
              PocetOvrl:Integer;
              A:array[1..100] of record
                              NAZEV:string;
                              Plocha:Double;
                             end;
             end;
 TPoleOvrlParCisParPodl = record
              PocetOvrl:Integer;
              A:array[1..100] of record
                              ParCis  :String;
                              ParPodl :String;
                              LV      :String;
                              Kultura :integer;
                              Plocha  :Double;
                             end;
             end;

Function  NajdiSkupinuVOrbu(SLHC,sSprava,sODD,sDil,sPOR,sPSK:String;Var chyba:String):TGis_PorostniSkupina;
Function  NajdiDilecVOddeleniOrbu(V_Oddeleni:Tgis_Oddeleni;sDIL:String;Var chyba:String):Tgis_Dilec;
Function  NajdiPorostVDilciOrbu(V_Dilec:Tgis_Dilec;sPor:String;Var chyba:String):Tgis_Porost;
Function  NajdiSkupinuVPorostuOrbu(V_Porost:Tgis_Porost;sPSK:String;Var chyba:String):Tgis_PorostniSkupina;
Function  NajdiOddeleniVOrbu(SLHC,sSprava,sODD:String;Var chyba:String):Tgis_Oddeleni;
Procedure DoOddeleniVTaxuDoplnBezlesiZOrbu(VOdd:Toddeleni;Vgis_Oddeleni:Tgis_Oddeleni;Var chyba:String;Infomemo:TMemo);
Function  JeNactenProjektLedu(Var chyba:String):Boolean;

procedure nactiPlochyZOrbuDoOddeleni(VOdd:Toddeleni; HlChyb:TOznaceniPorSkupinyHlaskaChybyMN;infomemo:TMemo;infoEdit:TEdit);

procedure nactiZTax20XXaUloz20XXProOrb(LesniCelek:TLesniCelek;var HlChyb:TOznaceniPorSkupinyHlaskaChybyMN;infomemo:TMemo;infoEdit:TEdit);
procedure nactiZTax20XXaUloz20XXProOrbOchrPrir(LesniCelek:TLesniCelek;var HlChyb:TOznaceniPorSkupinyHlaskaChybyMN;infomemo:TMemo;infoEdit:TEdit;CoNacistzOchrPrir:TCoNacistzOchrPrir);

procedure vytvorPoledleParCisParPodlZPAROwelay(     GisSkupina:Tgis_PorostniSkupina;
                                       Var PoleOvrl : TPoleOvrlParCisParPodl);


implementation

uses e_GeometryElement,
      SPPolNactLED;


Function NajdiSkupinuVOrbu(SLHC,sSprava,sODD,sDil,sPOR,sPSK:String;Var chyba:String):TGis_PorostniSkupina;
var
    V_Oddeleni:Tgis_Oddeleni;
    V_Dilec:Tgis_Dilec;
    V_Porost:Tgis_Porost;
    V_Skupina:Tgis_PorostniSkupina;

 begin
  result:=nil;
  V_Oddeleni:=NajdiOddeleniVOrbu(SLHC,sSprava,sODD,chyba);
  if V_Oddeleni=nil then
                     begin chyba:=chyba+'  '+'oddeleni neni'; exit;  end;
  V_Dilec:=NajdiDilecVOddeleniOrbu(V_Oddeleni,sDIL,chyba);
  if V_Dilec=nil then
                     begin chyba:=chyba+'  '+'dilec neni'; exit;  end;
  V_Porost:=NajdiPorostVDilciOrbu(V_Dilec,sPor,chyba);
  if V_Porost=nil then
                     begin chyba:=chyba+'  '+'porost neni'; exit;  end;
  V_Skupina:=NajdiSkupinuVPorostuOrbu(V_Porost,sPSK,chyba);
  if V_Skupina=nil then
                     begin chyba:=chyba+'  '+'Skupina neni'; exit;  end;
  result:=V_Skupina;
 end;
Function NajdiDilecVOddeleniOrbu(V_Oddeleni:Tgis_Oddeleni;sDIL:String;Var chyba:String):Tgis_Dilec;
 begin
  result:=nil;
  if V_Oddeleni.FindElementName('dilce')=nil then exit;
  result:=Tgis_Dilec(TOwnerEntity(V_Oddeleni.FindElementName('dilce')).FindElementName(sDIL));
 end;

Function NajdiPorostVDilciOrbu(V_Dilec:Tgis_Dilec;sPor:String;Var chyba:String):Tgis_Porost;
 begin
  result:=nil;
  if V_Dilec.FindElementName('porosty')=nil then exit;
  result:=Tgis_Porost(TOwnerEntity(V_Dilec.FindElementName('porosty')).FindElementName(sPOR));
 end;

Function NajdiSkupinuVPorostuOrbu(V_Porost:Tgis_Porost;sPSK:String;Var chyba:String):Tgis_PorostniSkupina;
var
 i:integer;
 begin
  result:=nil;
  sPSK:=ubm(sPSK);
  if V_Porost.FindElementName('skupiny')=nil then exit;
  for i:=0 to TOwnerEntity(V_Porost.FindElementName('skupiny')).count - 1 do
   begin
    if sPSK=ubm(Tgis_PorostniSkupina(TOwnerEntity(V_Porost.FindElementName('skupiny')).Elements[i]).Name) then
     begin
      result:=Tgis_PorostniSkupina(TOwnerEntity(V_Porost.FindElementName('skupiny')).Elements[i]);
     end;
   end;
  // result:=Tgis_PorostniSkupina(TOwnerEntity(V_Porost.FindElementName('skupiny')).FindElementName(sPSK));
 end;

Function JeNactenProjektLedu(Var chyba:String):Boolean;
var
 iLHC,iSprava:integer;
 begin
  result:=false;
  if TOwnerEntity(World.objectmodel.FindElementName('DATA'))=nil then
   begin
    chyba:=' Element DATA v objectmodelu nenalezen';
    exit;
   end;
  if TOwnerEntity(World.objectmodel.FindElementName('DATA')).FindElementName('LHC')=nil then
   begin
    chyba:=' Element LHC v objectmodelu nenalezen';
    exit;
   end;
  with TOwnerEntity(TOwnerEntity(World.objectmodel.FindElementName('DATA')).FindElementName('LHC')) do
   begin
     for iLhc:=0 to count-1 do
      begin
       if TOwnerEntity(elements[iLHC]).FindElementName('LS')<>nil then
        begin
         for iSprava:=0 to TOwnerEntity(TOwnerEntity(elements[iLHC]).FindElementName('LS')).Count-1 do
          begin
           if TOwnerEntity(TOwnerEntity(TOwnerEntity(elements[iLHC]).FindElementName('LS')).elements[iSprava]).FindElementName('Oddeleni')<>nil then
            begin
             result:=true;
            end;
          end;
        end;
      end;
    end;
 end;
Function NajdiParceluVOrbu(SLHC,sKU_KOD,sSkupParc:String;Var chyba:String):Tgis_Oddeleni;
var
 Katastr:TOwnerEntity;
 begin
  result:=nil;
  chyba:='';
  if TOwnerEntity(World.objectmodel.FindElementName('DATA'))=nil then
   begin
    chyba:=' Element DATA v objectmodelu nenalezen';
    exit;
   end;
  if TOwnerEntity(World.objectmodel.FindElementName('DATA')).FindElementName('PARCELY')=nil then
   begin
    chyba:=' Element PARCELY v objectmodelu nenalezen';
    exit;
   end;
  Katastr:=TOwnerEntity(TOwnerEntity(TOwnerEntity(World.objectmodel.FindElementName('DATA')).FindElementName('PARCELY')).FindElementName(sKU_KOD));
  if katastr=nil then
   begin

   end;
 end;

Function NajdiOddeleniVOrbu(SLHC,sSprava,sODD:String;Var chyba:String):Tgis_Oddeleni;
var
 iLHC,iSprava:integer;
 begin
  result:=nil;
  chyba:='';
  if TOwnerEntity(World.objectmodel.FindElementName('DATA'))=nil then
   begin
    chyba:=' Element DATA v objectmodelu nenalezen';
    exit;
   end;
     if TOwnerEntity(World.objectmodel.FindElementName('DATA')).FindElementName('LHC')=nil then
      begin
       chyba:=' Element LHC v objectmodelu nenalezen';
       exit;
      end;
  with TOwnerEntity(TOwnerEntity(World.objectmodel.FindElementName('DATA')).FindElementName('LHC')) do
   begin
     for iLhc:=0 to count-1 do
      begin
       if TOwnerEntity(elements[iLHC]).FindElementName('LS')<>nil then
        begin
         for iSprava:=0 to TOwnerEntity(TOwnerEntity(elements[iLHC]).FindElementName('LS')).Count-1 do
          begin
           if TOwnerEntity(TOwnerEntity(TOwnerEntity(elements[iLHC]).FindElementName('LS')).elements[iSprava]).FindElementName('Oddeleni')<>nil then
            begin
             result:=Tgis_Oddeleni(TOwnerEntity(TOwnerEntity(TOwnerEntity(TOwnerEntity(elements[iLHC]).FindElementName('LS')).elements[iSprava]).FindElementName('Oddeleni')).FindElementName(SODD));
             if result<>nil then exit;
            end;
          end;
        end;
      end;

   end;
 end;

Procedure PropertaJeStejnaVCelemPorostu(SProperta:string; Vgis_Porost:Tgis_Porost; Var JeStejna:boolean; Var HlHodnota:string);
var iPSK:Integer;
 begin
  hlHodnota:='V gis_porostu se nevyskytuje dn gis_skupina. ';
  JeStejna:=true;
  if Vgis_Porost.FindElementName('skupiny')<>Nil then
   begin
    for iPSK:=0 to TOwnerEntity(Vgis_Porost.FindElementName('skupiny')).count-1 do
     begin
      if hlHodnota='V gis_porostu se nevyskytuje dn gis_skupina. ' then
       begin
        HlHodnota:=Tgis_PorostniSkupina(TOwnerEntity(Vgis_Porost.FindElementName('skupiny')).elements[iPSK]).GetPropertyStringByName(SProperta);
       end
      else
       begin
        if HlHodnota<>Tgis_PorostniSkupina(TOwnerEntity(Vgis_Porost.FindElementName('skupiny')).elements[iPSK]).GetPropertyStringByName(SProperta) then
         begin
          JeStejna:=False;
         end;
       end;
     end;
   end
  else
   begin
    if Vgis_Porost.HasPropertyByName(SProperta) then
     begin
      if hlHodnota='V gis_porostu se nevyskytuje dn gis_skupina. ' then
       begin
        HlHodnota:=Vgis_Porost.GetPropertyStringByName(SProperta);
       end
      else
       begin
        if hlHodnota<>Vgis_Porost.GetPropertyStringByName(SProperta)
               then JeStejna:=False;
       end;
     end;
   end;
  if hlHodnota='V gis_porostu se nevyskytuje dn gis_skupina. ' then hlHodnota:='';
 end;

Procedure PropertaJeStejnaVCelemDilci(SProperta:string; Vgis_Dilec:Tgis_Dilec; Var JeStejna:boolean; Var HlHodnota:string;Infomemo:TMemo);
var iPSK,iPor:Integer;
    Vgis_Porost:Tgis_Porost;
 begin
  hlHodnota:='V gis_Dilci se nevyskytuje dn gis_skupina. ';
  JeStejna:=true;
  for iPor:=0 to TOwnerEntity(Vgis_Dilec.FindElementName('Porosty')).count-1 do
   begin
    Vgis_Porost:=Tgis_Porost(TOwnerEntity(Vgis_Dilec.FindElementName('Porosty')).elements[iPOR]);
    if Vgis_Porost.FindElementName('skupiny')<>Nil then
     begin
      for iPSK:=0 to TOwnerEntity(Vgis_Porost.FindElementName('skupiny')).count-1 do
       begin
        //Infomemo.Lines.Add('Dlec ' +Vgis_Dilec.name +Vgis_Porost.name
        //                  +' '+Tgis_PorostniSkupina(TOwnerEntity(Vgis_Porost.FindElementName('skupiny')).elements[iPSK]).name
        //                  +' '+HlHodnota
        //                  +' '+Tgis_PorostniSkupina(TOwnerEntity(Vgis_Porost.FindElementName('skupiny')).elements[iPSK]).GetPropertyStringByName(SProperta));
        if hlHodnota='V gis_Dilci se nevyskytuje dn gis_skupina. ' then
         begin
          HlHodnota:=Tgis_PorostniSkupina(TOwnerEntity(Vgis_Porost.FindElementName('skupiny')).elements[iPSK]).GetPropertyStringByName(SProperta);
         end
        else
         begin
          if HlHodnota<>Tgis_PorostniSkupina(TOwnerEntity(Vgis_Porost.FindElementName('skupiny')).elements[iPSK]).GetPropertyStringByName(SProperta)
           then JeStejna:=False;
         end;
       end;
     end
    else
     begin
      if Vgis_Porost.HasPropertyByName(SProperta) then
       begin
        if hlHodnota='V gis_Dilci se nevyskytuje dn gis_skupina. ' then
         begin
          HlHodnota:=Vgis_Porost.GetPropertyStringByName(SProperta);
         end
        else
         begin
          if hlHodnota<>Vgis_Porost.GetPropertyStringByName(SProperta)
             then JeStejna:=False;
         end;
       end;
     end;
   end;
  if hlHodnota='V gis_Dilci se nevyskytuje dn gis_skupina. ' then hlHodnota:='';
 end;


Procedure PropertaJeStejnaVCelemOddeleni(SProperta:string; Vgis_Oddeleni:Tgis_Oddeleni; Var JeStejna:boolean; Var HlHodnota:string;Infomemo:TMemo);
var iPSK,iPor,iDil:Integer;
    Vgis_Porost:Tgis_Porost;
 begin
  hlHodnota:='V gis_Oddeleni se nevyskytuje dn gis_skupina. ';
  JeStejna:=true;
  for iDil:=0 to TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).count-1 do
   begin
    // infomemo.Lines.Add('dil='+Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).DIL);
    if Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).FindElementName('Porosty')=nil then
     begin
      infomemo.Lines.Add('DILEC '+inttostr(Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).Oddeleni)+Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).DIL+'  neobsahuje dn porosty.');
     end
    else
     begin
      if TOwnerEntity(Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).FindElementName('Porosty')).count=0 then
       begin
        infomemo.Lines.Add('DILEC '+inttostr(Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).Oddeleni)+Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).DIL+'  neobsahuje dn porosty.');
       end;
      for iPor:=0 to TOwnerEntity(Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).FindElementName('Porosty')).count-1 do
       begin
        Vgis_Porost:=Tgis_Porost(TOwnerEntity(Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).FindElementName('Porosty')).elements[iPOR]);
        if Vgis_Porost.FindElementName('skupiny')<>Nil then
         begin
          for iPSK:=0 to TOwnerEntity(Vgis_Porost.FindElementName('skupiny')).count-1 do
           begin
            {Infomemo.Lines.Add(Vgis_Oddeleni.name +Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).name +Vgis_Porost.name
                          +' '+Tgis_PorostniSkupina(TOwnerEntity(Vgis_Porost.FindElementName('skupiny')).elements[iPSK]).name
                          +' '+HlHodnota
                          +' '+Tgis_PorostniSkupina(TOwnerEntity(Vgis_Porost.FindElementName('skupiny')).elements[iPSK]).GetPropertyStringByName(SProperta));  }
            if hlHodnota='V gis_Oddeleni se nevyskytuje dn gis_skupina. ' then
             begin
              HlHodnota:=Tgis_PorostniSkupina(TOwnerEntity(Vgis_Porost.FindElementName('skupiny')).elements[iPSK]).GetPropertyStringByName(SProperta);
             end
            else
             begin
              if hlHodnota<>Tgis_PorostniSkupina(TOwnerEntity(Vgis_Porost.FindElementName('skupiny')).elements[iPSK]).GetPropertyStringByName(SProperta)
               then JeStejna:=False;
             end;
           end; // for ipsk
         end // if Vgis_Porost.FindElementName('skupiny')<>Nil
        else
         begin
          if Vgis_Porost.HasPropertyByName(SProperta) then
           begin
            if hlHodnota='V gis_Oddeleni se nevyskytuje dn gis_skupina. ' then
             begin
              HlHodnota:=Vgis_Porost.GetPropertyStringByName(SProperta);
             end
            else
             begin
              if hlHodnota<>Vgis_Porost.GetPropertyStringByName(SProperta)
               then JeStejna:=False;
             end;
           end;
         end;
       end;
     end;
   end;
  if hlHodnota='V gis_Oddeleni se nevyskytuje dn gis_skupina. ' then hlHodnota:='';
 end;


procedure nactiKategorieDoTabOchr(TabOchr:TTable;vyprazdnitTabulku:Boolean;infoMemo:Tmemo);
 var i, iLhc,iSprava,Iodd,iDil,iPor,iPsk  :integer;
     Vgis_Oddeleni :Tgis_Oddeleni;
     JeStejna:boolean;
     HlHodnota,S,S1,S2:string;
 begin
  if vyprazdnitTabulku then
   begin
    try
     TabOchr.close;
     TabOchr.Exclusive:=true;
     TabOchr.EmptyTable;
     TabOchr.open;
    except
     infomemo.Lines.Add('V tabulce ' + TabOchr.TableName+' jsou problmy. ');

    end;
   end;
  with TOwnerEntity(TOwnerEntity(World.objectmodel.FindElementName('DATA')).FindElementName('LHC')) do
   begin
     for iLhc:=0 to count-1 do
      begin
       if TOwnerEntity(elements[iLHC]).FindElementName('LS')<>nil then
        begin
         for iSprava:=0 to TOwnerEntity(TOwnerEntity(elements[iLHC]).FindElementName('LS')).Count-1 do
          begin
           if TOwnerEntity(TOwnerEntity(TOwnerEntity(elements[iLHC]).FindElementName('LS')).elements[iSprava]).FindElementName('Oddeleni')<>nil then
            begin
             for IOdd:=0 to TOwnerEntity(TOwnerEntity(TOwnerEntity(TOwnerEntity(elements[iLHC]).FindElementName('LS')).elements[iSprava]).FindElementName('Oddeleni')).Count-1 do
              begin
               Vgis_Oddeleni:=Tgis_Oddeleni(TOwnerEntity(TOwnerEntity(TOwnerEntity(TOwnerEntity(elements[iLHC]).FindElementName('LS')).elements[iSprava]).FindElementName('Oddeleni')).elements[iODD]);
               // infomemo.Lines.Add('ODD=' + intTOStr(Vgis_Oddeleni.ODD));

               PropertaJeStejnaVCelemOddeleni('KATS',Vgis_Oddeleni,JeStejna,HlHodnota,infoMemo);
               if jeStejna then
                begin
                 // infomemo.Lines.Add('je stejna odd');
                 S:=HlHodnota;
                 i:=1;
                 while S<>'' do
                  begin
                   RozdelDlePrvnihoStringu(s,',',S1,S2);
                   s:=S2;
                   TabOchr.Insert;
                   TabOchr.fieldbyName('ODDELENI').AsInteger:= Vgis_Oddeleni.ODD;
                   TabOchr.fieldbyName('ID').AsInteger:= i;
                   TabOchr.fieldbyName('KTG').AsString:=S1;
                   TabOchr.post;
                   inc(i);
                  end;
                end
               else
                begin
                 // infomemo.Lines.Add('neni stejna odd');
                 for iDil:=0 to TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).count-1 do
                  begin
                    // infomemo.Lines.Add('neni stejna dil' + Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).DIL);
                   PropertaJeStejnaVCelemDilci('KATS',Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]),JeStejna,HlHodnota,infoMemo);
                   if jeStejna then
                    begin
                    // infomemo.Lines.Add('je stejna DIL');
                    S:=HlHodnota;
                    i:=1;
                     while S<>'' do
                      begin
                       RozdelDlePrvnihoStringu(s,',',S1,S2);
                       s:=S2;
                       TabOchr.Insert;
                       TabOchr.fieldbyName('ODDELENI').AsInteger:= Vgis_Oddeleni.ODD;
                       TabOchr.fieldbyName('DILEC').AsString :=Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).DIL;
                       TabOchr.fieldbyName('ID').AsInteger:= i;
                       TabOchr.fieldbyName('KTG').AsString:=S1;
                       TabOchr.post;
                       inc(i);
                      end;
                    end
                   else
                    begin
                     // infomemo.Lines.Add('neni stejna DIL');
                     for iPOR:=0 to TOwnerEntity(Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).FindElementName('porosty')).count-1 do
                      begin
                       HlHodnota:=Tgis_Porost(TOwnerEntity(Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).FindElementName('porosty')).Elements[IPor]).KATS;
                       i:=1;
                       S:=HlHodnota;
                       while S<>'' do
                        begin
                         RozdelDlePrvnihoStringu(s,',',S1,S2);
                         s:=S2;
                         TabOchr.Insert;
                         TabOchr.fieldbyName('ODDELENI').AsInteger:= Vgis_Oddeleni.ODD;
                         TabOchr.fieldbyName('DILEC').AsString :=Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).DIL;
                         TabOchr.fieldbyName('POROST').AsString :=Tgis_Porost(TOwnerEntity(Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).FindElementName('porosty')).Elements[IPor]).POR;
                         TabOchr.fieldbyName('ID').AsInteger:= i;
                         TabOchr.fieldbyName('KTG').AsString:=S1;
                         TabOchr.post;
                         inc(i);
                        end;
                      end;
                    end;
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
 end;

procedure nactiZvlastniStatutyDoTabOchr(TabOchr:TTable;vyprazdnitTabulku:Boolean;infoMemo:Tmemo);
 var i, iLhc,iSprava,Iodd,iDil,iPor,iPsk  :integer;
     Vgis_Oddeleni :Tgis_Oddeleni;
     JeStejna:boolean;
     HlHodnota,S,S1,S2:string;
 begin
  if vyprazdnitTabulku then
   begin
    try
     TabOchr.close;
     TabOchr.Exclusive:=true;
     TabOchr.EmptyTable;
     TabOchr.open;
    except
     infomemo.Lines.Add('V tabulce ' + TabOchr.TableName+' jsou problmy. ');
    end;
   end;
  with TOwnerEntity(TOwnerEntity(World.objectmodel.FindElementName('DATA')).FindElementName('LHC')) do
   begin
     for iLhc:=0 to count-1 do
      begin
       if TOwnerEntity(elements[iLHC]).FindElementName('LS')<>nil then
        begin
         for iSprava:=0 to TOwnerEntity(TOwnerEntity(elements[iLHC]).FindElementName('LS')).Count-1 do
          begin
           if TOwnerEntity(TOwnerEntity(TOwnerEntity(elements[iLHC]).FindElementName('LS')).elements[iSprava]).FindElementName('Oddeleni')<>nil then
            begin
             for IOdd:=0 to TOwnerEntity(TOwnerEntity(TOwnerEntity(TOwnerEntity(elements[iLHC]).FindElementName('LS')).elements[iSprava]).FindElementName('Oddeleni')).Count-1 do
              begin
               Vgis_Oddeleni:=Tgis_Oddeleni(TOwnerEntity(TOwnerEntity(TOwnerEntity(TOwnerEntity(elements[iLHC]).FindElementName('LS')).elements[iSprava]).FindElementName('Oddeleni')).elements[iODD]);
               PropertaJeStejnaVCelemOddeleni('ZVL_STATUT',Vgis_Oddeleni,JeStejna,HlHodnota,infoMemo);
               if jeStejna then
                begin
                 S:=HlHodnota;
                 i:=1;
                 while S<>'' do
                  begin
                   RozdelDlePrvnihoStringu(s,',',S1,S2);
                   s:=S2;
                   TabOchr.Insert;
                   TabOchr.fieldbyName('ODDELENI').AsInteger:= Vgis_Oddeleni.ODD;
                   TabOchr.fieldbyName('ID').AsInteger:= i;
                   TabOchr.fieldbyName('ZVL_KOD').AsString:=S1;
                   TabOchr.post;
                   inc(i);
                  end;
                end
               else
                begin
                 for iDil:=0 to TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).count-1 do
                  begin
                   PropertaJeStejnaVCelemDilci('ZVL_STATUT',Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]),JeStejna,HlHodnota,infoMemo);
                   if jeStejna then
                    begin
                    S:=HlHodnota;
                    i:=1;
                     while S<>'' do
                      begin
                       RozdelDlePrvnihoStringu(s,',',S1,S2);
                       s:=S2;
                       TabOchr.Insert;
                       TabOchr.fieldbyName('ODDELENI').AsInteger:= Vgis_Oddeleni.ODD;
                       TabOchr.fieldbyName('DILEC').AsString :=Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).DIL;
                       TabOchr.fieldbyName('ID').AsInteger:= i;
                       TabOchr.fieldbyName('ZVL_KOD').AsString:=S1;
                       TabOchr.post;
                       inc(i);
                      end;
                    end
                   else
                    begin
                     for iPOR:=0 to TOwnerEntity(Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).FindElementName('porosty')).count-1 do
                      begin
                       HlHodnota:=Tgis_Porost(TOwnerEntity(Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).FindElementName('porosty')).Elements[IPor]).ZVL_STATUT;
                       i:=1;
                       S:=HlHodnota;
                       while S<>'' do
                        begin
                         RozdelDlePrvnihoStringu(s,',',S1,S2);
                         s:=S2;
                         TabOchr.Insert;
                         TabOchr.fieldbyName('ODDELENI').AsInteger:= Vgis_Oddeleni.ODD;
                         TabOchr.fieldbyName('DILEC').AsString :=Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).DIL;
                         TabOchr.fieldbyName('POROST').AsString :=Tgis_Porost(TOwnerEntity(Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).FindElementName('porosty')).Elements[IPor]).POR;
                         TabOchr.fieldbyName('ID').AsInteger:= i;
                         TabOchr.fieldbyName('ZVL_KOD').AsString:=S1;
                         TabOchr.post;
                         inc(i);
                        end;
                      end;
                    end;
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
 end;

function  PocetCasti (GisSkupina:Tgis_PorostniSkupina):Integer;
Var
   i:integer;
 begin
  Result:=0;
  for i:=0 to gisSkupina.count-1 do
   begin
    if gisSkupina.elements[i] is TMultiAreaElement then Result:=Result+TMultiAreaElement(gisSkupina.elements[i]).count;
    if gisSkupina.elements[i] is TPolyLineAreaElement then Result:=Result+1;
   end;
 end;

procedure vytvorPoledleKulturyZPAROwelay(     GisSkupina:Tgis_PorostniSkupina;
                                       Var PoleOvrl : TPoleOvrl;
                                           infomemo:TMemo );
Var
 OE:TOverlayGeometryElement;
 Parcela:TGis_Parcela;
 iOw,iOvrl,HlOvrl:integer;
 begin
            for iOvrl:=1 to 100 do
             begin
              PoleOvrl.a[iOvrl].NAZEV:='';
              PoleOvrl.a[iOvrl].Plocha:=0;
             end;
            PoleOvrl.PocetOvrl:=0;
            for iOw:=0 to  GisSkupina.OwnersCount-1 do
             begin
              if  GisSkupina.Owners[iOw] is TOverlayGeometryElement then
               begin
                if TOverlayGeometryElement(GisSkupina.Owners[iOw]).FindOwnerName('OverlayPAR')<>NIL then
                 begin
                  OE:=TOverlayGeometryElement(GisSkupina.Owners[iOw]);
                  if OE.IsFull then
                   begin
                    Parcela:=Tgis_Parcela(Tgis_ParcelaCast(OE.A2).FindOwnerClass(Tgis_Parcela));
                    HlOvrl:=-1;
                     for iOvrl:=1 to PoleOvrl.PocetOvrl do
                      begin
                       if PoleOvrl.a[iOvrl].NAZEV=inttostr(Parcela.Kultura) then HlOvrl:=iOvrl;
                      end;
                    if HlOvrl=-1 then
                     begin
                      inc(PoleOvrl.PocetOvrl);
                      HlOvrl:=PoleOvrl.PocetOvrl;
                      PoleOvrl.a[HlOvrl].NAZEV:=inttostr(Parcela.Kultura);
                     end;
                    PoleOvrl.a[HlOvrl].Plocha:=PoleOvrl.a[HlOvrl].Plocha + OE.Area/10000; //Tgis_LT(OE.A2).Plocha;
                   end;
                 end;
               end
              else
               begin
               end;
             end; // for iow
 end;

procedure vytvorPoledleParCisParPodlZPAROwelay(     GisSkupina:Tgis_PorostniSkupina;
                                       Var PoleOvrl : TPoleOvrlParCisParPodl );
Var
 OE:TOverlayGeometryElement;
 Parcela:TGis_Parcela;
 iOw,iOvrl,HlOvrl:integer;
 begin
            for iOvrl:=1 to 100 do
             begin
              PoleOvrl.a[iOvrl].ParCis:='';
              PoleOvrl.a[iOvrl].ParPodl:='';
              PoleOvrl.a[iOvrl].Kultura:=0;
              PoleOvrl.a[iOvrl].Plocha:=0;
              PoleOvrl.a[iOvrl].LV:='';
             end;
            PoleOvrl.PocetOvrl:=0;
            for iOw:=0 to  GisSkupina.OwnersCount-1 do
             begin
              if  GisSkupina.Owners[iOw] is TOverlayGeometryElement then
               begin
                if TOverlayGeometryElement(GisSkupina.Owners[iOw]).FindOwnerName('OverlayPAR')<>NIL then
                 begin
                  OE:=TOverlayGeometryElement(GisSkupina.Owners[iOw]);
                  if OE.IsFull then
                   begin
                    Parcela:=Tgis_Parcela(Tgis_ParcelaCast(OE.A2).FindOwnerClass(Tgis_Parcela));
                    HlOvrl:=-1;
                     for iOvrl:=1 to PoleOvrl.PocetOvrl do
                      begin
                       if     (PoleOvrl.a[iOvrl].ParCis=inttostr(Parcela.PARCIS))
                          and (PoleOvrl.a[iOvrl].ParPodl=inttostr(Parcela.PARPOD))
                          and (PoleOvrl.a[iOvrl].LV=inttostr(Tgis_ParcelaCast(OE.A2).LVC))
                          // and (PoleOvrl.a[iOvrl].LV=inttostr(Parcela.LV))

                       then HlOvrl:=iOvrl;
                      end;
                    if HlOvrl=-1 then
                     begin
                      inc(PoleOvrl.PocetOvrl);
                      HlOvrl:=PoleOvrl.PocetOvrl;
                      // PoleOvrl.a[HlOvrl].NAZEV:=inttostr(Parcela.Kultura);
                      PoleOvrl.a[HlOvrl].ParCis:=inttostr(Parcela.PARCIS);
                      PoleOvrl.a[HlOvrl].ParPodl:=inttostr(Parcela.PARPOD);
                      PoleOvrl.a[HlOvrl].Kultura:=Parcela.Kultura;
                      // PoleOvrl.a[HlOvrl].LV:=inttostr(Parcela.LV);
                      PoleOvrl.a[HlOvrl].LV:=inttostr(Tgis_ParcelaCast(OE.A2).LVC);
                     end;
                    PoleOvrl.a[HlOvrl].Plocha:=PoleOvrl.a[HlOvrl].Plocha + OE.Area/10000; //Tgis_LT(OE.A2).Plocha;
                   end;
                 end;
               end
              else
               begin
               end;
             end; // for iow
 end;

procedure vytvorPoledleHodnotyZLTOwelay(     GisSkupina:Tgis_PorostniSkupina; HlProperta:String;
                                       Var PoleOvrl : TPoleOvrl;
                                           infomemo:TMemo );
Var
 OE:TOverlayGeometryElement;
 iOw,iOvrl,HlOvrl:integer;
 begin
            for iOvrl:=1 to 100 do
             begin
              PoleOvrl.a[iOvrl].NAZEV:='';
              PoleOvrl.a[iOvrl].Plocha:=0;
             end;
            PoleOvrl.PocetOvrl:=0;
            for iOw:=0 to  GisSkupina.OwnersCount-1 do
             begin
              if  GisSkupina.Owners[iOw] is TOverlayGeometryElement then
               begin
                if TOverlayGeometryElement(GisSkupina.Owners[iOw]).FindOwnerName('OVERLAY')<>NIL then
                 begin
                  OE:=TOverlayGeometryElement(GisSkupina.Owners[iOw]);
                  if OE.IsFull then
                   begin
                    HlOvrl:=-1;
                    for iOvrl:=1 to PoleOvrl.PocetOvrl do
                     begin
                      if PoleOvrl.a[iOvrl].NAZEV=Tgis_LT(OE.A2).GetPropertyStringByName(HlProperta) then HlOvrl:=iOvrl;
                     end;
                    if HlOvrl=-1 then
                     begin
                      inc(PoleOvrl.PocetOvrl);
                      HlOvrl:=PoleOvrl.PocetOvrl;
                      PoleOvrl.a[HlOvrl].NAZEV:=Tgis_LT(OE.A2).GetPropertyStringByName(HlProperta);
                     end;
                    PoleOvrl.a[HlOvrl].Plocha:=PoleOvrl.a[HlOvrl].Plocha + OE.Area/10000; //Tgis_LT(OE.A2).Plocha;
                   end;
                 end;
               end
              else
               begin
               end;
             end; // for iow
 end;

procedure vytvorPoledleHodnotyZOchrPrir(     GisSkupina:Tgis_PorostniSkupina; HlProperta:String;
                                       Var PoleOvrl : TPoleOvrl;
                                           infomemo:TMemo );
Var
 OE:TOverlayGeometryElement;
 iOw,iOvrl,HlOvrl:integer;
 begin
            for iOvrl:=1 to 100 do
             begin
              PoleOvrl.a[iOvrl].NAZEV:='';
              PoleOvrl.a[iOvrl].Plocha:=0;
             end;
            PoleOvrl.PocetOvrl:=0;
            for iOw:=0 to  GisSkupina.OwnersCount-1 do
             begin
              if  GisSkupina.Owners[iOw] is TOverlayGeometryElement then
               begin
                if TOverlayGeometryElement(GisSkupina.Owners[iOw]).FindOwnerName('OVERLAY')<>NIL then
                 begin
                  OE:=TOverlayGeometryElement(GisSkupina.Owners[iOw]);
                  if OE.IsFull then
                   begin
                    HlOvrl:=-1;
                    for iOvrl:=1 to PoleOvrl.PocetOvrl do
                     begin
                      if PoleOvrl.a[iOvrl].NAZEV=OE.GetPropertyStringByName(HlProperta) then HlOvrl:=iOvrl;
                     end;
                    if HlOvrl=-1 then
                     begin
                      inc(PoleOvrl.PocetOvrl);
                      HlOvrl:=PoleOvrl.PocetOvrl;
                      PoleOvrl.a[HlOvrl].NAZEV:=OE.GetPropertyStringByName(HlProperta);
                     end;
                    PoleOvrl.a[HlOvrl].Plocha:=PoleOvrl.a[HlOvrl].Plocha + OE.Area/10000; //Tgis_LT(OE.A2).Plocha;
                   end;
                 end;
               end
              else
               begin
               end;
             end; // for iow
 end;


procedure SetridPoleOvrl(var PoleOvrl : TPoleOvrl);
var
 NPoleOvrl : TPoleOvrl;
 POvrl,iOvrl, maxiOvrl:Integer;
 maxPlocha:double;
 begin
  for POvrl:=1 to PoleOvrl.PocetOvrl do
   begin
    maxPlocha:=0;
    for iOvrl:=1 to PoleOvrl.PocetOvrl do
     begin
      if maxPlocha<PoleOvrl.A[iOvrl].Plocha then
       begin
        maxPlocha :=PoleOvrl.A[iOvrl].Plocha;
        maxiOvrl  :=iOvrl;
       end;
     end;
    NPoleOvrl.A[POvrl]:=PoleOvrl.A[maxiOvrl];
    PoleOvrl.A[maxiOvrl].Plocha:=-1;
   end;
  NPoleOvrl.PocetOvrl:=PoleOvrl.PocetOvrl;
  PoleOvrl :=NPoleOvrl;
 end;

Procedure SetridenyPole  (     GisSkupina:Tgis_PorostniSkupina; HlProperta:String;
                           var SetridenePoleOvrl : TPoleOvrl;
                                           infomemo:TMemo );
 var PoleOvrl : TPoleOvrl;
 begin
  vytvorPoledleHodnotyZLTOwelay(GisSkupina,HlProperta,PoleOvrl,infomemo);
  SetridPoleOvrl(PoleOvrl);

  SetridenePoleOvrl :=  PoleOvrl ;

 end;

Procedure SetridenyPoleOchrPrir  (     GisSkupina:Tgis_PorostniSkupina; HlProperta:String;
                           var SetridenePoleOvrl : TPoleOvrl;
                                           infomemo:TMemo );
 var PoleOvrl : TPoleOvrl;
 begin
  vytvorPoledleHodnotyZOchrPrir(GisSkupina,HlProperta,PoleOvrl,infomemo);
  SetridPoleOvrl(PoleOvrl);

  SetridenePoleOvrl :=  PoleOvrl ;

 end;


procedure prevazujiciHodnotaZLTOwelay( GisSkupina:Tgis_PorostniSkupina; HlProperta:String;
                                       Var VyslHodnProperty:String; Var VahaProperty {podilplochy}:Double;
                                           infomemo:TMemo );
var
 maxPlocha:Double;
 maxNazev:string;
 PoleOvrl : TPoleOvrl;
 iOvrl:integer;
 begin
  vytvorPoledleHodnotyZLTOwelay(GisSkupina,HlProperta,PoleOvrl,infomemo);

            maxPlocha:=-1;
            maxNazev:='';
            for iOvrl:=1 to PoleOvrl.PocetOvrl do
             begin
              infomemo.Lines.Add(PoleOvrl.A[iOvrl].NAZEV+ '  ' + floatTOStrf(PoleOvrl.A[iOvrl].Plocha,ffFixed,10,2));
              if maxPlocha<PoleOvrl.A[iOvrl].Plocha then
               begin
                maxPlocha :=PoleOvrl.A[iOvrl].Plocha;
                maxNazev  :=PoleOvrl.A[iOvrl].NAZEV;
               end;
             end;
   VyslHodnProperty :=maxNazev;
   if GisSkupina.plocha>0.000001 then
    begin
     VahaProperty:=maxPlocha/GisSkupina.plocha;
    end
   else
    begin
     VahaProperty:=0;
    end;
 end;

procedure prevazujiciKulturaZPAROwelay( GisSkupina:Tgis_PorostniSkupina;
                                       Var VyslHodnProperty:String; Var VahaProperty {podilplochy}:Double;
                                           infomemo:TMemo );
var
 maxPlocha:Double;
 maxNazev:string;
 PoleOvrl : TPoleOvrl;
 iOvrl:integer;
 begin
  vytvorPoledleKulturyZPAROwelay(GisSkupina,PoleOvrl,infomemo);

            maxPlocha:=-1;
            maxNazev:='';
            for iOvrl:=1 to PoleOvrl.PocetOvrl do
             begin
              infomemo.Lines.Add(PoleOvrl.A[iOvrl].NAZEV+ '  ' + floatTOStrf(PoleOvrl.A[iOvrl].Plocha,ffFixed,10,2));
              if maxPlocha<PoleOvrl.A[iOvrl].Plocha then
               begin
                maxPlocha :=PoleOvrl.A[iOvrl].Plocha;
                maxNazev  :=PoleOvrl.A[iOvrl].NAZEV;
               end;
             end;
   VyslHodnProperty :=maxNazev;
   VahaProperty:=maxPlocha/GisSkupina.plocha;
 end;

procedure nactiOchrPrirZOrbuDoOddeleni(VOdd:Toddeleni; HlChyb:TOznaceniPorSkupinyHlaskaChybyMN;
                                       infomemo:TMemo;infoEdit:TEdit;CoNacistzOchrPrir:TCoNacistzOchrPrir);
var
 iDil,iPor,iPsk,iBzl,iJP,iOst,iOw:integer;
 GisSkupina:Tgis_PorostniSkupina;
 SLHC,sSprava,sODD,sDil,sPOR,sPSK,sBzl,sJP,sOst:String;
 NazevProZvl:String;
 Vgis_Oddeleni : Tgis_Oddeleni;
 chyba1:String;
 TYP1:String;
 SetridenePoleOvrl,SetridenePoleOvrl1,SetridenePoleOvrl2 : TPoleOvrl;
 iOvrl:Integer;
 begin
  SLHC:=inttostr(vODD.OwnerLHC_KOD);
  sODD:=inttostr(vODD.ODD);
  sSprava:='je na nic';
  for iDil:=0 to VOdd.DilecMN.Count-1 do
   begin
    sDIL:=vODD.IDilec[iDil].DIL;
    for iPor:=0 to VOdd.iDilec[iDil].porostMN.Count-1 do
     begin
      with  VOdd.iDilec[iDil].iporost[iPor] do
       begin
        sPOR:=POR;
        sSprava:='je na nic';
        for iPsk:=0 to porostniSkupinaMN.Count-1 do
         begin
          infoedit.text:='nacitam '+IPorostniSkupina[iPsk].CeleOznaceni; infoedit.refresh;
          sPSK:=ubm(IPorostniSkupina[iPsk].PSK);
          GisSkupina:=NajdiSkupinuVOrbu(SLHC,sSprava,sODD,sDil,sPOR,sPSK,chyba1);
          if GisSkupina<>nil then
           begin
            SetridenyPoleOchrPrir(  GisSkupina, 'A2_N_KOD',  SetridenePoleOvrl, infomemo );
            if CoNacistzOchrPrir = NacistZCHU  then
             begin
              // dal poloky z tabulky
              // sem se nat TYP
              SetridenyPoleOchrPrir(  GisSkupina, 'A2_N_KOD1',  SetridenePoleOvrl1, infomemo );
              // dal poloky z tabulky SetridenyPoleOchrPrir(  GisSkupina, 'A2_N_KOD2',  SetridenePoleOvrl, infomemo );
             end;
            for iOvrl:=1 to SetridenePoleOvrl.PocetOvrl  do
               begin
                with SetridenePoleOvrl.a[iOvrl] do
                 begin
                   if Plocha/IPorostniSkupina[iPsk].PSK_P>0.3 then
                    begin
                     case CoNacistzOchrPrir  of
                     NacistZCHU:
                      begin
                       TYP1:=SetridenePoleOvrl1.a[iOvrl].NAZEV;
                       TYP1:=ubm(TYP1);
                       if TYP1='PR' then
                        begin
                          IPorostniSkupina[iPsk].PR_KOD:=strtoint0(NAZEV);
                          infomemo.Lines.Add('Nacteno PR '+sODD+sDil+sPOR+' '+sPSK+' '+NAZEV);
                        end;
                       if TYP1='PP' then
                        begin
                          IPorostniSkupina[iPsk].PP_KOD:=strtoint0(NAZEV);
                          infomemo.Lines.Add('Nacteno PP '+sODD+sDil+sPOR+' '+sPSK+' '+NAZEV);
                        end;
                       if TYP1='NPR' then
                        begin
                          IPorostniSkupina[iPsk].NPR_KOD:=NAZEV;
                          infomemo.Lines.Add('Nacteno NPR '+sODD+sDil+sPOR+' '+sPSK+' '+NAZEV);
                        end;
                       if TYP1='NPP' then
                        begin
                          IPorostniSkupina[iPsk].NPP_KOD:=NAZEV;
                          infomemo.Lines.Add('Nacteno NPP '+sODD+sDil+sPOR+' '+sPSK+' '+NAZEV);
                        end;
                      end;
                     nacistEVL:
                      begin
                       IPorostniSkupina[iPsk].EVL_KOD:=NAZEV;
                       infomemo.Lines.Add('Nacteno EVL '+sODD+sDil+sPOR+' '+sPSK+' '+NAZEV);
                      end;
                     nacistPO:
                      begin
                       IPorostniSkupina[iPsk].PO_KOD:=strtoint0(NAZEV);
                       infomemo.Lines.Add('Nacteno ptaci obl. '+sODD+sDil+sPOR+' '+sPSK+' '+NAZEV);
                      end;
                     NacistCHKO:
                      begin
                       IPorostniSkupina[iPsk].CHKO_KOD:=strtoint0(NAZEV);
                       infomemo.Lines.Add('Nacteno CHKO '+sODD+sDil+sPOR+' '+sPSK+' '+NAZEV);
                      end;
                     NacistUSESNazev:
                      begin
                       IPorostniSkupina[iPsk].OwnerPorost.ZVL_ST_Pridej:='19';
                       If pos('USES:',IPorostniSkupina[iPsk].PSK_TEXT)<=0 then
                        begin
                         IPorostniSkupina[iPsk].PRIDPOZN:='USES: '+NAZEV;
                         infomemo.Lines.Add('pidn USES '+sODD+sDil+sPOR+' '+sPSK+' '+NAZEV);
                        end
                       else
                        begin
                         infomemo.Lines.Add('Na datech USES ji byl '+sODD+sDil+sPOR+' '+sPSK+' '+NAZEV);
                        end;
                      end;
                     NacistUSESKOD_UPK:
                      begin
                       if ubm(NAZEV)<>'' then
                        begin
                         IPorostniSkupina[iPsk].PRIDPOZN:=' '+NAZEV+' ';
                        end;
                      end;
                     NacistUsesKOD_UPKdoZvlSt:
                      begin
                       NazevProZvl:='';
                       if Length(ubm(NAZEV))>2 then NazevProZvl:=copy(ubm(uppercase(NAZEV)),1,3);
                       if NazevProZvl='NBC' then IPorostniSkupina[iPsk].OwnerPorost.ZVL_ST_Pridej:='20';
                       if NazevProZvl='RBC' then IPorostniSkupina[iPsk].OwnerPorost.ZVL_ST_Pridej:='21';
                       if NazevProZvl='LBC' then IPorostniSkupina[iPsk].OwnerPorost.ZVL_ST_Pridej:='22';
                      end;
                    end; // case
                    end;
                 end;
               end;
           end;
         end;

        for iBzl:=0 to BezlesiMN.Count-1 do
         begin
          infoedit.text:='nacitam '+IBezlesi[iBzl].CeleOznaceni; infoedit.refresh;
          sPSK:=inttostr(IBezlesi[iBzl].BZL);
          GisSkupina:=NajdiSkupinuVOrbu(SLHC,sSprava,sODD,sDil,sPOR,sPSK,chyba1);
          if GisSkupina<>nil then
           begin
            SetridenyPoleOchrPrir(  GisSkupina, 'A2_N_KOD',  SetridenePoleOvrl, infomemo );
            for iOvrl:=1 to SetridenePoleOvrl.PocetOvrl  do
               begin
                with SetridenePoleOvrl.a[iOvrl] do
                 begin
                   if Plocha/IBezlesi[iBzl].BZL_P>0.3 then
                    begin
                     case CoNacistzOchrPrir  of
                     nacistEVL:
                      begin
                       IBezlesi[iBzl].EVL_KOD:=NAZEV;
                       infomemo.Lines.Add('Do bezlesi nacteno EVL '+sODD+sDil+sPOR+' '+sPSK+' '+NAZEV+' ');
                      end;
                     nacistPO:
                      begin
                       IBezlesi[iBzl].PO_KOD:=strtoint0(NAZEV);
                       infomemo.Lines.Add('Do bezlesi nacteno ptaci obl. '+sODD+sDil+sPOR+' '+sPSK+' '+NAZEV);
                      end;
                     NacistCHKO:
                      begin
                       IBezlesi[iBzl].CHKO_KOD:=strtoint0(NAZEV);
                       infomemo.Lines.Add('Do bezlesi nacteno CHKO '+sODD+sDil+sPOR+' '+sPSK+' '+NAZEV);
                      end;
                     NacistUsesKOD_UPKdoZvlSt:
                      begin
                       NazevProZvl:='';
                       if Length(ubm(NAZEV))>2 then NazevProZvl:=copy(ubm(uppercase(NAZEV)),1,3);
                       if NazevProZvl='NBC' then IBezlesi[iBzl].OwnerPorost.ZVL_ST_Pridej:='20';
                       if NazevProZvl='RBC' then IBezlesi[iBzl].OwnerPorost.ZVL_ST_Pridej:='21';
                       if NazevProZvl='LBC' then IBezlesi[iBzl].OwnerPorost.ZVL_ST_Pridej:='22';
                      end;
                     end; // case
                   end;
                 end;
               end;
           end;
         end;

        for iJP:=0 to JinyPozemekMN.Count-1 do
         begin
          infoedit.text:='nacitam '+IJinyPozemek[iJP].CeleOznaceni; infoedit.refresh;
          sPSK:=inttostr(IJinyPozemek[iJP].JP);
          GisSkupina:=NajdiSkupinuVOrbu(SLHC,sSprava,sODD,sDil,sPOR,sPSK,chyba1);
          if GisSkupina<>nil then
           begin
            SetridenyPoleOchrPrir(  GisSkupina, 'A2_N_KOD',  SetridenePoleOvrl, infomemo );
            for iOvrl:=1 to SetridenePoleOvrl.PocetOvrl  do
               begin
                with SetridenePoleOvrl.a[iOvrl] do
                 begin
                   if Plocha/IJinyPozemek[iJP].JP_P>0.3 then
                    begin
                     case CoNacistzOchrPrir  of
                     nacistEVL:
                      begin
                       IJinyPozemek[iJP].EVL_KOD:=NAZEV;
                       infomemo.Lines.Add('Do jineho poz. nacteno EVL '+sODD+sDil+sPOR+' '+sPSK+' '+NAZEV+' ');
                      end;
                     nacistPO:
                      begin
                       IJinyPozemek[iJP].PO_KOD:=strtoint0(NAZEV);
                       infomemo.Lines.Add('Do jineho poz. nacteno ptaci obl. '+sODD+sDil+sPOR+' '+sPSK+' '+NAZEV);
                      end;
                     NacistCHKO:
                      begin
                       IJinyPozemek[iJP].CHKO_KOD:=strtoint0(NAZEV);
                       infomemo.Lines.Add('Do jineho poz. nacteno CHKO '+sODD+sDil+sPOR+' '+sPSK+' '+NAZEV);
                      end;
                     NacistUsesKOD_UPKdoZvlSt:
                      begin
                       NazevProZvl:='';
                       if Length(ubm(NAZEV))>2 then NazevProZvl:=copy(ubm(uppercase(NAZEV)),1,3);
                       if NazevProZvl='NBC' then IJinyPozemek[iJP].OwnerPorost.ZVL_ST_Pridej:='20';
                       if NazevProZvl='RBC' then IJinyPozemek[iJP].OwnerPorost.ZVL_ST_Pridej:='21';
                       if NazevProZvl='LBC' then IJinyPozemek[iJP].OwnerPorost.ZVL_ST_Pridej:='22';
                      end;
                     end; // case
                    end;
                 end;
               end;
           end;
         end;
        for iOst:=0 to OstatniMN.Count-1 do
         begin
          infoedit.text:='nacitam '+IOstatni[iOst].CeleOznaceni; infoedit.refresh;
          sPSK:=inttostr(IOstatni[iOst].OST);
          GisSkupina:=NajdiSkupinuVOrbu(SLHC,sSprava,sODD,sDil,sPOR,sPSK,chyba1);
          if GisSkupina<>nil then
           begin
            SetridenyPoleOchrPrir(  GisSkupina, 'A2_N_KOD',  SetridenePoleOvrl, infomemo );
            for iOvrl:=1 to SetridenePoleOvrl.PocetOvrl  do
               begin
                with SetridenePoleOvrl.a[iOvrl] do
                 begin
                   if Plocha/IOstatni[iOst].OST_P>0.3 then
                    begin
                     case CoNacistzOchrPrir  of
                     nacistEVL:
                      begin
                       IOstatni[iOst].EVL_KOD:=NAZEV;
                       infomemo.Lines.Add('Do ostatnich nacteno EVL '+sODD+sDil+sPOR+' '+sPSK+' '+NAZEV);
                      end;
                     nacistPO:
                      begin
                       IOstatni[iOst].PO_KOD:=strtoint0(NAZEV);
                       infomemo.Lines.Add('Do ostatnich nacteno ptaci obl. '+sODD+sDil+sPOR+' '+sPSK+' '+NAZEV);
                      end;
                     NacistCHKO:
                      begin
                       IOstatni[iOst].CHKO_KOD:=strtoint0(NAZEV);
                       infomemo.Lines.Add('Do ostatnich nacteno CHKO '+sODD+sDil+sPOR+' '+sPSK+' '+NAZEV);
                      end;
                     end; // case
                    end;
                 end;
               end;
           end;
         end;
       end;
     end;
   end;
 end;

procedure nactiPlochyZOrbuDoOddeleni(VOdd:Toddeleni; HlChyb:TOznaceniPorSkupinyHlaskaChybyMN; infomemo:TMemo;infoEdit:TEdit);
var
 iDil,iPor,iPsk,iBzl,iJP,iOst,iOw:integer;
 GisSkupina:Tgis_PorostniSkupina;
 SLHC,sSprava,sODD,sDil,sPOR,sPSK,sBzl,sJP,sOst:String;
 chyba1:String;
 VChyb:TOznaceniPorSkupinyHlaskaChyby;
 bylNactenPorost:boolean;
 VyslHodnProperty,SS,SeznamLT,sPSK_TEXT,
 SPocetCastiSlovne,S1,S2,S3,S4:String;
 iSt:Integer;
 konec,naselCisloCast:Boolean;
 VahaProperty {podilplochy}:Double;

 OE:TOverlayGeometryElement;
 PocetOvrl,iOvrl,HlOvrl,OUi:integer;
 maxPlocha:Double;
 maxNazev:string;

 SetridenePoleOvrl : TPoleOvrl;
 Vgis_Oddeleni : Tgis_Oddeleni;

 begin
  SLHC:=inttostr(vODD.OwnerLHC_KOD);
  sODD:=inttostr(vODD.ODD);
  with PozadovaneNacteniZLedu do
   begin
  if    (KVAL_PdoPSK_KVAL_Vypocet1 in NacteniZLedu)
     or (KVAL_PdoPSK_KVAL_BezVypoctu in NacteniZLedu) then
   begin
    vOdd.nastavZdaMenitPlochy;
    VOdd.nastavZdaMenitPodleBarev;
   end;
  sSprava:='je na nic';
  if SmazADoplnBezlJinOST in NacteniZLedu then
   begin
    VODD.SmazBezlesiJPaOst;
   end;
  if (DoplnBezlJinOSTKdyzNeni in NacteniZLedu) or (SmazADoplnBezlJinOST in NacteniZLedu) then
   begin
    Vgis_Oddeleni:=NajdiOddeleniVOrbu(SLHC,sSprava,sODD,chyba1);
    if Vgis_Oddeleni<>nil then DoOddeleniVTaxuDoplnBezlesiZOrbu(VOdd,Vgis_Oddeleni,chyba1,Infomemo);
   end;
  for iDil:=0 to VOdd.DilecMN.Count-1 do
   begin
    sDIL:=vODD.IDilec[iDil].DIL;
    for iPor:=0 to VOdd.iDilec[iDil].porostMN.Count-1 do
     begin
      with  VOdd.iDilec[iDil].iporost[iPor] do
       begin
        sPOR:=POR;
        sSprava:='je na nic';
        bylNactenPorost:=false;
        for iPsk:=0 to porostniSkupinaMN.Count-1 do
         begin
          infoedit.text:='nacitam '+IPorostniSkupina[iPsk].CeleOznaceni; infoedit.refresh;
          sPSK:=ubm(IPorostniSkupina[iPsk].PSK);
          GisSkupina:=NajdiSkupinuVOrbu(SLHC,sSprava,sODD,sDil,sPOR,sPSK,chyba1);
          if GisSkupina=nil then
           begin
            // SHOWMESSAGE('neexistuje SKUPINA '+IPorostniSkupina[iPsk].celeOznaceni);
            VChyb:=TOznaceniPorSkupinyHlaskaChyby.create;
            VChyb.Odd:=vODD.ODD;
            VChyb.Dil:=sDIL;
            VChyb.Por:=sPOR;
            VChyb.PSK:=sPSK;
            VChyb.cisloChyby:=1;
            VChyb.HlaskaChyby:='Plocha nen v LEDu. '+Chyba1;
            HlChyb.AddElement(VChyb);
           end
          else
           begin
            if DalsiLTdoPSK_TEXT in NacteniZLedu then
             begin
              SetridenyPole (  GisSkupina, 'LT',  SetridenePoleOvrl, infomemo );
              SeznamLT:='';
              for iOvrl:=1 to SetridenePoleOvrl.PocetOvrl  do
               begin
                with SetridenePoleOvrl.a[iOvrl] do
                 begin
                  if (NAZEV<>IPorostniSkupina[iPsk].LT)
                     and ((length(NAZEV)=2)or(length(NAZEV)=3))
                     and  (plocha>0.0051) then
                   begin
                    If (length(NAZEV)=2) then SS:=Nazev+'0' else SS:=Nazev;
                    if  LesTypvPoradku(SS) then
                     begin
                      if SeznamLT='' then SeznamLT:=NAZEV else SeznamLT:=SeznamLT+','+NAZEV;
                     end;
                   end;
                 end;
               end;
              sPSK_TEXT:=IPorostniSkupina[iPsk].PSK_TEXT;
              if pos('Dal LT:',sPSK_TEXT)>0 then
               begin
                RozdelDlePrvnihoStringu(sPSK_TEXT,'Dal LT:',S1,S2);
                RozdelDlePrvnihoStringu(S2,'.',S3,S4);
                sPSK_TEXT:=S1+S4;
               end;
              if SeznamLT<>'' then
               begin
                sPSK_TEXT:=vlozPredNMD_DTO(sPSK_TEXT,' Dal LT: '+SeznamLT+'.');
                //sPSK_TEXT + ' Dal LT: '+SeznamLT+'.';
               end;
              if length(sPSK_TEXT)>1023 then
               begin
                VChyb:=TOznaceniPorSkupinyHlaskaChyby.create;
                VChyb.Odd:=vODD.ODD;
                VChyb.Dil:=sDIL;
                VChyb.Por:=sPOR;
                VChyb.PSK:=sPSK;
                VChyb.cisloChyby:=2;
                VChyb.HlaskaChyby:='PSK_TEXT del 1023 zn. Neuloeno "'+copy(sPSK_TEXT,1023,length(sPSK_TEXT)-1023)+'"';
                HlChyb.AddElement(VChyb);
               end;
              IPorostniSkupina[iPsk].PSK_TEXT:=sPSK_TEXT;
             end;
            if PocetCastiDoPSK_TEXT  in NacteniZLedu  then
             begin
              IPorostniSkupina[iPsk].PocetCasti:= PocetCasti(GisSkupina);

              sPSK_TEXT:=IPorostniSkupina[iPsk].PSK_TEXT;
              SPocetCastiSlovne:=IPorostniSkupina[iPsk].PocetCastiSlovne;
              if not(pos(SPocetCastiSlovne,sPSK_TEXT)>0) then
               begin
                ist:=9999;
                if pos(' sti.',sPSK_TEXT)>0 then
                 begin
                  RozdelDlePrvnihoStringu(sPSK_TEXT,' sti.',S1,S2);
                  iSt:=Length(S1);
                 end;
                if pos(' st.',sPSK_TEXT)>0 then
                 begin
                  RozdelDlePrvnihoStringu(sPSK_TEXT,' st.',S1,S2);
                  iSt:=Length(S1);
                 end;
                if pos(' sti;',sPSK_TEXT)>0 then
                 begin
                  RozdelDlePrvnihoStringu(sPSK_TEXT,' sti;',S1,S2);
                  iSt:=Length(S1);
                 end;
                if pos(' st;',sPSK_TEXT)>0 then
                 begin
                  RozdelDlePrvnihoStringu(sPSK_TEXT,' st;',S1,S2);
                  iSt:=Length(S1);
                 end;
                if pos(' sti,',sPSK_TEXT)>0 then
                 begin
                  RozdelDlePrvnihoStringu(sPSK_TEXT,' sti,',S1,S2);
                  iSt:=Length(S1);
                 end;
                if pos(' st,',sPSK_TEXT)>0 then
                 begin
                  RozdelDlePrvnihoStringu(sPSK_TEXT,' st,',S1,S2);
                  iSt:=Length(S1);
                 end;

                if ist<>9999 then
                 begin
                  konec:=false;
                  naselCisloCast:=false;
                  while (S1[ist]>='0')and(S1[ist]<='9')and(not(konec)) do
                   begin
                    naselCisloCast:=true;
                    if ist>1 then
                     begin
                      dec(ist)
                     end
                    else
                     begin
                      konec:=true;
                     end;
                   end;
                  if konec then S1:=''
                  else S1:=copy(S1,1,iSt);
                  if naselCisloCast then
                   begin
                    S1:=trim(S1);
                    if S1<>'' then
                     begin
                      if S1[length(S1)]=';' then S1:=copy(S1,1,length(S1)-1);
                     end;
                    sPSK_TEXT:=S1+S2;
                   end;
                 end;
                // sPSK_TEXT:=sPSK_TEXT+' '+SPocetCastiSlovne;
                sPSK_TEXT:=DoplnPoznamkuZaStrednik(sPSK_TEXT,SPocetCastiSlovne);

                if length(sPSK_TEXT)>1023 then
                 begin
                  VChyb:=TOznaceniPorSkupinyHlaskaChyby.create;
                  VChyb.Odd:=vODD.ODD;
                  VChyb.Dil:=sDIL;
                  VChyb.Por:=sPOR;
                  VChyb.PSK:=sPSK;
                  VChyb.cisloChyby:=2;
                  VChyb.HlaskaChyby:='PSK_TEXT je del ne 1023 znak. Pidvalo se "'+SPocetCastiSlovne+'".';
                  HlChyb.AddElement(VChyb);
                 end;
                IPorostniSkupina[iPsk].PSK_TEXT:=sPSK_TEXT;
               end;
             end;
            if PocetCastiDoPocetCasti  in NacteniZLedu  then
             begin
              IPorostniSkupina[iPsk].PocetCasti:= PocetCasti(GisSkupina);
              infomemo.Lines.Add('--------- PocetCasti ---' + inttostr(IPorostniSkupina[iPsk].PocetCasti));
             end;


            if LVSdoLVSPsk in NacteniZLedu  then
             begin
              IPorostniSkupina[iPsk].LVS := GisSkupina.LVS;
             end;

            if LVdoCislo_Tel in NacteniZLedu  then
             begin
              IPorostniSkupina[iPsk].CISLO_TEL_XML := inttostr(GisSkupina.LV);
             end;

           if  LTdoLTPSK in NacteniZLedu then
             begin
               prevazujiciHodnotaZLTOwelay(GisSkupina,'LT',VyslHodnProperty,VahaProperty,infomemo);
               IPorostniSkupina[iPsk].LT:=VyslHodnProperty;
             end;

            if  SLTdoSLTPSK in NacteniZLedu then
             begin
               prevazujiciHodnotaZLTOwelay(GisSkupina,'SLT',VyslHodnProperty,VahaProperty,infomemo);
               IPorostniSkupina[iPsk].SLT:=VyslHodnProperty;
             end;

            // prevazujiciHodnotaZLTOwelay(GisSkupina,'SLT',VyslHodnProperty,VahaProperty,infomemo);
            // IPorostniSkupina[iPsk].PSK_TEXT := IPorostniSkupina[iPsk].PSK_TEXT+VyslHodnProperty;
                 //         /LTdoLT, /SLTDoSLT, /LES_OBLDoLES_OBL,/DalsiLTdoPSK_TEXT,PocetCastiDoPSK_TEXT


            if PLOCHAdoPlocha0PSK in NacteniZLedu then
             begin
               IPorostniSkupina[iPsk].Plocha0:=GisSkupina.Plocha;
             end;
            if VYMERAdoVymeraPSK in NacteniZLedu then
             begin
              IPorostniSkupina[iPsk].Vymera:=GisSkupina.Vymera;
             end;
            if KVAL_PdoPSK_KVAL_Vypocet1 in NacteniZLedu then
             begin
              IPorostniSkupina[iPsk].PSK_KVAL_Vypocet:=GisSkupina.KVAL_P;
             end;

            if KVAL_PdoPSK_KVAL_BezVypoctu in NacteniZLedu then
             begin
              IPorostniSkupina[iPsk].PSK_KVAL_BezVypoctu:=GisSkupina.KVAL_P;
             end;


            if KU_KODdoKU_KODPSK in NacteniZLedu then
             begin
              IPorostniSkupina[iPsk].KU_KOD:=GisSkupina.KU_KOD;
             end;
            if KU_KODdoORPzKU6PSK in NacteniZLedu then
             begin
              IPorostniSkupina[iPsk].NactiORPzKU6:=GisSkupina.KU_KOD;
             end;
            if SK_PARCdoSKUPPARCPSK in NacteniZLedu then
             begin
              IPorostniSkupina[iPsk].SKUPPARC:=inttostr(GisSkupina.SK_PARC);
             end;
            if KATPAR_KODdoPOT_VLASTPSK in NacteniZLedu then
             begin
              IPorostniSkupina[iPsk].POT_VLAST:=GisSkupina.KATPAR_KOD;
             end;
           infoedit.text:='porost '+CeleOznaceni; infoedit.refresh;
           // if (OwnerDilec.DIL='L') and (POR='b') then ShowMessage('CAU tady');
            bylNactenPorost:=true;
            if MAJ_KODdoMAJ_KOD in NacteniZLedu then
             begin
              MAJ_KOD:=GisSkupina.VLASTNIK;  // pro vybrala 2011 a kivku 2014
            //  MAJ_KOD:=GisSkupina.MAJ_KOD;
             end;
            if MAJ_DRUHdoMAJ_DRUH in NacteniZLedu then
             begin
               MAJ_DRUH:=GisSkupina.MAJ_DRUH;
             end;
            if PAS_OHRdoPAS_OHR in NacteniZLedu then
             begin
               if GisSkupina.HasPropertyByName('PAS_OHR') then
                 begin
                  infomemo.Lines.Add('*'+GisSkupina.getpropertyStringByName('PAS_OHR')+'*')
                 end;
               PAS_OHR:=GisSkupina.getpropertyStringByName('PAS_OHR');
             end;


              if LS_KODDoOrgUr in NacteniZLedu then
               begin
                OUi:=strtoint(copy(ubm(FSPPolNactLED.CmbOrgUr.text),1,1));
                case OUi of
                 1:ORG_UROVEN1:=inttostr(GisSkupina.LS_Kod);
                 2:ORG_UROVEN2:=inttostr(GisSkupina.LS_Kod);
                 3:ORG_UROVEN3:=inttostr(GisSkupina.LS_Kod);
                end;
               end;


            if ZVL_STATUTdoZvlStVcetnePrekryvu in NacteniZLedu then
             begin
               ZvlStMn.NovaZvlStVcetnePrekryvusCarkama:= GisSkupina.ZVL_STATUT;
             end;
            if KATSdoKategorieVcetnePrekryvu in NacteniZLedu then
             begin
               Kategorie1Mn.NovaKategorieVcetnePrekryvusCarkama:=GisSkupina.KATS;
             end;

            if  LES_OBLDoLES_OBL in NacteniZLedu then
             begin
               prevazujiciHodnotaZLTOwelay(GisSkupina,'LES_OBL',VyslHodnProperty,VahaProperty,infomemo);
               LES_OBL := VyslHodnProperty;
             end;
            if LO_CASTDoLES_PODOBL in NacteniZLedu then
             begin
               prevazujiciHodnotaZLTOwelay(GisSkupina,'LO_CAST',VyslHodnProperty,VahaProperty,infomemo);
               if  JenPismena(VyslHodnProperty) then LES_PODOBL := LES_OBL+VyslHodnProperty
                                                else LES_PODOBL := VyslHodnProperty;
             end;
           end;
         end;

        for iBZL:=0 to bezlesiMN.Count-1 do
         begin
          infoedit.text:='nact bezl '+inttostr(Ibezlesi[iBZL].BZL); infoedit.refresh;

          sBZL:=inttostr(Ibezlesi[iBZL].BZL);
          GisSkupina:=NajdiSkupinuVOrbu(SLHC,sSprava,sODD,sDil,sPOR,sBZL,chyba1);
          if GisSkupina=nil then
           begin
            VChyb:=TOznaceniPorSkupinyHlaskaChyby.create;
            VChyb.Odd:=vODD.ODD;
            VChyb.Dil:=sDIL;
            VChyb.Por:=sPOR;
            VChyb.PSK:=sBZL;
            VChyb.cisloChyby:=1;
            VChyb.HlaskaChyby:='Bezles nen v LEDu';
            HlChyb.AddElement(VChyb);
           end
          else
           begin
//            infomemo.Lines.Add(Ibezlesi[iBZL].CeleOznaceni+'   bla='+GisSkupina.GetPropertyStringByName('BLABLABLA'));
            if BLABLABLAdoBZL_DRUH  in NacteniZLedu then
             begin
              // infomemo.Lines.Add(FSPPolNactLED.Ed1BLABLABLAdoBZL_DRUH.text);
              Ibezlesi[iBZL].BZL_DRUH:=uppercase(GisSkupina.GetPropertyStringByName(FSPPolNactLED.Ed1BLABLABLAdoBZL_DRUH.text));
              // infomemo.Lines.Add(Ibezlesi[iBZL].BZL_DRUH);
             end;
            if PLOCHAdoPlocha0BZL in NacteniZLedu then
             begin
               Ibezlesi[iBZL].Plocha0:=GisSkupina.Plocha;
             end;
            if VYMERAdoVymeraBZL in NacteniZLedu then
             begin
              Ibezlesi[iBZL].Vymera:=GisSkupina.Vymera;
             end;

            if KVAL_PdoBZL_KVAL_Vypocet in NacteniZLedu then
             begin
              IBezlesi[iBZL].BZL_KVAL_Vypocet:=GisSkupina.KVAL_P;
             end;
            if PoznamkaDoBZL_VYUZ in NacteniZLedu then
             begin
              // IBezlesi[iBZL].BZL_VYUZ:=GisSkupina.GetPropertyStringByName('Poznamka');
              IBezlesi[iBZL].BZL_VYUZ:=GisSkupina.GetPropertyStringByName(FSPPolNactLED.Ed1PoznamkaDoBZL_VYUZ.text);
              infomemo.Lines.Add(IBezlesi[iBZL].CeleOznaceniKratce+' '+FSPPolNactLED.Ed1PoznamkaDoBZL_VYUZ.text+'='
              +GisSkupina.GetPropertyStringByName(FSPPolNactLED.Ed1PoznamkaDoBZL_VYUZ.text));
             end;




            if KU_KODdoKU_KODBZL in NacteniZLedu then
             begin
              IBezlesi[iBZL].KU_KOD:=GisSkupina.KU_KOD;
             end;
            if KU_KODdoORPzKU6BZL in NacteniZLedu then
             begin
              IBezlesi[iBZL].NactiORPzKU6:=GisSkupina.KU_KOD;
             end;
            if SK_PARCdoSKUPPARCBZL in NacteniZLedu then
             begin
              IBezlesi[iBZL].SKUPPARC:=inttostr(GisSkupina.SK_PARC);
             end;
            if KATPAR_KODdoPOT_VLASTBZL in NacteniZLedu then
             begin
              IBezlesi[iBZL].POT_VLAST:=GisSkupina.KATPAR_KOD;
             end;

            if LVSdoLVSBzlJPOst in NacteniZLedu  then
             begin
              IBezlesi[iBZL].LVS := GisSkupina.LVS;
             end;

            if LVdoCislo_Tel in NacteniZLedu  then
             begin
              IBezlesi[iBZL].CISLO_TEL_XML := inttostr(GisSkupina.LV);
             end;

            if  LTdoLTBzlJPOst in NacteniZLedu then
             begin
              prevazujiciHodnotaZLTOwelay(GisSkupina,'LT',VyslHodnProperty,VahaProperty,infomemo);
              IBezlesi[iBZL].LT:=VyslHodnProperty;
             end;
            if  SLTdoSLTBzlJPOst in NacteniZLedu then
             begin
              prevazujiciHodnotaZLTOwelay(GisSkupina,'SLT',VyslHodnProperty,VahaProperty,infomemo);
              IBezlesi[iBZL].SLT:=VyslHodnProperty;
             end;


            if not bylNactenPorost then
             begin
              if MAJ_KODdoMAJ_KOD in NacteniZLedu then
               begin
                 MAJ_KOD:=GisSkupina.VLASTNIK;  // pro vybrala  2012 A kRIVKU 2014
                //  MAJ_KOD:=GisSkupina.MAJ_KOD;    PRO OSTATNI
               end;
              if MAJ_DRUHdoMAJ_DRUH in NacteniZLedu then
               begin
                MAJ_DRUH:=GisSkupina.MAJ_DRUH;
               end;

              if PAS_OHRdoPAS_OHR in NacteniZLedu then
               begin
                if GisSkupina.HasPropertyByName('PAS_OHR') then
                 begin
                  infomemo.Lines.Add('*'+GisSkupina.getpropertyStringByName('PAS_OHR')+'*')
                 end;
                PAS_OHR:=GisSkupina.getpropertyStringByName('PAS_OHR');
               end;

              if LS_KODDoOrgUr in NacteniZLedu then
               begin
                OUi:=strtoint(copy(ubm(FSPPolNactLED.CmbOrgUr.text),1,1));
                case OUi of
                 1:ORG_UROVEN1:=inttostr(GisSkupina.LS_Kod);
                 2:ORG_UROVEN2:=inttostr(GisSkupina.LS_Kod);
                 3:ORG_UROVEN3:=inttostr(GisSkupina.LS_Kod);
                end;
               end;


              if ZVL_STATUTdoZvlStVcetnePrekryvu in NacteniZLedu then
               begin
                ZvlStMn.NovaZvlStVcetnePrekryvusCarkama:= GisSkupina.ZVL_STATUT;
               end;
              if KATSdoKategorieVcetnePrekryvu in NacteniZLedu then
               begin
                Kategorie1Mn.NovaKategorieVcetnePrekryvusCarkama:=GisSkupina.KAT;
               end;
              if  LES_OBLDoLES_OBL in NacteniZLedu then
               begin
                prevazujiciHodnotaZLTOwelay(GisSkupina,'LES_OBL',VyslHodnProperty,VahaProperty,infomemo);
                LES_OBL := VyslHodnProperty;
               end;
              if LO_CASTDoLES_PODOBL in NacteniZLedu then
               begin
                 prevazujiciHodnotaZLTOwelay(GisSkupina,'LO_CAST',VyslHodnProperty,VahaProperty,infomemo);
                 LES_PODOBL := VyslHodnProperty;
               end;
             end;
           end;
         end;

        for iJP:=0 to JinyPozemekMN.Count-1 do
         begin

          infoedit.text:='nacitam JP '+IJinyPozemek[iJP].CeleOznaceni; infoedit.refresh;
          sJP:=inttostr(IJinyPozemek[iJP].JP);
          GisSkupina:=NajdiSkupinuVOrbu(SLHC,sSprava,sODD,sDil,sPOR,sJP,chyba1);
          if GisSkupina=nil then
           begin
            VChyb:=TOznaceniPorSkupinyHlaskaChyby.create;
            VChyb.Odd:=vODD.ODD;
            VChyb.Dil:=sDIL;
            VChyb.Por:=sPOR;
            VChyb.PSK:=sJP;
            VChyb.cisloChyby:=1;
            VChyb.HlaskaChyby:='Jin pozemek nen v LEDu';
            HlChyb.AddElement(VChyb);
           end
          else
           begin
            if PLOCHAdoPlocha0JP in NacteniZLedu then
             begin
               IJinyPozemek[iJP].Plocha0:=GisSkupina.Plocha;
             end;
           if BLABLABLAdoBZL_DRUH  in NacteniZLedu then
             begin
              IJinyPozemek[iJP].JP_DRUH:=uppercase(GisSkupina.GetPropertyStringByName(FSPPolNactLED.Ed1BLABLABLAdoBZL_DRUH.text));
             end;
           if KULTURAdoDRUH_POZJP  in NacteniZLedu then
             begin
               prevazujiciKulturaZPAROwelay(GisSkupina,VyslHodnProperty,VahaProperty,infomemo);
               IJinyPozemek[iJP].DRUH_POZ:=VyslHodnProperty;
             end;

            if VYMERAdoVymeraJP in NacteniZLedu then
             begin
              IJinyPozemek[iJP].Vymera:=GisSkupina.Vymera;
             end;
            if KVAL_PdoJP_KVAL_Vypocet in NacteniZLedu then
             begin
              IJinyPozemek[iJP].JP_KVAL_Vypocet:=GisSkupina.KVAL_P;
             end;
            if PoznamkaDoJP_VYUZ in NacteniZLedu then
             begin
              // IJinyPozemek[iJP].JP_VYUZ:=GisSkupina.GetPropertyStringByName('Poznamka');
              IJinyPozemek[iJP].JP_VYUZ:=GisSkupina.GetPropertyStringByName(FSPPolNactLED.Ed1PoznamkaDoBZL_VYUZ.text);
              infomemo.Lines.Add(IJinyPozemek[iJP].CeleOznaceniKratce+' '+FSPPolNactLED.Ed1PoznamkaDoBZL_VYUZ.text+' '
              +GisSkupina.GetPropertyStringByName(FSPPolNactLED.Ed1PoznamkaDoBZL_VYUZ.text));
             end;


            if KU_KODdoKU_KODJP in NacteniZLedu then
             begin
              IJinyPozemek[iJP].KU_KOD:=GisSkupina.KU_KOD;
             end;
            if KU_KODdoORPzKU6JP in NacteniZLedu then
             begin
              IJinyPozemek[iJP].NactiORPzKU6:=GisSkupina.KU_KOD;
             end;
            if SK_PARCdoSKUPPARCJP in NacteniZLedu then
             begin
              IJinyPozemek[iJP].SKUPPARC:=inttostr(GisSkupina.SK_PARC);
             end;
            if KATPAR_KODdoPOT_VLASTJP in NacteniZLedu then
             begin
              IJinyPozemek[iJP].POT_VLAST:=GisSkupina.KATPAR_KOD;
             end;
            if  LTdoLTBzlJPOst in NacteniZLedu then
             begin
              prevazujiciHodnotaZLTOwelay(GisSkupina,'LT',VyslHodnProperty,VahaProperty,infomemo);
              IJinyPozemek[iJP].LT:=VyslHodnProperty;
             end;
            if  SLTdoSLTBzlJPOst in NacteniZLedu then
             begin
              prevazujiciHodnotaZLTOwelay(GisSkupina,'SLT',VyslHodnProperty,VahaProperty,infomemo);
              IJinyPozemek[iJP].SLT:=VyslHodnProperty;
             end;
            if LVSdoLVSBzlJPOst in NacteniZLedu  then
             begin
              IJinyPozemek[iJP].LVS := GisSkupina.LVS;
             end;

            if LVdoCislo_Tel in NacteniZLedu  then
             begin
              IJinyPozemek[iJP].CISLO_TEL_XML := inttostr(GisSkupina.LV);
             end;


            if not bylNactenPorost then
             begin
              if MAJ_KODdoMAJ_KOD in NacteniZLedu then
               begin
                 MAJ_KOD:=GisSkupina.VLASTNIK;  // pro vybrala  2012 A kRIVKU 2014
                //  MAJ_KOD:=GisSkupina.MAJ_KOD;    PRO OSTATNI
               end;
              if MAJ_DRUHdoMAJ_DRUH in NacteniZLedu then
               begin
                MAJ_DRUH:=GisSkupina.MAJ_DRUH;
               end;
              if PAS_OHRdoPAS_OHR in NacteniZLedu then
               begin
               if GisSkupina.HasPropertyByName('PAS_OHR') then
                 begin
                  infomemo.Lines.Add('*'+GisSkupina.getpropertyStringByName('PAS_OHR')+'*')
                 end;
                PAS_OHR:=GisSkupina.getpropertyStringByName('PAS_OHR');
               end;

              if LS_KODDoOrgUr in NacteniZLedu then
               begin
                OUi:=strtoint(copy(ubm(FSPPolNactLED.CmbOrgUr.text),1,1));
                case OUi of
                 1:ORG_UROVEN1:=inttostr(GisSkupina.LS_Kod);
                 2:ORG_UROVEN2:=inttostr(GisSkupina.LS_Kod);
                 3:ORG_UROVEN3:=inttostr(GisSkupina.LS_Kod);
                end;
               end;
             if ZVL_STATUTdoZvlStVcetnePrekryvu in NacteniZLedu then
               begin
                ZvlStMn.NovaZvlStVcetnePrekryvusCarkama:= GisSkupina.ZVL_STATUT;
               end;
             if KATSdoKategorieVcetnePrekryvu in NacteniZLedu then
               begin
                Kategorie1Mn.NovaKategorieVcetnePrekryvusCarkama:=GisSkupina.KAT;
               end;
             if  LES_OBLDoLES_OBL in NacteniZLedu then
              begin
               prevazujiciHodnotaZLTOwelay(GisSkupina,'LES_OBL',VyslHodnProperty,VahaProperty,infomemo);
               LES_OBL := VyslHodnProperty;
              end;
             if LO_CASTDoLES_PODOBL in NacteniZLedu then
              begin
                prevazujiciHodnotaZLTOwelay(GisSkupina,'LO_CAST',VyslHodnProperty,VahaProperty,infomemo);
                LES_PODOBL := VyslHodnProperty;
              end;
            end;
           end;
         end;
        for iOST:=0 to OstatniMN.Count-1 do
         begin
          sOST:=inttostr(IOstatni[iOST].OST);
          infoedit.text:='nacitam OST '+IOstatni[iOST].CeleOznaceni; infoedit.refresh;
          GisSkupina:=NajdiSkupinuVOrbu(SLHC,sSprava,sODD,sDil,sPOR,sOST,chyba1);
          if GisSkupina=nil then
           begin
            VChyb:=TOznaceniPorSkupinyHlaskaChyby.create;
            VChyb.Odd:=vODD.ODD;
            VChyb.Dil:=sDIL;
            VChyb.Por:=sPOR;
            VChyb.PSK:=sOST;
            VChyb.cisloChyby:=1;
            VChyb.HlaskaChyby:='Bezles nen v LEDu';
            HlChyb.AddElement(VChyb);
           end
          else
           begin
            if PLOCHAdoPlocha0OST in NacteniZLedu then
             begin
               IOstatni[iOST].Plocha0:=GisSkupina.Plocha;
             end;
            if BLABLABLAdoBZL_DRUH  in NacteniZLedu then
             begin
              IOstatni[iOST].OP_DRUH:=uppercase(GisSkupina.GetPropertyStringByName(FSPPolNactLED.Ed1BLABLABLAdoBZL_DRUH.text));
             end;
           if KULTURAdoDRUH_POZOST  in NacteniZLedu then
             begin
               prevazujiciKulturaZPAROwelay(GisSkupina,VyslHodnProperty,VahaProperty,infomemo);
               IOstatni[iOST].DRUH_POZ:=VyslHodnProperty;
             end;

            if VYMERAdoVymeraOST in NacteniZLedu then
             begin
              IOstatni[iOST].Vymera:=GisSkupina.Vymera;
             end;
            if KVAL_PdoOST_KVAL_Vypocet in NacteniZLedu then
             begin
              IOstatni[iOST].OST_KVAL_Vypocet:=GisSkupina.KVAL_P;
             end;

            if PoznamkaDoOST_VYUZ in NacteniZLedu then
             begin
              // IOstatni[iOST].OST_VYUZ:=GisSkupina.GetPropertyStringByName('Poznamka');
              IOstatni[iOST].OST_VYUZ:=GisSkupina.GetPropertyStringByName(FSPPolNactLED.Ed1PoznamkaDoBZL_VYUZ.text);
              // infomemo.Lines.Add(IOstatni[iOST].CeleOznaceniKratce+'  Poznamka "'+GisSkupina.GetPropertyStringByName('Poznamka'));
              infomemo.Lines.Add(IOstatni[iOST].CeleOznaceniKratce+'  '+FSPPolNactLED.Ed1PoznamkaDoBZL_VYUZ.text+'  '
              +GisSkupina.GetPropertyStringByName(FSPPolNactLED.Ed1PoznamkaDoBZL_VYUZ.text));
             end;


            if KU_KODdoKU_KODOST in NacteniZLedu then
             begin
              IOstatni[iOST].KU_KOD:=GisSkupina.KU_KOD;
             end;
            if KU_KODdoORPzKU6OST in NacteniZLedu then
             begin
              IOstatni[iOST].NactiORPzKU6:=GisSkupina.KU_KOD;
             end;
            if SK_PARCdoSKUPPARCOST in NacteniZLedu then
             begin
              IOstatni[iOST].SKUPPARC:=inttostr(GisSkupina.SK_PARC);
             end;
            if KATPAR_KODdoPOT_VLASTOST in NacteniZLedu then
             begin
              IOstatni[iOST].POT_VLAST:=GisSkupina.KATPAR_KOD;
             end;
            if  LTdoLTBzlJPOst in NacteniZLedu then
             begin
              prevazujiciHodnotaZLTOwelay(GisSkupina,'LT',VyslHodnProperty,VahaProperty,infomemo);
              IOstatni[iOST].LT:=VyslHodnProperty;
             end;
            if  SLTdoSLTBzlJPOst in NacteniZLedu then
             begin
              prevazujiciHodnotaZLTOwelay(GisSkupina,'SLT',VyslHodnProperty,VahaProperty,infomemo);
              IOstatni[iOST].SLT:=VyslHodnProperty;
             end;
            if LVSdoLVSBzlJPOst in NacteniZLedu  then
             begin
              IOstatni[iOST].LVS := GisSkupina.LVS;
             end;

            if LVdoCislo_Tel in NacteniZLedu  then
             begin
              IOstatni[iOST].CISLO_TEL_XML := inttostr(GisSkupina.LV);
             end;

            if not bylNactenPorost then
             begin
              if MAJ_KODdoMAJ_KOD in NacteniZLedu then
               begin
                 MAJ_KOD:=GisSkupina.VLASTNIK;  // pro vybrala  2012 A kRIVKU 2014
                //  MAJ_KOD:=GisSkupina.MAJ_KOD;    PRO OSTATNI
               end;
              if MAJ_DRUHdoMAJ_DRUH in NacteniZLedu then
               begin
                MAJ_DRUH:=GisSkupina.MAJ_DRUH;
               end;
              if PAS_OHRdoPAS_OHR in NacteniZLedu then
               begin
                if GisSkupina.HasPropertyByName('PAS_OHR') then
                 begin
                  infomemo.Lines.Add('*'+GisSkupina.getpropertyStringByName('PAS_OHR')+'*')
                 end;
                PAS_OHR:=GisSkupina.getpropertyStringByName('PAS_OHR');
               end;

              if LS_KODDoOrgUr in NacteniZLedu then
               begin
                OUi:=strtoint(copy(ubm(FSPPolNactLED.CmbOrgUr.text),1,1));
                case OUi of
                 1:ORG_UROVEN1:=inttostr(GisSkupina.LS_Kod);
                 2:ORG_UROVEN2:=inttostr(GisSkupina.LS_Kod);
                 3:ORG_UROVEN3:=inttostr(GisSkupina.LS_Kod);
                end;
               end;


              if ZVL_STATUTdoZvlStVcetnePrekryvu in NacteniZLedu then
               begin
                 ZvlStMn.NovaZvlStVcetnePrekryvusCarkama:= GisSkupina.ZVL_STATUT;
               end;
              if KATSdoKategorieVcetnePrekryvu in NacteniZLedu then
               begin
                 Kategorie1Mn.NovaKategorieVcetnePrekryvusCarkama:=GisSkupina.KAT;
               end;
              if LES_OBLDoLES_OBL in NacteniZLedu then
               begin
                prevazujiciHodnotaZLTOwelay(GisSkupina,'LES_OBL',VyslHodnProperty,VahaProperty,infomemo);
                LES_OBL := VyslHodnProperty;
               end;
              if LO_CASTDoLES_PODOBL in NacteniZLedu then
               begin
                 prevazujiciHodnotaZLTOwelay(GisSkupina,'LO_CAST',VyslHodnProperty,VahaProperty,infomemo);
                 LES_PODOBL := VyslHodnProperty;
               end;
             end;
           end;
         end;
       end;
     end;
   end;
   end;
  infoedit.text:='nacteno ODD '+inttostr(VODD.ODD); infoedit.refresh;

 end;


procedure nactiZTax20XXaUloz20XXProOrb(LesniCelek:TLesniCelek;var HlChyb:TOznaceniPorSkupinyHlaskaChybyMN;infomemo:TMemo;infoEdit:TEdit);
var VOdd:TOddeleni;
    LOvr98A,LOvr98B:TOvr98;
    ZdrojNazevA,ZdrojNazevB,ZdrojNazevZZZ:String;
    LHCPrezCele:TLHCPrezCele;
    iDil,iPor,iPsk,iEt:integer;
    vPoradku:Boolean;
    initext:Tinifile;
    hl_Cesta:string;
    bylStejny:boolean;
    // aktDir:string;
    Odp:string;
    chyba:String;
 begin
  HlChyb:=TOznaceniPorSkupinyHlaskaChybyMN.create;
  LesniCelek.VcetneBarev:= VcetneBarvy1;
  druhaDataBaze98:=true;
  nespoustetManager:=false;
  umoznitZalozeniNoveDatabaze:=false;
  Application.CreateForm(TOVR98,LOvr98A);
  LesniCelek.JakBylNacten:='Tax98-Paradox';
  LesniCelek.FFOvr98:=LOvr98A;
  NactiPolozkyLHC_DB98(LesniCelek.LHC,LesniCelek.LOvr98);
  PriradCiselnik_DB98(LesniCelek.ciselnik,LesniCelek.LOvr98);
  LesniCelek.CiselOrbis.nactiSeZOrbu(LesniCelek.PHSNazev,true);
  NactiCiselOrbis_DB98(LesniCelek.CiselOrbis,LesniCelek.LOvr98);
  LOvr98A:=LesniCelek.LOvr98;
  LOvr98A.Name:='Ovr98A';
  ZdrojNazevA:=LesniCelek.ZdrojNazev;
  with LOvr98A do
   begin
    ZmenNameDatabaze(LOvr98A,db_zr98,'Bp_txP');
    ZmenNameDatabaze(LOvr98A,db_cisel98,'Bp_CisP');
    ZmenNameDatabaze(LOvr98A,db_ph98,'Bp_PHSP');
   end;
  druhaDataBaze98:=false;
  umoznitZalozeniNoveDatabaze:=true;
  LesniCelek.FFOvr98:=nil;

  nespoustetManager:=false;
  Application.CreateForm(TOVR98,LOvr98B);
  LesniCelek.JakBylNacten:='Tax98-Paradox';
  LesniCelek.FFOvr98:=LOvr98B;
  {
  LesniCelek.LOvr98.smazVse(true);
  LesniCelek.LOvr98.otevriSoubory1;
  LesniCelek.LOvr98.tb_LHC.edit;
  }
  ZdrojNazevB:=LesniCelek.ZdrojNazev;
  bylStejny:=false;
  if ZdrojNazevA=ZdrojNazevB then
   begin

    ZdrojNazevB:=najdiVolnyNazevAdresare(ZdrojNazevB);
    ForceDirectories(ZdrojNazevB);
    kopirujDoZdrojeSoubory(ZdrojNazevB);
    bylStejny:=true;

    hl_Cesta:=KPoslednimuZnaku(Application.ExeName,'\')+'\vtx.ini';
    initext:=Tinifile.create(Hl_cesta);
    initext.writeString('DATABASE','DATA','PATH='+ZdrojNazevB);
    initext.writeString('DATABASE','MANAGER','NE');
    initext.free;
    LOvr98B.free;
    nespoustetManager:=true;
    Application.CreateForm(TOVR98,LOvr98B);
    LOvr98B.zavriSoubory1;
    LesniCelek.JakBylNacten:='Tax98-Paradox';
    LesniCelek.FFOvr98:=LOvr98B;
    initext:=Tinifile.create(Hl_cesta);
    initext.writeString('DATABASE','MANAGER','ANO');
    initext.free;

   end;
   if (DoplnBezlJinOSTKdyzNeni in pozadovaneNacteniZLedu.NacteniZLedu) or (SmazADoplnBezlJinOST in  pozadovaneNacteniZLedu.NacteniZLedu) then
    begin
     CtiSpMezBezlOstJine;
    end;

   LesniCelek.LOvr98.smazVse(true);
   LesniCelek.LOvr98.tb_LHC.edit;
   UlozPolozkyLHC_DB98(LesniCelek.LHC,LesniCelek.LOvr98);
   if  KATSdoTB_PorKTG in pozadovaneNacteniZLedu.NacteniZLedu then  nactiKategorieDoTabOchr(LesniCelek.LOvr98.TB_PorKtg,true,infomemo);
   if  ZVL_STATUTdoTB_PorZvl in pozadovaneNacteniZLedu.NacteniZLedu then  nactiZvlastniStatutyDoTabOchr(LesniCelek.LOvr98.Tb_porZvl,true,infomemo);
    LOvr98B:=LesniCelek.LOvr98;
    LOvr98B.Name:='Ovr98B';
    with LOvr98B do
     begin
      ZmenNameDatabaze(LOvr98B,db_zr98,'Bp_txV');
      ZmenNameDatabaze(LOvr98B,db_cisel98,'Bp_CisV');
      ZmenNameDatabaze(LOvr98B,db_ph98,'Bp_PHSV');
     end;
    LesniCelek.FFOvr98:=nil;
    LesniCelek.LOvr98:=LOvr98A;
    LesniCelek.LOvr98.tb_odd.first;
    while not LesniCelek.LOvr98.tb_odd.eof do
     begin
      NactiOddeleniDb98(VOdd,LesniCelek.LOvr98,LesniCelek.VcetneBarev);
      DoEditu('Z taxu 98 nateno oddlen '+inttostr(VOdd.ODD),LesniCelek.infoedit);
      LesniCelek.LHC.OddeleniMN.AddElement(VOdd);
      nactiPlochyZOrbuDoOddeleni(VOdd,HlChyb,infomemo,infoEdit);
      LesniCelek.FFOvr98:=nil;
      LesniCelek.LOvr98:=LOvr98B;
      DoEditu('Ukldm oddlen '+inttostr(VOdd.ODD),LesniCelek.infoedit);
      // OpravForestu if VOdd.ODD>0 then
      UlozOddeleni_DB98(VOdd,LesniCelek.LOvr98,LesniCelek.VcetneBarev);
      LesniCelek.FFOvr98:=nil;
      LesniCelek.LOvr98:=LOvr98A;
     end;
  LesniCelek.FFOvr98:=nil;
  LOvr98A.free;
  LOvr98B.free;
  if bylStejny then
   begin
    initext:=Tinifile.create(KPoslednimuZnaku(Application.ExeName,'\')+'\vtx.ini');
    initext.writeString('DATABASE','DATA','PATH='+ZdrojNazevA);
    initext.free;
     Application.CreateForm(TFDotNaZal,FDotNaZal);
     ZdrojNazevZZZ:=KPoslednimuZnaku(zdrojNazevB,'(')+'(1)';
     FDotNaZal.label2.caption:='"'+zdrojNazevA+'"';
     if zdrojNazevB=zdrojNazevZZZ then
      begin
       FDotNaZal.ButZal1.caption:='Pvodn zdroj ponechat v "'+zdrojNazevZZZ+'"';
       FDotNaZal.ButZalX.visible:=false;
      end
     else
      begin
       FDotNaZal.ButZal1.caption:='Pvodnm zdrojem pemazat "'+zdrojNazevZZZ+'"';
       FDotNaZal.ButZalX.visible:=true;
       FDotNaZal.ButZalX.caption:='Pvodn zdroj ponechat v "'+zdrojNazevB+'"';
      end;
     with FDotNaZal do
      begin
       showmodal;
       Odp:=odpoved;
      end;
     FDotNaZal.free;
     if Odp='BEZZAL' then
      begin
       SmazVsechnySouboryVAdresari(ZdrojNazevA);
       RmDir(zdrojNazevA);
       RenameFile(zdrojNazevB,zdrojNazevA);
       exit;
      end;
     if Odp='ZAL1' then
      begin
       if zdrojNazevB=zdrojNazevZZZ then
        begin
         RenameFile(zdrojNazevA,zdrojNazevA+'FF');
         RenameFile(zdrojNazevZZZ,zdrojNazevA);
         RenameFile(zdrojNazevA+'FF',zdrojNazevZZZ);
         exit;
        end
       else
        begin
         SmazVsechnySouboryVAdresari(ZdrojNazevZZZ);
         RmDir(zdrojNazevZZZ);
         RenameFile(zdrojNazevA,zdrojNazevZZZ);
         RenameFile(zdrojNazevB,zdrojNazevA);
         exit;
        end;
      end;
     if Odp='ZALX' then
      begin
       RenameFile(zdrojNazevA,zdrojNazevA+'FF');
       RenameFile(zdrojNazevB,zdrojNazevA);
       RenameFile(zdrojNazevA+'FF',zdrojNazevB);
       exit;
      end;
   end;
 end;

procedure nactiZTax20XXaUloz20XXProOrbOchrPrir(LesniCelek:TLesniCelek;var HlChyb:TOznaceniPorSkupinyHlaskaChybyMN;infomemo:TMemo;infoEdit:TEdit;CoNacistzOchrPrir:TCoNacistzOchrPrir);
var VOdd:TOddeleni;
    LOvr98A,LOvr98B:TOvr98;
    ZdrojNazevA,ZdrojNazevB,ZdrojNazevZZZ:String;
    LHCPrezCele:TLHCPrezCele;
    iDil,iPor,iPsk,iEt:integer;
    vPoradku:Boolean;
    initext:Tinifile;
    hl_Cesta:string;
    bylStejny:boolean;
    // aktDir:string;
    Odp:string;
    chyba:String;
 begin
  HlChyb:=TOznaceniPorSkupinyHlaskaChybyMN.create;
  LesniCelek.VcetneBarev:= VcetneBarvy1;
  druhaDataBaze98:=true;
  nespoustetManager:=false;
  umoznitZalozeniNoveDatabaze:=false;
  Application.CreateForm(TOVR98,LOvr98A);
  LesniCelek.JakBylNacten:='Tax98-Paradox';
  LesniCelek.FFOvr98:=LOvr98A;
  NactiPolozkyLHC_DB98(LesniCelek.LHC,LesniCelek.LOvr98);
  PriradCiselnik_DB98(LesniCelek.ciselnik,LesniCelek.LOvr98);
  LesniCelek.CiselOrbis.nactiSeZOrbu(LesniCelek.PHSNazev,true);
  NactiCiselOrbis_DB98(LesniCelek.CiselOrbis,LesniCelek.LOvr98);
  LOvr98A:=LesniCelek.LOvr98;
  LOvr98A.Name:='Ovr98A';
  ZdrojNazevA:=LesniCelek.ZdrojNazev;
  with LOvr98A do
   begin
    ZmenNameDatabaze(LOvr98A,db_zr98,'Bp_txP');
    ZmenNameDatabaze(LOvr98A,db_cisel98,'Bp_CisP');
    ZmenNameDatabaze(LOvr98A,db_ph98,'Bp_PHSP');
   end;
  druhaDataBaze98:=false;
  umoznitZalozeniNoveDatabaze:=true;
  LesniCelek.FFOvr98:=nil;

  nespoustetManager:=false;
  Application.CreateForm(TOVR98,LOvr98B);
  LesniCelek.JakBylNacten:='Tax98-Paradox';
  LesniCelek.FFOvr98:=LOvr98B;
  {
  LesniCelek.LOvr98.smazVse(true);
  LesniCelek.LOvr98.otevriSoubory1;
  LesniCelek.LOvr98.tb_LHC.edit;
  }
  ZdrojNazevB:=LesniCelek.ZdrojNazev;
  bylStejny:=false;
  if ZdrojNazevA=ZdrojNazevB then
   begin

    ZdrojNazevB:=najdiVolnyNazevAdresare(ZdrojNazevB);
    ForceDirectories(ZdrojNazevB);
    kopirujDoZdrojeSoubory(ZdrojNazevB);
    bylStejny:=true;

    hl_Cesta:=KPoslednimuZnaku(Application.ExeName,'\')+'\vtx.ini';
    initext:=Tinifile.create(Hl_cesta);
    initext.writeString('DATABASE','DATA','PATH='+ZdrojNazevB);
    initext.writeString('DATABASE','MANAGER','NE');
    initext.free;
    LOvr98B.free;
    nespoustetManager:=true;
    Application.CreateForm(TOVR98,LOvr98B);
    LOvr98B.zavriSoubory1;
    LesniCelek.JakBylNacten:='Tax98-Paradox';
    LesniCelek.FFOvr98:=LOvr98B;
    initext:=Tinifile.create(Hl_cesta);
    initext.writeString('DATABASE','MANAGER','ANO');
    initext.free;

   end;
   if (DoplnBezlJinOSTKdyzNeni in PozadovaneNacteniZLedu.NacteniZLedu) or (SmazADoplnBezlJinOST in PozadovaneNacteniZLedu.NacteniZLedu) then
    begin
     CtiSpMezBezlOstJine;
    end;

   LesniCelek.LOvr98.smazVse(true);
   LesniCelek.LOvr98.tb_LHC.edit;
   UlozPolozkyLHC_DB98(LesniCelek.LHC,LesniCelek.LOvr98);
    LOvr98B:=LesniCelek.LOvr98;
    LOvr98B.Name:='Ovr98B';
    with LOvr98B do
     begin
      ZmenNameDatabaze(LOvr98B,db_zr98,'Bp_txV');
      ZmenNameDatabaze(LOvr98B,db_cisel98,'Bp_CisV');
      ZmenNameDatabaze(LOvr98B,db_ph98,'Bp_PHSV');
     end;
    LesniCelek.FFOvr98:=nil;
    LesniCelek.LOvr98:=LOvr98A;
    LesniCelek.LOvr98.tb_odd.first;
    while not LesniCelek.LOvr98.tb_odd.eof do
     begin
      NactiOddeleniDb98(VOdd,LesniCelek.LOvr98,LesniCelek.VcetneBarev);
      DoEditu('Z taxu 98 nateno oddlen '+inttostr(VOdd.ODD),LesniCelek.infoedit);
      LesniCelek.LHC.OddeleniMN.AddElement(VOdd);
      // nactiPlochyZOrbuDoOddeleni(VOdd,HlChyb,infomemo,infoEdit);
      nactiOchrPrirZOrbuDoOddeleni(VOdd,HlChyb,infomemo,infoEdit,CoNacistzOchrPrir);
      LesniCelek.FFOvr98:=nil;
      LesniCelek.LOvr98:=LOvr98B;
      DoEditu('Ukldm oddlen '+inttostr(VOdd.ODD),LesniCelek.infoedit);
      // OpravForestu if VOdd.ODD>0 then
      UlozOddeleni_DB98(VOdd,LesniCelek.LOvr98,LesniCelek.VcetneBarev);
      LesniCelek.FFOvr98:=nil;
      LesniCelek.LOvr98:=LOvr98A;
     end;
  LesniCelek.FFOvr98:=nil;
  LOvr98A.free;
  LOvr98B.free;
  if bylStejny then
   begin
    initext:=Tinifile.create(KPoslednimuZnaku(Application.ExeName,'\')+'\vtx.ini');
    initext.writeString('DATABASE','DATA','PATH='+ZdrojNazevA);
    initext.free;
     Application.CreateForm(TFDotNaZal,FDotNaZal);
     ZdrojNazevZZZ:=KPoslednimuZnaku(zdrojNazevB,'(')+'(1)';
     FDotNaZal.label2.caption:='"'+zdrojNazevA+'"';
     if zdrojNazevB=zdrojNazevZZZ then
      begin
       FDotNaZal.ButZal1.caption:='Pvodn zdroj ponechat v "'+zdrojNazevZZZ+'"';
       FDotNaZal.ButZalX.visible:=false;
      end
     else
      begin
       FDotNaZal.ButZal1.caption:='Pvodnm zdrojem pemazat "'+zdrojNazevZZZ+'"';
       FDotNaZal.ButZalX.visible:=true;
       FDotNaZal.ButZalX.caption:='Pvodn zdroj ponechat v "'+zdrojNazevB+'"';
      end;
     with FDotNaZal do
      begin
       showmodal;
       Odp:=odpoved;
      end;
     FDotNaZal.free;
     if Odp='BEZZAL' then
      begin
       SmazVsechnySouboryVAdresari(ZdrojNazevA);
       RmDir(zdrojNazevA);
       RenameFile(zdrojNazevB,zdrojNazevA);
       exit;
      end;
     if Odp='ZAL1' then
      begin
       if zdrojNazevB=zdrojNazevZZZ then
        begin
         RenameFile(zdrojNazevA,zdrojNazevA+'FF');
         RenameFile(zdrojNazevZZZ,zdrojNazevA);
         RenameFile(zdrojNazevA+'FF',zdrojNazevZZZ);
         exit;
        end
       else
        begin
         SmazVsechnySouboryVAdresari(ZdrojNazevZZZ);
         RmDir(zdrojNazevZZZ);
         RenameFile(zdrojNazevA,zdrojNazevZZZ);
         RenameFile(zdrojNazevB,zdrojNazevA);
         exit;
        end;
      end;
     if Odp='ZALX' then
      begin
       RenameFile(zdrojNazevA,zdrojNazevA+'FF');
       RenameFile(zdrojNazevB,zdrojNazevA);
       RenameFile(zdrojNazevA+'FF',zdrojNazevB);
       exit;
      end;
   end;
 end;



Procedure DoOddeleniVTaxuDoplnBezlesiZOrbu(VOdd:Toddeleni;Vgis_Oddeleni:Tgis_Oddeleni;Var chyba:String;Infomemo:TMemo);
 var
  iDil,iPor,iPsk:integer;
  Vgis_Porost:Tgis_Porost;
  vDIL,vPOR,vPskBzlJpO:string;
 begin
  for iDil:=0 to TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).count-1 do
   begin
    vDIL:=Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).DIL;
    for iPor:=0 to TOwnerEntity(Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).FindElementName('Porosty')).count-1 do
     begin
      Vgis_Porost:=Tgis_Porost(TOwnerEntity(Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).FindElementName('Porosty')).elements[iPOR]);
      for iPSK:=0 to TOwnerEntity(Vgis_Porost.FindElementName('skupiny')).count-1 do
       begin
        vPOR:=Vgis_Porost.POR;
        vPskBzlJpO:=Tgis_PorostniSkupina(TOwnerEntity(Vgis_Porost.FindElementName('skupiny')).elements[iPSK]).PSK;
        VOdd.DoplnBezlJinOSTKdyzNeni(vDIL,vPOR,vPskBzlJpO);

        Infomemo.Lines.Add(Vgis_Oddeleni.name +Tgis_Dilec(TOwnerEntity(Vgis_Oddeleni.FindElementName('dilce')).Elements[Idil]).name +Vgis_Porost.name
                          +' '+Tgis_PorostniSkupina(TOwnerEntity(Vgis_Porost.FindElementName('skupiny')).elements[iPSK]).name

                          +' '+Tgis_PorostniSkupina(TOwnerEntity(Vgis_Porost.FindElementName('skupiny')).elements[iPSK]).GetPropertyStringByName('Name'));
       end;
     end;
   end;
 end;
end.
