unit Uvyber;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, sp_ovr98, StdCtrls, Grids, DBGrids,
  Mat1, U_Sehr,dotaz, DB, DBTables, Kfindtab,Sp_vyhso,typyDelf;

type
  TFVyber = class(TForm)
    Query1: TQuery;
    DataSource1: TDataSource;
    DBGrid1:   TDBGrid;
    ButOdd:    TButton;
    Query2:    TQuery;
    DBGrid2:   TDBGrid;
    DataSource2: TDataSource;
    ButDl:     TButton;
    ButPor:    TButton;
    ButSkup:   TButton;
    ButRadek:  TButton;
    ButObnov:  TButton;
    Button1:   TButton;
    ButCelTab: TButton;
    ButVse:    TButton;
    ButSmaz:   TButton;
    Label1:    TLabel;
    Label2:    TLabel;
    Label3:    TLabel;
    Label4:    TLabel;
    Button2:   TButton;
    Table1: TTable;
    Table2: TTable;
    LFileVersion: TLabel;
    LPopisVerze: TLabel;
    procedure ButOddClick(Sender: TObject);
    procedure ButDlClick(Sender: TObject);
    procedure ButPorClick(Sender: TObject);
    procedure ButSkupClick(Sender: TObject);
    procedure ButRadekClick(Sender: TObject);
    procedure DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
      Field: TField; State: TGridDrawState);
    procedure ButObnovClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButCelTabClick(Sender: TObject);
    procedure ButVseClick(Sender: TObject);
    procedure ButSmazClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    HL_SQL2:TKSekvenFind;
    bookQ1:TBookMark;
    procedure KoordinujDruhou;
  end;

var
  FVyber: TFVyber;

implementation
{$R *.DFM}

uses E_lesodd,Dtb_les, Worlds;

procedure TFVyber.ButOddClick(Sender: TObject);
begin
 query1.close;
 query1.databasename:='Bp_txV';
 query1.SQL.clear;
 query1.SQL.add('select odd from oddeleni');
 query1.open;
 query2.close;
 query2.databasename:='Bp_txP';
 query2.SQL.clear;
 query2.SQL.add('select odd from oddeleni');
 query2.open;
end;
{ SELECT * FROM CITIES C, STATES S, MAYORS M
	WHERE C.CITY = M.CITY AND C.STATE = M.STATE }

procedure TFVyber.ButDlClick(Sender: TObject);
begin
 DBGrid1.onDrawDataCell:=nil;
 query1.close;
 query1.databasename:='Bp_txV';
 query1.SQL.clear;
 query1.SQL.add('select O.odd,D.dil from oddeleni O,dilec D ');
 query1.SQL.add('where O.ID=D.vazba');
 query1.SQL.add('order by O.odd,D.dil ');

 query1.open;
 DBGrid1.onDrawDataCell:=DBGrid1DrawDataCell;
 query2.close;
 query2.databasename:='Bp_txP';
 query2.SQL.clear;
 query2.SQL.add('select O.odd,D.dil from oddeleni O,dilec D ');
 query2.SQL.add('where O.ID=D.vazba');
 query2.SQL.add('order by O.odd,D.dil ');
 query2.open;
end;

procedure TFVyber.ButPorClick(Sender: TObject);
begin
 query1.close;
 query1.databasename:='Bp_txV';
 query1.SQL.clear;
 query1.SQL.add('select O.odd,D.dil,P.por from oddeleni O,dilec D,porost P ');
 query1.SQL.add('where (O.ID=D.vazba)and(D.ID=P.vazba)');
 query1.SQL.add('order BY Odd,dil,por');
 query1.open;
 query2.close;
 query2.databasename:='Bp_txP';
 query2.SQL.clear;
 query2.SQL.add('select O.odd,D.dil,P.por from oddeleni O,dilec D,porost P ');
 query2.SQL.add('where (O.ID=D.vazba)and(D.ID=P.vazba)');
 query2.SQL.add('order BY Odd,dil,por');
 query2.open;
end;

procedure TFVyber.ButSkupClick(Sender: TObject);
begin
 ButSkup.hide;
 query1.close;
 query1.databasename:='Bp_txV';
 query1.SQL.clear;
 query1.SQL.add('select O.odd,D.dil,P.por,s.psk from oddeleni O,dilec D,porost P,ps S ');
 query1.SQL.add('where (O.ID=D.vazba)and(D.ID=P.vazba)and(P.ID=S.vazba)');
 query1.SQL.add('order by O.odd,D.dil,P.por,s.psk ');
 query1.open;
 query2.close;
 query2.databasename:='Bp_txP';
 query2.SQL.clear;
 query2.SQL.add('select O.odd,D.dil,P.por,s.psk from oddeleni O,dilec D,porost P,ps S ');
 query2.SQL.add('where (O.ID=D.vazba)and(D.ID=P.vazba)and(P.ID=S.vazba)');
 query2.SQL.add('order by O.odd,D.dil,P.por,s.psk ');
 query2.open;
 ButSkup.show;
end;

procedure TFVyber.ButRadekClick(Sender: TObject);
var vysledek:integer;
begin
 ZkopirujPodleRadkuTabulky(ovr98,ovr98P,Query1,true,vysledek);
end;
procedure TFVyber.DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
  Field: TField; State: TGridDrawState);
begin
  KoordinujDruhou;
end;
procedure TFVyber.KoordinujDruhou;
 begin
   {edit1.text:='hled ='+Query1.fieldByName('ODD').asstring+
               Query1.fieldByName('DIL').asstring; }
   if query1.findfield('ODD')<>NIL then
    begin
     hl_SQL2.FindStyle:=fromTop;
     hl_SQL2.datafield:='ODD';
     if hl_SQL2.findText(Query1.fieldByName('ODD').asstring,true) then
      begin
       if query1.findfield('DIL')<>NIL then
        begin
         hl_SQL2.FindStyle:=fromCurrent;
         hl_SQL2.datafield:='DIL';
         if hl_SQL2.findText(Query1.fieldByName('DIL').asstring,true)
            and(Query1.fieldByName('ODD').asstring=Query2.fieldByName('ODD').asstring) then
          begin
           if query1.findfield('POR')<>NIL then
            begin
             hl_SQL2.datafield:='POR';
             if hl_SQL2.findText(Query1.fieldByName('POR').asstring,true)
                    and(Query1.fieldByName('ODD').asstring=Query2.fieldByName('ODD').asstring)
                    and(Query1.fieldByName('DIL').asstring=Query2.fieldByName('DIL').asstring)
                    then
              begin
               if query1.findfield('PSK')<>NIL then
                begin
                 hl_SQL2.datafield:='PSK';
                 if hl_SQL2.findText(Query1.fieldByName('PSK').asstring,true)
                    and(Query1.fieldByName('ODD').asstring=Query2.fieldByName('ODD').asstring)
                    and(Query1.fieldByName('DIL').asstring=Query2.fieldByName('DIL').asstring)
                    and(Query1.fieldByName('POR').asstring=Query2.fieldByName('POR').asstring)
                    then
                  begin
                  end
                 else
                  begin
                   hl_SQL2.FindStyle:=fromTop;
                   hl_SQL2.datafield:='ODD';
                   hl_SQL2.findText(Query1.fieldByName('ODD').asstring,true);
                   hl_SQL2.FindStyle:=fromCurrent;
                   hl_SQL2.datafield:='DIL';
                   hl_SQL2.findText(Query1.fieldByName('DIL').asstring,true);
                   hl_SQL2.datafield:='POR';
                   hl_SQL2.findText(Query1.fieldByName('POR').asstring,true);
                  end;
                end; {findfield'POR'}
              end{hl_Por}
             else
              begin
               hl_SQL2.FindStyle:=fromTop;
               hl_SQL2.datafield:='ODD';
               hl_SQL2.findText(Query1.fieldByName('ODD').asstring,true);
               hl_SQL2.FindStyle:=fromCurrent;
               hl_SQL2.datafield:='DIL';
               hl_SQL2.findText(Query1.fieldByName('DIL').asstring,true);
              end;
            end; {findfield'POR'}
          end {hl_Dil}
         else
          begin
           hl_SQL2.FindStyle:=fromTop;
           hl_SQL2.datafield:='ODD';
           hl_SQL2.findText(Query1.fieldByName('ODD').asstring,true);
          end;
        end; {findfield'DIL'}
      end; { hl'ODD' }
    end; { findfield'ODD' }
 end;

procedure TFVyber.ButObnovClick(Sender: TObject);
begin
 Query2.close;
 query2.open;
 KoordinujDruhou;
end;

procedure TFVyber.Button1Click(Sender: TObject);
var NazSoub,NazSoub1:string;
begin
Application.CreateForm(TS_VyhlSoub1, S_VyhlSoub1);
S_VyhlSoub1.showmodal;
if S_VyhlSoub1.Vybrano then
 begin
 DBGrid1.onDrawDataCell:=nil;
 query1.close;
 query1.databasename:=S_VyhlSoub1.FileListBox1.directory;
 nazSoub:=Copy(S_VyhlSoub1.FileListBox1.fileName,
               length(S_VyhlSoub1.FileListBox1.directory)+2,
               length(S_VyhlSoub1.FileListBox1.fileName)-
               (length(S_VyhlSoub1.FileListBox1.directory)+1));
 nazSoub1:=copy(nazSoub,1,pos('.',nazsoub)-1);
 query1.SQL.clear;
 query1.SQL.add('select * from '+nazsoub1);
 query1.open;
 end;
 S_vyhlSoub1.free;
end;

procedure TFVyber.FormShow(Sender: TObject);
begin
 World := TWorld.Create;
 umoznitZalozeniNoveDatabaze:=false;
 druhaDataBaze98:=true;
 Application.CreateForm(TOVR98, OVR98);
 with ovr98 do
  begin
   ZmenNameDatabaze(Ovr98,db_zr98,'Bp_txV');
   ZmenNameDatabaze(Ovr98,db_cisel98,'Bp_CisV');
   ZmenNameDatabaze(Ovr98,db_ph98,'Bp_PHSV');
  end;
 druhaDataBaze98:=false;
 umoznitZalozeniNoveDatabaze:=true;

 Application.CreateForm(TOVR98, OVR98P);

with ovr98P do
 begin
  ZmenNameDatabaze(Ovr98P,db_zr98,'Bp_txP');
  ZmenNameDatabaze(Ovr98P,db_cisel98,'Bp_CisP');
  ZmenNameDatabaze(Ovr98P,db_ph98,'Bp_PHSP');
 end;

label3.caption:=label3.caption+' '+copy(Ovr98P.DB_ZR98.Params[0],6,length(Ovr98P.DB_ZR98.Params[0])-5);
label4.caption:=label4.caption+' '+copy(Ovr98.DB_ZR98.Params[0],6,length(Ovr98.DB_ZR98.Params[0])-5);

HL_SQL2:=TKSekvenFind.create(self);
HL_SQL2.DataSource := DataSource2;
HL_SQL2.FindStyle := Kfindtab.FromTop;
HL_SQL2.ToBack := False;
  //HL_SQL2.Left := 336;
  //HL_SQL2.Top := 120;
end;

procedure TFVyber.ButCelTabClick (Sender:TObject);
var vysledek:integer;
begin
 Query1.first;
 while not query1.eof do
  begin
   ZkopirujPodleRadkuTabulky(ovr98,ovr98P,Query1,true,vysledek);
   if vysledek=1 then exit;
   query1.next;
  end;
end;

procedure TFVyber.ButVseClick(Sender: TObject);
begin
  ZkopirujVse(ovr98,ovr98P);
end;

procedure TFVyber.ButSmazClick(Sender: TObject);
begin
  SmazPodleRadku(Query2);
end;

procedure TFVyber.Button2Click(Sender: TObject);
 begin
 {
  Table1.TableName:='C:\DATAMoje\Pospisil\10vPrekryvu\ZDROJ2\PS.db';
  table1.open;
  Table2.TableName:='C:\DATAMoje\Pospisil\10vPrekryvu\ZDROJ3\PS.db';
  table2.open;
  PorovnejTabulky(Table1,Table2);
  }
  
 end;

procedure TFVyber.FormCreate(Sender: TObject);
begin
  LFileVersion.Caption:='Verze:'+DejFileVersionStr;
  LPopisVerze.Caption:=nazevDleVerze;
  caption:='Tax - Manager 20'+VerRok;
end;

end.
