unit Uvybpt98;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls,printers,
  PtCanvas,dtb_les,E_lesOdd,lesCisel,
   Grids, DBGrids, DB, DBTables;

type
  TFVybPT = class(TForm)
    ButZobrOdd: TButton;
    BuTiskOdd: TButton;
    Query1: TQuery;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    ButTiskVse: TButton;
    ButSouc: TButton;
    ButKatas: TButton;
    ButPotVlast: TButton;
    ButTiskSouc: TButton;
    ButTiskKatas: TButton;
    ButTiskPotVlast: TButton;
    ChTiskPor: TCheckBox;
    ButFR: TButton;
    ButRec: TButton;
    ButZobr: TButton;
    ButNacti: TButton;
    procedure ButZobrOddClick(Sender: TObject);
    procedure BuTiskOddClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButTiskVseClick(Sender: TObject);
    procedure ButSoucClick(Sender: TObject);
    procedure ButKatasClick(Sender: TObject);
    procedure ButPotVlastClick(Sender: TObject);
    procedure ButTiskSoucClick(Sender: TObject);
    procedure ButTiskKatasClick(Sender: TObject);
    procedure ButTiskPotVlastClick(Sender: TObject);
    procedure ButFRClick(Sender: TObject);
    procedure ButRecClick(Sender: TObject);
    procedure ButNactiClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FVybPT: TFVybPT;
  VODD:TOddeleni;
procedure ZobrazPTOddeleniDoImage(VODD:TOddeleni;var Strana:integer;
                   strana_pozadovana_k_tiskuI:integer;tiskPorost:boolean);
procedure OddeleniNaTiskarnu(VODD:TOddeleni;var strana:integer;
                   strana_pozadovana_k_tiskuI:integer;tiskPorost:boolean);
implementation
uses
  Sp_ovr;

{$R *.DFM}

procedure TFVybPT.ButZobrOddClick(Sender: TObject);
var Strana0:integer;
begin
 with Ovr.Tb_ODD do
  begin
   EditKey;
   FieldByName('VAZBA').AsInteger :=ovr.TB_LHC.FieldByName('ID').AsInteger;
   FieldByName('ODD').AsInteger := Query1.fieldByName('ODD').asinteger;
   GotoNearest;
  end;
 if Ovr.Tb_ODD.FieldByName('ODD').AsInteger
      <> Query1.fieldByName('ODD').asinteger
//if not ovr.hl_odd1.findText(Query1.fieldByName('ODD').asstring,true)
      then
        begin
          showmessage('Oddln '+
             query1.fieldByName('ODD').asstring+
             ' nen v databzi.');
          exit;
        end;
 NactiOddeleni_DB(VOdd,ovr,nil);
 strana0:=0;
 ZobrazPTOddeleniDoImage(VOdd,strana0,0,CHTiskPor.checked);
{ showmessage('Dobry');   }
 VOdd.free;
{ showmessage('Spatny'); }
end;
procedure OddeleniNaTiskarnu(VODD:TOddeleni;var strana:integer;
               strana_pozadovana_k_tiskuI:integer;tiskPorost:boolean);
var PXI,PYI:integer;
begin
 with FPTCanvas do
  begin
   with printer do
    begin
{    Orientation := poLandscape; }
     pxi:=round(printer.PageWidth);
     pyi:=printer.PageHeight;
{    beginDoc;  }
     tiskPloTabOddeleni(VOdd,Strana,strana_pozadovana_k_tiskuI,canvas,pXi,pYi,true,false,nil,tiskPorost);
{    enddoc;     }
    end;
  end;
end;

procedure ZobrazPTOddeleniDoImage(VODD:TOddeleni;var Strana:integer;
                  strana_pozadovana_k_tiskuI:integer;tiskPorost:boolean);
var mxi,myi:integer;
begin
with FPTCanvas do
 begin
 mxi:=round(screen.width*1.5);
 myi:=round(screen.height*1.5);
 Image1.picture.bitmap.Width:=image1.width;
 Image1.picture.bitmap.height:=image1.height;
 Image1.picture.bitmap.canvas.fillrect(
         rect(0,0,image1.width,image1.height));
 tiskPloTabOddeleni(VOdd,Strana,strana_pozadovana_k_tiskuI,
            Image1.picture.bitmap.canvas,MXi,MYi,false,false,nil,tiskPorost);
 image1.refresh;
 showmodal;
 end;
end;

procedure ZobrazSoucetDoImage(VODD:TOddeleni;var Strana:integer;strana_pozadovana_k_tiskuI:integer);
var mxi,myi:integer;
begin
with FPTCanvas do
 begin
 mxi:=round(screen.width*1.5);
 myi:=round(screen.height*1.5);
 Image1.picture.bitmap.Width:=image1.width;
 Image1.picture.bitmap.height:=image1.height;
 Image1.picture.bitmap.canvas.fillrect(
         rect(0,0,image1.width,image1.height));
 tiskPloTabOddeleni(VOdd,Strana,strana_pozadovana_k_tiskuI,
            Image1.picture.bitmap.canvas,MXi,MYi,False,true,nil,False);
 image1.refresh;
 showmodal;
 end;
end;
procedure SoucetNaTiskarnu(VODD:TOddeleni;var Strana:integer;strana_pozadovana_k_tiskuI:integer);
var PXI,PYI:integer;
begin
 with FPTCanvas do
  begin
   with printer do
    begin
{    Orientation := poLandscape; }
     pxi:=round(printer.PageWidth);
     pyi:=printer.PageHeight;
{    beginDoc;  }
     tiskPloTabOddeleni(VOdd,Strana,strana_pozadovana_k_tiskuI,
                          canvas,pXi,pYi,true,True,nil,false);
{    enddoc;     }
    end;
  end;
end;

procedure ZobrazKatastryDoImage;
var mxi,myi:integer;
begin
with FPTCanvas do
 begin
 mxi:=round(screen.width*1.5);
 myi:=round(screen.height*1.5);
 Image1.picture.bitmap.Width:=image1.width;
 Image1.picture.bitmap.height:=image1.height;
 Image1.picture.bitmap.canvas.fillrect(
         rect(0,0,image1.width,image1.height));
 TiskKatastru(nil,Image1.picture.bitmap.canvas,MXi,MYi,False);
 image1.refresh;
 showmodal;
 end;
end;
procedure KatastryNaTiskarnu;
var PXI,PYI:integer;
begin
 with FPTCanvas do
  begin
   with printer do
    begin
     pxi:=round(printer.PageWidth);
     pyi:=printer.PageHeight;
     TiskKatastru(nil,canvas,pXi,pYi,True);
    end;
  end;
end;
procedure ZobrazPot_VlastDoImage;
var mxi,myi:integer;
begin
with FPTCanvas do
 begin
 mxi:=round(screen.width*1.5);
 myi:=round(screen.height*1.5);
 Image1.picture.bitmap.Width:=image1.width;
 Image1.picture.bitmap.height:=image1.height;
 Image1.picture.bitmap.canvas.fillrect(
         rect(0,0,image1.width,image1.height));
 TiskPot_Vlast(nil,Image1.picture.bitmap.canvas,MXi,MYi,False);
 image1.refresh;
 showmodal;
 end;
end;
procedure Pot_VlastNaTiskarnu;
var PXI,PYI:integer;
begin
 with FPTCanvas do
  begin
   with printer do
    begin
     pxi:=round(printer.PageWidth);
     pyi:=printer.PageHeight;
     TiskPot_Vlast(nil,canvas,pXi,pYi,True);
    end;
  end;
end;

procedure TFVybPT.BuTiskOddClick(Sender: TObject);
var Strana0:integer;
begin
 with printer do
  begin
   if not printing then
    begin
     Orientation := poLandscape;
     beginDoc;
    end;
  end;
 ciselnik:=TCiselnik.create;
 PriradCiselnik_DB(ciselnik,ovr);
 with Ovr.Tb_ODD do
  begin
   EditKey;
   FieldByName('VAZBA').AsInteger :=ovr.TB_LHC.FieldByName('ID').AsInteger;
   FieldByName('ODD').AsInteger := Query1.fieldByName('ODD').asinteger;
   GotoNearest;
  end;
 if Ovr.Tb_ODD.FieldByName('ODD').AsInteger
      <> Query1.fieldByName('ODD').asinteger
 // if not ovr.hl_odd1.findText(Query1.fieldByName('ODD').asstring,true)
      then
        begin
          showmessage('Oddln '+
             query1.fieldByName('ODD').asstring+
             ' nen v databzi.');
          exit;
        end;
 NactiOddeleni_DB(VOdd,ovr,nil);
 strana0:=0;
 OddeleniNaTiskarnu(VOdd,strana0,0,chTiskPor.checked);
 VOdd.free;
end;
procedure TFVybPT.FormShow(Sender: TObject);
begin
 query1.close;
 query1.databasename:='DB_tx';
 query1.SQL.clear;
 query1.SQL.add('select odd from oddeleni');
 query1.open;
end;

procedure TFVybPT.ButTiskVseClick(Sender: TObject);
var strana0:integer;
begin
 with printer do
  begin
   if not printing then
    begin
     Orientation := poLandscape;
     beginDoc;
    end;
  end;
 ciselnik:=TCiselnik.create;
 PriradCiselnik_DB(ciselnik,ovr);
 {   if not ovr.hl_odd1.findText(
             Query1.fieldByName('ODD').asstring,true)
      then
        begin
          showmessage('Oddln '+
             query1.fieldByName('ODD').asstring+
             ' nen v databzi.');
          exit;
        end;  }
 ovr.tb_Odd.first;
 while not ovr.tb_Odd.eof do
  begin
   NactiOddeleni_DB(VOdd,ovr,nil);
   strana0:=0;
   OddeleniNaTiskarnu(VOdd,strana0,0,ChTiskPor.checked);
   VOdd.free;
   ovr.tb_Odd.next;
  end;
end;
procedure TFVybPT.ButSoucClick(Sender: TObject);
var Strana0:integer;
begin
 ciselnik:=TCiselnik.create;
 PriradCiselnik_DB(ciselnik,ovr);
 strana0:=0;
 ZobrazSoucetDoImage(VOdd,strana0,0);
end;

procedure TFVybPT.ButKatasClick(Sender: TObject);
begin
 ZobrazKatastryDoImage;
end;

procedure TFVybPT.ButPotVlastClick(Sender: TObject);
begin
 ZobrazPot_VlastDoImage;
end;

procedure TFVybPT.ButTiskSoucClick(Sender: TObject);
var Strana0:integer;
begin
 with printer do
  begin
   if not printing then
    begin
     Orientation := poLandscape;
     beginDoc;
    end;
  end;
 ciselnik:=TCiselnik.create;
 PriradCiselnik_DB(ciselnik,ovr);
 strana0:=0;
 SoucetNaTiskarnu(VOdd,strana0,0);
end;

procedure TFVybPT.ButTiskKatasClick(Sender: TObject);
begin
 with printer do
  begin
   if not printing then
    begin
     Orientation := poLandscape;
     beginDoc;
    end;
  end;
 KatastryNaTiskarnu;
end;

procedure TFVybPT.ButTiskPotVlastClick(Sender: TObject);
begin
 with printer do
  begin
   if not printing then
    begin
     Orientation := poLandscape;
     beginDoc;
    end;
  end;
 Pot_VlastNaTiskarnu;
end;

procedure TFVybPT.ButFRClick(Sender: TObject);
begin
 VOdd.free;
end;

procedure TFVybPT.ButRecClick(Sender: TObject);
begin
 VOdd.SmazEntityTridyRekursivne(TFPole);
end;

procedure TFVybPT.ButNactiClick(Sender: TObject);
begin
  ciselnik:=TCiselnik.create;
  PriradCiselnik_DB(ciselnik,ovr);
  NactiOddeleni_DB(VOdd,ovr,nil);
end;

end.
