unit Uvybsv97;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, sp_ovr, StdCtrls, Grids, DBGrids, printers,
  dotaz, DB, DBTables, Kfindtab,Sp_vyhso,typyDelf;

type
  TFVybSV97 = class(TForm)
    Query1: TQuery;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    ButOdd: TButton;
    ButDl: TButton;
    ButPor: TButton;
    ButRadTisk: TButton;
    Button1: TButton;
    ButCelTab: TButton;
    ButVse: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    ComboBox1: TComboBox;
    Label3: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    ChPorost: TCheckBox;
    Label5: TLabel;
    ChNasobnost: TCheckBox;
    Label6: TLabel;
    Label7: TLabel;
    ChiDiliPor: TCheckBox;
    Label8: TLabel;
    ChMajitel: TCheckBox;
    ChDruh_Maj: TCheckBox;
    Ch_olh: TCheckBox;
    Label9: TLabel;
    Label10: TLabel;
    RBLheDleLCR: TRadioButton;
    RBLheDleObce: TRadioButton;
    RBlheNic: TRadioButton;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    ChPlDrZal: TCheckBox;
    Button3: TButton;
    Edit3: TEdit;
    Label15: TLabel;
    Ch_Zhustene: TCheckBox;
    ChRelBon: TCheckBox;
    Label16: TLabel;
    Label17: TLabel;
    CHZaruba: TCheckBox;
    procedure ButOddClick(Sender: TObject);
    procedure ButDlClick(Sender: TObject);
    procedure ButPorClick(Sender: TObject);
    procedure ButRadTiskClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ButCelTabClick(Sender: TObject);
    procedure ButVseClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    bookQ1:TBookMark;
  end;
procedure ZobrazPodleRadkuTabulky(tb_vyb:TDataset;var vysledek:integer);
procedure ZobrazPorostDoImage(
    var strana:integer;strana_pozadovana_k_tiskuI:integer;
        tiskniEvidenciLCR,tiskniEvidenciObce:boolean);
procedure TiskniDilec(var strana:integer);
procedure TiskniOddeleni(var strana:integer);
procedure TiskniVse;
procedure porostNaTiskarnu(var strana:integer;
                     strana_pozadovana_k_tiskuI:integer;
                     tiskniEvidenciLCR,tiskniEvidenciObce:boolean);
var
   FVybSV97   :TFVybSV97;
   stranaI,strana_pozadovana_k_tisku_Z   :integer;
   levaPrava :Byte;

implementation

{$R *.DFM}
uses SVCanv97,hkCanv97;
procedure TiskniDilec(var strana:integer);
var Bm,bmd : TBookmark;
 begin
  with ovr do
   begin
    tb_porost.first;
    while not tb_porost.eof do
     begin
      Bm:=tb_porost.GetBookmark;
      Bmd:=tb_dl.GetBookmark;
      porostNaTiskarnu(strana,0,FVybSv97.RBLheDleLCR.checked,FVybSv97.RBLheDleObce.checked);
      tb_dl.GotoBookmark(Bmd);
      tb_porost.GotoBookmark(Bm);
      tb_dl.FreeBookmark(Bmd);
      tb_porost.FreeBookmark(Bm);
      tb_porost.next;
     end;
   end;
 end;

procedure TiskniOddeleni(var strana:integer);
var Bm : TBookmark;
 begin
  with ovr do
   begin
    tb_dl.first;
    while not tb_dl.eof do
     begin
      Bm:=tb_dl.GetBookmark;
      tiskniDilec(strana);
      tb_dl.GotoBookmark(Bm);
      tb_dl.FreeBookmark(Bm);
      tb_dl.next;
     end;
   end;
 end;

 procedure TiskniVse;
 var strana:integer;
 begin
 strana:=stranaI;
  with ovr do
   begin
    tb_odd.first;
    while not tb_odd.eof do
     begin
      tiskniOddeleni(strana);
      tb_odd.next;
     end;
   end;
 end;

procedure TiskniPodleRadkuTabulky(tb_vyb:TDataset;var vysledek:integer);
var strana:integer;
    dilS,PorS:string;
begin
 strana:=stranaI;
 vysledek:=0;

 if tb_vyb.findfield('ODD')=nil then
  begin
   vysledek:=1;
   showmessage('Z tabulky nelze tisknout, chyb sloupec ODD ');
   exit;
  end;
 if tb_vyb.findfield('DIL')=nil then
  begin
   dilS:=chr(ord('A')-1);
  end
 else
  begin
   DilS:=tb_vyb.findfield('DIL').asstring;
  end;
 if tb_vyb.findfield('POR')=nil then
  begin
   porS:=chr(ord('a')-1);
  end
 else
  begin
   porS:=tb_vyb.findfield('POR').asstring;
  end;
 ovr.nastavPorost(tb_vyb.findfield('ODD').asinteger,DilS,PorS);

 if (ovr.Tb_odd.fieldByName('ODD').asinteger<>tb_vyb.findfield('ODD').asinteger) then
  begin
   showmessage('Oddlen '+
     tb_vyb.fieldByName('ODD').asstring+
           ' nen v databzi.');
     vysledek:=2;
   exit;
  end;
 if (dilS=chr(ord('A')-1)) then
  begin
   TiskniOddeleni(strana);
  end
 else
  begin
   if DilS<>ovr.Tb_dl.fieldByName('DIL').asstring then
    begin
     showmessage('Dlec '+
         tb_vyb.fieldByName('ODD').asstring+
         tb_vyb.fieldByName('DIL').asstring+
             ' nen v databzi.');
     vysledek:=3;
     exit;
    end
   else
    begin
     if porS=chr(ord('a')-1) then
      begin
       TiskniDilec(strana);
      end
     else
      begin
       if PorS<>ovr.Tb_porost.fieldByName('POR').asstring then
        begin
         showmessage('Porost  '+
                     tb_vyb.fieldByName('ODD').asstring+
                     tb_vyb.fieldByName('DIL').asstring+
                     tb_vyb.fieldByName('POR').asstring+
                    ' nen v databzi.');
         vysledek:=4;
         exit;
        end
       else
        begin
         porostNaTiskarnu(strana,strana_pozadovana_k_tisku_Z,FVybSv97.RBLheDleLCR.checked,FVybSv97.RBLheDleObce.checked);
        end;
      end;
    end;
  end;

{
 if tb_vyb.findfield('ODD')<>nil then
   begin
    if not ovr.hl_odd1.findText(
             tb_vyb.fieldByName('ODD').asstring,true)
      then
        begin
          showmessage('Oddln '+
             tb_vyb.fieldByName('ODD').asstring+
             ' nen v databzi.');
          vysledek:=2;
          exit;
        end;
     if tb_vyb.findfield('DIL')<>nil then
      begin
       if not ovr.hl_dl1.findText(
              tb_vyb.fieldByName('DIL').asstring
                  ,true)
        then
         begin
          showmessage('Dlec '+
             tb_vyb.fieldByName('ODD').asstring+
             tb_vyb.fieldByName('DIL').asstring+
             ' nen v databzi.');
          vysledek:=3;
          exit;
         end;
       if tb_vyb.findfield('POR')<>nil then
        begin
         if not ovr.hl_porost.findText(
                  tb_vyb.fieldByName('POR').asstring,true)
            then
             begin
                showmessage('Porost  '+
                             tb_vyb.fieldByName('ODD').asstring+
                             tb_vyb.fieldByName('DIL').asstring+
                             tb_vyb.fieldByName('POR').asstring+
                             ' nen v databzi.');
              vysledek:=4;
              exit;
             end
          else
           begin
            porostNaTiskarnu(strana,strana_pozadovana_k_tisku_Z,FVybSv97.RBLheDleLCR.checked,FVybSv97.RBLheDleObce.checked);
           end;
        end
       else
        begin
         TiskniDilec(strana);
        end;
      end
     else
      begin
       TiskniOddeleni(strana);
      end;
   end
 else
   begin
    vysledek:=1;
    showmessage('Z tabulky nelze tisknout, chyb sloupec ODD ');
   end;
 }
 stranaI:=strana;
 FVybSv97.edit1.text:=Inttostr(StranaI);
 FVybSv97.edit1.refresh;
end;

procedure ZobrazPodleRadkuTabulky(tb_vyb:TDataset;var vysledek:integer);
var strana:integer;
begin
 strana:=stranaI;
 vysledek:=0;

 if tb_vyb.findfield('ODD')=nil then
  begin
   vysledek:=1;
   showmessage('V tabulce "Vbr" chyb polko "ODD"');
   exit;
  end;
 if tb_vyb.findfield('DIL')=nil then
  begin
   vysledek:=1;
   showmessage('V tabulce "Vbr" chyb polko "DIL"');
   exit;
  end;
 if tb_vyb.findfield('POR')=nil then
  begin
   vysledek:=1;
   showmessage('V tabulce "Vbr" chyb polko "POR"');
   exit;
  end;
 ovr.nastavPorost(tb_vyb.findfield('ODD').asinteger,
                  tb_vyb.findfield('DIL').asstring,
                  tb_vyb.findfield('POR').asstring);

 if (ovr.Tb_odd.fieldByName('ODD').asinteger<>tb_vyb.findfield('ODD').asinteger) then
  begin
   showmessage('Oddln '+
             tb_vyb.fieldByName('ODD').asstring+
             ' nen v databzi.');
   vysledek:=2;
   exit;
  end;
 if (ovr.Tb_dl.fieldByName('DIL').asstring<>tb_vyb.findfield('DIL').asstring) then
  begin
   showmessage('Dlec '+
           tb_vyb.fieldByName('ODD').asstring+
           tb_vyb.fieldByName('DIL').asstring+
           ' nen v databzi.');
   vysledek:=3;
   exit;
  end;
 if (ovr.Tb_Porost.fieldByName('POR').asstring<>tb_vyb.findfield('POR').asstring) then
  begin
   showmessage('Porost  '+
                           tb_vyb.fieldByName('ODD').asstring+
                           tb_vyb.fieldByName('DIL').asstring+
                           tb_vyb.fieldByName('POR').asstring+
                           ' nen v databzi.');
   vysledek:=4;
   exit;
  end;


{
 if tb_vyb.findfield('ODD')=nil then
  begin
   vysledek:=1;
   showmessage('V tabulce "Vbr" chyb polko "ODD"');
   exit;
  end
 else
  begin
   if not ovr.hl_odd1.findText(
             tb_vyb.fieldByName('ODD').asstring,true) then
    begin
     showmessage('Oddln '+
             tb_vyb.fieldByName('ODD').asstring+
             ' nen v databzi.');
     vysledek:=2;
     exit;
    end;
  end;
 if tb_vyb.findfield('DIL')=nil then
  begin
   vysledek:=1;
   showmessage('V tabulce "Vbr" chyb polko "DIL"');
   exit;
  end
 else
  begin
   if not ovr.hl_dl1.findText(
              tb_vyb.fieldByName('DIL').asstring,true) then
    begin
     showmessage('Dlec '+
             tb_vyb.fieldByName('ODD').asstring+
             tb_vyb.fieldByName('DIL').asstring+
             ' nen v databzi.');
     vysledek:=3;
     exit;
    end;
  end;
 if tb_vyb.findfield('POR')=nil then
  begin
   vysledek:=1;
   showmessage('V tabulce "Vbr" chyb polko "POR"');
   exit;
  end
 else
  begin
   if not ovr.hl_porost.findText(
              tb_vyb.fieldByName('POR').asstring,true) then
    begin
     showmessage('Porost  '+
                             tb_vyb.fieldByName('ODD').asstring+
                             tb_vyb.fieldByName('DIL').asstring+
                             tb_vyb.fieldByName('POR').asstring+
                             ' nen v databzi.');
     vysledek:=4;
     exit;
    end;
  end; }
  ZobrazPorostDoImage(strana,strana_pozadovana_k_tisku_Z,
                FVybSv97.RBLheDleLCR.checked,FVybSv97.RBLheDleObce.checked);
end;
procedure porostNaTiskarnu(var strana:integer;
                     strana_pozadovana_k_tiskuI:integer;
                     tiskniEvidenciLCR,tiskniEvidenciObce:boolean);
var PXI,PYI:integer;
begin
with FCanv97 do
begin
with printer do
 begin
 pyi:=round(printer.PageWidth*1.15);
 pxi:=printer.PageHeight;
 tiskPorostSVOL97(Strana,strana_pozadovana_k_tiskuI,
                  FVybSv97.CHMajitel.checked,
                  FVybSv97.CHNasobnost.checked,
                  FVybSv97.CHPorost.checked,
                  FVybSv97.CHIDilIPor.checked,
                  true,tiskniEvidenciLCR,tiskniEvidenciObce,
                  levaprava,Canvas,PXi,PYi,
                  FVybSv97.CHDruh_maj.checked,
                  FVybSv97.CH_OLH.checked,
                  FVybSv97.CHPlDrZal.checked,
                  FVybSv97.CH_Zhustene.checked,
                  FVybSv97.CHRelBon.checked,
                  FVybSv97.CHZaruba.checked
                  );
 end;
end;
end;
procedure ZobrazPorostDoImage(var Strana:integer;strana_pozadovana_k_tiskuI:integer;
                                  tiskniEvidenciLCR,tiskniEvidenciObce:boolean);
var mxi,myi:integer;
begin
with FCanv97 do
 begin
 mxi:=round(screen.width*1.5);
 myi:=round(screen.height*1.5);
{ Image1.picture.bitmap.Width:=image1.width;
 Image1.picture.bitmap.height:=image1.height;
 Image1.picture.bitmap.canvas.fillrect(
         rect(0,0,image1.width,image1.height)); }
 tiskPorostSVOL97(Strana,strana_pozadovana_k_tiskuI,
            FVybSv97.CHMajitel.checked,
            FVybSv97.CHNasobnost.checked,
            FVybSv97.CHPorost.checked,
            FVybSv97.CHIDilIPor.checked,
            false,tiskniEvidenciLCR,tiskniEvidenciObce,
            levaprava,canvas,MXi,MYi,
            FVybSv97.CHDruh_maj.checked,
            FVybSv97.CH_OLH.checked,
            FVybSv97.CHPlDrZAl.checked,
            FVybSv97.CH_Zhustene.checked,
            FVybSv97.CHRelBon.checked,
            FVybSv97.CHZaruba.checked
            );
 refresh;
 showmodal;
 end;
end;


procedure TFVybSV97.ButOddClick(Sender: TObject);
begin
 query1.close;
 query1.databasename:='DB_tx';
 query1.SQL.clear;
 query1.SQL.add('select odd from oddeleni');
 query1.open;
end;
{ SELECT * FROM CITIES C, STATES S, MAYORS M
	WHERE C.CITY = M.CITY AND C.STATE = M.STATE }

procedure TFVybSV97.ButDlClick(Sender: TObject);
begin
 query1.close;
 query1.databasename:='DB_tx';
 query1.SQL.clear;
 query1.SQL.add('select O.odd,D.dil from oddeleni O,dilec D ');
 query1.SQL.add('where O.ID=D.vazba');
 query1.open;
end;

procedure TFVybSV97.ButPorClick(Sender: TObject);
begin
 query1.close;
 query1.databasename:='DB_tx';
 query1.SQL.clear;
 query1.SQL.add('select O.odd,D.dil,P.por from oddeleni O,dilec D,porost P ');
 query1.SQL.add('where (O.ID=D.vazba)and(D.ID=P.vazba)');
 query1.open;
end;


procedure TFVybSV97.ButRadTiskClick(Sender: TObject);
var vysledek:integer;
begin
 with printer do
  begin
   if not printing then
    begin
     Orientation := poPortrait;
     beginDoc;
    end;
  end;
 TiskniPodleRadkuTabulky(Query1,vysledek);
 { ZkopirujPodleRadkuTabulky(ovr,ovrP,Query1,true,vysledek); }
end;
procedure TFVybSV97.Button1Click(Sender: TObject);
var NazSoub,NazSoub1:string;
begin
S_VyhlSoub1.showmodal;
if S_VyhlSoub1.Vybrano then
 begin
 DBGrid1.onDrawDataCell:=nil;
 query1.close;
 query1.databasename:=S_VyhlSoub1.FileListBox1.directory;
 nazSoub:=Copy(S_VyhlSoub1.FileListBox1.fileName,
               length(S_VyhlSoub1.FileListBox1.directory)+2,
               length(S_VyhlSoub1.FileListBox1.fileName)-
               (length(S_VyhlSoub1.FileListBox1.directory)+1));
 nazSoub1:=copy(nazSoub,1,pos('.',nazsoub)-1);
 query1.SQL.clear;
 query1.SQL.add('select * from '+nazsoub1);
 query1.open;
 end;
end;

procedure TFVybSV97.ButCelTabClick(Sender: TObject);
var vysledek:integer;
begin
 with printer do
  begin
   if not printing then
    begin
     Orientation := poPortrait;
     beginDoc;
    end;
  end;
 Query1.first;
 while not query1.eof do
  begin
  { ZkopirujPodleRadkuTabulky(ovr,ovrP,Query1,true,vysledek);}
   TiskniPodleRadkuTabulky(Query1,vysledek);
   if vysledek=1 then exit;
   query1.next;
  end;
end;

procedure TFVybSV97.ButVseClick(Sender: TObject);
begin
 with printer do
  begin
   if not printing then
    begin
     Orientation := poPortrait;
     beginDoc;
    end;
  end;
 tiskniVse;
end;

procedure TFVybSV97.Button2Click(Sender: TObject);
var vysledek:integer;
begin
 ZobrazPodleRadkuTabulky(Query1,vysledek);
end;

procedure TFVybSV97.FormCreate(Sender: TObject);
begin
 stranaI:=1;
 strana_pozadovana_k_tisku_Z:=0;
 levaPrava:=1;
 ComboBox1.itemindex:=levaPrava;
 comboBox1.text:=ComboBox1.items[ComboBox1.itemindex];
{with printer do
 begin
 Orientation := poLandscape;
 pxi:=round(GetDeviceCaps(Printer.Handle, LOGPIXELSX)*1.15);
 pyi:=GetDeviceCaps(Printer.Handle, LOGPIXELSY);
 pxi:=round(printer.PageWidth*1.15);
 pyi:=printer.PageHeight;
 beginDoc;
 end;  }
end;

procedure TFVybSV97.Edit1Change(Sender: TObject);
begin
if (edit1.text='')or(edit1.text=' ')or(edit1.text='  ') then
  begin
   stranaI:=1;
  end
else
begin
try
 stranaI:=strtoint(edit1.text);
except
 on EConvertError do
    begin
     showmessage('Stranu lze zadavat pouze arabskmi slicemi.');
     edit1.text:='1';
    end;
end;
end;
end;

procedure TFVybSV97.ComboBox1Change(Sender: TObject);
begin
 levaprava:=ComboBox1.itemindex;
end;

procedure TFVybSV97.Edit2Change(Sender: TObject);
begin
if (edit2.text='')or(edit2.text=' ')or(edit2.text='  ') then
  begin
   strana_pozadovana_k_tisku_Z:=0;
  end
else
begin
try
 strana_pozadovana_k_tisku_Z:=strtoint(edit2.text);
except
 on EConvertError do
    begin
     showmessage('Stranu lze zadavat pouze arabskmi slicemi.');
     edit2.text:='0';
    end;
end;
end;
end;
procedure TFVybSV97.Button3Click(Sender: TObject);
var im,i:integer;
    vysledek:integer;
begin
 with printer do
  begin
   if not printing then
    begin
     Orientation := poPortrait;
     beginDoc;
    end;
  end;
 IM:=strtoint(edit3.text);
 if IM=0 then
  begin
   while not query1.eof do
    begin
     TiskniPodleRadkuTabulky(Query1,vysledek);
     if vysledek=1 then exit;
     query1.next;
    end;
  end
 else
  begin
   for i:=1  to IM do
    begin
     TiskniPodleRadkuTabulky(Query1,vysledek);
     if vysledek=1 then exit;
     query1.next;
    end;
  end;
end;

end.
