unit U_sehr;
interface
uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls, StdCtrls,
  Forms, Dialogs, DBTables, DB, Kfindtab, Grids, DBGrids,DBIPROCS,
  typyDelf,ctipreh, bonita,sp_meldr,sp_hlavi,sp_hlask,dotaz,IniFiles,
  DdeMan, KSumary, sp_ovr98,ovr_ovr,UNahraj,mat1;

procedure NastavPorost(var ovrP:TOvr98;odd,dil,por:string);
procedure ZkopirujSkupinu(var ovr1,ovr2:tOvr98;kontrola:boolean);
procedure ZkopirujBezlesi(var ovr1,ovr2:tOvr98;kontrola:boolean);
procedure ZkopirujRadekTabulky(var Tab1,Tab2:TTable);
procedure PorovnejTabulky(var Tab1,Tab2,TabRozd:TTable);
procedure ZkopirujPorost(var ovr1,ovr2:tOvr98; kontrola:boolean);
procedure ZkopirujDilec(var ovr1,ovr2:tOvr98; kontrola:boolean);
procedure ZkopirujOddeleni(var ovr1,ovr2:tOvr98; kontrola:boolean);
procedure ZkopirujVse(var ovr1,ovr2:tOvr98);
procedure ZkopirujJine(var ovr1,ovr2:tOvr98;kontrola:boolean);
procedure ZkopirujOstatni(var ovr1,ovr2:tOvr98;kontrola:boolean);
procedure PripravCestuKDilci(var ovr1,ovr2:tOvr98);
procedure PripravCestuKPorostu(var ovr1,ovr2:tOvr98);
procedure PripravCestuKeSkupine(var ovr1,ovr2:tOvr98);
procedure ZkopirujBezlesiSCestou(var ovr1,ovr2:tOvr98;kontrola:boolean);
procedure ZkopirujJineSCestou(var ovr1,ovr2:tOvr98;kontrola:boolean);
procedure ZkopirujOstatniSCestou(var ovr1,ovr2:tOvr98;kontrola:boolean);
procedure ZkopirujSkupinuSCestou(var ovr1,ovr2:tOvr98;kontrola:boolean);
procedure ZkopirujPorostSCestou(var ovr1,ovr2:tOvr98;kontrola:boolean);
procedure ZkopirujDilecSCestou(var ovr1,ovr2:tOvr98;kontrola:boolean);
procedure ZkopirujPodleRadkuTabulky(var ovr1,ovr2:tOvr98;tb_vyb:TDataset;
            kontrola:boolean;var vysledek:integer);
procedure SmazPodleRadku(Query2:TDataSet);
procedure NactizTab1doTab2(var Tab1,Tab2:TTable);

implementation
uses Uvyber;

procedure NactizTab1doTab2(var Tab1,Tab2:TTable);
 begin
  Tab1.active:=true;
  Tab2.active:=true;
  Tab1.first;
  while not tab1.eof do
   begin
    ZkopirujRadekTabulky(Tab1,Tab2);
    Tab1.Next;
   end;
 end;

procedure NastavPorost(var ovrP:TOvr98;odd,dil,por:string);
begin
 ovrP.hl_odd1.findText(odd,true);
 ovrP.hl_dl1.findText(dil,true);
 ovrP.hl_porost.findText(por,true);
end;
function TypeAsString(Value : TFieldType) : String;
begin
  Case Value of
    ftString  : Result := 'CHAR';
    ftSmallint: Result := 'INTEGER';
    ftInteger : Result := 'Integer';
    ftWord    : Result := 'INTEGER';
    ftBoolean : Result := 'Boolean';
    ftFloat   : Result := 'Float';
    ftCurrency: Result := 'Currency';
    ftBCD     : Result := 'BCD';
    ftDate    : Result := 'Date';
    ftTime    : Result := 'Time';
    ftDateTime: Result := 'DateTime';
    ftBytes   : Result := 'Bytes';
    ftVarBytes: Result := 'VarBytes';
    ftBlob    : Result := 'Blob';
    ftMemo    : Result := 'Memo';
    ftGraphic : Result := 'Graphic';
    else Result := 'Neznm';
  end;
end;

procedure DoplnSloupceTabulky(var Tab1,Tab2:TTable);
var
  i:integer;
  chybPol,chybPolTyp:string;
 begin
 repeat
  chybPol:='';
  for i:=0 to tab1.fieldCount-1 do
   begin
     if tab2.findField(tab1.fields[i].FullName)=nil then
      begin
        chybPol:=tab1.fields[i].FullName;
        chybPolTyp:=TypeAsString(tab1.fields[i].datatype);
        if tab1.fields[i].datatype=ftString then
         begin
          chybPolTyp:=chybPolTyp+'('+inttostr(tab1.fields[i].DataSize)+')';
         end;
      end;
   end;
  if chybPol<>'' then
   begin
    tab2.close;
    Ovr98.queryDotaz.DatabaseName:=tab2.DatabaseName;
    Ovr98.Querydotaz.SQL.clear;
    // showmessage('cau '+KPrvnimuZnaku(tab2.tableName,'.'));
    Ovr98.Querydotaz.SQL.add('ALTER TABLE '+KPrvnimuZnaku(tab2.tableName,'.')
        +' ADD '+chybPol+' '+chybPolTyp);
    Ovr98.QueryDotaz.execSQL;
    tab2.open;
   end;
  until chybPol='';
 end;

procedure ZkopirujRadekTabulky(var Tab1,Tab2:TTable);
var
 i:integer;
 vPoradku,nacteniProbehlo:boolean;
 InfStr:string;
 begin
 InfStr:='';
 repeat
  tab2.insert;
  vporadku:=true;
  for i:=0 to tab1.fieldCount-1 do
   begin
    try
    nacteniProbehlo:=false;
    if tab2.FieldCount>i then
     begin
      if tab2.fields[i].FullName=tab1.fields[i].FullName then
       begin
        tab2.fields[i].assign(tab1.fields[i]);

        nacteniProbehlo:=true;
        InfStr:=InfStr+tab2.fields[i].asstring+'#';
       end;
     end;
    if not nacteniProbehlo then
     begin
      if tab2.findField(tab1.fields[i].FullName)<>nil then
       begin
        tab2.fieldByName(tab1.fields[i].FullName).assign(tab1.fields[i]);
       end
      else
       begin
        showmessage('V tabulce '+tab2.Name+' = '+tab2.TableName+' chyb sloupec '+tab1.fields[i].FullName);
        vporadku:=false;
       end;
     end;
    except
     showmessage('Chyba pi koprovn dku tabulky '+tab1.TableName+' ve sloupci'+tab1.fields[i].FullName);
     vporadku:=false;
    end;
   end;
  if not vporadku then
   begin
         Application.CreateForm(TdotazF1,dotazF2);
         dotazF2.Label1.caption:='Mm doplnit chybjc sloupeky do tabulky '+tab2.TableName+'?';
         dotazF2.Label2.caption:='';
         dotazF2.showmodal;
         if dotazF2.odpoved then
          begin
           Tab2.delete;
           DoplnSloupceTabulky(Tab1,Tab2);
          end
         else
          begin
           halt;
          end;
         dotazF2.free;
   end;
  until vporadku;
 end;

procedure PorovnejTabulky(var Tab1,Tab2,TabRozd:TTable);
var
 i:integer;
 vPoradku,nacteniProbehlo:boolean;
 begin
  for i:=0 to tab1.fieldCount-1 do
   begin
    if tab2.findField(tab1.fields[i].FullName)=nil then
     begin
     // showmessage('V tabulce '+Tab2.TableName+' chyb pole '+tab1.fields[i].FullName);
      TabRozd.Insert;
      TabRozd.FieldByName('Poznamka').Asstring:='V tabulce '+Tab2.TableName+' chyb pole '+tab1.fields[i].FullName;
      TabRozd.post;
     end;
   end;
  for i:=0 to tab2.fieldCount-1 do
   begin
    if tab1.findField(tab2.fields[i].FullName)=nil then
     begin
      // showmessage('V tabulce '+Tab1.TableName+' chyb pole '+tab2.fields[i].FullName);
      TabRozd.Insert;
      TabRozd.FieldByName('Poznamka').Asstring:='V tabulce '+Tab1.TableName+' chyb pole '+tab2.fields[i].FullName;
      TabRozd.Post;
     end;
   end;
 end;

procedure ZkopirujBezlesi(var ovr1,ovr2:tOvr98;kontrola:boolean);
begin
  if kontrola then
   begin
   if ovr2.hl_bzl.findText(
          ovr1.tb_bzl.fieldByName('BZL').asstring,true)
    then
     begin
      FNahraj.odpoved:='Z';
      repeat
      begin
       FNahraj.label1.caption:=' Bezlesi "' +
          ovr1.tb_odd.fieldByName('ODD').asstring+
          ovr1.tb_dl.fieldByName('DIL').asstring+
          ovr1.tb_porost.fieldByName('POR').asstring+'  '+
          ovr1.tb_bzl.fieldByName('BZL').asstring+
          '" ji existuje.';
       FNahraj.label2.caption:='';
       FNahraj.label3.caption:='';
       FNahraj.buttonS.visible:=false;
       FNahraj.showmodal;
      end;
    if FNahraj.odpoved='N' then
      begin
       exit;
      end;
    if Fnahraj.Odpoved='P' then
     begin
      ovr2.Tb_bzl.delete;
     end;
    if FNahraj.odpoved='D' then
      begin
       if (length(FNahraj.editOzn.text)>3)or(length(FNahraj.editOzn.text)<1) then
        begin
         showmessage('Bezlesi se oznauje jednm a temi znaky.');
         FNahraj.odpoved:='ZD';
        end;
     if ovr2.hl_bzl.findText(FNahraj.editOzn.text, true) then
       begin
         showmessage('Bezlesi s tmto oznaenm ji existuje.');
         FNahraj.odpoved:='ZD';
       end;
      end;

  until FNahraj.odpoved[1]<>'Z';
  end;{if hl bzl}
  end;{if kontrola}
  zkopirujRadekTabulky(ovr1.tb_bzl,ovr2.tb_bzl);
  ovr2.tb_bzl.fieldByName('VAZBA').asstring:=
              ovr2.tb_porost.fieldByName('ID').asstring;
  if FNahraj.odpoved='D' then
   begin
    ovr2.tb_bzl.fieldByName('BZL').asstring:=FNahraj.editOzn.text;
    FNahraj.odpoved:='Z';
   end;
  IDPridej(ovr2.tb_id,ovr2.tb_bzl,'BEZLESI');
  ovr2.Tb_bzl.post; ovr2.Tb_bzl.edit;
end;
procedure ZkopirujPrekryv(var ovr1,ovr2:tOvr98);
begin
  zkopirujRadekTabulky(ovr1.tb_prekryv1,ovr2.tb_prekryv1);
  ovr2.tb_prekryv1.fieldByName('VAZBA').asstring:=
              ovr2.tb_porost.fieldByName('ID').asstring;
  IDPridej(ovr2.tb_id,ovr2.tb_prekryv1,'PREKRYV');
  ovr2.Tb_prekryv1.post; ovr2.Tb_prekryv1.edit;
end;

procedure ZkopirujZvlSt(var ovr1,ovr2:tOvr98);
begin
  zkopirujRadekTabulky(ovr1.tb_zvlSt,ovr2.tb_zvlSt);
  ovr2.tb_zvlSt.fieldByName('VAZBA').asstring:=
              ovr2.tb_Porost.fieldByName('ID').asstring;
  IDPridej(ovr2.tb_id,ovr2.tb_zvlSt,'PREKRYV');
  ovr2.Tb_zvlSt.post; ovr2.Tb_zvlSt.edit;
end;


procedure ZkopirujPOR_POZN(var ovr1,ovr2:tOvr98);
begin
  zkopirujRadekTabulky(ovr1.tb_por_pozn,ovr2.tb_por_pozn);
  ovr2.tb_por_pozn.fieldByName('VAZBA').asstring:=
              ovr2.tb_Porost.fieldByName('ID').asstring;
  IDPridej(ovr2.tb_id,ovr2.tb_por_pozn,'POR_POZN');
  ovr2.tb_por_pozn.post; ovr2.tb_por_pozn.edit;
end;


procedure ZkopirujOstatni(var ovr1,ovr2:tOvr98;kontrola:boolean);
begin
  if kontrola then
   begin
   if ovr2.hl_ost.findText(
          ovr1.tb_ost.fieldByName('OST').asstring,true)
    then
     begin
      FNahraj.odpoved:='Z';
      repeat
      begin
       FNahraj.label1.caption:=' Ostatn "' +
          ovr1.tb_odd.fieldByName('ODD').asstring+
          ovr1.tb_ost.fieldByName('OST').asstring+
          '" ji existuje.';
       FNahraj.label2.caption:='';
       FNahraj.label3.caption:='';
       FNahraj.buttonS.visible:=false;
       FNahraj.showmodal;
      end;
    if FNahraj.odpoved='N' then
      begin
       exit;
      end;
    if Fnahraj.Odpoved='P' then
     begin
      ovr2.Tb_ost.delete;
     end;
    if FNahraj.odpoved='D' then
      begin
       if (length(FNahraj.editOzn.text)>3)or(length(FNahraj.editOzn.text)<1) then
        begin
         showmessage('Ostatni pda se oznauje jednm a temi znaky.');
         FNahraj.odpoved:='ZD';
        end;
     if ovr2.hl_ost.findText(FNahraj.editOzn.text, true) then
       begin
         showmessage('Ostatni pda s tmto oznaenm ji existuje.');
         FNahraj.odpoved:='ZD';
       end;
      end;

  until FNahraj.odpoved[1]<>'Z';
  end;{if hl ost}
  end;{if kontrola}
  zkopirujRadekTabulky(ovr1.tb_ost,ovr2.tb_ost);
  ovr2.tb_ost.fieldByName('VAZBA').asstring:=
              ovr2.tb_porost.fieldByName('ID').asstring;
  if FNahraj.odpoved='D' then
   begin
    ovr2.tb_ost.fieldByName('OST').asstring:=FNahraj.editOzn.text;
    FNahraj.odpoved:='Z';
   end;
  IDPridej(ovr2.tb_id,ovr2.tb_ost,'OST_POZ');
  ovr2.Tb_ost.post; ovr2.Tb_ost.edit;
end;

procedure ZkopirujJine(var ovr1,ovr2:tOvr98;kontrola:boolean);
begin
  if kontrola then
   begin
   if ovr2.hl_jine.findText(
          ovr1.tb_jine.fieldByName('JP').asstring,true)
    then
     begin
      FNahraj.odpoved:='Z';
      repeat
      begin
       FNahraj.label1.caption:=' Jin pozemek "' + '  '+
          ovr1.tb_jine.fieldByName('JP').asstring+
          '" ji existuje.';
       FNahraj.label2.caption:='';
       FNahraj.label3.caption:='';
       FNahraj.buttonS.visible:=false;
       FNahraj.showmodal;
      end;
    if FNahraj.odpoved='N' then
      begin
       exit;
      end;
    if Fnahraj.Odpoved='P' then
     begin
      ovr2.Tb_jine.delete;
     end;
    if FNahraj.odpoved='D' then
      begin
       if (length(FNahraj.editOzn.text)>3)or(length(FNahraj.editOzn.text)<1) then
        begin
         showmessage('Jin pozemek se oznauje jednm a temi znaky.');
         FNahraj.odpoved:='ZD';
        end;
     if ovr2.hl_jine.findText(FNahraj.editOzn.text, true) then
       begin
         showmessage('Pozemek s tmto oznaenm ji existuje.');
         FNahraj.odpoved:='ZD';
       end;
      end;

  until FNahraj.odpoved[1]<>'Z';
  end;{if hl bzl}
  end;{if kontrola}
  zkopirujRadekTabulky(ovr1.tb_jine,ovr2.tb_jine);
  ovr2.tb_jine.fieldByName('VAZBA').asstring:=
              ovr2.tb_porost.fieldByName('ID').asstring;
  if FNahraj.odpoved='D' then
   begin
    ovr2.tb_jine.fieldByName('JP').asstring:=FNahraj.editOzn.text;
    FNahraj.odpoved:='Z';
   end;
  IDPridej(ovr2.tb_id,ovr2.tb_jine,'JINE_POZ');
  ovr2.Tb_jine.post;
  ovr2.Tb_jine.edit;
end;

procedure ZkopirujSkupinu(var ovr1,ovr2:tOvr98;kontrola:boolean);
 begin
  if kontrola then
   begin
   if ovr2.hl_PSK.findText(
          ovr1.tb_sk.fieldByName('PSK').asstring
                ,true)
    then
     begin
      FNahraj.odpoved:='Z';
      repeat
      begin
      { Application.CreateForm(TFNahraj, FNahraj); }
       FNahraj.label1.caption:=' Skupina "' +
          ovr1.tb_odd.fieldByName('ODD').asstring+
          ovr1.tb_dl.fieldByName('DIL').asstring+
          ovr1.tb_porost.fieldByName('POR').asstring+'  '+
          ovr1.tb_sk.fieldByName('PSK').asstring+
          '" ji existuje.';
       FNahraj.label2.caption:='';
       FNahraj.label3.caption:='';
       FNahraj.buttonS.visible:=false;
       FNahraj.showmodal;
      end;
    if FNahraj.odpoved='N' then
      begin
       exit;
      end;
    if Fnahraj.Odpoved='P' then
     begin
      ovr2.SmazSkupinu;
     end;
    if FNahraj.odpoved='D' then
      begin
       if (length(FNahraj.editOzn.text)>3)or(length(FNahraj.editOzn.text)<1) then
        begin
         showmessage('Skupina se oznauje jednm a temi znaky.');
         FNahraj.odpoved:='ZD';
        end;
     if ovr2.hl_PSK.findText(FNahraj.editOzn.text, true) then
       begin
         showmessage('Skupina s tmto oznaenm ji existuje.');
         FNahraj.odpoved:='ZD';
       end;
      end;

  until FNahraj.odpoved[1]<>'Z';
  end;{if hl sk}
  end;{if kontrola}
  zkopirujRadekTabulky(ovr1.tb_sk,ovr2.tb_sk);
  ovr2.tb_sk.fieldByName('VAZBA').asstring:=
              ovr2.tb_porost.fieldByName('ID').asstring;
  if FNahraj.odpoved='D' then
   begin
    ovr2.tb_sk.fieldByName('PSK').asstring:=FNahraj.editOzn.text;
    FNahraj.odpoved:='Z';
   end;
  IDPridej(ovr2.tb_id,ovr2.tb_sk,'PS');
  ovr2.Tb_sk.post;
  ovr2.Tb_sk.edit;
  while not ovr1.tb_ps_pozn.eof do
   begin
    zkopirujRadekTabulky(ovr1.tb_ps_pozn,ovr2.tb_ps_pozn);
    ovr2.tb_ps_Pozn.fieldByName('VAZBA').asstring:=
              ovr2.tb_sk.fieldByName('ID').asstring;
    IDPridej(ovr2.tb_id,ovr2.tb_PS_POZN,'PS_POZN');
    ovr2.Tb_ps_pozn.post;
    ovr2.Tb_ps_pozn.edit;
    ovr1.Tb_ps_pozn.next;
   end;
  ovr1.tb_navrh1.open;
  ovr2.tb_navrh1.open;
  ovr1.tb_etaz.first;
  while not ovr1.tb_etaz.eof do
   begin
    zkopirujRadekTabulky(ovr1.tb_etaz,ovr2.tb_etaz);
    ovr2.tb_etaz.fieldByName('VAZBA').asstring:=
              ovr2.tb_sk.fieldByName('ID').asstring;
    IDPridej(ovr2.tb_id,ovr2.tb_etaz,'ETAZ');
    ovr2.Tb_etaz.post; ovr2.Tb_etaz.edit;
    ovr1.tb_dr.first;
     while not ovr1.tb_dr.eof do
       begin
        zkopirujRadekTabulky(ovr1.tb_dr,ovr2.tb_dr);
        ovr2.tb_dr.fieldByName('VAZBA').asstring:=
              ovr2.tb_etaz.fieldByName('ID').asstring;
        IDPridej(ovr2.tb_id,ovr2.tb_dr,'DREVINA');
        ovr2.Tb_dr.post; ovr2.Tb_dr.edit;
        ovr1.tb_poskoz.first;
         while not ovr1.tb_poskoz.eof do
          begin
           zkopirujRadekTabulky(ovr1.tb_poskoz,ovr2.tb_poskoz);
           ovr2.tb_poskoz.fieldByName('VAZBA').asstring:=
              ovr2.tb_dr.fieldByName('ID').asstring;
           ovr2.Tb_poskoz.post; ovr2.Tb_poskoz.edit;
           ovr1.tb_poskoz.next;
          end;
        ovr1.tb_dr.next;
       end;
    {ovr1.nastavsetrange1(ovr1); }
   (*
   with ovr1.tb_navrh do
   begin
   SetRangeStart; { Set the beginning key }
   FieldByName('ID').AsInteger := 0;
   FieldByName('N_Druh_vykonu').AsInteger :=0;
   FieldByName('VAZBA').AsInteger:=ovr1.TB_Etaz.FieldByName('ID').asInteger;
   SetRangeEnd; { Set the ending key }
   FieldByName('ID').AsInteger :=900000;
   FieldByName('N_Druh_vykonu').AsInteger :=99;
   FieldByName('VAZBA').AsInteger:=ovr1.TB_Etaz.FieldByName('ID').asInteger;
   ApplyRange; { Tell the dataset to establish the range }
   end;
   with ovr2.tb_navrh do
   begin
   SetRangeStart; { Set the beginning key }
   FieldByName('ID').AsInteger := 0;
   FieldByName('N_Druh_vykonu').AsInteger :=0;
   FieldByName('VAZBA').AsInteger:=ovr1.TB_Etaz.FieldByName('ID').asInteger;
   SetRangeEnd; { Set the ending key }
   FieldByName('ID').AsInteger :=900000;
   FieldByName('N_Druh_vykonu').AsInteger :=99;
   FieldByName('VAZBA').AsInteger:=ovr1.TB_Etaz.FieldByName('ID').asInteger;
   ApplyRange; { Tell the dataset to establish the range }
   end; *)
Ovr2.TB_NAVRH.close;
Ovr2.TB_TEZOB.close;
Ovr2.TB_ZAL.close;
Ovr2.TB_PROR.close;
    ovr1.tb_navrh1.first;
     while not ovr1.tb_navrh1.eof do
       begin
           zkopirujRadekTabulky(ovr1.tb_navrh1,ovr2.tb_navrh1);
           ovr2.tb_navrh1.fieldByName('VAZBA').asstring:=
              ovr2.tb_etaz.fieldByName('ID').asstring;
           IDPridej(ovr2.tb_id,ovr2.tb_navrh1,'NAVRH');
           ovr2.Tb_navrh1.post; ovr2.Tb_navrh1.edit;
           ovr1.tb_navrh1.next;
       end;
Ovr2.TB_NAVRH.open;
Ovr2.TB_TEZOB.open;
Ovr2.TB_ZAL.open;
Ovr2.TB_PROR.open;
   { ovr1.tb_zal.first;
     while not ovr1.tb_zal.eof do
       begin
           zkopirujRadekwwTabulky(ovr1.tb_zal,ovr2.tb_zal);
           ovr2.tb_zal.fieldByName('VAZBA').asstring:=
              ovr2.tb_etaz.fieldByName('ID').asstring;
           IDPridej(ovr2.tb_id,ovr2.tb_zal,'NAVRH');
           ovr2.tb_zal.post; ovr2.tb_zal.edit;
           ovr1.tb_zal.next;
       end;
     ovr1.tb_tezOb.first;
     while not ovr1.tb_tezOb.eof do
       begin
           zkopirujRadekwwTabulky(ovr1.tb_tezOb,ovr2.tb_tezOb);
           ovr2.tb_tezOb.fieldByName('VAZBA').asstring:=
              ovr2.tb_etaz.fieldByName('ID').asstring;
           IDPridej(ovr2.tb_id,ovr2.tb_tezOb,'NAVRH');
           ovr2.tb_tezOb.post; ovr2.tb_tezOb.edit;
           ovr1.tb_tezOb.next;
       end;
     ovr1.tb_pror.first;
     while not ovr1.tb_pror.eof do
       begin
           zkopirujRadekTabulky(ovr1.tb_pror,ovr2.tb_pror);
           ovr2.tb_pror.fieldByName('VAZBA').asstring:=
              ovr2.tb_etaz.fieldByName('ID').asstring;
           IDPridej(ovr2.tb_id,ovr2.tb_pror,'NAVRH');
           ovr2.tb_pror.post; ovr2.tb_pror.edit;
           ovr1.tb_pror.next;
       end;  }
    ovr1.tb_etaz.next;
   end;
 end;

procedure ZkopirujPorost(var ovr1,ovr2:tOvr98; kontrola:boolean);
var
   kontrola_sk:boolean;
 begin
  kontrola_sk:=false;
  if kontrola then
   begin
   if ovr2.hl_porost.findText(
          ovr1.tb_porost.fieldByName('POR').asstring
                ,true)
    then
     begin
      FNahraj.odpoved:='Z';
      repeat
      begin
      { Application.CreateForm(TFNahraj, FNahraj); }
       FNahraj.label1.caption:=' Porost "' +
          ovr1.tb_odd.fieldByName('ODD').asstring+
          ovr1.tb_dl.fieldByName('DIL').asstring+
          ovr1.tb_porost.fieldByName('POR').asstring+
          '" ji existuje.';
       FNahraj.label2.caption:='';
       FNahraj.label3.caption:='';
       FNahraj.ButtonS.Visible:=true;

       FNahraj.showmodal;
      end;
    if FNahraj.odpoved='N' then
      begin
       exit;
      end;
    if FNahraj.odpoved='D' then
      begin
       if length(FNahraj.editOzn.text)<>1 then
        begin
         showmessage('Porost se oznauje jednm znakem.');
         FNahraj.odpoved:='ZD';
        end;
     if ovr2.hl_porost.findText(FNahraj.editOzn.text, true) then
       begin
         showmessage('Porost s tmto oznaenm ji existuje.');
         FNahraj.odpoved:='ZD';
       end;
      end;
    if Fnahraj.Odpoved='P' then
     begin
      ovr2.SmazPorost;
     end;
    if Fnahraj.Odpoved='S' then
     begin
      kontrola_sk:=true;
     end;
    until FNahraj.odpoved[1]<>'Z';
   end;
  end;
 if not kontrola_sk then
  begin
  zkopirujRadekTabulky(ovr1.tb_porost,ovr2.tb_porost);
  ovr2.tb_porost.fieldByName('VAZBA').asstring:=
       ovr2.tb_dl.fieldByName('ID').asstring;
  if FNahraj.odpoved='D' then
   begin
    ovr2.tb_porost.fieldByName('POR').asstring:=FNahraj.editOzn.text;
    FNahraj.odpoved:='Z';
   end;
  IDPridej(ovr2.tb_id,ovr2.tb_porost,'POROST');
  ovr2.tb_porost.post;
  ovr2.tb_porost.edit;
  {
  zkopirujRadekTabulky(ovr1.tb_por_pozn,ovr2.tb_por_pozn);
  ovr2.tb_por_pozn.fieldByName('VAZBA').asstring:=
       ovr2.tb_porost.fieldByName('ID').asstring;
  IDPridej(ovr2.tb_id,ovr2.tb_por_pozn,'POR_POZN');
  ovr2.tb_por_pozn.post;
  ovr2.tb_por_pozn.edit;
  }
 end;
  ovr1.tb_sk.first;
     while not ovr1.tb_sk.eof do
       begin
        ZkopirujSkupinu(ovr1,ovr2,kontrola_sk);
        ovr1.tb_sk.next;
       end;
  ovr1.tb_bzl.first;
     while not ovr1.tb_bzl.eof do
       begin
        ZkopirujBezlesi(ovr1,ovr2,kontrola_sk);
        ovr1.tb_bzl.next;
       end;
  ovr1.tb_jine.first;
     while not ovr1.tb_jine.eof do
       begin
        ZkopirujJine(ovr1,ovr2,kontrola_sk);
        ovr1.tb_jine.next;
       end;
  ovr1.tb_ost.first;
     while not ovr1.tb_ost.eof do
       begin
        ZkopirujOstatni(ovr1,ovr2,kontrola_sk);
        ovr1.tb_ost.next;
       end;
  if pocetRec0(ovr2.tb_prekryv1) then
   begin
    ovr1.tb_prekryv1.first;
     while not ovr1.tb_prekryv1.eof do
      begin
       Zkopirujprekryv(ovr1,ovr2);
       ovr1.tb_prekryv1.next;
      end;
   end;
  if pocetRec0(ovr2.tb_ZvlSt) then
   begin
    ovr1.tb_ZvlSt.first;
     while not ovr1.tb_ZvlSt.eof do
      begin
       ZkopirujZvlSt(ovr1,ovr2);
       ovr1.tb_ZvlSt.next;
      end;
   end;
  if pocetRec0(ovr2.tb_por_pozn) then
   begin
    ovr1.tb_por_pozn.first;
     while not ovr1.tb_por_pozn.eof do
      begin
       ZkopirujPOR_POZN(ovr1,ovr2);
       ovr1.tb_por_pozn.next;
      end;
   end;

 end;

procedure ZkopirujDilec(var ovr1,ovr2:tOvr98; kontrola:boolean);
var
   kontrola_por:boolean;
 begin
  kontrola_por:=false;
  if kontrola then
   begin
   if ovr2.hl_dl1.findText(
          ovr1.tb_DL.fieldByName('DIL').asstring
                ,true)
    then
     begin
      FNahraj.odpoved:='Z';
      repeat
      begin
       FNahraj.label1.caption:=' Dlec "' +
          ovr1.tb_odd.fieldByName('ODD').asstring+
          ovr1.tb_dl.fieldByName('DIL').asstring+
          '" ji existuje.';
       FNahraj.label2.caption:='';
       FNahraj.label3.caption:='';
       FNahraj.ButtonS.Visible:=true;
       FNahraj.showmodal;
      end;
    if FNahraj.odpoved='N' then
      begin
       exit;
      end;
    if FNahraj.odpoved='D' then
      begin
       if length(FNahraj.editOzn.text)<>1 then
        begin
         showmessage('Dlec se oznauje jednm znakem.');
         FNahraj.odpoved:='ZD';
        end;
     if ovr2.hl_dl1.findText(FNahraj.editOzn.text, true) then
       begin
         showmessage('Dilec s tmto oznaenm ji existuje.');
         FNahraj.odpoved:='ZD';
       end;
      end;
    if Fnahraj.Odpoved='P' then
     begin
      ovr2.SmazDilec;
     end;
    if Fnahraj.Odpoved='S' then
     begin
      kontrola_por:=true;
     end;
    until FNahraj.odpoved[1]<>'Z';
   end;
  end;
 if not kontrola_por then
  begin
   zkopirujRadekTabulky(ovr1.tb_dl,ovr2.tb_dl);
   ovr2.tb_dl.fieldByName('VAZBA').asstring:=
       ovr2.tb_odd.fieldByName('ID').asstring;
   if FNahraj.odpoved='D' then
    begin
     ovr2.tb_dl.fieldByName('DIL').asstring:=FNahraj.editOzn.text;
     FNahraj.odpoved:='Z';
    end;
   IDPridej(ovr2.tb_id,ovr2.tb_Dl,'DILEC');
   ovr2.tb_dl.post;
   ovr2.tb_dl.edit;
  end;
  ovr1.tb_porost.first;
     while not ovr1.tb_porost.eof do
       begin
        ZkopirujPorost(ovr1,ovr2,kontrola_por);
        ovr1.tb_porost.next;
       end;
 end;

procedure ZkopirujOddeleni(var ovr1,ovr2:tOvr98; kontrola:boolean);
var
   kontrola_dl:boolean;
 begin
  kontrola_dl:=false;
{ if ovr2.hl_odd1.findText(
          ovr1.tb_odd.fieldByName('ODD').asstring
                ,true) }
 if ovr2.hl_odd1.findNumber(
          ovr1.tb_odd.fieldByName('ODD').asinteger)
    then
     begin
   if kontrola then
    begin
      FNahraj.odpoved:='Z';
      repeat
      begin
      { Application.CreateForm(TFNahraj, FNahraj); }
       FNahraj.label1.caption:=' Oddelen "' +
          ovr1.tb_odd.fieldByName('ODD').asstring+
          '" ji existuje.';
       FNahraj.label2.caption:='';
       FNahraj.label3.caption:='';
       FNahraj.ButtonS.Visible:=true;
       FNahraj.showmodal;
      end;
    if FNahraj.odpoved='N' then
      begin
       exit;
      end;
    if FNahraj.odpoved='D' then
      begin
       if (length(FNahraj.editOzn.text)>3)or(length(FNahraj.editOzn.text)<1) then
        begin
         showmessage('Oddlen se oznauje maximn temi znaky.');
         FNahraj.odpoved:='ZD';
        end;
     if ovr2.hl_odd1.findText(FNahraj.editOzn.text, true) then
       begin
         showmessage('Oddlen s tmto oznaenm ji existuje.');
         FNahraj.odpoved:='ZD';
       end;
      end;
    if Fnahraj.Odpoved='P' then
     begin
      ovr2.SmazOddeleni;
     end;
    if Fnahraj.Odpoved='S' then
     begin
      kontrola_dl:=true;
     end;
    until FNahraj.odpoved[1]<>'Z';
   end
  else
   begin
     Fnahraj.Odpoved:='S';
     kontrola_dl:=true;
   end;
  end;
 if not kontrola_dl then
  begin
  zkopirujRadekTabulky(ovr1.tb_odd,ovr2.tb_odd);
  ovr2.tb_odd.fieldByName('VAZBA').asstring:=
       ovr2.tb_lhc.fieldByName('ID').asstring;
  if FNahraj.odpoved='D' then
   begin
    ovr2.tb_odd.fieldByName('ODD').asstring:=FNahraj.editOzn.text;
    FNahraj.odpoved:='Z';
   end;
  IDPridej(ovr2.tb_id,ovr2.tb_odd,'ODDELENI');
  ovr2.tb_odd.post;
  ovr2.tb_odd.edit;
 end;
  ovr1.tb_dl.first;
     while not ovr1.tb_dl.eof do
       begin
        ZkopirujDilec(ovr1,ovr2,kontrola_dl);
        ovr1.tb_dl.next;
       end;
 end;
procedure ZkopirujVse(var ovr1,ovr2:tOvr98);
var
   kontrola_odd:boolean;
 begin
  kontrola_odd:=false;
  ovr1.tb_odd.first;
     while not ovr1.tb_odd.eof do
       begin
        ZkopirujOddeleni(ovr1,ovr2,kontrola_odd);
        ovr1.tb_odd.next;
       end;
 end;
procedure PripravCestuKDilci(var ovr1,ovr2:tOvr98);
begin
 if not ovr2.hl_odd1.findNumber(
          ovr1.tb_odd.fieldByName('ODD').asinteger)
    then
     begin
      zkopirujRadekTabulky(ovr1.tb_odd,ovr2.tb_odd);
      ovr2.tb_odd.fieldByName('VAZBA').asstring:=
         ovr2.tb_lhc.fieldByName('ID').asstring;
      IDPridej(ovr2.tb_id,ovr2.tb_odd,'ODDELENI');
      ovr2.tb_odd.post;
      ovr2.tb_odd.edit;
     end;
end;
procedure PripravCestuKPorostu(var ovr1,ovr2:tOvr98);
begin
 pripravCestuKDilci(ovr1,Ovr2);
 if not ovr2.hl_dl1.findText(
          ovr1.tb_DL.fieldByName('DIL').asstring
                ,true)
    then
     begin
      zkopirujRadekTabulky(ovr1.tb_dl,ovr2.tb_dl);
      ovr2.tb_dl.fieldByName('VAZBA').asstring:=
         ovr2.tb_odd.fieldByName('ID').asstring;
      IDPridej(ovr2.tb_id,ovr2.tb_dl,'DILEC');
      ovr2.tb_dl.post;
      ovr2.tb_dl.edit;
     end;
end;
procedure PripravCestuKeSkupine(var ovr1,ovr2:tOvr98);
begin
 pripravCestuKPorostu(ovr1,Ovr2);
   if not ovr2.hl_porost.findText(
          ovr1.tb_porost.fieldByName('POR').asstring
                ,true)
    then
     begin
      zkopirujRadekTabulky(ovr1.tb_porost,ovr2.tb_porost);
      ovr2.tb_porost.fieldByName('VAZBA').asstring:=
         ovr2.tb_dl.fieldByName('ID').asstring;
      IDPridej(ovr2.tb_id,ovr2.tb_porost,'POROST');
      ovr2.tb_porost.post;
      ovr2.tb_porost.edit;
      zkopirujRadekTabulky(ovr1.tb_por_pozn,ovr2.tb_por_pozn);
      ovr2.tb_por_pozn.fieldByName('VAZBA').asstring:=
         ovr2.tb_porost.fieldByName('ID').asstring;
      IDPridej(ovr2.tb_id,ovr2.tb_por_pozn,'POR_POZN');
      ovr2.tb_por_pozn.post;
      ovr2.tb_por_pozn.edit;
      if pocetRec0(ovr2.tb_prekryv1) then
       begin
        ovr1.tb_prekryv1.first;
        while not ovr1.tb_prekryv1.eof do
         begin
          Zkopirujprekryv(ovr1,ovr2);
          ovr1.tb_prekryv1.next;
         end;
       end;
      if pocetRec0(ovr2.tb_ZvlSt) then
       begin
        ovr1.tb_ZvlSt.first;
        while not ovr1.tb_ZvlSt.eof do
         begin
          ZkopirujZvlSt(ovr1,ovr2);
          ovr1.tb_ZvlSt.next;
         end;
       end;
     end;
end;
procedure ZkopirujSkupinuSCestou(var ovr1,ovr2:tOvr98;kontrola:boolean);
begin
  PripravCestuKeSkupine(ovr1,ovr2);
  ZkopirujSkupinu(ovr1,ovr2,kontrola);
end;
procedure ZkopirujBezlesiSCestou(var ovr1,ovr2:tOvr98;kontrola:boolean);
begin
  PripravCestuKeSkupine(ovr1,ovr2);
  ZkopirujBezlesi(ovr1,ovr2,kontrola);
end;
procedure ZkopirujJineSCestou(var ovr1,ovr2:tOvr98;kontrola:boolean);
begin
  PripravCestuKeSkupine(ovr1,ovr2);
  ZkopirujJine(ovr1,ovr2,kontrola);
end;
procedure ZkopirujOstatniSCestou(var ovr1,ovr2:tOvr98;kontrola:boolean);
begin
  PripravCestuKeSkupine(ovr1,ovr2);
  ZkopirujOstatni(ovr1,ovr2,kontrola);
end;
procedure ZkopirujPorostSCestou(var ovr1,ovr2:tOvr98;kontrola:boolean);
begin
  PripravCestuKPorostu(ovr1,ovr2);
  ZkopirujPorost(ovr1,ovr2,kontrola);
end;
procedure ZkopirujDilecSCestou(var ovr1,ovr2:tOvr98;kontrola:boolean);
begin
  PripravCestuKDilci(ovr1,ovr2);
  ZkopirujDilec(ovr1,ovr2,kontrola);
end;
procedure ZkopirujPodleRadkuTabulky(var ovr1,ovr2:tOvr98;tb_vyb:TDataset;
            kontrola:boolean;var vysledek:integer);
var
 kopirovani_provedeno:boolean;
 PSKv:String;
begin
vysledek:=0;
 if tb_vyb.findfield('ODD')<>nil then
   begin
    if not ovr1.hl_odd1.findNumber(
             tb_vyb.fieldByName('ODD').asinteger)
{    if not ovr1.hl_odd1.findText(
             tb_vyb.fieldByName('ODD').asstring,true) }
      then
        begin
          showmessage('Oddln '+
             tb_vyb.fieldByName('ODD').asstring+
             ' nen v natan databzi.');
          vysledek:=2;
          exit;
        end;
     if tb_vyb.findfield('DIL')<>nil then
      begin
       if not ovr1.hl_dl1.findText(
              tb_vyb.fieldByName('DIL').asstring
                  ,true)
        then
         begin
          showmessage('Dlec '+
             tb_vyb.fieldByName('ODD').asstring+
             tb_vyb.fieldByName('DIL').asstring+
             ' nen v natan databzi.');
          vysledek:=3;
          exit;
         end;
       if tb_vyb.findfield('POR')<>nil then
        begin
         if not ovr1.hl_porost.findText(
                  tb_vyb.fieldByName('POR').asstring,true)
            then
             begin
                showmessage('Porost  '+
                             tb_vyb.fieldByName('ODD').asstring+
                             tb_vyb.fieldByName('DIL').asstring+
                             tb_vyb.fieldByName('POR').asstring+
                             ' nen v natan databzi.');
              vysledek:=4;
              exit;
             end;
          if tb_vyb.findfield('PSK')<>nil then
           begin
            kopirovani_provedeno:=false;
            if ovr1.hl_PSK.findText(tb_vyb.fieldByName('PSK').asstring,true)
            then
              begin
               ZkopirujSkupinuSCestou(ovr1,ovr2,kontrola);
               kopirovani_provedeno:=true;
              end
            else
              begin
               PSKv:=opravenaSkupina(tb_vyb.fieldByName('PSK').asstring);
               if PSKv<>'' then
                begin
                 if PSKv[Length(PSKv)]=' ' then PSKv:=Copy(PSKv,1,length(PSKv)-1);
                end;
               if ovr1.hl_PSK.findText(PSKv,true) then
                begin
                 ZkopirujSkupinuSCestou(ovr1,ovr2,kontrola);
                 kopirovani_provedeno:=true;
                end
               else
                begin
                 PSKv:=opravenaSkupina(tb_vyb.fieldByName('PSK').asstring);
                 if ovr1.hl_PSK.findText(PSKv,true) then
                  begin
                   ZkopirujSkupinuSCestou(ovr1,ovr2,kontrola);
                   kopirovani_provedeno:=true;
                  end
                 else
                  begin
                   PSKv:=opravenaSkupinaBezPosledniMezery(tb_vyb.fieldByName('PSK').asstring);
                   if ovr1.hl_PSK.findText(PSKv,true) then
                    begin
                     ZkopirujSkupinuSCestou(ovr1,ovr2,kontrola);
                     kopirovani_provedeno:=true;
                    end;
                  end;
                end;
              end;
            if (ovr1.hl_BZL.findText(tb_vyb.fieldByName('PSK').asstring,true))
                 and (not kopirovani_provedeno) then
                 begin
                  ZkopirujBezlesiSCestou(ovr1,ovr2,kontrola);
                  kopirovani_provedeno:=true;
                 end;
            if (ovr1.hl_OST.findText(tb_vyb.fieldByName('PSK').asstring,true))
                 and (not kopirovani_provedeno) then
                 begin
                  ZkopirujOstatniSCestou(ovr1,ovr2,kontrola);
                  kopirovani_provedeno:=true;
                 end;
            if (ovr1.hl_JINE.findText(tb_vyb.fieldByName('PSK').asstring,true))
                 and (not kopirovani_provedeno) then
                 begin
                  ZkopirujJineSCestou(ovr1,ovr2,kontrola);
                  kopirovani_provedeno:=true;
                 end;
            if (not kopirovani_provedeno) then
              begin
               vysledek:=5;
               showmessage('Skupina  '+
                             tb_vyb.fieldByName('ODD').asstring+
                             tb_vyb.fieldByName('DIL').asstring+
                             tb_vyb.fieldByName('POR').asstring+
                             tb_vyb.fieldByName('PSK').asstring+
                             ' nen v natan databzi.');
               exit;
              end;
           end
          else
           begin
            ZkopirujPorostSCestou(ovr1,ovr2,kontrola);
           end;
        end
       else
        begin
         ZkopirujDilecSCestou(ovr1,ovr2,kontrola);
        end;
      end
     else
      begin
       zkopirujOddeleni(ovr1,Ovr2,true);
      end;
   end
 else
   begin
    vysledek:=1;
    showmessage('Z tabulky nelze natat, chyb sloupec ODD ');
   end;
end;

procedure SmazPodleRadku(Query2:TDataSet);
procedure zeptejSeASmaz(coSmazat:byte);
                                                {1 - oddeleni
                                                 2 - dilec
                                                 3 - porost
                                                 4 -skupinu}

               begin

                Application.CreateForm(TDotazf1, DotazF2);
                DotazF2.activecontrol:=DotazF2.CancelBtn;
                case coSmazat of
                1:begin
                   DotazF2.label1.caption:='Mm opravdu smazat oddlen '+Query2.fieldByName('ODD').asstring;
                   DotazF2.label2.caption:='';
                   DotazF2.showmodal;
                   if DotazF2.odpoved=true then
                    begin
                     ovr98P.smazOddeleni;
                    end;
                  end;
                2:begin
                   DotazF2.label1.caption:='Mm opravdu smazat dlec '
                   +Query2.fieldByName('ODD').asstring+Query2.fieldByName('DIL').asstring;
                   DotazF2.label2.caption:='';
                   DotazF2.showmodal;
                   if DotazF2.odpoved=true then
                   begin
                    ovr98P.smazDilec;
                    if pocetRec0(ovr98P.tb_dl) then ovr98P.smazOddeleni;
                   end;
                  end;
                3:begin
                   DotazF2.label1.caption:='Mm opravdu smazat porost '
                   +Query2.fieldByName('ODD').asstring
                   +Query2.fieldByName('DIL').asstring +Query2.fieldByName('POR').asstring;
                   DotazF2.label2.caption:='';
                   DotazF2.showmodal;
                   if DotazF2.odpoved=true then
                    begin
                     ovr98P.smazPorost;
                     if pocetRec0(ovr98P.tb_porost) then ovr98P.smazDilec;
                     if pocetRec0(ovr98P.tb_dl) then ovr98P.smazOddeleni;
                    end;
                  end;{1:}
                4:begin
                   DotazF2.label1.caption:='Mm opravdu smazat skupinu '
                   +Query2.fieldByName('ODD').asstring+' '
                   +Query2.fieldByName('DIL').asstring+' '
                   +Query2.fieldByName('POR').asstring+' '
                   +Query2.fieldByName('PSK').asstring;
                   DotazF2.label2.caption:='';
                   DotazF2.showmodal;
                   if DotazF2.odpoved=true then
                    begin
                     ovr98P.smazSkupinu;
                     if pocetRec0(ovr98P.tb_sk) then ovr98P.smazPorost;
                     if pocetRec0(ovr98P.tb_porost) then ovr98P.smazDilec;
                     if pocetRec0(ovr98P.tb_dl) then ovr98P.smazOddeleni;
                    end;
                  end;{4:}
                end;{case}
                if DotazF2.odpoved=true then
                 begin
                  Query2.close;
                  query2.open;
                  FVyber.KoordinujDruhou;
                 end;
                dotazf2.free;
               end;
begin
 if Query2.findfield('ODD')<>nil then
   begin
    if  ovr98P.hl_odd1.findText(
             Query2.fieldByName('ODD').asstring,true) then
     begin
      if Query2.findfield('DIL')<>nil then
       begin
        if  ovr98P.hl_dl1.findText(
             Query2.fieldByName('DIL').asstring,true) then
         begin
          if Query2.findfield('POR')<>nil then
           begin
            if  ovr98P.hl_porost.findText(
              Query2.fieldByName('POR').asstring,true) then
             begin
              if Query2.findfield('PSK')<>nil then
               begin
                if  ovr98P.hl_PSK.findText(
                  Query2.fieldByName('PSK').asstring,true) then
                 begin
                  zeptejSeASmaz(4{-skupina});
                 end;
               end
              else
               begin
                zeptejSeASmaz(3{-porost});
{               Application.CreateForm(TDotazf1, DotazF1);
                dotazf1.activecontrol:=dotazf1.CancelBtn;
                dotazf1.label1.caption:='Mm opravdu smazat porost '
                 +Query2.fieldByName('ODD').asstring
                 +Query2.fieldByName('DIL').asstring +Query2.fieldByName('POR').asstring;
                dotazf1.label2.caption:='';
                dotazf1.showmodal;
                if dotazf1.odpoved=true then
                 begin
                  ovr2.smazPorost;
                  Query2.close;
                  query2.open;
                  FVyber.KoordinujDruhou;
                 end;
                dotazf1.destroy; }
               end;
             end;
           end
          else
           begin
            zeptejSeASmaz(2{-dilec});
            {Application.CreateForm(TDotazf1, DotazF1);
             dotazf1.activecontrol:=dotazf1.CancelBtn;
             dotazf1.label1.caption:='Mm opravdu smazat dlec '
               +Query2.fieldByName('ODD').asstring+Query2.fieldByName('DIL').asstring;
             dotazf1.label2.caption:='';
             dotazf1.showmodal;
             if dotazf1.odpoved=true then
              begin
               ovr2.smazDilec;
               Query2.close;
               query2.open;
               FVyber.KoordinujDruhou;
              end;
             dotazf1.destroy;  }
            end;
         end
       end
      else
       begin
          zeptejSeASmaz(1{-oddeleni});
          {Application.CreateForm(TDotazf1, DotazF1);
          dotazf1.activecontrol:=dotazf1.CancelBtn;
          dotazf1.label1.caption:='Mm opravdu smazat oddlen '+Query2.fieldByName('ODD').asstring;
          dotazf1.label2.caption:='';
          dotazf1.showmodal;
          if dotazf1.odpoved=true then
           begin
            ovr2.smazOddeleni;
            Query2.close;
            query2.open;
            FVyber.KoordinujDruhou;
           end;
          dotazf1.destroy; }
       end;
     end;  { findText('ODD') }
   end;  { findfield('ODD')<>nil}
end;

begin

end.
