unit Uvybsvol;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, sp_ovr98, StdCtrls, Grids, DBGrids,
  printers_F, Printers_Util, UCasomir,
  dotaz, spZobrTable,SpsLhcP0444, E_LesOdd,
   DB, DBTables, Kfindtab,Sp_vyhso,typyDelf,mat1,inifiles;

type
  TFVybSVOL = class(TForm)
    Query1: TQuery;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    ButOdd: TButton;
    ButDl: TButton;
    ButPor: TButton;
    ButRadTisk: TButton;
    Button1: TButton;
    ButCelTab: TButton;
    ButVse: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    ComboBox1: TComboBox;
    Label3: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    ChPorost: TCheckBox;
    Label5: TLabel;
    ChNasobnost: TCheckBox;
    Label6: TLabel;
    Label7: TLabel;
    ChiDiliPor: TCheckBox;
    Label8: TLabel;
    ChMajitel: TCheckBox;
    ChDruh_Maj: TCheckBox;
    Ch_olh: TCheckBox;
    Label9: TLabel;
    Label10: TLabel;
    RBLheDleLCR: TRadioButton;
    RBLheDleObce: TRadioButton;
    RBlheNic: TRadioButton;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    ChPlDrZal: TCheckBox;
    Button3: TButton;
    Edit3: TEdit;
    ChRelBon: TCheckBox;
    Label16: TLabel;
    Label17: TLabel;
    CHZaruba: TCheckBox;
    ButPrazdStr: TButton;
    Edit4: TEdit;
    Label15: TLabel;
    Ch_Plan: TCheckBox;
    Label18: TLabel;
    ButZapi: TButton;
    ButZobrVyp: TButton;
    ButRadTiskVypis: TButton;
    StrGrDrev: TStringGrid;
    Label19: TLabel;
    Button4: TButton;
    QuNOddel: TQuery;
    QuNOddOdd: TQuery;
    QuNOddPorPSK: TQuery;
    Edinfo: TEdit;
    PrinterSetupDialog1: TPrinterSetupDialog;
    procedure ButOddClick(Sender: TObject);
    procedure ButDlClick(Sender: TObject);
    procedure ButPorClick(Sender: TObject);
    procedure ButRadTiskClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ButCelTabClick(Sender: TObject);
    procedure ButVseClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ButPrazdStrClick(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure ButZapiClick(Sender: TObject);
    procedure ButZobrVypClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButRadTiskVypisClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    bookQ1:TBookMark;
    ukonTisk:boolean;
    procedure tiskOdRadku;
    procedure NastavNAOdd(HlOdd:integer; var Nasel:boolean);
    procedure ButOddKlikni;
  end;
procedure ZobrazPodleRadkuTabulky(tb_vyb:TDataset;var vysledek:integer; infoEdit:TEdit);
procedure ZobrazPorostDoImage(
    var strana:integer;strana_pozadovana_k_tiskuI:integer;
        tiskniEvidenciLCR,tiskniEvidenciObce:boolean; infoEdit:TEdit);
procedure TiskniDilec(var strana:integer; infoEdit:TEdit);
procedure TiskniOddeleni(var strana:integer; infoEdit:TEdit);
procedure TiskniVse( infoEdit:TEdit);
procedure porostNaTiskarnu(var strana:integer;
                     strana_pozadovana_k_tiskuI:integer;
                     tiskniEvidenciLCR,tiskniEvidenciObce:boolean; infoEdit:TEdit);
procedure nactiParametry;
procedure ulozParametry;

var
   FVybSVOL   :TFVybSVOL;
   stranaI,strana_pozadovana_k_tisku_Z,pocetRadku  :integer;
   levaPrava :Byte;
   tisknoutVenkZapi:boolean; // false je tisknout svol
   prvniPorost:boolean;
   VQP0444:TQuery;
   VOddeleniSeTisklo:boolean;
implementation

{$R *.DFM}
uses SVCanvas,hkCanvas,VenkZapCanv, hkCanvOR;
procedure TiskniDilec(var strana:integer; infoEdit:TEdit);
var Bm,bmd,bmo : TBookmark;
 begin
  with ovr98 do
   begin
    tb_porost.first;
    while not tb_porost.eof do
     begin
      Bm:=tb_porost.GetBookmark;
      Bmd:=tb_dl.GetBookmark;
      BmO:=Tb_ODD.GetBookmark;
      porostNaTiskarnu(strana,0,FVybSVOL.RBLheDleLCR.checked,FVybSVOL.RBLheDleObce.checked, infoEdit);
      tb_odd.GotoBookmark(Bmo);
      tb_dl.GotoBookmark(Bmd);
      tb_porost.GotoBookmark(Bm);
      tb_odd.freeBookmark(Bmo);
      tb_dl.FreeBookmark(Bmd);
      tb_porost.FreeBookmark(Bm);
      tb_porost.next;
     end;
   end;
 end;

procedure TiskniOddeleni(var strana:integer; infoEdit:TEdit);
var Bm : TBookmark;
 begin
  with ovr98 do
   begin
    tb_dl.first;
    while not tb_dl.eof do
     begin
      Bm:=tb_dl.GetBookmark;
      tiskniDilec(strana, infoEdit);
      tb_dl.GotoBookmark(Bm);
      tb_dl.FreeBookmark(Bm);
      tb_dl.next;
     end;
   end;
 end;


 procedure TiskniVse;
 var strana:integer;
 begin
 strana:=stranaI;
  with ovr98 do
   begin
    tb_odd.first;
    while not tb_odd.eof do
     begin
      tiskniOddeleni(strana, infoEdit);
      tb_odd.next;
     end;
   end;
 end;

procedure TiskniPodleRadkuTabulky(tb_vyb:TDataset;var vysledek:integer; infoEdit:TEdit);
var strana:integer;
    dilS,PorS:string;
begin
 strana:=stranaI;
 vysledek:=0;

 if tb_vyb.findfield('ODD')=nil then
  begin
   vysledek:=1;
   showmessage('Z tabulky nelze tisknout, chyb sloupec ODD ');
   exit;
  end;
 if tb_vyb.findfield('DIL')=nil then
  begin
   dilS:=chr(ord('A')-1);
  end
 else
  begin
   DilS:=tb_vyb.findfield('DIL').asstring;
  end;
 if tb_vyb.findfield('POR')=nil then
  begin
   porS:=chr(ord('a')-1);
  end
 else
  begin
   porS:=tb_vyb.findfield('POR').asstring;
  end;
 ovr98.nastavPorost(tb_vyb.findfield('ODD').asinteger,DilS,PorS);

 if (ovr98.Tb_odd.fieldByName('ODD').asinteger<>tb_vyb.findfield('ODD').asinteger) then
  begin
   showmessage('Oddlen '+
     tb_vyb.fieldByName('ODD').asstring+
           ' nen v databzi.');
     vysledek:=2;
   exit;
  end;
 if (dilS=chr(ord('A')-1)) then
  begin
   TiskniOddeleni(strana, infoEdit );
  end
 else
  begin
   if DilS<>ovr98.Tb_dl.fieldByName('DIL').asstring then
    begin
     showmessage('Dlec '+
         tb_vyb.fieldByName('ODD').asstring+
         tb_vyb.fieldByName('DIL').asstring+
             ' nen v databzi.');
     vysledek:=3;
     exit;
    end
   else
    begin
     if porS=chr(ord('a')-1) then
      begin
       TiskniDilec(strana, infoEdit);
      end
     else
      begin
       if PorS<>ovr98.Tb_porost.fieldByName('POR').asstring then
        begin
         showmessage('Porost  '+
                     tb_vyb.fieldByName('ODD').asstring+
                     tb_vyb.fieldByName('DIL').asstring+
                     tb_vyb.fieldByName('POR').asstring+
                    ' nen v databzi.');
         vysledek:=4;
         exit;
        end
       else
        begin
         porostNaTiskarnu(strana,strana_pozadovana_k_tisku_Z,FVybSVOL.RBLheDleLCR.checked,FVybSVOL.RBLheDleObce.checked, infoEdit);
        end;
      end;
    end;
  end;
 stranaI:=strana;
 FVybSVOL.edit1.text:=Inttostr(StranaI);
 FVybSVOL.edit1.refresh;
end;

{var strana:integer;
begin
 strana:=stranaI;
 vysledek:=0;
 if tb_vyb.findfield('ODD')<>nil then
   begin
    if not ovr98.hl_odd1.findText(
             tb_vyb.fieldByName('ODD').asstring,true)
      then
        begin
          showmessage('Oddln '+
             tb_vyb.fieldByName('ODD').asstring+
             ' nen v databzi.');
          vysledek:=2;
          exit;
        end;
     if tb_vyb.findfield('DIL')<>nil then
      begin
       if not ovr98.hl_dl1.findText(
              tb_vyb.fieldByName('DIL').asstring
                  ,true)
        then
         begin
          showmessage('Dlec '+
             tb_vyb.fieldByName('ODD').asstring+
             tb_vyb.fieldByName('DIL').asstring+
             ' nen v databzi.');
          vysledek:=3;
          exit;
         end;
       if tb_vyb.findfield('POR')<>nil then
        begin
         if not ovr98.hl_porost.findText(
                  tb_vyb.fieldByName('POR').asstring,true)
            then
             begin
                showmessage('Porost  '+
                             tb_vyb.fieldByName('ODD').asstring+
                             tb_vyb.fieldByName('DIL').asstring+
                             tb_vyb.fieldByName('POR').asstring+
                             ' nen v databzi.');
              vysledek:=4;
              exit;
             end
          else
           begin
            porostNaTiskarnu(strana,strana_pozadovana_k_tisku_Z,FVybSVOL.RBLheDleLCR.checked,FVybSVOL.RBLheDleObce.checked);
           end;
        end
       else
        begin
         TiskniDilec(strana);
        end;
      end
     else
      begin
       TiskniOddeleni(strana);
      end;
   end
 else
   begin
    vysledek:=1;
    showmessage('Z tabulky nelze tisknout, chyb sloupec ODD ');
   end;
 stranaI:=strana;
 FVybSVOL.edit1.text:=Inttostr(StranaI);
 FVybSVOL.edit1.refresh;
end;
}
procedure ZobrazPodleRadkuTabulky(tb_vyb:TDataset;var vysledek:integer; infoEdit:TEdit);
var strana:integer;
begin
 strana:=stranaI;
 vysledek:=0;

 if tb_vyb.findfield('ODD')=nil then
  begin
   vysledek:=1;
   showmessage('V tabulce "Vbr" chyb polko "ODD"');
   exit;
  end;
 if tb_vyb.findfield('DIL')=nil then
  begin
   vysledek:=1;
   showmessage('V tabulce "Vbr" chyb polko "DIL"');
   exit;
  end;
 if tb_vyb.findfield('POR')=nil then
  begin
   vysledek:=1;
   showmessage('V tabulce "Vbr" chyb polko "POR"');
   exit;
  end;
 ovr98.nastavPorost(tb_vyb.findfield('ODD').asinteger,
                  tb_vyb.findfield('DIL').asstring,
                  tb_vyb.findfield('POR').asstring);

 if (ovr98.Tb_odd.fieldByName('ODD').asinteger<>tb_vyb.findfield('ODD').asinteger) then
  begin
   showmessage('Oddln '+
             tb_vyb.fieldByName('ODD').asstring+
             ' nen v databzi.');
   vysledek:=2;
   exit;
  end;
 if (ovr98.Tb_dl.fieldByName('DIL').asstring<>tb_vyb.findfield('DIL').asstring) then
  begin
   showmessage('Dlec '+
           tb_vyb.fieldByName('ODD').asstring+
           tb_vyb.fieldByName('DIL').asstring+
           ' nen v databzi.');
   vysledek:=3;
   exit;
  end;
 if (ovr98.Tb_Porost.fieldByName('POR').asstring<>tb_vyb.findfield('POR').asstring) then
  begin
   showmessage('Porost  '+
                           tb_vyb.fieldByName('ODD').asstring+
                           tb_vyb.fieldByName('DIL').asstring+
                           tb_vyb.fieldByName('POR').asstring+
                           ' nen v databzi.');
   vysledek:=4;
   exit;
  end;
  ZobrazPorostDoImage(strana,strana_pozadovana_k_tisku_Z,
                FVybSVOL.RBLheDleLCR.checked,FVybSVOL.RBLheDleObce.checked, infoEdit );
end;



{
var strana:integer;
begin
 strana:=stranaI;
 vysledek:=0;
 if tb_vyb.findfield('ODD')=nil then
  begin
   vysledek:=1;
   showmessage('V tabulce "Vbr" chyb polko "ODD"');
   exit;
  end
 else
  begin
   if not ovr98.hl_odd1.findText(
             tb_vyb.fieldByName('ODD').asstring,true) then
    begin
     showmessage('Oddln '+
             tb_vyb.fieldByName('ODD').asstring+
             ' nen v databzi.');
     vysledek:=2;
     exit;
    end;
  end;
 if tb_vyb.findfield('DIL')=nil then
  begin
   vysledek:=1;
   showmessage('V tabulce "Vbr" chyb polko "DIL"');
   exit;
  end
 else
  begin
   if not ovr98.hl_dl1.findText(
              tb_vyb.fieldByName('DIL').asstring,true) then
    begin
     showmessage('Dlec '+
             tb_vyb.fieldByName('ODD').asstring+
             tb_vyb.fieldByName('DIL').asstring+
             ' nen v databzi.');
     vysledek:=3;
     exit;
    end;
  end;
 if tb_vyb.findfield('POR')=nil then
  begin
   vysledek:=1;
   showmessage('V tabulce "Vbr" chyb polko "POR"');
   exit;
  end
 else
  begin
   if not ovr98.hl_porost.findText(
              tb_vyb.fieldByName('POR').asstring,true) then
    begin
     showmessage('Porost  '+
                             tb_vyb.fieldByName('ODD').asstring+
                             tb_vyb.fieldByName('DIL').asstring+
                             tb_vyb.fieldByName('POR').asstring+
                             ' nen v databzi.');
     vysledek:=4;
     exit;
    end;
  end;
  ZobrazPorostDoImage(strana,strana_pozadovana_k_tisku_Z,
                FVybSVOL.RBLheDleLCR.checked,FVybSVOL.RBLheDleObce.checked);
end;
}

procedure porostNaTiskarnu(var strana:integer;
                     strana_pozadovana_k_tiskuI:integer;
                     tiskniEvidenciLCR,tiskniEvidenciObce:boolean; infoEdit:TEdit);
var PXI,PYI:integer;
   tiskseUskutecnil:Boolean;
begin
tiskseUskutecnil:=true;
with FCanvas do
begin
with printer do
 begin
 pyi:=round(printer.PageWidth*1.15);
 pxi:=printer.PageHeight;
 if tisknoutVenkZapi then
  begin
   tiskPorostVenkZapi(Strana,strana_pozadovana_k_tiskuI,
                       Canvas,PXi,PYi,
                       true,
                       pocetRadku,prvniPorost,VQP0444,tiskseUskutecnil, infoEdit);
   if tiskseUskutecnil then VOddeleniSeTisklo:=true;
  end
 else
  begin
   tiskPorostSVOL(Strana,strana_pozadovana_k_tiskuI,
                  FVybSVOL.CHMajitel.checked,
                  FVybSVOL.CHNasobnost.checked,
                  FVybSVOL.CHPorost.checked,
                  FVybSVOL.CHIDilIPor.checked,
                  true,tiskniEvidenciLCR,tiskniEvidenciObce,
                  levaprava,Canvas,PXi,PYi,
                  FVybSVOL.CHDruh_maj.checked,
                  FVybSVOL.CH_OLH.checked,
                  FVybSVOL.CHPlDrZal.checked,
                  FVybSVOL.CHRelBon.checked,
                  FVybSVOL.CHZaruba.checked,
                  FVybSVOL.CH_Plan.checked,
                  pocetRadku,
                  ubm(FVybSVOL.StrGrDrev.cells[0,0]),
                  ubm(FVybSVOL.StrGrDrev.cells[0,1]),
                  ubm(FVybSVOL.StrGrDrev.cells[0,2]),
                  ubm(FVybSVOL.StrGrDrev.cells[0,3]));
  end;
  if tiskseUskutecnil then prvniPorost:=false;
 end;
end;
end;
procedure ZobrazPorostDoImage(var Strana:integer;strana_pozadovana_k_tiskuI:integer;
                                  tiskniEvidenciLCR,tiskniEvidenciObce:boolean; infoEdit:TEdit);
var mxi,myi:integer;
    tiskseUskutecnilNaNic:Boolean;
begin

with FCanvOr do
 begin
  WindowState:=wsMaximized;
  mxi:=round(screen.width*1.5);
  myi:=round(screen.height*1.5);
  Image1.picture.bitmap.Width:=image1.width;
  Image1.picture.bitmap.height:=image1.height;
  Image1.picture.bitmap.canvas.fillrect(
         rect(0,0,image1.width,image1.height));
 if tisknoutVenkZapi then
  begin
   tiskPorostVenkZapi(Strana,strana_pozadovana_k_tiskuI,
                       Image1.picture.bitmap.canvas,MXi,MYi,
                       false,
                       pocetRadku,prvniPorost,VQP0444,tiskseUskutecnilNaNic, infoEdit);
  end
 else
  begin
   tiskPorostSVOL(Strana,strana_pozadovana_k_tiskuI,
            FVybSVOL.CHMajitel.checked,
            FVybSVOL.CHNasobnost.checked,
            FVybSVOL.CHPorost.checked,
            FVybSVOL.CHIDilIPor.checked,
            false,tiskniEvidenciLCR,tiskniEvidenciObce,
            levaprava,Image1.picture.bitmap.canvas,MXi,MYi,
            FVybSVOL.CHDruh_maj.checked,
            FVybSVOL.CH_OLH.checked,
            FVybSVOL.CHPlDrZAl.checked,
            FVybSVOL.CHRelBon.checked,
            FVybSVOL.CHZaruba.checked,
            FVybSVOL.CH_Plan.checked,
            pocetRadku,
            ubm(FVybSVOL.StrGrDrev.cells[0,0]),
            ubm(FVybSVOL.StrGrDrev.cells[0,1]),
            ubm(FVybSVOL.StrGrDrev.cells[0,2]),
            ubm(FVybSVOL.StrGrDrev.cells[0,3]));
  end;
 image1.refresh;
 showmodal;
 end;
end;


procedure TFVybSVOL.ButOddClick(Sender: TObject);
 begin
  ButOddKlikni;
 end;
procedure TFVybSVOL.ButOddKlikni;
begin
 query1.close;
 query1.databasename:='DB_tx98';
 query1.SQL.clear;
 query1.SQL.add('select odd from oddeleni');
 query1.SQL.add('order by odd ');
 query1.open;
end;
procedure TFVybSVOL.NastavNAOdd(HlOdd:integer; var Nasel:boolean);
 begin
  query1.first;
  while not ((query1.fieldByName('Odd').asinteger=hlOdd)or(query1.eof)) do
   begin
    Query1.next;
   end;
  if (query1.fieldByName('Odd').asinteger=hlOdd) then Nasel:=true else Nasel:=false;
 end;
{ SELECT * FROM CITIES C, STATES S, MAYORS M
	WHERE C.CITY = M.CITY AND C.STATE = M.STATE }

procedure TFVybSVOL.ButDlClick(Sender: TObject);
begin
 query1.close;
 query1.databasename:='DB_tx98';
 query1.SQL.clear;
 query1.SQL.add('select O.odd,D.dil from oddeleni O,dilec D ');
 query1.SQL.add('where O.ID=D.vazba');
 query1.SQL.add('order by O.odd,D.dil ');
 query1.open;
end;

procedure TFVybSVOL.ButPorClick(Sender: TObject);
begin
 query1.close;
 query1.databasename:='DB_tx98';
 query1.SQL.clear;
 query1.SQL.add('select O.odd,D.dil,P.por from oddeleni O,dilec D,porost P ');
 query1.SQL.add('where (O.ID=D.vazba)and(D.ID=P.vazba)');
 query1.SQL.add('order by O.odd,D.dil,P.Por ');
 query1.open;
end;


procedure TFVybSVOL.ButRadTiskClick(Sender: TObject);
var vysledek:integer;
begin
 tisknoutVenkZapi:=false; //svol
 PrinterSetupDialog1.execute;
 SetPrinterByPrinters;
 with printer do
  begin
   if not printing then
    begin
     Orientation := poPortrait;
     beginDoc;
    end;
  end;
 TiskniPodleRadkuTabulky(Query1,vysledek,Edinfo);
 if (printer.printing)and(ukonTisk) then printer.enddoc;
end;
procedure TFVybSVOL.Button1Click(Sender: TObject);
var NazSoub,NazSoub1:string;
begin
Application.CreateForm(TS_VyhlSoub1, S_VyhlSoub1);

S_VyhlSoub1.fileListBox1.mask :='*.*';

S_VyhlSoub1.showmodal;
if S_VyhlSoub1.Vybrano then
 begin
 DBGrid1.onDrawDataCell:=nil;
 query1.close;
 query1.databasename:=S_VyhlSoub1.FileListBox1.directory;
 nazSoub:=Copy(S_VyhlSoub1.FileListBox1.fileName,
               length(S_VyhlSoub1.FileListBox1.directory)+2,
               length(S_VyhlSoub1.FileListBox1.fileName)-
               (length(S_VyhlSoub1.FileListBox1.directory)+1));
 nazSoub1:=copy(nazSoub,1,pos('.',nazsoub)-1);
 query1.SQL.clear;
 query1.SQL.add('select * from '+nazsoub1);
 query1.open;
 end;
 S_VyhlSoub1.free;
end;

procedure TFVybSVOL.ButCelTabClick(Sender: TObject);
var vysledek:integer;
begin
 tisknoutVenkZapi:=false; //svol
 PrinterSetupDialog1.execute;
 SetPrinterByPrinters;
 with printer do
  begin
   if not printing then
    begin
     Orientation := poPortrait;
     beginDoc;
    end;
  end;
 Query1.first;
 while not query1.eof do
  begin
   TiskniPodleRadkuTabulky(Query1,vysledek,Edinfo);
   if vysledek=1 then exit;
   query1.next;
  end;
 if (printer.printing)and(ukonTisk) then printer.enddoc;
end;

procedure TFVybSVOL.ButVseClick(Sender: TObject);
begin
 tisknoutVenkZapi:=false; //svol
 PrinterSetupDialog1.execute;
 SetPrinterByPrinters;

 with printer do
  begin
   if not printing then
    begin
     Orientation := poPortrait;
     beginDoc;
    end;
  end;
 tiskniVse(Edinfo);
 if (printer.printing)and(ukonTisk) then printer.enddoc;
end;

procedure TFVybSVOL.Button2Click(Sender: TObject);
var vysledek:integer;
begin
 tisknoutVenkZapi:=false; //svol
 ZobrazPodleRadkuTabulky(Query1,vysledek,Edinfo);
end;

procedure TFVybSVOL.FormCreate(Sender: TObject);
begin
 pocetRadku:=6;
 stranaI:=0;
 strana_pozadovana_k_tisku_Z:=0;
 levaPrava:=1;
 ComboBox1.itemindex:=levaPrava;
 comboBox1.text:=ComboBox1.items[ComboBox1.itemindex];
 StrGrDrev.Cells[0,0]:='SM';
 StrGrDrev.Cells[0,1]:='BO';
 StrGrDrev.Cells[0,2]:='BK';
 StrGrDrev.Cells[0,3]:='DB';
{with printer do
 begin
 Orientation := poLandscape;
 pxi:=round(GetDeviceCaps(Printer.Handle, LOGPIXELSX)*1.15);
 pyi:=GetDeviceCaps(Printer.Handle, LOGPIXELSY);
 pxi:=round(printer.PageWidth*1.15);
 pyi:=printer.PageHeight;
 beginDoc;
 end;  }
end;

procedure TFVybSVOL.Edit1Change(Sender: TObject);
begin
if (edit1.text='')or(edit1.text=' ')or(edit1.text='  ') then
  begin
   stranaI:=1;
  end
else
begin
try
 stranaI:=strtoint(edit1.text);
except
 on EConvertError do
    begin
     showmessage('Stranu lze zadavat pouze arabskmi slicemi.');
     edit1.text:='1';
    end;
end;
end;
end;

procedure TFVybSVOL.ComboBox1Change(Sender: TObject);
begin
 levaprava:=ComboBox1.itemindex;
end;

procedure TFVybSVOL.Edit2Change(Sender: TObject);
begin
if (edit2.text='')or(edit2.text=' ')or(edit2.text='  ') then
  begin
   strana_pozadovana_k_tisku_Z:=0;
  end
else
begin
try
 strana_pozadovana_k_tisku_Z:=strtoint(edit2.text);
except
 on EConvertError do
    begin
     showmessage('Stranu lze zadavat pouze arabskmi slicemi.');
     edit2.text:='0';
    end;
end;
end;
end;
procedure TFVybSVOL.Button3Click(Sender: TObject);
begin
 tisknoutVenkZapi:=false; //svol
 tiskOdRadku;
end;
procedure TFVybSVOL.tiskOdRadku;
var im,i:integer;
    vysledek:integer;
begin
 // tisknoutVenkZapi:=false; //svol
 PrinterSetupDialog1.execute;
 SetPrinterByPrinters;

 with printer do
  begin
   if not printing then
    begin
     Orientation := poPortrait;
     beginDoc;
    end;
  end;
 IM:=strtoint(edit3.text);
 VZapiOdd:=nil;
 if IM=0 then
  begin
   while not query1.eof do
    begin
     TiskniPodleRadkuTabulky(Query1,vysledek,Edinfo);
     if vysledek=1 then exit;
     query1.next;
    end;
  end
 else
  begin
   for i:=1  to IM do
    begin
     // zapniCas;
     TiskniPodleRadkuTabulky(Query1,vysledek,Edinfo);
     if vysledek=1 then exit;
     // vypniCas;
     // showmessage('CAS='+CAS);
     query1.next;
    end;
  end;
 if (printer.printing)and(ukonTisk) then printer.enddoc;
end;

procedure TFVybSVOL.ButPrazdStrClick(Sender: TObject);
begin
 PrinterSetupDialog1.execute;
 SetPrinterByPrinters;
 with printer do
  begin
   if not printing then
    begin
     Orientation := poPortrait;
     beginDoc;
    end;
   newpage;
  end;
end;

procedure TFVybSVOL.Edit4Change(Sender: TObject);
begin
if (edit4.text='')or(edit4.text=' ')or(edit4.text='  ') then
  begin
   pocetRadku:=6;
  end
else
begin
try
 pocetRadku:=strtoint(edit4.text);
except
 on EConvertError do
    begin
     showmessage('Stranu lze zadvat pouze arabskmi slicemi.');
     edit4.text:='6';
    end;
end;
end;
end;

procedure TFVybSVOL.ButZapiClick(Sender: TObject);
begin
 tisknoutVenkZapi:=true;
 prvniPorost:=true;
 tiskOdRadku;
end;

procedure TFVybSVOL.ButZobrVypClick(Sender: TObject);
var vysledek:integer;
begin
 VQP0444:=nil;
 prvniPorost:=true;
 tisknoutVenkZapi:=true; //vypis
 ZobrazPodleRadkuTabulky(Query1,vysledek,Edinfo);
end;

procedure TFVybSVOL.FormShow(Sender: TObject);
begin
 nactiParametry;
 ButPorClick(sender);
end;

procedure TFVybSVOL.ButRadTiskVypisClick(Sender: TObject);
var vysledek:integer;
begin
 VQP0444:=nil;
 tisknoutVenkZapi:=true; //svol
 prvniPorost:=true;
 PrinterSetupDialog1.execute;
 SetPrinterByPrinters;
 with printer do
  begin
   if not printing then
    begin
     Orientation := poPortrait;
     beginDoc;
    end;
  end;
 TiskniPodleRadkuTabulky(Query1,vysledek,Edinfo);
 if (printer.printing)and(ukonTisk) then printer.enddoc;
end;
Procedure NactiParametry;
var
 initext:TIniFile;
 psp:string;
  begin
   psp:=Ovr98.Db_ph98.params[0];
   psp:=copy(psp,Pos('=',psp)+1,length(psp)-Pos('=', psp));
   initext:=Tinifile.create(psp+'\PHS.ini');
  FVybSVOL.StrGrDrev.Cells[0,0]:=initext.readString('Hosp_Kniha_SVOL','DrevEvid1','SM');
  FVybSVOL.StrGrDrev.Cells[0,1]:=initext.readString('Hosp_Kniha_SVOL','DrevEvid2','BO');
  FVybSVOL.StrGrDrev.Cells[0,2]:=initext.readString('Hosp_Kniha_SVOL','DrevEvid3','BK');
  FVybSVOL.StrGrDrev.Cells[0,3]:=initext.readString('Hosp_Kniha_SVOL','DrevEvid4','DB');
  end;
Procedure ulozParametry;
var
 initext:TIniFile;
 psp:string;
  begin
   psp:=Ovr98.Db_ph98.params[0];
   psp:=copy(psp,Pos('=',psp)+1,length(psp)-Pos('=', psp));
   initext:=Tinifile.create(psp+'\PHS.ini');
   initext.writeString('Hosp_Kniha_SVOL','DrevEvid1',FVybSVOL.StrGrDrev.Cells[0,0]);
   initext.writeString('Hosp_Kniha_SVOL','DrevEvid2',FVybSVOL.StrGrDrev.Cells[0,1]);
   initext.writeString('Hosp_Kniha_SVOL','DrevEvid3',FVybSVOL.StrGrDrev.Cells[0,2]);
   initext.writeString('Hosp_Kniha_SVOL','DrevEvid4',FVybSVOL.StrGrDrev.Cells[0,3]);

{   FVybSVOL.StrGrDrev.Cells[0,0]:=initext.readString('Hosp_Kniha_SVOL','DrevEvid1','SM');
   FVybSVOL.StrGrDrev.Cells[0,1]:=initext.readString('Hosp_Kniha_SVOL','DrevEvid2','BO');
   FVybSVOL.StrGrDrev.Cells[0,2]:=initext.readString('Hosp_Kniha_SVOL','DrevEvid3','BK');
   FVybSVOL.StrGrDrev.Cells[0,3]:=initext.readString('Hosp_Kniha_SVOL','DrevEvid4','DB');
}
  end;
procedure TFVybSVOL.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 ulozParametry;
end;

procedure TFVybSVOL.Button4Click(Sender: TObject);
var
  SNODD,sAdrAJmenoP0444:string;
  iVOdd, vysledek, iNxt,ilhc:integer;
  NaselOdd, tisklose :boolean;
  seznLhcP0444:TNasobny_LongIntMN;
  VLhcP0444:TNasobny_LongInt;
  nasLHCStr:string;
function LhcOrZLongIntu:string;
var
 i:Integer;
 begin
  result:='';
  for i:=0 to seznLhcP0444.count-1 do
   begin
    result:=result+'or(LHC='+inttostr(TNasobny_LongInt(seznLhcP0444.Elements[i]).CISLO_LongInt)+')';
   end;
  if result<>'' then
   begin
    Result:=copy(result,3,length(result)-2);
    result:='('+result+')';
   end;
 end;


begin
 Application.CreateForm ( TFSpsLhcP0444, FSpsLhcP0444);
 FSpsLhcP0444.StringGrid1.ColWidths[0]:=FSpsLhcP0444.StringGrid1.Width-25;
 FSpsLhcP0444.showmodal;
 if FSpsLhcP0444.odpoved then
  begin
   seznLhcP0444:=TNasobny_LongIntMN.create;
   for ilhc:=0 to FSpsLhcP0444.StringGrid1.RowCount-1 do
    begin
     if vyberJenCisla(FSpsLhcP0444.StringGrid1.cells[0,ilhc])<>''  then
      begin
       VLhcP0444:=TNasobny_LongInt.create;
       VLhcP0444.CISLO_LongInt:=StrToint0 (vyberJenCisla(FSpsLhcP0444.StringGrid1.cells[0,ilhc]));
       seznLhcP0444.AddElement(VLhcP0444);
      end;
    end;
   nasLHCStr:=LhcOrZLongIntu;
   FSpsLhcP0444.free;
  end
 else
  begin
   FSpsLhcP0444.free;
   exit;
  end;
// showmessage(nasLHCStr);
// exit;
 Application.CreateForm(TS_VyhlSoub1, S_VyhlSoub1);
 S_VyhlSoub1.Caption:='Vyber soubor prekryvu P0444.DBF';
 S_VyhlSoub1.ButNovAdr.Visible:=false;
 S_VyhlSoub1.fileListBox1.mask := '*.dbf';
 S_VyhlSoub1.showmodal;
 if S_VyhlSoub1.Vybrano then
  begin
   sAdrAJmenoP0444:=S_VyhlSoub1.FileListBox1.FileName;
   S_VYHLSOUB1.Free;
  end
 else
  begin
   S_VYHLSOUB1.Free;
   exit;
  end;
 // sAdrAJmenoP0444:='C:\DATAMoje\gregor\ZmenRozdel\P0444.DBF';
 VQP0444:=QuNOddPorPSK;
 ButOddKlikni;
 tisknoutVenkZapi:=true;
 prvniPorost:=true;
 VOddeleniSeTisklo:=false;
 PrinterSetupDialog1.execute;
 SetPrinterByPrinters;
 with printer do
  begin
   if not printing then
    begin
     Orientation := poPortrait;
     beginDoc;
    end;
  end;


    with QuNOddel.SQL do
     begin
      clear;
      add('select NOddeleni from '''+sAdrAJmenoP0444+'''');
      if  nasLHCStr<>'' then
       begin
        add('where '+nasLHCStr);
       end;
      // showmessage('select NOddeleni from '''+sAdrAJmenoP0444+'''');
      add('group by NOddeleni');
      add('order by NOddeleni');
     end;
//  ZobrazQuery(QuNOddel);
 QuNOddel.open;
 QuNOddel.first;
 iNxt:=0;
 while not QuNOddel.Eof do
 // while inxt<4 do
  begin
   tisklose:=False;
   inc(Inxt);
   SNODD:=QuNOddel.fieldbyname('NOddeleni').AsString;
   if strtoint0(SNODD)>0 then
    begin
     with QuNOddOdd.SQL do
      begin
       clear;
       add('select NOddeleni,oddeleni from '''+sAdrAJmenoP0444+'''');
       if  nasLHCStr='' then
        begin
         add('where NOddeleni= '+SNODD);
        end
       else
        begin
          add('where ( NOddeleni= '+SNODD+') and ' + nasLHCStr);
        end;
       add('group by NOddeleni,oddeleni ');
       add('order by NOddeleni,oddeleni ');
      end;
     QuNOddOdd.open;
     QuNOddOdd.first;
     while not QuNOddOdd.Eof do
      begin
       iVOdd:=strtoint0(QuNOddOdd.fieldbyname('Oddeleni').AsString);
       if iVOdd>0 then
        begin
         NastavNAOdd(iVOdd,NaselOdd);
         if naselODD then
          begin
           with QuNOddPorPSK.SQL do
            begin
             clear;
             add('select NOddeleni,oddeleni,dilec,porost,skupina,Ndilec,Nporost  from '''+sAdrAJmenoP0444+'''');
             add('where ((NOddeleni= '+SNODD+')and(Oddeleni= '+inttostr(iVOdd)+'))');
           //  add('select NOddeleni,Ndilec,Nporost,oddeleni,dilec,porost,skupina  from '''+sAdrAJmenoP0444+'''');
           //  add('where ((NOddeleni= '+SNODD+')and(Oddeleni= '+inttostr(iVOdd)+'))');
           //  add('order by NOddeleni,Oddeleni,Ndilec,Nporost');
             if  nasLHCStr<>'' then
              begin
               add(' and '+nasLHCStr);
              end;
             add('order by NOddeleni,oddeleni,dilec,porost,skupina ');
            end;
           QuNOddPorPSK.open;
           QuNOddPorPSK.first;
           Edinfo.Text:= inttostr(iNxt)+' , '+SNODD+' , '+inttostr(iVOdd);
           Edinfo.Refresh;
           // ZobrazQuery(QuNOddPorPSK);
           NastavNAOdd(iVOdd,NaselOdd);
           // showmessage('SNODD='+SNODD+'   iVOdd='+inttostr(iVOdd));
           TiskniPodleRadkuTabulky(Query1,vysledek,Edinfo);
           tisklose:=true;
          end;
        end;
       QuNOddOdd.next;
      //  if not QuNOddOdd.eof  then Printer.NewPage
      end;
     // ZobrazQuery(QuNOddOdd);
    end;
   QuNOddel.next;
   if (tisklose and (not QuNOddel.eof) and (strtoint0(SNODD)>0)) then
    begin
     if VOddeleniSeTisklo then
      begin
       VOddeleniSeTisklo:=false;
       with printer do
        begin
          // bacha
           EndDoc;
           Orientation := poPortrait;
           beginDoc;
         //  NewPage;
         tisknoutVenkZapi:=true;
         prvniPorost:=true;
        end;
      end;
    end;
  end;
 printer.EndDoc;
 VQP0444:=nil;
 showmessage(' hotovo ');
end;

initialization
 VQP0444:=nil;
end.
