unit sp_vyhSoHel;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, FileCtrl, Buttons,
  ELesObec,E_Class,  Dotaz,
  dotazZad, mat1, ExtCtrls, Grids, u_Zobraz, Db, DBTables;

type

TZdroje   = class(TObecnyLesniPrvek)
private
 FLHC_KOD   :integer;
 FLHC_NAZ   :string;
 FZDROJ_ADR :string;
 FMDateTime :TDateTime;
 function getSDateTime:String;
 function getDateTimeJakoFloat:double;
public
published
 property  LHC_KOD   :integer         read FLHC_KOD   write FLHC_KOD;
 property  LHC_NAZ   :string          read FLHC_NAZ   write FLHC_NAZ;
 property  ZDROJ_ADR :string          read FZDROJ_ADR write FZDROJ_ADR;
 property  MDateTime :TDateTime       read FMDateTime write FMDateTime;
 property  SDateTime :String               read getSDateTime  stored false;
 property  DateTimeJakoMinusFloat :double  read getDateTimeJakoFloat  stored false;

end;

TZdrojeMN  = class(TLesniMnozina)
private
public
  constructor Create; override;
end;

  TS_VyhlSoHel = class(TForm)
    Panel1: TPanel;
    DriveComboBox1: TDriveComboBox;
    ButNovAdr: TButton;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Panel2: TPanel;
    Edit1: TEdit;
    Panel3: TPanel;
    FileListBox1: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    Table1: TTable;
    ButUbRad: TButton;
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure DriveComboBox1Change(Sender: TObject);
    procedure ButAliasClick(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure ButNovAdrClick(Sender: TObject);
    procedure ButCopFileClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
     vybrano:Boolean;
     procedure RePaint; override;
     procedure stGrmZdrojeClick(Sender: TObject);
  published
  end;

var
  S_VyhlSoHel: TS_VyhlSoHel;

implementation

{$R *.DFM}


procedure TS_VyhlSoHel.OKBtnClick(Sender: TObject);
var VZdroje :TZdroje;
begin
 vybrano:=true;
end;
function TZdroje.getDateTimeJakoFloat:double;
 begin
  result:=-Mdatetime;
 end;

function TZdroje.getSDateTime:String;
 begin
  result:={TimeToStr(FMDateTime)+'  '+}  DateTimeToStr(FMDateTime);
 end;

procedure TS_VyhlSoHel.CancelBtnClick(Sender: TObject);
begin
 vybrano:=false;
 close;
end;

procedure TS_VyhlSoHel.DirectoryListBox1Change(Sender: TObject);
 begin
  DriveComboBox1.OnChange:=nil;
  DriveComboBox1.Drive:=DirectoryListBox1.Drive;
  DriveComboBox1.OnChange:=DriveComboBox1Change;
  filelistBox1.Directory:=DirectoryListBox1.Directory;
  edit1.text:=filelistBox1.Directory;
  edit1.refresh;
 end;

procedure TS_VyhlSoHel.FormActivate(Sender: TObject);
 begin
  vybrano:=false;
 end;

procedure TS_VyhlSoHel.DriveComboBox1Change(Sender: TObject);
 begin
  DirectoryListBox1.Drive:=DriveComboBox1.Drive;
 end;

procedure TS_VyhlSoHel.ButAliasClick(Sender: TObject);
 begin
  Vybrano := true;
  close;
 end;

procedure TS_VyhlSoHel.FileListBox1Change(Sender: TObject);
begin
  edit1.text:=filelistBox1.FileName;
  edit1.refresh;
end;

procedure TS_VyhlSoHel.ButNovAdrClick(Sender: TObject);
var
 Adr_xml,Adr_PHS:string;
begin
 Application.CreateForm(TFdotazZad,FdotazZad);
 FdotazZad.caption:='Vyhledn etzce';
 FdotazZad.label1.caption:='Zadej nzev novho adrese:';
 FdotazZad.label2.caption:='';
 FdotazZad.Label3.caption:='';
 FdotazZad.Label4.caption:='';
 FdotazZad.edit2.Visible:=false;
 FdotazZad.CheckBox1.Visible:=false;
 FdotazZad.Edit1.Text:='zdroj';
 FdotazZad.ActiveControl:=FdotazZad.Edit1;
 FdotazZad.showModal;
 if FdotazZad.odpoved=false then
  begin
   FdotazZad.free;
   exit;
  end;
 Adr_xml:=trim(FdotazZad.Edit1.Text);
 FdotazZad.free;

  Adr_xml:=DirectoryListBox1.Directory+'/'+Adr_xml;
  ForceDirectories(Adr_xml);
  if DirectoryExists(Adr_xml) then
   begin
    if not SetCurrentDir(Adr_xml) then
     begin
      exit;
     end
    else
     begin
      DirectoryListBox1.Directory:=Adr_xml;
      refresh;
     end;
   end;
end;

procedure TS_VyhlSoHel.ButCopFileClick(Sender: TObject);
var
  odkud, kam :Pchar;
begin
  odkud:='C:\DATAMoje\Babka\Babka.zip';
  kam:='C:\DATAMoje\kukuc.zip';
  copyfile(odkud, kam,false);
end;
function najdiVolnyNazevAdresare(Nazev:string):string;
var i:integer;
 begin
  i:=1;
  while DirectoryExists(nazev+'('+inttostr(i)+')') do
   begin
    inc(i);
   end;
  result:=nazev+'('+inttostr(i)+')';
 end;
constructor TZdrojeMN.Create;
 begin
  inherited create;
  FClass:=TZdroje;
  FPredponaName:='Zdroje';
 end;

procedure TS_VyhlSoHel.RePaint;
 begin
  inherited repaint;
 end;

procedure TS_VyhlSoHel.stGrmZdrojeClick(Sender: TObject);
begin
end;

initialization

end.
