unit dotazComb;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls;

type
  TFdotazComb = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ButAnoVsem: TButton;
    ButNeVsem: TButton;
    ComboBox1: TComboBox;
    Label4: TLabel;
    RadioGroup1: TRadioGroup;
    RadButAB: TRadioButton;
    RadButC: TRadioButton;
    Label5: TLabel;
    EdDrev: TEdit;
    Label6: TLabel;
    procedure OKBtnClick      (Sender: TObject);
    procedure CancelBtnClick  (Sender: TObject);
    procedure FormShow        (Sender: TObject);
    procedure FormClose       (Sender: TObject;
                                 var Action: TCloseAction);
    procedure ButAnoVsemClick (Sender: TObject);
    procedure ButNeVsemClick  (Sender: TObject);
  private
    { Private declarations }
  public
    odpoved:boolean;
    vsem:boolean;
    { Public declarations }
  end;

var
  FdotazComb: TFdotazComb;

implementation

{$R *.DFM}

procedure TFdotazComb.OKBtnClick(Sender: TObject);
 begin
  vsem:=false;
  odpoved:=true;
  close;
 end;

procedure TFdotazComb.CancelBtnClick(Sender: TObject);
begin
 odpoved:=false;
 vsem:=false;
 close;
end;

procedure TFdotazComb.FormShow(Sender: TObject);
begin
 odpoved:=false;
 vsem:=false;
end;

procedure TFdotazComb.FormClose(Sender: TObject; var Action: TCloseAction);
 begin
  Application.ProcessMessages;
 end;

procedure TFdotazComb.ButAnoVsemClick(Sender: TObject);
begin
  vsem:=true;
  odpoved:=true;
  close;
end;

procedure TFdotazComb.ButNeVsemClick(Sender: TObject);
begin
  vsem:=true;
  odpoved:=false;
  close;
end;

end.
