unit EHledAChyb;

interface
uses
  Elements, E_Type, Math,  U_string, E_Class, StdCtrls, fileCtrl, DB, DBTables,
  dialogs, forms, Graphics, Windows, Messages, SysUtils, IniFiles,
  ELesObec, mat1,
  Dotaz, classes;


type
 SPozadovaneNacteniZLedu=(PLOCHAdoPlocha0PSK,VYMERAdoVymeraPSK,PLOCHAdoPlocha0BZL,VYMERAdoVymeraBZL,
                          PLOCHAdoPlocha0JP ,VYMERAdoVymeraJP ,PLOCHAdoPlocha0OST,VYMERAdoVymeraOST,
                          MAJ_KODdoMAJ_KOD  ,MAJ_DRUHdoMAJ_DRUH,
                          KVAL_PdoPSK_KVAL_Vypocet1,KVAL_PdoBZL_KVAL_Vypocet,KVAL_PdoJP_KVAL_Vypocet,KVAL_PdoOST_KVAL_Vypocet,
                          KU_KODdoKU_KODPSK,KU_KODdoORPzKU6PSK,SK_PARCdoSKUPPARCPSK,KATPAR_KODdoPOT_VLASTPSK,
                          KU_KODdoKU_KODBZL,KU_KODdoORPzKU6BZL,SK_PARCdoSKUPPARCBZL,KATPAR_KODdoPOT_VLASTBZL,
                          KU_KODdoKU_KODJP,KU_KODdoORPzKU6JP,SK_PARCdoSKUPPARCJP,KATPAR_KODdoPOT_VLASTJP,
                          KU_KODdoKU_KODOST,KU_KODdoORPzKU6OST,SK_PARCdoSKUPPARCOST,KATPAR_KODdoPOT_VLASTOST,
                          ZVL_STATUTdoZvlStVcetnePrekryvu,  KATSdoKategorieVcetnePrekryvu,
                          KATSdoTB_PorKtg, ZVL_STATUTdoTB_PorZvl,
                          LTdoLTPSK, LTdoLTBzlJPOst, SLTDoSLTPsk, SLTDoSLTBzlJPOst,
                          LES_OBLDoLES_OBL, LO_CASTDoLES_PODOBL,   DalsiLTdoPSK_TEXT,
                          PocetCastiDoPocetCasti, PocetCastiDoPSK_TEXT,
                          LVSdoLVSPSK, LVSdoLVSBzlJPOst,
                          LVdoCislo_Tel,
                          DoplnBezlJinOSTKdyzNeni,SmazADoplnBezlJinOST,
                          BLABLABLAdoBZL_DRUH,
                          LS_KODDoOrgUr,
                          KULTURAdoDRUH_POZJP,KULTURAdoDRUH_POZOST,
                          PAS_OHRdoPAS_OHR,
                          PoznamkaDoBZL_VYUZ, PoznamkaDoJP_VYUZ, PoznamkaDoOST_VYUZ ,
                          KVAL_PdoPSK_KVAL_BezVypoctu
                          );
 // Vlastnk, poznamka ??
 TPozadovaneNacteniZLedu1 =  record
                              NacteniZLedu: set of SPozadovaneNacteniZLedu;
                              TxtPoznamkaDoBZL_VYUZ:string;
                              TxtBLABLABLAdoBZL_DRUH:string;
                             end;

TOznaceniPorSkupiny = class(TOwnerEntity)
 private
  FOdd:integer;
  FDil:String;
  FPor:String;
  FPsk:String;
 published
  property Odd:integer read FOdd write FOdd;
  property Dil:String read FDil write FDil;
  property Por:String read FPor write FPor;
  property Psk:String read FPsk write FPsk;

 end;

TOznaceniPorSkupinyHlaskaChyby = class(TOznaceniPorSkupiny)
 private
  FcisloChyby:integer;
  FHlaskaChyby:String;
 published
  property cisloChyby:integer read FcisloChyby write FcisloChyby;
  property HlaskaChyby:String read FHlaskaChyby write FHlaskaChyby;
 end;


TOznaceniPorSkupinyMN = class(TLesniMnozina)
public
  constructor Create; override;
end;

TOznaceniPorSkupinyHlaskaChybyMN = class(TLesniMnozina)
public
  constructor Create; override;
  procedure ulozSeDoTabulky(Table1:TTable);
end;
procedure NactiPozadovaneNacteniZLedu(DirAsoub:String);
procedure UlozPozadovaneNacteniZLedu(DirAsoub:String);

var
  PozadovaneNacteniZLedu:TPozadovaneNacteniZLedu1;

implementation

{
procedure UlozPozadovaneNacteniZLedu(VPozadovaneNacteniZLedu:TPozadovaneNacteniZLedu;DirAsoub:String);
var
   FilPozadovaneNacteniZLedu:file of TPozadovaneNacteniZLedu;

 begin
    ForceDirectories(KPoslednimuZnaku(DirAsoub,'\'));
    AssignFile(FilPozadovaneNacteniZLedu,DirAsoub);
    rewrite(FilPozadovaneNacteniZLedu);
    Write(FilPozadovaneNacteniZLedu,VPozadovaneNacteniZLedu);
    closeFile(FilPozadovaneNacteniZLedu);
 end;  }

procedure UlozPozadovaneNacteniZLedu(DirAsoub:String);
var
 initext:Tinifile;
begin
  initext:=Tinifile.create(DirAsoub);
  with PozadovaneNacteniZLedu do
   begin
    if PLOCHAdoPlocha0PSK in NacteniZLedu then initext.writeString('nactKont','PLOCHAdoPlocha0PSK','ANO') else initext.writeString('nactKont','PLOCHAdoPlocha0PSK','NE');
if VYMERAdoVymeraPSK in NacteniZLedu then initext.writeString('nactKont','VYMERAdoVymeraPSK','ANO') else initext.writeString('nactKont','VYMERAdoVymeraPSK','NE');
if PLOCHAdoPlocha0BZL in NacteniZLedu  then initext.writeString('nactKont','PLOCHAdoPlocha0BZL','ANO') else initext.writeString('nactKont','PLOCHAdoPlocha0BZL','NE');
if VYMERAdoVymeraBZL in NacteniZLedu  then initext.writeString('nactKont','VYMERAdoVymeraBZL','ANO') else initext.writeString('nactKont','VYMERAdoVymeraBZL','NE');
if PLOCHAdoPlocha0JP  in NacteniZLedu  then initext.writeString('nactKont','PLOCHAdoPlocha0JP','ANO') else initext.writeString('nactKont','PLOCHAdoPlocha0JP','NE');
if VYMERAdoVymeraJP  in NacteniZLedu  then initext.writeString('nactKont','VYMERAdoVymeraJP','ANO') else initext.writeString('nactKont','VYMERAdoVymeraJP','NE');
if PLOCHAdoPlocha0OST in NacteniZLedu  then initext.writeString('nactKont','PLOCHAdoPlocha0OST','ANO') else initext.writeString('nactKont','PLOCHAdoPlocha0OST','NE');
if VYMERAdoVymeraOST in NacteniZLedu  then initext.writeString('nactKont','VYMERAdoVymeraOST','ANO') else initext.writeString('nactKont','VYMERAdoVymeraOST','NE');
if MAJ_KODdoMAJ_KOD in NacteniZLedu  then initext.writeString('nactKont','MAJ_KODdoMAJ_KOD','ANO') else initext.writeString('nactKont','MAJ_KODdoMAJ_KOD','NE');
if MAJ_DRUHdoMAJ_DRUH in NacteniZLedu  then initext.writeString('nactKont','MAJ_DRUHdoMAJ_DRUH','ANO') else initext.writeString('nactKont','MAJ_DRUHdoMAJ_DRUH','NE');
if LS_KODDoOrgUr in NacteniZLedu  then initext.writeString('nactKont','LS_KODDoOrgUr','ANO') else initext.writeString('nactKont','LS_KODDoOrgUr','NE');
if PAS_OHRdoPAS_OHR in NacteniZLedu  then initext.writeString('nactKont','PAS_OHRdoPAS_OHR','ANO') else initext.writeString('nactKont','MAJ_DRUHdoMAJ_DRUH','NE');


if KVAL_PdoPSK_KVAL_Vypocet1 in NacteniZLedu  then initext.writeString('nactKont','KVAL_PdoPSK_KVAL_Vypocet','ANO') else initext.writeString('nactKont','KVAL_PdoPSK_KVAL_Vypocet','NE');
if KVAL_PdoPSK_KVAL_BezVypoctu in NacteniZLedu  then initext.writeString('nactKont','KVAL_PdoPSK_KVAL_BezVypoctu','ANO') else initext.writeString('nactKont','KVAL_PdoPSK_KVAL_BezVypoctu','NE');
if KVAL_PdoBZL_KVAL_Vypocet in NacteniZLedu  then initext.writeString('nactKont','KVAL_PdoBZL_KVAL_Vypocet','ANO') else initext.writeString('nactKont','KVAL_PdoBZL_KVAL_Vypocet','NE');
if KVAL_PdoJP_KVAL_Vypocet in NacteniZLedu  then initext.writeString('nactKont','KVAL_PdoJP_KVAL_Vypocet','ANO') else initext.writeString('nactKont','KVAL_PdoJP_KVAL_Vypocet','NE');
if KVAL_PdoOST_KVAL_Vypocet in NacteniZLedu  then initext.writeString('nactKont','KVAL_PdoOST_KVAL_Vypocet','ANO') else initext.writeString('nactKont','KVAL_PdoOST_KVAL_Vypocet','NE');
if KU_KODdoKU_KODPSK in NacteniZLedu  then initext.writeString('nactKont','KU_KODdoKU_KODPSK','ANO') else initext.writeString('nactKont','KU_KODdoKU_KODPSK','NE');
if KU_KODdoORPzKU6PSK in NacteniZLedu  then initext.writeString('nactKont','KU_KODdoORPzKU6PSK','ANO') else initext.writeString('nactKont','KU_KODdoORPzKU6PSK','NE');
if SK_PARCdoSKUPPARCPSK in NacteniZLedu  then initext.writeString('nactKont','SK_PARCdoSKUPPARCPSK','ANO') else initext.writeString('nactKont','SK_PARCdoSKUPPARCPSK','NE');
if KATPAR_KODdoPOT_VLASTPSK in NacteniZLedu  then initext.writeString('nactKont','KATPAR_KODdoPOT_VLASTPSK','ANO') else initext.writeString('nactKont','KATPAR_KODdoPOT_VLASTPSK','NE');
if KU_KODdoKU_KODBZL in NacteniZLedu  then initext.writeString('nactKont','KU_KODdoKU_KODBZL','ANO') else initext.writeString('nactKont','KU_KODdoKU_KODBZL','NE');
if KU_KODdoORPzKU6BZL in NacteniZLedu  then initext.writeString('nactKont','KU_KODdoORPzKU6BZL','ANO') else initext.writeString('nactKont','KU_KODdoORPzKU6BZL','NE');
if SK_PARCdoSKUPPARCBZL in NacteniZLedu  then initext.writeString('nactKont','SK_PARCdoSKUPPARCBZL','ANO') else initext.writeString('nactKont','SK_PARCdoSKUPPARCBZL','NE');
if KATPAR_KODdoPOT_VLASTBZL in NacteniZLedu  then initext.writeString('nactKont','KATPAR_KODdoPOT_VLASTBZL','ANO') else initext.writeString('nactKont','KATPAR_KODdoPOT_VLASTBZL','NE');
if KU_KODdoKU_KODJP in NacteniZLedu  then initext.writeString('nactKont','KU_KODdoKU_KODJP','ANO') else initext.writeString('nactKont','KU_KODdoKU_KODJP','NE');
if KU_KODdoORPzKU6JP in NacteniZLedu  then initext.writeString('nactKont','KU_KODdoORPzKU6JP','ANO') else initext.writeString('nactKont','KU_KODdoORPzKU6JP','NE');
if SK_PARCdoSKUPPARCJP in NacteniZLedu  then initext.writeString('nactKont','SK_PARCdoSKUPPARCJP','ANO') else initext.writeString('nactKont','SK_PARCdoSKUPPARCJP','NE');
if KATPAR_KODdoPOT_VLASTJP in NacteniZLedu  then initext.writeString('nactKont','KATPAR_KODdoPOT_VLASTJP','ANO') else initext.writeString('nactKont','KATPAR_KODdoPOT_VLASTJP','NE');
if KU_KODdoKU_KODOST in NacteniZLedu  then initext.writeString('nactKont','KU_KODdoKU_KODOST','ANO') else initext.writeString('nactKont','KU_KODdoKU_KODOST','NE');
if KU_KODdoORPzKU6OST in NacteniZLedu  then initext.writeString('nactKont','KU_KODdoORPzKU6OST','ANO') else initext.writeString('nactKont','KU_KODdoORPzKU6OST','NE');
if SK_PARCdoSKUPPARCOST in NacteniZLedu  then initext.writeString('nactKont','SK_PARCdoSKUPPARCOST','ANO') else initext.writeString('nactKont','SK_PARCdoSKUPPARCOST','NE');
if KATPAR_KODdoPOT_VLASTOST in NacteniZLedu  then initext.writeString('nactKont','KATPAR_KODdoPOT_VLASTOST','ANO') else initext.writeString('nactKont','KATPAR_KODdoPOT_VLASTOST','NE');

if ZVL_STATUTdoZvlStVcetnePrekryvu in NacteniZLedu  then initext.writeString('nactKont','ZVL_STATUTdoZvlStVcetnePrekryvu','ANO') else initext.writeString('nactKont','ZVL_STATUTdoZvlStVcetnePrekryvu','NE');
if KATSdoKategorieVcetnePrekryvu in NacteniZLedu  then initext.writeString('nactKont','KATSdoKategorieVcetnePrekryvu','ANO') else initext.writeString('nactKont','KATSdoKategorieVcetnePrekryvu','NE');
if KATSdoTB_PorKtg  in NacteniZLedu  then initext.writeString('nactKont','KATSdoTB_PorKtg','ANO') else initext.writeString('nactKont','KATSdoTB_PorKtg','NE');
if ZVL_STATUTdoTB_PorZvl  in NacteniZLedu  then initext.writeString('nactKont','ZVL_STATUTdoTB_PorZvl','ANO') else initext.writeString('nactKont','ZVL_STATUTdoTB_PorZvl','NE');
if LTdoLTPsk  in NacteniZLedu  then initext.writeString('nactKont','LTdoLTPsk','ANO') else initext.writeString('nactKont','LTdoLTPsk','NE');
if SLTDoSLTPsk  in NacteniZLedu  then initext.writeString('nactKont','SLTDoSLTPsk','ANO') else initext.writeString('nactKont','SLTDoSLTPsk','NE');

if LTdoLTBzlJPOst  in NacteniZLedu  then initext.writeString('nactKont','LTdoLTBzlJPOst','ANO') else initext.writeString('nactKont','LTdoLTBzlJPOst','NE');
if SLTDoSLTBzlJPOst  in NacteniZLedu  then initext.writeString('nactKont','SLTDoSLTBzlJPOst','ANO') else initext.writeString('nactKont','SLTDoSLTBzlJPOst','NE');

if LES_OBLDoLES_OBL  in NacteniZLedu  then initext.writeString('nactKont','LES_OBLDoLES_OBL','ANO') else initext.writeString('nactKont','LES_OBLDoLES_OBL','NE');
if LO_CASTDoLES_PODOBL  in NacteniZLedu  then initext.writeString('nactKont','LO_CASTDoLES_PODOBL','ANO') else initext.writeString('nactKont','LO_CASTDoLES_PODOBL','NE');

if DalsiLTdoPSK_TEXT  in NacteniZLedu  then initext.writeString('nactKont','DalsiLTdoPSK_TEXT','ANO') else initext.writeString('nactKont','DalsiLTdoPSK_TEXT','NE');
if PocetCastiDoPocetCasti  in NacteniZLedu  then initext.writeString('nactKont','PocetCastiDoPocetCasti','ANO') else initext.writeString('nactKont','PocetCastiDoPocetCasti','NE');

if PocetCastiDoPSK_TEXT  in NacteniZLedu  then initext.writeString('nactKont','PocetCastiDoPSK_TEXT','ANO') else initext.writeString('nactKont','PocetCastiDoPSK_TEXT','NE');
if LVSdoLVSPsk in NacteniZLedu  then initext.writeString('nactKont','LVSdoLVSPSK','ANO') else initext.writeString('nactKont','LVSdoLVSPSK','NE');
if LVSdoLVSBzlJPOst in NacteniZLedu  then initext.writeString('nactKont','LVSdoLVSBzlJPOst','ANO') else initext.writeString('nactKont','LVSdoLVSBzlJPOst','NE');

if LVdoCislo_Tel in NacteniZLedu  then initext.writeString('nactKont','LVdoCislo_Tel','ANO') else initext.writeString('nactKont','LVdoCislo_Tel','NE');
if DoplnBezlJinOSTKdyzNeni in NacteniZLedu  then initext.writeString('nactKont','DoplnBezlJinOSTKdyzNeni','ANO') else initext.writeString('nactKont','DoplnBezlJinOSTKdyzNeni','NE');
if SmazADoplnBezlJinOST    in NacteniZLedu  then initext.writeString('nactKont','SmazADoplnBezlJinOST','ANO') else initext.writeString('nactKont','SmazADoplnBezlJinOST','NE');
if BLABLABLAdoBZL_DRUH    in NacteniZLedu  then initext.writeString('nactKont','BLABLABLAdoBZL_DRUH','ANO') else initext.writeString('nactKont','BLABLABLAdoBZL_DRUH','NE');
if KULTURAdoDRUH_POZJP    in NacteniZLedu  then initext.writeString('nactKont','KULTURAdoDRUH_POZJP','ANO') else initext.writeString('nactKont','KULTURAdoDRUH_POZJP','NE');
if KULTURAdoDRUH_POZOST    in NacteniZLedu  then initext.writeString('nactKont','KULTURAdoDRUH_POZOST','ANO') else initext.writeString('nactKont','KULTURAdoDRUH_POZOST','NE');

if PoznamkaDoBZL_VYUZ   in NacteniZLedu  then initext.writeString('nactKont','PoznamkaDoBZL_VYUZ','ANO') else initext.writeString('nactKont','PoznamkaDoBZL_VYUZ','NE');
if PoznamkaDoJP_VYUZ    in NacteniZLedu  then initext.writeString('nactKont','PoznamkaDoJP_VYUZ','ANO') else initext.writeString('nactKont','PoznamkaDoJP_VYUZ','NE');
if PoznamkaDoOST_VYUZ   in NacteniZLedu  then initext.writeString('nactKont','PoznamkaDoOST_VYUZ','ANO') else initext.writeString('nactKont','PoznamkaDoOST_VYUZ','NE');
    initext.writeString('nactKont','TxtPoznamkaDoBZL_VYUZ',TxtPoznamkaDoBZL_VYUZ);
    initext.writeString('nactKont','TxtBLABLABLAdoBZL_DRUH',TxtBLABLABLAdoBZL_DRUH);
    end;
initext.free;
end;

procedure NactiPozadovaneNacteniZLedu(DirAsoub:String);
var
 initext:Tinifile;
 S:String;
begin
  with PozadovaneNacteniZLedu do
   begin
  NacteniZLedu:=[];
  initext:=Tinifile.create(DirAsoub);
  s:=iniText.ReadString('nactKont','PLOCHAdoPlocha0PSK','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[PLOCHAdoPlocha0PSK];

  s:=iniText.ReadString('nactKont','VYMERAdoVymeraPSK','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[VYMERAdoVymeraPSK];
  s:=iniText.ReadString('nactKont','PLOCHAdoPlocha0BZL','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[PLOCHAdoPlocha0BZL];
  s:=iniText.ReadString('nactKont','VYMERAdoVymeraBZL','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[VYMERAdoVymeraBZL];
  s:=iniText.ReadString('nactKont','PLOCHAdoPlocha0JP','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[PLOCHAdoPlocha0JP];
  s:=iniText.ReadString('nactKont','VYMERAdoVymeraJP','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[VYMERAdoVymeraJP];
  s:=iniText.ReadString('nactKont','PLOCHAdoPlocha0OST','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[PLOCHAdoPlocha0OST];
  s:=iniText.ReadString('nactKont','VYMERAdoVymeraOST','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[VYMERAdoVymeraOST];
  s:=iniText.ReadString('nactKont','MAJ_KODdoMAJ_KOD','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[MAJ_KODdoMAJ_KOD];
  s:=iniText.ReadString('nactKont','MAJ_DRUHdoMAJ_DRUH','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[MAJ_DRUHdoMAJ_DRUH];
  s:=iniText.ReadString('nactKont','LS_KODDoOrgUr','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[LS_KODDoOrgUr];
  s:=iniText.ReadString('nactKont','MAJ_KODdoMAJ_KOD','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[PAS_OHRdoPAS_OHR];


  s:=iniText.ReadString('nactKont','KVAL_PdoPSK_KVAL_Vypocet','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KVAL_PdoPSK_KVAL_Vypocet1];
  s:=iniText.ReadString('nactKont','KVAL_PdoPSK_KVAL_BezVypoctu','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KVAL_PdoPSK_KVAL_BezVypoctu];

  s:=iniText.ReadString('nactKont','KVAL_PdoBZL_KVAL_Vypocet','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KVAL_PdoBZL_KVAL_Vypocet];
  s:=iniText.ReadString('nactKont','KVAL_PdoJP_KVAL_Vypocet','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KVAL_PdoJP_KVAL_Vypocet];
  s:=iniText.ReadString('nactKont','KVAL_PdoOST_KVAL_Vypocet','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KVAL_PdoOST_KVAL_Vypocet];
  s:=iniText.ReadString('nactKont','KU_KODdoKU_KODPSK','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KU_KODdoKU_KODPSK];
  s:=iniText.ReadString('nactKont','KU_KODdoORPzKU6PSK','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KU_KODdoORPzKU6PSK];
  s:=iniText.ReadString('nactKont','SK_PARCdoSKUPPARCPSK','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[SK_PARCdoSKUPPARCPSK];
  s:=iniText.ReadString('nactKont','KATPAR_KODdoPOT_VLASTPSK','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KATPAR_KODdoPOT_VLASTPSK];
  s:=iniText.ReadString('nactKont','KU_KODdoKU_KODBZL','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KU_KODdoKU_KODBZL];
  s:=iniText.ReadString('nactKont','KU_KODdoORPzKU6BZL','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KU_KODdoORPzKU6BZL];
  s:=iniText.ReadString('nactKont','SK_PARCdoSKUPPARCBZL','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[SK_PARCdoSKUPPARCBZL];
  s:=iniText.ReadString('nactKont','KATPAR_KODdoPOT_VLASTBZL','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KATPAR_KODdoPOT_VLASTBZL];
  s:=iniText.ReadString('nactKont','KU_KODdoKU_KODJP','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KU_KODdoKU_KODJP];
  s:=iniText.ReadString('nactKont','KU_KODdoORPzKU6JP','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KU_KODdoORPzKU6JP];
  s:=iniText.ReadString('nactKont','SK_PARCdoSKUPPARCJP','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[SK_PARCdoSKUPPARCJP];
  s:=iniText.ReadString('nactKont','KATPAR_KODdoPOT_VLASTJP','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KATPAR_KODdoPOT_VLASTJP];
  s:=iniText.ReadString('nactKont','KU_KODdoKU_KODOST','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KU_KODdoKU_KODOST];
  s:=iniText.ReadString('nactKont','KU_KODdoORPzKU6OST','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KU_KODdoORPzKU6OST];
  s:=iniText.ReadString('nactKont','SK_PARCdoSKUPPARCOST','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[SK_PARCdoSKUPPARCOST];
  s:=iniText.ReadString('nactKont','KATPAR_KODdoPOT_VLASTOST','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KATPAR_KODdoPOT_VLASTOST];
  s:=iniText.ReadString('nactKont','ZVL_STATUTdoZvlStVcetnePrekryvu','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[ZVL_STATUTdoZvlStVcetnePrekryvu];
  s:=iniText.ReadString('nactKont','KATSdoKategorieVcetnePrekryvu','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KATSdoKategorieVcetnePrekryvu];

  s:=iniText.ReadString('nactKont','KATSdoTB_PorKtg','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KATSdoTB_PorKtg];
  s:=iniText.ReadString('nactKont','ZVL_STATUTdoTB_PorZvl','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[ZVL_STATUTdoTB_PorZvl];

  s:=iniText.ReadString('nactKont','LTdoLTPSK','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[LTdoLTPSK];
  s:=iniText.ReadString('nactKont','SLTDoSLTPSK','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[SLTDoSLTPSK];
  s:=iniText.ReadString('nactKont','LTdoLTBzlJPOst','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[LTdoLTBzlJPOst];
  s:=iniText.ReadString('nactKont','SLTDoSLTBzlJPOst','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[SLTDoSLTBzlJPOst];

  s:=iniText.ReadString('nactKont','LES_OBLDoLES_OBL','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[LES_OBLDoLES_OBL];
  s:=iniText.ReadString('nactKont','LO_CASTDoLES_PODOBL','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[LO_CASTDoLES_PODOBL];

  s:=iniText.ReadString('nactKont','DalsiLTdoPSK_TEXT','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[DalsiLTdoPSK_TEXT];
  s:=iniText.ReadString('nactKont','PocetCastiDoPocetCasti','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[PocetCastiDoPocetCasti];
  s:=iniText.ReadString('nactKont','PocetCastiDoPSK_TEXT','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[PocetCastiDoPSK_TEXT];
  s:=iniText.ReadString('nactKont','LVSdoLVSPSK','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[LVSdoLVSPSK];
  s:=iniText.ReadString('nactKont','LVSdoLVSBzlJPOst','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[LVSdoLVSBzlJPOst];

  s:=iniText.ReadString('nactKont','LVdoCislo_Tel','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[LVdoCislo_Tel];
  s:=iniText.ReadString('nactKont','DoplnBezlJinOSTKdyzNeni','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[DoplnBezlJinOSTKdyzNeni];
  s:=iniText.ReadString('nactKont','SmazADoplnBezlJinOST','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[SmazADoplnBezlJinOST];
  s:=iniText.ReadString('nactKont','BLABLABLAdoBZL_DRUH','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[BLABLABLAdoBZL_DRUH];
  s:=iniText.ReadString('nactKont','KULTURAdoDRUH_POZJP','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KULTURAdoDRUH_POZJP];
  s:=iniText.ReadString('nactKont','KULTURAdoDRUH_POZOST','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[KULTURAdoDRUH_POZOST];
  s:=iniText.ReadString('nactKont','PoznamkaDoBZL_VYUZ','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[PoznamkaDoBZL_VYUZ];
  s:=iniText.ReadString('nactKont','PoznamkaDoJP_VYUZ','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[PoznamkaDoJP_VYUZ];
  s:=iniText.ReadString('nactKont','PoznamkaDoOST_VYUZ','NE'); if s='ANO' then NacteniZLedu:=NacteniZLedu+[PoznamkaDoOST_VYUZ];

  TxtPoznamkaDoBZL_VYUZ:=initext.readString('nactKont','TxtPoznamkaDoBZL_VYUZ','Poznamka');
  TxtBLABLABLAdoBZL_DRUH:=initext.readString('nactKont','TxtBLABLABLAdoBZL_DRUH','BLABLABLA');
  end;
  initext.free;
end;
{
procedure NactiPozadovaneNacteniZLedu(var VPozadovaneNacteniZLedu:TPozadovaneNacteniZLedu;DirAsoub:String);
var
   FilPozadovaneNacteniZLedu:file of TPozadovaneNacteniZLedu;

begin
     AssignFile(FilPozadovaneNacteniZLedu,DirAsoub);
  try
   reset(FilPozadovaneNacteniZLedu);
   Read(FilPozadovaneNacteniZLedu,VPozadovaneNacteniZLedu);
   closeFile(FilPozadovaneNacteniZLedu);
  except
   VPozadovaneNacteniZLedu:=[];
  end;
end;
}

constructor TOznaceniPorSkupinyMN.Create;
 begin
  inherited create;
  FClass:=TOznaceniPorSkupiny;
  FPredponaName:='OznPSK';
 end;

constructor TOznaceniPorSkupinyHlaskaChybyMN.Create;
 begin
  inherited create;
  FClass:=TOznaceniPorSkupinyHlaskaChyby;
  FPredponaName:='HlChyPSK';
 end;
procedure TOznaceniPorSkupinyHlaskaChybyMN.ulozSeDoTabulky(Table1:TTable);
var i:integer;
begin
  if FileExists(table1.TableName) then
   begin
    table1.emptytable;
   end
  else
   begin
    ForceDirectories(KPoslednimuZnaku(table1.TableName,'\'));
    with table1 do
    begin
     FieldDefs.clear;
     fieldDefs.Add('ODDELENI', ftInteger,0,false);
     fieldDefs.Add('DILEC', ftString,2,false);
     fieldDefs.Add('POROST', ftString,2,false);
     fieldDefs.Add('SKUPINA', ftString,20,false);
     fieldDefs.Add('CislChyb', ftInteger,0,false);
     fieldDefs.Add('TextChyb', ftString,80,false);
     createTable;
     open;
   end;
  end;
 if not table1.Active then table1.Open;
 for i:=0 to count-1 do
  begin
   table1.Insert;
   table1.FieldByName('ODDELENI').AsInteger:=TOznaceniPorSkupinyHlaskaChyby(Elements[i]).Odd;
   table1.FieldByName('DILEC').AsString:=TOznaceniPorSkupinyHlaskaChyby(Elements[i]).Dil;
   table1.FieldByName('POROST').AsString:=TOznaceniPorSkupinyHlaskaChyby(Elements[i]).Por;
   table1.FieldByName('SKUPINA').AsString:=TOznaceniPorSkupinyHlaskaChyby(Elements[i]).PSK;
   table1.FieldByName('CislChyb').AsInteger:=TOznaceniPorSkupinyHlaskaChyby(Elements[i]).cisloChyby;
   table1.FieldByName('TextChyb').AsString:=TOznaceniPorSkupinyHlaskaChyby(Elements[i]).HlaskaChyby;
   table1.Post;
  end;
end;

end.
