unit EOddBlok;

interface
uses sysUtils,Dialogs,dbtables,DB,
     e_Files, T_Select,
     ELesObec,E_LesOdd,LesCisOr,
     E_Class,U_props,T_oper,TypInfo,
     elements,creacond,U_Podmin;
type

 TOddDilPorSkABlokMapy = class(TObecnyLesniPrvek)
  private
   FSOdd:integer;
   FSDil:String;
   FSPor:String;
   FSPsk:String;
   FSDirTopolu:String;
   FSDirOrbu:String;
  published
   property SOdd:integer read FSOdd write FSOdd;
   property SDil:String  read FSDil write FSDil;
   property SPor:String  read FSPor write FSPor;
   property SPsk:String  read FSPsk write FSPsk;
   property SDirTopolu:String  read FSDirTopolu write FSDirTopolu;
   property SDirOrbu:String  read FSDirOrbu write FSDirOrbu;
  end;

 TOddDilPorSkABlokMapyMN = class(TLesniMnozina)
  private
  public
   constructor Create; override;
  end;
function Zjisti_typ_mapy(AdresarMapy:String):String;

implementation

constructor TOddDilPorSkABlokMapyMN.Create;
 begin
  inherited create;
  FClass:=TOddDilPorSkABlokMapy;
  FPredponaName:='OddSkBlMap';
 end;

function Zjisti_typ_mapy(AdresarMapy:String):String;
var
 DE:TDirectoryElement;
 S :TAllSelector;
 ip:integer;
 begin
  result:='';
  DE := TDirectoryElement.Create;
  DE.FileName := AdresarMapy;
  zvetsRekurzivneNAME(DE);
  S := TAllSelector.Create;
  S.Condition :='(Name=''P0110.DBF'')';
  S.Input := DE;
  S.DoIt;
  if TEntity(S.Output).count>0 then
   begin
    result:='Topol';
   end;
  S.free;

  DE := TDirectoryElement.Create;
  DE.FileName := AdresarMapy;
  zvetsRekurzivneNAME(DE);
  S := TAllSelector.Create;
  S.Condition :='(Name=''MAPA.ORB'')';
  S.Input := DE;
  S.DoIt;
  if TEntity(S.Output).count>0 then
   begin
    result:='Orbis';
   end;
  S.free;

 end;

initialization

 registerOrbisClass(TOddDilPorSkABlokMapy);
 registerOrbisClass(TOddDilPorSkABlokMapyMN);


end.
