unit E_leslhc;

interface
uses
  SysUtils,Elements,KatasPlo,dialogs,lesCisel, DB, DBTables,
  E_LesOdd,ELesObec,Sp_Ovr,Dtb_les,Sp_Ovr98,Dtbles98;
type
TKatastr=class(TOwnerEntity)
      private
       FOkres:int64;
       Fkatastr:int64;
       FPorostniPuda:double;
       FBezlesi:double;
       FjinePozemky:Double;
       FOstatniPozemky:Double;
       FAktualniPot_Vlast:integer;
       FPlochaPot_Vlast: array[11..14] of double;
       function  GetPlochaPot_Vlast:Double;
       procedure SetAktualniPot_Vlast(p:integer);
       procedure SetPlochaPot_Vlast(p:double);
       function  GetNazevKatastru:string;
       function  GetNazevOkresu:string;
      published
       property AktualniPot_Vlast:integer read FAktualniPot_Vlast write SetAktualniPot_Vlast;
       property PlochaPot_Vlast:double read GetPlochaPot_Vlast write SetPlochaPot_Vlast;
       property Okres:int64 read FOkres write FOkres;
       property OznKatastr:int64 read Fkatastr write Fkatastr;
       property NazevKatastru:string read GetNazevKatastru;
       property NazevOkresu:string read GetNazevOkresu;
       property porostniPuda:double read FPorostniPuda write FPorostniPuda;
       property Bezlesi:double read FBezlesi write FBezlesi;
       property jinePozemky:Double read FJinePozemky write FJinePozemky;
       property OstatniPozemky:Double read FOstatniPozemky write FOstatniPozemky;
      end;
TSumarLHC = class(TOwnerEntity)
private
  FPoradiAktualnihoVyuziti:integer;
  FPoleVyuziti:array [1..MaxZnackyVyuziti] of Double;
  FPocetKatastru:integer;
  FAktualniPoradiKatastru:Integer;
  FKatastr:TKatastr;
  FKatastrZaOkres:TKatastr;
  FPorostniPuda : double;
  FPlochaPUPFL  : double;
  FPlochaOSTATNI: double;
  FMajitelLHC:String;
  function  GetPlochaVYUZITI  :double;
  procedure SetPlochaVYUZITI(D:double);
  procedure SetAktualniKatastr(K:longint);
  // procedure SetNovyKatastr(K:Longint);
  function  GetKatastr:TKatastr;
  Procedure SetAktualniOkres(Ok:Integer);
public
  procedure VytvorNovyKatastr(K:Longint;LDU:LONGINT;celeOzn:string);
published
  Procedure PripoctiOddeleni(VOdd:TOddeleni);
  property PocetKatastru: integer read FPocetKatastru write FPocetKatastru;
  property AktualniPoradiKatastru: integer read FAktualniPoradiKatastru write FAktualniPoradiKatastru;
  property AktualniKatastr:Longint write SetAktualniKatastr;
  // property NovyKatastr:Longint write SetNovyKatastr;
  property Katastr:TKatastr read getKatastr;
  property AktualniOkres:integer write SetAktualniOkres;
  property KatastrZaOkres:TKatastr read FKatastrZaOkres;
  property PoradiAktualnihoVyuziti: integer read  FPoradiAktualnihoVyuziti
                                            write FPoradiAktualnihoVyuziti;
  property PlochaVyuziti: double read GetPlochaVYUZITI write SetPlochaVYUZITI;
  property PorostniPuda: double read FPorostniPuda write FPorostniPuda;
  property PlochaPUPFL: double read FPlochaPUPFL write FPlochaPUPFL;
  property Plochaostatni: double read FPlochaostatni write FPlochaostatni;
  property MajitelLHC:string read FMajitelLHC write FMajitelLHC;
  procedure PripoctiDoKatastru(VSLP:TLesniSlozenyPrvek);

end;

procedure SpoctiSumarLHC_DB97(var VSumarLHC:TSumarLHC);
procedure SpoctiSumarLHC_DB98(var VSumarLHC:TSumarLHC;Query1:TQuery);
procedure SpoctiSumarOddeleniMN97(var VSumarLHC:TSumarLHC;OddMN:TOddeleniMN);
procedure SpoctiSumarOddeleniMN98(var VSumarLHC:TSumarLHC;OddMN:TOddeleniMN);

implementation
function  TKatastr.GetPlochaPot_Vlast:Double;
 begin
  result:=FPlochaPot_Vlast[FAktualniPot_Vlast];
 end;
procedure TKatastr.SetPlochaPot_Vlast(p:double);
 begin
  FPlochaPot_Vlast[FAktualniPot_Vlast]:=P;
 end;
procedure TKatastr.SetAktualniPot_Vlast(p:integer);
 begin
  if p in [11,12,13,14] then  FAktualniPot_Vlast:=P
                            else  FAktualniPot_Vlast:=11;
 end;
function  TKatastr.GetNazevKatastru:string;
 begin
  if oznKatastr>10000000 then
   begin
    result:=DleCiselniku(CiselnikP.tb_Katastry,'Kod',
                       inttoStr(oznKatastr),'POPIS',false);
   end
  else
   begin
    result:=DleCiselniku(CiselnikP.tb_KU6a,'Kod',
                       inttoStr(oznKatastr),'POPIS',false);

   end;
 end;
function  TKatastr.GetNazevOkresu:string;
var
 S:string;
 begin

  {
  result:=DleCiselniku(CiselnikP.tb_ldu,'Kod',
                       inttoStr(okres),'POPIS',false);

  }

  if oznKatastr>10000000 then
   begin
    result:=DleCiselniku(CiselnikP.tb_LDU,'Kod',
                       inttostr(okres),'POPIS',false);
   end
  else
   begin
    result:=DleCiselniku(CiselnikP.tb_ORP,'Kod',
                       inttostr(Okres+200000),'POPIS',false);

   end;


 end;

Procedure  TSumarLHC.SetAktualniOkres(Ok:Integer);
var i,iPot_Vlast:integer;

 begin
  if FKatastrZaOkres<>nil then FKatastrZaOkres.free;
  FKatastrZaOkres:=TKatastr.create;
  FKatastrZaOkres.FOkres:=Ok;
    for i:=0 to count-1 do
     begin
      if Elements[i] is TKatastr then
       begin
        with TKatastr(Elements[i]) do
         begin
          if (okres=FKatastrZaOkres.Okres) or (-1=FKatastrZaOkres.Okres) then
           begin
            FKatastrZaOkres.FporostniPuda:=FKatastrZaOkres.FporostniPuda+PorostniPuda;
            FKatastrZaOkres.FBezlesi:=FKatastrZaOkres.FBezlesi+Bezlesi;
            FKatastrZaOkres.FjinePozemky:=FKatastrZaOkres.FjinePozemky+JinePozemky;
            FKatastrZaOkres.FOstatniPozemky:=FKatastrZaOkres.FOstatniPozemky+OstatniPozemky;
            for iPot_vlast:=11 to 14 do
             begin
              FKatastrZaOkres.AktualniPot_Vlast:=iPot_vlast;
              AktualniPot_Vlast:=iPot_vlast;
              FKatastrZaOkres.PlochaPot_Vlast:=FKatastrZaOkres.PlochaPot_Vlast+PlochaPot_Vlast;
             end;
           end;
         end;
       end;
     end;
 end;
function  TSumarLHC.getKatastr:TKatastr;
 begin
  result:=FKatastr;
 end;
procedure TSumarLHC.SetPlochaVYUZITI(D:double);
 begin
  FPoleVyuziti[PoradiAktualnihoVyuziti]:=D;
 end;
function  TSumarLHC.GetPlochaVYUZITI  :double;
 begin
  result:=FPoleVyuziti[PoradiAktualnihoVyuziti];
 end;
procedure TSumarLHC.SetAktualniKatastr(K:longint);
 begin
  FKatastr:= TKatastr(FindElementName('KATA '+IntToStr(K)));
 end;
procedure TSumarLHC.VytvorNovyKatastr(K:Longint;LDU:LONGINT;celeOzn:string);
begin
  FKatastr:= TKatastr(FindElementName('KATA '+IntToStr(K)));
  if  FKatastr= nil then
   begin
     // showmessage(' caj '+celeOzn+'  kat='+IntToStr(K)+'  ldu='+IntToStr(LDU));
     FKatastr:= TKatastr.Create;
     FKatastr.Name:='KATA '+IntToStr(K);
     AddElement(FKatastr);
     FKatastr.OznKatastr:=K;
     FKatastr.Okres:=LDU;
   end;
end;
procedure TSumarLHC.PripoctiDoKatastru(VSLP:TLesniSlozenyPrvek);
var i,iMN:integer;
// to je taky on
 begin
  with VSLP do
   begin
    for i:=0 to count-1 do
     begin
      if Elements[i] is TPorost then
       begin
        with TPorost(Elements[i]) do
         begin
          FMajitelLHC:=MAJ_KOD+'-'+MAJ_NAZ_xml;
         end;
       end;
      if Elements[i] is TPorostniSkupina then
       begin
        with TPorostniSkupina(Elements[i]) do
         begin
          IF abs(PLOCHA-round(Plocha*100)/100)>0.0001 then showmessage(celeOznaceni);
          VytvorNovyKatastr(KU_KOD,LES_URAD,celeOznaceni);
          katastr.PorostniPuda:=katastr.PorostniPuda+plocha;
          katastr.AktualniPot_Vlast:=POT_VLAST;
          katastr.PlochaPot_Vlast:=katastr.PlochaPot_Vlast+Plocha;
         end;
       end;
      if Elements[i] is TBezlesi then
       begin
        with TBezlesi(Elements[i]) do
         begin
          IF abs(PLOCHA-round(Plocha*100)/100)>0.0001 then showmessage(celeOznaceni);
          VytvorNovyKatastr(KU_KOD,LES_URAD,celeOznaceni);
          katastr.Bezlesi:=katastr.Bezlesi+plocha;
          katastr.AktualniPot_Vlast:=POT_VLAST;
          katastr.PlochaPot_Vlast:=katastr.PlochaPot_Vlast+Plocha;
         end;
       end;
      if Elements[i] is TJinyPozemek then
       begin
        with TJinyPozemek(Elements[i]) do
         begin
          IF abs(PLOCHA-round(Plocha*100)/100)>0.0001 then showmessage(celeOznaceni);
          VytvorNovyKatastr(KU_KOD,LES_URAD,celeOznaceni);
          katastr.JinePozemky:=katastr.JinePozemky+plocha;
          katastr.AktualniPot_Vlast:=POT_VLAST;
          katastr.PlochaPot_Vlast:=katastr.PlochaPot_Vlast+Plocha;
         end;
       end;
      if Elements[i] is TOstatni then
       begin
        with TOstatni(Elements[i]) do
         begin
          IF abs(PLOCHA-round(Plocha*100)/100)>0.0001 then
           begin
             // vyhozeno 15.2.2007 protoe to otravovalo BABKU
            showmessage(celeOznaceni
                 +' plocha='+floattostr(Plocha)+'=='+floattostr(round(Plocha*100)/100));
           end;
          VytvorNovyKatastr(KU_KOD,LES_URAD,celeOznaceni);
          katastr.OstatniPozemky:=katastr.OstatniPozemky+plocha;
          katastr.AktualniPot_Vlast:=POT_VLAST;
         { katastr.PlochaPot_Vlast:=katastr.PlochaPot_Vlast+Plocha; }
         end;
       end;
      if Elements[i] is TLesniSlozenyPrvek then
       begin
        PripoctiDoKatastru(TLesniSlozenyPrvek(Elements[i]));
       end;
      if Elements[i] is TLesniMnozina then
       begin
        for iMN:=0 to TLesniMnozina(Elements[i]).count-1 do
         begin
          with TLesniMnozina(Elements[i]) do
           begin
            if Elements[iMN] is TPorost then
             begin
              with TPorost(Elements[iMN]) do
               begin
                FMajitelLHC:=MAJ_KOD+'-'+MAJ_NAZ_xml;
               end;
             end;
            if Elements[iMN] is TPorostniSkupina then
             begin
              with TPorostniSkupina(Elements[iMN]) do
               begin
                // showmessage('Caj '+inttostr(KU_KOD)+KU_NAZ+' '+inttostr(LES_URAD)+' '+ celeOznaceni);
                IF abs(PLOCHA-round(Plocha*100)/100)>0.0001 then showmessage(celeOznaceni);
                VytvorNovyKatastr(KU_KOD,LES_URAD,celeOznaceni);
                katastr.PorostniPuda:=katastr.PorostniPuda+plocha;
                katastr.AktualniPot_Vlast:=POT_VLAST;
                katastr.PlochaPot_Vlast:=katastr.PlochaPot_Vlast+Plocha;
               end;
             end;
            if Elements[iMN] is TBezlesi then
             begin
              with TBezlesi(Elements[iMN]) do
               begin
                // showmessage('Caj '+inttostr(KU_KOD)+KU_NAZ+' '+inttostr(LES_URAD)+' '+ celeOznaceni);
                IF abs(PLOCHA-round(Plocha*100)/100)>0.0001 then showmessage(celeOznaceni);
                VytvorNovyKatastr(KU_KOD,LES_URAD,celeOznaceni);
                katastr.Bezlesi:=katastr.Bezlesi+plocha;
                katastr.AktualniPot_Vlast:=POT_VLAST;
                katastr.PlochaPot_Vlast:=katastr.PlochaPot_Vlast+Plocha;
               end;
             end;
            if Elements[iMN] is TJinyPozemek then
             begin
              with TJinyPozemek(Elements[iMN]) do
               begin
                // showmessage('Caj '+inttostr(KU_KOD)+KU_NAZ+' '+inttostr(LES_URAD)+' '+ celeOznaceni);
                IF abs(PLOCHA-round(Plocha*100)/100)>0.0001 then showmessage(celeOznaceni);
                VytvorNovyKatastr(KU_KOD,LES_URAD,celeOznaceni);
                katastr.JinePozemky:=katastr.JinePozemky+plocha;
                katastr.AktualniPot_Vlast:=POT_VLAST;
                katastr.PlochaPot_Vlast:=katastr.PlochaPot_Vlast+Plocha;
               end;
             end;
            if Elements[iMN] is TOstatni then
             begin
              with TOstatni(Elements[iMN]) do
               begin
                IF abs(PLOCHA-round(Plocha*100)/100)>0.0001 then
                 begin
                  // vyhozeno 15.2.2007 protoe to otravovalo BABKU
                   showmessage(celeOznaceni
                       +' plocha='+floattostr(Plocha)+'=='+floattostr(round(Plocha*100)/100));
                 end;
                VytvorNovyKatastr(KU_KOD,LES_URAD,celeOznaceni);
                katastr.OstatniPozemky:=katastr.OstatniPozemky+plocha;
                katastr.AktualniPot_Vlast:=POT_VLAST;
                { katastr.PlochaPot_Vlast:=katastr.PlochaPot_Vlast+Plocha; }
               end;
             end;
            if Elements[iMN] is TLesniSlozenyPrvek then
             begin
              PripoctiDoKatastru(TLesniSlozenyPrvek(Elements[iMN]));
             end;
           end; {with TLesniMnozina(Elements[i])}
         end; {if Elements[i] is TLesniMnozina}
       end;
     end;
   end;
 end;

Procedure TSumarLHC.PripoctiOddeleni(VOdd:TOddeleni);
var i:integer;
 begin
  try
  PripoctiDoKatastru(VOdd);
  // CAj porostniPuda:=round(porostniPuda*100)/100+VOdd.PorostniPuda;
  porostniPuda:=porostniPuda+VOdd.PorostniPuda;
  PlochaPUPFL:=PlochaPUPFL+VOdd.PlochaPUPFL;
  Plochaostatni:=Plochaostatni+VOdd.Plochaostatni;
  for i:=1 to MaxZnackyVyuziti do
   begin
    PoradiAktualnihoVyuziti:=i;
    VOdd.PoradiAktualnihoVyuziti:=i;
    PlochaVyuziti:=PlochaVyuziti+VOdd.plochaVyuziti;
   end;
  except
   showmessage('Chyba v oddln '+inttostr(VOdd.ODD));
  end;
 end;
procedure SpoctiSumarLHC_DB97(var VSumarLHC:TSumarLHC);
var VOdd:TOddeleni;
 begin
  VSumarLHC:= TSumarLHC.create;
  PriradCiselnik_DB(ciselnikP,ovr);
  ovr.tb_Odd.first;
  while not ovr.tb_Odd.eof do
   begin
    NactiOddeleni_DB(VOdd,ovr,nil);
    VSumarLHC.PripoctiOddeleni(VOdd);
    VOdd.free;
    // ovr.tb_Odd.next;
   end;
 end;
procedure SpoctiSumarLHC_DB98(var VSumarLHC:TSumarLHC;Query1:TQuery);
var VOdd:TOddeleni;
 begin
  VSumarLHC:= TSumarLHC.create;
  PriradCiselnik_DB98(ciselnikP,ovr98);
 while (not Query1.eof)  do
  begin
    NactiOddeleni_DB98_DleCisla(Query1.findfield('ODD').asstring,VOdd,Ovr98,BezBarvy1);
{
  ovr98.tb_Odd.first;
  while not ovr98.tb_Odd.eof do
   begin
    NactiOddeleniDB98(VOdd,ovr98,BezBarvy1);    }
    VSumarLHC.PripoctiOddeleni(VOdd);
    VOdd.free;
    Query1.next;
   end;
 end;
procedure SpoctiSumarOddeleniMN98(var VSumarLHC:TSumarLHC;OddMN:TOddeleniMN);
var i:integer;
 begin
  VSumarLHC:= TSumarLHC.create;
  PriradCiselnik_DB98(ciselnikP,ovr98);
  for i:=0 to OddMN.count-1 do
   begin
    VSumarLHC.PripoctiOddeleni(TOddeleni(OddMN.elements[i]));
   end;
 end;
procedure SpoctiSumarOddeleniMN97(var VSumarLHC:TSumarLHC;OddMN:TOddeleniMN);
var i:integer;
 begin
  VSumarLHC:= TSumarLHC.create;
  PriradCiselnik_DB(ciselnikP,ovr);
  for i:=0 to OddMN.count-1 do
   begin
    VSumarLHC.PripoctiOddeleni(TOddeleni(OddMN.elements[i]));
   end;
 end;
end.
