unit LesTopol;
interface
uses Dialogs,DBTables,DB,Elements,IniFiles,Forms,sp_vyhSo,mat1,E_LesOdd,
     SysUtils,Dotaz;
type
tTopolNacti = class(TOwnerEntity)
private
  FQ_P0110:TQuery;
  FQ_P0110BzlJineOst:TQuery;
  FQ_P0110BzlJineOstPoKatastrech:TQuery;
  FQ_P0135:TQuery;
  FQ_P0110ODD:TQuery;

  FAdresarTopolu:String;
  Koncime:Boolean;
  JeOK:integer;
  function GetQ_P0110:TQuery;
  function GetQ_P0110ODD:TQuery;
  function GetQ_P0135:TQuery;
  function GetQ_P0110BzlJineOst:TQuery;
  function GetQ_P0110BzlJineOstPoKatastrech:TQuery;
public
   topAdr:string;
published
  property  Q_P0110 :TQuery read GetQ_P0110 write FQ_P0110;
  property  Q_P0110BzlJineOst :TQuery read GetQ_P0110BzlJineOst write FQ_P0110BzlJineOst;
  property  Q_P0110BzlJineOstPoKatastrech :TQuery read GetQ_P0110BzlJineOstPoKatastrech write FQ_P0110BzlJineOstPoKatastrech;
  property  Q_P0135 :TQuery read GetQ_P0135 write FQ_P0135;
  property  Q_P0110ODD :TQuery read GetQ_P0110ODD write FQ_P0110ODD;
  property  AdresarTopolu:string read FAdresarTopolu write FAdresarTopolu;
  function  VyhledejP0110(ODD:integer;DIL,POR,PSK:string;ZeptejSe:Boolean;KolikNacist:TKolikNacist):Boolean;
  function  VyhledejP0135(ODD:integer;ZeptejSe:Boolean):Boolean;
  procedure VyhledejQ_P0110BzlJineOstPoKatastrech(VOddeleni,VDilec,Vporost,VSkupina:string);
  procedure vyhledejQ_P0110ODD;

end;
var TopolNacti:TTopolNacti;
implementation

function tTopolNacti.GetQ_P0110:TQuery;
 begin
  if FQ_P0110=nil then
   begin
    FQ_P0110:=TQuery.create(application.mainform);
   end;
  result:=FQ_P0110;
 end;

function tTopolNacti.GetQ_P0110ODD:TQuery;
 begin
  if FQ_P0110ODD=nil then
   begin
    FQ_P0110ODD:=TQuery.create(application.mainform);
   end;
  result:=FQ_P0110ODD;
 end;

function tTopolNacti.GetQ_P0135:TQuery;
 begin
  if FQ_P0135=nil then
   begin
    FQ_P0135:=TQuery.create(application.mainform);
   end;
  result:=FQ_P0135;
 end;


function tTopolNacti.GetQ_P0110BzlJineOst:TQuery;
 begin
  if FQ_P0110BzlJineOst=nil then
   begin
    FQ_P0110BzlJineOst:=TQuery.create(application.mainform);
   end;
  result:=FQ_P0110BzlJineOst;
 end;

function tTopolNacti.GetQ_P0110BzlJineOstPoKatastrech:TQuery;
 begin
  if FQ_P0110BzlJineOstPoKatastrech=nil then
   begin
    FQ_P0110BzlJineOstPoKatastrech:=TQuery.create(application.mainform);
   end;
  result:=FQ_P0110BzlJineOstPoKatastrech;
 end;
procedure tTopolNacti.vyhledejQ_P0110ODD;
 begin
    if Q_P0110ODD.active then Q_P0110ODD.close;
    with Q_P0110ODD.SQL do
     begin
      clear;
      add('select distinct ODDELENI  from ');
      // showmessage('select distinct ODDELENI  from ');
      add(chr(39)+AdresarTopolu{+'\P0110.dbf'}+chr(39));
      // showmessage(chr(39)+AdresarTopolu{+'\P0110.dbf'}+chr(39));
      try
       Q_P0110ODD.open;
      except
       showmessage('Nemohu otevt tabulku P0110ODD');
      end;
    end;
 end;

procedure tTopolNacti.VyhledejQ_P0110BzlJineOstPoKatastrech(VOddeleni,VDilec,Vporost,VSkupina:string);
 begin
    if Q_P0110BzlJineOstPoKatastrech.active then Q_P0110BzlJineOstPoKatastrech.close;
    with Q_P0110BzlJineOstPoKatastrech.SQL do
     begin
      clear;
      add('Select * from ');
      add(chr(39)+AdresarTopolu+'\P0110.dbf'+chr(39));
      add('where ((ODDELENI='''+VOddeleni+''')and(DILEC='''+Vdilec+''')and(POROST='''+Vporost+''')and(SKUPINA='''+Vskupina+''')');
      add('ORDER BY DILEC,POROST,SKUPINA ;');
      try
       Q_P0110BzlJineOstPoKatastrech.open;
      except
       showmessage('Nemohu otevt tabulku "');
      end;
    end;
 end;

function tTopolNacti.VyhledejP0110(ODD:integer;DIL,POR,PSK:string;ZeptejSe:Boolean;KolikNacist:TKolikNacist) :Boolean;
var DotazF1:tDotazF1;
    SS :String;
    ssa:WideString;
    iniText:TIniFile;
procedure NajdiP0110;
 begin
  jeok:=0;
  Application.CreateForm(TS_VyhlSoub1, S_VyhlSoub1);
  S_VyhlSoub1.caption:='Vyhledej P0110.DBF ve kter je oddlen '+intToStr(ODD)+' .';
  S_VyhlSoub1.fileListBox1.mask := 'P0110.DBF';
  initext:=Tinifile.create(KPoslednimuZnaku(Application.ExeName,'\')+'\vtx.ini');
  TopAdr:=iniText.ReadString('DATABASE','TOPOL','C:\');
  try
  S_VyhlSoub1.DirectoryListBox1.Directory:=
         KPoslednimuZnaku(topAdr,'\');
  except
   S_VyhlSoub1.DirectoryListBox1.Directory:='C:\';
  end;
  if ZeptejSe then S_VyhlSoub1.showmodal
     else S_VyhlSoub1.Vybrano:=True ;
  if S_VyhlSoub1.Vybrano then
   begin
    topAdr:=S_VyhlSoub1.DirectoryListBox1.Directory+'\P0110.dbf';
    {
    FPrazd1.Query1.active:=false;
    with FPrazd1.Query1.SQL do
     begin
      clear;
      add('Select * from ');
      add(chr(39)+topAdr+chr(39));
      case KolikNacist of
       nacOddeleni:add('where (ODDELENI='+intToStr(ODD)+')');
       nacDilec:add('where ((ODDELENI='+intToStr(ODD)+')and(DILEC='''+DIL+'''))');
       nacPorost:add('where ((ODDELENI='+intToStr(ODD)+')and(DILEC='''+DIL+''')and(POROST='''+POR+'''))');
       NacSkupinu:add('where ((ODDELENI='+intToStr(ODD)+')and(DILEC='''+DIL+''')and(POROST='''+POR+''')and(SKUPINA='''+ubm(PSK)+'''))');
      end; //case
      add('ORDER BY DILEC,POROST,SKUPINA ;');
     end;
    FPrazd1.Query1.open;
    }
    with Q_P0110.SQL do
     begin
      clear;
      add('Select * from ');
      add(chr(39)+topAdr+chr(39));
      case KolikNacist of
       nacOddeleni:add('where (ODDELENI='+intToStr(ODD)+')');
       nacDilec:add('where ((ODDELENI='+intToStr(ODD)+')and(DILEC='''+DIL+'''))');
       nacPorost:add('where ((ODDELENI='+intToStr(ODD)+')and(DILEC='''+DIL+''')and(POROST='''+POR+'''))');
       NacSkupinu:add('where ((ODDELENI='+intToStr(ODD)+')and(DILEC='''+DIL+''')and(POROST='''+POR+''')and(SKUPINA='''+ubm(PSK)+'''))');
      end; //case
      add('ORDER BY DILEC,POROST,SKUPINA ;');

      // ssa:=Q_P0110.SQL.Strings[0]+' '+Q_P0110.SQL.Strings[1]+' '+Q_P0110.SQL.Strings[2];
      // showmessage(ssa);

      try
       Q_P0110.open;
       {
       while not FPrazd1.Query1.eof do
        begin
         if ubm(FPrazd1.Query1.FieldByName('Poznamka').asstring)<>'' then
          begin
           showmessage('cau kk '+ FPrazd1.Query1.FieldByName('Poznamka').asstring);
          end;
         FPrazd1.Query1.next;
        end;
        FPrazd1.Query1.first;
        }
       {
       // cau
       ssa:='';
       while not Q_P0110.eof  do
        begin
         ssa:=ssa+Q_P0110.fieldbyNAme('DILEC').asstring+Q_P0110.fieldbyNAme('SKUPINA').asstring+',';
         Q_P0110.next;
        end;
       showmessage(ssa);
       Q_P0110.first;
       }
       // konec cau
       if (Q_P0110.findfield('PLOCHA')=nil)and(Q_P0110.findfield('VYMERA')=nil) then
        begin
         jeOK:=2;
        end;
       if (Q_P0110.findfield('CISLO')=nil)  then
        begin
         jeOK:=4;
        end;
       Q_P0110.first;
       if Q_P0110.eof then
        begin
         jeOK:=3;
        end;
        iniText.writeString('DATABASE','TOPOL',topAdr);
      except
       jeOK:=1;
      end;
    end;
  end
 else
  begin
   koncime:=true;
  end;
 initext.free;
 S_vyhlSoub1.free;
end;
begin
 repeat
  koncime:=false;
  NajdiP0110;
  if koncime then continue;
  if jeOk=0 then AdresarTopolu:=topAdr;
  if jeOk<>0 then
   begin
    zeptejSe:=true;
    Application.CreateForm(TDotazf1, DotazF1);
    dotazf1.width:=round(dotazf1.width*1.4);
    dotazf1.activecontrol := dotazf1.OkBtn;
    dotazf1.odpoved:=false;
    case jeOK of
     1:begin
        dotazf1.label1.caption:='Z tabulku vmr z topolu "'+topAdr+'" nelze otevt.';
        dotazf1.label2.caption:='Vyhledat jinou tabulku vmr?';
       end;
     2:begin
        dotazf1.label1.caption:='V tabulce vmr z topolu "'+topAdr+'" chyb plocha.';
        dotazf1.label2.caption:='Vyhledat jinou tabulku vmr?';
       end;
     3:begin
        dotazf1.label1.caption:='V tabulce vmr z topolu "'+topAdr+'" nen oddlen '
        +intToStr(odd)+' .';
        dotazf1.label2.caption:='Vyhledat jinou tabulku vmr?';
       end;
     4:begin
        dotazf1.label1.caption:='V tabulce vmr z topolu "'+topAdr+'" chyb kolonka slo plochy. ';
        dotazf1.label2.caption:='Vyhledat jinou tabulku vmr?';
       end;
    end; {case}
   dotazf1.showmodal;
   koncime:= not dotazf1.odpoved=true;
   dotazf1.destroy;
  end;{if jeO}
 until ((JeOk=0) or (koncime));
 result:=not koncime;
end;



function tTopolNacti.VyhledejP0135(ODD:integer;ZeptejSe:Boolean) :Boolean;
var DotazF1:tDotazF1;
    topAdr :String;
    iniText:TIniFile;
procedure NajdiP0135;
 begin
  jeok:=0;
  Application.CreateForm(TS_VyhlSoub1, S_VyhlSoub1);
  S_VyhlSoub1.caption:='Vyhledej P0135.DBF ve kter je oddlen '+intToStr(ODD)+' .';
  S_VyhlSoub1.fileListBox1.mask := 'P0135.DBF';
  initext:=Tinifile.create(KPoslednimuZnaku(Application.ExeName,'\')+'\vtx.ini');
  TopAdr:=iniText.ReadString('DATABASE','TOPOL','C:\wtx');
  try
  S_VyhlSoub1.DirectoryListBox1.Directory:=
         KPoslednimuZnaku(topAdr,'\');
  except
   S_VyhlSoub1.DirectoryListBox1.Directory:='C:\';
  end;
  if ZeptejSe then S_VyhlSoub1.showmodal
     else S_VyhlSoub1.Vybrano:=True ;
  if S_VyhlSoub1.Vybrano then
   begin
    topAdr:=S_VyhlSoub1.DirectoryListBox1.Directory+'\P0135.dbf';
    with Q_P0135.SQL do
     begin
      clear;
      add('Select * from ');
      add(chr(39)+topAdr+chr(39));
      add('where (ODDELENI='+intToStr(ODD)+')');
      add('ORDER BY DILEC,POROST,SKUPINA ;');
      try
       Q_P0135.open;
       if (Q_P0135.findfield('PLOCHA')=nil)and(Q_P0135.findfield('VYMERA')=nil) then
        begin
         jeOK:=2;
        end;
       if (Q_P0135.findfield('CISLO')=nil)  then
        begin
         jeOK:=4;
        end;
       Q_P0135.first;
       if Q_P0135.eof then
        begin
         jeOK:=3;
        end;
        iniText.writeString('DATABASE','TOPOL',topAdr);
      except
       jeOK:=1;
      end;
    end;
  end
 else
  begin
   koncime:=true;
  end;
 initext.free;
 S_vyhlSoub1.free;
end;





begin
 repeat
  koncime:=false;
  NajdiP0135;
  if koncime then continue;
  if jeOk=0 then AdresarTopolu:=topAdr;
  if jeOk<>0 then
   begin
    zeptejSe:=true;
    Application.CreateForm(TDotazf1, DotazF1);
    dotazf1.width:=round(dotazf1.width*1.4);
    dotazf1.activecontrol := dotazf1.OkBtn;
    dotazf1.odpoved:=false;
    case jeOK of
     1:begin
        dotazf1.label1.caption:='Z tabulku vmr z topolu "'+topAdr+'" nelze otevt.';
        dotazf1.label2.caption:='Vyhledat jinou tabulku vmr?';
       end;
     2:begin
        dotazf1.label1.caption:='V tabulce vmr z topolu "'+topAdr+'" chyb plocha.';
        dotazf1.label2.caption:='Vyhledat jinou tabulku vmr?';
       end;
     3:begin
        dotazf1.label1.caption:='V tabulce vmr z topolu "'+topAdr+'" nen oddlen '
        +intToStr(odd)+' .';
        dotazf1.label2.caption:='Vyhledat jinou tabulku vmr?';
       end;
     4:begin
        dotazf1.label1.caption:='V tabulce vmr z topolu "'+topAdr+'" chyb kolonka slo plochy. ';
        dotazf1.label2.caption:='Vyhledat jinou tabulku vmr?';
       end;
    end; {case}
   dotazf1.showmodal;
   koncime:= not dotazf1.odpoved=true;
   dotazf1.destroy;
  end;{if jeO}
 until ((JeOk=0) or (koncime));
 result:=not koncime;
end;


end.
