unit LesCisOr;

interface
uses SysUtils,stdctrls,Dialogs,DBTables,DB,Forms,Elements,
     vratTab, ELesObec,mat1,SpOraLCR;
const
 MaxFSlLesTyp=35;

type
TObsahPhsIni = class(TObecnyLesniPrvek)
private
 FStrana1:Longint;
 Fjazyk:Tjazyk;
 FStrana_Pozadovana_k_tisku:Longint ;
 FPenWidth3:integer ;
 FTisknoutMajitele:Boolean ;
 FTisknoutNasobnost:Boolean ;
 FmistoDilcePorost:Boolean ;
 FdilecIPorost:Boolean ;
 FtiskniEvidenciLCR:Boolean ;
 FtiskniEvidenciObce:Boolean ;
 FlevaPrava:Integer ;
 FtisknoutDruh_maj:Boolean ;
 FtisknoutOdb_hosp:Boolean ;
 FtisknoutPlDrZal:Boolean ;
 FZhustene:Boolean ;
 FmistoRelSchw:Boolean ;
 Fvymeru:Boolean ;
 FnasobneZasahy:Boolean ;
 Ft0vimisich:Boolean ;
 FAniDilecAniPorost:Boolean ;
public
 property jazyk:Tjazyk read Fjazyk write Fjazyk;
published
 property Strana1:Longint read FStrana1 write FStrana1;
 property Strana_Pozadovana_k_tisku:Longint read FStrana_Pozadovana_k_tisku write FStrana_Pozadovana_k_tisku;
 property PenWidth3:integer read FPenWidth3 write FPenWidth3;
 property TisknoutMajitele:Boolean read FTisknoutMajitele write FTisknoutMajitele;
 property TisknoutNasobnost:Boolean read FTisknoutNasobnost write FTisknoutNasobnost;
 property mistoDilcePorost:Boolean read FmistoDilcePorost write FmistoDilcePorost;
 property dilecIPorost:Boolean read FdilecIPorost write FdilecIPorost;
 property tiskniEvidenciLCR:Boolean read FtiskniEvidenciLCR write FtiskniEvidenciLCR;
 property tiskniEvidenciObce:Boolean read FtiskniEvidenciObce write FtiskniEvidenciObce;
 property levaPrava:Integer read FlevaPrava write FlevaPrava;
 property tisknoutDruh_maj:Boolean read FtisknoutDruh_maj write FtisknoutDruh_maj;
 property tisknoutOdb_hosp:Boolean read FtisknoutOdb_hosp write FtisknoutOdb_hosp;
 property tisknoutPlDrZal:Boolean read FtisknoutPlDrZal write FtisknoutPlDrZal;
 property Zhustene:Boolean read FZhustene write FZhustene;
 property mistoRelSchw:Boolean read FmistoRelSchw write FmistoRelSchw;
 property vymeru:Boolean read Fvymeru write Fvymeru;
 property nasobneZasahy:Boolean read FnasobneZasahy write FnasobneZasahy;
 property t0vimisich:Boolean read Ft0vimisich write Ft0vimisich;
 property AniDilecAniPorost:Boolean read FAniDilecAniPorost write FAniDilecAniPorost;
end;

TKodPopis  = class(TObecnyLesniPrvek)
private
 FKod:string;
 FPopis:string;
published
 property Kod:string read FKod write FKod;
 property Popis:string read FPopis write FPopis;
end;

TKodPopisMN  = class(TLesniMnozina)
private
public
  constructor Create; override;
end;

TKodPlocha  = class(TObecnyLesniPrvek)
private
 FKod:string;
 FPlocha:double;
published
 property Kod:string read FKod write FKod;
 property Plocha:double read FPlocha write FPlocha;
end;

TKodPlochaMN  = class(TLesniMnozina)
private
public
  constructor Create; override;
end;


TKodPlochaZAST  = class(TKodPlocha)
private
  FZastPl:double;
published
 property Kod:string read FKod write FKod;
 property ZastPl:double read FZastPL write FZastPL;
end;

TKodPlochaZASTMN  = class(TLesniMnozina)
private
public
  constructor Create; override;
end;



TOrgUr    = class(TKodPopis)
private
published
 property LHC_KOD:LongInt read GetLHC_KODOwnEnt stored false;
end;

TOrgUrMN  = class(TKodPopisMN)
private
public
  constructor Create; override;
end;

TCisSCHU  = class(TObecnyLesniPrvek)
private
 FSCHU_KOD:LongInt;
 FSCHU_NAZEV:String;
 FSCHU_SML:String;
 FSCHU_POPIS:String;
published
 property SCHU_KOD:LongInt read FSCHU_KOD write FSCHU_KOD;
 property SCHU_NAZEV:string read FSCHU_NAZEV write FSCHU_NAZEV;
 property SCHU_SML:string read FSCHU_SML write FSCHU_SML;
 property SCHU_POPIS:string read FSCHU_POPIS write FSCHU_POPIS;
 property LHC_KOD:LongInt read GetLHC_KODOwnEnt stored false;
end;

TCisSCHUMN  = class(TLesniMnozina)
private
public
  constructor Create; override;
end;


TTypRozhodnuti  = class(TObecnyLesniPrvek)
private
 FTyp_Dokum:string;
 FKod:string;
 FPopis:string;
 function GetJedinecnyTyp:string;
published
 property Typ_Dokum:string read FTyp_Dokum write FTyp_Dokum;
 property Kod:string read FKod write FKod;
 property Popis:string read FPopis write FPopis;
 property JedinecnyTyp:string  read GetJedinecnyTyp stored false;

end;

TTypRozhodnutiMN  = class(TLesniMnozina)
private
public
  constructor Create; override;
end;


TKrnapRSH = class(TObecnyLesniPrvek)
 private
 public
  TVL:integer;
  SLT_LT:Array[1..10] of stringdr;
  MNG:Array[1..4] of integer;
  HL_DR:Array[1..4] of stringdr;
  ZAST_DR:Array[1..4] of integer;
  JePritomnaVeSK50:Array[1..4] of boolean;
  JePritomnaVeSK75:Array[1..4] of boolean;
  V_DR:Array[1..7] of stringdr;

  Procedure ZaradDoHL_DR(vHl_DR:string;vZAST:double);

  Function JeV_DR(vV_DR:string):boolean;
  Function ZASTdleHl_DR(vHl_DR:string):integer;
  Function SumZASTHl_DR:integer;
  Function VsechnyHlDrBylyPritomny75:boolean;
  Function VsechnyHlDrBylyPritomny50:boolean;
  procedure VynulujJePritomnaVeSK;

 published
 end;

TKrnapRSHMN  = class(TLesniMnozina)
private
public
  function  NajdiVhodnyRadek(vTVL:integer;vLT:stringdr;vMNG:integer):TKrnapRSH;
  procedure Nactise(Table1:TTable);
  constructor Create; override;
end;

TTransforDleMajitele= class(TObecnyLesniPrvek)
private
   FODD      :Integer;
   FDIL      :String;
   FPOR      :String;
 //  FPSK      :String;
   FMAJ_DRUH :Integer;
   FMAJ_KOD  :string;
   FZmena    :TTypZmeny;
   function  GetZmena_Nazev:string;
   procedure SetZmena_Nazev(s:string);
   function  GetCeleOzn:string;
   function  GetOddDilPor:string;
public
  property  Zmena    :TTypZmeny read FZmena    write FZmena;
published
  property  ODD      :Integer read FODD      write FODD;
  property  DIL      :String  read FDIL      write FDIL;
  property  POR      :String  read FPOR      write FPOR;
//   property  PSK      :String  read FPSK      write FPSK;
  property  MAJ_DRUH :Integer read FMAJ_DRUH write FMAJ_DRUH;
  property  MAJ_KOD  :string read FMAJ_KOD  write FMAJ_KOD;
  property  Zmena_nazev:string read GetZmena_Nazev write SetZmena_Nazev;
  property  celeOzn:string read GetCeleOzn stored false;
  property  OddDilPor:string read GetOddDilPor stored false;
end;

TTransforDleMajiteleMN = class(TLesniMnozina)
private
public
  FIndexPrvniho:Integer;
  FPocet:Integer;
  procedure vypisSeDoMema(memo:Tmemo);
  constructor Create; override;
end;

TMajPoPorostech = class(TObecnyLesniPrvek)
private
   FMAJ_DRUH :Integer;
   FMAJ_KOD  :string;
   FODD      :Integer;
   FDIL      :String;
   FPOR      :String;
   FPSK      :String;
   FJP       :Integer;
   FKU_KOD   :LongInt;
   FOLH      :String;
   function  GetODD_DIL_POR:String;
   function  GetODD_DIL_PORtr:String;
  procedure SetPSK(VPSK:String);
published
  property  MAJ_DRUH :Integer read FMAJ_DRUH write FMAJ_DRUH;
  property  MAJ_KOD  :String read FMAJ_KOD write FMAJ_KOD;
  property  ODD      :Integer read FODD write FODD;
  property  DIL      :String  read FDIL write FDIL;
  property  POR      :String  read FPOR write FPOR;
  property  PSK      :String  read FPSK write SetPSK;
  property  JP       :Integer read FJP write FJP;
  property  KU_KOD   :LongInt read FKU_KOD write FKU_KOD;
  property  ODD_DIL_POR:String read GetODD_DIL_POR stored false;
  property  ODD_DIL_PORtr:String read GetODD_DIL_PORtr stored false;
  property  OLH      :String  read FOLH write FOLH;
end;

TMajPoPorostechMN = class(TLesniMnozina)
private
public
  constructor Create; override;
  function NajdiMAJ_DRUH_MAJ_KOD_ODD_DIL_POR_JP_KU_KOD
  (vMAJ_DRUH:Integer;vMAJ_KOD:string;vODD:Integer;vDIL,vPOR:string;VJP:integer;vKU_KOD:longInt):TMajPoPorostech;
end;



Tmajetky = class(TObecnyLesniPrvek)
private
 FMAJ_KOD:string;  //ciselnik  //navrat
 FMAJ_KOD0:string;
 FKU_KOD:string;   //ciselnik
 FMAJ_NAZ:string;  //ciselnik
 FMAJ_DRUH:string; //ciselnik  //navrat
 FLV:string;       //ciselnik  //navrat
 // FOLH:String;

 FPARCIS:string;   //ciselnik
 FPARPOD:string;   //ciselnik
 FPARDIL:string;   //ciselnik
 FPARVYM:string;   //ciselnik
 FDRUH_POZ:string; //ciselnik
 FPUPFL:string;    //ciselnik
 FTEZB_VYP : LongInt;  // navrat
 FTEZB_MAX : Longint; // navrat
 FLesniPoz : Double;  // navrat
 FJinePoz  : Double;   // navrat
 FRodneCis : String;   // navrat
 FJmePrijm : String;   // navrat
 FICO      : String;   // navrat
 FObchodJm : String;   // navrat
 FZastupce : String;   // navrat
 FPSC      : longInt;  // navrat
 FAdrObec  : String;   // navrat
 FAdrUlice : String;   // navrat
 FAdrCDomu : String;   // navrat
 FObec     : String;   // navrat
 FOSTATNI  : String;   // navrat
 FKOD      : LongInt;  // navrat
 FDOPLKOD  : LongInt;  // navrat
 FCISJEDN  : String;   // navrat
 FDATVYDANI: String;    // navrat
 FUZIVATEL : String;   // navrat
 FZADATEL  : String;   // navrat
 FCISORG   : String;   // navrat
 FODB_SPR  : String;   // navrat
 FNAJDATE  : String;     // navrat
 FNAJPLAT  : String;     // navrat
 FCJ_ROZHOD: String;   // navrat
 FNAHRADA  : String;   // navrat
 FPOZN     : String;   // navrat
 FUZIV     : String;   // navrat
 FDOHODA   : String;   // navrat
 FLES_URAD_nazev :String;  //prot o predani
 FCjOU     :String;  //prot o predani

 FJmePrijmZpln:String;  //prot o predani
 FPSCZpln     :String;  //prot o predani
 FEMailZpln   :String;  //prot o predani
 FObecZpln    :String;  //prot o predani
 FTelefonZpln :String;  //prot o predani
 FUliceZpln   :String;  //prot o predani
 FCDomuZpln   :String;  //prot o predani
 FFaxZpln     :String;  //prot o predani

 FVPred       :String;  //prot o predani
 FDnePred     :String;  //prot o predani
 FPrilohyPred :String;  //prot o predani
 FZastOU      :String;  //prot o predani
 FPSC_txt     :String;   // navrat

 FTEZB_VYCH : LongInt;
 FZAS_CEL : Longint;
 FPoznamkaDoMapy:string;
 OLH1:string;
 OLH2:string;
 OLH3:string;

 FMajPoPorostechMN:TMajPoPorostechMN;
 FFMajPoPorostechOLH1MN:TMajPoPorostechMN;
 FFMajPoPorostechOLH2MN:TMajPoPorostechMN;
 FFMajPoPorostechOLH3MN:TMajPoPorostechMN;

 function GetMajPoPorostechMN:TMajPoPorostechMN;

 function GetFMajPoPorostechOLH1MN:TMajPoPorostechMN;
 function GetFMajPoPorostechOLH2MN:TMajPoPorostechMN;
 function GetFMajPoPorostechOLH3MN:TMajPoPorostechMN;

 function GetMajPoPorostechOLH1MN:TMajPoPorostechMN;
 function GetMajPoPorostechOLH2MN:TMajPoPorostechMN;
 function GetMajPoPorostechOLH3MN:TMajPoPorostechMN;
 function GetNamePorostu:string;
 function GetNamePorostuOLH1:string;
 function GetNamePorostuOLH2:string;
 function GetNamePorostuOLH3:string;
 procedure SetNamePorostuOLH1(vOLH:String);
 procedure SetNamePorostuOLH2(vOLH:String);
 procedure SetNamePorostuOLH3(vOLH:String);
 function GetMAJ_KOD0:string;
 procedure SET_MAJ_NAZ_Stehlik(SMAJ_NAZ:String);
 function  getPSC_txt_C:string;
 procedure SetPSC_txt_C(s:String);
 function  GetLesniPoz : Double;
 function  GetJinePoz: Double;
 function  getMAJ_NAZ_C1:string;
 function  getMAJ_NAZ_C2:string;
 procedure SET_MAJ_NAZ_C2(SMAJ_NAZ_C2:String);

public
 property   MajPoPorostechMN:TMajPoPorostechMN read GetMajPoPorostechMN write FMajPoPorostechMN;

 property   BMajPoPorostechOLH1MN:TMajPoPorostechMN read GetFMajPoPorostechOLH1MN;
 property   BMajPoPorostechOLH2MN:TMajPoPorostechMN read GetFMajPoPorostechOLH2MN;
 property   BMajPoPorostechOLH3MN:TMajPoPorostechMN read GetFMajPoPorostechOLH3MN;

 property   MajPoPorostechOLH1MN:TMajPoPorostechMN read GetMajPoPorostechOLH1MN;
 property   MajPoPorostechOLH2MN:TMajPoPorostechMN read GetMajPoPorostechOLH2MN;
 property   MajPoPorostechOLH3MN:TMajPoPorostechMN read GetMajPoPorostechOLH3MN;

 constructor Create; override;
published
 property  MAJ_KOD_C:string read FMAJ_KOD write FMAJ_KOD;
 property  MAJ_KOD_C0:string read GetMAJ_KOD0 write FMAJ_KOD0;
 property  KU_KOD_C:string read FKU_KOD write FKU_KOD;
 property  MAJ_NAZ_C:string read FMAJ_NAZ write FMAJ_NAZ;
 property  MAJ_NAZ_C1:string read getMAJ_NAZ_C1 write FMAJ_NAZ;
 property  MAJ_NAZ_C2:string read getMAJ_NAZ_C2 write SET_MAJ_NAZ_C2;

 property  MAJ_NAZ_C_DBF:string read FMAJ_NAZ write SET_MAJ_NAZ_Stehlik  stored false;
 property  MAJ_DRUH_C:string read FMAJ_DRUH write FMAJ_DRUH;
 property  OLH_C:string read FODB_SPR write FODB_SPR stored false;

 property  LV_C:string read FLV write FLV;
 property  PARCIS_C:string read FPARCIS write FPARCIS;
 property  PARPOD_C:string read FPARPOD write FPARPOD;
 property  PARDIL_C:string read FPARDIL write FPARDIL;
 property  PARVYM_C:string read FPARVYM write FPARVYM;
 property  DRUH_POZ_C:string read FDRUH_POZ write FDRUH_POZ;
 property  PUPFL_C:string read FPUPFL write FPUPFL;
 property  TEZB_VYP_C : LongInt read FTEZB_VYP write FTEZB_VYP;
 property  TEZB_MAX_C : Longint read FTEZB_MAX write FTEZB_MAX;
 property  LesniPoz_C : Double read GetLesniPoz write FLesniPoz;
 property  JinePoz_C  : Double read GetJinePoz write FJinePoz;
 property  RodneCis_C : String read FRodneCis write FRodneCis;
 property  JmePrijm_C : String read FJmePrijm write FJmePrijm;
 property  ICO_C      : String read FICO write FICO;
 property  ObchodJm_C : String read FObchodJm write FObchodJm;
 property  Zastupce_C : String read FZastupce write FZastupce;
 property  PSC_C      : longInt read FPSC write FPSC;
 property  AdrObec_C  : String read FAdrObec write FAdrObec;
 property  AdrUlice_C : String read FAdrUlice write FAdrUlice;
 property  AdrCDomu_C : String read FAdrCDomu write FAdrCDomu;
 property  Obec_C     : String read FObec write FObec;
 property  OSTATNI_C  : String read FOSTATNI write FOSTATNI;
 property  KOD_C      : LongInt read FKOD write FKOD;
 property  DOPLKOD_C  : LongInt read FDOPLKOD write FDOPLKOD;
 property  CISJEDN_C  : String read FCISJEDN write FCISJEDN;
 property  DATVYDANI_C: String read FDATVYDANI write FDATVYDANI;
 property  UZIVATEL_C : String read FUZIVATEL write FUZIVATEL;
 property  ZADATEL_C  : String read FZADATEL write FZADATEL;
 property  CISORG_C   : String read FCISORG write FCISORG;
 property  ODB_SPR_C  : String read FODB_SPR write FODB_SPR;
 property  NAJDATE_C  : String read FNAJDATE write FNAJDATE;
 property  NAJPLAT_C  : String read FNAJPLAT write FNAJPLAT;
 property  CJ_ROZHOD_C: String read FCJ_ROZHOD write FCJ_ROZHOD;
 property  NAHRADA_C  : String read FNAHRADA write FNAHRADA;
 property  POZN_C     : String read FPOZN write FPOZN;
 property  UZIV_C     : String read FUZIV write FUZIV;
 property  DOHODA_C   : String read FDOHODA write FDOHODA;
 property  CjOU_C     : String read FCjOU write FCjOU;
 property  LES_URAD_nazev_C1   : String read FLES_URAD_nazev write FLES_URAD_nazev;

 Property  JmePrijmZpln_C:String read FJmePrijmZpln  write FJmePrijmZpln  ;
 Property  PSCZpln_C     :String read FPSCZpln  write FPSCZpln  ;
 Property  EMailZpln_C   :String read FEMailZpln  write FEMailZpln  ;
 Property  ObecZpln_C    :String read FObecZpln  write FObecZpln  ;
 Property  TelefonZpln_C :String read FTelefonZpln  write FTelefonZpln  ;
 Property  UliceZpln_C   :String read FUliceZpln  write FUliceZpln  ;
 Property  CDomuZpln_C   :String read FCDomuZpln  write FCDomuZpln  ;
 Property  FaxZpln_C     :String read FFaxZpln  write FFaxZpln  ;

 Property  VPred_C       :String read FVPred  write FVPred  ;
 Property  DnePred_C     :String read FDnePred  write FDnePred  ;
 Property  PrilohyPred_C :String read FPrilohyPred  write FPrilohyPred  ;
 Property  ZastOU_C      :String read FZastOU  write FZastOU  ;

 Property  TEZB_VYCH_C : LongInt  read FTEZB_VYCH write FTEZB_VYCH;
 Property  ZAS_CEL_C : Longint    read FZAS_CEL   write FZAS_CEL;
 property  PSC_txt_C     :String read getPSC_txt_C write SetPSC_txt_C;

 property  PoznamkaDoMapy_C:string read FPoznamkaDoMapy write FPoznamkaDoMapy;

 property  NamePorostu:string read GetNamePorostu  stored false;
 property  OLH1_C:string read OLH1 write OLH1 ;
 property  NamePorostuOLH1:string read GetNamePorostuOLH1 write SetNamePorostuOLH1  stored false;
 property  OLH2_C:string read OLH2 write OLH2 ;
 property  NamePorostuOLH2:string read GetNamePorostuOLH2 write SetNamePorostuOLH2  stored false;
 property  OLH3_C:string read OLH3 write OLH3 ;
 property  NamePorostuOLH3:string read GetNamePorostuOLH3 write SetNamePorostuOLH3  stored false;
end;

TOLH = class(TObecnyLesniPrvek)
private
 FKOD:string;
 FJMENO:string;
 FOKR_URAD:string;
 FCIS_LIC:string;
published
 property LHC_KOD:LongInt read GetLHC_KODOwnEnt stored false;
 property KOD:string read FKOD write FKOD;
 property JMENO:string read FJMENO write FJMENO;
 property OKR_URAD:string read FOKR_URAD write FOKR_URAD;
 property CIS_LIC:string read FCIS_LIC write FCIS_LIC;
end;

TMZDHospSoub = class(TObecnyLesniPrvek)
private
 FCISLO_HS:Integer;
 FMZD:Integer;
 FDR_ZKR:string;
 FLT_SLT:string;
 function GetCISLOHS_LTSLT:String;
public
  Destructor Destroy; override;
published
 property LHC_KOD:LongInt read GetLHC_KODOwnEnt stored false;
 property CISLO_HS:Integer read FCISLO_HS write FCISLO_HS;
 property MZD:Integer read FMZD write FMZD;
 property DR_ZKR:string read FDR_ZKR write FDR_ZKR;
 property LT_SLT:string read FLT_SLT write FLT_SLT;
 property CISLOHS_LTSLT:string read getCISLOHS_LTSLT;

end;

TCisHs  = class(TObecnyLesniPrvek)
private
 FCISLO_HS:Integer;
 FNAZEV_HS:string;
 FHOSP_ZP:Integer;
 FOBMYTI:Integer;
 FOBN_DOBA:Integer;
 FMZD:Integer;

 FPOC_PROR:Integer;
 FPOC_PROB:Integer;
 FPOC_MYTKLID:Integer;
 FODVOZ_TEZ:string;
 FJdeDoSestavDTO:string;
 FPovolenaTezbaPod80DleObmyti:string;
 function getPOC_OBNOVY:integer;
 procedure SetJdeDoSestavDTO(VJdeDoSestavDTO:string);
public
 function zasahDlePHS(vek:integer):string;
 constructor Create; override;

published
 property LHC_KOD:LongInt read GetLHC_KODOwnEnt stored false;
 property CISLO_HS:Integer read FCISLO_HS write FCISLO_HS;
 property NAZEV_HS:string read FNAZEV_HS write FNAZEV_HS;
 property HOSP_ZP:Integer read FHOSP_ZP write FHOSP_ZP;
 property OBMYTI:Integer read FOBMYTI write FOBMYTI;
 property OBN_DOBA:Integer read FOBN_DOBA write FOBN_DOBA;
 property POC_OBNOVY:integer read getPOC_OBNOVY stored false;
 property PovolenaTezbaPod80DleObmyti:string read FPovolenaTezbaPod80DleObmyti write FPovolenaTezbaPod80DleObmyti;

 property JdeDoSestavDTO:string read FJdeDoSestavDTO write SetJdeDoSestavDTO;

 property MZD:Integer read FMZD write FMZD;

 property POC_PROR:Integer read FPOC_PROR write FPOC_PROR;
 property POC_PROB:Integer read FPOC_PROB write FPOC_PROB;
 property POC_MYTKLID:Integer read FPOC_MYTKLID write FPOC_MYTKLID;
 property ODVOZ_TEZ:string read FODVOZ_TEZ write FODVOZ_TEZ;

end;

THospSoubPhs   = class(TObecnyLesniPrvek)
private
 FCisRad1:integer;
 procedure SetSlHospSoub0(HS:String);
 function  GetSlHospSoub0:string;

 procedure SetSlHospSoub1(HS:String);
 function  GetSlHospSoub1:string;

 procedure SetSlHospSoub2(HS:String);
 function  GetSlHospSoub2:string;

 procedure SetSlHospSoub3(HS:String);
 function  GetSlHospSoub3:string;

 procedure SetSlHospSoub4(HS:String);
 function  GetSlHospSoub4:string;

 procedure SetSlHospSoub5(HS:String);
 function  GetSlHospSoub5:string;

 procedure SetSlHospSoub6(HS:String);
 function  GetSlHospSoub6:string;

 procedure SetSlHospSoub7(HS:String);
 function  GetSlHospSoub7:string;

 procedure SetSlHospSoub8(HS:String);
 function  GetSlHospSoub8:string;

 procedure SetSlHospSoub9(HS:String);
 function  GetSlHospSoub9:string;

 procedure SetSlHospSoub10(HS:String);
 function  GetSlHospSoub10:string;

 procedure SetSlHospSoub11(HS:String);
 function  GetSlHospSoub11:string;

 procedure SetSlHospSoub12(HS:String);
 function  GetSlHospSoub12:string;

 procedure SetSlHospSoub13(HS:String);
 function  GetSlHospSoub13:string;

 procedure SetSlHospSoub14(HS:String);
 function  GetSlHospSoub14:string;

 procedure SetSlHospSoub15(HS:String);
 function  GetSlHospSoub15:string;

 procedure SetSlHospSoub16(HS:String);
 function  GetSlHospSoub16:string;

 procedure SetSlHospSoub17(HS:String);
 function  GetSlHospSoub17:string;

 procedure SetSlHospSoub18(HS:String);
 function  GetSlHospSoub18:string;

 procedure SetSlHospSoub19(HS:String);
 function  GetSlHospSoub19:string;

 procedure SetSlHospSoub20(HS:String);
 function  GetSlHospSoub20:string;

 procedure SetSlHospSoub21(HS:String);
 function  GetSlHospSoub21:string;

 procedure SetSlHospSoub22(HS:String);
 function  GetSlHospSoub22:string;

 procedure SetSlHospSoub23(HS:String);
 function  GetSlHospSoub23:string;

 procedure SetSlHospSoub24(HS:String);
 function  GetSlHospSoub24:string;

 procedure SetSlHospSoub25(HS:String);
 function  GetSlHospSoub25:string;

 procedure SetSlHospSoub26(HS:String);
 function  GetSlHospSoub26:string;

 procedure SetSlHospSoub27(HS:String);
 function  GetSlHospSoub27:string;

 procedure SetSlHospSoub28(HS:String);
 function  GetSlHospSoub28:string;

 procedure SetSlHospSoub29(HS:String);
 function  GetSlHospSoub29:string;

 procedure SetSlHospSoub30(HS:String);
 function  GetSlHospSoub30:string;

 procedure SetSlHospSoub31(HS:String);
 function  GetSlHospSoub31:string;

 procedure SetSlHospSoub32(HS:String);
 function  GetSlHospSoub32:string;

 procedure SetSlHospSoub33(HS:String);
 function  GetSlHospSoub33:string;

 procedure SetSlHospSoub34(HS:String);
 function  GetSlHospSoub34:string;

 procedure SetSlHospSoub35(HS:String);
 function  GetSlHospSoub35:string;
public
 FSlHospSoub:array [0..MaxFSlLesTyp] of string;
 function nejblizsiLevyHS(Sloup:integer):string;
published
 property CisRad1:integer read FCisRad1 write FCisRad1;
 property SlHospSoub0:string  read GetSlHospSoub0 write SetSlHospSoub0;
 property SlHospSoub1:string  read GetSlHospSoub1 write SetSlHospSoub1;
 property SlHospSoub2:string  read GetSlHospSoub2 write SetSlHospSoub2;
 property SlHospSoub3:string  read GetSlHospSoub3 write SetSlHospSoub3;
 property SlHospSoub4:string  read GetSlHospSoub4 write SetSlHospSoub4;
 property SlHospSoub5:string  read GetSlHospSoub5 write SetSlHospSoub5;
 property SlHospSoub6:string  read GetSlHospSoub6 write SetSlHospSoub6;
 property SlHospSoub7:string  read GetSlHospSoub7 write SetSlHospSoub7;
 property SlHospSoub8:string  read GetSlHospSoub8 write SetSlHospSoub8;
 property SlHospSoub9:string  read GetSlHospSoub9 write SetSlHospSoub9;
 property SlHospSoub10:string read GetSlHospSoub10 write SetSlHospSoub10;
 property SlHospSoub11:string read GetSlHospSoub11 write SetSlHospSoub11;
 property SlHospSoub12:string read GetSlHospSoub12 write SetSlHospSoub12;
 property SlHospSoub13:string read GetSlHospSoub13 write SetSlHospSoub13;
 property SlHospSoub14:string read GetSlHospSoub14 write SetSlHospSoub14;
 property SlHospSoub15:string read GetSlHospSoub15 write SetSlHospSoub15;
 property SlHospSoub16:string read GetSlHospSoub16 write SetSlHospSoub16;
 property SlHospSoub17:string read GetSlHospSoub17 write SetSlHospSoub17;
 property SlHospSoub18:string read GetSlHospSoub18 write SetSlHospSoub18;
 property SlHospSoub19:string read GetSlHospSoub19 write SetSlHospSoub19;
 property SlHospSoub20:string read GetSlHospSoub20 write SetSlHospSoub20;
 property SlHospSoub21:string read GetSlHospSoub21 write SetSlHospSoub21;
 property SlHospSoub22:string read GetSlHospSoub22 write SetSlHospSoub22;
 property SlHospSoub23:string read GetSlHospSoub23 write SetSlHospSoub23;
 property SlHospSoub24:string read GetSlHospSoub24 write SetSlHospSoub24;
 property SlHospSoub25:string read GetSlHospSoub25 write SetSlHospSoub25;
 property SlHospSoub26:string read GetSlHospSoub26 write SetSlHospSoub26;
 property SlHospSoub27:string read GetSlHospSoub27 write SetSlHospSoub27;
 property SlHospSoub28:string read GetSlHospSoub28 write SetSlHospSoub28;
 property SlHospSoub29:string read GetSlHospSoub29 write SetSlHospSoub29;
 property SlHospSoub30:string read GetSlHospSoub30 write SetSlHospSoub30;
 property SlHospSoub31:string read GetSlHospSoub31 write SetSlHospSoub31;
 property SlHospSoub32:string read GetSlHospSoub32 write SetSlHospSoub32;
 property SlHospSoub33:string read GetSlHospSoub33 write SetSlHospSoub33;
 property SlHospSoub34:string read GetSlHospSoub34 write SetSlHospSoub34;
 property SlHospSoub35:string read GetSlHospSoub35 write SetSlHospSoub35;

end;

TLesTypPhs   = class(TObecnyLesniPrvek)
private
 procedure SetSlLesTyp0(LT:String);
 function  GetSlLesTyp0:string;

 procedure SetSlLesTyp1(LT:String);
 function  GetSlLesTyp1:string;

 procedure SetSlLesTyp2(LT:String);
 function  GetSlLesTyp2:string;

 procedure SetSlLesTyp3(LT:String);
 function  GetSlLesTyp3:string;

 procedure SetSlLesTyp4(LT:String);
 function  GetSlLesTyp4:string;

 procedure SetSlLesTyp5(LT:String);
 function  GetSlLesTyp5:string;

 procedure SetSlLesTyp6(LT:String);
 function  GetSlLesTyp6:string;

 procedure SetSlLesTyp7(LT:String);
 function  GetSlLesTyp7:string;

 procedure SetSlLesTyp8(LT:String);
 function  GetSlLesTyp8:string;

 procedure SetSlLesTyp9(LT:String);
 function  GetSlLesTyp9:string;

 procedure SetSlLesTyp10(LT:String);
 function  GetSlLesTyp10:string;

 procedure SetSlLesTyp11(LT:String);
 function  GetSlLesTyp11:string;

 procedure SetSlLesTyp12(LT:String);
 function  GetSlLesTyp12:string;

 procedure SetSlLesTyp13(LT:String);
 function  GetSlLesTyp13:string;

 procedure SetSlLesTyp14(LT:String);
 function  GetSlLesTyp14:string;

 procedure SetSlLesTyp15(LT:String);
 function  GetSlLesTyp15:string;

 procedure SetSlLesTyp16(LT:String);
 function  GetSlLesTyp16:string;

 procedure SetSlLesTyp17(LT:String);
 function  GetSlLesTyp17:string;

 procedure SetSlLesTyp18(LT:String);
 function  GetSlLesTyp18:string;

 procedure SetSlLesTyp19(LT:String);
 function  GetSlLesTyp19:string;

 procedure SetSlLesTyp20(LT:String);
 function  GetSlLesTyp20:string;

 procedure SetSlLesTyp21(LT:String);
 function  GetSlLesTyp21:string;

 procedure SetSlLesTyp22(LT:String);
 function  GetSlLesTyp22:string;

 procedure SetSlLesTyp23(LT:String);
 function  GetSlLesTyp23:string;

 procedure SetSlLesTyp24(LT:String);
 function  GetSlLesTyp24:string;

 procedure SetSlLesTyp25(LT:String);
 function  GetSlLesTyp25:string;

 procedure SetSlLesTyp26(LT:String);
 function  GetSlLesTyp26:string;

 procedure SetSlLesTyp27(LT:String);
 function  GetSlLesTyp27:string;

 procedure SetSlLesTyp28(LT:String);
 function  GetSlLesTyp28:string;

 procedure SetSlLesTyp29(LT:String);
 function  GetSlLesTyp29:string;

 procedure SetSlLesTyp30(LT:String);
 function  GetSlLesTyp30:string;

 procedure SetSlLesTyp31(LT:String);
 function  GetSlLesTyp31:string;

 procedure SetSlLesTyp32(LT:String);
 function  GetSlLesTyp32:string;

 procedure SetSlLesTyp33(LT:String);
 function  GetSlLesTyp33:string;

 procedure SetSlLesTyp34(LT:String);
 function  GetSlLesTyp34:string;

 procedure SetSlLesTyp35(LT:String);
 function  GetSlLesTyp35:string;

public
 FSlLesTyp:array [0..MaxFSlLesTyp] of string;
published
 property SlLesTyp0:string read GetSlLesTyp0 write SetSlLesTyp0;
 property SlLesTyp1:string read GetSlLesTyp1 write SetSlLesTyp1;
 property SlLesTyp2:string read GetSlLesTyp2 write SetSlLesTyp2;
 property SlLesTyp3:string read GetSlLesTyp3 write SetSlLesTyp3;
 property SlLesTyp4:string read GetSlLesTyp4 write SetSlLesTyp4;
 property SlLesTyp5:string read GetSlLesTyp5 write SetSlLesTyp5;
 property SlLesTyp6:string read GetSlLesTyp6 write SetSlLesTyp6;
 property SlLesTyp7:string read GetSlLesTyp7 write SetSlLesTyp7;
 property SlLesTyp8:string read GetSlLesTyp8 write SetSlLesTyp8;
 property SlLesTyp9:string read GetSlLesTyp9 write SetSlLesTyp9;
 property SlLesTyp10:string read GetSlLesTyp10 write SetSlLesTyp10;
 property SlLesTyp11:string read GetSlLesTyp11 write SetSlLesTyp11;
 property SlLesTyp12:string read GetSlLesTyp12 write SetSlLesTyp12;
 property SlLesTyp13:string read GetSlLesTyp13 write SetSlLesTyp13;
 property SlLesTyp14:string read GetSlLesTyp14 write SetSlLesTyp14;
 property SlLesTyp15:string read GetSlLesTyp15 write SetSlLesTyp15;
 property SlLesTyp16:string read GetSlLesTyp16 write SetSlLesTyp16;
 property SlLesTyp17:string read GetSlLesTyp17 write SetSlLesTyp17;
 property SlLesTyp18:string read GetSlLesTyp18 write SetSlLesTyp18;
 property SlLesTyp19:string read GetSlLesTyp19 write SetSlLesTyp19;
 property SlLesTyp20:string read GetSlLesTyp20 write SetSlLesTyp20;
 property SlLesTyp21:string read GetSlLesTyp21 write SetSlLesTyp21;
 property SlLesTyp22:string read GetSlLesTyp22 write SetSlLesTyp22;
 property SlLesTyp23:string read GetSlLesTyp23 write SetSlLesTyp23;
 property SlLesTyp24:string read GetSlLesTyp24 write SetSlLesTyp24;
 property SlLesTyp25:string read GetSlLesTyp25 write SetSlLesTyp25;
 property SlLesTyp26:string read GetSlLesTyp26 write SetSlLesTyp26;
 property SlLesTyp27:string read GetSlLesTyp27 write SetSlLesTyp27;
 property SlLesTyp28:string read GetSlLesTyp28 write SetSlLesTyp28;
 property SlLesTyp29:string read GetSlLesTyp29 write SetSlLesTyp29;
 property SlLesTyp30:string read GetSlLesTyp30 write SetSlLesTyp30;
 property SlLesTyp31:string read GetSlLesTyp31 write SetSlLesTyp31;
 property SlLesTyp32:string read GetSlLesTyp32 write SetSlLesTyp32;
 property SlLesTyp33:string read GetSlLesTyp33 write SetSlLesTyp33;
 property SlLesTyp34:string read GetSlLesTyp34 write SetSlLesTyp34;
 property SlLesTyp35:string read GetSlLesTyp35 write SetSlLesTyp35;
end;

TSpecPodHSPhs   = class(TObecnyLesniPrvek)
private
 FZastoupHS:integer;
 FMinZastoupHS:String;
 FUrciHS:string;
 FPodminHS:String;
published
 property UrciHS    :string read FUrciHS   write FUrciHS;
 property PodminHS  :String read FPodminHS write FPodminHS;
 property ZastoupHS :integer read FZastoupHS write FZastoupHS stored false;
 property MinZastoupHS :String read FMinZastoupHS write FMinZastoupHS;
end;

TProbirkaPhs   = class(TObecnyLesniPrvek)
private
 FDrevina:string;
 FPodminka:String;
 FProcTV1:integer;
 FProcTV2:integer;
 FProcTV3:integer;
 FProcTV4:integer;
 FProcTV5:integer;
 FProcTV6:integer;
 FProcTV7:integer;
 FProcTV8:integer;
 FProcTV9:integer;
 FProcTV10:integer;
 FProcTV11:integer;
 FProcTV12:integer;
 FProcTV13:integer;
 FProcTV14:integer;
 FProcTV15:integer;
 FProcTV16:integer;
 FProcTV17:integer;
 FProcTV18:integer;
 FProcTV19:integer;
 Function GetProcTV(index:integer):integer;
public
 function obsahujeDrevinu(StDrev:string):boolean;
 function ProcTVPodleVeku(vVEK:integer):integer;
 function ProcTVPodleVekuPostaru(vVEK:integer):integer; // platilo do verze '9.0.2.0'
 property ProcTV[index:integer]:integer read GetProcTV;
published
 property Drevina   :string read FDrevina write FDrevina;
 property Podminka  :String read FPodminka write FPodminka;
 property  ProcTV1 :integer read FProcTV1  write FProcTV1 ;
 property  ProcTV2 :integer read FProcTV2  write FProcTV2 ;
 property  ProcTV3 :integer read FProcTV3  write FProcTV3 ;
 property  ProcTV4 :integer read FProcTV4  write FProcTV4 ;
 property  ProcTV5 :integer read FProcTV5  write FProcTV5 ;
 property  ProcTV6 :integer read FProcTV6  write FProcTV6 ;
 property  ProcTV7 :integer read FProcTV7  write FProcTV7 ;
 property  ProcTV8 :integer read FProcTV8  write FProcTV8 ;
 property  ProcTV9 :integer read FProcTV9  write FProcTV9 ;
 property  ProcTV10:integer read FProcTV10 write FProcTV10;
 property  ProcTV11:integer read FProcTV11 write FProcTV11;
 property  ProcTV12:integer read FProcTV12 write FProcTV12;
 property  ProcTV13:integer read FProcTV13 write FProcTV13;
 property  ProcTV14:integer read FProcTV14 write FProcTV14;
 property  ProcTV15:integer read FProcTV15 write FProcTV15;
 property  ProcTV16:integer read FProcTV16 write FProcTV16;
 property  ProcTV17:integer read FProcTV17 write FProcTV17;
 property  ProcTV18:integer read FProcTV18 write FProcTV18;
 property  ProcTV19:integer read FProcTV19 write FProcTV19;
end;



TDrKtgPhs   = class(TObecnyLesniPrvek)
private
 FCisRadku   :integer;
 FKtg_ZvlSt  :string;
 FKtgPhs     :String;
 FZvlStPHS   :String;
 FEVLphs     :String;
 FPOphs      :String;
 FCHKOphs    :String;
 FCHKO_Zphs  :String;
 FNPphs      :String;
 FNP_Zphs    :String;
 FNPPphs     :String;
 FNPRphs     :String;
 FPPphs      :String;
 FPRphs      :String;
 FSCHUphs    :String;
 FSpecPodminka:String;

 FZkrDrev    :string;
 FDrevPodpur :string;

 procedure SetEVLphs(V:string);
 procedure SetPOphs      (V:string);
 procedure SetCHKOphs    (V:string);
 procedure SetCHKO_Zphs  (V:string);
 procedure SetNPphs      (V:string);
 procedure SetNP_Zphs    (V:string);
 procedure SetNPPphs     (V:string);
 procedure SetNPRphs     (V:string);
 procedure SetPPphs      (V:string);
 procedure SetPRphs      (V:string);
 procedure SetSCHUphs    (V:string);
public
// function obsahujeDrevinu(Drev:String):Boolean;
 function obsahujeDrevinu(Drev:String;JeDrevPodpur:Boolean):Boolean;
 function obsahujeKategorii(VKtg_ZvlSt:String):Boolean;
published
 property CisRadku   :integer read  FCisRadku write FCisRadku;
 property Ktg_ZvlSt  :string  read  FKtg_ZvlSt write FKtg_ZvlSt;
 property KtgPhs     :String  read  FKtgPhs write FKtgPhs ;
 property ZvlStPHS   :String  read  FZvlStPHS write FZvlStPHS ;
 property EVLphs     :String  read  FEVLphs write SetEVLphs ;
 property POphs      :String  read  FPOphs write SetPOphs ;
 property CHKOphs    :String  read  FCHKOphs write SetCHKOphs ;
 property CHKO_Zphs  :String  read  FCHKO_Zphs write SetCHKO_Zphs ;
 property NPphs      :String  read  FNPphs write SetNPphs;
 property NP_Zphs    :String  read  FNP_Zphs write SetNP_Zphs ;
 property NPPphs     :String  read  FNPPphs write SetNPPphs ;
 property NPRphs     :String  read  FNPRphs write SetNPRphs ;
 property PPphs      :String  read  FPPphs write SetPPphs ;
 property PRphs      :String  read  FPRphs write SetPRphs ;
 property SCHUphs    :String  read  FSCHUphs write SetSCHUphs ;

 property ZkrDrev:string read FZkrDrev write FZkrDrev;
 property DrevPodpur:string read FDrevPodpur write FDrevPodpur;
 property SpecPodminka:String read FSpecPodminka write FSpecPodminka;
end;



THospSoubPhsMN  = class(TLesniMnozina)
private

public
  function radekDleCisRadku(CisRadku:integer):integer;
  constructor Create; override;
end;

TSpecPodHSPhsMN  = class(TLesniMnozina)
private
public
  constructor Create; override;
end;

TProbirkaPhsMN  = class(TLesniMnozina)
private
public
  constructor Create; override;
end;

TDrKtgPhsMN  = class(TLesniMnozina)
private
  FiKTGaZvlStDohromady:integer;
  function GetKTGaZvlStDohromady:boolean;
  procedure SetKTGaZvlStDohromady(A:boolean);
  function GetiKTGaZvlStDohromady:integer;
  procedure SetiKTGaZvlStDohromady(A:integer);
public
  constructor Create; override;
published
  property iKTGaZvlStDohromady:Integer  read  GetiKTGaZvlStDohromady write SetiKTGaZvlStDohromady;
  property KTGaZvlStDohromady:boolean  read  GetKTGaZvlStDohromady write SetKTGaZvlStDohromady stored false;
end;

TLesTypPhsMN  = class(TLesniMnozina)
private
public
  constructor Create; override;
  function CisloSloupeckuDleLT(lt:String):integer;
end;

TCisHsMN  = class(TLesniMnozina)
private
  function GetHScoNejdouDoSestavDTO:String;
public
  constructor Create; override;
published
  property HScoNejdouDoSestavDTO:String read GetHScoNejdouDoSestavDTO stored false;
end;

TMZDHospSoubMN  = class(TLesniMnozina)
private
public
  procedure TransformujSe;
  constructor Create; override;
end;


TOLHMN  = class(TLesniMnozina)
private
public
  constructor Create; override;
end;

TmajetkyMN  = class(TLesniMnozina)
private
  FTridenoPodle:String;
public
  function NajdiMAJ_DRUH_MAJ_KOD(vMAJ_DRUH,vMAJ_KOD:string):TMajetky;
  procedure kdyzNeniMAJ_DRUH_MAJ_KODTakPridej(VMajetky:TMajetky);
  constructor Create; override;
  function OLH_DLE_MAJ(vMAJ_DRUH,vMAJ_KOD:string; VOdd:integer; VDIL,VPOR,VPSK:String):string;
published
  property TridenoPodle:String read FTridenoPodle write FTridenoPodle;
end;
TVybText  = class(TObecnyLesniPrvek)
private
 FVybTxt:string;
published
 property VybTxt:string read FVybTxt write FVybTxt;
end;

TVybTextMN  = class(TLesniMnozina)
private
public
  constructor Create; override;
end;

TPoznNmdDto = class(TObecnyLesniPrvek)
 private
  FVybPozn_MN:TVybTextMN;
  FVybNMD_MN:TVybTextMN;
  FVybDTO_MN:TVybTextMN;
 public
  procedure ulozSeDoOrbu(kamDir:string);
  procedure nactiSeZOrbu(odkudDir:string);
  property VybPozn_MN  :TVybTextMN read FVybPozn_MN write FVybPozn_MN;
  property VybNMD_MN   :TVybTextMN read FVybNMD_MN write FVybNMD_MN;
  property VybDTO_MN   :TVybTextMN read FVybDTO_MN write FVybDTO_MN;
  constructor Create; override;
 published
 end;


TCiselOrbis = class(TObecnyLesniPrvek)
private
 FOraLCR:TFOraLCR;
 FHospSoubPhsMN:THospSoubPhsMN;
 FLesTypPhsMN:TLesTypPhsMN;
 FDrKtgPhsMN:TDrKtgPhsMN;
 FSpecPodHSPhsMN:TSpecPodHSPhsMN;
 FProbirkaPhsMN:TProbirkaPhsMN;
 FKrnapRSHMN:TKrnapRSHMN;

 FcisHsMN:TCisHsMN;
 FMZDHospSoubMN:TMZDHospSoubMN;
 FOrgUr1MN:TOrgUrMN;
 FOrgUr2MN:TOrgUrMN;
 FOrgUr3MN:TOrgUrMN;
 FCisSCHUMN:TCisSCHUMN;
 FOLHMN1:TOLHMN;
 FKatastryMN:TKodPopisMN;
 FmajetkyMN:TmajetkyMN;
 FTypRozhodnutiMN:TTypRozhodnutiMN;
 function GetOLHMN:TOLHMN;
 procedure SetMajetkyMN(VMajetkyMN:TmajetkyMN);
public
  function  zasahDlePHS(HS,vek:integer):string;
  procedure ulozSeDoOrbuCIS(kamDir:string);
  procedure nactiSeZOrbu(odkudDir:string;hlasitKdyzNeni:boolean);
  procedure SpojSCiselOrbisem(PrCisOrb:TCiselOrbis);
  procedure zTabulkyTypRozhodnutiMN(odkudDiraJm:string);
  procedure DoplnMZDHospSoub(EdInfo:Tedit);
  procedure RozvinMZDHospSoub;
  procedure DoplnMZDHospSoubPuv;

  property HospSoubPhsMN:THospSoubPhsMN read FHospSoubPhsMN;
  property LesTypPhsMN:TLesTypPhsMN read FLesTypPhsMN;
  property DrKtgPhsMN:TDrKtgPhsMN read FDrKtgPhsMN;
  property SpecPodHSPhsMN:TSpecPodHSPhsMN read FSpecPodHSPhsMN;
  property ProbirkaPhsMN:TProbirkaPhsMN read FProbirkaPhsMN;
  property KrnapRSHMN:TKrnapRSHMN read FKrnapRSHMN;

  property cisHsMN:TCisHsMN read FCisHsMN write FCisHsMN;
  property MZDHospSoubMN:TMZDHospSoubMN read FMZDHospSoubMN;
  property OrgUr1MN :TOrgUrMN read FOrgUr1MN;
  property OrgUr2MN :TOrgUrMN read FOrgUr2MN;
  property OrgUr3MN :TOrgUrMN read FOrgUr3MN;
  property CisSCHUMN :TCisSCHUMN read FCisSCHUMN;

  property KatastryMN:TKodPopisMN read FKatastryMN;
  property OLHMN:TOLHMN read getOLHMN write FOLHMN1;
  property majetkyMN:TmajetkyMN read FmajetkyMN write SetMajetkyMN;
  property TypRozhodnutiMN:TTypRozhodnutiMN read FTypRozhodnutiMN write FTypRozhodnutiMN;
  property LOraLCR:TFOraLCR read FOraLCR write FOraLCR;

  constructor Create; override;
end;


function ZMnozinyMNMajPoPorostechMN(mnozinaMN:TLesniMnozina):TMajPoPorostechMN;
function ZtabulkyMajPoPorostechMN(Tb:TTable):TMajPoPorostechMN;
function ZCestyNaTabulkuMajPoPorostechMN(CestaAJmeno:String):TMajPoPorostechMN;
function ZNamePorostuTransformace1
     (VMaj_Kod:string;VMaj_Druh:integer;VNamePorostu:string;
     VTransforDleMajiteleMN:TTransforDleMajiteleMN;Memo:Tmemo):Boolean;

function  VNamePorostuJeNecoSmazano(PuvodniVNamePorostu,NoveVNamePorostu:string):boolean;
function  NajdiPorostVMajetcich(VMajetkyMN:TMajetkyMN;ODD:Integer;DIL,POR,PSK:string;var MajetkyKtereHoObsahuji:TMajetky):TMajPoPorostech;
function  NajdiUcelenyDilecVMajetcich(VMajetkyMN:TMajetkyMN;ODD:Integer;DIL:string):TMajPoPorostech;
function  NajdiUcelenyPorostVMajetcich(VMajetkyMN:TMajetkyMN;ODD:Integer;DIL,POR:string; var MajetkyKtereHoObsahuji:TMajetky):TMajPoPorostech;
// procedure opravPorMajitelePodlePorTransformace(VMajetkyMN:TMajetkyMN;VTransforDleMajitele,MN:TTransforDleMajitele,MN);

Function  VratTezProc(Vek,Obmyti,ObnovniDoba:integer):integer;
Function ProcentoPoNormalniTezbe(Vek,Obmyti,ObnovniDoba:integer):double;

{
procedure NactiCiselOrbis_LCR
  (VCiselOrbis:TCiselOrbis;VFU_DTB_LES:TFU_DTB_LES;VLHC_KOD_ID:string);
}
procedure rozpadniName1PorAZkontroluj(VName1Por:string;var VODD,VDIL,VPOR,VPSK,Chyba:string);
function MajPoPorDleOzn(ODD:Integer;DIL,POR,PSK:string; VMajPoPorostechMN:TMajPoPorostechMN):TMajPoPorostech;
procedure KU6aORP(KU9:longint; Tb9_6Win,tbObce:TTable; var KU6,ORP:longint;var vporadku:Boolean);
function vrat9KUdle3q2002(KU9:longint; tb2001ku3q852:TTable):longint;

function opraveneNamePorostu(VNamePorostu1:String; var NamevPoradku:Boolean):String;
function udelejMAJ_KOD_C0(zCeho:string):string;

var
 vytvaretMZDHospSOUB:boolean;
implementation
uses
   e_Class;
const
{
PolTezProc: array[0..7]    // vekovy stupen - vzdalenost od U
            of array[1..5] // obnovni doba v desitkach let
            of byte =
((  0,  0,  0,  0,  0),
 (  0,  0,  0,  0,  2),
 (  0,  0,  4, 12, 18),
 ( 12, 25, 30, 29, 25),
 ( 86, 67, 50, 40, 33),
 (100,100, 88, 67, 50),
 (100,100,100,100, 88),
 (100,100,100,100,100));
}

PolTezProc: array[0..7]    {vekovy stupen - vzdalenost od U}
            of array[1..6]  {obnovni doba v desitkach let}
            of byte =
((  0,  0,  0,  0,  0, 0),
 (  0,  0,  0,  0,  2, 8),
 (  0,  0,  4, 12, 18,18),
 ( 12, 25, 30, 29, 25,22),
 ( 86, 67, 50, 40, 33,29),
 (100,100, 88, 67, 50,40),
 (100,100,100,100, 88,67),
 (100,100,100,100,100,100));

procedure KU6aORP(KU9:longint; Tb9_6Win,tbObce:TTable; var KU6,ORP:longint;var vporadku:Boolean);
begin
// showmessage('cay '+Tb9_6Win.TableName+'  '+tbObce.TableName);
 with Tb9_6Win do
  begin
   EditKey;
   FieldByName('KATUZ').AsInteger :=KU9;
   GotoNearest;
   if FieldByName('KATUZ').AsInteger<>KU9 then
    begin
     vporadku:=false;
    end
   else
    begin
     vporadku:=true;
    end;
  end;
 KU6:=Tb9_6Win.FieldByName('IDENTCIS').asinteger;
 if tbObce<>nil then
  begin
   ORP:=tbObce.FieldByName('CISORP').asinteger+200000;
  end
 else
  begin
   ORP:=0;
  end;
end;

function vrat9KUdle3q2002(KU9:longint; tb2001ku3q852:TTable):longint;
begin
 // showmessage('cay '+tb2001ku3q852.TableName);
 with tb2001ku3q852 do
  begin
   EditKey;
   FieldByName('N_KATUZ').AsInteger:=KU9;
   GotoNearest;
  end;
 if tb2001ku3q852.FieldByName('N_KATUZ').AsInteger=KU9  then
  begin
   result:=tb2001ku3q852.FieldByName('KATUZ').asinteger;
  end
 else
  begin
   result:=-1;
  end;
end;



function StringJeVeStringu(StrVelky,hlStr:string):boolean;
 var konSt:string;
     i1:integer;
   begin
    strVelky:=ubm(StrVelky);
    result:=false;
    while StrVelky<>'' do
     begin
      konSt:=KPrvnimuZnaku(StrVelky,',');
      if KonSt=HlStr then
       begin
        result:=true;
       end;
      i1:=pos(',',StrVelky);
      if i1>0 then
       begin
        StrVelky:=OdPrvnihoZnaku(StrVelky,',');
       end
      else
       begin
        StrVelky:='';
       end;
     end;
   end;

function TDrKtgPhs.obsahujeDrevinu(Drev:String;JeDrevPodpur:Boolean):Boolean;
 begin
  if not(JeDrevPodpur) then result:=StringJeVeStringu(ZkrDrev,Drev)
  else result:=StringJeVeStringu(DrevPodpur,Drev);
 end;

function TDrKtgPhs.obsahujeKategorii(VKtg_ZvlSt:String):Boolean;
 begin
  result:=StringJeVeStringu(Ktg_ZvlSt,VKtg_ZvlSt);
 end;

function THospSoubPhs.nejblizsiLevyHS(Sloup:integer):string;
 begin
  while ((FSlHospSoub[sloup]='')and(sloup>0)) do
   begin
    dec(Sloup);
   end;
  result:=FSlHospSoub[sloup];
 end;


function TLesTypPhsMN.CisloSloupeckuDleLT(lt:String):integer;
var
 i,i1:integer;
begin
 lt:=upperCase(ubm(LT));
 result:=-1;
 for i:=0 to count-1 do
  begin
   with TLesTypPhs(elements[i]) do
    begin
     for i1:=0 to MaxFSlLesTyp do
      begin
       if FSlLesTyp[i1]=lt then
        begin
         result:=i1;
        end;
      end;
    end;
  end;
 if result=-1 then
  begin
   lt:=copy(LT,1,2);
   result:=-1;
   for i:=0 to count-1 do
    begin
     with TLesTypPhs(elements[i]) do
      begin
       for i1:=0 to MaxFSlLesTyp do
        begin
         if FSlLesTyp[i1]=lt then
          begin
           result:=i1;
          end;
        end;
      end;
    end;
  end;
end;
function THospSoubPhsMN.radekDleCisRadku(CisRadku:integer):integer;
var i:integer;
 begin
  result:=-1;
  for i:=0 to count-1 do
   begin
    if THospSoubPhs(Elements[i]).CisRad1=CisRadku then
     begin
      result:=i;
     end;
   end;
 end;

function TTypRozhodnuti.GetJedinecnyTyp:string;
 begin
  result:=Typ_Dokum+ubm(Kod);
 end;

function ZMnozinyMNMajPoPorostechMN(mnozinaMN:TLesniMnozina):TMajPoPorostechMN;
var
  vMajPoPorostechMN  :TMajPoPorostechMN;
  vMajPoPorostech    :TMajPoPorostech;
  i:integer;
 begin
  vMajPoPorostechMN := TMajPoPorostechMN.create;
  if mnozinaMN.count=0 then
   begin
    result:=vMajPoPorostechMN;
    exit;
   end;
  if not(mnozinaMN.elements[0].HasPropertyByName('ODD')) then
   begin
    showmessage('Mnoina neobsahuje prvky s Propertou "ODD"');
    exit;
   end;
  if not(mnozinaMN.elements[0].HasPropertyByName('DIL')) then
   begin
    showmessage('Mnoina neobsahuje prvky s Propertou "DIL"');
    exit;
   end;
  i:=0;
  while i<mnozinaMN.count do
   begin
    with mnozinaMN.elements[i] do
     begin
      vMajPoPorostech:=TMajPoPorostech.create;
      VMajPoPorostech.ODD:=GetPropertyLongIntByName('ODD');
      VMajPoPorostech.DIL:=GetPropertyStringByName('DIL');
      VMajPoPorostech.POR:=GetPropertyStringByName('POR');
      VMajPoPorostech.PSK:=GetPropertyStringByName('PSK');
     end;
    vMajPoPorostechMN.addElement(VMajPoPorostech);
    inc(i);
   end;
  result:=vMajPoPorostechMN;
 end;


function ZtabulkyMajPoPorostechMN(Tb:TTable):TMajPoPorostechMN;
var
  vMajPoPorostechMN  :TMajPoPorostechMN;
  vMajPoPorostech    :TMajPoPorostech;
 begin
  vMajPoPorostechMN := TMajPoPorostechMN.create;
  if Tb.findfield('ODD')=nil then
   begin
    exit;
   end;
  while not tb.eof do
   begin
    vMajPoPorostech:=TMajPoPorostech.create;
    VMajPoPorostech.ODD:=tb.fieldByName('ODD').asinteger;
    if Tb.findfield('DIL')<>nil then
     begin
      VMajPoPorostech.DIL:=tb.fieldByName('DIL').asstring;
      if Tb.findfield('POR')<>nil then
       begin
        VMajPoPorostech.POR:=tb.fieldByName('POR').asstring;
        if Tb.findfield('PSK')<>nil then
         begin
          VMajPoPorostech.PSK:=tb.fieldByName('PSK').asstring;
         end;
       end;
     end;
    vMajPoPorostechMN.addElement(VMajPoPorostech);
    tb.next;
   end;
  result:=vMajPoPorostechMN;
 end;

function ZCestyNaTabulkuMajPoPorostechMN(CestaAJmeno:String):TMajPoPorostechMN;
var Tb:TTable;
 begin
  Tb:=TTable.create(application.mainform);
  Tb.TableName:=CestaAJmeno;
  Tb.TableType:=ttDefault;
  try
   Tb.open;
   result:=ZtabulkyMajPoPorostechMN(Tb);
   tb.close;
  except
   result:=TMajPoPorostechMN.create;
  end;
  Tb.free;
 end;


function TMajPoPorostechMN.NajdiMAJ_DRUH_MAJ_KOD_ODD_DIL_POR_JP_KU_KOD
        (vMAJ_DRUH:Integer;vMAJ_KOD:string;vODD:Integer;vDIL,vPOR:string;VJP:integer;vKU_KOD:longInt):TMajPoPorostech;
var i:integer;
 begin
  result:=nil;
  for i:=0 to count-1 do
   begin
    with  TMajPoPorostech(Elements[i]) do
     begin
      if    (MAJ_DRUH = vMAJ_DRUH)
       and  (MAJ_KOD  = vMAJ_KOD)
       and  (ODD  = vODD)
       and  (DIL  = vDIL)
       and  (POR  = vPOR)
       and  ((JP  = vJP)or(vJP=-1))
       and  ((KU_KOD  = vKU_KOD)or(vKU_KOD=-1))
       then
       begin
        result:=TMajPoPorostech(Elements[i]);
       end;
     end;
   end;
 end;


function TMajetkyMN.NajdiMAJ_DRUH_MAJ_KOD(vMAJ_DRUH,vMAJ_KOD:string):TMajetky;
var i:integer;
 begin
  result:=nil;
  for i:=0 to count-1 do
   begin
    if    (trim(TMajetky(Elements[i]).MAJ_DRUH_C)=trim(vMAJ_DRUH))
       and (trim(TMajetky(Elements[i]).MAJ_KOD_C)=trim(vMAJ_KOD)) then
     begin
      result:=TMajetky(Elements[i]);
     end;
   end;
 end;
function TMajetkyMN.OLH_DLE_MAJ(vMAJ_DRUH,vMAJ_KOD:string; VOdd:integer; VDIL,VPOR,VPSK:String):string;
var
 VMajetky:TMajetky;
 VMajPoPorostechOLH:TMajPoPorostech;
 begin
  VMajetky:=NajdiMAJ_DRUH_MAJ_KOD(vMAJ_DRUH,vMAJ_KOD);
  if VMajetky=nil then
   begin
    result:='';
   end
  else
   begin
    result:=VMajetky.OLH_C;
    if MajPoPorDleOzn(VODD,VDIL,VPOR,VPSK,VMajetky.bMajPoPorostechOLH1MN)<>nil then
     begin
      result:=VMajetky.OLH1_C;
     end;
    if MajPoPorDleOzn(VODD,VDIL,VPOR,VPSK,VMajetky.bMajPoPorostechOLH2MN)<>nil then
     begin
      result:=VMajetky.OLH2_C;
     end;
    if MajPoPorDleOzn(VODD,VDIL,VPOR,VPSK,VMajetky.bMajPoPorostechOLH3MN)<>nil then
     begin
      result:=VMajetky.OLH3_C;
     end;
   end;
 end;
procedure TMajetkyMN.kdyzNeniMAJ_DRUH_MAJ_KODTakPridej(VMajetky:TMajetky);
var
  NajMajetky:TMajetky;
 begin
  NajMajetky:=NajdiMAJ_DRUH_MAJ_KOD(VMajetky.MAJ_DRUH_C,VMajetky.MAJ_KOD_C);
  if NajMajetky=nil then
   begin
    addelement(VMajetky);
   end
  else
   begin
    if ubm(NajMajetky.OLH_C)<>ubm(VMajetky.OLH_C) then
     begin
      if ubm(NajMajetky.OLH_C)='' then
       begin
        NajMajetky.OLH_C:=VMajetky.OLH_C;
       end
      else
       begin
        if ubm(VMajetky.OLH_C)<>'' then NajMajetky.OLH_C:='Vce OLH';
       end;
     end;
   end;
 end;
constructor Tmajetky.Create;
 begin
  inherited create;
  MAJ_DRUH_C:='0';
  MAJ_KOD_C:='99999';
 end;
procedure TCiselOrbis.zTabulkyTypRozhodnutiMN(odkudDiraJm:string);
var Tb:TTable;
   PKod,Krok:string;
 begin
  Tb:=TTable.create(application.mainform);
  Tb.TableName:=odkudDiraJm;
  Tb.TableType:=ttParadox;
  Tb.ReadOnly:=true;
  Tb.exclusive:=false;
  try
  krok:='1';
  tb.open;
  krok:='2';
  while not Tb.eof do
   begin
  krok:='3';
    FTypRozhodnutiMN.NovyPrvek:=Tb.fieldByName('Typ_Dokum').asstring
                                +'-'+ Tb.fieldByName('Kod').asstring;
    if FTypRozhodnutiMN.AktualniPrvek <>nil then
     begin
  krok:='4';
      with TTypRozhodnuti(FTypRozhodnutiMN.AktualniPrvek) do
       begin
  krok:='5';
         if tb.FindField('Typ_Dokum')<>nil then
          begin
  krok:='6';
           Typ_Dokum:=Tb.fieldByName('Typ_Dokum').asstring;
  krok:='7';
          end;
         if tb.FindField('Kod')<>nil then
          begin
  krok:='8';
           pKod:=Kod;
           Kod      :=Tb.fieldByName('Kod').asstring;
  krok:='9';
          end;
         if tb.FindField('Popis')<>nil then
          begin
  krok:='10';
           Popis    :=Tb.fieldByName('Popis').asstring;
  krok:='11';
          end;
  krok:='12';
       end;
  krok:='13';
     end;
  krok:='14';
    Tb.Next;
  krok:='15';
   end;
 // showmessage('V klidu otvirm v tabulku "'+odkudDiraJm+'".');

  except
   showmessage('Problmy v tabulce "'+odkudDiraJm+'". Volejte horkou linku. Pkod='+PKod+' Krok='+Krok);
  end;
  Tb.Close;
  tb.free;
 end;

constructor TPoznNmdDto.Create;
 begin
  inherited create;
  FVybPozn_MN:=TVybTextMN.create;
  addelement(FVybPozn_MN);
  FVybNMD_MN:=TVybTextMN.create;
  addelement(FVybNMD_MN);
  FVybDTO_MN:=TVybTextMN.create;
  addelement(FVybDTO_MN);
 end;
constructor TCiselOrbis.Create;
 begin
  inherited create;
  FHospSoubPhsMN:=THospSoubPhsMN.create;
  addelement(FHospSoubPhsMN);
  FLesTypPhsMN:=TLesTypPhsMN.create;
  addelement(FLesTypPhsMN);
  FDrKtgPhsMN:=TDrKtgPhsMN.create;
  addelement(FDrKtgPhsMN);
  FSpecPodHSPhsMN:=TSpecPodHSPhsMN.create;
  addelement(FSpecPodHSPhsMN);
  FProbirkaPhsMN:=TProbirkaPhsMN.create;
  addelement(FProbirkaPhsMN);

  FKrnapRSHMN:=TKrnapRSHMN.create;
  addelement(FKrnapRSHMN);

  FcisHsMN:=TcisHsMN.create;
  addelement(FcisHsMN);
  FMZDHospSoubMN:=TMZDHospSoubMN.create;
  addelement(FMZDHospSoubMN);
  FOrgUr1MN:=TOrgUrMN.create;
  FOrgUr1MN.Name:='OrgUr1MN';
  addelement(FOrgUr1MN);
  FOrgUr2MN:=TOrgUrMN.create;
  FOrgUr2MN.Name:='OrgUr2MN';
  addelement(FOrgUr2MN);
  FOrgUr3MN:=TOrgUrMN.create;
  FOrgUr3MN.Name:='OrgUr3MN';
  addelement(FOrgUr3MN);

  FCisSCHUMN:=TCisSCHUMN.create;
  FCisSCHUMN.Name:='CisSCHUMN';
  addelement(FCisSCHUMN);

  FOLHMN1:=TOLHMN.create;
  addelement(FOLHMN1);
  FkatastryMN:=TKodPopisMN.create;
  FkatastryMN.Name:='katastryMN';
  addelement(FkatastryMN);
  FmajetkyMN:=TmajetkyMN.create;
  addelement(FmajetkyMN);
  FTypRozhodnutiMN:=TTypRozhodnutiMN.create;
  addelement(FTypRozhodnutiMN);
  FOraLCR:=nil;
 {


  FTypRozhodnutiMN.NovyPrvek:='1-odneti';
  with TKodPopis(FTypRozhodnutiMN.AktualniPrvek) do
   begin
    Kod:='1';
    Popis:='1 - rozhodnuti o odnt nebo omezen pozemk urench k plnn funkc lesa';
   end;
  FTypRozhodnutiMN.NovyPrvek:='2-Mlad80Let';
  with TKodPopis(FTypRozhodnutiMN.AktualniPrvek) do
   begin
    Kod:='2';
    Popis:='2 - rozhodnut o vjimce ze zkazu mtn tby v porostech mladch 80 let';
   end;
  FTypRozhodnutiMN.NovyPrvek:='3-uznPorost';
  with TKodPopis(FTypRozhodnutiMN.AktualniPrvek) do
   begin
    Kod:='3';
    Popis:='3 - rozhodnut o uznn vbrovch strom a lesnch porost';
   end;
  FTypRozhodnutiMN.NovyPrvek:='4-VelikSec';
  with TKodPopis(FTypRozhodnutiMN.AktualniPrvek) do
   begin
    Kod:='4';
    Popis:='4 - povolen vjimky ze stanoven velikosti nebo ky hol see';
   end;
  FTypRozhodnutiMN.NovyPrvek:='5-Zalesneni';
  with TKodPopis(FTypRozhodnutiMN.AktualniPrvek) do
   begin
    Kod:='5';
    Popis:='5 - povolen vjimky ze zkonn lhty pro zalesnn kultur';
   end;
  FTypRozhodnutiMN.NovyPrvek:='6-Zajisteni';
  with TKodPopis(FTypRozhodnutiMN.AktualniPrvek) do
   begin
    Kod:='6';
    Popis:='6 - povolen vjimky ze zkonn lhty pro zajitn kultur';
   end;
  FTypRozhodnutiMN.NovyPrvek:='7-Poznamka';
  with TKodPopis(FTypRozhodnutiMN.AktualniPrvek) do
   begin
    Kod:='7';
    Popis:='7 - Poznmka';
   end;
  }
 end;
constructor TCisHsMN.Create;
 begin
  inherited create;
  FClass:=TCisHS;
  FPredponaName:='CiHS';
 end;
constructor TMZDHospSoubMN.Create;
 begin
  inherited create;
  FClass:=TMZDHospSoub;
  FPredponaName:='MzdHS';
 end;

constructor TTypRozhodnutiMN.Create;
 begin
  inherited create;
  FClass:=TTypRozhodnuti;
  FPredponaName:='TypRozh';
 end;


constructor TKrnapRSHMN.Create;
 begin
  inherited create;
  FClass:=TKrnapRSH;
  FPredponaName:='KrnapRSH';
 end;

constructor TLesTypPhsMN.Create;
 begin
  inherited create;
  FClass:=TLesTypPhs;
  FPredponaName:='LesTypPhs';
 end;
constructor TDrKtgPhsMN.Create;
 begin
  inherited create;
  FClass:=TDrKtgPhs;
  FPredponaName:='DrKtgPhs';
  KTGaZvlStDohromady:=true;
  // showmessage('Po create ');
 end;
constructor TSpecPodHSPhsMN.Create;
 begin
  inherited create;
  FClass:=TSpecPodHSPhs;
  FPredponaName:='SpecPodHSPhs';
 end;

constructor TCisHs.Create;
 begin
  inherited create;
  PovolenaTezbaPod80DleObmyti:='A';
 end;

constructor TProbirkaPhsMN.Create;
 begin
  inherited create;
  FClass:=TProbirkaPhs;
  FPredponaName:='ProbirkaPhs';
 end;

constructor THospSoubPhsMN.Create;
 begin
  inherited create;
  FClass:=THospSoubPhs;
  FPredponaName:='HospSoubPhs';
 end;

constructor TMajPoPorostechMN.Create;
 begin
  inherited create;
  FClass:=TMajPoPorostech;
  FPredponaName:='MajPoPor';
 end;

constructor TmajetkyMN.Create;
 begin
  inherited create;
  FClass:=Tmajetky;
  FPredponaName:='CiMaj';
 end;
constructor TOLHMN.Create;
 begin
  inherited create;
  FClass:=TOLH;
  FPredponaName:='CiOLH';
 end;
constructor TKodPopisMN.Create;
 begin
  inherited create;
  FClass:=TKodPopis;
  FPredponaName:='KodPop';
 end;
constructor TKodPlochaMN.Create;
 begin
  inherited create;
  FClass:=TKodPlocha;
  FPredponaName:='KodPloch';
 end;

constructor TKodPlochaZASTMN.Create;
 begin
  inherited create;
  FClass:=TKodPlochaZast;
  FPredponaName:='PloZast';
 end;



constructor TVybTextMN.Create;
 begin
  inherited create;
  FClass:=TVybText;
  FPredponaName:='VybTxt';
 end;


constructor TOrgUrMN.Create;
 begin
  inherited create;
  FClass:=TOrgUr;
  FPredponaName:='OrgUr';
 end;

constructor TCisSCHUMN.Create;
 begin
  inherited create;
  FClass:=TCisSCHU;
  FPredponaName:='SCHU';
 end;


function Tmajetky.GetMajPoPorostechMN:TMajPoPorostechMN;
 begin
  if FMajPoPorostechMN=nil then
   begin
    FMajPoPorostechMN:=TMajPoPorostechMN(findElementClass(TMajPoPorostechMN));
    if FMajPoPorostechMN=nil then
     begin
      FMajPoPorostechMN:=TMajPoPorostechMN.create;
      addelement(FMajPoPorostechMN);
     end;
   end;
  result:=FMajPoPorostechMN;
 end;
function Tmajetky.GetFMajPoPorostechOLH1MN:TMajPoPorostechMN;
 begin
  result:=TMajPoPorostechMN(findElementName('MajPoPorostechOLH1MN'));
 end;
function Tmajetky.GetFMajPoPorostechOLH2MN:TMajPoPorostechMN;
 begin
  result:=TMajPoPorostechMN(findElementName('MajPoPorostechOLH2MN'));
 end;
function Tmajetky.GetFMajPoPorostechOLH3MN:TMajPoPorostechMN;
 begin
  result:=TMajPoPorostechMN(findElementName('MajPoPorostechOLH3MN'));
 end;


function Tmajetky.GetMajPoPorostechOLH1MN:TMajPoPorostechMN;
var
 VMajPoPorostechOLH1MN:TMajPoPorostechMN;
 begin
  if bMajPoPorostechOLH1MN=nil then
   begin
      vMajPoPorostechOLH1MN:=TMajPoPorostechMN.create;
      vMajPoPorostechOLH1MN.name:='MajPoPorostechOLH1MN';
      addelement(vMajPoPorostechOLH1MN);
   end;
  result:=bMajPoPorostechOLH1MN;
 end;

function Tmajetky.GetMajPoPorostechOLH2MN:TMajPoPorostechMN;
var
 VMajPoPorostechOLH2MN:TMajPoPorostechMN;
 begin
  if bMajPoPorostechOLH2MN=nil then
   begin
      vMajPoPorostechOLH2MN:=TMajPoPorostechMN.create;
      vMajPoPorostechOLH2MN.name:='MajPoPorostechOLH2MN';
      addelement(vMajPoPorostechOLH2MN);
   end;
  result:=bMajPoPorostechOLH2MN;
 end;

function Tmajetky.GetMajPoPorostechOLH3MN:TMajPoPorostechMN;
var
 VMajPoPorostechOLH3MN:TMajPoPorostechMN;
 begin
  if bMajPoPorostechOLH3MN=nil then
   begin
      vMajPoPorostechOLH3MN:=TMajPoPorostechMN.create;
      vMajPoPorostechOLH3MN.name:='MajPoPorostechOLH3MN';
      addelement(vMajPoPorostechOLH3MN);
   end;
  result:=bMajPoPorostechOLH3MN;
 end;
{
function Tmajetky.GetMajPoPorostechOLHMN:TMajPoPorostechMN;
 begin
  if FMajPoPorostechOLHMN=nil then
   begin
    FMajPoPorostechOLHMN:=TMajPoPorostechMN(findElementClass(TMajPoPorostechMN));
    if FMajPoPorostechOLHMN=nil then
     begin
      FMajPoPorostechOLHMN:=TMajPoPorostechMN.create;
      addelement(FMajPoPorostechOLHMN);
     end;
   end;
  result:=FMajPoPorostechOLHMN;
 end;
}

function Tmajetky.GetNamePorostu:string;
 begin
  if  MajPoPorostechMN.count>100 then
   begin
    result:='pli mnoho';
   end
  else
   begin
    result:=' '+MajPoPorostechMN.ZaSebouStr('ODD_DIL_POR',' ');
   end;
 end;
 function  Tmajetky.GetNamePorostuOLH1:string;
  begin
   if bMajPoPorostechOLH1MN=nil then result:=''
   else
    begin
     result:=' '+bMajPoPorostechOLH1MN.ZaSebouStr('ODD_DIL_POR',' ');
    end;
  end;
 function  Tmajetky.GetNamePorostuOLH2:string;
  begin
   if bMajPoPorostechOLH2MN=nil then result:=''
   else
    begin
     result:=' '+bMajPoPorostechOLH2MN.ZaSebouStr('ODD_DIL_POR',' ');
    end;
  end;
 function  Tmajetky.GetNamePorostuOLH3:string;
  begin
   if bMajPoPorostechOLH3MN=nil then result:=''
   else
    begin
     result:=' '+bMajPoPorostechOLH3MN.ZaSebouStr('ODD_DIL_POR',' ');
    end;
  end;
 function MajPoPorDleOzn(ODD:Integer;DIL,POR,PSK:string; VMajPoPorostechMN:TMajPoPorostechMN):TMajPoPorostech;
  var
   VMajPoPorostech :TMajPoPorostech;
   im:integer;
  begin
   result:=nil;
   if VMajPOPorostechMN=nil then exit;
   for im:=0 to VMajPoPorostechMN.count-1 do
     begin
      VMajPoPorostech:= TMajPoPorostech(VMajPoPorostechMN.elements[im]);
      if    (VMajPoPorostech.ODD=ODD)
         and(VMajPoPorostech.DIL=DIL)
         and(VMajPoPorostech.POR=POR)
         and(ubm(VMajPoPorostech.PSK)=ubm(PSK)) then
       begin
        result:=VMajPoPorostech;
       end;
     end;
  end;
 procedure Tmajetky.SetNamePorostuOLH1(vOLH:String);
 var
   s1,s2:string;
   VODD,VDIL,VPOR,VPSK,Chyba:string;
   VOlhZal:string;
   VMajPoPorostech:TMajPoPorostech;
  begin
   if NamePorostuOLH1=vOLH then exit;
   VOlh:=trim(VOlh);
   if VNamePorostuJeNecoSmazano(NamePorostuOLH1,vOLH) then
    begin
     showmessage('V porostech OLH nelze mazat, pokud chcete ubrat porost, zapite jej k novmu OLH. Oddlujte mezerou.');
     exit;
    end;
   VOlhZal:=VOlh;
   while VOLH<>'' do
    begin
     RozdelDlePrvnihoStringu(VOlh,' ',S1,S2);
     rozpadniName1PorAZkontroluj(s1,VODD,VDIL,VPOR,VPSK,Chyba);
     if chyba<>'' then
      begin
       showmessage('Chyba pi vkldn porostu u OLH1:"'+CHyba+'"');
       exit;
      end;
     if MajPoPorDleOzn(strtoint0(VODD),VDIL,VPOR,VPSK,MajPoPorostechMN)=nil then
      begin
       showmessage(' Porost "'+s1+'" nepat majiteli.');
      end;
     VOlh:=trim(S2);
    end;
   VOlh:=VOlhZal;
   while VOLH<>'' do
    begin
     RozdelDlePrvnihoStringu(VOlh,' ',S1,S2);
     rozpadniName1PorAZkontroluj(s1,VODD,VDIL,VPOR,VPSK,Chyba);
     if MajPoPorDleOzn(strtoint0(VODD),VDIL,VPOR,VPSK,MajPoPorostechOLH1MN)=nil then
      begin
       VMajPoPorostech:= MajPoPorDleOzn(strtoint0(VODD),VDIL,VPOR,VPSK,MajPoPorostechMN);
       MajPoPorostechOLH1MN.AddElement(VMajPoPorostech);
       VMajPoPorostech:= MajPoPorDleOzn(strtoint0(VODD),VDIL,VPOR,VPSK,MajPoPorostechOLH2MN);
       if VMajPoPorostech<>nil then
        begin
         MajPoPorostechOLH2MN.RemoveElement(VMajPoPorostech);
        end;
       VMajPoPorostech:= MajPoPorDleOzn(strtoint0(VODD),VDIL,VPOR,VPSK,MajPoPorostechOLH3MN);
       if VMajPoPorostech<>nil then
        begin
         MajPoPorostechOLH3MN.RemoveElement(VMajPoPorostech);
        end;
      end;
     VOlh:=trim(S2);
    end;
  end;
procedure Tmajetky.SetNamePorostuOLH2(vOLH:String);
 var
   s1,s2:string;
   VODD,VDIL,VPOR,VPSK,Chyba:string;
   VOlhZal:string;
   VMajPoPorostech:TMajPoPorostech;
  begin
   if NamePorostuOLH2=vOLH then exit;
   VOlh:=trim(VOlh);
   if VNamePorostuJeNecoSmazano(NamePorostuOLH2,vOLH) then
    begin
     showmessage('V porostech OLH nelze mazat, pokud chcete ubrat porost, zapite jej k novmu OLH. Oddlujte mezerou.');
     exit;
    end;
   VOlhZal:=VOlh;
   while VOLH<>'' do
    begin
     RozdelDlePrvnihoStringu(VOlh,' ',S1,S2);
     rozpadniName1PorAZkontroluj(s1,VODD,VDIL,VPOR,VPSK,Chyba);
     if chyba<>'' then
      begin
       showmessage('Chyba pi vkldn porostu u OLH1:"'+CHyba+'"');
       exit;
      end;
     if MajPoPorDleOzn(strtoint0(VODD),VDIL,VPOR,VPSK,MajPoPorostechMN)=nil then
      begin
       showmessage(' Porost "'+s1+'" nepat majiteli.');
      end;
     VOlh:=trim(S2);
    end;
   VOlh:=VOlhZal;
   while VOLH<>'' do
    begin
     RozdelDlePrvnihoStringu(VOlh,' ',S1,S2);
     rozpadniName1PorAZkontroluj(s1,VODD,VDIL,VPOR,VPSK,Chyba);
     if MajPoPorDleOzn(strtoint0(VODD),VDIL,VPOR,VPSK,MajPoPorostechOLH2MN)=nil then
      begin
       VMajPoPorostech:= MajPoPorDleOzn(strtoint0(VODD),VDIL,VPOR,VPSK,MajPoPorostechMN);
       MajPoPorostechOLH2MN.AddElement(VMajPoPorostech);
       VMajPoPorostech:= MajPoPorDleOzn(strtoint0(VODD),VDIL,VPOR,VPSK,MajPoPorostechOLH1MN);
       if VMajPoPorostech<>nil then
        begin
         MajPoPorostechOLH1MN.RemoveElement(VMajPoPorostech);
        end;
       VMajPoPorostech:= MajPoPorDleOzn(strtoint0(VODD),VDIL,VPOR,VPSK,MajPoPorostechOLH3MN);
       if VMajPoPorostech<>nil then
        begin
         MajPoPorostechOLH3MN.RemoveElement(VMajPoPorostech);
        end;
      end;
     VOlh:=trim(S2);
    end;
  end;

 procedure Tmajetky.SetNamePorostuOLH3(vOLH:String);
 var
   s1,s2:string;
   VODD,VDIL,VPOR,VPSK,Chyba:string;
   VOlhZal:string;
   VMajPoPorostech:TMajPoPorostech;
  begin
   if NamePorostuOLH3=vOLH then exit;
   VOlh:=trim(VOlh);
   if VNamePorostuJeNecoSmazano(NamePorostuOLH3,vOLH) then
    begin
     showmessage('V porostech OLH nelze mazat, pokud chcete ubrat porost, zapite jej k novmu OLH. Oddlujte mezerou.');
     exit;
    end;
   VOlhZal:=VOlh;
   while VOLH<>'' do
    begin
     RozdelDlePrvnihoStringu(VOlh,' ',S1,S2);
     rozpadniName1PorAZkontroluj(s1,VODD,VDIL,VPOR,VPSK,Chyba);
     if chyba<>'' then
      begin
       showmessage('Chyba pi vkldn porostu u OLH1:"'+CHyba+'"');
       exit;
      end;
     if MajPoPorDleOzn(strtoint0(VODD),VDIL,VPOR,VPSK,MajPoPorostechMN)=nil then
      begin
       showmessage(' Porost "'+s1+'" nepat majiteli.');
      end;
     VOlh:=trim(S2);
    end;
   VOlh:=VOlhZal;
   while VOLH<>'' do
    begin
     RozdelDlePrvnihoStringu(VOlh,' ',S1,S2);
     rozpadniName1PorAZkontroluj(s1,VODD,VDIL,VPOR,VPSK,Chyba);
     if MajPoPorDleOzn(strtoint0(VODD),VDIL,VPOR,VPSK,MajPoPorostechOLH3MN)=nil then
      begin
       VMajPoPorostech:= MajPoPorDleOzn(strtoint0(VODD),VDIL,VPOR,VPSK,MajPoPorostechMN);
       MajPoPorostechOLH3MN.AddElement(VMajPoPorostech);
       VMajPoPorostech:= MajPoPorDleOzn(strtoint0(VODD),VDIL,VPOR,VPSK,MajPoPorostechOLH1MN);
       if VMajPoPorostech<>nil then
        begin
         MajPoPorostechOLH1MN.RemoveElement(VMajPoPorostech);
        end;
       VMajPoPorostech:= MajPoPorDleOzn(strtoint0(VODD),VDIL,VPOR,VPSK,MajPoPorostechOLH2MN);
       if VMajPoPorostech<>nil then
        begin
         MajPoPorostechOLH2MN.RemoveElement(VMajPoPorostech);
        end;
      end;
     VOlh:=trim(S2);
    end;
  end;

function  TMajPoPorostech.GetODD_DIL_POR:String;
 begin
  if JP=0 then result:=inttostr(ODD)+DIL+POR+PSK
  else result:=inttostr(ODD)+DIL+POR+PSK+inttostr(JP)
 end;
function  TMajPoPorostech.GetODD_DIL_PORtr:String;
 begin
  result:=DoplnZePreduZnakem1(inttostr(ODD),4,'0')+DIL+POR;
 end;
function udelejMAJ_KOD_C0(zCeho:string):string;
 begin
  result:=DoplnZePreduZnakem1(zCeho,15,'0');
 end;

function Tmajetky.GetMAJ_KOD0:string;
 begin
  result:=udelejMAJ_KOD_C0(FMAJ_KOD);
 end;

procedure Tmajetky.SET_MAJ_NAZ_Stehlik(SMAJ_NAZ:String);
 begin
  FMAJ_NAZ:=StehlikToWin(SMAJ_NAZ);
 end;
 function  Tmajetky.getPSC_txt_C:string;
  begin
   if FPSC_txt='' then result:=inttostr(FPSC)
   else result:=FPSC_txt;
   if ubm(result)='0' then result:='';
  end;
 procedure Tmajetky.SetPSC_txt_C(s:String);
  begin
   FPSC:=strToInt0(KPrvnimuZnaku(s,'@'));
   FPSC_txt:=s;
  end;
constructor TTransforDleMajiteleMN.Create;
 begin
  inherited create;
  FClass:=TTransforDleMajitele;
  FPredponaName:='Transf';
 end;
function TTransforDleMajitele.GetZmena_Nazev:string;
 begin
  result:=ZTypuZmenyString(Zmena);
 end;
procedure TTransforDleMajitele.SetZmena_Nazev(s:string);
 begin
  Zmena:=ZeStringuTypZmeny(s);
 end;

procedure rozpadniName1Por(VName1Por:string;var VODD,VDIL,VPOR,VPSK:string);
var i:integer;
   VPsk3:string;
 begin
  VODD:='';
  VDIL:='';
  VPOR:='';
  VPSK:='';
  i:=1;
  while (VName1Por[i]>='0') and (VName1Por[i]<='9') do
   begin
    VODD:=VODD+VName1Por[i];
    inc(i);
    if i>length(VName1Por) then exit;
   end;
  VDil:=VName1Por[i];
  inc(i);
  if i>length(VName1Por) then exit;
  if (VName1Por[i]>='0') and (VName1Por[i]<='9') then
   begin
    VPSK:=copy(VName1Por,i,length(VName1Por)-(i-1));
   end
  else
   begin
    VPor:=VName1Por[i];
    if length(VName1Por)>i then
     begin
      inc(i);
      VPSK:=copy(VName1Por,i,length(VName1Por)-(i-1));
     end;
   end;
 end;
procedure rozpadniName1PorAZkontroluj(VName1Por:string;var VODD,VDIL,VPOR,VPSK,Chyba:string);
var
   VPsk3:string;
 begin
 rozpadniName1Por(VName1Por,VODD,VDIL,VPOR,VPSK);
 Chyba:='';
 if (VOdd='')  then
  begin
   Chyba:='Jmeno porostu nebo porostni skupiny "'+VName1Por+'" mus obsahovat cslo oddlen.';
   exit;
  end;
 if (VDIL='')  then
  begin
   Chyba:='Jmeno porostu nebo porostni skupiny "'+VName1Por+'" mus obsahovat oznaen dlce.';
   exit;
  end;
 if (VDIL>='a')and(VDIL<='z')  then
  begin
   Chyba:='Jmeno porostu nebo porostni skupiny "'+VName1Por+'" mus bt oznaen dlce velkm psmenem.';
   exit;
  end;

 if (VPOR='') and (VPSK='') then
  begin
   Chyba:='V "'+VName1Por+'" mus bt jmno porostu nebo porostni skupiny.';
   exit;
  end;

 if VPor<>'' then
  begin
   if (length(VPOR)>1) then
    begin
     Chyba:='V "'+VName1Por+'" je jmno porostu "'+VPOR+'" uvedeno chybn. Nesm bt del ne 1 psmeno.';
     exit;
    end;
   if VPSK<>'' then
    begin
     Chyba:='V "'+VName1Por+'" je jmno porostu "'+VPOR+'" a zarove jmno por.skupiny "" Me bt uvedeno bu jedno nebo druh.';
     exit;
    end;
  end
 else
  begin
   VPsk3:=VPsk;
   VPSK3:=opravenaSkupina(VPSK3);
   {if length(VPSK3)>3 then
    begin
     Chyba:='V "'+VName1Por+'" je jmno porostn skupiny  "'+VPSK+'" uvedeno chybn. ';
     exit;
    end;  }
   if not((VPSK3[1]=' ')or((VPSK3[1]>='0') and (VPSK3[1]<='9'))) then
    begin
     Chyba:='V "'+VName1Por+'" je jmno porostn skupiny  "'+VPSK+'" uvedeno chybn. ';
     exit;
    end;
   if not((VPSK3[2]>='0') and (VPSK3[2]<='9')) then
    begin
     Chyba:='V "'+VName1Por+'" je jmno porostn skupiny  "'+VPSK+'" uvedeno chybn. ';
     exit;
    end;
   if not((VPSK3[3]=' ')or((VPSK3[3]>='a') and (VPSK3[3]<='z'))) then
    begin
     Chyba:='V "'+VName1Por+'" je jmno porostn skupiny  "'+VPSK+'" uvedeno chybn. ';
     exit;
    end;
   VPSK:=VPSK3;
  end;
end;
procedure ZName1PorTransformace
       (VMaj_Kod:string;VMaj_Druh:integer;VName1Por:string;
         VTransforDleMajiteleMN:TTransforDleMajiteleMN;var Chyba:string;Memo:TMemo);
var VODD,VDIL,VPOR:string;
    // VPSK:string;
    VPSKkont:string;
    TransDleMaj:TTransforDleMajitele;
    i:integer;
begin
 if memo<>nil then
  begin
   memo.lines.Add('jsem v ZName1PorTransformace');
   memo.refresh;
  end;
 rozpadniName1PorAZkontroluj(VName1Por,VODD,VDIL,VPOR,VPSKkont,Chyba);
 if VPSKkont<>'' then
  begin
   showmessage('transformaci je VPSKkont<>""  VPSKkont<>"'+VPSKkont+'"')
  end;
 // showmessage('odd='+VODD+',dil='+VDIL+',por='+VPOR+',psk='+VPSK+',');

 if Chyba<>'' then exit;
 with VTransforDleMajiteleMN do
  begin
   {
   for i:=0 to count-1 do
    begin
     if  (TTransforDleMajitele(Elements[i]).MAJ_KOD=VMAJ_KOD) and
         (TTransforDleMajitele(Elements[i]).MAJ_DRUH=VMAJ_DRUH)and
         (TTransforDleMajitele(Elements[i]).Zmena=nezmenilse)  then
      begin
       TTransforDleMajitele(Elements[i]).Zmena:=BudeSmazan;
      end;
    end;
   }
   PrvniIndexAPocetStejnychPrvkuPodleSetridenePropertyLongInt('ODD',strtoInt(VODD),FIndexPrvniho,FPocet);

   if memo<>nil then
    begin
     memo.lines.Add('FIndexPrvniho je '+inttostr(FIndexPrvniho)+' FPocet je '+inttostr(FPocet));
     memo.refresh;
    end;

   if Fpocet>0 then
    begin
     for i:=FIndexPrvniho to FIndexPrvniho+FPocet-1 do
      begin
       if  (TTransforDleMajitele(Elements[i]).DIL=VDIL) and
           (TTransforDleMajitele(Elements[i]).POR=VPOR)
            // and (ubm(TTransforDleMajitele(Elements[i]).PSK)=ubm(VPSK))
             then
        begin
         TTransforDleMajitele(Elements[i]).Zmena:=BudeSmazan1;
         if memo<>nil then
          begin
            with TTransforDleMajitele(Elements[i]) do
             begin
              memo.lines.Add('majK='+MAJ_KOD+'majD='+inttostr(MAJ_DRUH)+' odd='+VODD+',dil='+VDIL+',por='+VPOR+', bude smazan');
              memo.refresh;
             end;
          end;
        end;
      end;

     for i:=FIndexPrvniho to FIndexPrvniho+FPocet-1 do
      begin
       if  (TTransforDleMajitele(Elements[i]).DIL=VDIL) and
           (TTransforDleMajitele(Elements[i]).POR=VPOR) and
           // (ubm(TTransforDleMajitele(Elements[i]).PSK)=ubm(VPSK)) and
           (TTransforDleMajitele(Elements[i]).MAJ_KOD=VMAJ_KOD) and
           (TTransforDleMajitele(Elements[i]).MAJ_DRUH=VMAJ_DRUH)
            then
        begin
         if memo<>nil then
          begin
           with TTransforDleMajitele(Elements[i]) do
            begin
             memo.lines.Add('MAJ_kod='+VMAJ_KOD+'dr='+inttostr(VMAJ_DRUH)+'odd='+VODD+',dil='+VDIL+',por='+VPOR+' nove zaveden a ex ');
             memo.refresh;
            end;
          end;
         TTransforDleMajitele(Elements[i]).Zmena:=bylNoveZaveden;
         exit;
        end;
      end;
    end;
   TransDleMaj:=TTransforDleMajitele.create;
   TransDleMaj.ODD:=strToInt(VODD);
   TransDleMaj.DIL:=VDIL;
   TransDleMaj.POR:=VPOR;
//   TransDleMaj.PSK:=VPSK;
   TransDleMaj.Maj_Kod:=VMaj_Kod;
   TransDleMaj.Maj_Druh:=VMaj_Druh;
   TransDleMaj.Zmena:=bylNoveZaveden;
   if memo<>nil then
    begin
     memo.lines.Add('MAJ_kod='+VMAJ_KOD+'dr='+inttostr(VMAJ_DRUH)+'odd='+VODD+',dil='+VDIL+',por='+VPOR+'  do TransDleMaj');
     memo.refresh;
    end;
   InsertElement(FIndexPrvniho+FPocet,TransDleMaj);
   inc(FPocet);
  end; // with VTransforDleMajiteleMN do
end;

// XXXXXXXXXXX

function VNamePorostuJeNecoSmazano(PuvodniVNamePorostu,NoveVNamePorostu:string):boolean;
 var S1,S2:string;
 begin
  result:=false;
  PuvodniVNamePorostu:=trim(PuvodniVNamePorostu);
  NoveVNamePorostu:=trim(NoveVNamePorostu)+' ';
  while PuvodniVNamePorostu<>'' do
   begin
    RozdelDlePrvnihoStringu(PuvodniVNamePorostu,' ',S1,S2);
    if pos(S1+' ',NoveVNamePorostu)=0 then
     begin
      result:=true;
      exit;
     end;
    PuvodniVNamePorostu:=trim(s2);
   end;
 end;

function ZNamePorostuTransformace1
        (VMaj_Kod:string;VMaj_Druh:integer;VNamePorostu:string;VTransforDleMajiteleMN:TTransforDleMajiteleMN;Memo:Tmemo):boolean;
 var S1,S2,chyba:string;
     i:integer;
  begin
   result:=true;

   with VTransforDleMajiteleMN do
    begin
     for i:=0 to count-1 do
      begin
       { pokusMalik
       if  (TTransforDleMajitele(Elements[i]).MAJ_KOD=VMAJ_KOD) and
           (TTransforDleMajitele(Elements[i]).MAJ_DRUH=VMAJ_DRUH)and
           (TTransforDleMajitele(Elements[i]).Zmena=nezmenilse)  then
        begin
         TTransforDleMajitele(Elements[i]).Zmena:=BudeSmazan;
        end;
       }
      end;
    end;
   VNamePorostu:=trim(VNamePorostu);
   while VNamePorostu<>'' do
    begin
     RozdelDlePrvnihoStringu(VNamePorostu,' ',S1,S2);
     ZName1PorTransformace(VMaj_Kod,VMaj_Druh,S1,VTransforDleMajiteleMN,Chyba,memo);
     if chyba<>'' then
      begin
       showmessage(chyba);
       result:=false;
      end;
     VNamePorostu:=trim(s2);
    end;
  end;

function NajdiPorostVMajetcich(VMajetkyMN:TMajetkyMN;ODD:Integer;DIL,POR,PSK:string;var MajetkyKtereHoObsahuji:TMajetky):TMajPoPorostech;
var
 VMajPoPorostech:TMajPoPorostech;
 i,im:integer;
 begin
  result:=nil;
  MajetkyKtereHoObsahuji:=nil;
  for i:=0 to VMajetkyMN.count-1 do
   begin
    for im:=0 to TMajetky(VMajetkyMN.elements[i]).MajPoPorostechMN.count-1 do
     begin
      VMajPoPorostech:= TMajPoPorostech(TMajetky(VMajetkyMN.elements[i]).MajPoPorostechMN.elements[im]);
      if    (VMajPoPorostech.ODD=ODD)
         and(VMajPoPorostech.DIL=DIL)
         and(VMajPoPorostech.POR=POR)
         and(ubm(VMajPoPorostech.PSK)=ubm(PSK)) then
       begin
        result:=VMajPoPorostech;
        MajetkyKtereHoObsahuji:=TMajetky(VMajetkyMN.elements[i]);
       end;
     end;
   end;
 end;

function NajdiUcelenyDilecVMajetcich(VMajetkyMN:TMajetkyMN;ODD:Integer;DIL:string):TMajPoPorostech;
var
 VMajPoPorostech:TMajPoPorostech;
 i,im:integer;
 begin
  result:=nil;
  for i:=0 to VMajetkyMN.count-1 do
   begin
    for im:=0 to TMajetky(VMajetkyMN.elements[i]).MajPoPorostechMN.count-1 do
     begin
      VMajPoPorostech:= TMajPoPorostech(TMajetky(VMajetkyMN.elements[i]).MajPoPorostechMN.elements[im]);
      if    (VMajPoPorostech.ODD=ODD)
         and(VMajPoPorostech.DIL=DIL)
         and(VMajPoPorostech.POR<>'')
         and(VMajPoPorostech.PSK='') then
       begin
        result:=VMajPoPorostech;
       end;
     end;
   end;
 end;

function NajdiUcelenyPorostVMajetcich(VMajetkyMN:TMajetkyMN;ODD:Integer;DIL,POR:string; var MajetkyKtereHoObsahuji:TMajetky):TMajPoPorostech;
var
 VMajPoPorostech:TMajPoPorostech;
 i,im:integer;
 begin
  result:=nil;
  for i:=0 to VMajetkyMN.count-1 do
   begin
    for im:=0 to TMajetky(VMajetkyMN.elements[i]).MajPoPorostechMN.count-1 do
     begin
      VMajPoPorostech:= TMajPoPorostech(TMajetky(VMajetkyMN.elements[i]).MajPoPorostechMN.elements[im]);
      if    (VMajPoPorostech.ODD=ODD)
         and(VMajPoPorostech.DIL=DIL)
         and(VMajPoPorostech.POR=POR)
         and(VMajPoPorostech.PSK='') then
       begin
        MajetkyKtereHoObsahuji := TMajetky(VMajetkyMN.elements[i]);
        result:=VMajPoPorostech;
       end;
     end;
   end;
 end;

{
procedure opravPorMajitelePodlePorTransformace(VMajetkyMN:TMajetkyMN;VTransforDleMajiteleMN:TTransforDleMajiteleMN);
var
 i,Im:integer;
 VMajetky:TMajetky;
 VMajPoPorostech,SmazMajPoPorostech:TMajPoPorostech;
 begin
  for i:=0 to VTransforDleMajiteleMN.count-1 do
   begin
    with TTransforDleMajitele(VTransforDleMajiteleMN.Elements[i]) do
     begin
      if zmena=BudeSmazan then
       begin
        VMajetky:=TMajetky(VMajetkyMN.GetNejblizsiPrvekPodleSetridenePropertyLongInt('MAJ_KOD_C',MAJ_KOD));
        if VMajetky.MAJ_KOD_C=inttostr(MAJ_KOD) then
         begin
          SmazMajPoPorostech:=nil;
          for Im:=0 to VMajetky.MajPoPorostechMN.count-1 do
           begin
            VMajPoPorostech:=TMajPoPorostech(VMajetky.MajPoPorostechMN.elements[im]);
            if    (VMajPoPorostech.ODD=ODD)
               and(VMajPoPorostech.DIL=DIL)
               and(VMajPoPorostech.POR=POR)
               and(VMajPoPorostech.PSK=PSK) then
             begin
              SmazMajPoPorostech:=VMajPoPorostech;
             end;
           end;
          if SmazMajPoPorostech<>nil then
           begin
            SmazMajPoPorostech.free;
           end;
         end
        else
         begin
          showmessage('Pozor majetek '+inttostr(MAJ_KOD)+' se nepodailo nalzt v seznamu majitel');
         end;
       end;

      if zmena=bylNoveZaveden then
       begin
        SmazMajPoPorostech:=NajdiPorostVMajetcich(VMajetkyMN,ODD,DIL,POR,PSK);
        if SmazMajPoPorostech<>nil then
         begin
          SmazMajPoPorostech.free;
         end;
        VMajetky:=TMajetky(VMajetkyMN.GetNejblizsiPrvekPodleSetridenePropertyLongInt('MAJ_KOD_C',MAJ_KOD));
        if VMajetky.MAJ_KOD_C=inttostr(MAJ_KOD) then
         begin
          VMajetky.MajPoPorostechMN.NovyPrvekVzdy:='OPR'+inttostr(i);
          VMajPoPorostech:=TMajPoPorostech(VMajetky.MajPoPorostechMN.AktualniPrvek);
          VMajPoPorostech.ODD:=ODD;
          VMajPoPorostech.DIL:=DIL;
          VMajPoPorostech.POR:=POR;
          VMajPoPorostech.PSK:=PSK;
         end
        else
         begin
          showmessage('Pozor majetek '+inttostr(MAJ_KOD)+' se nepodailo nalzt v seznamu majitel');
         end;
       end;
     end;
   end;
 end;
}
procedure TMajPoPorostech.SetPSK(VPSK:String);
 begin
  FPSK:=ubm(VPSK);
 end;

procedure THospSoubPhs.SetSlHospSoub0(HS:String);
 begin
  FSlHospSoub[0]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub0:string;
 begin
  result:=FSlHospSoub[0];
 end;

procedure TLesTypPhs.SetSlLesTyp0(LT:String);
 begin
  FSlLesTyp[0]:=LT;
 end;
function  TLesTypPhs.GetSlLesTyp0:string;
 begin
  result:=FSlLesTyp[0];
 end;



procedure THospSoubPhs.SetSlHospSoub1(HS:String);
 begin
          FSlHospSoub[1]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub1:string;
 begin
  result:=FSlHospSoub[1];
 end;

procedure     TLesTypPhs.SetSlLesTyp1(LT:String);
 begin
            FSlLesTyp[1]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp1:string;
 begin
    result:=FSlLesTyp[1];
 end;




procedure THospSoubPhs.SetSlHospSoub2(HS:String);
 begin
          FSlHospSoub[2]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub2:string;
 begin
  result:=FSlHospSoub[2];
 end;

procedure     TLesTypPhs.SetSlLesTyp2(LT:String);
 begin
            FSlLesTyp[2]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp2:string;
 begin
    result:=FSlLesTyp[2];
 end;




procedure THospSoubPhs.SetSlHospSoub3(HS:String);
 begin
          FSlHospSoub[3]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub3:string;
 begin
  result:=FSlHospSoub[3];
 end;

procedure     TLesTypPhs.SetSlLesTyp3(LT:String);
 begin
            FSlLesTyp[3]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp3:string;
 begin
    result:=FSlLesTyp[3];
 end;




procedure THospSoubPhs.SetSlHospSoub4(HS:String);
 begin
          FSlHospSoub[4]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub4:string;
 begin
  result:=FSlHospSoub[4];
 end;

procedure     TLesTypPhs.SetSlLesTyp4(LT:String);
 begin
            FSlLesTyp[4]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp4:string;
 begin
    result:=FSlLesTyp[4];
 end;




procedure THospSoubPhs.SetSlHospSoub5(HS:String);
 begin
          FSlHospSoub[5]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub5:string;
 begin
  result:=FSlHospSoub[5];
 end;

procedure     TLesTypPhs.SetSlLesTyp5(LT:String);
 begin
            FSlLesTyp[5]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp5:string;
 begin
    result:=FSlLesTyp[5];
 end;




procedure THospSoubPhs.SetSlHospSoub6(HS:String);
 begin
          FSlHospSoub[6]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub6:string;
 begin
  result:=FSlHospSoub[6];
 end;

procedure     TLesTypPhs.SetSlLesTyp6(LT:String);
 begin
            FSlLesTyp[6]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp6:string;
 begin
    result:=FSlLesTyp[6];
 end;




procedure THospSoubPhs.SetSlHospSoub7(HS:String);
 begin
          FSlHospSoub[7]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub7:string;
 begin
  result:=FSlHospSoub[7];
 end;

procedure     TLesTypPhs.SetSlLesTyp7(LT:String);
 begin
            FSlLesTyp[7]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp7:string;
 begin
    result:=FSlLesTyp[7];
 end;




procedure THospSoubPhs.SetSlHospSoub8(HS:String);
 begin
          FSlHospSoub[8]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub8:string;
 begin
  result:=FSlHospSoub[8];
 end;

procedure     TLesTypPhs.SetSlLesTyp8(LT:String);
 begin
            FSlLesTyp[8]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp8:string;
 begin
    result:=FSlLesTyp[8];
 end;




procedure THospSoubPhs.SetSlHospSoub9(HS:String);
 begin
          FSlHospSoub[9]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub9:string;
 begin
  result:=FSlHospSoub[9];
 end;

procedure     TLesTypPhs.SetSlLesTyp9(LT:String);
 begin
            FSlLesTyp[9]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp9:string;
 begin
    result:=FSlLesTyp[9];
 end;




procedure THospSoubPhs.SetSlHospSoub10(HS:String);
 begin
          FSlHospSoub[10]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub10:string;
 begin
  result:=FSlHospSoub[10];
 end;

procedure     TLesTypPhs.SetSlLesTyp10(LT:String);
 begin
            FSlLesTyp[10]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp10:string;
 begin
    result:=FSlLesTyp[10];
 end;



procedure THospSoubPhs.SetSlHospSoub11(HS:String);
 begin
          FSlHospSoub[11]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub11:string;
 begin
  result:=FSlHospSoub[11];
 end;

procedure     TLesTypPhs.SetSlLesTyp11(LT:String);
 begin
            FSlLesTyp[11]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp11:string;
 begin
    result:=FSlLesTyp[11];
 end;



procedure THospSoubPhs.SetSlHospSoub12(HS:String);
 begin
          FSlHospSoub[12]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub12:string;
 begin
  result:=FSlHospSoub[12];
 end;

procedure     TLesTypPhs.SetSlLesTyp12(LT:String);
 begin
            FSlLesTyp[12]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp12:string;
 begin
    result:=FSlLesTyp[12];
 end;



procedure THospSoubPhs.SetSlHospSoub13(HS:String);
 begin
          FSlHospSoub[13]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub13:string;
 begin
  result:=FSlHospSoub[13];
 end;

procedure     TLesTypPhs.SetSlLesTyp13(LT:String);
 begin
            FSlLesTyp[13]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp13:string;
 begin
    result:=FSlLesTyp[13];
 end;



procedure THospSoubPhs.SetSlHospSoub14(HS:String);
 begin
          FSlHospSoub[14]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub14:string;
 begin
  result:=FSlHospSoub[14];
 end;

procedure     TLesTypPhs.SetSlLesTyp14(LT:String);
 begin
            FSlLesTyp[14]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp14:string;
 begin
    result:=FSlLesTyp[14];
 end;



procedure THospSoubPhs.SetSlHospSoub15(HS:String);
 begin
          FSlHospSoub[15]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub15:string;
 begin
  result:=FSlHospSoub[15];
 end;

procedure     TLesTypPhs.SetSlLesTyp15(LT:String);
 begin
            FSlLesTyp[15]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp15:string;
 begin
    result:=FSlLesTyp[15];
 end;



procedure THospSoubPhs.SetSlHospSoub16(HS:String);
 begin
          FSlHospSoub[16]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub16:string;
 begin
  result:=FSlHospSoub[16];
 end;

procedure     TLesTypPhs.SetSlLesTyp16(LT:String);
 begin
            FSlLesTyp[16]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp16:string;
 begin
    result:=FSlLesTyp[16];
 end;



procedure THospSoubPhs.SetSlHospSoub17(HS:String);
 begin
          FSlHospSoub[17]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub17:string;
 begin
  result:=FSlHospSoub[17];
 end;

procedure     TLesTypPhs.SetSlLesTyp17(LT:String);
 begin
            FSlLesTyp[17]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp17:string;
 begin
    result:=FSlLesTyp[17];
 end;



procedure THospSoubPhs.SetSlHospSoub18(HS:String);
 begin
          FSlHospSoub[18]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub18:string;
 begin
  result:=FSlHospSoub[18];
 end;

procedure     TLesTypPhs.SetSlLesTyp18(LT:String);
 begin
            FSlLesTyp[18]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp18:string;
 begin
    result:=FSlLesTyp[18];
 end;



procedure THospSoubPhs.SetSlHospSoub19(HS:String);
 begin
          FSlHospSoub[19]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub19:string;
 begin
  result:=FSlHospSoub[19];
 end;

procedure     TLesTypPhs.SetSlLesTyp19(LT:String);
 begin
            FSlLesTyp[19]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp19:string;
 begin
    result:=FSlLesTyp[19];
 end;

procedure THospSoubPhs.SetSlHospSoub20(HS:String);
 begin
          FSlHospSoub[20]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub20:string;
 begin
  result:=FSlHospSoub[20];
 end;

procedure THospSoubPhs.SetSlHospSoub21(HS:String);
 begin
          FSlHospSoub[21]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub21:string;
 begin
  result:=FSlHospSoub[21];
 end;

procedure THospSoubPhs.SetSlHospSoub22(HS:String);
 begin
          FSlHospSoub[22]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub22:string;
 begin
  result:=FSlHospSoub[22];
 end;

procedure THospSoubPhs.SetSlHospSoub23(HS:String);
 begin
          FSlHospSoub[23]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub23:string;
 begin
  result:=FSlHospSoub[23];
 end;

procedure THospSoubPhs.SetSlHospSoub24(HS:String);
 begin
          FSlHospSoub[24]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub24:string;
 begin
  result:=FSlHospSoub[24];
 end;

procedure THospSoubPhs.SetSlHospSoub25(HS:String);
 begin
          FSlHospSoub[25]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub25:string;
 begin
  result:=FSlHospSoub[25];
 end;

procedure THospSoubPhs.SetSlHospSoub26(HS:String);
 begin
          FSlHospSoub[26]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub26:string;
 begin
  result:=FSlHospSoub[26];
 end;

procedure THospSoubPhs.SetSlHospSoub27(HS:String);
 begin
          FSlHospSoub[27]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub27:string;
 begin
  result:=FSlHospSoub[27];
 end;

procedure THospSoubPhs.SetSlHospSoub28(HS:String);
 begin
          FSlHospSoub[28]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub28:string;
 begin
  result:=FSlHospSoub[28];
 end;

procedure THospSoubPhs.SetSlHospSoub29(HS:String);
 begin
          FSlHospSoub[29]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub29:string;
 begin
  result:=FSlHospSoub[29];
 end;

procedure THospSoubPhs.SetSlHospSoub30(HS:String);
 begin
          FSlHospSoub[30]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub30:string;
 begin
  result:=FSlHospSoub[30];
 end;

procedure THospSoubPhs.SetSlHospSoub31(HS:String);
 begin
          FSlHospSoub[31]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub31:string;
 begin
  result:=FSlHospSoub[31];
 end;

procedure THospSoubPhs.SetSlHospSoub32(HS:String);
 begin
          FSlHospSoub[32]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub32:string;
 begin
  result:=FSlHospSoub[32];
 end;

procedure THospSoubPhs.SetSlHospSoub33(HS:String);
 begin
          FSlHospSoub[33]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub33:string;
 begin
  result:=FSlHospSoub[33];
 end;

procedure THospSoubPhs.SetSlHospSoub34(HS:String);
 begin
          FSlHospSoub[34]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub34:string;
 begin
  result:=FSlHospSoub[34];
 end;

procedure THospSoubPhs.SetSlHospSoub35(HS:String);
 begin
          FSlHospSoub[35]:=HS;
 end;
function  THospSoubPhs.GetSlHospSoub35:string;
 begin
  result:=FSlHospSoub[35];
 end;

procedure     TLesTypPhs.SetSlLesTyp20(LT:String);
 begin
            FSlLesTyp[20]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp20:string;
 begin
    result:=FSlLesTyp[20];
 end;

procedure     TLesTypPhs.SetSlLesTyp21(LT:String);
 begin
            FSlLesTyp[21]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp21:string;
 begin
    result:=FSlLesTyp[21];
 end;

procedure     TLesTypPhs.SetSlLesTyp22(LT:String);
 begin
            FSlLesTyp[22]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp22:string;
 begin
    result:=FSlLesTyp[22];
 end;

procedure     TLesTypPhs.SetSlLesTyp23(LT:String);
 begin
            FSlLesTyp[23]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp23:string;
 begin
    result:=FSlLesTyp[23];
 end;

procedure     TLesTypPhs.SetSlLesTyp24(LT:String);
 begin
            FSlLesTyp[24]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp24:string;
 begin
    result:=FSlLesTyp[24];
 end;

procedure     TLesTypPhs.SetSlLesTyp25(LT:String);
 begin
            FSlLesTyp[25]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp25:string;
 begin
    result:=FSlLesTyp[25];
 end;

procedure     TLesTypPhs.SetSlLesTyp26(LT:String);
 begin
            FSlLesTyp[26]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp26:string;
 begin
    result:=FSlLesTyp[26];
 end;

procedure     TLesTypPhs.SetSlLesTyp27(LT:String);
 begin
            FSlLesTyp[27]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp27:string;
 begin
    result:=FSlLesTyp[27];
 end;

procedure     TLesTypPhs.SetSlLesTyp28(LT:String);
 begin
            FSlLesTyp[28]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp28:string;
 begin
    result:=FSlLesTyp[28];
 end;

procedure     TLesTypPhs.SetSlLesTyp29(LT:String);
 begin
            FSlLesTyp[29]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp29:string;
 begin
    result:=FSlLesTyp[29];
 end;

procedure     TLesTypPhs.SetSlLesTyp30(LT:String);
 begin
            FSlLesTyp[30]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp30:string;
 begin
    result:=FSlLesTyp[30];
 end;

procedure     TLesTypPhs.SetSlLesTyp31(LT:String);
 begin
            FSlLesTyp[31]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp31:string;
 begin
    result:=FSlLesTyp[31];
 end;

procedure     TLesTypPhs.SetSlLesTyp32(LT:String);
 begin
            FSlLesTyp[32]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp32:string;
 begin
    result:=FSlLesTyp[32];
 end;

procedure     TLesTypPhs.SetSlLesTyp33(LT:String);
 begin
            FSlLesTyp[33]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp33:string;
 begin
    result:=FSlLesTyp[33];
 end;

procedure     TLesTypPhs.SetSlLesTyp34(LT:String);
 begin
            FSlLesTyp[34]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp34:string;
 begin
    result:=FSlLesTyp[34];
 end;

procedure     TLesTypPhs.SetSlLesTyp35(LT:String);
 begin
            FSlLesTyp[35]:=LT;
 end;
function      TLesTypPhs.GetSlLesTyp35:string;
 begin
    result:=FSlLesTyp[35];
 end;

procedure TPoznNmdDto.ulozSeDoOrbu(kamDir:string);
 begin
  UlozDoOrbu(VybPozn_MN  ,kamDir+'\VybPozn.Orb',1);
  UlozDoOrbu(VybNMD_MN   ,kamDir+'\VybNMD.Orb',1);
  UlozDoOrbu(VybDTO_MN   ,kamDir+'\VybDTO.Orb',1);
 end;
procedure TPoznNmdDto.nactiSeZOrbu(odkudDir:string);
 begin
  FVybPozn_MN.free;
  FVybNMD_MN.free;
  FVybDTO_MN.free;

  if fileExists(odkudDir+'\VybPozn.Orb') then
   begin
    FVybPozn_MN:=TVybTextMN(NactiZOrbu(odkudDir+'\VybPozn.Orb',true));
    FVybNMD_MN:=TVybTextMN(NactiZOrbu(odkudDir+'\VybNMD.Orb',true));
    FVybDTO_MN:=TVybTextMN(NactiZOrbu(odkudDir+'\VybDTO.Orb',true));
   end
  else
   begin
    FVybPozn_MN:=TVybTextMN.Create;
    FVybNMD_MN:=TVybTextMN.Create;
    FVybDTO_MN:=TVybTextMN.Create;
   end;
  addelement(FVybPozn_MN);
  addelement(FVybNMD_MN);
  addelement(FVybDTO_MN);

 end;

procedure TCiselOrbis.ulozSeDoOrbuCIS(kamDir:string);
 begin
  UlozDoOrbu(FHospSoubPhsMN  ,kamDir+'\HsPhs.Orb',2);
  UlozDoOrbu(FLesTypPhsMN    ,kamDir+'\LTPhs.Orb',2);
//  if FDrKtgPhsMN.KTGaZvlStDohromady then showmessage('cau KTGaZvlStDohromady') else showmessage('cau  NEEEE KTGaZvlStDohromady');
  UlozDoOrbu(FDrKtgPhsMN     ,kamDir+'\DrKtgPhs.Orb',2);
//  if FDrKtgPhsMN.KTGaZvlStDohromady then showmessage('cau AAA KTGaZvlStDohromady') else showmessage('cau AAA NEEEE KTGaZvlStDohromady');
  UlozDoOrbu(FSpecPodHSPhsMN ,kamDir+'\SpecPPhs.Orb',2);
  UlozDoOrbu(FcisHsMN        ,kamDir+'\CisHsPhs.Orb',2);
 end;
procedure TCiselOrbis.SpojSCiselOrbisem(PrCisOrb:TCiselOrbis);
var i:integer;
 begin
  for i:=0 to PrCisOrb.FHospSoubPhsMN.count-1 do
   begin
    FHospSoubPhsMN.AddElement(THospSoubPhs(PrCisOrb.FHospSoubPhsMN.Elements[i]));
   end;
  for i:=0 to PrCisOrb.FLesTypPhsMN.count-1 do
   begin
    FLesTypPhsMN.AddElement(TLesTypPhs(PrCisOrb.FLesTypPhsMN.Elements[i]));
   end;
  for i:=0 to PrCisOrb.FDrKtgPhsMN.count-1 do
   begin
    FDrKtgPhsMN.AddElement(TDrKtgPhs(PrCisOrb.FDrKtgPhsMN.Elements[i]));
   end;
  for i:=0 to PrCisOrb.FSpecPodHSPhsMN.count-1 do
   begin
    FSpecPodHSPhsMN.AddElement(TSpecPodHSPhs(PrCisOrb.FSpecPodHSPhsMN.Elements[i]));
   end;
  for i:=0 to PrCisOrb.FcisHsMN.count-1 do
   begin
    FcisHsMN.AddElement(TcisHs(PrCisOrb.FcisHsMN.Elements[i]));
   end;

 end;
procedure TCiselOrbis.nactiSeZOrbu(odkudDir:string;hlasitKdyzNeni:boolean);
 begin
  FHospSoubPhsMN.free;
  FLesTypPhsMN.free;
  FDrKtgPhsMN.free;
  FSpecPodHSPhsMN.free;
  FcisHsMN.free;
  FHospSoubPhsMN:=THospSoubPhsMN(NactiZOrbu(odkudDir+'\HsPhs.Orb',hlasitKdyzNeni));
  FLesTypPhsMN:=TLesTypPhsMN(NactiZOrbu(odkudDir+'\LTPhs.Orb',hlasitKdyzNeni));
  FDrKtgPhsMN:=TDrKtgPhsMN(NactiZOrbu(odkudDir+'\DrKtgPhs.Orb',hlasitKdyzNeni));
  // if FDrKtgPhsMN.KTGaZvlStDohromady then showmessage('cau bbbb KTGaZvlStDohromady') else showmessage('cau bbbb NEEEE KTGaZvlStDohromady');

  FSpecPodHSPhsMN:=TSpecPodHSPhsMN(NactiZOrbu(odkudDir+'\SpecPPhs.Orb',hlasitKdyzNeni));
  FcisHsMN:=TcisHsMN(NactiZOrbu(odkudDir+'\CisHsPhs.Orb',hlasitKdyzNeni));
  addelement(FHospSoubPhsMN);
  addelement(FLesTypPhsMN);
  addelement(FDrKtgPhsMN);
  addelement(FSpecPodHSPhsMN);
  addelement(FcisHsMN);
 end;
function TCiselOrbis.zasahDlePHS(HS,vek:integer):string;
var
 VCisHs:TCisHs;
 begin
  VCisHs:=TCisHs(FcisHsMN.PrvekPodleHodnotyProperty('CISLO_HS',inttostr(HS)));
  if VCisHs<>nil then
   begin
    result:=VCisHs.zasahDlePHS(vek);
   end
  else
   begin
    result:='neni soubor';
   end;
 end;
function TCisHs.zasahDlePHS(vek:integer):string;
var
 TezProc:integer;
 begin
   TezProc:=VratTezProc(vek,FOBMYTI,FOBN_DOBA);
   if TezProc>0 then
    begin
     result:='t'+inttostr(TezProc);
     exit;
    end;
   if (vek>=POC_MYTKLID)and(POC_MYTKLID>0) then
    begin
     result:='o';
     exit;
    end;
   if (vek>=POC_PROB) and (POC_PROB>0) then
    begin
     result:='v10';
     exit;
    end;
   if (vek>=POC_PROR) and (POC_PROR>0) then
    begin
     result:='p1';
     exit;
    end;
   result:='o';
 end;

Function ProcentoPoNormalniTezbe(Vek,Obmyti,ObnovniDoba:integer):double;
Var iVek:integer;
    Iproc,IprocPo:double;
 begin
  iVek:=1;
  IprocPo:=1;

  while iVek<=Vek-10 do
  //Vek-10 protoe tebn procento je na pt decenium ale normalita je k potku platnosti plnu
   begin
    IProc:=1-VratTezProc(iVek,Obmyti,ObnovniDoba)/100;
    IprocPo:=IprocPo*Iproc;
    iVek:=iVek+10;
   end;
  result:=IprocPo*100;
 end;

Function VratTezProc(Vek,Obmyti,ObnovniDoba:integer):integer;
var vst:integer;
 begin
  ObnovniDoba:=round(ObnovniDoba/10);
  if (obnovniDoba>6) or (obnovniDoba<1) then
    begin
     VratTezProc:=0;
    end
  else
    begin
     Vst:=((Vek-Obmyti)+49) div 10;
     if Vst>7 then vst:=7;
     If Vst<0 then Vst:=0;
     VratTezProc:=PolTezProc[Vst,ObnovniDoba];
    end;
 end;
function TCisHs.getPOC_OBNOVY:integer;
 begin
  result:=((OBMYTI-(OBN_DOBA div 2)) div 10)*10+1;
 end;

 function  Tmajetky.GetLesniPoz : Double;
  begin
   result:=round(FLesniPoz*10000)/10000;
  end;
 function  Tmajetky.GetJinePoz  : Double;
  begin
   result:=round(FJinePoz*10000)/10000;
  end;
function TProbirkaPhs.ProcTVPodleVeku(vVEK:integer):integer;
var
 iVek,vvp,vvP1:integer;
 begin
//  vekst:=vVEK;
  vVek:=vVek-5;
  iVEK:=((vVEK) div 5);
  vvP:=((iVEK+1)*5-vVek); // vha veku ProcTV[iVEK]
  vvp1:=5-vvP; // vha veku ProcTV[iVEK+1]
//  showmessage('iVEK='+inttostr(iVEK)+'   ProcTV[iVEK]='+inttostr(ProcTV[iVEK])
//      +'  ProcTV[iVEK+1]='+inttostr(ProcTV[iVEK+1])+'  vvp='+inttostr(vvp)+'  vvp1='+inttostr(vvp1));
  result:=round((ProcTV[iVEK]*vvp+(ProcTV[iVEK+1]*vvp1))/5);
 //  showmessage('result='+inttostr(result)+'   postaru='+inttostr(ProcTVPodleVekuPostaru(vekst)));
 end;

function TProbirkaPhs.ProcTVPodleVekuPostaru(vVEK:integer):integer; // platilo do verze '9.0.2.0'
var
 iVek:integer;
 begin
  vVek:=vVek-5;
  iVEK:=((vVEK) div 5)-1;
  result:=round((ProcTV[iVEK]*((iVEK+1)*5-vVek)+(ProcTV[iVEK+1]*(vVek-(Ivek*5))))/5);
 end;

//  showmessage('iVEK='+inttostr(iVEK)+'   ProcTV[iVEK]='+inttostr(ProcTV[iVEK])
//                                    +'  ProcTV[iVEK+1]='+inttostr(ProcTV[iVEK+1])
//       +'  ((iVEK+1)*5-vVek)='+inttostr(((iVEK+1)*5-vVek))+'  (ProcTV[iVEK+1]*(vVek-(Ivek*5)))='+inttostr((ProcTV[iVEK+1]*(vVek-(Ivek*5)))));
//  result:=round((ProcTV[iVEK]*((iVEK+1)*5-vVek)+(ProcTV[iVEK+1]*(vVek-(Ivek*5))))/5);

{
function TProbirkaPhs.ProcTVPodleVeku(iVEK:integer):integer;
 begin
  iVEK:=((iVEK-1) div 5)-1;
  result:=ProcTV[iVEK];
 end;
} 
function TProbirkaPhs.obsahujeDrevinu(StDrev:string):boolean;
 begin
  result:=StringJeVeStringu(Drevina,StDrev);
 end;
function TProbirkaPhs.GetProcTV(index:integer):integer;
 begin
  if index<=0 then
   begin
    index:=1;
   end;
  if index>=19 then
   begin
    index:=19;
   end;
  case index of
    1:result:=ProcTV1 ;
    2:result:=ProcTV2 ;
    3:result:=ProcTV3 ;
    4:result:=ProcTV4 ;
    5:result:=ProcTV5 ;
    6:result:=ProcTV6 ;
    7:result:=ProcTV7 ;
    8:result:=ProcTV8 ;
    9:result:=ProcTV9 ;
   10:result:=ProcTV10;
   11:result:=ProcTV11;
   12:result:=ProcTV12;
   13:result:=ProcTV13;
   14:result:=ProcTV14;
   15:result:=ProcTV15;
   16:result:=ProcTV16;
   17:result:=ProcTV17;
   18:result:=ProcTV18;
   19:result:=ProcTV19;
  end; //case index
 end;

procedure TMZDHospSoubMN.TransformujSe;
var i:integer;
 aMZDHospSoub:TMZDHospSoub;
 sDR_ZKR1,sDR_ZKR2,sDR_ZKR,sLT_SLT,sLT_SLT1,sLT_SLT2:string;
 begin
  application.ProcessMessages;
  i:=count-1;
  while i>=0 do
   begin
    sDR_ZKR:=TMZDHospSoub(elements[i]).DR_ZKR;
    repeat
     RozdelDlePrvnihoStringu(sDR_ZKR,'$',sDR_ZKR1,sDR_ZKR2);
     sDR_ZKR:=sDR_ZKR2;
     sLT_SLT:=TMZDHospSoub(elements[i]).LT_SLT;
      repeat
       RozdelDlePrvnihoStringu(sLT_SLT,'$',sLT_SLT1,sLT_SLT2);
       sLT_SLT:=sLT_SLT2;
       aMZDHospSoub:=TMZDHospSoub.create;
       aMZDHospSoub.CISLO_HS:= TMZDHospSoub(elements[i]).CISLO_HS ;
       aMZDHospSoub.MZD     := TMZDHospSoub(elements[i]).MZD ;
       aMZDHospSoub.LT_SLT  := sLT_SLT1;
       aMZDHospSoub.DR_ZKR  := sDR_ZKR1;
       aMZDHospSoub.NAME    := TMZDHospSoub(elements[i]).NAME+'_'+sDR_ZKR1+'_'+sLT_SLT1;
       AddElement(aMZDHospSoub);
       application.ProcessMessages;
      until sLT_SLT='';
     // RozdelDlePrvnihoStringu(ss:string;StrZnak:string;var S1,S2:string);
    until sDR_ZKR='';
    application.ProcessMessages;
    TMZDHospSoub(elements[i]).free;
    application.ProcessMessages;
    dec(i);
   end;
 end;

function TCiselOrbis.GetOLHMN:TOLHMN;
 begin
  result:=FOLHMN1;
 end;
procedure TCiselOrbis.SetMajetkyMN(VMajetkyMN:TmajetkyMN);
 begin
  if FMajetkyMN<>VMajetkyMN then
   begin
    FMajetkyMN:=VMajetkyMN;
    addelement(VMajetkyMN);
   end;
 end;
Destructor TMZDHospSoub.destroy;
 begin
  inherited destroy;
 end;
function opraveneNamePorostu(VNamePorostu1:String; var NamevPoradku:Boolean):String;
var
 S1:string;
 i,io:integer;
 nasel:boolean;
 ch:CHar;
 begin
  NamevPoradku:=true;
  result:='';
    VNamePorostu1:=vyberjenCislaAPismena(VNamePorostu1);
    if VNamePorostu1='' then
     begin
      NamevPoradku:=false;
      exit;
     end;
    repeat
     s1:='';
     nasel:=false;
     if length(VNamePorostu1)>1 then
      begin
       for i:=2 to length(VNamePorostu1) do
        begin
         if (JenPismena(VNamePorostu1[i-1])and jencisla(VNamePorostu1[i]))and(not nasel) then
          begin
           Nasel:=true;
           io:=i;
          end;
        end;
       if nasel then
        begin
         S1:=copy(VNamePorostu1,1,io-1);
         VNamePorostu1:=copy(VNamePorostu1,io,length(VNamePorostu1)-io+1);
        end
       else
        begin
         S1:=VNamePorostu1;
         VNamePorostu1:='';
        end;
       if length(s1)<3 then
        begin
         NamevPoradku:=false;
        end
       else
        begin
         if not JenCisla(copy(s1,1,length(s1)-2)) then
          begin
           NamevPoradku:=false;
          end;
         if not JenPismena(copy(s1,length(s1)-1,2)) then
          begin
           NamevPoradku:=false;
          end;
         ch:=s1[length(s1)-1];
         ch:=uppercase(ch)[1];
         s1[length(s1)-1]:=ch;

         ch:=s1[length(s1)];
         ch:=lowercase(ch)[1];
         s1[length(s1)]:=ch;

         // showmessage('*'+S1+'*'+VNamePorostu1+'*');
         result:=result+S1;
         if nasel then result:=result+' ';
         // showmessage('*'+result+'*');
        end;
      end;
    until not nasel;
 end;
function  TTransforDleMajitele.GetCeleOzn:string;
 begin
  result:='MAJDR:'+inttostr(MAJ_DRUH)+'MAJKOD:'+MAJ_KOD+' por:"'+inttostr(odd)+dil+por+'"'+' Zmena: '+Zmena_nazev;
 end;
function  TTransforDleMajitele.GetoddDilPor:string;
 begin
  result:=inttostr(odd+10000)+dil+por;
 end;

procedure TTransforDleMajiteleMN.vypisSeDoMema(memo:Tmemo);
var i:integer;
 begin
  memo.lines.add('pocet TTransforDleMajiteleMN ='+ inttostr(count));
  for i:=0 to count-1 do
   begin
    with TTransforDleMajitele(Elements[i]) do
     begin
      memo.lines.add(inttostr(i)+'.  '+CeleOzn+' '+Zmena_nazev);
     end;
   end;
 end;

procedure TCiselOrbis.DoplnMZDHospSoubPuv;
var i,VoHS,ir,vHdr,pp,irNasel:Integer;
   ss,ss1,ss2,ssHdr:String;
   SS_dr,SS_dr1,SS_dr2:String;
   VMZDHospSoub:TMZDHospSoub;
 begin
  for i:=0 to CisHSMN.count -1 do
   begin
    VoHS:= ((TCisHS(CisHSMN.Elements[i]).CISLO_HS)  mod 1000) div 10;
    if (VoHS mod 2) =  0 then VoHS:=VoHS+1;
    vHdr:= TCisHS(CisHSMN.Elements[i]).CISLO_HS mod 10;
    ssHdr:='';
    case vHdr of
         { DO 1.12.2006 /CHYBA
         2:ssHdr:='BO';
         3:ssHdr:='BK';
         4:ssHdr:='DB';
         }
         3:ssHdr:='BO';
         6:ssHdr:='BK';
         5:ssHdr:='DB';
    end;
    for Ir:=1 to maxVyhlLT_MZD do
     begin
      if  (VyhlLT_MZD(ir).oHS=VoHS)and(VyhlLT_MZD(ir).Hdr='') then
       begin
        irNAsel:=0;
        if ssHDR<>'' then
         begin
          for pp:=-8 to 8 do
           begin
            if (pp+ir<maxVyhlLT_MZD)and(pp+ir>0) then
             begin
              if (VyhlLT_MZD(ir+pp).LT=VyhlLT_MZD(ir).LT) and (VyhlLT_MZD(ir+pp).hdr=ssHDR) then
               begin
                irNasel:=pp;
               end;
             end;
           end;
         end;
        ss:=VyhlLT_MZD(ir+irNAsel).LT;
        repeat
         RozdelDlePrvnihoStringu(ss,',',ss1,ss2);
         ss:=SS2;
         SS_dr:=copy(VyhlLT_MZD(ir+irNAsel).Dr,2,length(VyhlLT_MZD(ir+irNAsel).Dr)-1);
         repeat
          RozdelDlePrvnihoStringu(ss_dr,',',ss_dr1,ss_dr2);
          ss_dr:=SS_dr2;
          VMZDHospSoub:=TMZDHospSoub.create;
          VMZDHospSoub.CISLO_HS:=TCisHS(CisHSMN.Elements[i]).CISLO_HS;
          VMZDHospSoub.MZD:=VyhlLT_MZD(ir).p;
          VMZDHospSoub.LT_SLT:=SS1;
          VMZDHospSoub.DR_ZKR:=SS_dr1;
          MZDHospSoubMN.AddElement(VMZDHospSoub);
         until SS_DR='';
        until SS='';
       end;
     end;
   end;

 end;
procedure TCiselOrbis.RozvinMZDHospSoub;
var
 VMZDHospSoub:TMZDHospSoub;
 NovMZDHospSoubMN:TMZDHospSoubMN;
 i,ir,iRozvinLT,iRozvin,hlRozvin,pp,poslirNasel:integer;
 poslUbrLT,HlSLT,HlLT_SLT:String;
 vHdr:integer;
 SShdr,ss_dr,ss_dr1,SS_dr2:String;
 irNasel:integer;
 TestChyb:string;
 begin
  // showmessage('cau RozvinMZDHospSoub');
  // exit;
  NovMZDHospSoubMN:=TMZDHospSoubMN.create;
  poslUbrLT:='';
  for i:=0 to MZDHospSoubMN.Count -1 do
   begin
    with TMZDHospSoub(MZDHospSoubMN.Elements[i]) do
     begin
      {
      if CISLO_HS=416 then
       begin
        showmessage('cau A rozvjm '+LT_SLT+'  poslUbrLT:='+poslUbrLT);
       end;  }
      // TestChyb:='A "'+LT_SLT+'"  poslUbrLT:="'+poslUbrLT+'"';
      iRozvinLT :=-1;
      iRozvin   :=-1;
      for Ir:=1 to maxVyhlLT_MZD do
       begin
        if pos(LT_SLT+',',VyhlLT_MZD(ir).LT)>0 then
         begin
          iRozvinLT:=ir;
          // poslUbrLT:=HlSLT;  // doplneno 2.2.2007
         end;
       end;
      {
      if CISLO_HS=416 then
       begin
        showmessage('cau B rozvjm '+LT_SLT+'  poslUbrLT:='+poslUbrLT);
       end;    }
      // TestChyb:=TestChyb+' B  "'+LT_SLT+'"  poslUbrLT:="'+poslUbrLT+'"';
      if iRozvinLT=-1 then
       begin
        HlSLT:=copy(LT_SLT,1,2)+',';
        if HlSLT=poslUbrLT then
         begin
          iRozvin:=-1;
          hlLT_SLT:=copy(HlSLT,1,2);
          HlRozvin:=poslirNasel;
         end
        else
         begin
          for Ir:=1 to maxVyhlLT_MZD do
           begin
            if pos(HlSLT,VyhlLT_MZD(ir).LT)>0 then
             begin
              iRozvin:=ir;
              poslUbrLT:=HlSLT;
              poslirNasel:=ir;
             end;
           end;
         end;
       end;
      {
      if CISLO_HS=416 then
       begin
        showmessage('cau C rozvjm '+LT_SLT+'  poslUbrLT:='+poslUbrLT);
       end;     }
      // TestChyb:=TestChyb+' C "'+LT_SLT+'"  poslUbrLT:="'+poslUbrLT+'"';

      If (iRozvinLT<>-1) then
       begin
        hlROzvin:=iRozvinLT;
        hlLT_SLT:=LT_SLT;
       end;
     { if CISLO_HS=416 then
       begin
        showmessage('cau D rozvjm '+LT_SLT+'  poslUbrLT:='+poslUbrLT);
       end;  }
      // TestChyb:=TestChyb+' D  "'+LT_SLT+'"  poslUbrLT:="'+poslUbrLT+'"';
      If (iRozvin<>-1) then
       begin
        hlROzvin:=iRozvin;
        hlLT_SLT:=copy(LT_SLT,1,2);
       end;
      { if CISLO_HS=416 then
       begin
        showmessage('cau E rozvjm '+LT_SLT+'  poslUbrLT:='+poslUbrLT);
       end;     }
      // TestChyb:=TestChyb+' E "'+LT_SLT+'"  poslUbrLT:="'+poslUbrLT+'"';
      If (HlRozvin<>-1) then
       begin
        vHdr:= CISLO_HS mod 10;
        ssHdr:='';
        case vHdr of
         { DO 1.12.2006 /CHYBA
         2:ssHdr:='BO';
         3:ssHdr:='BK';
         4:ssHdr:='DB';
         }
         3:ssHdr:='BO';
         6:ssHdr:='BK';
         5:ssHdr:='DB';
        end;
        TestChyb:='';
        repeat
        irNasel:=-999;
        for pp:=hlRozvin-8 to hlRozvin+8 do
         begin
          if (pp>0)and(pp<=maxVyhlLT_MZD) then
           begin
            TestChyb:=TestChyb+'<<'+VyhlLT_MZD(pp).LT+'='+VyhlLT_MZD(hlRozvin).LT+':::'+VyhlLT_MZD(pp).hdr+'='+ssHDR+'>>';
            if (VyhlLT_MZD(pp).LT=VyhlLT_MZD(hlRozvin).LT) and (VyhlLT_MZD(pp).hdr=ssHDR) then
             begin
              TestChyb:=TestChyb+'NNAA';
              irNasel:=pp;
             end;
           end;
         end;
         // showmessage(TestChyb);
         if irNasel=-999 then
          begin
           if ssHDR<>'' then
            begin
             ssHDR:='';
            end
           else
            begin
             showmessage('asto proto, e LT nejsou (ale mus) bt stejn pro rzn dreviny a jeden ridHS');
             showmessage(' pro hlRozvin='+inttostr(hlRozvin)+'  LT='+VyhlLT_MZD(hlRozvin).LT
             +'  ssHDR="'+ssHDR+'" nebylo nalezeno ir :'+TestChyb);
             irNasel:=-998;
            end;
          end;
         until (irNasel<>-999);
         SS_dr:=copy(VyhlLT_MZD(irNAsel).Dr,2,length(VyhlLT_MZD(irNAsel).Dr)-1);
         repeat
          try
          RozdelDlePrvnihoStringu(ss_dr,',',ss_dr1,ss_dr2);
          ss_dr:=SS_dr2;
          VMZDHospSoub:=TMZDHospSoub.create;
          VMZDHospSoub.CISLO_HS:=CISLO_HS;
          VMZDHospSoub.MZD:=VyhlLT_MZD(irNasel).p;
          VMZDHospSoub.LT_SLT:=HlLT_SLT;
          VMZDHospSoub.DR_ZKR:=SS_dr1;
          NovMZDHospSoubMN.AddElement(VMZDHospSoub);
          except
           showmessage('chyba v RozvinMZDHospSoub ss_DR='+ss_DR);
          end;
         until SS_DR='';
       end;
     end;
   end;
  FMZDHospSoubMN.FreeAll;
  FMZDHospSoubMN:=NovMZDHospSoubMN;
  AddElement(NovMZDHospSoubMN);
 end;

procedure TCiselOrbis.DoplnMZDHospSoub(EdInfo:Tedit);
var i,VoHS,ir,vHdr,pp,irNasel:Integer;
   ss,ss1,ss2,ssHdr:String;
   SS_dr,SS_dr1,SS_dr2:String;
   VMZDHospSoub:TMZDHospSoub;
 begin
  for i:=0 to CisHSMN.count -1 do
   begin
    DoEditu('Tvom MZD dle HS a LT soubor: '+intToStr(TCisHS(CisHSMN.Elements[i]).CISLO_HS),EdInfo);

    VoHS:= ((TCisHS(CisHSMN.Elements[i]).CISLO_HS)  mod 1000) div 10;
    if (VoHS mod 2) =  0 then VoHS:=VoHS+1;
    vHdr:= TCisHS(CisHSMN.Elements[i]).CISLO_HS mod 10;
    ssHdr:='';
    case vHdr of
         { DO 1.12.2006 /CHYBA
         2:ssHdr:='BO';
         3:ssHdr:='BK';
         4:ssHdr:='DB';
         }
         3:ssHdr:='BO';
         6:ssHdr:='BK';
         5:ssHdr:='DB';

    end;
    for Ir:=1 to maxVyhlLT_MZD do
     begin
      if  {(VyhlLT_MZD[ir].oHS=VoHS)and} (VyhlLT_MZD(ir).Hdr='') then
       begin
        irNAsel:=0;
        if ssHDR<>'' then
         begin
          for pp:=-8 to 8 do
           begin
            if (pp+ir<maxVyhlLT_MZD)and(pp+ir>0) then
             begin
              if (VyhlLT_MZD(ir+pp).LT=VyhlLT_MZD(ir).LT) and (VyhlLT_MZD(ir+pp).hdr=ssHDR) then
               begin
                irNasel:=pp;
               end;
             end;
           end;
         end;
        ss:=VyhlLT_MZD(ir+irNAsel).LT;
        repeat
         RozdelDlePrvnihoStringu(ss,',',ss1,ss2);
         ss:=SS2;
         SS_dr:=copy(VyhlLT_MZD(ir+irNAsel).Dr,2,length(VyhlLT_MZD(ir+irNAsel).Dr)-1);
         repeat
          RozdelDlePrvnihoStringu(ss_dr,',',ss_dr1,ss_dr2);
          ss_dr:=SS_dr2;
          VMZDHospSoub:=TMZDHospSoub.create;
          VMZDHospSoub.CISLO_HS:=TCisHS(CisHSMN.Elements[i]).CISLO_HS;
          VMZDHospSoub.MZD:=VyhlLT_MZD(ir).p;
          VMZDHospSoub.LT_SLT:=SS1;
          VMZDHospSoub.DR_ZKR:=SS_dr1;
          MZDHospSoubMN.AddElement(VMZDHospSoub);
         until SS_DR='';
        until SS='';
       end;
     end;
   end;
 end;
function  Tmajetky.getMAJ_NAZ_C1:string;
 begin
  if length (fMAJ_NAZ)> 254 then
   begin
    result:=copy(FMAJ_NAZ,1,254);
   end
  else
   begin
    result:=FMAJ_NAZ;
   end;
 end;

function  Tmajetky.getMAJ_NAZ_C2:string;
 begin
  if length (fMAJ_NAZ)> 254 then
   begin
    result:=copy(FMAJ_NAZ,255,length(fMAJ_NAZ)-254);
   end
  else
   begin
    result:='';
   end;
 end;

procedure Tmajetky.SET_MAJ_NAZ_C2(SMAJ_NAZ_C2:String);
 begin
  FMAJ_NAZ:=FMAJ_NAZ+ SMAJ_NAZ_C2;
 end;

function TMZDHospSoub.GetCISLOHS_LTSLT:String;
 begin
  result:=  DoplnZePreduZnakem1(inttostr(CISLO_HS),5,'0')
          + DoplnZezaduZnakem(LT_SLT,3,' ');
 end;

function TDrKtgPhsMN.GetKTGaZvlStDohromady:boolean;
 begin
  if FiKTGaZvlStDohromady=2 then result:=false else result:=true;
 end;
procedure TDrKtgPhsMN.SetKTGaZvlStDohromady(A:boolean);
 begin
  if A then FiKTGaZvlStDohromady:=3 else FiKTGaZvlStDohromady:=2;
 end;

function TDrKtgPhsMN.GetiKTGaZvlStDohromady:integer;
 begin
  result:=FiKTGaZvlStDohromady;
  // showmessage('Get='+inttostr(FiKTGaZvlStDohromady));
 end;
procedure TDrKtgPhsMN.SetiKTGaZvlStDohromady(A:integer);
 begin
  FiKTGaZvlStDohromady:=A;
  // showmessage('Set='+inttostr(FiKTGaZvlStDohromady));
 end;
{
procedure TDrKtgPhs.SetEVLphs(V:string);
 begin
   V:=uppercase(ubm(V));
  if (V<>'V')and(V<>'')and(not JenCisla(V)) then
   begin
    showmessage('EVL me bt jen slo nebo psmeno "V".');
    exit;
   end
  else
   begin
    FEVLphs:=V;
   end;
 end; }
function UpravaCis(var V:string;NazProp:string):boolean;
 begin
   V:=uppercase(ubm(V));
  if (V<>'V')and(V<>'')and(not JenCisla(V)) then
   begin
    showmessage(NazProp + ' me bt jen slo nebo psmeno "V".');
    result:=false;
   end
  else
   begin
    result:=true;
   end;
 end;
function UpravaCisLom(var V:string;NazProp:string):boolean;
var i:integer;
 begin
   V:=uppercase(ubm(V));
   if V='' then
    begin
     result:=true;
     exit;
    end;
  for i:=1 to length(V) do
   begin
    if V[i]='\' then V[i]:='/';
   end;
  if V[1]='/' then V:=copy(v,2,length(V)-1);
  if V[length(V)]='/' then V:=copy(v,1,length(V)-1);
  if (V<>'V')and(not JenCislaALomitka(V)) then
   begin
    showmessage(NazProp + ' me bt jen slo, sla oddlen lomtkem nebo psmeno "V".');
    result:=false;
   end
  else
   begin
    result:=true;
   end;

 end;
procedure TDrKtgPhs.SetEVLphs(V:string);
 begin
  if UpravaCisLom(V,'EVL') then FEVLphs:=V;
 end;
procedure TDrKtgPhs.SetPOphs      (V:string);
 begin
  if UpravaCis(V,'PO') then FPOphs:=V;
 end;
procedure TDrKtgPhs.SetCHKOphs    (V:string);
 begin
  if UpravaCis(V,'CHKO') then FCHKOphs:=V;
 end;
procedure TDrKtgPhs.SetCHKO_Zphs  (V:string);
 begin
  if UpravaCis(V,'CHKO_Z') then FCHKO_Zphs:=V;
 end;
procedure TDrKtgPhs.SetNPphs      (V:string);
 begin
  if UpravaCis(V,'NP') then FNPphs:=V;
 end;
procedure TDrKtgPhs.SetNP_Zphs    (V:string);
 begin
  if UpravaCis(V,'NP_Z') then FNP_Zphs:=V;
 end;
procedure TDrKtgPhs.SetNPPphs     (V:string);
 begin
  if UpravaCisLom(V,'NPP') then FNPPphs:=V;
 end;
procedure TDrKtgPhs.SetNPRphs     (V:string);
 begin
  if UpravaCisLOM(V,'NPR') then FNPRphs:=V;
 end;
procedure TDrKtgPhs.SetPPphs      (V:string);
 begin
  if UpravaCis(V,'PP') then FPPphs:=V;
 end;
procedure TDrKtgPhs.SetPRphs      (V:string);
 begin
  if UpravaCis(V,'PR') then FPRphs:=V;
 end;
procedure TDrKtgPhs.SetSCHUphs    (V:string);
 begin
  if UpravaCis(V,'SCHU') then FSCHUphs:=V;
 end;

procedure TCisHs.SetJdeDoSestavDTO(VJdeDoSestavDTO:string);
 begin
  VJdeDoSestavDTO:=uppercase(ubm(VJdeDoSestavDTO));
  If VJdeDoSestavDTO='' then VJdeDoSestavDTO:='A';
  if VJdeDoSestavDTO[1]='N' then FJdeDoSestavDTO:='N' else FJdeDoSestavDTO:='A';
 end;

function TCisHsMN.GetHScoNejdouDoSestavDTO:String;
var i:integer;
 begin
  result:='';
  for i:=0 to count-1 do
   begin
    with TCisHs(elements[i]) do
     begin
      if JdeDoSestavDTO='N' then
       begin
        if result<>'' then result:=result+',';
        result:=result+inttostr(CISLO_HS);
       end;
     end;
   end;
 end;

procedure TKrnapRSHMN.Nactise(Table1:TTable);
var
 VKrnapRSH: TKrnapRSH;
 begin
  Table1.open;
  while not Table1.eof do
   begin
    with table1 do
     begin
      VKrnapRSH:= TKrnapRSH.create;
       with VKrnapRSH do
        begin

         TVL:= fieldByName('TVL').asinteger;

        MNG[1]:=strtoInt0(fieldByName('MNG1').AsString);
        MNG[2]:=strtoInt0(fieldByName('MNG2').AsString);
        MNG[3]:=strtoInt0(fieldByName('MNG3').AsString);

        HL_DR[1]:=fieldByName('HL_DR1').AsString;
        HL_DR[2]:=fieldByName('HL_DR2').AsString;
        HL_DR[3]:=fieldByName('HL_DR3').AsString;
        HL_DR[4]:=fieldByName('HL_DR4').AsString;

        ZAST_DR[1]:=strtoInt0(fieldByName('ZAST_DR1').AsString);
        ZAST_DR[2]:=strtoInt0(fieldByName('ZAST_DR2').AsString);
        ZAST_DR[3]:=strtoInt0(fieldByName('ZAST_DR3').AsString);
        ZAST_DR[4]:=strtoInt0(fieldByName('ZAST_DR4').AsString);

        V_DR[1]:=fieldByName('V_DR1').AsString;
        V_DR[2]:=fieldByName('V_DR2').AsString;
        V_DR[3]:=fieldByName('V_DR3').AsString;
        V_DR[4]:=fieldByName('V_DR4').AsString;
        V_DR[5]:=fieldByName('V_DR5').AsString;
        V_DR[6]:=fieldByName('V_DR6').AsString;
        V_DR[7]:=fieldByName('V_DR7').AsString;


        SLT_LT[1]:=fieldByName('SLT_LT1').AsString;
        SLT_LT[2]:=fieldByName('SLT_LT2').AsString;
        SLT_LT[3]:=fieldByName('SLT_LT3').AsString;
        SLT_LT[4]:=fieldByName('SLT_LT4').AsString;
        SLT_LT[5]:=fieldByName('SLT_LT5').AsString;
        SLT_LT[6]:=fieldByName('SLT_LT6').AsString;
        SLT_LT[7]:=fieldByName('SLT_LT7').AsString;
        SLT_LT[8]:=fieldByName('SLT_LT8').AsString;
        SLT_LT[9]:=fieldByName('SLT_LT9').AsString;
        SLT_LT[10]:=fieldByName('SLT_LT10').AsString;


 { ZAST_DR:Array[1..5] of integer;
  V_DR:Array[1..8] of stringdr;
          }
        end;
      self.AddElement(VKrnapRSH);
      next;
     end;
   end;
    table1.close;
 end;

function  TKrnapRSHMN.NajdiVhodnyRadek(vTVL:integer;vLT:stringdr;vMNG:integer):TKrnapRSH;
Var
 i,ir:integer;
 nasel, naselNeprazdny:boolean;
 vSLT:string;
 begin
  result:= nil;
  for i:=0 to count-1 do
   begin
    with TKrnapRSH(Elements[i]) do
     begin
      nasel:=false;
      if (TVL=vTVL) then
       begin
        naselNeprazdny:=false;
        for ir:=1 to 3 do
         begin
          if mng[ir]<>0 then naselNeprazdny:=true;
         end;
        if not naselneprazdny then
         begin
          nasel:=true;
         end
        else
         begin
          nasel:=false;
          for ir:=1 to 3 do
           begin
            if mng[ir]=vMNG then nasel:=true;
           end;
         end;
        if nasel then
         begin
          nasel:=false;
          if length(vLT)>2 then vSLT:=copy(vLT,1,2) else vSLT:=vLT;
          for ir:=1 to 10 do
           begin
            if copy(SLT_LT[ir],1,2)=vSLT then nasel:=true;
           end;
         end;
       end;
     end;
    if nasel then
     begin
      result:=TKrnapRSH(Elements[i]);
      // Showmessage('Cislo radku v KrnapRSH.DB je ' + inttostr(i+1));
     end;
   end;
 end;

Procedure TKrnapRSH.ZaradDoHL_DR(vHl_DR:string;vZAST:double);
var i:integer;
  begin
   for i:=1 to 4 do
    begin
     if ubm(vHl_DR)=ubm(Hl_DR[i]) then
      begin
       if vZAST/ZAST_DR[i] > 0.749 then
        begin
         JePritomnaVeSK75[i]:=true;
        end;
       if vZAST/ZAST_DR[i] > 0.499 then
        begin
         JePritomnaVeSK50[i]:=true;
        end;
     end
    end;
  end;

Function TKrnapRSH.JeV_DR(vV_DR:string):boolean;
var i:integer;
  begin
   result:=false;
   for i:=1 to 7 do
    begin
     if ubm(vV_DR)=ubm(V_DR[i]) then
      begin
       result:=true;
      end
    end;
  end;


Function TKrnapRSH.VsechnyHlDrBylyPritomny75:boolean;
var i:integer;
  begin
   result:=true;
   for i:=1 to 4 do
    begin
     if (ubm(Hl_DR[i])<>'')and(JePritomnaVeSK75[i]=false)  then
      begin
       result:=false;
      end;
    end;
  end;

Function TKrnapRSH.VsechnyHlDrBylyPritomny50:boolean;
var i:integer;
  begin
   result:=true;
   for i:=1 to 4 do
    begin
     if (ubm(Hl_DR[i])<>'')and(JePritomnaVeSK50[i]=false)  then
      begin
       result:=false;
      end;
    end;
  end;



procedure TKrnapRSH.VynulujJePritomnaVeSK;
var i:integer;
  begin
   for i:=1 to 4 do
    begin
     JePritomnaVeSK50[i]:=false;
     JePritomnaVeSK75[i]:=false;
    end;
  end;

Function TKrnapRSH.ZASTdleHl_DR(vHl_DR:string):integer;
var i:integer;
  begin
   result:=0;
   for i:=1 to 4 do
    begin
     if ubm(vHl_DR)=ubm(Hl_DR[i]) then result:=ZAST_DR[i];
    end;
  end;

Function TKrnapRSH.SumZASTHl_DR:integer;
 var i:integer;
  begin
   result:=0;
   for i:=1 to 4 do
    begin
     if (ubm(Hl_DR[i])<>'') then result:=result+ZAST_DR[i];
    end;
  end;


initialization
 registerOrbisClass(TMajetky);
 registerOrbisClass(TMajetkyMN);
 registerOrbisClass(TMajPoPorostech);
 registerOrbisClass(TMajPoPorostechMN);
 registerOrbisClass(TTransforDleMajiteleMN);
 registerOrbisClass(TTransforDleMajitele);

 registerOrbisClass(THospSoubPhsMN);
 registerOrbisClass(THospSoubPhs);
 registerOrbisClass(TLesTypPhsMN);
 registerOrbisClass(TLesTypPhs);
 registerOrbisClass(TDrKtgPhsMN);
 registerOrbisClass(TDrKtgPhs);
 registerOrbisClass(TSpecPodHSPhsMN);
 registerOrbisClass(TSpecPodHSPhs);
 registerOrbisClass(TProbirkaPhsMN);
 registerOrbisClass(TProbirkaPhs);

 registerOrbisClass(TKrnapRSHMN);
 registerOrbisClass(TKrnapRSH);

 registerOrbisClass(TcisHsMN);
 registerOrbisClass(TcisHs);

 registerOrbisClass(TVybTextMN);
 registerOrbisClass(TVybText);
 registerOrbisClass(TPoznNmdDto);

 registerOrbisClass(TOLH);
 registerOrbisClass(TOLHMN);

end.
