unit SP_KonNactiPl;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Grids, db,
  E_LesCel, E_LesOdd, ELesObec, dbtables, U_Zobraz, mat1, StdCtrls;

type
  TSumNactP0110 = class(TObecnyLesniPrvek)
   private
    FOdd:Integer;
    FDIL:string;
    FPOR:string;
    FPSK:string;
    FJeVTaxu:String;
    FPocetVP0110:integer;
   Public
   Published
    property LOdd: integer read FOdd write FOdd;
    property LDIL: string  read FDIL write FDIL;
    property LPOR: string  read FPOR write FPOR;
    property LPSK: string  read FPSK write FPSK;
    property JeVTaxu: string  read FJeVTaxu write FJeVTaxu;
    property PocetVP0110:integer  read FPocetVP0110 write FPocetVP0110;
  end;
  TSumNactP0110Mn = class(TLesniMnozina)
   private
   Public
    constructor Create; override;
   Published
  end;

  TFSP_KonNactiPl = class(TForm)
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    P0110:TQuery;
    LesniCelek:TLesniCelek;
    VOddeleni:TOddeleni;
    SumNactP0110Mn:TSumNactP0110Mn;
    stGrmSumNact:TStringGridMuj;
    LKolikNacist:TKolikNacist;
    procedure RePaint; override;
    procedure Prezobraz;
    procedure naplnSumNactP0110MnTabulkou(Tabulka:TDataSet);
    procedure naplnSumNactP0110MnPorostniSkupinou(VPorSk:TPorostniSkupina);
    procedure naplnSumNactP0110MnPorost(VPorost:TPorost);
    procedure naplnSumNactP0110MnDilec(VDilec:TDilec);
    procedure naplnSumNactP0110MnOddeleni(VOddeleni:TOddeleni);
    procedure naplnSumNactP0110Mn;
  end;

var
  FSP_KonNactiPl: TFSP_KonNactiPl;
  procedure VytvorSumNactP0110(VStGrmSumNact:TStringGridMuj);

implementation

{$R *.DFM}
constructor TSumNactP0110Mn.Create;
 begin
  inherited create;
  FClass:=TSumNactP0110;
  FPredponaName:='NactP0110';
 end;

procedure TFSP_KonNactiPl.PreZobraz;
 begin
  if LesniCelek<>nil then
   begin
    with stGrmSumNact do
     begin
      ObLesMN:=SumNactP0110Mn;
      mnozinuDoGridu;
     end;
   end;
 end;
procedure TFSP_KonNactiPl.RePaint;
 begin
  prezobraz;
  inherited repaint;
 end;

procedure TFSP_KonNactiPl.FormCreate(Sender: TObject);
  begin
   stGrmSumNact:=TStringGridMuj.Create(Self);
   VytvorSumNactP0110(stGrmSumNact);
   StGrmSumNact.Parent :=GroupBox1;
   SumNactP0110Mn:=TSumNactP0110Mn.create;
  end;
procedure TFSP_KonNactiPl.naplnSumNactP0110Mn;
 begin
  case LKolikNacist of
   nacOddeleni:begin
                naplnSumNactP0110MnOddeleni(VOddeleni);
               end;
   nacDilec   :begin
                naplnSumNactP0110MnDilec(VOddeleni.dilec);
               end;
   nacPorost  :begin
                naplnSumNactP0110MnPorost(VOddeleni.dilec.porost);
               end;
   NacSkupinu :begin
                naplnSumNactP0110MnPorostniSkupinou(VOddeleni.dilec.porost.porostniSkupina);
               end;
  end; {case}
  naplnSumNactP0110MnTabulkou(P0110);
  prezobraz;
 end;
procedure TFSP_KonNactiPl.naplnSumNactP0110MnDilec(VDilec:TDilec);
var
  i:integer;
 begin
  for i:=0 to Vdilec.porostMN.count-1 do
   begin
    naplnSumNactP0110MnPorost(VDilec.iPorost[i]);
   end;
 end;
procedure TFSP_KonNactiPl.naplnSumNactP0110MnTabulkou(Tabulka:TDataSet);
var sODD,i:integer;
    sDIL,sPOR,sPSK:string;
    jeShodny,bylVtaxu:boolean;
    VSumNactP0110:TSumNactP0110;
 begin
  tabulka.first;
  while not tabulka.eof do
   begin
    sDIL:='';sPOR:='';sPSK:='';
    sODD:=-1;
    if tabulka.FindField('ODDELENI')<>nil then
      begin
       sODD:=tabulka.FieldByName('ODDELENI').asinteger;
      end;
    if tabulka.FindField('DILEC')<>nil then
      begin
       sDIL:=tabulka.FieldByName('DILEC').asstring;
      end;
    if tabulka.FindField('POROST')<>nil then
      begin
       sPOR:=tabulka.FieldByName('POROST').asstring;
      end;
    if tabulka.FindField('SKUPINA')<>nil then
      begin
       sPSK:=ubm(tabulka.FieldByName('SKUPINA').asstring);
      end;
    for i:=0 to  SumNactP0110Mn.count-1 do
      begin
       with TSumNactP0110(SumNactP0110Mn.Elements[i]) do
        begin
         if (sODD<>-1)or(sDil<>'')or(sPOR<>'')or(sPSK<>'') then jeShodny:=true else jeShodny:=true;
         if (sODD<>-1) then
           begin
            if sODD<>LOdd then jeShodny:=false;
           end;
         if (sDIL<>'') then
           begin
            if sDIL<>LDil then jeShodny:=false;
           end;
         if (sPOR<>'') then
           begin
            if sPOR<>LPOR then jeShodny:=false;
           end;
         if (sPSK<>'') then
           begin
            if UBM(sPSK)<>ubm(LPSK) then jeShodny:=false;
           end;
         if jeShodny then
           begin
            PocetVP0110:=POcetVP0110+1;
            BylVTaxu:=true
           end;
        end;
      end;
    if not BylVTaxu then
     begin
      VSumNactP0110:=TSumNactP0110.create;
      with VSumNactP0110 do
       begin
        Lodd:=SOdd;
        LDil:=sDIL;
        LPor:=sPOR;
        LPsk:=sPSK;
        JeVTaxu:='NENI!!!';
       end;
      SumNactP0110Mn.AddElement(VSumNactP0110);
     end;
    tabulka.next;
   end;
  tabulka.first;
 end;
procedure TFSP_KonNactiPl.naplnSumNactP0110MnOddeleni(VOddeleni:TOddeleni);
var
  i:integer;
 begin
  for i:=0 to Voddeleni.dilecMN.count-1 do
   begin
    naplnSumNactP0110MnDilec(VOddeleni.idilec[i]);
   end;
 end;
procedure TFSP_KonNactiPl.naplnSumNactP0110MnPorost(VPorost:TPorost);
Var VSumNactP0110:TSumNactP0110;
    I:integer;
 begin
  with VPorost do
   begin
    for i:=0 to porostniSkupinaMN.count-1 do
     begin
      naplnSumNactP0110MnPorostniSkupinou(IporostniSkupina[i]);
     end;
    for i:=0 to BezlesiMN.count-1  do
     begin
      VSumNactP0110:=TSumNactP0110.create;
      with VSumNactP0110 do
       begin
        Lodd:=ownerDilec.OwnerOddeleni.odd;
        LDil:=ownerDilec.DIL;
        LPor:=POR;
        LPsk:=inttostr(IBezlesi[i].BZL);
        JeVTaxu:='ANO';
       end;
      SumNactP0110Mn.AddElement(VSumNactP0110);
     end;
    for i:=0 to jinyPozemekMN.count-1  do
     begin
      VSumNactP0110:=TSumNactP0110.create;
      with VSumNactP0110 do
       begin
        Lodd:=ownerDilec.OwnerOddeleni.odd;
        LDil:=ownerDilec.DIL;
        LPor:=POR;
        LPsk:=inttostr(IJinyPozemek[i].JP);
        JeVTaxu:='ANO';
       end;
      SumNactP0110Mn.AddElement(VSumNactP0110);
     end;
    for i:=0 to OstatniMN.count-1  do
     begin
      VSumNactP0110:=TSumNactP0110.create;
      with VSumNactP0110 do
       begin
        Lodd:=ownerDilec.OwnerOddeleni.odd;
        LDil:=ownerDilec.DIL;
        LPor:=POR;
        LPsk:=inttostr(IOstatni[i].OST);
        JeVTaxu:='ANO';
       end;
      SumNactP0110Mn.AddElement(VSumNactP0110);
     end;

   end;
 end;
procedure TFSP_KonNactiPl.naplnSumNactP0110MnPorostniSkupinou(VPorSk:TPorostniSkupina);
Var VSumNactP0110:TSumNactP0110;
 begin
  VSumNactP0110:=TSumNactP0110.create;
  with VSumNactP0110 do
   begin
    LOdd:=VPorSk.ownerPorost.ownerDilec.OwnerOddeleni.ODD;
    LDil:=VPorSk.ownerPorost.ownerDilec.DIL;
    LPor:=VPorSk.ownerPorost.por;
    LPsk:=VPorSk.PSK;
    JeVTaxu:='ANO';
   end;
  SumNactP0110Mn.AddElement(VSumNactP0110);
 end;
{
 begin
  for iDil:=0 to VOddeleni.dilecMN.count-1 do
   begin
    for iPor:=0 to VOddeleni.iDilec[iDil].porostMN.count-1 do
   end;
 end;
}
procedure VytvorSumNactP0110(VStGrmSumNact:TStringGridMuj);
var i:integer;
 begin
  with VStGrmSumNact do
   begin
    name:='StGrmSumNact';
    NastavStringGridMujNaTaxPHS(VstGrmSumNact);
    fixedCols:=0;
    // Parent := GroupHSZasahPhs;
    align := alClient;
    menitRowHeights:=true;
    ZobrazeniGridu:=vybranePole;
    ObLesMN:=TSumNactP0110Mn.create;
    NastavGrid;
    with VlastnostiSloupcuMN do
     begin
      for I:=0 to count-1 do
       begin
        with TVlastnostiSloupcu(elements[i]) do
         begin
          viditelny:=False;
         end;
       end;
      JmenoAktualnihoPrvku:='LOdd';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=10*kr;
        Nadpis:='Oddlen';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='LDil';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=10*kr;
        Nadpis:='Dlec';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='LPor';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=10*kr;
        Nadpis:='Porost';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='LPsk';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=10*kr;
        Nadpis:='Porostn@$&Skupina';
        poziceTisku:=uprostred;
       end;


      JmenoAktualnihoPrvku:='JeVTaxu';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=15*kr;
        Nadpis:='Je ptomen@$& v tax. datech';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='PocetVP0110';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=16*kr;
        Nadpis:='Poet ploch@$&v map';
        poziceTisku:=uprostred;
       end;
     end;
    PripravZobrazeniGridu;
    options:=[goFixedVertLine,goFixedHorzLine,goVertLine,goHorzLine,goRangeSelect,goEditing];
   end;
 end;


end.
