unit SpOchrPrir;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ELesObec,E_lesCel, E_lesOdd, uPrevod, U_Zobraz, dotaz, mat1,
  ExtCtrls, StdCtrls, iniFiles;

type
  TFOchrPrir = class(TForm)
    LOdd: TLabel;
    LDilec: TLabel;
    LPorost: TLabel;
    LEVL: TLabel;
    LNPP: TLabel;
    LNPR: TLabel;
    LPO_KOD: TLabel;
    LCHKO_KOD: TLabel;
    LCHKO_Z_KOD: TLabel;
    LNP_KOD: TLabel;
    LNP_Z_KOD: TLabel;
    LPP_KOD: TLabel;
    LPR_KOD: TLabel;
    LSCHU_KOD: TLabel;
    Label1: TLabel;
    LOzn: TLabel;
    ButTridCisOchr: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButTridCisOchrClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
     LesniCelek:TLesniCelek;
     LLesniPlosnyPrvek:TLesniPlosnyPrvek;
     stGrmEVL,stGrmNPR,stGrmNPP:TStringGridMuj;
     stGrm1ODD,stGrm1DIL,stGrm1POR,stGrm1OZN:TStringGridMujJednoPole;
     stGrm1PO_KOD,stGrm1CHKO_KOD,stGrm1CHKO_Z_KOD,stGrm1NP_KOD,stGrm1NP_Z_KOD,stGrm1PP_KOD,
     stGrm1PR_KOD,stGrm1SCHU_KOD:TStringGridMujJednoPole;

     cobEVL,cobNPR,cobNPP :TComboBoxCiselnikProGrid;
     cobPO_KOD, cobCHKO_KOD, cobCHKO_Z_KOD,
     cobNP_KOD, cobNP_Z_KOD, cobPP_KOD, cobPR_KOD, cobSCHU_KOD : TComboBoxCiselnik;

     procedure PreZobraz;
     procedure RePaint; override;
     procedure stGrmEVLExit(Sender: TObject);
     procedure stGrmEVLKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
     procedure stGrmEVLEnter(Sender: TObject);
     procedure stGrmEVLDblClick(Sender: TObject);

     procedure stGrmNPRExit(Sender: TObject);
     procedure stGrmNPRKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
     procedure stGrmNPREnter(Sender: TObject);
     procedure stGrmNPRDblClick(Sender: TObject);

     procedure stGrmNPPExit(Sender: TObject);
     procedure stGrmNPPKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
     procedure stGrmNPPEnter(Sender: TObject);
     procedure stGrmNPPDblClick(Sender: TObject);

     procedure ZobrazCobEVL;
     procedure ZobrazCobNPR;
     procedure ZobrazCobNPP;

  end;

var
  FOchrPrir: TFOchrPrir;
  jmTabSCHU1:String;
implementation

procedure TFOchrPrir.PreZobraz;
 begin
  if triditAbecedneCiselnikyOchrPrir  then
   begin
    cobPO_KOD.setrid(sOdPomlcky,true);
    cobPR_KOD.setrid(sOdPomlcky,true);
    cobPP_KOD.setrid(sOdPomlcky,true);
    cobCHKO_KOD.setrid(sOdPomlcky,true);
    cobNP_KOD.setrid(sOdPomlcky,true);
    cobSCHU_KOD.setrid(sOdPomlcky,true);
    cobEVL.setrid(sOdPomlcky,true);
    cobNPR.setrid(sOdPomlcky,true);
    cobNPP.setrid(sOdPomlcky,true);
    ButTridCisOchr.Caption:='Tdit selniky seln';
   end
  else
   begin
    cobPO_KOD.setrid(sDoPomlcky,true);
    cobPR_KOD.setrid(sDoPomlcky,true);
    cobPP_KOD.setrid(sDoPomlcky,true);
    cobCHKO_KOD.setrid(sDoPomlcky,true);
    cobNP_KOD.setrid(sDoPomlcky,true);
    cobSCHU_KOD.setrid(sDoPomlcky,true);
    cobEVL.setrid(sDoPomlcky,true);
    cobNPR.setrid(sDoPomlcky,true);
    cobNPP.setrid(sDoPomlcky,true);
    ButTridCisOchr.Caption:='Tdit selniky abecedn';
   end;
  with LesniCelek.lhc do
   begin
    oddeleniVzdy.VlastnostiMNCreateKdyzNejsou;
    dilecVzdy.VlastnostiMNCreateKdyzNejsou;
    porostVzdy.VlastnostiMNCreateKdyzNejsou;
    with stGrm1ODD do
     begin
      ObLesPrvek:=oddeleniVzdyN;
      refresh;
     end;
    with stGrm1DIL do
     begin
      ObLesPrvek:=DilecVzdy;
      refresh;
     end;
    with stGrm1POR do
     begin
      ObLesPrvek:=porostVzdy;
      refresh;
     end;
    with stGrm1OZN do
     begin
      ObLesPrvek:=LLesniPlosnyPrvek;
      refresh;
     end;
     with stGrm1PO_KOD do
     begin
      ObLesPrvek:=LLesniPlosnyPrvek;
      refresh;
      PouzeCteni:=false;
     end;

     with stGrm1CHKO_KOD  do
     begin
      ObLesPrvek:=LLesniPlosnyPrvek;
      refresh;
      PouzeCteni:=false;
     end;
     with stGrm1CHKO_Z_KOD  do
     begin
      ObLesPrvek:=LLesniPlosnyPrvek;
      refresh;
      PouzeCteni:=false;
     end;
     with stGrm1NP_KOD  do
     begin
      ObLesPrvek:=LLesniPlosnyPrvek;
      refresh;
      PouzeCteni:=false;
     end;
     with stGrm1NP_Z_KOD  do
     begin
      ObLesPrvek:=LLesniPlosnyPrvek;
      refresh;
      PouzeCteni:=false;
     end;
     with stGrm1PP_KOD  do
     begin
      ObLesPrvek:=LLesniPlosnyPrvek;
      refresh;
      PouzeCteni:=false;
     end;
     with stGrm1PR_KOD   do
     begin
      ObLesPrvek:=LLesniPlosnyPrvek;
      refresh;
      PouzeCteni:=false;
     end;
     with stGrm1SCHU_KOD  do
     begin
      ObLesPrvek:=LLesniPlosnyPrvek;
      refresh;
      PouzeCteni:=false;
     end;

    with stGrmEVL do
     begin
      ObLesMN:=LLesniPlosnyPrvek.EVL_KODmn;
      mnozinuDoGriduAVlastnosti;
      PouzeCteni:=false;
     end;
    with stGrmNPR do
     begin
      ObLesMN:=LLesniPlosnyPrvek.NPR_KODmn;
      mnozinuDoGriduAVlastnosti;
      PouzeCteni:=false;
     end;
    with stGrmNPP do
     begin
      ObLesMN:=LLesniPlosnyPrvek.NPP_KODmn;
      mnozinuDoGriduAVlastnosti;
      PouzeCteni:=false;
     end;
   end;
 end;

procedure TFOchrPrir.RePaint;
 begin
  inherited repaint;
  prezobraz;
 end;



{$R *.DFM}

procedure TFOchrPrir.FormCreate(Sender: TObject);
var i:integer;
begin
  stGrm1ODD:=TStringGridMujJednoPole.Create(Self);
  with StGrm1ODD do
   begin
    Parent  := self;
    top     := 12;
    left    := 6;
    mheight := 19;
    mwidth  := 35;
    JmenoProperty:='ODD';
   end;
  LODD.left:=stGrm1ODD.left;
  stGrm1DIL:=TStringGridMujJednoPole.Create(Self);
  with StGrm1DIL do
   begin
    Parent  := self;
    top     := 12;
    left    := 58;
    mheight := 19;
    mwidth  := 19;
    JmenoProperty:='DIL';
   end;
  LDilec.left:=stGrm1DIL.left;

  stGrm1POR:=TStringGridMujJednoPole.Create(Self);
  with StGrm1POR do
   begin
    Parent := self;
    top    := 12;
    left   := 94;
    mheight := 19;
    mwidth  := 20;
    JmenoProperty:='POR';
   end;
  LPorost.left:=stGrm1POR.left;

  stGrm1OZN:=TStringGridMujJednoPole.Create(Self);
  with StGrm1OZN do
   begin
    Parent := self;
    top    := 12;
    left   := 94;
    mheight := 19;
    mwidth  := 80;
    JmenoProperty:='Ozn';
   end;
  LOzn.left:=stGrm1OZN.left;


  CobPO_KOD:=TComboBoxCiselnik.Create(Self);
  with CobPO_KOD do
   begin
    Parent := self;
    MaxWidth:=185;
    ZpPrevodu:=doPomlcky;
    DropDownCount:=12;
    name:='CobPO_KOD';
   end;

  stGrm1PO_KOD:=TStringGridMujJednoPole.Create(Self);
  with StGrm1PO_KOD do
   begin
    Parent := self;
    top    := 12;
    left   := 94;
    mheight := 19;
    mwidth  := 60;
    JmenoProperty:='PO_KOD';
    PocetZnaku:=6;
    typPolozky:='I';
   end;
  SetTopPod(stGrm1PO_KOD,LPO_KOD);
  SetStredX(stGrm1PO_KOD,GetStredX(LPO_KOD));
  CobPO_KOD.JednoPole:=StGrm1PO_KOD;
  CobPO_KOD.NactiZTabulky
              (KPoslednimuZnaku(Application.ExeName,'\')
                                       +'\ciselnik\C_OCHR_PO.DB','POPIS');
  SetStredX(LPO_KOD,GetStredX(CobPO_KOD));
  // upravMaxLeft(CobPO_KOD,self.Width);



  CobCHKO_KOD:=TComboBoxCiselnik.Create(Self);
  with CobCHKO_KOD do
   begin
    Parent := self;
    MaxWidth:=185;
    ZpPrevodu:=doPomlcky;
    DropDownCount:=12;
    name:='CobCHKO_KOD';
   end;

  stGrm1CHKO_KOD:=TStringGridMujJednoPole.Create(Self);
  with StGrm1CHKO_KOD do
   begin
    Parent := self;
    top    := 12;
    left   := 94;
    mheight := 19;
    mwidth  := 60;
    JmenoProperty:='CHKO_KOD';
    PocetZnaku:=6;
    typPolozky:='I';
   end;
  SetTopPod(stGrm1CHKO_KOD,LCHKO_KOD);
  SetStredX(stGrm1CHKO_KOD,GetStredX(LCHKO_KOD));
  CobCHKO_KOD.JednoPole:=StGrm1CHKO_KOD;
  CobCHKO_KOD.NactiZTabulky
              (KPoslednimuZnaku(Application.ExeName,'\')
                                       +'\ciselnik\C_OCHR_CHKO.DB','POPIS');
  SetStredX(LCHKO_KOD,GetStredX(CobCHKO_KOD));
  // upravMaxLeft(CobPO_KOD,self.Width);

  CobCHKO_Z_KOD:=TComboBoxCiselnik.Create(Self);
  with CobCHKO_Z_KOD do
   begin
    Parent := self;
    MaxWidth:=185;
    ZpPrevodu:=doPomlcky;
    DropDownCount:=12;
    name:='CobCHKO_Z_KOD';
   end;

  stGrm1CHKO_Z_KOD:=TStringGridMujJednoPole.Create(Self);
  with StGrm1CHKO_Z_KOD do
   begin
    Parent := self;
    top    := 12;
    left   := 94;
    mheight := 19;
    mwidth  := 60;
    JmenoProperty:='CHKO_Z_KOD';
    PocetZnaku:=6;
    typPolozky:='I';
   end;
  SetTopPod(stGrm1CHKO_Z_KOD,LCHKO_Z_KOD);
  SetStredX(stGrm1CHKO_Z_KOD,GetStredX(LCHKO_Z_KOD));
  CobCHKO_Z_KOD.JednoPole:=StGrm1CHKO_Z_KOD;
  CobCHKO_Z_KOD.NactiZTabulky
              (KPoslednimuZnaku(Application.ExeName,'\')
                                       +'\ciselnik\C_OCHR_ZONY.DB','POPIS');
  SetStredX(LCHKO_Z_KOD,GetStredX(CobCHKO_Z_KOD));

  CobNP_KOD:=TComboBoxCiselnik.Create(Self);
  with CobNP_KOD do
   begin
    Parent := self;
    MaxWidth:=185;
    ZpPrevodu:=doPomlcky;
    DropDownCount:=12;
    name:='CobNP_KOD';
   end;
  stGrm1NP_KOD:=TStringGridMujJednoPole.Create(Self);
  with StGrm1NP_KOD do
   begin
    Parent := self;
    top    := 12;
    left   := 94;
    mheight := 19;
    mwidth  := 60;
    JmenoProperty:='NP_KOD';
    PocetZnaku:=6;
    typPolozky:='I';
   end;
  SetTopPod(stGrm1NP_KOD,LNP_KOD);
  SetStredX(stGrm1NP_KOD,GetStredX(LNP_KOD));
  CobNP_KOD.JednoPole:=StGrm1NP_KOD;
  CobNP_KOD.NactiZTabulky
              (KPoslednimuZnaku(Application.ExeName,'\')
                                       +'\ciselnik\C_OCHR_NP.DB','POPIS');
  SetStredX(LNP_KOD,GetStredX(CobNP_KOD));


  CobNP_Z_KOD:=TComboBoxCiselnik.Create(Self);
  with CobNP_Z_KOD do
   begin
    Parent := self;
    MaxWidth:=185;
    ZpPrevodu:=doPomlcky;
    DropDownCount:=12;
    name:='CobNP_Z_KOD';
   end;
  stGrm1NP_Z_KOD:=TStringGridMujJednoPole.Create(Self);
  with StGrm1NP_Z_KOD do
   begin
    Parent := self;
    top    := 12;
    left   := 94;
    mheight := 19;
    mwidth  := 60;
    JmenoProperty:='NP_Z_KOD';
    PocetZnaku:=6;
    typPolozky:='I';
   end;
  SetTopPod(stGrm1NP_Z_KOD,LNP_Z_KOD);
  SetStredX(stGrm1NP_Z_KOD,GetStredX(LNP_Z_KOD));
  CobNP_Z_KOD.JednoPole:=StGrm1NP_Z_KOD;
  CobNP_Z_KOD.NactiZTabulky
              (KPoslednimuZnaku(Application.ExeName,'\')
                                       +'\ciselnik\C_OCHR_ZONY.DB','POPIS');
  SetStredX(LNP_Z_KOD,GetStredX(CobNP_Z_KOD));

  CobPP_KOD:=TComboBoxCiselnik.Create(Self);
  with CobPP_KOD do
   begin
    Parent := self;
    MaxWidth:=185;
    ZpPrevodu:=doPomlcky;
    DropDownCount:=12;
    name:='CobPP_KOD';
   end;
  stGrm1PP_KOD:=TStringGridMujJednoPole.Create(Self);
  with StGrm1PP_KOD do
   begin
    Parent := self;
    top    := 12;
    left   := 94;
    mheight := 19;
    mwidth  := 60;
    JmenoProperty:='PP_KOD';
    PocetZnaku:=6;
    typPolozky:='I';
   end;
  SetTopPod(stGrm1PP_KOD,LPP_KOD);
  SetStredX(stGrm1PP_KOD,GetStredX(LPP_KOD));
  CobPP_KOD.JednoPole:=StGrm1PP_KOD;
  CobPP_KOD.NactiZTabulky
              (KPoslednimuZnaku(Application.ExeName,'\')
                                       +'\ciselnik\C_OCHR_PP.DB','POPIS');
  SetStredX(LPP_KOD,GetStredX(CobPP_KOD));

  CobPR_KOD:=TComboBoxCiselnik.Create(Self);
  with CobPR_KOD do
   begin
    Parent := self;
    MaxWidth:=185;
    ZpPrevodu:=doPomlcky;
    DropDownCount:=12;
    name:='CobPR_KOD';
   end;
  stGrm1PR_KOD:=TStringGridMujJednoPole.Create(Self);
  with StGrm1PR_KOD do
   begin
    Parent := self;
    top    := 12;
    left   := 94;
    mheight := 19;
    mwidth  := 60;
    JmenoProperty:='PR_KOD';
    PocetZnaku:=6;
    typPolozky:='I';
   end;
  SetTopPod(stGrm1PR_KOD,LPR_KOD);
  SetStredX(stGrm1PR_KOD,GetStredX(LPR_KOD));
  CobPR_KOD.JednoPole:=StGrm1PR_KOD;
  CobPR_KOD.NactiZTabulky
              (KPoslednimuZnaku(Application.ExeName,'\')
                                       +'\ciselnik\C_OCHR_PR.DB','POPIS');
  SetStredX(LPR_KOD,GetStredX(CobPR_KOD));

  CobSCHU_KOD:=TComboBoxCiselnik.Create(Self);
  with CobSCHU_KOD do
   begin
    Parent := self;
    MaxWidth:=185;
    ZpPrevodu:=dleJinehoSloupce;
    DropDownCount:=12;
    name:='CobSCHU_KOD';
   end;
  stGrm1SCHU_KOD:=TStringGridMujJednoPole.Create(Self);
  with StGrm1SCHU_KOD do
   begin
    Parent := self;
    top    := 12;
    left   := 94;
    mheight := 19;
    mwidth  := 60;
    JmenoProperty:='SCHU_KOD';
    PocetZnaku:=6;
    typPolozky:='I';
   end;
  SetTopPod(stGrm1SCHU_KOD,LSCHU_KOD);
  SetStredX(stGrm1SCHU_KOD,GetStredX(LSCHU_KOD));
  CobSCHU_KOD.JednoPole:=StGrm1SCHU_KOD;
  // CobSCHU_KOD.NactiZTabulky(KPoslednimuZnaku(Application.ExeName,'\')+'\ciselnik\C_OCHR_PR.DB','POPIS');
  CobSCHU_KOD.NactiZTabulkyIJinySloupec(jmTabSCHU1,'SCHU_NAZEV','SCHU_KOD');
  SetStredX(LSCHU_KOD,GetStredX(CobSCHU_KOD));


  stGrmEVL:=TStringGridMuj.Create(Self);
  with StGrmEVL do
   begin
    name:='stGrmEVL';
    NastavStringGridMujNaTax200(stGrmEVL);
    Parent := self;
    ZobrazeniGridu:=vybranePole;
    top    := 135;
    left   := 10;
    height := 83;
    width  := 100;
    align  := alNone;
    ObLesMN:=TNasobny_LongIntMN.create;
    NastavGrid;
    with VlastnostiSloupcuMN do
     begin
      for I:=0 to count-1 do
       begin
        with TVlastnostiSloupcu(elements[i]) do
         begin
          viditelny:=False;
         end;
       end;
     end;
    with VlastnostiSloupcuMN do
     begin
      JmenoAktualnihoPrvku:='CISLO_LongInt';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=37;
        Nadpis:='EVL';
        poziceTisku:=uprostred;
       end;
     end;
    PripravZobrazeniGridu;
    onExit:=stGrmEVLExit;
    OnKeyDown:=stGrmEVLKeyDown;
    onEnter:=stGrmEVLEnter;
    OnDblClick:=stGrmEVLDblClick;

    SetTopPod(StGrmEVL,LEVL);
    StGrmEVL.Left:=LEVL.left;
   end;

  CobEVL:=TComboBoxCiselnikProGrid.Create(Self);
  with CobEVL do
    begin
     Parent := SELF;
     height := 19;
     ZpPrevodu:=DoPomlcky ;
     name   := 'CobEVL';
     visible:=false;
     JmenoHlProperty:='CISLO_LongInt';
     StrGrMuj:=StGrmEVL;
     NactiZTabulky
              (KPoslednimuZnaku(Application.ExeName,'\')
                                       +'\ciselnik\C_OCHR_EVL.DB','POPIS');
    end;


  stGrmNPR:=TStringGridMuj.Create(Self);
  with StGrmNPR do
   begin
    name:='stGrmNPR';
    NastavStringGridMujNaTax200(stGrmNPR);
    Parent := self;
    ZobrazeniGridu:=vybranePole;
    top    := 235;
    left   := 110;
    height := 83;
    width  := 100;
    align  := alNone;
    ObLesMN:=TNasobny_LongIntMN.create;
    NastavGrid;
    with VlastnostiSloupcuMN do
     begin
      for I:=0 to count-1 do
       begin
        with TVlastnostiSloupcu(elements[i]) do
         begin
          viditelny:=False;
         end;
       end;
     end;
    with VlastnostiSloupcuMN do
     begin
      JmenoAktualnihoPrvku:='CISLO_LongInt';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=37;
        Nadpis:='NPR';
        poziceTisku:=uprostred;
       end;
     end;
    PripravZobrazeniGridu;
    onExit:=stGrmNPRExit;
    OnKeyDown:=stGrmNPRKeyDown;
    onEnter:=stGrmNPREnter;
    OnDblClick:=stGrmNPRDblClick;

    SetTopPod(StGrmNPR,LNPR);
    StGrmNPR.Left:=LNPR.left;
   end;
  CobNPR:=TComboBoxCiselnikProGrid.Create(Self);
  with CobNPR do
    begin
     Parent := SELF;
     height := 19;
     ZpPrevodu:=DoPomlcky ;
     name   := 'CobNPR';
     visible:=false;
     JmenoHlProperty:='CISLO_LongInt';
     StrGrMuj:=StGrmNPR;
     NactiZTabulky
              (KPoslednimuZnaku(Application.ExeName,'\')
                                       +'\ciselnik\C_OCHR_NPR.DB','POPIS');
    end;


  stGrmNPP:=TStringGridMuj.Create(Self);
  with StGrmNPP do
   begin
    name:='stGrmNPP';
    NastavStringGridMujNaTax200(stGrmNPP);
    Parent := self;
    ZobrazeniGridu:=vybranePole;
    top    := 335;
    left   := 110;
    height := 83;
    width  := 100;
    align  := alNone;
    ObLesMN:=TNasobny_LongIntMN.create;
    NastavGrid;
    with VlastnostiSloupcuMN do
     begin
      for I:=0 to count-1 do
       begin
        with TVlastnostiSloupcu(elements[i]) do
         begin
          viditelny:=False;
         end;
       end;
     end;
    with VlastnostiSloupcuMN do
     begin
      JmenoAktualnihoPrvku:='CISLO_LongInt';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=37;
        Nadpis:='NPP';
        poziceTisku:=uprostred;
       end;
     end;
    PripravZobrazeniGridu;
    onExit:=stGrmNPPExit;
    OnKeyDown:=stGrmNPPKeyDown;
    onEnter:=stGrmNPPEnter;
    OnDblClick:=stGrmNPPDblClick;
    SetTopPod(StGrmNPP,LNPP);
    StGrmNPP.Left:=LNPP.left;
   end;
  CobNPP:=TComboBoxCiselnikProGrid.Create(Self);
  with CobNPP do
    begin
     Parent := SELF;
     height := 19;
     ZpPrevodu:=DoPomlcky ;
     name   := 'CobNPP';
     visible:=false;
     JmenoHlProperty:='CISLO_LongInt';
     StrGrMuj:=StGrmNPP;
     NactiZTabulky
              (KPoslednimuZnaku(Application.ExeName,'\')
                                       +'\ciselnik\C_OCHR_NPP.DB','POPIS');
    end;
 end;


procedure TFOchrPrir.FormShow(Sender: TObject);
begin
  PreZobraz;
end;

procedure TFOchrPrir.FormClose(Sender: TObject; var Action: TCloseAction);
var
 Schyba:String;
begin
  stGrmEVLExit(Nil);
  stGrmNPRExit(Nil);
  stGrmNPPExit(Nil);
  Application.ProcessMessages;
  if activeControl is TStringGridMujJednoPole then
   begin
    TStringGridMujJednoPole(ActiveControl).doexitPublic;
   end;
  Schyba:=LLesniPlosnyPrvek.ChybaVOchrPrir;
  if Schyba<>'' then
   begin
     Application.CreateForm(TdotazF1,dotazF2);
     dotazF2.caption:='Chyba v dajch ochrany prody';
     dotazF2.label1.caption:=Schyba;
     dotazF2.label2.caption:='Mm pesto zavt formul a uloit data s chybou ?';
     dotazF2.label3.caption:='';
     dotazF2.showModal;
     if dotazF2.odpoved=false then
      begin
       action:=caNone;
       dotazF2.free;
       exit;
      end;
     dotazF2.free;

   end;
end;

procedure TFOchrPrir.stGrmEVLExit(Sender: TObject);
var iC:integer;
    byloMeneno:boolean;
 begin
  stGrmEVL.onExit:=nil;
  stGrmEVL.DoExitPublic;
  iC:=0;
  byloMeneno:=false;
  with TNasobny_LongIntMN(stGrmEVL.ObLesMN) do
   begin
    while iC<count do
     begin
      if  TNasobny_LongInt(elements[iC]).CISLO_LongInt=0 then
       begin
        TNasobny_LongInt(elements[iC]).free;
        byloMeneno:=true;
       end
      else
       begin
        inc(ic);
       end;
     end;
   end;
  if byloMeneno then prezobraz;
  stGrmEVL.onExit:=stGrmEVLExit;
 end;


procedure TFOchrPrir.stGrmEVLKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (KEY=46) then
  begin
   if ssCtrl in shift then
    begin
     stGrmEVL.onExit:=nil;
     stGrmEVL.DoExitPublic;
     LLesniPlosnyPrvek.EVL_KODmn.AktualniPrvek.Free;
     prezobraz;
     stGrmEVL.onExit:=stGrmEVLExit;
    end;
  end;
 if (KEY=40) then
  begin
   if stGrmEVL.row=stGrmEVL.rowcount-1 then
    begin
      stGrmEVL.onExit:=nil;
      stGrmEVL.DoExitPublic;
      LLesniPlosnyPrvek.EVL_KODmn.PridejCislo_LongInt:='0';
      prezobraz;
      stGrmEVL.onExit:=stGrmEVLExit;
    end;
  end;
end;

procedure TFOchrPrir.stGrmNPRExit(Sender: TObject);
var iC:integer;
    byloMeneno:boolean;
 begin
  stGrmNPR.onExit:=nil;
  stGrmNPR.DoExitPublic;
  iC:=0;
  byloMeneno:=false;
  with TNasobny_LongIntMN(stGrmNPR.ObLesMN) do
   begin
    while iC<count do
     begin
      if  TNasobny_LongInt(elements[iC]).CISLO_LongInt=0 then
       begin
        TNasobny_LongInt(elements[iC]).free;
        byloMeneno:=true;
       end
      else
       begin
        inc(ic);
       end;
     end;
   end;
  if byloMeneno then prezobraz;
  stGrmNPR.onExit:=stGrmNPRExit;
 end;


procedure TFOchrPrir.stGrmNPRKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (KEY=46) then
  begin
   if ssCtrl in shift then
    begin
     stGrmNPR.onExit:=nil;
     stGrmNPR.DoExitPublic;
     LLesniPlosnyPrvek.NPR_KODmn.AktualniPrvek.Free;
     prezobraz;
     prezobraz;
     stGrmNPR.onExit:=stGrmNPRExit;
    end;
  end;
 if (KEY=40) then
  begin
   if stGrmNPR.row=stGrmNPR.rowcount-1 then
    begin
      stGrmNPR.onExit:=nil;
      stGrmNPR.DoExitPublic;
      LLesniPlosnyPrvek.NPR_KODmn.PridejCislo_LongInt:='0';
      prezobraz;
      stGrmNPR.onExit:=stGrmNPRExit;
    end;
  end;
end;

procedure TFOchrPrir.stGrmNPPExit(Sender: TObject);
var iC:integer;
    byloMeneno:boolean;
 begin
  stGrmNPP.onExit:=nil;
  stGrmNPP.DoExitPublic;
  iC:=0;
  byloMeneno:=false;
  with TNasobny_LongIntMN(stGrmNPP.ObLesMN) do
   begin
    while iC<count do
     begin
      if  TNasobny_LongInt(elements[iC]).CISLO_LongInt=0 then
       begin
        TNasobny_LongInt(elements[iC]).free;
        byloMeneno:=true;
       end
      else
       begin
        inc(ic);
       end;
     end;
   end;
  if byloMeneno then prezobraz;
  stGrmNPP.onExit:=stGrmNPPExit;
 end;


procedure TFOchrPrir.stGrmNPPKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (KEY=46) then
  begin
   if ssCtrl in shift then
    begin
     stGrmNPP.onExit:=nil;
     stGrmNPP.DoExitPublic;
     LLesniPlosnyPrvek.NPP_KODmn.AktualniPrvek.Free;
     prezobraz;
     stGrmNPP.onExit:=stGrmNPPExit;
    end;
  end;
 if (KEY=40) then
  begin
   if stGrmNPP.row=stGrmNPP.rowcount-1 then
    begin
      stGrmNPP.onExit:=nil;
      stGrmNPP.DoExitPublic;
      LLesniPlosnyPrvek.NPP_KODmn.PridejCislo_LongInt:='0';
      prezobraz;
      stGrmNPP.onExit:=stGrmNPPExit;
    end;
  end;
end;

procedure TFOchrPrir.stGrmEVLEnter(Sender: TObject);
var
  V:TNasobny_LongInt;
begin
 with stGrmEVL do
  begin
   onEnter:=nil;
   if LLesniPlosnyPrvek.EVL_KODmn.count=0 then
    begin
     V:=TNasobny_LongInt.create;
     LLesniPlosnyPrvek.EVL_KODmn.AddElement(V);
     prezobraz;
    end;
   onEnter:=stGrmEVLEnter;
  end;
end;

procedure TFOchrPrir.stGrmNPREnter(Sender: TObject);
var
  V:TNasobny_LongInt;
begin
 with stGrmNPR do
  begin
   onEnter:=nil;
   if LLesniPlosnyPrvek.NPR_KODmn.count=0 then
    begin
     V:=TNasobny_LongInt.create;
     LLesniPlosnyPrvek.NPR_KODmn.AddElement(V);
     prezobraz;
    end;
   onEnter:=stGrmNPREnter;
  end;
end;

procedure TFOchrPrir.stGrmNPPEnter(Sender: TObject);
var
  V:TNasobny_LongInt;
begin
 with stGrmNPP do
  begin
   onEnter:=nil;
   if LLesniPlosnyPrvek.NPP_KODmn.count=0 then
    begin
     V:=TNasobny_LongInt.create;
     LLesniPlosnyPrvek.NPP_KODmn.AddElement(V);
     prezobraz;
    end;
   onEnter:=stGrmNPPEnter;
  end;
end;
// cobEVL,cobNPR,cobNPP
procedure TFOchrPrir.ZobrazCobEVL;
var Acol,Arow:integer;
 begin
  with CobEVL do
   begin
    if not visible then
     begin
      acol:=stgrmEVL.col;
      arow:=stgrmEVL.row;
      left   :=stGrmEVL.left+stGrmEVL.colLeft[aCol+1]; // ColLeft[1]; //
      width  :=Self.width-left-50;
      Top    :=stGrmEVL.Top+stGrmEVL.RowHeights[0];
      DroppedDown:=true;
      visible:=true;
     end;
    activeControl:=CobEVL;
   end;
 end;

procedure TFOchrPrir.stGrmEVLDblClick(Sender: TObject);
 begin
  stGrmEVL.OnExit:=nil;
  if stGrmEVL.col=stGrmEVL.ColDleProperty('CISLO_LongInt') then  ZobrazCobEVL;
  stGrmEVL.OnExit:=stGrmEVLExit;
 end;

procedure TFOchrPrir.ZobrazCobNPR;
var Acol,Arow:integer;
 begin
  with CobNPR do
   begin
    if not visible then
     begin
      acol:=stgrmNPR.col;
      arow:=stgrmNPR.row;
      left   :=stGrmNPR.left+stGrmNPR.colLeft[aCol+1]; // ColLeft[1]; //
      width  :=Self.width-left-50;
      Top    :=stGrmNPR.Top+stGrmNPR.RowHeights[0];
      DroppedDown:=true;
      visible:=true;
     end;
    activeControl:=CobNPR;
   end;
 end;

procedure TFOchrPrir.stGrmNPRDblClick(Sender: TObject);
 begin
  stGrmNPR.OnExit:=nil;
  if stGrmNPR.col=stGrmNPR.ColDleProperty('CISLO_LongInt') then  ZobrazCobNPR;
  stGrmNPR.OnExit:=stGrmNPRExit;
 end;

procedure TFOchrPrir.ZobrazCobNPP;
var Acol,Arow:integer;
 begin
  with CobNPP do
   begin
    if not visible then
     begin
      acol:=stgrmNPP.col;
      arow:=stgrmNPP.row;
      left   :=stGrmNPP.left+stGrmNPP.colLeft[aCol+1]; // ColLeft[1]; //
      width  :=Self.width-left-50;
      Top    :=stGrmNPP.Top+stGrmNPP.RowHeights[0];
      DroppedDown:=true;
      visible:=true;
     end;
    activeControl:=CobNPP;
   end;
 end;

procedure TFOchrPrir.stGrmNPPDblClick(Sender: TObject);
 begin
  stGrmNPP.OnExit:=nil;
  if stGrmNPP.col=stGrmNPP.ColDleProperty('CISLO_LongInt') then  ZobrazCobNPP;
  stGrmNPP.OnExit:=stGrmNPPExit;
 end;


procedure TFOchrPrir.ButTridCisOchrClick(Sender: TObject);
var ss:string;
    initext:Tinifile;

begin
  triditAbecedneCiselnikyOchrPrir:=not(triditAbecedneCiselnikyOchrPrir);
  initext:=Tinifile.create(KPoslednimuZnaku(Application.ExeName,'\')+'\vtx.ini');
  if triditAbecedneCiselnikyOchrPrir then ss:='ANO'
                      else Ss:='NE';
  initext.writeString('DATABASE','triditAbecedneCiselnikyOchrPrir',ss);
  iniText.free;

  PreZobraz;
end;

end.
