unit SpWieSep;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs,
  Dotaz, U_Zobraz, E_LesCel, E_LesOdd, ELesObec, lesCisOr,
  PtcanvRTF, hkCanvOR, SpPracuj,
  Secanvas,SeCanvParcel, mat1,IniFiles,
  StdCtrls,printers_F, Grids, DBGrids, Db, DBTables;

type
  TFWieSep = class(TForm)
    EdMAJ_KOD    : TEdit;
    EdMAJ_DRUH   : TEdit;
    ButTiskSep   : TButton;
    Label16: TLabel;
    ButTiskProt: TButton;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    EdLES_URAD_nazev: TEdit;
    Label22: TLabel;
    EdCjOU: TEdit;
    MemRodneCis: TMemo;
    MemICO: TMemo;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    MemObchodJm: TMemo;
    MemJmePrijmZas: TMemo;
    ButZobrProt: TButton;
    MemPSC: TMemo;
    MemObec: TMemo;
    MemUlice: TMemo;
    MemCDomu: TMemo;
    Label29: TLabel;
    Label28: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    EdJmePrijmZpln: TEdit;
    EdPSCZpln: TEdit;
    EdEMailZpln: TEdit;
    EdObecZpln: TEdit;
    EdTelefonZpln: TEdit;
    EdUliceZpln: TEdit;
    EdCDomuZpln: TEdit;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    EdFaxZpln: TEdit;
    Label42: TLabel;
    Label43: TLabel;
    Label44: TLabel;
    EdLV: TEdit;
    EdLesObec: TEdit;
    MemJmePrijm: TMemo;
    Label45: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    EdVPred: TEdit;
    EdDnePred: TEdit;
    EdPrilohyPred: TEdit;
    EdZastOU: TEdit;
    Label1: TLabel;
    MemMAJ_NAZ1: TMemo;
    ButTiskSepPlTab: TButton;
    ButTiskSepObr: TButton;
    ButZobrProtAParc: TButton;
    ButTiskProtAParc: TButton;
    Query1: TQuery;
    DataSource1: TDataSource;
    y: TDBGrid;
    ButIskSepAParc: TButton;
    EdPoznamkaDoMapy: TEdit;
    Label2: TLabel;
    procedure FormShow(Sender: TObject);
    procedure ButTiskSepClick(Sender: TObject);
    procedure ButZobrProtClick(Sender: TObject);
    procedure ButTiskProtClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButTiskSepPlTabClick(Sender: TObject);
    procedure ButTiskSepObrClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButZobrProtAParcClick(Sender: TObject);
    procedure ButTiskProtAParcClick(Sender: TObject);
    procedure ButIskSepAParcClick(Sender: TObject);
  private
    { Private declarations }
   procedure textyDoPropert;
  public
    { Public declarations }
    lesniCelek:TLesniCelek;
    Majetky:TMajetky;
    mistoPlochyVymera:Boolean;
    ukladatTextyDoPropert:Boolean;
    fontSeparatu:string;
   procedure PlochovkaMajiteleNaTiskarnu(ukoncovat:boolean;VColor:TColor);
   procedure HospodarskaKnihaMajiteleNaTiskarnu(ukoncovat:boolean);
   procedure tiskJednohoSeparatu(plochovku,knihu,Protokol,UzaviratAzPo:boolean);
   procedure tiskJednohoSeparatuVcetneParcel(plochovku,knihu,Protokol,UzaviratAzPo:boolean; DleKoho:TTypTiskuParcel);

   procedure tiskJednohoSeparatuObracene(plochovku,knihu,Protokol:boolean);
   procedure tiskPlochoveTabulkySeparatu;
   procedure OtevryParcely(var DleKoho:TTypTiskuParcel);
  end;

procedure OddeleniNaTiskarnu(VODD:TOddeleni;var strana:integer;
               strana_pozadovana_k_tiskuI:integer;
               tiskPorost,tiskMajit:boolean;VColor:TColor);

procedure SeparatNaTiskarnu(VMajitel:TMajitel;
                            VychDo40,RamcSmer,VAdresaSoucastiJmena:TAnoNeRozhodniSeSam;
                            VColor:TColor;ukoncovat:boolean;fontSeparatu:string);
procedure ZobrazSeparatDoImage( VMajitel:TMajitel;
                                VychDo40,RamcSmer,VAdresaSoucastiJmena:TAnoNeRozhodniSeSam;
                                VColor:TColor;fontSeparatu:string);

var
  FWieSep: TFWieSep;

implementation

{$R *.DFM}
uses SpTaxWie;
procedure ZobrazSeparatDoImage(VMajitel:TMajitel;VychDo40,RamcSmer,VAdresaSoucastiJmena:TAnoNeRozhodniSeSam;VColor:TColor;fontSeparatu:string);
var mxi,myi:integer;
begin
 Application.CreateForm(TFSeCanvas, FSeCanvas);
 with FSeCanvas do
  begin
   mxi:=round(screen.width*1.1);
   myi:=round(screen.height*1.1);
   {Image1.picture.bitmap.Width:=image1.width;
    Image1.picture.bitmap.height:=image1.height; }
   {Image1.picture.bitmap.canvas.fillrect(
         rect(0,0,image1.width,image1.height)); }
   tiskSeparatu(VMajitel,Image1.picture.bitmap.canvas,MXi,MYi,false,VychDo40,RamcSmer,VAdresaSoucastiJmena,VColor,fontSeparatu);
   image1.refresh;
   showmodal;
  end;
 FSeCanvas.free;
end;


procedure ZobrazSeparatDoImageVcetneParcel(VMajitel:TMajitel;VychDo40,RamcSmer,VAdresaSoucastiJmena:TAnoNeRozhodniSeSam;VColor:TColor;DleKoho:TTypTiskuParcel);
var mxi,myi:integer;
begin
 Application.CreateForm (TFSeCanvParcel,FSeCanvParcel);
 with FSeCanvParcel do
  begin
   mxi:=round(screen.width*1.5);
   myi:=round(screen.height*1.5);
   Image1.picture.bitmap.Width:=image1.width;
   Image1.picture.bitmap.height:=image1.height;
   {Image1.picture.bitmap.canvas.fillrect(
         rect(0,0,image1.width,image1.height)); }
   tiskSeparatuParcel(VMajitel,Image1.picture.bitmap.canvas, MXi, MYi,false,VychDo40,RamcSmer,VAdresaSoucastiJmena,VColor,dleKoho);
                                                                                                                         //false);
                                                                                                                         // dle vitkovice true);
   image1.refresh;
   showmodal;
  end;
 FSeCanvParcel.free;
end;

procedure SeparatNaTiskarnu(VMajitel:TMajitel;VychDo40,RamcSmer,VAdresaSoucastiJmena:TAnoNeRozhodniSeSam;VColor:TColor;ukoncovat:boolean;fontSeparatu:string);
var PXI,PYI:integer;
    ZalFileName:string;

begin
 with FSeCanvas do
  begin
   with printer do
    begin
     if printing then
      begin
       endDoc;
      end;
     Orientation := poPortrait;
     pxi:=round(printer.PageHeight);
     pyi:=round(printer.PageWidth);
     if filename<>'' then
      begin
       ZalFileName:=FileName;
       FileName:=vlozPredString(FileName,'.','Prot');
      end;
     beginDoc;
     tiskSeparatu(VMajitel,canvas,pXi,pYi,True,VychDo40,RamcSmer,VAdresaSoucastiJmena,VColor,fontSeparatu);
     if filename<>'' then
      begin
       enddoc;
       FileName := ZalFileName;
      end
     else
      begin
       if ukoncovat then
        begin
         enddoc;
        end
       else
        begin
         // newPage;
        end;
      end;
    end;
  end;
end;

procedure SeparatNaTiskarnuVcetneParcel(VMajitel:TMajitel;VychDo40,RamcSmer,VAdresaSoucastiJmena:TAnoNeRozhodniSeSam;VColor:TColor;Ukoncovat:Boolean; DleKoho:TTypTiskuParcel);
var PXI,PYI:integer;
begin
 with FSeCanvParcel do
  begin
   with printer do
    begin
     if ukoncovat then
      begin
       if printing then
        begin
         endDoc;
        end;
      end;
     Orientation := poPortrait;
     pxi:=round(printer.PageHeight);
     pyi:=round(printer.PageWidth);
     beginDoc;
     tiskSeparatuParcel(VMajitel,canvas,pXi,pYi,True,VychDo40,RamcSmer,VAdresaSoucastiJmena,VColor,dleKoho);
                                                                                        // dle vitkovice true);
     if ukoncovat then
      begin
       enddoc;
      end
     else
      begin
       // newPage;
      end;
    end;
  end;
end;

procedure TFWieSep.textyDoPropert;
 begin
   if not ukladatTextyDoPropert then  exit;
   Majetky.MAJ_DRUH_C:= EdMAJ_DRUH.text;
   Majetky.MAJ_KOD_C := EdMAJ_KOD.text;
   if LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.AdresaNeniSoucastiJmena_SC=ne then
    begin
     Majetky.MAJ_NAZ_C := ZMemoDostringu(MemMaj_Naz1);
    end
   else
    begin
     Majetky.MAJ_NAZ_C := ZMemoDostringu(MemJmePrijm);
    end;
   Majetky.LES_URAD_nazev_C1:=EdLES_URAD_nazev.text;
   Majetky.CjOU_C    := EdCjOU.text;
   Majetky.RodneCis_C:= ZMemoDostringu(MemRodneCis);
   Majetky.JmePrijm_C:= ZMemoDostringu(MemJmePrijm);

   Majetky.ICO_C:= ZMemoDostringu(MemICO);

   Majetky.ObchodJm_C:=ZMemoDostringu(MemObchodJm);
   Majetky.Zastupce_C:=ZMemoDostringu(MemJmePrijmZas);
   Majetky.PSC_TXT_C := ZMemoDostringu(MemPSC);
   Majetky.AdrObec_C :=ZMemoDostringu(MemObec);
   Majetky.AdrUlice_C:=ZMemoDostringu(MemUlice);
   Majetky.AdrCDomu_C:=ZMemoDostringu(MemCDomu);

   Majetky.JmePrijmZpln_C:=EdJmePrijmZpln.text;
   Majetky.PSCZpln_C:=EdPSCZpln.text;
   Majetky.EMailZpln_C:=EdEMailZpln.text;
   Majetky.ObecZpln_C:=EdObecZpln.text;
   Majetky.TelefonZpln_C:=EdTelefonZpln.text;
   Majetky.UliceZpln_C:=EdUliceZpln.text;
   Majetky.CDomuZpln_C:=EdCDomuZpln.text;
   Majetky.FaxZpln_C:=EdFaxZpln.text;

   Majetky.VPred_C:=EdVPred.text;
   Majetky.DnePred_C:=EdDnePred.text;
   Majetky.PrilohyPred_C:=EdPrilohyPred.text;
   Majetky.ZastOU_C:=EdZastOU.text;


   Majetky.LV_C:= EdLV.text;
   Majetky.Obec_C:= EdLesObec.text;
   Majetky.PoznamkaDoMapy_C:= EdPoznamkaDoMapy.text;
 end;

procedure TFWieSep.FormShow(Sender: TObject);
var
 LesPlPrv:TLesniPlosnyPrvek;
 iOdd,Ipor,iDil:integer;
 begin

  EdMAJ_DRUH.text := Majetky.MAJ_DRUH_C;
  EdMAJ_KOD.text  := Majetky.MAJ_KOD_C;

   if LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.AdresaNeniSoucastiJmena_SC=ne then
    begin
     ZeStringuDoMema(MemMaj_Naz1,Majetky.MAJ_NAZ_C);
    end
   else
    begin
     ZeStringuDoMema(MemJmePrijm,Majetky.MAJ_NAZ_C);
    end;


  // EdRodneCis.text:=Majetky.RodneCis_C;
  ZeStringuDoMema(MemRodneCis,Majetky.RodneCis_C);
  //EdICO.text:=Majetky.ICO_C;
  ZeStringuDoMema(MemICO,Majetky.ICO_C);
  // EdJmeprim.text:=Majetky.JmePrijm_C;
  if trim(Majetky.JmePrijm_C)<>'' then
   begin
     if Majetky.MAJ_NAZ_C<>Majetky.JmePrijm_C then
      begin
       Application.CreateForm(TdotazF1,dotazF2);
       dotazF2.Width:=800;
       dotazF2.caption:='Rozdl v zpisech. ';
       dotazF2.label1.caption:='  H. "nzev majitele" je '+Majetky.MAJ_NAZ_C+'.';
       dotazF2.label2.caption:='a h. "jmePrijm" je '+Majetky.JmePrijm_C+'.';
       dotazF2.label3.caption:='Mm hodnotu nzvu majitele nahredit hodnotou jmePrijm?';
       dotazF2.showModal;
       if dotazF2.odpoved=true then
        begin
         ZeStringuDoMema(MemJmePrijm,Majetky.JmePrijm_C);
        end;
       dotazF2.free;

      end;
   end;
  // EdObchodJm.text:=Majetky.ObchodJm_C;
  ZeStringuDoMema(MemObchodJm,Majetky.ObchodJm_C);
  // EdJmePrijmZas.text:=Majetky.Zastupce_C;
  ZeStringuDoMema(MemJmePrijmZas,Majetky.Zastupce_C);
  // EdPSC.text:=inttostr(Majetky.PSC_C);
  ZeStringuDoMema(MemPSC,Majetky.PSC_txt_C);
  // EdObec.text:=Majetky.AdrObec_C;
  ZeStringuDoMema(MemObec,Majetky.AdrObec_C);
  // EdUlice.text:=Majetky.AdrUlice_C;
  ZeStringuDoMema(MemUlice,Majetky.AdrUlice_C);
  // EdCDomu.text:=Majetky.AdrCDomu_C;
  ZeStringuDoMema(MemCDomu,Majetky.AdrCDomu_C);
  EdLV.text:=Majetky.LV_C;
  EdLesObec.text:=Majetky.Obec_C;
  LesniCelek.NactiJednohoMajiteleOr(Majetky,mistoPlochyVymera);

   EdJmePrijmZpln.text:=Majetky.JmePrijmZpln_C;
   EdPSCZpln.text:=Majetky.PSCZpln_C;
   EdEMailZpln.text:=Majetky.EMailZpln_C;
   EdObecZpln.text:=Majetky.ObecZpln_C;
   EdTelefonZpln.text:=Majetky.TelefonZpln_C;
   EdUliceZpln.text:=Majetky.UliceZpln_C;
   EdCDomuZpln.text:=Majetky.CDomuZpln_C;
   EdFaxZpln.text:=Majetky.FaxZpln_C;

   EdVPred.text:=Majetky.VPred_C;
   EdDnePred.text:=Majetky.DnePred_C;
   EdPrilohyPred.text:=Majetky.PrilohyPred_C;
   EdZastOU.text:=Majetky.ZastOU_C;


  if trim(Majetky.LES_URAD_nazev_C1)='' then
    begin
     LesPlPrv:=TLesniPlosnyPrvek(LesniCelek.LHC.Majitel.PrvniPrvekTypu(TLesniPlosnyPrvek));
     EdLES_URAD_nazev.text:=LesPlPrv.LES_URAD_nazev;
     Majetky.LES_URAD_nazev_C1:=LesPlPrv.LES_URAD_nazev;
    end
  else EdLES_URAD_nazev.text:=Majetky.LES_URAD_nazev_C1;

  EdCjOU.text:=Majetky.CjOU_C;
  EdPoznamkaDoMapy.text:=Majetky.PoznamkaDoMapy_C;
 end;
procedure TFWieSep.tiskJednohoSeparatu(plochovku,knihu,Protokol,UzaviratAzPo:boolean);
var
  UkoncovatPlochovku,Ukoncovatknihu,UkoncovatProtokol:boolean;
 begin
  // LesniCelek.NactiJednohoMajiteleOr(Majetky);
  if uzaviratAzPo then
   begin
    UkoncovatPlochovku:=false;
    Ukoncovatknihu:=false;
    UkoncovatProtokol:=false;
   end
  else
   begin
    if (not knihu)and(not protokol) then  UkoncovatPlochovku:=true else UkoncovatPlochovku:=false;
    if (not protokol) then  UkoncovatKnihu:=true else UkoncovatKnihu:=false;
    UkoncovatProtokol:=true;
   end;
  if plochovku then PlochovkaMajiteleNaTiskarnu( UkoncovatPlochovku, //ukoncovatProtokol,
                             LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.Color_SC);
  if knihu     then HospodarskaKnihaMajiteleNaTiskarnu(Ukoncovatknihu); //ukoncovatProtokol);
  if Protokol  then SeparatNaTiskarnu(
                         LesniCelek.LHC.Majitel,
                         LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.VychDo40_SC,
                         LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.RamcSmern_SC,
                         LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.AdresaNeniSoucastiJmena_SC,
                         LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.Color_SC,
                         ukoncovatProtokol,fontseparatu);
 end;
procedure TFWieSep.tiskJednohoSeparatuVcetneParcel(plochovku,knihu,Protokol,UzaviratAzPo:boolean;DleKoho:TTypTiskuParcel);
var
  UkoncovatPlochovku,Ukoncovatknihu,UkoncovatProtokol:boolean;
 begin
  // LesniCelek.NactiJednohoMajiteleOr(Majetky);
  if uzaviratAzPo then
   begin
    UkoncovatPlochovku:=false;
    Ukoncovatknihu:=false;
    UkoncovatProtokol:=false;
   end
  else
   begin
    if (not knihu)and(not protokol) then  UkoncovatPlochovku:=true else UkoncovatPlochovku:=false;
    if (not protokol) then  UkoncovatKnihu:=true else UkoncovatKnihu:=false;
    UkoncovatProtokol:=true;
   end;
  if plochovku then PlochovkaMajiteleNaTiskarnu(true,
                             LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.Color_SC);
  if knihu     then HospodarskaKnihaMajiteleNaTiskarnu(true);
  if Protokol  then SeparatNaTiskarnuVcetneParcel(
                         LesniCelek.LHC.Majitel,
                         LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.VychDo40_SC,
                         LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.RamcSmern_SC,
                         ano, //dleVitkovice
                         // LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.AdresaNeniSoucastiJmena_SC,
                         LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.Color_SC,
                         UkoncovatProtokol,dleKoho);
 end;

procedure  TFWieSep.tiskPlochoveTabulkySeparatu;
 begin
  PlochovkaMajiteleNaTiskarnu(true,LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.Color_SC);
 end;
procedure  TFWieSep.tiskJednohoSeparatuObracene(plochovku,knihu,Protokol:boolean);
 begin
  if knihu     then HospodarskaKnihaMajiteleNaTiskarnu(true);
  if plochovku then PlochovkaMajiteleNaTiskarnu(true,
                        LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.Color_SC);
  if protokol  then SeparatNaTiskarnu(LesniCelek.LHC.Majitel,
                      LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.VychDo40_SC,
                      LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.RamcSmern_SC,
                      LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.AdresaNeniSoucastiJmena_SC,
                      LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.Color_SC,false, fontSeparatu);
 end;
procedure TFWieSep.ButTiskSepClick(Sender: TObject);
begin
 FTaxWie.creaShowSpPracuj;
 application.ProcessMessages;
 ButtiskSep.visible:=false;
 textyDoPropert;
 tiskJednohoSeparatu(true,true,true,false);
 ButtiskSep.visible:=true;
 FTaxWie.FSpPracujUkonci;
 showmessage('Vytitno');
 close;
end;

procedure OddeleniNaTiskarnu(VODD:TOddeleni;var strana:integer;
               strana_pozadovana_k_tiskuI:integer;tiskPorost,tiskMajit:boolean;VColor:TColor);
var PXI,PYI:integer;
begin
// with FPTCanvas do
  begin
   with printer do
    begin
{    Orientation := poLandscape; }
     pxi:=round(printer.PageWidth);
     pyi:=printer.PageHeight;
{    beginDoc;  }
     tiskPloTabOddeleni(VOdd,Strana,strana_pozadovana_k_tiskuI,canvas,nil,nil,pXi,pYi,true,
                             false,nil,tiskPorost,tiskMajit,false,VColor,FTaxWie.EdFontTisku.text
                             // 'ARIAL'
                             ,FALSE,false,4,1,1,cesky,nil);
{    enddoc;     }
    end;
  end;
end;

procedure TFWieSep.HospodarskaKnihaMajiteleNaTiskarnu(ukoncovat:boolean);
var iodd,iDil,iPor,PXI,PYI:Integer;
    strana:Integer;
    merYZacatekPorostu:longint;
    initext:Tinifile;
    ZalFileName:string;
 begin
   initext:=Tinifile.create(LesniCelek.PHSNazev+'\PHS.ini');
   // initext:=Tinifile.create(CestaANazevIniParametru);
   initext.writeString('Hosp_Kniha','Cislovat_od_strany','2');
   initext.free;
  with printer do
   begin
    if FileName<>'' then
     begin
      ZalFileName:=FileName;
      FileName:=vlozPredString(FileName,'.','Hosp');
      Orientation := poLandscape;
      beginDoc;
     end;
    if not printing then
     begin
      Orientation := poLandscape;
      beginDoc;
     end;
    pxi:=round(printer.PageWidth*1.15);
    pyi:=printer.PageHeight;
   end;
  with LesniCelek.LHC.Majitel.oddeleniMN do
   begin
    for iodd:=0 to count - 1 do
     begin
      for iDil:=0 to TOddeleni(elements[iOdd]).dilecMN.count-1 do
       begin
        with TOddeleni(elements[iOdd]).Idilec[iDil] do
         begin
          for IPor:=0 to porostMN.count-1 do
           begin
            if not((iodd=0)and(idil=0)and(ipor=0)) then printer.newpage;
            merYZacatekPorostu:=0;
            TiskniPorostPodleParametruOR(Iporost[iPor],LesniCelek,
                                          '',true,printer.canvas,PXI,PYI,false,AnoStrakovat,FTaxWie.EdFontTisku.text,merYZacatekPorostu);
           end;
         end;
       end;
     end;
   end;
 if printer.FileName<>'' then
  begin
   printer.enddoc;
   printer.Orientation := poPortrait;
   printer.FileName:=ZalFileName;
  end
 else
  begin
   if ukoncovat then
    begin
     with printer do
      begin
       enddoc;
       Orientation := poPortrait;
      end;
    end
   else
    begin
    // printer.newpage;
    end;
  end;  
end;

procedure TFWieSep.PlochovkaMajiteleNaTiskarnu(ukoncovat:boolean;VColor:TColor);
var i:Integer;
    strana:Integer;
    ZalFileName:string;
begin
 with printer do
  begin
   if not printing then
    begin
     if filename<>'' then
      begin
       ZalFileName:=FileName;
       FileName:=vlozPredString(FileName,'.','Ploch');
      end;
     Orientation := poLandscape;
     beginDoc;
    end
   else
    begin
     if orientation<>poLandscape then
      begin
       endDoc;
       if filename<>'' then
        begin
         FileName:=ZalFileName;
         FileName:=vlozPredString(FileName,'.','Ploch');
        end;
       Orientation := poLandscape;
       beginDoc;
      end;
    end;
  end;
 with LesniCelek.LHC.Majitel.oddeleniMN do
  begin
   strana:=1;
   for i:=0 to count - 1 do
    begin
     if not (i=0) then printer.newpage;
     OddeleniNaTiskarnu(TOddeleni(elements[i]),strana,0,true,true,VColor);
    end;
  end;
 if printer.filename<>'' then
  begin
   printer.enddoc;
   printer.FileName:=ZalFileName;
  end
 else
  begin
   if ukoncovat then
    begin
     with printer do
      begin
       enddoc;
       Orientation := poPortrait;
      end;
    end
   else
    begin
     printer.newpage;
    end;
  end;
end;

procedure TFWieSep.ButZobrProtClick(Sender: TObject);

 begin
  textyDoPropert;


  ZobrazSeparatDoImage(LesniCelek.LHC.Majitel,
             LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.VychDo40_SC,
             LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.RamcSmern_SC,
             LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.AdresaNeniSoucastiJmena_SC,
             LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.Color_SC,fontSeparatu);
  if LesniCelek.LHC.oddeleniVzdy.OwnerLHC=nil then
   begin
    showmessage('OwnerLHC=nil ');
    exit;
   end;
  if LesniCelek.LHC.oddeleniVzdy=nil then
   begin
    showmessage('oddeleniVzdy=nil ');
    exit;
   end;
  if LesniCelek.LHC=nil then
   begin
    showmessage('LHC=nil');
    exit;
   end;
  if LesniCelek=nil then
   begin
    showmessage('LesniCelek=nil');
    exit;
   end;
 end;
procedure TFWieSep.ButTiskProtClick(Sender: TObject);
 begin
  textyDoPropert;
  // LesniCelek.NactiJednohoMajiteleOr(Majetky);
  SeparatNaTiskarnu(LesniCelek.LHC.Majitel,
             LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.VychDo40_SC,
             LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.RamcSmern_SC,
             LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.AdresaNeniSoucastiJmena_SC,
             LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.Color_SC,true,fontSeparatu);
  showmessage('Vytitno.');
 end;

procedure TFWieSep.Button1Click(Sender: TObject);
begin
{
EdMaj_Naz.text:=ZMemoDostringu(MemMaj_Naz);
EdMaj_Naz.refresh; }
end;

procedure TFWieSep.Button2Click(Sender: TObject);
 begin
 {
  ZeStringuDoMema(MemMaj_Naz,EdMaj_Naz.text);
  MemMaj_Naz.refresh;   }
 end;

procedure TFWieSep.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if ukladatTextyDoPropert then TextyDoPropert;
end;

procedure TFWieSep.ButTiskSepPlTabClick(Sender: TObject);
begin
 FTaxWie.creaShowSpPracuj;
 application.ProcessMessages;
 ButtiskSep.visible:=false;
 textyDoPropert;
 tiskPlochoveTabulkySeparatu;
 ButtiskSep.visible:=true;
 FTaxWie.FSpPracujUkonci;
 showmessage('Vytitno');
 close;
end;

procedure TFWieSep.ButTiskSepObrClick(Sender: TObject);
begin
 FTaxWie.creaShowSpPracuj;
 application.ProcessMessages;
 ButtiskSep.visible:=false;
 textyDoPropert;
 tiskJednohoSeparatuObracene(true,true,true);
 ButtiskSep.visible:=true;
 FTaxWie.FSpPracujUkonci;
 showmessage('Vytitno');
 close;

end;

procedure TFWieSep.FormCreate(Sender: TObject);
begin
 ukladatTextyDoPropert:=true;
end;

procedure TFWieSep.OtevryParcely(var DleKoho:TTypTiskuParcel);
 begin
  dleKoho:=dleMrazka;
  case dlekoho of
  dleGregora:
   begin
    Query1.active:=false;
    Query1.SQL.clear;
    Query1.SQL.add('select * from '''+LesniCelek.adresarObecnychDatLHP+'\Heletax_Parcely.dbF''');
    Query1.SQL.add('where MAJ_KOD=' + Majetky.MAJ_KOD_C);
    Query1.SQL.add('order by PARCIS,PARPOD,SUBJEKT');
    Query1.active:=true;
   end;
  dleVitkovice, dleDvoraka:
   begin
    Query1.active:=false;
    Query1.SQL.clear;
    // Query1.SQL.add('select * from ''C:\tax99\dvorak\JablChvala\_vychod\Vychod\Vypis_KN.db''');
    Query1.SQL.add('select * from '''+LesniCelek.adresarObecnychDatLHP+'\Vypis_KN.db''');
    Query1.SQL.add('where MAJ_KOD=' + Majetky.MAJ_KOD_C);
    Query1.SQL.add('order by  CKAT_KN,LV,PARCIS,PARPOD');
    // Query1.SQL.add('where MAJ_KOD='+EdMaj_kod.text);
    Query1.active:=true;
   end;
 dleMrazka:
   begin
    Query1.active:=false;
    Query1.SQL.clear;
    // Query1.SQL.add('select * from ''C:\tax99\dvorak\JablChvala\_vychod\Vychod\Vypis_KN.db''');
    Query1.SQL.add('select * from '''+LesniCelek.adresarObecnychDatLHP+'\P8210.dbf''');
    Query1.SQL.add('where MAJ_KOD=' + Majetky.MAJ_KOD_C);
    Query1.SQL.add('order by LV,PARCIS,PARPOD');
    // Query1.SQL.add('where MAJ_KOD='+EdMaj_kod.text);
    Query1.active:=true;
   end;
 end;
end;
procedure TFWieSep.ButZobrProtAParcClick(Sender: TObject);
var
  DleKoho:TTypTiskuParcel;
begin
  textyDoPropert;
  OtevryParcely(DleKoho);
  ZobrazSeparatDoImageVcetneParcel(LesniCelek.LHC.Majitel,
             LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.VychDo40_SC,
             LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.RamcSmern_SC,
             //LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.AdresaNeniSoucastiJmena_SC,
             ano,//dleVitkovice
             LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.Color_SC,dleKoho);
end;

procedure TFWieSep.ButTiskProtAParcClick(Sender: TObject);
var
  DleKoho:TTypTiskuParcel;
begin
  textyDoPropert;
  OtevryParcely(DleKoho);
  SeparatNaTiskarnuVcetneParcel(LesniCelek.LHC.Majitel,
             LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.VychDo40_SC,
             LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.RamcSmern_SC,
             // LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.AdresaNeniSoucastiJmena_SC,
             ano,//dleVitkovice
             LesniCelek.PolozkaSeznamuCelkuOdkudPochazi.Color_SC,true,dleKoho);
  showmessage('Vytitno.');
end;

procedure TFWieSep.ButIskSepAParcClick(Sender: TObject);
var DleKoho:TTypTiskuParcel;
begin
 FTaxWie.creaShowSpPracuj;
 application.ProcessMessages;
 ButtiskSep.visible:=false;
 textyDoPropert;
 OtevryParcely(DleKoho);
 tiskJednohoSeparatuVcetneParcel(true,true,true,false,dleKoho);
 ButtiskSep.visible:=true;
 FTaxWie.FSpPracujUkonci;
 showmessage('Vytitno');
 close;
end;

end.
