unit UDtbVyb;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, DBGrids, Db, DBTables,
  u_props,
  dotaz,UUkonTrans,uVybLHCID,mat1,UVyODDID,
  ComCtrls, Mask, DBCtrls;

type
  TStavVyberu=(vybranoNic,vybranoODD,vybranoPOR,vybranoPSK,vybranoBZL,vybranoJP);
  TZpusobKopirovani=(naNecistoN,priChybeDoIDmin1,nacisto,presunNanecistoN,presunpriChybeDoIDmin);
  TFDtbVyb = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    LLHC_KOD: TLabel;
    LLHC_KOD_ID: TLabel;
    LLHC_NAZ: TLabel;
    ButODD: TButton;
    ButPOR: TButton;
    ButPSK: TButton;
    QuVyber: TQuery;
    SUVyber: TDataSource;
    DBVyber: TDBGrid;
    ButCopy: TButton;
    ButMove: TButton;
    ButDelete: TButton;
    Button1: TButton;
    Button2: TButton;
    QueryV1: TQuery;
    QueryV2: TQuery;
    InfoEdit: TEdit;
    QueryV3: TQuery;
    ButDestinLHC: TButton;
    LHP_DATABASE: TDatabase;
    Label4: TLabel;
    LLHC_KODcopy: TLabel;
    LLHC_KOD_IDCopy: TLabel;
    Label7: TLabel;
    LLHC_NAZcopy: TLabel;
    RichEdit1: TRichEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    LOdd: TLabel;
    LODD_ID: TLabel;
    ButTrans: TButton;
    LMazano: TLabel;
    ButDeleteBezBZL: TButton;
    QueryV4: TQuery;
    procedure ButODDClick(Sender: TObject);
    procedure ButPORClick(Sender: TObject);
    procedure ButPSKClick(Sender: TObject);
    procedure ButCopyClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ButMoveClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ButDestinLHCClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButTransClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButDeleteClick(Sender: TObject);
    procedure ButDeleteBezBZLClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
     // LHP_DATABASE: TDatabase;
   FDtbVyb1        :TFDtbVyb;
   FDtbVybPuvodni  :TFDtbVyb;
   procedure obnov;
   function  StavVyberu:TStavVyberu;
   function  SWhere(VStavVyberu:TStavVyberu):string;
   function  SWhereProLHC(vLHC_KOD,vLHC_KOD_ID,VODD_ID:string;VStavVyberu:TStavVyberu):string;
   function  RadekVLHCExistuje(vLHC_KOD,vLHC_KOD_ID,VODD_ID:string;VStavVyberu:TStavVyberu):boolean;
   function  VyberLHCdoKterehoBudesKopirovat:boolean;
   procedure ZaridUkonceniTransAkce;
   procedure KontrolaODDaODD_ID;
   function  ODD_IDNove:String;
   function  lzePripojit:Boolean;
   procedure KopirujTabulkyOdPOROST_SKUPDolu;
   procedure KopirujTabulkyOdPOROSTDolu;
   procedure SmazTabulkyOdPOROST_SKUPDolu;
   procedure SmazTabulkyOdPOROSTDolu(vcetneBZLaJP:Boolean);
   function  PorostMaJednu_PSK_JP_BZL(vLHC_KOD,vLHC_KOD_ID,VODD,VODD_ID,VDIL,VPOR:string):boolean;
   procedure Smaz(vcetneBZLaJP:Boolean);
  end;

procedure zkopirujCeleQuery(  vTabul:string;
                              zpusobKopirovani:TZpusobKopirovani;
                              VRichEdit: TRichEdit;
                              VDATABASE: TDatabase;
                              infoedit:Tedit;
                              Query1,QueryKopirovane:TQuery;
                              vLHC_KOD,vLHC_KOD_ID,vODD_ID:string);

procedure zkopirujRadekQuery( zpusobKopirovani:TZpusobKopirovani;
                              VRichEdit: TRichEdit;
                              Query1,Query2:TQuery;
                              vODD_ID,vLHC_KOD,vLHC_KOD_ID,vTabul:string);

var
  FDtbVyb: TFDtbVyb;

implementation

{$R *.DFM}

procedure TFDtbVyb.ButODDClick(Sender: TObject);
 begin
  QuVyber.close;
  QuVyber.SQL.clear;
  QuVyber.SQL.Add('select distinct ODD,ODD_ID from POROST');
  QuVyber.SQL.Add('where ((LHC_KOD = '+LLHC_KOD.Caption
                +') and ( LHC_KOD_ID = '+LLHC_KOD_ID.Caption+'))');
  QuVyber.SQL.Add('order by  ODD,ODD_ID');
  SuVyber.dataSet:=QuVyber;
  QuVyber.open;
end;

procedure TFDtbVyb.ButPORClick(Sender: TObject);
begin
  QuVyber.close;
  QuVyber.SQL.clear;
  QuVyber.SQL.Add('select ODD,ODD_ID,DIL,POR  from POROST');
  QuVyber.SQL.Add('where ((LHC_KOD = '+LLHC_KOD.Caption
                +') and ( LHC_KOD_ID = '+LLHC_KOD_ID.Caption+'))');
  QuVyber.SQL.Add('order by  ODD,ODD_ID,DIL,POR');
  QuVyber.open;
end;

procedure TFDtbVyb.ButPSKClick(Sender: TObject);
begin
  QuVyber.close;
  QuVyber.SQL.clear;
  QuVyber.SQL.Add('select ODD,ODD_ID,DIL,POR,PSK  from POROST_SKUP');
  QuVyber.SQL.Add('where ((LHC_KOD = '+LLHC_KOD.Caption
                +') and ( LHC_KOD_ID = '+LLHC_KOD_ID.Caption+'))');
  QuVyber.SQL.Add('order by  ODD,ODD_ID,DIL,POR,PSK');
  QuVyber.open;
end;

procedure zkopirujCeleQuery(  vTabul:string;
                              zpusobKopirovani:TZpusobKopirovani;
                              VRichEdit: TRichEdit;
                              VDATABASE: TDatabase;
                              infoedit:Tedit;
                              Query1,QueryKopirovane:TQuery;
                              vLHC_KOD,vLHC_KOD_ID,vODD_ID:string);
var i:longint;
    // radekNalezen:boolean;
 begin
 if zpusobKopirovani=naCisto then
   begin
    VRichEdit.lines.add('V tabulce '+VTabul+' zanm koprovat.');
   end;
  i:=0;
  doeditu('otvirm tabulku '+VTabul,infoedit);
  QueryKopirovane.open;
  doeditu('nedelam nic findfirst tabulku '+VTabul,infoedit);
  // radekNalezen:=QueryKopirovane.findfirst;
  // radekNalezen:=true;
  QueryKopirovane.first;
  if not VDATABASE.InTransaction then
            VDATABASE.StartTransaction;
  while not QueryKopirovane.eof do
   begin
    inc(i);
    zkopirujRadekQuery(zpusobKopirovani,VRichEdit,Query1,QueryKopirovane,
                        vODD_ID,vLHC_KOD,vLHC_KOD_ID,vTabul);
    doeditu('Kopiruju tabulku '+VTabul+' '+inttostr(i),infoedit);
    QueryKopirovane.next;
    if (i mod 100)=0 then
     begin
      if zpusobKopirovani=naCisto then
       begin
        if VDATABASE.InTransaction then
          begin
           DoEditu('Zavrni tabulky commit',infoedit);
           VRichEdit.lines.add('V tabulce '+VTabul+' '+inttostr(i)+' proveden commit');
           VDATABASE.commit;
          end;
        if not VDATABASE.InTransaction then
                 VDATABASE.StartTransaction;
       end;
     end;
   end;
  if zpusobKopirovani=naCisto then
   begin
    if VDATABASE.InTransaction then
       begin
        DoEditu('Zavrni tabulky commit',infoedit);
         VDATABASE.commit;
       end;
   end;
   doeditu('zavrm tabulku '+VTabul,infoedit);
   QueryKopirovane.close;
   if zpusobKopirovani=naCisto then
    begin
     VRichEdit.lines.add('V tabulce '+VTabul+' jsem vechno zkoproval.');
    end;
 end;

procedure zkopirujRadekQuery( zpusobKopirovani:TZpusobKopirovani;
                              VRichEdit: TRichEdit;
                              Query1,Query2:TQuery;
                              vODD_ID,vLHC_KOD,vLHC_KOD_ID,vTabul:string);
var i:integer;
    s:string;
    vporadku:boolean;
 begin
  repeat
  Query1.SQL.clear;
  s:='INSERT into '+vTabul+' VALUES (';
   for i:=0 to Query2.fieldcount-1 do
    begin
     if Query2.fields[i].fieldName='LHC_KOD' then
      begin
       s:=s+vLHC_KOD;
      end
     else
      begin
       if Query2.fields[i].fieldName='LHC_KOD_ID' then
        begin
         s:=s+vLHC_KOD_ID;
        end
       else
        begin
         if Query2.fields[i].fieldName='ODD_ID' then
          begin
           if VODD_ID<>''  then  s:=s+VODD_ID
           else s:=s+U0Oracle(Query2.fields[i].asstring);
          end
         else
          begin
           case Query2.fields[i].datatype of
            ftstring,ftMemo:
              begin
               s:=s+' '''+DvojitzApostrof(Query2.fields[i].asstring)+''' ';
              end;
            ftdateTime:
              begin
               s:=s+DatumOracle(Query2.fields[i].asstring);
              end;
            ftSmallint,ftInteger,ftWord,ftFloat,ftBCD :
              begin
                s:=s+U0Oracle(Query2.fields[i].asstring);
              end;
            else
              begin
               showmessage('Bacha,Bacha fieldName "'+Query2.fields[i].fieldName+'"='+inttostr(ord(Query2.fields[i].datatype)));
              end;
           end; //case
          end; // else Query2.fields[i].fieldName='ODD_ID'
        end; // else Query2.fields[i].fieldName='LHC_KOD_ID'
      end; // else Query2.fields[i].fieldName='LHC_KOD'
     if i<>Query2.fieldcount-1 then
      begin
       s:=s+',';
      end
     else
      begin
       s:=s+')';
      end;
    end;
   // showmessage(s);
   Query1.SQL.Add(s);
    vPoradku:=true;
   try
    Query1.ExecSQL;
   except
    if VRichEdit<>nil then VRichEdit.lines.add('Nelze provst '''+s+'''');
    case zpusobKopirovani of
      priChybeDoIDmin1:
        begin
         if trim(vODD_ID)<>'-1' then
          begin
           VPoradku:=false;
           vODD_ID:='-1';
           if VRichEdit<>nil then VRichEdit.lines.add('Zkusm to nahrt s ODD_ID=-1');
          end;
        end;
     end; //case
    if VRichEdit<>nil then VRichEdit.perform(EM_SCROLLCARET,0,0);
    beep;
   end; //except
  until VPoradku;
end;
procedure TFDtbVyb.ZaridUkonceniTransAkce;
 begin
  if not lhp_Database.connected then exit;
  if (LLHC_KODcopy.caption='') and not (LMazano.visible) then
   begin
    if lhp_Database.InTransaction then
    LHP_Database.Commit;
   end
  else
   begin
    Application.CreateForm(TFUkonTrans,FUkonTrans);
    FUkonTrans.showmodal;
    if FUkonTrans.vybrano then
     begin
      showmessage('Bude provedeno definitvn zapsn zmn z posledn transakce. Pokud tomu chces zabrnit, mus ihned nsiln perusit aplikaci.');
      LHP_Database.Commit;
      DoEditu('provedeno definitvn zapsn zmn z posledn transakce.',infoedit);
     end
    else
     begin
      LHP_Database.rollback;
      obnov;
      DoEditu('Zmny z posledn transakce byly opt smazny.',infoedit);
     end;
    FUkonTrans.free;
   end;

  LLHC_KODcopy.caption:='';
  LLHC_KOD_IDCopy.caption:='';
  LLHC_NAZcopy.caption:='';
  LODD_ID.caption:='';
  LODD.caption:='';
  LMazano.visible:=false;
  if FDtbVyb1<>nil then
   begin
    FDtbVyb1.free;
    FDtbVyb1:=nil;
   end;
  RichEdit1.lines.clear;
 end;
function TFDtbVyb.VyberLHCdoKterehoBudesKopirovat:boolean;
 var VPoradku:boolean;
  begin
  ZaridUkonceniTransAkce;
  LHP_DATABASE.StartTransaction;
  Application.CreateForm(TFVybLHCID,FVybLHCID);
  FVybLHCID.ELHC_KOD.text:=LLHC_KOD.caption;
  FVybLHCID.ELHC_KOD_ID.text:=LLHC_KOD_ID.caption;
  repeat
  vPoradku:=true;
  FVybLHCID.showmodal;
  if FVybLHCID.vybrano then
   begin
    queryV1.active:=false;
    queryV1.SQL.clear;
    queryV1.SQL.Add('Select count(*) from LHC');
    queryV1.SQL.Add('where (LHC_KOD='+FVybLHCID.ELHC_KOD.text
                    +')and(LHC_KOD_ID='+FVybLHCID.ELHC_KOD_ID.text+')');
    queryV1.open;
    if queryV1.fieldbyname('count(*)').asinteger=0 then
     begin
      showmessage('Nelze zkoprovat. LHC_KOD "'+FVybLHCID.ELHC_KOD.text
         +'", LHC_KOD_ID "'+FVybLHCID.ELHC_KOD_ID.text
         +'" neexistuje. Zadej znovu.');
      vporadku:=false;
     end;
    queryV1.Close;
   end;
  until vPoradku;
  if FVybLHCID.vybrano then
   begin
    queryV1.SQL.clear;
    queryV1.SQL.Add('Select LHC_NAZ from LHC');
    queryV1.SQL.Add('where (LHC_KOD='+FVybLHCID.ELHC_KOD.text
                    +')and(LHC_KOD_ID='+FVybLHCID.ELHC_KOD_ID.text+')');
    queryV1.open;
    queryV1.fieldbyname('LHC_NAZ').asString;
    LLHC_KODcopy.caption:=FVybLHCID.ELHC_KOD.text;
    LLHC_KOD_IDCopy.caption:=FVybLHCID.ELHC_KOD_ID.text;
    LLHC_NAZcopy.caption:=queryV1.fieldbyname('LHC_NAZ').asString;
    if FDtbVyb1<>nil then FDtbVyb1.free;
   end;
  result:=FVybLHCID.vybrano;
  FVybLHCID.free;
 end;
procedure TFDtbVyb.KontrolaODDaODD_ID;
 begin
  if StavVyberu=vybranoNic then exit;
  if QuVyber.fieldByName('ODD').asstring=LODD.caption then exit;
  queryV2.active:=false;
  with queryV2.SQL do
   begin
    clear;
    Add('select distinct ODD_ID from POROST');
    Add('where ((LHC_KOD = '+LLHC_KODcopy.Caption
                +') and ( LHC_KOD_ID = '+LLHC_KOD_IDcopy.Caption
                +') and ( ODD = '+QuVyber.fieldByName('ODD').asstring
                +'))');
    Add('order by ODD_ID');
   end;
  queryV2.Open;
  if queryV2.eof then
   begin
    LODD.caption:=QuVyber.fieldByName('ODD').asstring;
    LODD_ID.caption:=''; // QuVyber.fieldByName('ODD_ID').asstring;
    queryV2.close;
    exit;
   end;
  Application.CreateForm(TFVyODDID,FVyODDID);
  FVyODDID.DataSource1.DataSet:=queryV2;
  FVyODDID.EODD_IDNove.text:=QueryV2.fieldByName('ODD_ID').asstring;
  FVyODDID.LODD.caption:=QuVyber.fieldByName('ODD').asstring;
  FVyODDID.showmodal;
  LODD.caption:=FVyODDID.LODD.caption;
  LODD_ID.caption:=FVyODDID.EODD_IDNove.text;
  FVyODDID.free;
  queryV2.close;
 end;
function TFDtbVyb.ODD_IDNove:String;
 begin
  if LODD_ID.Caption<>'' then result:= LODD_ID.Caption
  else
   begin
    if StavVyberu=vybranoNic then result:=''
    else result:=QuVyber.fieldByName('ODD_ID').asstring;
   end
 end;
procedure TFDtbVyb.Button1Click(Sender: TObject);
begin

  QuVyber.close;
  QuVyber.SQL.clear;
  QuVyber.SQL.Add('select ODD,ODD_ID,DIL,POR,BZL,BZL_ID  from BEZLESI');
  QuVyber.SQL.Add('where ((LHC_KOD = '+LLHC_KOD.Caption
                +') and ( LHC_KOD_ID = '+LLHC_KOD_ID.Caption+'))');
  QuVyber.SQL.Add('order by  ODD,ODD_ID,DIL,POR,BZL,BZL_ID');
  QuVyber.open;

end;

procedure TFDtbVyb.Button2Click(Sender: TObject);
begin

  QuVyber.close;
  QuVyber.SQL.clear;
  QuVyber.SQL.Add('select ODD,ODD_ID,DIL,POR,JP,JP_ID  from JINE_POZ');
  QuVyber.SQL.Add('where ((LHC_KOD = '+LLHC_KOD.Caption
                +') and ( LHC_KOD_ID = '+LLHC_KOD_ID.Caption+'))');
  QuVyber.SQL.Add('order by  ODD,ODD_ID,DIL,POR,JP,JP_ID');
  QuVyber.open;

end;

procedure TFDtbVyb.ButMoveClick(Sender: TObject);
 begin
  ButCopyClick(Sender);
  ButDeleteClick(Sender);
 end;
function TFDtbVyb.SWhere(VStavVyberu:TStavVyberu):string;
 begin
  if VStavVyberu=vybranoNic then
   begin
    result:='Nic nen vybrno.';
    exit;
   end;
  result:=SWhereProLHC(LLHC_KOD.Caption,LLHC_KOD_ID.Caption,QuVyber.fieldByName('ODD_ID').asstring,VStavVyberu);
 end;
function TFDtbVyb.SWhereProLHC(vLHC_KOD,vLHC_KOD_ID,VODD_ID:string;VStavVyberu:TStavVyberu):string;
var s:string;
begin
 s:='Where (LHC_KOD='+vLHC_KOD+')and(LHC_KOD_ID='+vLHC_KOD_ID+')';
 case VStavVyberu of
   vybranoNic:begin
               result:='Nic nen vybrno.';
              end;
   vybranoODD:begin
               result:=s+'and(ODD='+QuVyber.fieldByName('ODD').asstring+')'
                        +'and(ODD_ID='+VODD_ID+')'
                     ;
              end;
   vybranoPOR:begin
               result:=s+'and(ODD='+QuVyber.fieldByName('ODD').asstring+')'
                        +'and(ODD_ID='+VODD_ID+')'
                        +'and(DIL='''+QuVyber.fieldByName('DIL').asstring+''')'
                        +'and(POR='''+QuVyber.fieldByName('POR').asstring+''')'
               ;
              end;
   vybranoPSK:begin
               result:=s+'and(ODD='+QuVyber.fieldByName('ODD').asstring+')'
                        +'and(ODD_ID='+VODD_ID+')'
                        +'and(DIL='''+QuVyber.fieldByName('DIL').asstring+''')'
                        +'and(POR='''+QuVyber.fieldByName('POR').asstring+''')'
                        +'and(PSK='''+QuVyber.fieldByName('PSK').asstring+''')'
               ;
              end;
   vybranoBZL:begin
               result:=s+'and(ODD='+QuVyber.fieldByName('ODD').asstring+')'
                        +'and(ODD_ID='+VODD_ID+')'
                        +'and(DIL='''+QuVyber.fieldByName('DIL').asstring+''')'
                        +'and(POR='''+QuVyber.fieldByName('POR').asstring+''')'
                        +'and(BZL='+QuVyber.fieldByName('BZL').asstring+')'
                        +'and(BZL_ID='+QuVyber.fieldByName('BZL_ID').asstring+')'
               ;
              end;
   vybranoJP:begin
               result:=s+'and(ODD='+QuVyber.fieldByName('ODD').asstring+')'
                        +'and(ODD_ID='+VODD_ID+')'
                        +'and(DIL='''+QuVyber.fieldByName('DIL').asstring+''')'
                        +'and(POR='''+QuVyber.fieldByName('POR').asstring+''')'
                        +'and(JP='+QuVyber.fieldByName('JP').asstring+')'
                        +'and(JP_ID='+QuVyber.fieldByName('JP_ID').asstring+')'
               ;
              end;
 end; //case
end;
function TFDtbVyb.StavVyberu:TStavVyberu;
 begin
  if QuVyber.active=false then
   begin
    result:=VybranoNic;
    exit;
   end;
  if QuVyber.findfield('JP')<>nil then
   begin
    result:=VybranoJP;
    exit;
   end;
  if QuVyber.findfield('BZL')<>nil then
   begin
    result:=VybranoBZL;
    exit;
   end;
  if QuVyber.findfield('PSK')<>nil then
   begin
    result:=VybranoPSK;
    exit;
   end;
  if QuVyber.findfield('POR')<>nil then
   begin
    result:=VybranoPOR;
    exit;
   end;
  if QuVyber.findfield('ODD')<>nil then
   begin
    result:=VybranoODD;
    exit;
   end;
  result:=VybranoNic;
 end;
function TFDtbVyb.RadekVLHCExistuje(vLHC_KOD,vLHC_KOD_ID,VODD_ID:string;VStavVyberu:TStavVyberu):boolean;
 begin
  QueryV3.active:=false;
  QueryV3.SQL.Clear;
  case VStavVyberu of
   vybranoODD:  QueryV3.SQL.Add('Select count(*) from POROST');
   vybranoPOR:  QueryV3.SQL.Add('Select count(*) from POROST');
   vybranoPSK:  QueryV3.SQL.Add('Select count(*) from POROST_SKUP');
   vybranoBZL:  QueryV3.SQL.Add('Select count(*) from BEZLESI');
   vybranoJP:   QueryV3.SQL.Add('Select count(*) from JINE_POZ');
  end; //case
  QueryV3.SQL.Add(SWhereProLHC(vLHC_KOD,vLHC_KOD_ID,VODD_ID,VStavVyberu));
  QueryV3.open;
  if (QueryV3.fieldByName('count(*)').asinteger=0) then result:=false
    else result:=true;
  QueryV3.close;
 end;

function TFDtbVyb.PorostMaJednu_PSK_JP_BZL(vLHC_KOD,vLHC_KOD_ID,VODD,VODD_ID,VDIL,VPOR:string):boolean;
 var swhe:string;
 begin
  if (VDIL='') and (VPOR='') then
   begin
    swhe:='Where (LHC_KOD='+vLHC_KOD+')and(LHC_KOD_ID='+vLHC_KOD_ID+')'
               +'and(ODD='+VODD+')'
               +'and(ODD_ID='+VODD_ID+')'
               ;
   end
  else
   begin
    swhe:='Where (LHC_KOD='+vLHC_KOD+')and(LHC_KOD_ID='+vLHC_KOD_ID+')'
               +'and(ODD='+VODD+')'
               +'and(ODD_ID='+VODD_ID+')'
               +'and(DIL='''+VDIL+''')'
               +'and(POR='''+VPOR+''')'
               ;
   end;
  QueryV3.active:=false;
  QueryV3.SQL.Clear;
  QueryV3.SQL.Add('Select count(*) from POROST_SKUP');
  QueryV3.SQL.Add(swhe);
  QueryV3.open;
  if (QueryV3.fieldByName('count(*)').asinteger>0) then
   begin
    result:=true;
    QueryV3.close;
    exit;
   end;

  QueryV3.active:=false;
  QueryV3.SQL.Clear;
  QueryV3.SQL.Add('Select count(*) from BEZLESI');
  QueryV3.SQL.Add(swhe);
  QueryV3.open;
  if (QueryV3.fieldByName('count(*)').asinteger>0) then
   begin
    result:=true;
    QueryV3.close;
    exit;
   end;

  QueryV3.active:=false;
  QueryV3.SQL.Clear;
  QueryV3.SQL.Add('Select count(*) from JINE_POZ');
  QueryV3.SQL.Add(swhe);
  QueryV3.open;
  if (QueryV3.fieldByName('count(*)').asinteger>0) then
   begin
    result:=true;
    QueryV3.close;
    exit;
   end;

  result:=False;
  QueryV3.close;

 end;

function TFDtbVyb.lzePripojit:Boolean;
 begin
  try
   LHP_DATABASE.DatabaseName:='ORAC'+LLHC_KOD.Caption+'I'+LLHC_KOD_ID.Caption;
   LHP_DATABASE.connected:=true;
   LHP_DATABASE.connected:=false;
   result:=true;
  except
   result:=false;
   showmessage('Nelze pipojit databzi. Pravdpodobn se sna otev podruh stejn LHC.');
  end;
 end;
procedure TFDtbVyb.FormShow(Sender: TObject);
var i:integer;
begin
 LLHC_KODcopy.caption:='';
 LLHC_KOD_IDCopy.caption:='';
 LLHC_NAZcopy.caption:='';
 LODD_ID.Caption:='';
 LODD.Caption:='';
 LMazano.visible:=false;
 FDtbVyb1:=nil;
 FDtbVybPuvodni:=nil;
 for i:=0 to componentcount-1 do
  begin
   SetPropStringByName(components[i], 'DatabaseName' ,'ORAC'+LLHC_KOD.Caption+'I'+LLHC_KOD_ID.Caption);
  end;
 LHP_DATABASE.connected:=true;
 LHP_DATABASE.StartTransaction;
 ButODDClick(Sender);
end;


procedure TFDtbVyb.FormActivate(Sender: TObject);
 begin
  obnov;
 end;
procedure TFDtbVyb.obnov;
 var Bm:TBookmark;
 begin
 if QuVyber.active then
  begin
   Bm:=QuVyber.GetBookMark;
   QuVyber.close;
   QuVyber.open;
   try
    QuVyber.gotoBookmark(Bm);
   except
   end;
   QuVyber.FreeBookmark(Bm);
  end;
end;

procedure TFDtbVyb.ButDestinLHCClick(Sender: TObject);
var
    i:integer;
    Podminka:Boolean;
begin
  if FDtbVyb1<>nil then
   begin
    // Showmessage('Formular pro kontroln LHC je u vytvoen.');
    FDtbVyb1.WindowState:=WsNormal;
    FDtbVyb1.show;
    FDtbVyb1.SetFocus;
    exit;
   end;
  if LLHC_KODcopy.Caption<>'' then podminka:=true
   else podminka:=VyberLHCdoKterehoBudesKopirovat;
  if podminka then
  begin
  Application.CreateForm(TFDtbVyb,FDtbVyb1);
  FDtbVyb1.LLHC_KOD.caption:=LLHC_KODcopy.caption;
  FDtbVyb1.LLHC_KOD_ID.caption:=LLHC_KOD_IDCopy.Caption;
  FDtbVyb1.LLHC_NAZ.caption:=LLHC_NAZcopy.caption;

  FDtbVyb1.Caption:='Kontrola '
      +FDtbVyb1.LLHC_KOD.caption
      +'-'+FDtbVyb1.LLHC_KOD_ID.caption
      +' '+FDtbVyb1.LLHC_NAZ.caption;

  FDtbVyb1.onShow:=nil;
  FDtbVyb1.FDtbVyb1:=nil;
  FDtbVyb1.LLHC_KODcopy.caption:='';
  FDtbVyb1.LLHC_KOD_IDCopy.caption:='';
  FDtbVyb1.LLHC_NAZcopy.caption:='';
  FDtbVyb1.LODD_ID.Caption:='';
  FDtbVyb1.LODD.Caption:='';
  LMazano.visible:=false;
  for i:=0 to  FDtbVyb1.componentcount-1 do
   begin
    if trim(uppercase(FDtbVyb1.components[i].name))<>'LHP_DATABASE' then
      SetPropStringByName( FDtbVyb1.components[i], 'DatabaseName' ,'ORAC'+LLHC_KOD.Caption+'I'+LLHC_KOD_ID.Caption);
   end;
  FDtbVyb1.ButODDClick(Sender);
  FDtbVyb1.ButTrans.Visible:=false;
  FDtbVyb1.ButMove.Visible:=false;
  FDtbVyb1.ButCopy.Visible:=false;
  FDtbVyb1.ButDestinLHC.Visible:=false;
  FDtbVyb1.FDtbVybPuvodni:=self;
  FDtbVyb1.show;
  end;
 end;
procedure TFDtbVyb.FormClose(Sender: TObject; var Action: TCloseAction);
 begin
  ZaridUkonceniTransAkce;
  LHP_Database.Connected:=False;
  LHP_Database.databaseName:='';
 end;

procedure TFDtbVyb.ButTransClick(Sender: TObject);
begin
 ZaridUkonceniTransAkce;
end;

procedure TFDtbVyb.FormDestroy(Sender: TObject);
begin
 if FDtbVybPuvodni<>NIL then FDtbVybPuvodni.FDtbVyb1:=nil;
end;

procedure TFDtbVyb.KopirujTabulkyOdPOROST_SKUPDolu;
  begin
   with QueryV2.SQL do
     begin
      Clear;Add('select * from POROST_SKUP');Add(SWhere(StavVyberu));
      zkopirujCeleQuery('POROST_SKUP',priChybeDoIDmin1,RichEdit1,LHP_DATABASE,infoedit,QueryV1,QueryV2,LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,LODD_ID.Caption);

      Clear;Add('select * from PS_V_KU');Add(SWhere(StavVyberu));
      zkopirujCeleQuery('PS_V_KU',priChybeDoIDmin1,RichEdit1,LHP_DATABASE,infoedit,QueryV1,QueryV2,LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,LODD_ID.Caption);

      Clear;Add('select * from ETAZ');Add(SWhere(StavVyberu));
      zkopirujCeleQuery('ETAZ',priChybeDoIDmin1,RichEdit1,LHP_DATABASE,infoedit,QueryV1,QueryV2,LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,LODD_ID.Caption);

      Clear;Add('select * from DREV_ZALES');Add(SWhere(StavVyberu));
      zkopirujCeleQuery('DREV_ZALES',priChybeDoIDmin1,RichEdit1,LHP_DATABASE,infoedit,QueryV1,QueryV2,LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,LODD_ID.Caption);

      Clear;Add('select * from DREVINA');Add(SWhere(StavVyberu));
      zkopirujCeleQuery('DREVINA',priChybeDoIDmin1,RichEdit1,LHP_DATABASE,infoedit,QueryV1,QueryV2,LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,LODD_ID.Caption);

      Clear;Add('select * from SKODY');Add(SWhere(StavVyberu));
      zkopirujCeleQuery('SKODY',priChybeDoIDmin1,RichEdit1,LHP_DATABASE,infoedit,QueryV1,QueryV2,LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,LODD_ID.Caption);

     end;
  end;
procedure TFDtbVyb.KopirujTabulkyOdPOROSTDolu;
  begin
   with QueryV2.SQL do
    begin
     Clear;Add('select * from POROST');Add(SWhere(stavVyberu));
     zkopirujCeleQuery('POROST',priChybeDoIDmin1,RichEdit1,LHP_DATABASE,infoedit,QueryV1,QueryV2,LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,LODD_ID.Caption);

     Clear;Add('select * from BEZLESI');Add(SWhere(StavVyberu));
     zkopirujCeleQuery('BEZLESI',priChybeDoIDmin1,RichEdit1,LHP_DATABASE,infoedit,QueryV1,QueryV2,LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,LODD_ID.Caption);

     Clear;Add('select * from JINE_POZ');Add(SWhere(StavVyberu));
     zkopirujCeleQuery('JINE_POZ',priChybeDoIDmin1,RichEdit1,LHP_DATABASE,infoedit,QueryV1,QueryV2,LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,LODD_ID.Caption);

     Clear;Add('select * from PREKRYV');Add(SWhere(StavVyberu));
     zkopirujCeleQuery('PREKRYV',priChybeDoIDmin1,RichEdit1,LHP_DATABASE,infoedit,QueryV1,QueryV2,LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,LODD_ID.Caption);
    end;
   KopirujTabulkyOdPOROST_SKUPDolu;
  end;
procedure TFDtbVyb.SmazTabulkyOdPOROST_SKUPDolu;
  begin
   with QueryV2.SQL do
     begin
      doeditu('Mau POROST_SKUP',infoedit);
      Clear;Add('delete POROST_SKUP');Add(SWhere(StavVyberu)); QueryV2.execSQL;
      doeditu('Mau PS_V_KU',infoedit);
      Clear;Add('delete PS_V_KU');    Add(SWhere(StavVyberu));QueryV2.execSQL;
      doeditu('Mau ETAZ',infoedit);
      Clear;Add('delete ETAZ');       Add(SWhere(StavVyberu));QueryV2.execSQL;
      doeditu('Mau DREV_ZALES',infoedit);
      Clear;Add('delete DREV_ZALES'); Add(SWhere(StavVyberu));QueryV2.execSQL;
      doeditu('Mau DREVINA',infoedit);
      Clear;Add('delete DREVINA');    Add(SWhere(StavVyberu));QueryV2.execSQL;
      doeditu('Mau SKODY',infoedit);
      Clear;Add('delete SKODY');      Add(SWhere(StavVyberu));QueryV2.execSQL;
      doeditu(' ',infoedit);
     end;
  end;

procedure TFDtbVyb.SmazTabulkyOdPOROSTDolu(vcetneBZLaJP:Boolean);
  begin
   with QueryV2.SQL do
     begin
      SmazTabulkyOdPOROST_SKUPDolu;
      if vcetneBZLaJP then
       begin
        doeditu('Mau BEZLESI',infoedit);
        Clear;Add('delete BEZLESI');    Add(SWhere(StavVyberu));QueryV2.execSQL;

        doeditu('Mau JINE_POZ',infoedit);
        Clear;Add('delete JINE_POZ');   Add(SWhere(StavVyberu));QueryV2.execSQL;

        doeditu('Mau PREKRYV',infoedit);
        Clear;Add('delete PREKRYV');    Add(SWhere(StavVyberu));QueryV2.execSQL;

        doeditu('Mau POROST',infoedit);
        Clear;Add('delete POROST');Add(SWhere(StavVyberu)); QueryV2.execSQL;

        doeditu(' ',infoedit);
       end;
     end;
  end;
procedure TFDtbVyb.ButCopyClick(Sender: TObject);
var Podminka:Boolean;
begin
  if LLHC_KODcopy.Caption<>'' then podminka:=true
   else podminka:=VyberLHCdoKterehoBudesKopirovat;
  if podminka then
   begin
   // SuVyber.dataset:=QueryV2;
    KontrolaODDaODD_ID;
    case StavVyberu of
         vybranoNic:begin
                    showmessage('Chyba pi vbru pole');
                    end;
         vybranoODD:begin
                     KopirujTabulkyOdPOROSTDolu;
                     DoEditu('Hotovo - Koprovn oddln probhlo.',infoedit);
                    end;
         VybranoPor:begin
                     if RadekVLHCExistuje(LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,ODD_IDNove,VybranoPor)
                      then showmessage('Nelze koprovat, porost u existuje.')
                      else
                       begin
                        KopirujTabulkyOdPOROSTDolu;
                        DoEditu('Hotovo - Koprovn porostu probhlo.',infoedit);
                       end
                    end;
         vybranoPSK:begin
                     if not RadekVLHCExistuje(LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,ODD_IDNove,VybranoPor) then
                       begin
                        with QueryV2.SQL do
                         begin
                          Clear;Add('select * from POROST');Add(SWhere(VybranoPor));
                          zkopirujCeleQuery('POROST',priChybeDoIDmin1,RichEdit1,LHP_DATABASE,infoedit,QueryV1,QueryV2,LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,LODD_ID.Caption);
                         end;
                       end;
                     if RadekVLHCExistuje(LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,ODD_IDNove,VybranoPSK)
                       then
                        begin
                         showmessage('Nelze koprovat, PSK u existuje.');
                         exit;
                        end;
                     KopirujTabulkyOdPOROST_SKUPDolu;
                     DoEditu('Hotovo - Koprovn porostn skupiny probhlo.',infoedit);
                    end;
         vybranoBZL:begin
                     if not RadekVLHCExistuje(LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,ODD_IDNove,VybranoPor) then
                       begin
                        with QueryV2.SQL do
                         begin
                          Clear;Add('select * from POROST');Add(SWhere(VybranoPor));
                          zkopirujCeleQuery('POROST',priChybeDoIDmin1,RichEdit1,LHP_DATABASE,infoedit,QueryV1,QueryV2,LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,LODD_ID.Caption);
                         end;
                       end;
                     if RadekVLHCExistuje(LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,ODD_IDNove,VybranoBZL)
                       then
                        begin
                         showmessage('Nelze koprovat, BZL u existuje.');
                         exit;
                        end;
                    with QueryV2.SQL do
                      begin
                       Clear;Add('select * from BEZLESI');Add(SWhere(StavVyberu));
                       zkopirujCeleQuery('BEZLESI',priChybeDoIDmin1,RichEdit1,LHP_DATABASE,infoedit,QueryV1,QueryV2,LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,LODD_ID.Caption);
                      end;
                     DoEditu('Hotovo - Koprovn bezles probhlo.',infoedit);
                    end;
          vybranoJP:begin
                     if not RadekVLHCExistuje(LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,ODD_IDNove,VybranoPor) then
                       begin
                        with QueryV2.SQL do
                         begin
                          Clear;Add('select * from POROST');Add(SWhere(VybranoPor));
                          zkopirujCeleQuery('POROST',priChybeDoIDmin1,RichEdit1,LHP_DATABASE,infoedit,QueryV1,QueryV2,LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,LODD_ID.Caption);
                         end;
                       end;
                     if RadekVLHCExistuje(LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,ODD_IDNove,VybranoJP)
                       then
                        begin
                         showmessage('Nelze koprovat, JP u existuje.');
                         exit;
                        end;
                     with QueryV2.SQL do
                      begin
                       Clear;Add('select * from JINE_POZ');Add(SWhere(StavVyberu));
                       zkopirujCeleQuery('JINE_POZ',priChybeDoIDmin1,RichEdit1,LHP_DATABASE,infoedit,QueryV1,QueryV2,LLHC_KODcopy.Caption,LLHC_KOD_IDcopy.Caption,LODD_ID.Caption);
                      end;
                     DoEditu('Hotovo - Koprovn jinho pozemku probhlo.',infoedit);
                    end;
         end; //case
   end;
end;

procedure TFDtbVyb.ButDeleteClick(Sender: TObject);
begin
 Smaz(true);
end;
procedure TFDtbVyb.Smaz(vcetneBZLaJP:Boolean);
   var VODD,VODD_ID,VDIL,VPOR:string;

   procedure priradPromenne(QuVyber:TQuery);
    begin
     VODD:=QuVyber.fieldByName('ODD').asstring;
     VODD_ID:=QuVyber.fieldByName('ODD_ID').asstring;
     vDIL:='';
     VPOR:='';
     if QuVyber.findfield('DIL')<>nil then
      begin
       VDIL:=QuVyber.fieldByName('DIL').asstring;
      end;
     if QuVyber.findfield('POR')<>nil then
      begin
       VPOR:=QuVyber.fieldByName('POR').asstring;
      end;
    end;
   procedure KdyzPorostPrazdnyTakSmaz;
    var Swhe:String;
      begin
       if not PorostMaJednu_PSK_JP_BZL(LLHC_KOD.caption,LLHC_KOD_ID.caption,VODD,VODD_ID,VDIL,VPOR) then
        begin
         Application.CreateForm(TdotazF1,dotazF2);
         dotazF2.Label1.caption:='Porost  '+VODD+VDIL+VPOR+'  neobsahuje dnou POROST_SKUP,BEZLESI ani JINY_POZ.';
         dotazF2.Label2.caption:='Mm jej smazat ?';
         dotazF2.showmodal;
         if dotazF2.odpoved then
          begin
           swhe:='Where (LHC_KOD='+LLHC_KOD.caption+')and(LHC_KOD_ID='+LLHC_KOD_ID.caption+')'
                     +'and(ODD='+VODD+')'
                     +'and(ODD_ID='+VODD_ID+')'
                     +'and(DIL='''+VDIL+''')'
                     +'and(POR='''+VPOR+''')'
                    ;
           QueryV3.active:=false;
           QueryV3.SQL.Clear;
           QueryV3.SQL.Add('Delete POROST');
           QueryV3.SQL.Add(swhe);
           QueryV3.execSQL;
           QueryV3.active:=false;
           QueryV3.SQL.Clear;
           QueryV3.SQL.Add('Delete PREKRYV');
           QueryV3.SQL.Add(swhe);
           QueryV3.execSQL;
         end;
         dotazF2.free;
       end;
     end;

   procedure KdyzPorostVOddeleniPrazdnyTakSmaz;
    var swhe1:string;
     begin
       swhe1:='Where (LHC_KOD='+LLHC_KOD.caption+')and(LHC_KOD_ID='+LLHC_KOD_ID.caption+')'
                     +'and(ODD='+VODD+')'
                     +'and(ODD_ID='+VODD_ID+')';
       QueryV4.Active:=False;
       QueryV4.SQL.Clear;
       QueryV4.SQL.Add('Select ODD,ODD_ID,DIL,POR from POROST');
       QueryV4.SQL.Add(swhe1);
       QueryV4.open;
       while not QueryV4.eof do
        begin
         priradPromenne(QueryV4);
         KdyzPorostPrazdnyTakSmaz;
         QueryV4.next;
        end;
    end;
begin
  LMazano.visible:=true;
  if not LHP_DATABASE.InTransaction then
            LHP_DATABASE.StartTransaction;
    case StavVyberu of
         vybranoNic:begin
                    showmessage('Chyba pi vbru pole');
                    end;
         vybranoODD:begin
                     SmazTabulkyOdPOROSTDolu(vcetneBZLaJP);
                     if not vcetneBZLaJP then
                      begin
                       priradPromenne(QuVyber);
                       KdyzPorostVOddeleniPrazdnyTakSmaz;
                      end;
                     obnov;
                     DoEditu('Hotovo - Mazn oddln probhlo.',infoedit);
                    end;
         VybranoPor:begin
                     SmazTabulkyOdPOROSTDolu(vcetneBZLaJP);
                     if not vcetneBZLaJP then
                      begin
                       priradPromenne(QuVyber);
                       KdyzPorostPrazdnyTakSmaz;
                      end;
                     obnov;
                     DoEditu('Hotovo - Mazn porostu probhlo.',infoedit);
                    end;
         vybranoPSK:begin
                     priradPromenne(QuVyber);
                     SmazTabulkyOdPOROST_SKUPDolu;
                     obnov;
                     KdyzPorostPrazdnyTakSmaz;
                     DoEditu('Hotovo - Mazn porostn skupiny probhlo.',infoedit);
                    end;
         vybranoBZL:begin
                     if not vcetneBZLaJP then
                       begin
                        showmessage('Bezles nen porostn pda.');
                        exit;
                       end;
                     priradPromenne(QuVyber);
                      with QueryV2.SQL do
                       begin
                        doeditu('Mau BEZLESI',infoedit);
                        Clear;Add('delete BEZLESI');    Add(SWhere(StavVyberu));QueryV2.execSQL;
                       end;
                     obnov;
                     KdyzPorostPrazdnyTakSmaz;
                     DoEditu('Hotovo - Mazn bezles probhlo.',infoedit);
                    end;
         vybranoJP:begin
                     if not vcetneBZLaJP then
                       begin
                        showmessage('Jin pozemek nen porostn pda.');
                        exit;
                       end;
                     priradPromenne(QuVyber);
                      with QueryV2.SQL do
                       begin
                        doeditu('Mau JINE_POZ',infoedit);
                        Clear;Add('delete JINE_POZ');   Add(SWhere(StavVyberu));QueryV2.execSQL;
                       end;
                      obnov;
                      KdyzPorostPrazdnyTakSmaz;
                      DoEditu('Hotovo - Mazn jinho pozemku probhlo.',infoedit);
                     end
         end; // Case
end;

procedure TFDtbVyb.ButDeleteBezBZLClick(Sender: TObject);
begin
 Smaz(false);
end;

end.
