unit UPhs;
interface
 uses dialogs,Sysutils,
      LesCisOr,E_lesCel,E_lesOdd,LesCisel,Mat1;
 procedure VytvorPhs_Pom(LesniCelek:TLesniCelek;kamDir:string);
 procedure zkontrolujPhs_Pom(LesniCelek:TLesniCelek);
 procedure SmazHSVHospSoubPhsMN(mazanyHs:integer;HospSoubPhsMN:THospSoubPhsMN);
 procedure DoplnPrvniHSVHospSoubPhsMN(HospSoubPhsMN:THospSoubPhsMN);
 procedure SetridCisHS(LesniCelek:TLesniCelek);
 function  HlHSVHospSoubPhsMN(HlHs:integer;HospSoubPhsMN:THospSoubPhsMN):Boolean;
 procedure NastrkejDoTab_HS(LesniCelek:TLesniCelek);
 procedure VytvorPhs_TXT(LesniCelek:TLesniCelek;kamDir:string);
implementation

procedure NastrkejDoTab_HS(LesniCelek:TLesniCelek);
var i:integer;
 begin
  LesniCelek.Ciselnik.Tb_HS.active    :=false;
  LesniCelek.Ciselnik.Tb_HS.exclusive :=true;
  LesniCelek.FFOvr98.Tb_HS.active   :=false;
  LesniCelek.Ciselnik.Tb_HS.EmptyTable;
  LesniCelek.Ciselnik.Tb_HS.exclusive :=false;
  LesniCelek.Ciselnik.Tb_HS.open;
  if LesniCelek.Ciselnik.TB_HS.findfield('SEST_DTO')=nil then
   begin
     LesniCelek.Ciselnik.TB_HS.close;
     LesniCelek.LOvr98.TB_HS.close;
     LesniCelek.LOvr98.Querydotaz.SQL.clear;
     LesniCelek.LOvr98.Querydotaz.SQL.add('ALTER TABLE TAB_HS ADD SEST_DTO CHAR(2)');
     try
      LesniCelek.LOvr98.QueryDotaz.execSQL;
     except
     end;
     LesniCelek.Ciselnik.TB_HS.open;
   end;

  if LesniCelek.Ciselnik.TB_HS.findfield('PovTezPod80')=nil then
   begin
     LesniCelek.Ciselnik.TB_HS.close;
     LesniCelek.LOvr98.TB_HS.close;
     LesniCelek.LOvr98.Querydotaz.SQL.clear;
     LesniCelek.LOvr98.Querydotaz.SQL.add('ALTER TABLE TAB_HS ADD PovTezPod80 CHAR(1)');
     try
      LesniCelek.LOvr98.QueryDotaz.execSQL;
     except
     end;
     LesniCelek.Ciselnik.TB_HS.open;
   end;

  with  LesniCelek.CiselOrbis.cisHsMN do
   begin
    for i:=0 to count-1 do
     begin
      with TcisHs(elements[i]) do
       begin
        with LesniCelek.Ciselnik.Tb_HS do
         begin
          Insert;
          fieldByName('CISLO_HS').asinteger:=CISLO_HS;
          fieldByName('NAZEV_HS').asstring:=NAZEV_HS;
          fieldByName('OBMYTI').asinteger:=OBMYTI;
          fieldByName('OBN_DOBA').asinteger:=OBN_DOBA;
          fieldByName('POC_OBNOVY').asinteger:=POC_OBNOVY;
          fieldByName('POC_PROR').asinteger:=POC_PROR;
          fieldByName('POC_MYTKLID').asinteger:=POC_MYTKLID;
          fieldByName('POD_MEL_DR').asinteger:=MZD;
          fieldByName('ODVOZ_TEZ').asstring:=ODVOZ_TEZ;
          fieldByName('SEST_DTO').asstring:=JdeDoSestavDTO;
          fieldByName('PovTezPod80').asstring:=PovolenaTezbaPod80DleObmyti;
          post;
         end;
       end;
     end;
   end;
 end;


procedure VytvorPhs_Pom(LesniCelek:TLesniCelek;kamDir:string);
 var
   phsTx :textfile;
   i,Ivek,Pvek,ip:integer;
   konec,prvne:boolean;
   ZkrDrev1,ZkrDrev2,ZkrDrev3,Ktg_ZvlSt1,Ktg_ZvlSt2,Ktg_ZvlSt3:string;

  begin
   try
   assignfile (phsTx,kamDir+'\PHS.POM');
   rewrite(phsTx);
   except
    showmessage(' PHS.POM ponechn pvodn.');
    exit;
   end;
   writeln(phsTx,'           Pestebni a tezebni zasahy na jednotlivych hospodarskych souborech');
   writeln(phsTx,'');
   writeln(phsTx,'Ŀ');
   writeln(phsTx,'hosp. forma     1        2        3        4        5        6        7        8        9        10       11       12       13      14       15       16       17        18      19       20       21    ');
   writeln(phsTx,'soub.hosp.zp                                                                                                                                                                        ');
   with  LesniCelek.CiselOrbis.cisHsMN do
    begin
     for i:=0 to count-1 do
      begin
       writeln(phsTx,'Ĵ');
       with TcisHs(elements[i]) do
        begin
         write(phsTx,
         ''+DoplnZePreduZnakem1(intToStr(CISLO_HS),5,' ')+
         ''+DoplnZePreduZnakem1(intToStr(HOSP_ZP),4,' ')+'   ');
         for iVek:=1 to 42 do
          begin
           Pvek:=(IVek*5)-2;
           write(phsTx,''+DoplnZePreduZnakem1(zasahDlePHS(Pvek),4,' '));
          end;
         writeln(phsTx,'');
        end;
      end;
    end;
   writeln(phsTx,'');
   writeln(phsTx,'');
   writeln(phsTx,'                            Prehled hospodarskych souboru');
   writeln(phsTx,'Ŀ');
   writeln(phsTx,'Stanovistniextremni     exponovana           kysela              zivna          oglejena   podmacena  luzni  ');
   writeln(phsTx,'   rada     J,X,Y,Z     C/W/,N,A,F           M,K,I               S,B,H,D         V,O,P,Q     T,G,R     L,U   ');
   writeln(phsTx,'Ĵ');
   with  LesniCelek.CiselOrbis.LesTypPhsMN do
    begin
     for i:=0 to count-1 do
      begin
       with TLesTypPhs(Elements[i]) do
        begin
         write(phsTx,'           ');
         for ip:=0 to 20 do
          begin
           write(phsTx,''+DoplnZePreduZnakem1(FSlLesTyp[ip],4,' '));
          end;
         writeln(phsTx,'')
        end;
      end;
    end;
   with  LesniCelek.CiselOrbis.HospSoubPhsMN do
    begin
     for i:=0 to count-1 do
      begin
       with THospSoubPhs(elements[i]) do
        begin
         writeln(phsTx,'Ĵ');
         write  (phsTx,''+DoplnZePreduZnakem1(intToStr(CisRad1),6,' ')+'     ');
         for ip:=0 to 20 do
          begin
           write(phsTx,''+DoplnZePreduZnakem1(FSlHospSoub[ip],4,' '));
          end;
         writeln(phsTx,'')
        end;
      end;
    end;
   writeln(phsTx,'');
   writeln(phsTx,'');
   writeln(phsTx,'       Dreviny  a  kategorie  pro jednotlive kolonky  prehledu hosp. souboru');
   writeln(phsTx,'Ŀ');
   with  LesniCelek.CiselOrbis.DrKtgPhsMN do
    begin
     for i:=0 to count-1 do
      begin
       prvne:=true;
       with TDrKtgPhs(elements[i]) do
        begin
         Ktg_ZvlSt1:=Ktg_ZvlSt;
         ZkrDrev1  :=ZkrDrev;
         repeat
          konec:=true;
          if length(Ktg_ZvlSt1)>29 then
           begin
            konec:=false;
            rozdelDlePredchazejicihoStringuPozici
              (Ktg_ZvlSt1,',',29,Ktg_ZvlSt2,Ktg_ZvlSt3);
            Ktg_ZvlSt1:=Ktg_ZvlSt3;
           end
          else
           begin
            Ktg_ZvlSt2:=Ktg_ZvlSt1;
            Ktg_ZvlSt1:='';
           end;
          if length(ZkrDrev1)>134 then
           begin
            konec:=false;
            rozdelDlePredchazejicihoStringuPozici
              (ZkrDrev1,',',134,ZkrDrev2,ZkrDrev3);
            ZkrDrev1:=ZkrDrev3;
           end
          else
           begin
            ZkrDrev2:=ZkrDrev1;
            ZkrDrev1:='';
           end;
          if prvne then
           begin
            writeln(phsTx,''+DoplnZePreduZnakem1(inttostr(CisRadku),2,' ')+
                          ''+DoplnZePreduZnakem1(Ktg_ZvlSt2,  29,' ')+
                          ''+DoplnZeZaduZnakem(  ZkrDrev2  , 134,' ')+
                          '');
            prvne:=false;
           end
          else
           begin
            writeln(phsTx,''+DoplnZePreduZnakem1('',2,' ')+
                          ''+DoplnZePreduZnakem1(Ktg_ZvlSt2,  29,' ')+
                          ''+DoplnZeZaduZnakem(  ZkrDrev2  , 134,' ')+
                          '');
           end;
         until Konec;
        end;
       if i<>count-1 then
        begin
         writeln(phsTx,'Ĵ');
        end;
      end;
    end;
   writeln(phsTx,'');
   closefile(phsTx);

   // showmessage('phs Vytvoren');
    //LesniCelek.CiselOrbis.ulozSeDoOrbu(adrPhs);
  end;

procedure VytvorPhs_TXT(LesniCelek:TLesniCelek;kamDir:string);
 var
   phsTx :textfile;
   i,Ivek,Pvek,ip:integer;
   konec,prvne:boolean;
   ZkrDrev1,ZkrDrev2,ZkrDrev3,Ktg_ZvlSt1,Ktg_ZvlSt2,Ktg_ZvlSt3:string;

  begin
   try
   assignfile (phsTx,kamDir+'\PHS.TXT');
   rewrite(phsTx);
   except
    showmessage(' PHS.TXT ponechn pvodn.');
    exit;
   end;
   writeln(phsTx,'           Pestebni a tezebni zasahy na jednotlivych hospodarskych souborech');
   writeln(phsTx,'');
   writeln(phsTx,'');
   // writeln(phsTx,'Ŀ');
   writeln(phsTx,''+chr(9)+'hosp.'+chr(9)+' forma '+chr(9)+'    1    '+chr(9)+'    2    '+chr(9)+'    3    '+chr(9)+'    4    '+chr(9)+'    5    '+chr(9)+'    6    '+chr(9)+'    7    '+chr(9)+'    8    '+chr(9)+'    9    '+chr(9)+'    10   '+chr(9)+'    11   '+chr(9)+'    12   '+chr(9)+'    13   '+chr(9)+'   14    '+chr(9)+'   15    '+chr(9)+'   16    '+chr(9)+'   17    '+chr(9)+'    18   '+chr(9)+'   19    '+chr(9)+'   20    '+chr(9)+'   21    '+chr(9)+'');
   writeln(phsTx,''+chr(9)+'soub.'+chr(9)+'hosp.zp'+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'    '+chr(9)+'');
   with  LesniCelek.CiselOrbis.cisHsMN do
    begin
     for i:=0 to count-1 do
      begin
       //writeln(phsTx,'');
       // writeln(phsTx,'Ĵ');
       with TcisHs(elements[i]) do
        begin
         write(phsTx,
         ''+chr(9)+''+DoplnZePreduZnakem1(intToStr(CISLO_HS),5,' ')+
         ''+chr(9)+''+DoplnZePreduZnakem1(intToStr(HOSP_ZP),4,' ')+'   ');
         for iVek:=1 to 42 do
          begin
           Pvek:=(IVek*5)-2;
           write(phsTx,''+chr(9)+''+DoplnZePreduZnakem1(zasahDlePHS(Pvek),4,' '));
          end;
         writeln(phsTx,''+chr(9)+'');
        end;
      end;
    end;
   // writeln(phsTx,'');
   writeln(phsTx,'');
   writeln(phsTx,'');
   writeln(phsTx,'                            Prehled hospodarskych souboru');
   writeln(phsTx,'');
   // writeln(phsTx,'Ŀ');
   writeln(phsTx,''+chr(9)+'Stanovistni'+chr(9)+'extremni '+chr(9)+'    exponovana     '+chr(9)+'      kysela       '+chr(9)+'       zivna       '+chr(9)+'   oglejena   '+chr(9)+'podmacena'+chr(9)+'  luzni  '+chr(9)+'');
   writeln(phsTx,''+chr(9)+'   rada    '+chr(9)+' J,X,Y,Z '+chr(9)+'    C/W/,N,A,F     '+chr(9)+'      M,K,I        '+chr(9)+'       S,B,H,D     '+chr(9)+'    V,O,P,Q   '+chr(9)+'  T,G,R  '+chr(9)+'   L,U   '+chr(9)+'');
   writeln(phsTx,'');
   // writeln(phsTx,'Ĵ');
   with  LesniCelek.CiselOrbis.LesTypPhsMN do
    begin
     for i:=0 to count-1 do
      begin
       with TLesTypPhs(Elements[i]) do
        begin
         write(phsTx,''+chr(9)+'           ');
         for ip:=0 to 20 do
          begin
           write(phsTx,''+chr(9)+''+DoplnZePreduZnakem1(FSlLesTyp[ip],4,' '));
          end;
         writeln(phsTx,''+chr(9)+'')
        end;
      end;
    end;
   with  LesniCelek.CiselOrbis.HospSoubPhsMN do
    begin
     for i:=0 to count-1 do
      begin
       with THospSoubPhs(elements[i]) do
        begin
         writeln(phsTx,'');
         // writeln(phsTx,'Ĵ');
         write  (phsTx,''+chr(9)+''+DoplnZePreduZnakem1(intToStr(CisRad1),6,' ')+'     ');
         for ip:=0 to 20 do
          begin
           write(phsTx,''+chr(9)+''+DoplnZePreduZnakem1(FSlHospSoub[ip],4,' '));
          end;
         writeln(phsTx,''+chr(9)+'')
        end;
      end;
    end;
   // writeln(phsTx,'');
   writeln(phsTx,'');
   writeln(phsTx,'');
   writeln(phsTx,'       Dreviny  a  kategorie  pro jednotlive kolonky  prehledu hosp. souboru');
   writeln(phsTx,'');
   // writeln(phsTx,'Ŀ');
   with  LesniCelek.CiselOrbis.DrKtgPhsMN do
    begin
     for i:=0 to count-1 do
      begin
       prvne:=true;
       with TDrKtgPhs(elements[i]) do
        begin
         Ktg_ZvlSt1:=Ktg_ZvlSt;
         ZkrDrev1  :=ZkrDrev;
         repeat
          konec:=true;
          if length(Ktg_ZvlSt1)>29 then
           begin
            konec:=false;
            rozdelDlePredchazejicihoStringuPozici
              (Ktg_ZvlSt1,',',29,Ktg_ZvlSt2,Ktg_ZvlSt3);
            Ktg_ZvlSt1:=Ktg_ZvlSt3;
           end
          else
           begin
            Ktg_ZvlSt2:=Ktg_ZvlSt1;
            Ktg_ZvlSt1:='';
           end;
          if length(ZkrDrev1)>134 then
           begin
            konec:=false;
            rozdelDlePredchazejicihoStringuPozici
              (ZkrDrev1,',',134,ZkrDrev2,ZkrDrev3);
            ZkrDrev1:=ZkrDrev3;
           end
          else
           begin
            ZkrDrev2:=ZkrDrev1;
            ZkrDrev1:='';
           end;
          if prvne then
           begin
            writeln(phsTx,''+chr(9)+''+DoplnZePreduZnakem1(inttostr(CisRadku),2,' ')+
                          ''+chr(9)+''+DoplnZePreduZnakem1(Ktg_ZvlSt2,  29,' ')+
                          ''+chr(9)+''+DoplnZeZaduZnakem(  ZkrDrev2  , 134,' ')+
                          ''+chr(9)+'');
            prvne:=false;
           end
          else
           begin
            writeln(phsTx,''+chr(9)+''+DoplnZePreduZnakem1('',2,' ')+
                          ''+chr(9)+''+DoplnZePreduZnakem1(Ktg_ZvlSt2,  29,' ')+
                          ''+chr(9)+''+DoplnZeZaduZnakem(  ZkrDrev2  , 134,' ')+
                          ''+chr(9)+'');
           end;
         until Konec;
        end;
       if i<>count-1 then
        begin
         // writeln(phsTx,'');
         // writeln(phsTx,'Ĵ');
        end;
      end;
    end;
   writeln(phsTx,'');
//   writeln(phsTx,'');
   closefile(phsTx);

   // showmessage('phs Vytvoren');
    //LesniCelek.CiselOrbis.ulozSeDoOrbu(adrPhs);
  end;




procedure zkontrolujPhs_Pom(LesniCelek:TLesniCelek);
var HlHS,i,ip:integer;
    ch :char;
  procedure ZkontrolujKategorii(KtgZvl:string;i:integer);
   var
    konKtgZvl,konKtg,konZvl,konKtg1,konZvl1,konKtg2,konZvl2:string;

    i1,i2:integer;
   begin
    while KtgZvl<>'' do
     begin
      konKtgZvl:=KPrvnimuZnaku(KtgZvl,',');
      i1:=pos(',',KtgZvl);
      if i1>0 then
       begin
        KtgZvl:=OdPrvnihoZnaku(KtgZvl,',');
       end
      else
       begin
        KtgZvl:='';
       end;
      i2:=pos(':',KonKtgZvl);
      if i2>0 then
       begin
        konKtg:=KPrvnimuZnaku(KonKtgZvl,':');
        konZvl:=OdPrvnihoZnaku(KonKtgZvl,':');
       end
      else
       begin
        konKtg:=KonKtgZvl;
        konZvl:='';
       end;
      repeat
      RozdelDlePrvnihoStringu(konKtg,'/',konKtg1,konKtg2);
      if not(JeVCiselniku(LesniCelek.Ciselnik.Tb_Ktg,'Kod',KonKtg1,True,false)) then
        begin
         showmessage('V tabulce kateg. a deviny pro HS na dku '+inttostr(i+1)+' kategorie "'+konKtg+'" nen v selnku kategori.');
        end;
       konktg:=Konktg2;
      until konktg2='';
      if konZvl<>'' then
       begin
        repeat
         RozdelDlePrvnihoStringu(KonZvl,'/',KonZvl1,KonZvl2);
         if not(JeVCiselniku(LesniCelek.Ciselnik.Tb_ZVL_Stat,'Kod',KonZvl1,True,false)) then
          begin
           showmessage('V tabulce kateg. a deviny pro HS na dku '+inttostr(i+1)+' zvltn statut "'+konZvl+'" nen v selnku zvl.st.');
          end;
         konZvl:=KonZvl2;
        until konZvl2='';
       end;
     end;
   end;
  procedure Zkontrolujdreviny(ZkrDrev:string;i:integer);
   var konDr:string;
       i1,iDR:integer;
   begin
    while ZkrDrev<>'' do
     begin
      konDr:=KPrvnimuZnaku(ZkrDrev,',');
      iDR:= CiselneOznaceniDrevinyLHP(LesniCelek.Ciselnik.tb_DrevCis,KonDR);
      if iDR=-1 then
       begin
        showmessage('V tabulce kateg. a deviny pro HS na dku '+inttostr(i+1)+' devina "'+konDr+'" nen v selnku devin.');
       end;
      i1:=pos(',',ZkrDrev);
      if i1>0 then
       begin
        ZkrDrev:=OdPrvnihoZnaku(ZkrDrev,',');
       end
      else
       begin
        ZkrDrev:='';
       end;
     end;
   end;
begin
 with  LesniCelek.CiselOrbis.HospSoubPhsMN do
  begin
   for i:=0 to count-1 do
    begin
     with THospSoubPhs(elements[i]) do
      begin
       for ip:=0 to 20 do
        begin
         FSlHospSoub[ip]:=ubm(FSlHospSoub[ip]);
         if FSlHospSoub[ip]<>'' then
          begin
           try
            HlHS:=strtoint(FSlHospSoub[ip]);
            if not (LesniCelek.CiselOrbis.cisHsMN.HodnotaPropertyExistuje('CISLO_HS',FSlHospSoub[ip])) then
             begin
              showmessage(
               'V tabulce HS na dku '+inttostr(i+1)
                   +' ve sloupeku '+inttostr(ip)
                   +' hodnota '+FSlHospSoub[ip]
                   +' nen obsaena v tabulce zsahy v hosp.souborech');
             end;
           except
            showmessage(
            'V tabulce HS na dku '+inttostr(i+1)
                   +' ve sloupeku '+inttostr(ip)
                   +' hodnota '+FSlHospSoub[ip]+' nen islo.');
           end;
          end;
        end;
      end;
    end;
  end;
 if   LesniCelek.CiselOrbis.HospSoubPhsMN.count
      <>LesniCelek.CiselOrbis.DrKtgPhsMN.count then
  begin
   showmessage('V tabulce HS je jin poet dk ne v tabulce deviny a ktg. pro HS.');
  end;
 with  LesniCelek.CiselOrbis.DrKtgPhsMN do
  begin
   for i:=0 to count-1 do
    begin
     with TDrKtgPhs(elements[i]) do
      begin
       ZkrDrev:=ubm(uppercase(ZkrDrev));
       ZkrDrev:=BezPoslednihoZnaku(ZkrDrev,',');
       Zkontrolujdreviny(ZkrDrev,i);

       DrevPodpur:=ubm(uppercase(DrevPodpur));
       DrevPodpur:=BezPoslednihoZnaku(DrevPodpur,',');
       Zkontrolujdreviny(DrevPodpur,i);

       Ktg_ZvlSt:=ubm(lowercase(Ktg_ZvlSt));
       Ktg_ZvlSt:=BezPoslednihoZnaku(Ktg_ZvlSt,',');
       ZkontrolujKategorii(Ktg_ZvlSt,i);
      end;
    end;
  end;
 with  LesniCelek.CiselOrbis.SpecPodHSPhsMN do
  begin
   for i:=0 to count-1 do
    begin
     with TSpecPodHSPhs(Elements[i]) do
      begin
       MinZastoupHS:=Ubm(MinZastoupHS);
       if MinZastoupHS<>'' then
        begin
         try
          ip:=STRtoInt(MinZastoupHS);
          if ip>100 then showmessage('Min % HS nesm bt vt ne 100. A je "'+MinZastoupHS+'"');
         except
          showmessage('Min % HS mus bt slo nebo przdn znak. A je "'+MinZastoupHS+'".');
         end;
        end;
      end;
    end;
  end;
 with  LesniCelek.CiselOrbis.LesTypPhsMN do
  begin
   for i:=0 to count-1 do
    begin
     with TLesTypPhs(Elements[i]) do
      begin
       for ip:=0 to 20 do
        begin
         FSlLesTyp[ip]:=uppercase(ubm(FSlLesTyp[ip]));
         if FSlLesTyp[ip]='' then continue;
         if length(FSlLesTyp[ip])<2 then
          begin
           showmessage(
            'V tabulce Lesni typy na dku '+inttostr(i+1)
                   +' ve sloupeku '+inttostr(ip)
                   +' hodnota '+FSlLesTyp[ip]+' nen lesn typ.');
           continue;
          end;
         ch:=FSlLesTyp[ip][1];
         if (ch<'0')or (ch>'9') then
          begin
           showmessage(
            'V tabulce Lesni typy na dku '+inttostr(i+1)
                   +' ve sloupeku '+inttostr(ip)
                   +' hodnota '+FSlLesTyp[ip]+' nen lesn typ.');
           continue;
          end;
         ch:=uppercase(FSlLesTyp[ip])[2];
         if (ch<'A')or (ch>'Z') then
          begin
           showmessage(
            'V tabulce Lesni typy na dku '+inttostr(i+1)
                   +' ve sloupeku '+inttostr(ip)
                   +' hodnota '+FSlLesTyp[ip]+' nen lesn typ.');
           continue;
          end;
         if length(FSlLesTyp[ip])<3 then continue;
         ch:=FSlLesTyp[ip][3];
         if (ch<'0')or (ch>'9') then
          begin
           showmessage(
            'V tabulce Lesni typy na dku '+inttostr(i+1)
                   +' ve sloupeku '+inttostr(ip)
                   +' hodnota '+FSlLesTyp[ip]+' nen lesn typ.');
           continue;
          end;
         if length(FSlLesTyp[ip])<4 then continue;
         ch:=uppercase(FSlLesTyp[ip])[4];
         if (ch<>'D') then
          begin
           showmessage(
            'V tabulce Lesni typy na dku '+inttostr(i+1)
                   +' ve sloupeku '+inttostr(ip)
                   +' hodnota '+FSlLesTyp[ip]+' nen lesn typ.');
           continue;
          end;
        end;
      end;
    end;
  end;
 for i:=0 to LesniCelek.CiselOrbis.cisHsMN.Count-1 do
  begin
   with TCisHs(LesniCelek.CiselOrbis.cisHsMN.elements[i]) do
    begin
     if not (HlHSVHospSoubPhsMN(CISLO_HS,
                            LesniCelek.CiselOrbis.HospSoubPhsMN)) then
      begin
       showmessage('Nen chyba jen upozornn. V tabulce zsahy v HS je uveden HS '
                     +inttostr(CISLO_HS)+', kter nen pouit v tabulce HS dle typ');
      end;
    end;
  end;
 SetridCisHS(LesniCelek);
 for i:=0 to LesniCelek.CiselOrbis.cisHsMN.Count-2 do
  begin
   if    TCisHs(LesniCelek.CiselOrbis.cisHsMN.elements[i]).CISLO_HS
       = TCisHs(LesniCelek.CiselOrbis.cisHsMN.elements[i+1]).CISLO_HS then
    begin
     showmessage('Pozor soubor '+inttostr(TCisHs(LesniCelek.CiselOrbis.cisHsMN.elements[i]).CISLO_HS)+' se opakuje 2x.');
    end;
  end;
 showmessage('kontrola provedena');
end;
procedure  DoplnPrvniHSVHospSoubPhsMN(HospSoubPhsMN:THospSoubPhsMN);
var
 i,ip:integer;
 HlHs:string;
 begin
  with  HospSoubPhsMN do
   begin
    for i:=0 to count-1 do
     begin
      with THospSoubPhs(elements[i]) do
       begin
        if FSlHospSoub[0]='' then
         begin
          HlHs:='';
          for Ip:=1 to 20 do
           begin
            if HlHs='' then HlHs:=FSlHospSoub[ip];
           end;
          if HlHs='' then
           begin
            showmessage(
            'V tabulce HS na dku '+inttostr(i+1)+' nen  vyplnn dn HS.');
           end
          else
           begin
            FSlHospSoub[0]:=HlHs;
           end;
         end;
       end;
     end;
   end;
 end;

function  HlHSVHospSoubPhsMN(HlHs:integer;HospSoubPhsMN:THospSoubPhsMN):Boolean;
var
 i,ip:integer;
 begin
  result:=false;
  with HospSoubPhsMN do
   begin
    for i:=0 to count-1 do
     begin
      with THospSoubPhs(elements[i]) do
       begin
        for ip:=0 to 20 do
         begin
          if strtoint0(FSlHospSoub[ip])=HlHs then
           begin
            result:=true;
           end;
         end;
       end;
     end;
   end;
 end;

procedure  SmazHSVHospSoubPhsMN(mazanyHs:integer;HospSoubPhsMN:THospSoubPhsMN);
var
 i,ip:integer;
 begin
  with  HospSoubPhsMN do
   begin
    for i:=0 to count-1 do
     begin
      with THospSoubPhs(elements[i]) do
       begin
        for ip:=0 to 20 do
         begin
          if strtoint0(FSlHospSoub[ip])=mazanyHs then
           begin
            FSlHospSoub[ip]:='';
           end;
         end;
       end;
     end;
   end;
 end;
procedure SetridCisHS(LesniCelek:TLesniCelek);
 begin
  LesniCelek.CiselOrbis.cisHsMN.setridPodlePropertyLongInt('CISLO_HS',true);
 end;
end.
