unit UTab_Odd;

interface
uses Sp_OznBz,E_LesOdd,ELesObec,Elements,LesRecur,mat1,
     db,dialogs,dbtables,SysUtils,IniFiles;
type

TZpusobNaplneni=(ZRadkuTabulky,Konstantou,PolozkamaVyberu_idetifikatorem);

TTabulkuDoOdd = class(TOwnerEntity)
private
 FTabHodnot:TDataset;
 FLOdd:TOddeleni;
 FCestaNaIniFile:String;
 FCestaNaTabulku:String;
 FPolozkyVyberuSection:String;
 FpodminkypolozekVyberuSection:String;
 FplnenePolozkyVObjektechSection:String;
 FnaplneniPolozekSection:String;
 FPredpisPolozkyVyberu:TLesniStringListElement;
 FPredpispodminkypolozekVyberu:TLesniStringListElement;
 FPredpisplnenePolozkyVObjektech:TLesniStringListElement;
 FPredpisnaplneniPolozek:TLesniStringListElement;
 FPredpisZpusobuNaplneniPolozek:TLesniStringListElement;
 FKopirovatSkupinyPodleTabulky:boolean;
public
 property PredpisnaplneniPolozek:TLesniStringListElement read FPredpisnaplneniPolozek write FPredpisnaplneniPolozek;
 function PolozkyVyberuVTabulce(nameObjektu:String):String;
 procedure nactiZIniFile;
 function  UpravPredpisNaplneniPolozek:Boolean;
 procedure napln(ZpusobNaplneni:TZpusobNaplneni;VkolikNacist:TKolikNacist;SDil,SPor,SPsk:String);
 procedure NaplnZCeleTabulky;
 procedure vymazOddeleniTake;
 function  JeVsechnoVPoradku:Boolean;
 function  EntitaVyhovuje(ZpusobNaplneni:TZpusobNaplneni;VEntita:TOwnerEntity;SObjekt:String):Boolean;
 function  vyhovujiciEntita(MN:TLesniMnozina;SObjekt:String):TOwnerEntity;
 procedure EntituZmenDlePredpisuNaplneni(ZpusobNaplneni:TZpusobNaplneni;VEntita:TOwnerEntity;SObjekt:String);
 procedure EntituZmenDlePredpisu(ZpusobNaplneni:TZpusobNaplneni;VEntita:TOwnerEntity;SObjekt:String;
                                              VPredpisPlnenePolozkyVObjektech,VPredpisnaplneniPolozek:TLesniStringListElement);
 procedure vytvorEntituPodleRadkuTabulky(UrPlneni:TUrovenPlneni);
 procedure vytvorVOddBezlesiJineOstatni(VKolikNacist:TKolikNacist);
 property  KopirovatSkupinyPodleTabulky:boolean read FKopirovatSkupinyPodleTabulky write FKopirovatSkupinyPodleTabulky;
published
 property TabHodnot:TDataset read FTabHodnot write FTabHodnot;
 property LOdd:TOddeleni read FLOdd write FLOdd;
 property cestaNaIniFile:String read FcestaNaIniFile write FcestaNaIniFile;
 property cestaNaTabulku:String read FcestaNaTabulku write FcestaNaTabulku;
 property PolozkyVyberuSection:String read FPolozkyVyberuSection write FPolozkyVyberuSection;
 property podminkypolozekVyberuSection:String read FpodminkypolozekVyberuSection write FpodminkypolozekVyberuSection;
 property naplneniPolozekSection:String read FnaplneniPolozekSection write FnaplneniPolozekSection;
 property plnenePolozkyVObjektechSection:String read FplnenePolozkyVObjektechSection write FplnenePolozkyVObjektechSection;
end;

implementation
uses U_String;

function TTabulkuDoOdd.UpravPredpisNaplneniPolozek:Boolean;
var i,posI:integer;
    s,sChyb:string;
 begin
  result:=true;
   for i:=0 to FPredpisPlnenePolozkyVObjektech.StringListElement.count-1 do
    begin
     try
      sChyb:='I='+inttostr(I);
     //showmessage('cai I='+inttostr(I));
     with FPredpisPlnenePolozkyVObjektech.StringListElement do
      begin
       // showmessage('cai UpperNames[i]='+UpperNames[i]);
       Names[i]:=UBM(UpperNames[i]);
       sChyb:=sChyb+'Names='+Names[i];
       // showmessage('cai Names[i]='+Names[i]);
      end;
     with FPredpisNaplneniPolozek.StringListElement do
      begin
       s:=UBM(uppercase(Strings[i]));
       // showmessage('cai S='+S);
       sChyb:=sChyb+' S='+S;
       posI:=pos(':',s);
       strings[i]:=copy(s,posI+1,length(S)-posI);
       sChyb:=sChyb+' strings='+strings[i];
       // showmessage('cai strings[i]='+strings[i]);
      end;
     with FPredpisZpusobuNaplneniPolozek.StringListElement do
      begin
       strings[i]:=copy(s,1,posI-1);
       //showmessage('cai NAPL strings[i]='+strings[i]);
       if (posI=0) then
        begin
         strings[i]:='TAB_FIELD';
        end;
       result:=false;
       //showmessage('cai RESULT strings[i]='+strings[i]);
       if strings[i]='TAB_FIELD' then result:=True;
       if strings[i]='CONST' then result:=True;
       if strings[i]='SUM' then result:=True;
       if not result then
        begin
          showmessage('V souboru '+FCestaNaIniFile
          +', na prav stran sekce '
          +naplneniPolozekSection
          +' je u poloky "'
          +NAMES[i]

          +'" ped dvojtekou nesmysln daj "'
          +Strings[i]
          +'". Me bt jen TAB_FIELD,CONST,SUM.');
        end;
        schyb:=schyb+ ' hot='+strings[i];
      end;
     except
      showmessage('Chyba v P0110nac.ini' +Schyb);
      result:=false;
      exit;
     end;
    end;
end;


procedure TTabulkuDoOdd.nactiZIniFile;
var
  ini:TIniFile;
 begin
   ini:=Tinifile.create(cestaNaIniFile);
   KopirovatSkupinyPodleTabulky:=
             StrToBool1(ini.readString('KopirovatSkupinyPodleTabulky','KopirovatSkupiny','NE'));
   NactiSeznamIniFile(FPredpisPolozkyVyberu            ,cestaNaIniFile,PolozkyVyberuSection           );
   NactiSeznamIniFile(FPredpispodminkypolozekVyberu    ,cestaNaIniFile,podminkypolozekVyberuSection   );
   NactiSeznamIniFile(FPredpisplnenePolozkyVObjektech  ,cestaNaIniFile,plnenePolozkyVObjektechSection );
   NactiSeznamIniFile(FPredpisNaplneniPolozek          ,cestaNaIniFile,naplneniPolozekSection         );
   NactiSeznamIniFile(FPredpisZpusobuNaplneniPolozek   ,cestaNaIniFile,naplneniPolozekSection         );
 end;
function Vyhovuje(Co,Cemu:String):Boolean;
 begin
  if ubm(uppercase(Co))=ubm(uppercase(Cemu)) then result:=true else result:=false;
 end;
procedure TTabulkuDoOdd.EntituZmenDlePredpisuNaplneni(ZpusobNaplneni:TZpusobNaplneni;VEntita:TOwnerEntity;SObjekt:String);
begin
 EntituZmenDlePredpisu(ZpusobNaplneni,VEntita,SObjekt,FPredpisPlnenePolozkyVObjektech,FPredpisnaplneniPolozek);
end;

procedure TTabulkuDoOdd.EntituZmenDlePredpisu(ZpusobNaplneni:TZpusobNaplneni;VEntita:TOwnerEntity;SObjekt:String;
                                              VPredpisPlnenePolozkyVObjektech,VPredpisnaplneniPolozek:TLesniStringListElement);
var i:integer;
    s:string;
    SName:String;
    ext1,ext2: extended;
 begin
  with VPredpisPlnenePolozkyVObjektech.StringListElement do
   begin
   { if ubm(TabHodnot.FieldByName('Poznamka').asstring)<>'' then
     begin
      showmessage('cau  '+ TabHodnot.FieldByName('Poznamka').asstring);
     end;   }
    for i:=0 to count-1 do
     begin
      sName:=UBM(UpperNames[i]);
      if sName=SObjekt then
       begin
        case ZpusobNaplneni of
         Konstantou:
           begin
            if FPredpisZpusobuNaplneniPolozek.StringListElement.Strings[i]='CONST' then
             begin
              s:=VPredpisnaplneniPolozek.StringListElement.Strings[i];
              VEntita.SetPropertyStringByName(Strings[i],s);
             end;
            if FPredpisZpusobuNaplneniPolozek.StringListElement.Strings[i]='SUM' then
             begin
              if Strings[i]='PridejCislo_TEL' then
               begin
                VEntita.SetPropertyStringByName(Strings[i],'VymazVse');
               end
              else
               begin
                VEntita.SetPropertyStringByName(Strings[i],'0');
               end;
             end;
           end;
         ZRadkuTabulky:
           begin
            if FPredpisZpusobuNaplneniPolozek.StringListElement.Strings[i]='TAB_FIELD' then
             begin
              s:=TabHodnot.FieldByName(VPredpisnaplneniPolozek.StringListElement.Strings[i]).asstring;
              VEntita.SetPropertyStringByName(Strings[i],s);
             end;
            if FPredpisZpusobuNaplneniPolozek.StringListElement.Strings[i]='SUM' then
             begin
              if Strings[i]='PridejCislo_TEL' then
               begin
                s:=TabHodnot.FieldByName(VPredpisnaplneniPolozek.StringListElement.Strings[i]).asstring;
                VEntita.SetPropertyStringByName(Strings[i],s);
               end
              else
               begin
                s:=TabHodnot.FieldByName(VPredpisnaplneniPolozek.StringListElement.Strings[i]).asstring;
                ext1:=StrToExtended(s);
                s:=VEntita.GetPropertyStringByName(Strings[i]);
                ext2:=StrToExtended(s);
                s:=floatToStr(ext1+ext2);
                VEntita.SetPropertyStringByName(Strings[i],s);
               end;
             end;
           end;
          PolozkamaVyberu_idetifikatorem:
           begin
              s:=TabHodnot.FieldByName(VPredpisnaplneniPolozek.StringListElement.Strings[i]).asstring;
              VEntita.SetPropertyStringByName(Strings[i],s);
           end;
         end;{case}

       end;
     end;
   end;
 end;
function TTabulkuDoOdd.vyhovujiciEntita(MN:TLesniMnozina;SObjekt:String):TOwnerEntity;
var i:integer;
 begin
  result:=nil;
  for i:=0 to MN.count-1 do
   begin
    if EntitaVyhovuje(PolozkamaVyberu_idetifikatorem,TOwnerEntity(MN.elements[i]),sObjekt) then
     begin
      result:=TOwnerEntity(MN.elements[i]);
     end;
   end;
 end;
function TTabulkuDoOdd.EntitaVyhovuje(ZpusobNaplneni:TZpusobNaplneni;VEntita:TOwnerEntity;SObjekt:String):Boolean;
var i:integer;
 begin
  result:=true;
  if ZpusobNaplneni=konstantou then exit;
  with FPredpisPolozkyVyberu.StringListElement do
   begin
    result:=true;
    for i:=0 to count-1 do
     begin
      if UpperNames[i]=SObjekt then
       begin
        if not vyhovuje(VEntita.GetPropertyStringByName(Strings[i]),
             TabHodnot.FieldByName(FPredpispodminkypolozekVyberu.StringListElement.Strings[i]).asstring)
        then
         begin
          result:=false;
          exit;
         end;
       end;
     end;
   end;
 end;
procedure TTabulkuDoOdd.naplnZCeleTabulky;
 begin
  TabHodnot.first;
  while not TabHodnot.eof do
   begin
    napln(ZRadkuTabulky,nacOddeleni,'','','');  // Je to jedno,  je to tam jenom kvuli plneni konstantou
    TabHodnot.next;
   end;
  if KopirovatSkupinyPodleTabulky then
   begin
    vymazOddeleniTake;
   end;
 end;
procedure TTabulkuDoOdd.vymazOddeleniTake;
var
 VDil:TDilec;
 VPorSkup:TPorostniSkupina;
 iDil,iPor,IPsk,IPos1,IPos:integer;
 S1:string;
 begin
  for idil:=0 to LOdd.dilecMN.count-1 do
   begin
    VDil:=TDilec(LOdd.DilecMN.elements[idil]);
    for iPor:=0 to VDil.PorostMN.count-1 do
     begin
      for IPsk:=0 to VDil.IPorost[iPor].porostniskupinaMN.Count-1 do
       begin
        VPorSkup:=VDil.IPorost[iPor].Iporostniskupina[Ipsk];
        IPos:=Pos('tak::',lowercase(VPorSkup.PSK_TEXT));
        if IPos=0 then
         begin
          IPos:=Pos('take::',lowercase(VPorSkup.PSK_TEXT));
         end;
        IPos:=IPos;
        if iPos>0 then
         begin
          S1:=copy(VPorSkup.PSK_TEXT,IPos,length(VPorSkup.PSK_TEXT)-IPos+1);
          IPos1:=Pos(';',S1);
          IPos1:=IPos1+iPos;
          VPorSkup.PSK_TEXT:=   copy(VPorSkup.PSK_TEXT,1,IPos-1)
              + copy(VPorSkup.PSK_TEXT,IPos1,length(VPorSkup.PSK_TEXT)-IPos1+1);
         end;
       end;
     end;
   end;
 end;
procedure TTabulkuDoOdd.vytvorEntituPodleRadkuTabulky(UrPlneni:TUrovenPlneni);
var Aktual:TOwnerEntity;
    Field1:string;
 begin
  if not EntitaVyhovuje(ZRadkuTabulky,LOdd,'ODDELENI') then  exit;
  with LOdd do
   begin
    if PrvniJeNadDruhymNeboStejny(PoDilec,UrPlneni) then
    // if UrPlneni<=PoDilec then
     begin
      Aktual:=vyhovujiciEntita(DilecMN,'DILEC');
      if Aktual=nil then
       begin
        Field1:=KPrvnimuZnaku(PolozkyVyberuVTabulce('DILEC'),',');
        if TabHodnot.FindField(Field1)<>nil then
         begin
          DilecMN.NovyPrvekVzdy:=TabHodnot.FieldByName(Field1).asstring;
          Dilec.DIL:=TabHodnot.FieldByName(Field1).asstring;
         end
        else
         begin
          DilecMN.NovyPrvekVzdy:='-';
          Dilec.DIL:='-';
         end;
        EntituZmenDlePredpisu(PolozkamaVyberu_idetifikatorem,dilec,'DILEC',
              FPredpisPolozkyVyberu,FPredpispodminkypolozekVyberu);
       end
      else
       begin
        DilecMN.AktualniPrvek:=Aktual;
       end;
     end;
   end;
  with LOdd.dilec do
   begin
    if PrvniJeNadDruhymNeboStejny(PoPorost,UrPlneni) then
     begin
      Aktual:=vyhovujiciEntita(PorostMN,'POROST');
      if Aktual=nil then
       begin
        Field1:=KPrvnimuZnaku(PolozkyVyberuVTabulce('POROST'),',');
        if TabHodnot.FindField(Field1)<>nil then
         begin
          PorostMN.NovyPrvekVzdy:=TabHodnot.FieldByName(Field1).asstring;
          porost.POR:=TabHodnot.FieldByName(Field1).asstring;
         end
        else
         begin
          PorostMN.NovyPrvekVzdy:='-';
          porost.POR:='-';
         end;
        EntituZmenDlePredpisu(PolozkamaVyberu_idetifikatorem,Porost,'Porost',
              FPredpisPolozkyVyberu,FPredpispodminkypolozekVyberu);
       end
      else
       begin
        porostMN.AktualniPrvek:=Aktual;
       end;
     end;
   end;
  with LOdd.dilec.porost do
   begin
    if PrvniJeNadDruhymNeboStejny(PoBezlesi,UrPlneni) then
     begin
      Aktual:=vyhovujiciEntita(BezlesiMN,'BEZLESI');
      if Aktual=nil then
       begin
        Field1:=KPrvnimuZnaku(PolozkyVyberuVTabulce('BEZLESI'),',');
        if TabHodnot.FindField(Field1)<>nil then
          BezlesiMN.NovyPrvekVzdy:=TabHodnot.FieldByName(Field1).asstring
        else BezlesiMN.NovyPrvekVzdy:='-';
        EntituZmenDlePredpisu(PolozkamaVyberu_idetifikatorem,Bezlesi,'BEZLESI',
              FPredpisPolozkyVyberu,FPredpispodminkypolozekVyberu);
       end
      else
       begin
        BezlesiMN.AktualniPrvek:=Aktual;
       end;
     end;
    if PrvniJeNadDruhymNeboStejny(PoJine,UrPlneni) then
     begin
      Aktual:=vyhovujiciEntita(JinyPozemekMN,'JINYPOZEMEK');
      if Aktual=nil then
       begin
        Field1:=KPrvnimuZnaku(PolozkyVyberuVTabulce('JINYPOZEMEK'),',');
        if TabHodnot.FindField(Field1)<>nil then
          JinyPozemekMN.NovyPrvekVzdy:=TabHodnot.FieldByName(Field1).asstring
        else JinyPozemekMN.NovyPrvekVzdy:='-';
        EntituZmenDlePredpisu(PolozkamaVyberu_idetifikatorem,JinyPozemek,'JINYPOZEMEK',
              FPredpisPolozkyVyberu,FPredpispodminkypolozekVyberu);
       end
      else
       begin
        JinyPozemekMN.AktualniPrvek:=Aktual;
       end;
     end;
    if PrvniJeNadDruhymNeboStejny(PoOstatni,UrPlneni) then
     begin
      Aktual:=vyhovujiciEntita(OstatniMN,'OSTATNI');
      if Aktual=nil then
       begin
        Field1:=KPrvnimuZnaku(PolozkyVyberuVTabulce('OSTATNI'),',');
        if TabHodnot.FindField(Field1)<>nil then
          OstatniMN.NovyPrvekVzdy:=TabHodnot.FieldByName(Field1).asstring
        else OstatniMN.NovyPrvekVzdy:='-';
        EntituZmenDlePredpisu(PolozkamaVyberu_idetifikatorem,Ostatni,'OSTATNI',
              FPredpisPolozkyVyberu,FPredpispodminkypolozekVyberu);
       end
      else
       begin
        OstatniMN.AktualniPrvek:=Aktual;
       end;
     end;
   end;
 end;
procedure TTabulkuDoOdd.napln(ZpusobNaplneni:TZpusobNaplneni;VkolikNacist:TKolikNacist;SDil,SPor,SPsk:String);
var IDil,IPor,IPsk,IEt,IDr,IPosk,IBzl,IJine,IOst,i:integer;
    entitaVyhovela:Boolean;
    hl_PSK:string;
    existujeJenJednaPSK:boolean;
    chyba1:Boolean;
    Vzor_PSK,NovaPSK:TPorostniSkupina;
 begin
  if KopirovatSkupinyPodleTabulky then
   begin
    if FTabHodnot.FindField(FPredpispodminkypolozekVyberu.StringListElement.GetStringByName('PSK'))=nil then
     begin
      KopirovatSkupinyPodleTabulky:=false;
     end;
   end;
  if not EntitaVyhovuje(ZpusobNaplneni,LOdd,'ODDELENI') then  exit;
  EntituZmenDlePredpisuNaplneni(ZpusobNaplneni,LOdd,'ODDELENI');
  with LOdd do
   begin
    for Idil:=0 to DilecMN.count-1 do
     begin
      if VkolikNacist in [nacDilec,nacPorost,NacSkupinu] then
       begin
        if IDilec[idil].DIL<> SDil then continue;
       end;
      if not EntitaVyhovuje(ZpusobNaplneni,TDilec(DilecMN.elements[idil]),'DILEC') then continue;
      EntituZmenDlePredpisuNaplneni(ZpusobNaplneni,TDilec(DilecMN.elements[idil]),'DILEC');
      with TDilec(DilecMN.elements[idil]) do
       begin
        for IPor:=0 to PorostMN.count-1 do
         begin
          if VkolikNacist in [nacPorost,NacSkupinu] then
           begin
            if IPorost[iPor].POR<> sPOR then continue;
           end;
          if not EntitaVyhovuje(ZpusobNaplneni,TPorost(PorostMN.elements[iPor]),'POROST') then  continue;
          EntituZmenDlePredpisuNaplneni(ZpusobNaplneni,TPorost(PorostMN.elements[iPor]),'POROST');
          with TPorost(PorostMN.elements[iPor]) do
           begin
            if KopirovatSkupinyPodleTabulky then
             begin
              entitaVyhovela:=false;
              for IPsk:=0 to PorostniSkupinaMN.count-1 do
               begin
                if VkolikNacist in [NacSkupinu] then
                  begin
                   if IPorostniSkupina[iPsk].PSK<> sPSK then continue;
                  end;
                if EntitaVyhovuje(ZpusobNaplneni,TPorostniSkupina(PorostniSkupinaMN.elements[iPsk]),'POROSTNISKUPINA') then
                 begin
                  entitaVyhovela:=true;
                 end;
               end;
              if not entitaVyhovela then
               begin
                for Ibzl:=0 to BezlesiMN.count-1 do
                 begin
                  if  EntitaVyhovuje(ZpusobNaplneni,TBezlesi(BezlesiMN.elements[iBzl]),'BEZLESI') then
                   begin
                    entitaVyhovela:=true;
                   end;
                 end;
               end;
              if not entitaVyhovela then
               begin
                for IJine:=0 to JinyPozemekMN.count-1 do
                 begin
                  if EntitaVyhovuje(ZpusobNaplneni,TJinyPozemek(JinyPozemekMN.elements[iJine]),'JINYPOZEMEK') then
                   begin
                    entitaVyhovela:=true;
                   end;
                 end;
               end;
              if not entitaVyhovela then
               begin
                for IOst:=0 to OstatniMN.count-1 do
                 begin
                  if EntitaVyhovuje(ZpusobNaplneni,TOstatni(OstatniMN.elements[iOst]),'OSTATNI') then
                   begin
                    entitaVyhovela:=true;
                   end;
                 end;
               end;
              if not entitaVyhovela then
               begin
                hl_PSK:=FTabHodnot.FindField(FPredpispodminkypolozekVyberu.StringListElement.GetStringByName('PSK')).asstring;
                Vzor_PSK:=PorostMN.VzorovaPSK(hl_PSK,existujeJenJednaPSK,chyba1);
                if Vzor_PSK<>nil then
                 begin
                  NovaPSK:=Vzor_PSK.KopiePorostniSkupiny;
                  NovaPSK.name :=hl_PSK;
                  NovaPSK.PSK  :=hl_PSK;
                  PorostniSkupinaMN.AddElement(NovaPSK);
                 end;
               end;
             end;
            for IPsk:=0 to PorostniSkupinaMN.count-1 do
             begin
                if VkolikNacist in [NacSkupinu] then
                  begin
                   if IPorostniSkupina[iPsk].PSK<> sPSK then continue;
                  end;
              if not EntitaVyhovuje(ZpusobNaplneni,TPorostniSkupina(PorostniSkupinaMN.elements[iPsk]),'POROSTNISKUPINA') then  continue;
              EntituZmenDlePredpisuNaplneni(ZpusobNaplneni,TPorostniSkupina(PorostniSkupinaMN.elements[iPsk]),'POROSTNISKUPINA');
              with TPorostniSkupina(PorostniSkupinaMN.elements[iPsk]) do
               begin
                for IEt:=0 to EtazMN.count-1 do
                 begin
                  if not EntitaVyhovuje(ZpusobNaplneni,TEtaz(EtazMN.elements[iEt]),'ETAZ') then  continue;
                  EntituZmenDlePredpisuNaplneni(ZpusobNaplneni,TEtaz(EtazMN.elements[iEt]),'ETAZ');
                  with TEtaz(EtazMN.elements[iEt]) do
                   begin
                    for IDr:=0 to DrevinaMN.count-1 do
                     begin
                      if not EntitaVyhovuje(ZpusobNaplneni,TDrevina(DrevinaMN.elements[IDr]),'DREVINA') then  continue;
                      EntituZmenDlePredpisuNaplneni(ZpusobNaplneni,TDrevina(DrevinaMN.elements[IDr]),'DREVINA');
                      with TDrevina(DrevinaMN.elements[IDr]) do
                       begin
                        for IPosk:=0 to PoskozeniMN.count-1 do
                         begin
                          if not EntitaVyhovuje(ZpusobNaplneni,TPoskozeni(PoskozeniMN.elements[iPosk]),'POSKOZENI') then  continue;
                          EntituZmenDlePredpisuNaplneni(ZpusobNaplneni,TPoskozeni(PoskozeniMN.elements[iPosk]),'POSKOZENI');
                          with TPoskozeni(PoskozeniMN.elements[iPosk]) do
                           begin

                           end;
                         end;
                       end;
                     end;
                   end;
                 end;
               end;
             end;
            for Ibzl:=0 to BezlesiMN.count-1 do
             begin
              if not EntitaVyhovuje(ZpusobNaplneni,TBezlesi(BezlesiMN.elements[iBzl]),'BEZLESI') then  continue;
              EntituZmenDlePredpisuNaplneni(ZpusobNaplneni,TBezlesi(BezlesiMN.elements[iBzl]),'BEZLESI');
              with TBezlesi(BezlesiMN.elements[iBzl]) do
               begin
               end;
             end;
            for IJine:=0 to JinyPozemekMN.count-1 do
             begin
              if not EntitaVyhovuje(ZpusobNaplneni,TJinyPozemek(JinyPozemekMN.elements[iJine]),'JINYPOZEMEK') then  continue;
              EntituZmenDlePredpisuNaplneni(ZpusobNaplneni,TJinyPozemek(JinyPozemekMN.elements[iJine]),'JINYPOZEMEK');
              with TJinyPozemek(JinyPozemekMN.elements[iJine]) do
               begin
               end;
             end;
            for IOst:=0 to OstatniMN.count-1 do
             begin
              if not EntitaVyhovuje(ZpusobNaplneni,TOstatni(OstatniMN.elements[iOst]),'OSTATNI') then  continue;
              EntituZmenDlePredpisuNaplneni(ZpusobNaplneni,TOstatni(OstatniMN.elements[iOst]),'OSTATNI');
              with TOstatni(OstatniMN.elements[iOst]) do
               begin
               end;
             end;
           end;
         end;
       end;
     end;
   end;
 end;


procedure  propertaOdpovidaObjektu(SProperta,SObjekt:String;var jeObjekt,propertaOdpovida:Boolean);
var
    APoskozeni  :TPoskozeni;
    ADrevina    :TDrevina;
    AEtaz       :TEtaz;
    AZalesneni  :TZalesneni;
    APorostniSkupina:TPorostniSkupina;
    APorost     :TPorost;
    ADilec      :TDilec;
    AOddeleni   :TOddeleni;
    ABezlesi    :TBezlesi;
    AJinyPozemek:TJinyPozemek;
    AOstatni    :TOstatni;
 begin
  jeObjekt:=false;
  propertaOdpovida:=false;
  SObjekt:=ubm(uppercase(SObjekt));
      if 'ODDELENI'=SObjekt then
       begin
        jeObjekt:=true;
        AOddeleni:=TOddeleni.create;
        propertaOdpovida:=AOddeleni.HasPropertyByName(SProperta);
        AOddeleni.free;
       end;
      if 'DILEC'=SObjekt then
       begin
        jeObjekt:=true;
        ADilec:=TDilec.create;
        propertaOdpovida:=ADilec.HasPropertyByName(SProperta);
        ADilec.free;
       end;
      if 'POROST'=SObjekt then
       begin
        jeObjekt:=true;
        APorost:=TPorost.create;
        propertaOdpovida:=APorost.HasPropertyByName(SProperta);
        APorost.free;
       end;
      if 'POROSTNISKUPINA'=SObjekt then
       begin
        jeObjekt:=true;
        APorostniSkupina:=TPorostniSkupina.create;
        propertaOdpovida:=APorostniSkupina.HasPropertyByName(SProperta);
        APorostniSkupina.free;
       end;
      if 'BEZLESI'=SObjekt then
       begin
        jeObjekt:=true;
        ABezlesi:=TBezlesi.create;
        propertaOdpovida:=ABezlesi.HasPropertyByName(SProperta);
        ABezlesi.free;
       end;
      if 'JINYPOZEMEK'=SObjekt then
       begin
        jeObjekt:=true;
        AJinyPozemek:=TJinyPozemek.create;
        propertaOdpovida:=AJinyPozemek.HasPropertyByName(SProperta);
        AJinyPozemek.free;
       end;
      if 'OSTATNI'=SObjekt then
       begin
        jeObjekt:=true;
        AOstatni:=TOstatni.create;
        propertaOdpovida:=AOstatni.HasPropertyByName(SProperta);
        AOstatni.free;
       end;
      if 'ETAZ'=SObjekt then
       begin
        jeObjekt:=true;
        AEtaz:=TEtaz.create;
        propertaOdpovida:=AEtaz.HasPropertyByName(SProperta);
        AEtaz.free;
       end;
      if 'ZALESNENI'=SObjekt then
       begin
        jeObjekt:=true;
        AZalesneni:=TZalesneni.create;
        propertaOdpovida:=AZalesneni.HasPropertyByName(SProperta);
        AZalesneni.free;
       end;
      if 'DREVINA'=SObjekt then
       begin
        jeObjekt:=true;
        ADrevina:=TDrevina.create;
        propertaOdpovida:=ADrevina.HasPropertyByName(SProperta);
        ADrevina.free;
       end;
      if 'POSKOZENI'=SObjekt then
       begin
        jeObjekt:=true;
        APoskozeni:=TPoskozeni.create;
        propertaOdpovida:=APoskozeni.HasPropertyByName(SProperta);
        APoskozeni.free;
       end;
 end;

function  TTabulkuDoOdd.JeVsechnoVPoradku:Boolean;
var i:integer;
    jeObjekt,propertaOdpovida:Boolean;
 begin
  result:=true;
  with FPredpisPolozkyVyberu.StringListElement do
   begin
    for i:=0 to count-1 do
     begin
      propertaOdpovidaObjektu(Strings[i],Names[i],jeObjekt,propertaOdpovida);
      if not (jeObjekt) then
         begin
          showmessage('V souboru '+FCestaNaIniFile+ ' sekci '+ FPolozkyVyberuSection
                       +' je na dku '+inttostr(i+1)+' chybn lev strana "'+Names[i]
                       +'". Me bt jen '+
          'ODDELENI,DILEC,POROST,POROSTNISKUPINA,BEZLESI,JINYPOZEMEK,OSTATNI,ETAZ,ZALESNENI,DREVINA,POSKOZENI.');
          result:=False;
          exit;
         end;
      if not (PropertaOdpovida) then
         begin
          showmessage('V souboru '+FCestaNaIniFile+
          ', na prav stran sekce '+FPolozkyVyberuSection
          +' je polozka "'+Strings[i]+'", kter nen dnou lesnicku vlastost prvku '+Names[i]+'.');
          result:=false;
          exit;
         end;
      if  ubm(uppercase(FPredpispodminkypolozekVyberu.StringListElement.Names[i]))<>ubm(uppercase(Strings[i])) then
       begin
        showmessage('V souboru '+FCestaNaIniFile+
                    ' na dku '+inttostr(i+1)+' nen lev strana sekce '+FpodminkyPolozekVyberuSection
                    +' rovna prav stran sekce '+ FPolozkyVyberuSection);
        result:=False;
        exit;
       end;
      if FTabHodnot.FindField(FPredpispodminkypolozekVyberu.StringListElement.strings[i])=nil then
       begin
        showmessage('V souboru '+FCestaNaIniFile
        +', na prav stran sekce '+FpodminkypolozekVyberuSection
        +' je polozka '+FPredpispodminkypolozekVyberu.StringListElement.strings[i]
        +', kter nen v tabulce '+cestaNaTabulku+'.');
        result:=False;
        exit;
       end;
     end;
   end;



  with FPredpisplnenePolozkyVObjektech.StringListElement do
   begin
    for i:=0 to count-1 do
     begin
      propertaOdpovidaObjektu(Strings[i],Names[i],jeObjekt,propertaOdpovida);
      if not (jeObjekt) then
         begin
          showmessage('V souboru '+FCestaNaIniFile+ ' sekci '+ FplnenePolozkyVObjektechSection
                       +' je na dku '+inttostr(i+1)+' chybn lev strana "'+Names[i]
                       +'". Me bt jen '+
          'ODDELENI,DILEC,POROST,POROSTNISKUPINA,BEZLESI,JINYPOZEMEK,OSTATNI,ETAZ,ZALESNENI,DREVINA,POSKOZENI.');
          result:=False;
          exit;
         end;
      if not (PropertaOdpovida) then
         begin
          showmessage('V souboru '+FCestaNaIniFile+
          ', na prav stran sekce '+FplnenePolozkyVObjektechSection
          +' je polozka "'+Strings[i]+'", kter nen dnou lesnicku vlastost prvku '+Names[i]+'.');
          result:=false;
          exit;
         end;

      if  ubm(uppercase(FPredpisNaplneniPolozek.StringListElement.Names[i]))<>ubm(uppercase(Strings[i])) then
       begin
        showmessage('V souboru '+FCestaNaIniFile+
                    ' na dku '+inttostr(i+1)+' nen lev strana sekce '+FNaplneniPolozekSection
                    +' rovna prav stran sekce '+ FplnenePolozkyVObjektechSection);
        result:=False;
        exit;
       end;

   {  if not propertaVubecVOddeleniExistuje(ubm(names[i])) then
       begin
        showmessage('V souboru '+FCestaNaIniFile+
        ', na lev stran sekce '+FnaplneniPolozekSection
        +' je polozka "'+names[i]+'", kter nen dnou lesnicku vlastost.');
        result:=False;
        exit;
       end; }
     if (  (FPredpisZpusobuNaplneniPolozek.StringListElement.Strings[i]='TAB_FIELD')
         or(FPredpisZpusobuNaplneniPolozek.StringListElement.Strings[i]='SUM')
         )
        and(FTabHodnot.FindField(FPredpisNaplneniPolozek.StringListElement.strings[i])=nil)
      then
       begin
        showmessage('V souboru '+FCestaNaIniFile
        +', na prav stran sekce '+FNaplneniPolozekSection
        +' je polozka '+FPredpisNaplneniPolozek.StringListElement.strings[i]+', kter nen v tabulce '+cestaNaTabulku+'.');
        result:=False;
        exit;
       end;
     end;
   end;
 end;
function TTabulkuDoOdd.PolozkyVyberuVTabulce(nameObjektu:String):String;
var I:Integer;
 begin
  nameObjektu:=trim(uppercase(nameObjektu));
  result:='';
  for I:=0 to  FPredpisPolozkyVyberu.StringListElement.count-1 do
   begin
    if trim(uppercase(FPredpisPolozkyVyberu.StringListElement.Names[i]))=nameObjektu then
     begin
      if result<>'' then result:=result+',';
      result:=result+FPredpispodminkypolozekVyberu.StringListElement.Strings[i];
     end;
   end;
 end;

procedure TTabulkuDoOdd.vytvorVOddBezlesiJineOstatni(VKolikNacist:TKolikNacist);
var SVybTab,FieldOdd,FieldDIL,FieldPOR:String;
 begin
 // pro bezlesi
        SVybTab:=PolozkyVyberuVTabulce('ODDELENI');
        SVybTab:=SVybTab+','+PolozkyVyberuVTabulce('DILEC');
        SVybTab:=SVybTab+','+PolozkyVyberuVTabulce('POROST');
        SVybTab:=SVybTab+','+PolozkyVyberuVTabulce('BEZLESI');
        SVybTab:='SELECT DISTINCT '+ SVybTab +' FROM '''+cestaNaTabulku+'''';
        // showmessage(SVybTab);
        TabHodnot.active:=false;
        TQuery(TabHodnot).SQL.Clear;
         TQuery(TabHodnot).SQL.add(SVybTab);
        case VKolikNacist of
         nacOddeleni:begin
                      FieldOdd:=KPrvnimuZnaku(PolozkyVyberuVTabulce('ODDELENI'),',');
                      TQuery(TabHodnot).SQL.add('where '+FieldOdd+'='+inttostr(LOdd.ODD));
                     end;
         // add('where (ODDELENI='+intToStr(ODD)+')');
         nacDilec:begin
                      FieldOdd:=KPrvnimuZnaku(PolozkyVyberuVTabulce('ODDELENI'),',');
                      FieldDIL:=KPrvnimuZnaku(PolozkyVyberuVTabulce('DILEC'),',');
                      TQuery(TabHodnot).SQL.add('where (('+FieldOdd+'='+inttostr(LOdd.ODD)+')and('+FieldDIL+'='''+LOdd.Dilec.DIL+'''))');
                      // showmessage('where (('+FieldOdd+'='+inttostr(LOdd.ODD)+')and('+FieldDIL+'='''+LOdd.Dilec.DIL+'''))');
                  end;

         // add('where ((ODDELENI='+intToStr(ODD)+')and(DILEC='''+DIL+'''))');
         nacPorost:begin
                      FieldOdd:=KPrvnimuZnaku(PolozkyVyberuVTabulce('ODDELENI'),',');
                      FieldDIL:=KPrvnimuZnaku(PolozkyVyberuVTabulce('DILEC'),',');
                      FieldPOR:=KPrvnimuZnaku(PolozkyVyberuVTabulce('POROST'),',');
                      TQuery(TabHodnot).SQL.add('where (('+FieldOdd+'='+inttostr(LOdd.ODD)+')and('+FieldDIL+'='''+LOdd.Dilec.DIL+''')and('+FieldPOR+'='''+LOdd.Dilec.porost.POR+'''))');
                  end;
         //add('where ((ODDELENI='+intToStr(ODD)+')and(DILEC='''+DIL+''')and(POROST='''+POR+'''))');
         NacSkupinu:exit;
        end; //case

        try
        TabHodnot.open;
        while not TabHodnot.eof do
         begin
          if JeBezlesi(TabHodnot.fieldByName('SKUPINA').asstring) then
           begin
             vytvorEntituPodleRadkuTabulky(PoBezlesi);
           end;
          TabHodnot.next;
         end;
        TabHodnot.close;
        except
        end;
 // pro jine
        SVybTab:=PolozkyVyberuVTabulce('ODDELENI');
        SVybTab:=SVybTab+','+PolozkyVyberuVTabulce('DILEC');
        SVybTab:=SVybTab+','+PolozkyVyberuVTabulce('POROST');
        SVybTab:=SVybTab+','+PolozkyVyberuVTabulce('JINYPOZEMEK');
        SVybTab:='SELECT DISTINCT '+ SVybTab +' FROM '''+cestaNaTabulku+'''';
        // showmessage(SVybTab);
        TabHodnot.active:=false;
        TQuery(TabHodnot).SQL.Clear;
         TQuery(TabHodnot).SQL.add(SVybTab);
//        FieldOdd:=KPrvnimuZnaku(PolozkyVyberuVTabulce('ODDELENI'),',');
//         TQuery(TabHodnot).SQL.add('where '+FieldOdd+'='+inttostr(LOdd.ODD));
        case VKolikNacist of
         nacOddeleni:begin
                      FieldOdd:=KPrvnimuZnaku(PolozkyVyberuVTabulce('ODDELENI'),',');
                      TQuery(TabHodnot).SQL.add('where '+FieldOdd+'='+inttostr(LOdd.ODD));
                     end;
         // add('where (ODDELENI='+intToStr(ODD)+')');
         nacDilec:begin
                      FieldOdd:=KPrvnimuZnaku(PolozkyVyberuVTabulce('ODDELENI'),',');
                      FieldDIL:=KPrvnimuZnaku(PolozkyVyberuVTabulce('DILEC'),',');
                      TQuery(TabHodnot).SQL.add('where (('+FieldOdd+'='+inttostr(LOdd.ODD)+')and('+FieldDIL+'='''+LOdd.Dilec.DIL+'''))');
                      // showmessage('where (('+FieldOdd+'='+inttostr(LOdd.ODD)+')and('+FieldDIL+'='''+LOdd.Dilec.DIL+'''))');
                  end;

         // add('where ((ODDELENI='+intToStr(ODD)+')and(DILEC='''+DIL+'''))');
         nacPorost:begin
                      FieldOdd:=KPrvnimuZnaku(PolozkyVyberuVTabulce('ODDELENI'),',');
                      FieldDIL:=KPrvnimuZnaku(PolozkyVyberuVTabulce('DILEC'),',');
                      FieldPOR:=KPrvnimuZnaku(PolozkyVyberuVTabulce('POROST'),',');
                      TQuery(TabHodnot).SQL.add('where (('+FieldOdd+'='+inttostr(LOdd.ODD)+')and('+FieldDIL+'='''+LOdd.Dilec.DIL+''')and('+FieldPOR+'='''+LOdd.Dilec.porost.POR+'''))');
                  end;
         //add('where ((ODDELENI='+intToStr(ODD)+')and(DILEC='''+DIL+''')and(POROST='''+POR+'''))');
         NacSkupinu:exit;
        end; //case
        try
        TabHodnot.open;
        while not TabHodnot.eof do
         begin
          if JeJine(TabHodnot.fieldByName('SKUPINA').asstring) then
           begin
             vytvorEntituPodleRadkuTabulky(PoJine);
           end;
          TabHodnot.next;
         end;
        TabHodnot.close;
        except
        end;
 // pro ostatni
        SVybTab:=PolozkyVyberuVTabulce('ODDELENI');
        SVybTab:=SVybTab+','+PolozkyVyberuVTabulce('DILEC');
        SVybTab:=SVybTab+','+PolozkyVyberuVTabulce('POROST');
        SVybTab:=SVybTab+','+PolozkyVyberuVTabulce('OSTATNI');
        SVybTab:='SELECT DISTINCT '+ SVybTab +' FROM '''+cestaNaTabulku+'''';
        // showmessage(SVybTab);
        TabHodnot.active:=false;
        TQuery(TabHodnot).SQL.Clear;
         TQuery(TabHodnot).SQL.add(SVybTab);
//        FieldOdd:=KPrvnimuZnaku(PolozkyVyberuVTabulce('ODDELENI'),',');
//         TQuery(TabHodnot).SQL.add('where '+FieldOdd+'='+inttostr(LOdd.ODD));
        case VKolikNacist of
         nacOddeleni:begin
                      FieldOdd:=KPrvnimuZnaku(PolozkyVyberuVTabulce('ODDELENI'),',');
                      TQuery(TabHodnot).SQL.add('where '+FieldOdd+'='+inttostr(LOdd.ODD));
                     end;
         // add('where (ODDELENI='+intToStr(ODD)+')');
         nacDilec:begin
                      FieldOdd:=KPrvnimuZnaku(PolozkyVyberuVTabulce('ODDELENI'),',');
                      FieldDIL:=KPrvnimuZnaku(PolozkyVyberuVTabulce('DILEC'),',');
                      TQuery(TabHodnot).SQL.add('where (('+FieldOdd+'='+inttostr(LOdd.ODD)+')and('+FieldDIL+'='''+LOdd.Dilec.DIL+'''))');
                     // showmessage('where (('+FieldOdd+'='+inttostr(LOdd.ODD)+')and('+FieldDIL+'='''+LOdd.Dilec.DIL+'''))');
                  end;

         // add('where ((ODDELENI='+intToStr(ODD)+')and(DILEC='''+DIL+'''))');
         nacPorost:begin
                      FieldOdd:=KPrvnimuZnaku(PolozkyVyberuVTabulce('ODDELENI'),',');
                      FieldDIL:=KPrvnimuZnaku(PolozkyVyberuVTabulce('DILEC'),',');
                      FieldPOR:=KPrvnimuZnaku(PolozkyVyberuVTabulce('POROST'),',');
                      TQuery(TabHodnot).SQL.add('where (('+FieldOdd+'='+inttostr(LOdd.ODD)+')and('+FieldDIL+'='''+LOdd.Dilec.DIL+''')and('+FieldPOR+'='''+LOdd.Dilec.porost.POR+'''))');
                  end;
         //add('where ((ODDELENI='+intToStr(ODD)+')and(DILEC='''+DIL+''')and(POROST='''+POR+'''))');
         NacSkupinu:exit;
        end; //case
        try
        TabHodnot.open;
        while not TabHodnot.eof do
         begin
          if Jeostatni(TabHodnot.fieldByName('SKUPINA').asstring) then
           begin
             vytvorEntituPodleRadkuTabulky(PoOstatni);
           end;
          TabHodnot.next;
         end;
        TabHodnot.close;
        except
        end;
 end;
end.
