unit VypocLetax;

interface

uses forms, sysUtils, dialogs, FileCtrl, Stdctrls, classes, DB, DBTables,
     D_txt, Elements, T_Grp,E_Type, e_KatastrModel,
     mat1, E_lesOdd, ELesObec, E_LesCel, LesCisel, LesCisOR,
     DTBLes98, SP_ovr98, SP_Vyhso,
     excelImpl, UExcelOle, e_LHCModel,
     e_OverlayGeometryElement, UPrevOrb;
type

TPlochovkaParcelyLETAX  = class(TOwnerEntity)
private
 FNOrgUr2 :integer;
 FNKatastr:longint;
 FNparcela:string;
 FNParPod:string;
 FNdruh_poz:integer;
 FNvymera_PK_KN:Double;
 FNOdd      :integer;
 FNDil      :string;
 FNPor      :string;
 FNPSKBzlJpOst:string;
 FNKateg      :String;
 FNporPuda    :Double;
 FNBZL_POZN    :String;
 FNBzlPuda    :Double;
 FNJinpPuda   :Double;
 FNJP_POZN     :String;
 FNOstPuda    :Double;
 Function GetOrgUrKatast:String;

 public
 published
 property NOrgUr2  :integer read FNOrgUr2  write FNOrgUr2;
 property NKatastr:longint read FNKatastr  write FNKatastr;
 property Nparcela:string read FNparcela  write FNparcela;
 property NParPod:string read FNParPod  write FNParPod;
 property Ndruh_poz:integer read FNdruh_poz  write FNdruh_poz;
 property Nvymera_PK_KN:Double read FNvymera_PK_KN  write FNvymera_PK_KN;
 property NOdd      :integer read FNOdd  write FNOdd;
 property NDil      :string read FNDil  write FNDil;
 property NPor      :string read FNPor  write FNPor;
 property NPSKBzlJpOst:string read FNPSKBzlJpOst  write FNPSKBzlJpOst;
 property NKateg      :string read FNKateg  write FNKateg;
 property NporPuda    :Double read FNporPuda  write FNporPuda;
 property NBzlPuda    :Double read FNBzlPuda  write FNBzlPuda;
 property NBZL_POZN      :string read FNBZL_POZN  write FNBZL_POZN;

 property NJinpPuda   :Double read FNJinpPuda  write FNJinpPuda;
 property NJP_POZN      :string read FNJP_POZN  write FNJP_POZN;

 property NOstPuda    :Double read FNOstPuda  write FNOstPuda;

 property OrgUrKatast:String  read GetOrgUrKatast;
end;

TPlochovkaParcelyLETAXmn = class(TLesniMnozina)
private
  FProvadetVypocet:boolean;

public
  inputOddeleni:TOddeleni;
  Function OwnerLesniCelek:TLesniCelek;
  procedure PripoctiOddeleni;
  // procedure DoTabulky(Tb:TTable;infoedit:TEdit);
  procedure   SestavaXLS;
  constructor Create; override;
  property ProvadetVypocet : boolean read FProvadetVypocet write FProvadetVypocet;
end;


procedure provedVypoctyLetax (VLesniCelek:TLesnicelek;infoedit:TEdit);

procedure PripoctiDoOddeleniHeletMajit(VOdd:TOddeleni;infoMemo:TMemo;Vmajetky:TMajetkyMN);
procedure provedVypoctyHeletMajit(VLesniCelek:TLesnicelek;infoMemo:TMemo);
procedure VytvorAProvedVypoctyHeletMajit(VLesniCelek:TLesnicelek;infoMemo:TMemo);


procedure SestavaXLSLetax;


Var
 PlochovkaParcelyLETAXmn:TPlochovkaParcelyLETAXmn;

implementation
constructor TPlochovkaParcelyLETAXMN.Create;
 begin
  inherited create;
  FClass:=TPlochovkaParcelyLETAX;
  FPredponaName:='PlochParcLTX';
 end;

function  TPlochovkaParcelyLETAXmn.OwnerLesniCelek:TLesniCelek;
begin
 result:=TLesniCelek(OwnerTypu(TLesniCelek));
end;

procedure TPlochovkaParcelyLETAXmn.SestavaXLS;
 var
   i,i1:integer;
   SS:string;
   Ulozit,ulozitNaposled,zapsatKatastr:boolean;
   PosledniRAdek:integer;
   vPlochovkaParcelyLETAX:TPlochovkaParcelyLETAX;
 begin
  try
   if ExistsOleObject(ExcelApplication) then
    begin
      ZavriExcelZem;
    end;
  pripojexcelZem(KPoslednimuZnaku(Application.ExeName,'\')+'\sablony\PlochParc.xlt',true); //Pokus1.xlt');
  ulozJako(OwnerLesniCelek.ZdrojNazev,'zzz');
  except
   showmessage('Sestavy nebudou uloeny v XLS. Nepodailo se navzat spojen sExcelem');
   exit;
  end;
 vPlochovkaParcelyLETAX:=TPlochovkaParcelyLETAX.create;
 i1:=0;
 for i:=0 to PlochovkaParcelyLETAXMN.count-1 do
  begin
   with  TPlochovkaParcelyLETAX(PlochovkaParcelyLETAXMN.Elements[i]) do
    begin
     inc(i1);
     KopirujRadekVExceluZem(7,i1+8);
     ZapisDoBunkyZem(i1+8,1,inttoStr(NKatastr));
     ZapisDoBunkyZem(i1+8,3,NParcela);
     ZapisDoBunkyZem(i1+8,4,NParPod);
     ZapisDoBunkyZem(i1+8,5,inttostr(Ndruh_poz));
     ZapisDoBunkyZemdouble(i1+8,6,Nvymera_PK_KN,true);
     ZapisDoBunkyZem(i1+8,7,inttoStr(NODD));
     ZapisDoBunkyZem(i1+8,8,NDIL);
     ZapisDoBunkyZem(i1+8,9,NPOR);
     ZapisDoBunkyZem(i1+8,10,NPSKBzlJpOst);
     ZapisDoBunkyZemdouble(i1+8,14,NporPuda+NBzlPuda,true);
     ZapisDoBunkyZemdouble(i1+8,16,NporPuda,true);
     ZapisDoBunkyZemdouble(i1+8,17,NBzlPuda,true);
     ZapisDoBunkyZemdouble(i1+8,19,NJinpPuda,true);
     ZapisDoBunkyZemdouble(i1+8,21,NporPuda+NBzlPuda+NJinpPuda,true);
     ZapisDoBunkyZemdouble(i1+8,22,NOstPuda,true);

     vPlochovkaParcelyLETAX.Nvymera_PK_KN :=vPlochovkaParcelyLETAX.Nvymera_PK_KN + Nvymera_PK_KN;
     vPlochovkaParcelyLETAX.NporPuda :=vPlochovkaParcelyLETAX.NporPuda +NporPuda;
     vPlochovkaParcelyLETAX.NBzlPuda :=vPlochovkaParcelyLETAX.NBzlPuda +NBzlPuda ;
     vPlochovkaParcelyLETAX.NJinpPuda :=vPlochovkaParcelyLETAX.NJinpPuda + NJinpPuda;
     vPlochovkaParcelyLETAX.NOstPuda :=vPlochovkaParcelyLETAX.NOstPuda +NOstPuda;
    end;

   zapsatKatastr:=false;
   ulozit:=false;
   ulozitNaposled:=false;
   if i<PlochovkaParcelyLETAXMN.count-1 then
    begin
     if (TPlochovkaParcelyLETAX(PlochovkaParcelyLETAXMN.Elements[i]).NKatastr<>TPlochovkaParcelyLETAX(PlochovkaParcelyLETAXMN.Elements[i+1]).NKatastr ) then
      begin
       zapsatKatastr:=true;
      end ;
     if (TPlochovkaParcelyLETAX(PlochovkaParcelyLETAXMN.Elements[i]).NOrgUr2<>TPlochovkaParcelyLETAX(PlochovkaParcelyLETAXMN.Elements[i+1]).NOrgUr2 ) then
      begin
       zapsatKatastr:=true;
       Ulozit:=true;
      end ;
    end
   else
    begin
     zapsatKatastr:=true;
     Ulozit:=true;
     ulozitNaposled:=true;
    end;
   if zapsatKatastr then
    begin
     inc(i1);
     KopirujRadekVExceluZem(7,i1+8);
     SS := DleCiselniku(OwnerLesniCelek.Ciselnik.tb_KU6a,'Kod',
                   inttostr(TPlochovkaParcelyLETAX(PlochovkaParcelyLETAXMN.Elements[i]).NKatastr),'POPIS',false);
     SS := uBezZnaku(SS,'*');
     ZapisDoBunkyZem(i1+8,1,'Katastr:'+SS);
     with vPlochovkaParcelyLETAX do
      begin
       ZapisDoBunkyZemdouble(i1+8,6,Nvymera_PK_KN,true);
       ZapisDoBunkyZemdouble(i1+8,14,NporPuda+NBzlPuda,true);
       ZapisDoBunkyZemdouble(i1+8,16,NporPuda,true);
       ZapisDoBunkyZemdouble(i1+8,17,NBzlPuda,true);
       ZapisDoBunkyZemdouble(i1+8,19,NJinpPuda,true);
       ZapisDoBunkyZemdouble(i1+8,21,NporPuda+NBzlPuda+NJinpPuda,true);
       ZapisDoBunkyZemdouble(i1+8,22,NOstPuda,true);
      end;
     UdelejPlnouCaruZem(i1+7,1,3,22);
     UdelejPlnouCaruZem(i1+8,1,3,22);
     vPlochovkaParcelyLETAX.Free;
     vPlochovkaParcelyLETAX:=TPlochovkaParcelyLETAX.create;
    end;

   if ulozit then
    begin

     SmazRadkyVExceluZem(6,8,PosledniRAdek);

     SS := DleCiselniku(OwnerLesniCelek.Ciselnik.tb_OrgUr2,'Kod',
                   inttostr(TPlochovkaParcelyLETAX(PlochovkaParcelyLETAXMN.Elements[i]).NOrgUr2),'POPIS',false);
     SS := uBezZnaku(SS,'*');

     // showmessage('CAU '+SS);
     if FileExists(OwnerLesniCelek.zdrojNazev+'\vypocty\'+SS+'.xls') then
      begin
       try
        DeleteFile(OwnerLesniCelek.zdrojNazev+'\vypocty\'+SS+'.xls');
       except
       end;
      end;
     try
      UlozAktivniWorkBookdoSouboruZem(OwnerLesniCelek.zdrojNazev+'\vypocty\'+SS+'.xls');
     except
      showmessage('Nepodailo se uloen do souboru ** '+OwnerLesniCelek.zdrojNazev+'\vypocty\'+SS+'.xls');
     end;
     if not ulozitNaposled then
      begin
       try
        if ExistsOleObject(ExcelApplication) then
         begin
          ZavriExcelZem;
         end;
        pripojexcelZem(KPoslednimuZnaku(Application.ExeName,'\')+'\sablony\PlochParc.xlt',true); //Pokus1.xlt');
        ulozJako(OwnerLesniCelek.ZdrojNazev,'zzz');
       except
        showmessage('Sestavy nebudou uloeny v XLS. Nepodailo se navzat spojen sExcelem');
        exit;
       end;
      end; // not ulozit naposled
     i1:=0;
    end; // if ulozit
  end;
 {
 if FileExists(OwnerLesniCelek.zdrojNazev+'\vypocty\PlochParc.xls') then
  begin
   try
    DeleteFile(OwnerLesniCelek.zdrojNazev+'\vypocty\PlochParc.xls');
   except
   end;
  end;

  try
   UlozAktivniWorkBookdoSouboruZem(OwnerLesniCelek.zdrojNazev+'\vypocty\PlochParc.xls');
  except
   showmessage('Nepodailo se uloen do souboru ** '+OwnerLesniCelek.zdrojNazev+'\vypocty\PlochParc.xls');
  end; }
end;

procedure TPlochovkaParcelyLETAXmn.PripoctiOddeleni;
var IDil,IPor,IPsk,IBZL,iJP,iOst:integer;
    NName:String;
    VPlochovkaParcelyLETAX:TPlochovkaParcelyLETAX;
    GisSkupina : Tgis_PorostniSkupina;
    SLHC,sSprava,sODD,sDil,sPOR,sPSK,chyba1:String;
    iOw,PorIow:Integer;
    Parcela:Tgis_Parcela;
    OE:TOverlayGeometryElement;
    PoleOvrl : TPoleOvrlParCisParPodl;
 begin
  if not ProvadetVypocet then exit;
  SLHC:=inttostr(inputOddeleni.OwnerLHC_KOD);
  sODD:=inttostr(inputOddeleni.ODD);
  sSprava:='je na nic';

  with inputOddeleni do
   begin
    for Idil:=0 to DilecMN.count-1 do
     begin
      with TDilec(DilecMN.elements[idil]) do
       begin
        Sdil:=DIL;
        for IPor:=0 to PorostMN.count-1 do
         begin
          with TPorost(PorostMN.elements[iPor]) do
           begin
            SPor:=Por;
            for IPsk:=0 to PorostniSkupinaMN.count-1 do
             begin
              with iPorostniSkupina[iPsk] do
               begin
                sPSK:=ubm(PSK);
                VPlochovkaParcelyLETAX:=TPlochovkaParcelyLETAX.Create;
                self.AddElement(VPlochovkaParcelyLETAX);
                VPlochovkaParcelyLETAX.NOrgUr2:=strtoint0(ORG_UROVEN2);
                VPlochovkaParcelyLETAX.NKatastr:=KU_KOD;
                VPlochovkaParcelyLETAX.NOdd:=ODD;
                VPlochovkaParcelyLETAX.NDil:=DIL;
                VPlochovkaParcelyLETAX.NPor:=POR;
                VPlochovkaParcelyLETAX.NPSKBzlJpOst:=ubm(PSK);
                VPlochovkaParcelyLETAX.NporPuda:=PSK_P;//PSK_;
                VPlochovkaParcelyLETAX.NKateg:=Kategorie1Mn.KategorieVcetnePrekryvu;
                GisSkupina:=NajdiSkupinuVOrbu(SLHC,sSprava,sODD,sDil,sPOR,sPSK,chyba1);
                if GisSkupina<>NIL then
                 begin
                  vytvorPoledleParCisParPodlZPAROwelay(GisSkupina,PoleOvrl);
                  iOw:=0;
                  for PorIow:=1 to PoleOvrl.PocetOvrl do
                   begin
                    if PoleOvrl.a[porIow].Plocha<0.0009 then
                     begin
                       continue;
                     end;
                    inc(iOw);
                    if iOw>1 then
                     begin
                      VPlochovkaParcelyLETAX:=TPlochovkaParcelyLETAX.Create;
                      self.AddElement(VPlochovkaParcelyLETAX);
                      VPlochovkaParcelyLETAX.NOrgUr2:=strtoint0(ORG_UROVEN2);
                      VPlochovkaParcelyLETAX.NKatastr:=KU_KOD;
                      VPlochovkaParcelyLETAX.NOdd:=ODD;
                      VPlochovkaParcelyLETAX.NDil:=DIL;
                      VPlochovkaParcelyLETAX.NPor:=POR;
                      VPlochovkaParcelyLETAX.NPSKBzlJpOst:=ubm(PSK);
                      VPlochovkaParcelyLETAX.NporPuda:=0;
                      VPlochovkaParcelyLETAX.NKateg:=Kategorie1Mn.KategorieVcetnePrekryvu;
                     end;
                    VPlochovkaParcelyLETAX.Nparcela  := PoleOvrl.a[porIow].ParCis;
                    VPlochovkaParcelyLETAX.NParPod   := PoleOvrl.a[porIow].ParPodl;
                    VPlochovkaParcelyLETAX.Ndruh_poz := PoleOvrl.a[porIow].Kultura;
                    VPlochovkaParcelyLETAX.Nvymera_PK_KN := PoleOvrl.a[porIow].Plocha;
                   end;
                 end;
               end;
             end;
            for IBzl:=0 to BezlesiMN.count-1 do
             begin
              with iBezlesi[iBzl] do
               begin
                VPlochovkaParcelyLETAX:=TPlochovkaParcelyLETAX.Create;
                self.AddElement(VPlochovkaParcelyLETAX);
                VPlochovkaParcelyLETAX.NOrgUr2:=strtoint0(ORG_UROVEN2);
                VPlochovkaParcelyLETAX.NKatastr:=KU_KOD;
                VPlochovkaParcelyLETAX.NOdd:=ODD;
                VPlochovkaParcelyLETAX.NDil:=DIL;
                VPlochovkaParcelyLETAX.NPor:=POR;
                VPlochovkaParcelyLETAX.NPSKBzlJpOst:=inttostr(BZL);
                VPlochovkaParcelyLETAX.NBzlPuda:=BZL_P; //BZL_V;

                sPSK:=inttostr(BZL);
                GisSkupina:=NajdiSkupinuVOrbu(SLHC,sSprava,sODD,sDil,sPOR,sPSK,chyba1);
                if GisSkupina<>NIL then
                 begin
                  vytvorPoledleParCisParPodlZPAROwelay(GisSkupina,PoleOvrl);
                  iOw:=0;
                  for PorIow:=1 to PoleOvrl.PocetOvrl do
                   begin
                    if PoleOvrl.a[porIow].Plocha<0.0009 then
                     begin
                       continue;
                     end;
                    inc(iOw);
                    if iOw>1 then
                     begin
                      VPlochovkaParcelyLETAX:=TPlochovkaParcelyLETAX.Create;
                      self.AddElement(VPlochovkaParcelyLETAX);
                      VPlochovkaParcelyLETAX.NOrgUr2:=strtoint0(ORG_UROVEN2);
                      VPlochovkaParcelyLETAX.NKatastr:=KU_KOD;
                      VPlochovkaParcelyLETAX.NOdd:=ODD;
                      VPlochovkaParcelyLETAX.NDil:=DIL;
                      VPlochovkaParcelyLETAX.NPor:=POR;
                      VPlochovkaParcelyLETAX.NPSKBzlJpOst:=inttostr(BZL);
                     end;
                    VPlochovkaParcelyLETAX.Nparcela  := PoleOvrl.a[porIow].ParCis;
                    VPlochovkaParcelyLETAX.NParPod   := PoleOvrl.a[porIow].ParPodl;
                    VPlochovkaParcelyLETAX.Ndruh_poz := PoleOvrl.a[porIow].Kultura;
                    VPlochovkaParcelyLETAX.Nvymera_PK_KN := PoleOvrl.a[porIow].Plocha;
                   end;
                 end;
               end;
             end;
            for iJP:=0 to jinypozemekMN.count-1 do
             begin
              with ijinypozemek[iJP] do
               begin
                VPlochovkaParcelyLETAX:=TPlochovkaParcelyLETAX.Create;
                self.AddElement(VPlochovkaParcelyLETAX);
                VPlochovkaParcelyLETAX.NOrgUr2:=strtoint0(ORG_UROVEN2);
                VPlochovkaParcelyLETAX.NKatastr:=KU_KOD;
                VPlochovkaParcelyLETAX.NOdd:=ODD;
                VPlochovkaParcelyLETAX.NDil:=DIL;
                VPlochovkaParcelyLETAX.NPor:=POR;
                VPlochovkaParcelyLETAX.NPSKBzlJpOst:=inttostr(JP);
                VPlochovkaParcelyLETAX.NJinpPuda:=JP_P; //JP_V;
                sPSK:=inttostr(JP);
                GisSkupina:=NajdiSkupinuVOrbu(SLHC,sSprava,sODD,sDil,sPOR,sPSK,chyba1);
                if GisSkupina<>NIL then
                 begin
                  vytvorPoledleParCisParPodlZPAROwelay(GisSkupina,PoleOvrl);
                  iOw:=0;
                  for PorIow:=1 to PoleOvrl.PocetOvrl do
                   begin
                    if PoleOvrl.a[porIow].Plocha<0.0009 then
                     begin
                       continue;
                     end;
                    inc(iOw);
                    if iOw>1 then
                     begin
                      VPlochovkaParcelyLETAX:=TPlochovkaParcelyLETAX.Create;
                      self.AddElement(VPlochovkaParcelyLETAX);
                      VPlochovkaParcelyLETAX.NOrgUr2:=strtoint0(ORG_UROVEN2);
                      VPlochovkaParcelyLETAX.NKatastr:=KU_KOD;
                      VPlochovkaParcelyLETAX.NOdd:= ODD;
                      VPlochovkaParcelyLETAX.NDil:= DIL;
                      VPlochovkaParcelyLETAX.NPor:= POR;
                      VPlochovkaParcelyLETAX.NPSKBzlJpOst:=inttostr(JP);
                     end;
                    VPlochovkaParcelyLETAX.Nparcela  := PoleOvrl.a[porIow].ParCis;
                    VPlochovkaParcelyLETAX.NParPod   := PoleOvrl.a[porIow].ParPodl;
                    VPlochovkaParcelyLETAX.Ndruh_poz := PoleOvrl.a[porIow].Kultura;
                    VPlochovkaParcelyLETAX.Nvymera_PK_KN := PoleOvrl.a[porIow].Plocha;
                   end;
                 end;
               end;
             end;
            for IOst:=0 to OstatniMN.count-1 do
             begin
              with iOstatni[iOst] do
               begin
                VPlochovkaParcelyLETAX:=TPlochovkaParcelyLETAX.Create;
                self.AddElement(VPlochovkaParcelyLETAX);
                VPlochovkaParcelyLETAX.NOrgUr2:=strtoint0(ORG_UROVEN2);
                VPlochovkaParcelyLETAX.NKatastr:=KU_KOD;
                VPlochovkaParcelyLETAX.NOdd:=ODD;
                VPlochovkaParcelyLETAX.NDil:=DIL;
                VPlochovkaParcelyLETAX.NPor:=POR;
                VPlochovkaParcelyLETAX.NPSKBzlJpOst:=inttostr(OST);  //+'x'+floattostr(OST_V);
                VPlochovkaParcelyLETAX.NOstPuda:=OST_P;//OST_V;

                sPSK:=inttostr(OST);
                GisSkupina:=NajdiSkupinuVOrbu(SLHC,sSprava,sODD,sDil,sPOR,sPSK,chyba1);
                if GisSkupina<>NIL then
                 begin
                  vytvorPoledleParCisParPodlZPAROwelay(GisSkupina,PoleOvrl);
                  iOw:=0;
                  for PorIow:=1 to PoleOvrl.PocetOvrl do
                   begin
                    if PoleOvrl.a[porIow].Plocha<0.0009 then
                     begin
                      continue;
                     end;
                    inc(iOw);
                    if iOw>1 then
                     begin
                      VPlochovkaParcelyLETAX:=TPlochovkaParcelyLETAX.Create;
                      self.AddElement(VPlochovkaParcelyLETAX);
                      VPlochovkaParcelyLETAX.NOrgUr2:=strtoint0(ORG_UROVEN2);
                      VPlochovkaParcelyLETAX.NKatastr:=KU_KOD;
                      VPlochovkaParcelyLETAX.NOdd:=ODD;
                      VPlochovkaParcelyLETAX.NDil:=DIL;
                      VPlochovkaParcelyLETAX.NPor:=POR;
                      VPlochovkaParcelyLETAX.NPSKBzlJpOst:=inttostr(OST);
                     end;
                    VPlochovkaParcelyLETAX.Nparcela  := PoleOvrl.a[porIow].ParCis;
                    VPlochovkaParcelyLETAX.NParPod   := PoleOvrl.a[porIow].ParPodl;
                    VPlochovkaParcelyLETAX.Ndruh_poz := PoleOvrl.a[porIow].Kultura;
                    VPlochovkaParcelyLETAX.Nvymera_PK_KN := PoleOvrl.a[porIow].Plocha;
                   end;
                 end;
               end;
             end;
           end;
         end;
       end;
     end;
   end;
 end;



Procedure PripoctiOddeleniLetax(vOdd:TOddeleni);
 begin

  // DoEditu('Zpracovvm oddlen '+intToStr(lhc.Oddeleni.ODD)+' do tabulky OddOrgUr.db',infoedit);
  PlochovkaParcelyLETAXmn.inputOddeleni:=VOdd;
  PlochovkaParcelyLETAXmn.PripoctiOddeleni;
 end;

procedure SestavaXLSLetax;
 begin
  PlochovkaParcelyLETAXmn.SestavaXLS;
 end;

procedure PripoctiDoOddeleniHeletMajit(VOdd:TOddeleni;infoMemo:TMemo;Vmajetky:TMajetkyMN);
var IDil,IPor,IPsk,IBZL,iJP,iOst:integer;
    NName:String;
//    VPlochovkaParcelyLETAX:TPlochovkaParcelyLETAX;
    GisSkupina : Tgis_PorostniSkupina;
    SLHC,sSprava,sODD,sDil,sPOR,sPSK,sKU_KOD,chyba1:String;
    iOw,PorIow:Integer;
    Parcela:Tgis_Parcela;
    OE:TOverlayGeometryElement;
    PoleOvrl : TPoleOvrlParCisParPodl;
    VMaj:TMajetky;
 begin
  SLHC:=inttostr(VOdd.OwnerLHC_KOD);
  sODD:=inttostr(VOdd.ODD);
  sSprava:='je na nic';

  with VOdd do
   begin
    for Idil:=0 to DilecMN.count-1 do
     begin
      with TDilec(DilecMN.elements[idil]) do
       begin
        Sdil:=DIL;
        for IPor:=0 to PorostMN.count-1 do
         begin
          with TPorost(PorostMN.elements[iPor]) do
           begin
            SPor:=Por;
            Vmaj:=Vmajetky.NajdiMAJ_DRUH_MAJ_KOD(inttostr(MAJ_DRUH),MAJ_KOD);
            for IPsk:=0 to PorostniSkupinaMN.count-1 do
             begin
              with iPorostniSkupina[iPsk] do
               begin
                sPSK:=ubm(PSK);
                sKU_KOD:=inttostr(KU_KOD);
                GisSkupina:=NajdiSkupinuVOrbu(SLHC,sSprava,sODD,sDil,sPOR,sPSK,chyba1);
                if GisSkupina<>NIL then
                 begin
                  vytvorPoledleParCisParPodlZPAROwelay(GisSkupina,PoleOvrl);
                  iOw:=0;
                  if PoleOvrl.PocetOvrl>1 then
                   begin
                    for PorIow:=1 to PoleOvrl.PocetOvrl do
                     begin
                      with PoleOvrl.a[porIow] do
                       begin
                        infoMemo.Lines.Add(floatTOStrf(Plocha,ffFixed,8,2)+ParCis+' '+ParPodl+' '+LV);
                       end;
                     end;
                    infoMemo.Lines.Add('----------');
                   end;
                  for PorIow:=1 to PoleOvrl.PocetOvrl do
                   begin
                    if PoleOvrl.a[porIow].Plocha<0.0009 then
                     begin
                       continue;
                     end;
                    inc(iOw);
                    if VMaj=nil then
                     begin
                      infoMemo.Lines.Add(CeleOznaceni+'nil Vmaj');
                     end
                    else
                     begin
                      VMaj.KU_KOD_C:=sKU_KOD;
                      VMaj.PARPOD_C:=''; //DoplnPoznamkuPokudTamNeni(VMaj.PARPOD_C,PoleOvrl.a[porIow].ParPodl,',');
                      if ubm(PoleOvrl.a[porIow].ParPodl)<>'' then
                       begin
                        VMaj.PARCIS_C:=DoplnPoznamkuPokudTamNeni(VMaj.PARCIS_C,
                          PoleOvrl.a[porIow].ParCis+'/'+PoleOvrl.a[porIow].ParPodl,',');
                       end
                      else
                       begin
                        VMaj.PARCIS_C:=DoplnPoznamkuPokudTamNeni(VMaj.PARCIS_C,PoleOvrl.a[porIow].ParCis,',');
                       end;
                      VMaj.LV_C:=DoplnPoznamkuPokudTamNeni(VMaj.LV_C,PoleOvrl.a[porIow].LV,',');
                      { infoMemo.Lines.Add(CeleOznaceni
                         +'  MAJ_KOD='+VMaj.MAJ_KOD_C
                         +'  MAJ_DRUH='+VMaj.MAJ_DRUH_C
                         +'  ParCisc='+VMaj.PARCIS_C
                         +'  ParPodlc='+VMaj.PARPOD_C
                         +'  LVc='+VMaj.LV_C); }
                     end;
                   end;
                 end;
               end;
             end;
            {
            for IBzl:=0 to BezlesiMN.count-1 do
             begin
              with iBezlesi[iBzl] do
               begin
                VPlochovkaParcelyLETAX:=TPlochovkaParcelyLETAX.Create;
                self.AddElement(VPlochovkaParcelyLETAX);
                VPlochovkaParcelyLETAX.NOrgUr2:=strtoint0(ORG_UROVEN2);
                VPlochovkaParcelyLETAX.NKatastr:=KU_KOD;
                VPlochovkaParcelyLETAX.NOdd:=ODD;
                VPlochovkaParcelyLETAX.NDil:=DIL;
                VPlochovkaParcelyLETAX.NPor:=POR;
                VPlochovkaParcelyLETAX.NPSKBzlJpOst:=inttostr(BZL);
                VPlochovkaParcelyLETAX.NBzlPuda:=BZL_P; //BZL_V;

                sPSK:=inttostr(BZL);
                GisSkupina:=NajdiSkupinuVOrbu(SLHC,sSprava,sODD,sDil,sPOR,sPSK,chyba1);
                if GisSkupina<>NIL then
                 begin
                  vytvorPoledleParCisParPodlZPAROwelay(GisSkupina,PoleOvrl);
                  iOw:=0;
                  for PorIow:=1 to PoleOvrl.PocetOvrl do
                   begin
                    if PoleOvrl.a[porIow].Plocha<0.0009 then
                     begin
                       continue;
                     end;
                    inc(iOw);
                    if iOw>1 then
                     begin
                      VPlochovkaParcelyLETAX:=TPlochovkaParcelyLETAX.Create;
                      self.AddElement(VPlochovkaParcelyLETAX);
                      VPlochovkaParcelyLETAX.NOrgUr2:=strtoint0(ORG_UROVEN2);
                      VPlochovkaParcelyLETAX.NKatastr:=KU_KOD;
                      VPlochovkaParcelyLETAX.NOdd:=ODD;
                      VPlochovkaParcelyLETAX.NDil:=DIL;
                      VPlochovkaParcelyLETAX.NPor:=POR;
                      VPlochovkaParcelyLETAX.NPSKBzlJpOst:=inttostr(BZL);
                     end;
                    VPlochovkaParcelyLETAX.Nparcela  := PoleOvrl.a[porIow].ParCis;
                    VPlochovkaParcelyLETAX.NParPod   := PoleOvrl.a[porIow].ParPodl;
                    VPlochovkaParcelyLETAX.Ndruh_poz := PoleOvrl.a[porIow].Kultura;
                    VPlochovkaParcelyLETAX.Nvymera_PK_KN := PoleOvrl.a[porIow].Plocha;
                   end;
                 end;
               end;
             end;
            for iJP:=0 to jinypozemekMN.count-1 do
             begin
              with ijinypozemek[iJP] do
               begin
                VPlochovkaParcelyLETAX:=TPlochovkaParcelyLETAX.Create;
                self.AddElement(VPlochovkaParcelyLETAX);
                VPlochovkaParcelyLETAX.NOrgUr2:=strtoint0(ORG_UROVEN2);
                VPlochovkaParcelyLETAX.NKatastr:=KU_KOD;
                VPlochovkaParcelyLETAX.NOdd:=ODD;
                VPlochovkaParcelyLETAX.NDil:=DIL;
                VPlochovkaParcelyLETAX.NPor:=POR;
                VPlochovkaParcelyLETAX.NPSKBzlJpOst:=inttostr(JP);
                VPlochovkaParcelyLETAX.NJinpPuda:=JP_P; //JP_V;
                sPSK:=inttostr(JP);
                GisSkupina:=NajdiSkupinuVOrbu(SLHC,sSprava,sODD,sDil,sPOR,sPSK,chyba1);
                if GisSkupina<>NIL then
                 begin
                  vytvorPoledleParCisParPodlZPAROwelay(GisSkupina,PoleOvrl);
                  iOw:=0;
                  for PorIow:=1 to PoleOvrl.PocetOvrl do
                   begin
                    if PoleOvrl.a[porIow].Plocha<0.0009 then
                     begin
                       continue;
                     end;
                    inc(iOw);
                    if iOw>1 then
                     begin
                      VPlochovkaParcelyLETAX:=TPlochovkaParcelyLETAX.Create;
                      self.AddElement(VPlochovkaParcelyLETAX);
                      VPlochovkaParcelyLETAX.NOrgUr2:=strtoint0(ORG_UROVEN2);
                      VPlochovkaParcelyLETAX.NKatastr:=KU_KOD;
                      VPlochovkaParcelyLETAX.NOdd:= ODD;
                      VPlochovkaParcelyLETAX.NDil:= DIL;
                      VPlochovkaParcelyLETAX.NPor:= POR;
                      VPlochovkaParcelyLETAX.NPSKBzlJpOst:=inttostr(JP);
                     end;
                    VPlochovkaParcelyLETAX.Nparcela  := PoleOvrl.a[porIow].ParCis;
                    VPlochovkaParcelyLETAX.NParPod   := PoleOvrl.a[porIow].ParPodl;
                    VPlochovkaParcelyLETAX.Ndruh_poz := PoleOvrl.a[porIow].Kultura;
                    VPlochovkaParcelyLETAX.Nvymera_PK_KN := PoleOvrl.a[porIow].Plocha;
                   end;
                 end;
               end;
             end;
            for IOst:=0 to OstatniMN.count-1 do
             begin
              with iOstatni[iOst] do
               begin
                VPlochovkaParcelyLETAX:=TPlochovkaParcelyLETAX.Create;
                self.AddElement(VPlochovkaParcelyLETAX);
                VPlochovkaParcelyLETAX.NOrgUr2:=strtoint0(ORG_UROVEN2);
                VPlochovkaParcelyLETAX.NKatastr:=KU_KOD;
                VPlochovkaParcelyLETAX.NOdd:=ODD;
                VPlochovkaParcelyLETAX.NDil:=DIL;
                VPlochovkaParcelyLETAX.NPor:=POR;
                VPlochovkaParcelyLETAX.NPSKBzlJpOst:=inttostr(OST);  //+'x'+floattostr(OST_V);
                VPlochovkaParcelyLETAX.NOstPuda:=OST_P;//OST_V;

                sPSK:=inttostr(OST);
                GisSkupina:=NajdiSkupinuVOrbu(SLHC,sSprava,sODD,sDil,sPOR,sPSK,chyba1);
                if GisSkupina<>NIL then
                 begin
                  vytvorPoledleParCisParPodlZPAROwelay(GisSkupina,PoleOvrl);
                  iOw:=0;
                  for PorIow:=1 to PoleOvrl.PocetOvrl do
                   begin
                    if PoleOvrl.a[porIow].Plocha<0.0009 then
                     begin
                      continue;
                     end;
                    inc(iOw);
                    if iOw>1 then
                     begin
                      VPlochovkaParcelyLETAX:=TPlochovkaParcelyLETAX.Create;
                      self.AddElement(VPlochovkaParcelyLETAX);
                      VPlochovkaParcelyLETAX.NOrgUr2:=strtoint0(ORG_UROVEN2);
                      VPlochovkaParcelyLETAX.NKatastr:=KU_KOD;
                      VPlochovkaParcelyLETAX.NOdd:=ODD;
                      VPlochovkaParcelyLETAX.NDil:=DIL;
                      VPlochovkaParcelyLETAX.NPor:=POR;
                      VPlochovkaParcelyLETAX.NPSKBzlJpOst:=inttostr(OST);
                     end;
                    VPlochovkaParcelyLETAX.Nparcela  := PoleOvrl.a[porIow].ParCis;
                    VPlochovkaParcelyLETAX.NParPod   := PoleOvrl.a[porIow].ParPodl;
                    VPlochovkaParcelyLETAX.Ndruh_poz := PoleOvrl.a[porIow].Kultura;
                    VPlochovkaParcelyLETAX.Nvymera_PK_KN := PoleOvrl.a[porIow].Plocha;
                   end;
                 end;
               end;
             end;  }
           end;
         end;
       end;
     end;
   end;
  infoMemo.Lines.Add(' dokonceno ');

 end;


procedure provedVypoctyLetax (VLesniCelek:TLesnicelek;infoedit:TEdit);
var
 vOdd:TOddeleni;
 LOvr98A:TOvr98;

 begin
  PlochovkaParcelyLETAXmn:=TPlochovkaParcelyLETAXmn.Create;
  VLesniCelek.AddElement(PlochovkaParcelyLETAXmn);
  PlochovkaParcelyLETAXmn.ProvadetVypocet:=true;
  VLesniCelek.VcetneBarev:= VcetneBarvy1;
  druhaDataBaze98:=true;
  nespoustetManager:=false;
  umoznitZalozeniNoveDatabaze:=false;
  Application.CreateForm(TOVR98,LOvr98A);
  VLesniCelek.JakBylNacten:='Tax98-Paradox';
  VLesniCelek.FFOvr98:=LOvr98A;
  NactiPolozkyLHC_DB98(VLesniCelek.LHC,VLesniCelek.LOvr98);
  PriradCiselnik_DB98(VLesniCelek.ciselnik,VLesniCelek.LOvr98);
  VLesniCelek.CiselOrbis.nactiSeZOrbu(VLesniCelek.PHSNazev,true);
  NactiCiselOrbis_DB98(VLesniCelek.CiselOrbis,VLesniCelek.LOvr98);
  with VLesniCelek do
   begin
    // NactiSe_DB98;
    LOvr98.tb_odd.first;
    while not LOvr98.tb_odd.eof do
     begin
      NactiOddelenidb98 (VOdd,LOvr98,VcetneBarev);
      LHC.OddeleniMN.AddElement(VOdd);
      infoedit.Text:='nacteno odd '+Inttostr(VOdd.ODD); infoedit.Refresh;
      PripoctiOddeleniLetax(vOdd);
     end;
    LHC.OddeleniMN.AktualniPrvek.free;
   end;
  PlochovkaParcelyLETAXMN.setridPodlePropertyString('OrgUrKatast',true);
  infoedit.Text:='provedVypoctyLetax hotovo';
 end;

procedure ulozMAjiteleDoXLS( MajetkyMN:TMajetkyMN;CestaAJmeno:string);
var i,i1:integer;
begin
  try
   if ExistsOleObject(ExcelApplication) then
    begin
      ZavriExcelZem;
    end;
  pripojexcelZem(KPoslednimuZnaku(Application.ExeName,'\')+'\sablony\MajitLvParc.xlt',true); //Pokus1.xlt');
  ulozJako(CestaAJmeno,'zzz');
  except
   showmessage('Sestavy nebudou uloeny v XLS. Nepodailo se navzat spojen sExcelem');
   exit;
  end;

 i1:=1;
 for i:=0 to MajetkyMN.count-1 do
  begin
   with  Tmajetky(majetkyMN.Elements[i]) do
    begin
     inc(i1);
     //KopirujRadekVExceluZem(7,i1+8);
     ZapisDoBunkyZem(i1,1,MAJ_KOD_c);
     ZapisDoBunkyZem(i1,2,MAJ_DRUH_c);
     ZapisDoBunkyZem(i1,3,MAJ_NAZ_c);
     ZapisDoBunkyZem(i1,4,KU_KOD_c);
     ZapisDoBunkyZem(i1,5,LV_c);
     ZapisDoBunkyZem(i1,6,Parcis_c);
     ZapisDoBunkyZem(i1,7,NamePorostu);
   //   ZapisDoBunkyZemdouble(i1+8,6,Nvymera_PK_KN,true);
    end; // with Tmajetky(majetkyMN.Elements[i])
  end; // for i

//     if FileExists(OwnerLesniCelek.zdrojNazev+'\vypocty\'+SS+'.xls') then
     if FileExists(CestaAJmeno+'\Majitele.xls') then
      begin
       try
        DeleteFile(CestaAJmeno+'\Majitele.xls');
       except
       end;
      end;
     try
      UlozAktivniWorkBookdoSouboruZem(CestaAJmeno+'\Majitele.xls');
     except
      showmessage('Nepodailo se uloen do souboru ** '+CestaAJmeno+'\Majitele.xls');
     end;
end;
procedure UlozMajetkydoDBF(VLesniCelek:TLesnicelek;infoMemo:TMemo;CestaAJmeno:string);
 var i:integer;
 TbMajit:TTable;
begin
  TbMajit:=TTable.Create(VLesniCelek.LOvr98);
  with TbMajit do
   begin
      close;
      TableName:=CestaAJmeno+'\Majitele.DBF';
      // TableName:=KPoslednimuZnaku(Application.ExeName,'\')+'\Majitele.DBF';
      TableType:=ttDBase;   //ttParadox;
      Exclusive:=true;
      with FieldDefs do
       begin
        clear;
         Add('MAJ_DRUH' , ftstring ,   2, false);
         Add('MAJ_KOD'  , ftstring ,  10, false);
         Add('KU_KOD'   , ftString , 255, false);
         Add('MAJ_NAZ'  , ftString , 255, false);
         Add('MAJ_NAZ2' , ftString , 255, false);
         Add('CJOU'   , ftString , 100, false);
         Add('LV'       , ftString ,  50, false);
         Add('PARCIS'   , ftString ,  50, false);
         Add('PARPOD'   , ftString ,  50, false);
         Add('PARDIL'   , ftString ,  50, false);
         Add('PARVYM'   , ftString ,  50, false);
         Add('DRUH_POZ' , ftString ,  25, false);
         Add('PUPFL'    , ftString ,  25, false);
         Add('TEZB_VYP' , ftInteger,   0, false);
         Add('TEZB_MAX' , ftInteger,   0, false);
         Add('LesniPoz' , ftFloat  ,   0, false);
         Add('JinePoz'  , ftFloat  ,   0, false);
         Add('RodneCis' , ftString , 100, false);
         Add('JmePrijm' , ftString , 255, false);
         Add('ICO'      , ftString ,  14, false);
         Add('ObchodJm' , ftString ,  30, false);
         Add('Zastupce' , ftString ,  30, false);
         Add('PSC'      , ftInteger,   0, false);
         Add('AdrObec'  , ftString , 255, false);
         Add('AdrUlice' , ftString , 255, false);
         Add('AdrCDomu' , ftString , 255, false);
         Add('Obec'     , ftString , 255, false);
         Add('OSTATNI'  , ftString , 100, false);
         Add('KOD'      , ftInteger,   0, false);
         Add('DOPLKOD'  , ftInteger,   0, false);
         Add('CISJEDN'  , ftString,   15, false);
         Add('DATVYDANI', ftString,    0, false);
         Add('UZIVATEL' , ftString,  255, false);
         Add('ZADATEL'  , ftString,  255, false);
         Add('CISORG'   , ftString,   12, false);
         Add('ODB_SPR'  , ftString,   12, false);
         Add('NAJDATE'  , ftString,    0, false);
         Add('NAJPLAT'  , ftString,    0, false);
         Add('CJ_ROZHOD', ftString,   15, false);
         Add('NAHRADA'  , ftString,   15, false);
         Add('POZN'     , ftString,   80, false);
         Add('UZIV'     , ftString,   15, false);
         Add('DOHODA'   , ftString,   50, false);
         Add('TEZB_VYCH', ftInteger,   0, false);
         Add('ZAS_CEL'  , ftInteger,   0, false);
         Add('POROSTY'  , ftString,   255, false);
        end;
      createTable;
      // addindex('ccc','MAJ_DRUH;MAJ_KOD',[ixprimary]);
      exclusive:=false;
      open;
     end; {Width }
 for i:=0 to VlesniCelek.ciselOrbis.MajetkyMN.count-1 do
  begin
   TbMajit.insert;
   with tMajetky(VlesniCelek.ciselOrbis.MajetkyMN.elements[i]) do
    begin
     TbMajit.fieldByName('MAJ_KOD').asstring  :=MAJ_KOD_C;
     TbMajit.fieldByName('KU_KOD').asstring   :=KU_KOD_c;
     TbMajit.fieldByName('MAJ_NAZ').asstring  :=MAJ_NAZ_c1;
     TbMajit.fieldByName('MAJ_NAZ2').asstring :=MAJ_NAZ_c2;
     TbMajit.fieldByName('MAJ_DRUH').asstring :=MAJ_DRUH_c;
     TbMajit.fieldByName('LV').asstring       :=LV_c;
     TbMajit.fieldByName('CJOU').asstring   :=CjOU_C;

     TbMajit.fieldByName('PARCIS').asstring   :=PARCIS_c;
     TbMajit.fieldByName('PARPOD').asstring   :=PARPOD_c;
     TbMajit.fieldByName('PARDIL').asstring   :=PARDIL_c;
     TbMajit.fieldByName('PARVYM').asstring   :=PARVYM_c;
     TbMajit.fieldByName('DRUH_POZ').asstring :=DRUH_POZ_c;
     TbMajit.fieldByName('PUPFL').asstring    :=PUPFL_c;
     TbMajit.fieldByName('TEZB_VYP').asinteger:=TEZB_VYP_c;
     TbMajit.fieldByName('TEZB_MAX').asinteger:=TEZB_MAX_c;
     TbMajit.fieldByName('LesniPoz').asfloat:=LesniPoz_c;
     TbMajit.fieldByName('JinePoz').asfloat:=JinePoz_c;
     TbMajit.fieldByName('RodneCis').asstring:=RodneCis_c;
     TbMajit.fieldByName('JmePrijm').asstring:=JmePrijm_c;
     TbMajit.fieldByName('ICO').asstring:=ICO_c;
     TbMajit.fieldByName('ObchodJm').asstring:=ObchodJm_c;
     TbMajit.fieldByName('Zastupce').asstring:=Zastupce_c;
     TbMajit.fieldByName('PSC').asInteger:=PSC_c;
     TbMajit.fieldByName('AdrObec').asstring:=AdrObec_c;
     TbMajit.fieldByName('AdrUlice').asstring:=AdrUlice_c;
     TbMajit.fieldByName('AdrCDomu').asstring:=AdrCDomu_c;
     TbMajit.fieldByName('Obec').asstring:=Obec_c;
     TbMajit.fieldByName('OSTATNI').asstring:=OSTATNI_c;
     TbMajit.fieldByName('KOD').asinteger:=KOD_c;
     TbMajit.fieldByName('DOPLKOD').asinteger:=DOPLKOD_c;
     TbMajit.fieldByName('CISJEDN').asstring:=CISJEDN_c;
     TbMajit.fieldByName('DATVYDANI').asstring:=DATVYDANI_c;
     TbMajit.fieldByName('UZIVATEL').asstring:=UZIVATEL_c;
     TbMajit.fieldByName('ZADATEL').asstring:=ZADATEL_c;
     TbMajit.fieldByName('CISORG').asstring:=CISORG_c;
     TbMajit.fieldByName('ODB_SPR').asstring:=ODB_SPR_c;
     TbMajit.fieldByName('NAJDATE').asstring:=NAJDATE_c;
     TbMajit.fieldByName('NAJPLAT').asstring:=NAJPLAT_c;
     TbMajit.fieldByName('CJ_ROZHOD').asstring:=CJ_ROZHOD_c;
     TbMajit.fieldByName('NAHRADA').asstring:=NAHRADA_c;
     TbMajit.fieldByName('POZN').asstring:=POZN_c;
     TbMajit.fieldByName('UZIV').asstring:=UZIV_c;
     TbMajit.fieldByName('DOHODA').asstring:=DOHODA_c;
     TbMajit.fieldByName('TEZB_VYCH').asinteger:=TEZB_VYCH_c;
     TbMajit.fieldByName('ZAS_CEL').asinteger:=ZAS_CEL_c;
     TbMajit.fieldByName('POROSTY').asstring:=NamePorostu;
    end;
   TbMajit.post;
  end;
 TbMajit.close;
end;

procedure VytvorAProvedVypoctyHeletMajit(VLesniCelek:TLesnicelek;infoMemo:TMemo);
var
 vOdd:TOddeleni;
 LOvr98A:TOvr98;
 CestaAJmeno : string;
 i:integer;
 begin
  VLesniCelek.VcetneBarev:= VcetneBarvy1;
  druhaDataBaze98:=true;
  nespoustetManager:=false;
  umoznitZalozeniNoveDatabaze:=false;
  Application.CreateForm(TOVR98,LOvr98A);
  VLesniCelek.JakBylNacten:='Tax98-Paradox';
  VLesniCelek.FFOvr98:=LOvr98A;
  NactiPolozkyLHC_DB98(VLesniCelek.LHC,VLesniCelek.LOvr98);
  PriradCiselnik_DB98(VLesniCelek.ciselnik,VLesniCelek.LOvr98);
  VLesniCelek.CiselOrbis.nactiSeZOrbu(VLesniCelek.PHSNazev,true);
  NactiCiselOrbis_DB98(VLesniCelek.CiselOrbis,VLesniCelek.LOvr98);
  VLesniCelek.NactiSe_DB98;
  VLesniCelek.TypDatLHP:=tax98;
  CestaAJmeno := Najdi_Adresar('C:\','Najdi prazdn adres do kterho budou uloeny vsledky','*.*',neukazZdroje);
  //CestaAJmeno := Najdi_Soubor('C:\','Vyber soubor Majetky.ORB kam bude doplnn LV a ParCis.','Majetky.ORB',neukazZdroje);

  // CestaAJmeno := 'C:\Heletax_5R1\Heletax_PomAdesare\205804_1.pom\Majetky.ORB';
  {
  if fileExists(CestaAJmeno) then
   begin
    VlesniCelek.ciselOrbis.MajetkyMN:=TMajetkyMN(NactiZOrbuLesniMnozinu(CestaAJmeno));
    VlesniCelek.ciselOrbis.MajetkyMN.setridPodlePropertyString('MAJ_NAZ_C',true);
    VlesniCelek.ciselOrbis.MajetkyMN.TridenoPodle:='MAJ_NAZ';
   end
  else
   begin
    VLesniCelek.NactiSeznamMajitelu;
   end;                           }
  VLesniCelek.NactiSeznamMajitelu;
  with VLesniCelek do
   begin
    // NactiSe_DB98;
    LOvr98.tb_odd.first;
    while not LOvr98.tb_odd.eof do
     begin
      NactiOddelenidb98 (VOdd,LOvr98,VcetneBarev);
      LHC.OddeleniMN.AddElement(VOdd);
      infoedit.Text:='nacteno odd '+Inttostr(VOdd.ODD); infoedit.Refresh;
      PripoctiDoOddeleniHeletMajit(VOdd,infoMemo,VlesniCelek.ciselOrbis.MajetkyMN);
     end;
    LHC.OddeleniMN.AktualniPrvek.free;
   end;
  if fileExists(CestaAJmeno) then
   begin
    VlesniCelek.ciselOrbis.MajetkyMN.AdresaOrbu := CestaAJmeno;
    end
   else
   begin
    VlesniCelek.ciselOrbis.MajetkyMN.AdresaOrbu := CestaAJmeno+'/majetky.orb';
   end;
    VlesniCelek.ciselOrbis.MajetkyMN.PouzeCteni:=false;
    VlesniCelek.ciselOrbis.MajetkyMN.UlozDoOrbuPodleAdresy(3);
  UlozMajetkydoDBF(VLesniCelek,infoMemo,CestaAJmeno);
  infoMemo.lines.add('provedVypoctyHeletMajit hotovo - majety uloeny '+CestaAJmeno+'"');
  ulozMAjiteleDoXLS( VlesniCelek.ciselOrbis.MajetkyMN,CestaAJmeno);
  infoMemo.lines.add('sestava v excelu uloena "'+CestaAJmeno+'"');

 end;

procedure provedVypoctyHeletMajit(VLesniCelek:TLesnicelek;infoMemo:TMemo);
var
 vOdd:TOddeleni;
 LOvr98A:TOvr98;
 CestaAJmeno : string;
 i:integer;
 begin
  VLesniCelek.VcetneBarev:= VcetneBarvy1;
  druhaDataBaze98:=true;
  nespoustetManager:=false;
  umoznitZalozeniNoveDatabaze:=false;
  Application.CreateForm(TOVR98,LOvr98A);
  VLesniCelek.JakBylNacten:='Tax98-Paradox';
  VLesniCelek.FFOvr98:=LOvr98A;
  NactiPolozkyLHC_DB98(VLesniCelek.LHC,VLesniCelek.LOvr98);
  PriradCiselnik_DB98(VLesniCelek.ciselnik,VLesniCelek.LOvr98);
  VLesniCelek.CiselOrbis.nactiSeZOrbu(VLesniCelek.PHSNazev,true);
  NactiCiselOrbis_DB98(VLesniCelek.CiselOrbis,VLesniCelek.LOvr98);

  CestaAJmeno := Najdi_Soubor('C:\','Vyber soubor Majetky.ORB kam bude doplnn LV a ParCis.','Majetky.ORB',neukazZdroje);

  // CestaAJmeno := 'C:\Heletax_5R1\Heletax_PomAdesare\205804_1.pom\Majetky.ORB';
  if fileExists(CestaAJmeno) then
   begin
    VlesniCelek.ciselOrbis.MajetkyMN:=TMajetkyMN(NactiZOrbuLesniMnozinu(CestaAJmeno));
    VlesniCelek.ciselOrbis.MajetkyMN.setridPodlePropertyString('MAJ_NAZ_C',true);
    VlesniCelek.ciselOrbis.MajetkyMN.TridenoPodle:='MAJ_NAZ';
   end;

  with VLesniCelek do
   begin
    // NactiSe_DB98;
    LOvr98.tb_odd.first;
    while not LOvr98.tb_odd.eof do
     begin
      NactiOddelenidb98 (VOdd,LOvr98,VcetneBarev);
      LHC.OddeleniMN.AddElement(VOdd);
      infoedit.Text:='nacteno odd '+Inttostr(VOdd.ODD); infoedit.Refresh;
      PripoctiDoOddeleniHeletMajit(VOdd,infoMemo,VlesniCelek.ciselOrbis.MajetkyMN);
     end;
    LHC.OddeleniMN.AktualniPrvek.free;
   end;
    VlesniCelek.ciselOrbis.MajetkyMN.AdresaOrbu := CestaAJmeno;
    {
    for i:=0 to VlesniCelek.ciselOrbis.MajetkyMN.count-1 do
     begin
      with  Tmajetky( VlesniCelek.ciselOrbis.MajetkyMN.Elements[i]) do
       begin
                            infoMemo.Lines.Add(
                         '  MAJ_KOD='+MAJ_KOD_C
                         +'  MAJ_DRUH='+MAJ_DRUH_C
                         +'  ParCisc='+PARCIS_C
                         +'  ParPodlc='+PARPOD_C
                         +'  LVc='+LV_C);
       end;
     end;
     }
    VlesniCelek.ciselOrbis.MajetkyMN.PouzeCteni:=false;
    VlesniCelek.ciselOrbis.MajetkyMN.UlozDoOrbuPodleAdresy(3);
  infoMemo.lines.add('provedVypoctyHeletMajit hotovo - majety uloeny '+CestaAJmeno+'"');
 end;

(*
procedure provedVypoctyLetax (VLesniCelek:TLesnicelek;infoedit:TEdit);
var
 vOdd:TOddeleni;
 LOvr98A:TOvr98;

 begin
  PlochovkaParcelyLETAXmn:=TPlochovkaParcelyLETAXmn.Create;
  VLesniCelek.AddElement(PlochovkaParcelyLETAXmn);
  PlochovkaParcelyLETAXmn.ProvadetVypocet:=true;
  VLesniCelek.VcetneBarev:= VcetneBarvy1;
  druhaDataBaze98:=true;
  nespoustetManager:=false;
  umoznitZalozeniNoveDatabaze:=false;
  Application.CreateForm(TOVR98,LOvr98A);
  VLesniCelek.JakBylNacten:='Tax98-Paradox';
  VLesniCelek.FFOvr98:=LOvr98A;
  NactiPolozkyLHC_DB98(VLesniCelek.LHC,VLesniCelek.LOvr98);
  PriradCiselnik_DB98(VLesniCelek.ciselnik,VLesniCelek.LOvr98);
  VLesniCelek.CiselOrbis.nactiSeZOrbu(VLesniCelek.PHSNazev,true);
  NactiCiselOrbis_DB98(VLesniCelek.CiselOrbis,VLesniCelek.LOvr98);
  with VLesniCelek do
   begin
    // NactiSe_DB98;
    LOvr98.tb_odd.first;
    while not LOvr98.tb_odd.eof do
     begin
      NactiOddelenidb98 (VOdd,LOvr98,VcetneBarev);
      LHC.OddeleniMN.AddElement(VOdd);
      infoedit.Text:='nacteno odd '+Inttostr(VOdd.ODD); infoedit.Refresh;
      PripoctiOddeleniLetax(vOdd);
     end;
    LHC.OddeleniMN.AktualniPrvek.free;
   end;
  PlochovkaParcelyLETAXMN.setridPodlePropertyString('OrgUrKatast',true);
  infoedit.Text:='provedVypoctyLetax hotovo';
 end;
*)

Function TPlochovkaParcelyLETAX.GetOrgUrKatast:String;
 begin
  result:=    DoplnZePreduZnakem1(inttostr(NOrgUr2),4,'0')
            + DoplnZePreduZnakem1(inttostr(NKatastr),9,'0')
            + DoplnZePreduZnakem1(inttostr(NOdd),4,'0')
            + DoplnZePreduZnakem1(NDil,1,'0')
            + DoplnZePreduZnakem1(NPor,1,'0')
            + DoplnZePreduZnakem1(NPSKBzlJpOst,15,'0')
            ;
 end;

end.

